#!C:\Programme\Python25\python.exe

'''
$RCSfile: $
$Revision: 1260 $
$Author: j.holetschek $
$Date: 2013-02-07 11:38:43 +0100 (Do, 07. Feb 2013) $
'''

# ****************************************
# +++  BioCASE
# +++  pywrapper
#
# See http://www.biocase.org for details
#
# ****************************************

import cgi, sys, os.path

# ***** include the biocase.lib directory in the python sys path for module importing *****
execfile(os.path.abspath(os.path.join(os.path.dirname(__file__), os.path.pardir, 'lib', 'biocase', 'adjustpath.py')))

import biocase.configuration
cfg = biocase.configuration.Cfg()

import logging, biocase.initlogs
log = logging.getLogger("pywrapper")

from biocase.wrapper.pywrapper import pywrapper

# get datasource alias from GET querystring
if os.environ.has_key("QUERY_STRING"):
    QS = cgi.parse_qs(os.environ["QUERY_STRING"])

    # Inventory parameter: Requests the dataset inventory to be returned; no BioCASe protocol usage
    if QS.has_key('inventory'):
        inventory = True if QS['inventory'][0] in ('1', 'true', 'True') else False
    else:
        inventory = False

    if QS.has_key('dsa'):
        dsa = QS['dsa'][0]
    elif QS.has_key('DSA'):
        dsa = QS['DSA'][0]
    elif QS.has_key('datasource'):
        dsa = QS['datasource'][0]
    else:
        sys.stdout.write('Content-Type: text/plain\n\n')
        sys.exit("No Datasource alias given!")
else:
    sys.stdout.write('Content-Type: text/plain\n\n')
    sys.exit("No querystring given. Pass at least a datasource alias via dsa=XXX!")

biocase.initlogs.initWrapperLogging(dsa)
try:
    # If dataset inventory is requested, the protocol to None; otherwise biocase
    if inventory:
        pywInstance = pywrapper(None, dsa=dsa)
    else:
        pywInstance = pywrapper('biocase', dsa=dsa)
except:
    sys.stdout.write('Content-Type: text/plain\n\n')
    raise

# create a request from CGI
log.debug("pywInstance.parseRequest...")
pywInstance.parseRequest()

# print the result to the stream
log.debug("pywInstance.doResponse...")
pywInstance.doResponse(httpHeader=1)

log.info("PyWrapper response successful")
