--
-- PostgreSQL database dump
--

-- Started on 2008-04-30 20:34:04 CEST

SET client_encoding = 'UTF8';
SET standard_conforming_strings = off;
SET check_function_bodies = false;
SET client_min_messages = warning;
SET escape_string_warning = off;

SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- TOC entry 1331 (class 1259 OID 31961)
-- Dependencies: 1610 1611 1612 3
-- Name: chorotype; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE chorotype (
    chorotype_id integer DEFAULT 0 NOT NULL,
    chorotype character(255) DEFAULT NULL::bpchar,
    abbreviation character(255) DEFAULT NULL::bpchar
);


ALTER TABLE public.chorotype OWNER TO postgres;

--
-- TOC entry 1332 (class 1259 OID 31972)
-- Dependencies: 1613 1614 1615 3
-- Name: country; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE country (
    country_id integer DEFAULT 0 NOT NULL,
    iso_code character(50) DEFAULT NULL::bpchar,
    country character(255) DEFAULT NULL::bpchar
);


ALTER TABLE public.country OWNER TO postgres;

--
-- TOC entry 1333 (class 1259 OID 31980)
-- Dependencies: 1616 1617 3
-- Name: genus; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE genus (
    genus character varying(250) DEFAULT ''::character varying NOT NULL,
    family character varying(250) DEFAULT NULL::character varying
);


ALTER TABLE public.genus OWNER TO postgres;

--
-- TOC entry 1334 (class 1259 OID 31987)
-- Dependencies: 1618 1619 1620 1621 1622 3
-- Name: lifeform; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE lifeform (
    id integer DEFAULT 0 NOT NULL,
    lifeform_id character(255) DEFAULT NULL::bpchar,
    lebi_abk character(255) DEFAULT NULL::bpchar,
    lifeform character(255) DEFAULT NULL::bpchar,
    abbreviation character(255) DEFAULT NULL::bpchar,
    test integer
);


ALTER TABLE public.lifeform OWNER TO postgres;

--
-- TOC entry 1335 (class 1259 OID 32000)
-- Dependencies: 1623 1624 1625 1626 1627 1628 1629 1630 1631 1632 1633 1634 1635 1636 1637 3
-- Name: locality; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE locality (
    locality_id integer NOT NULL,
    locality_abrev character varying(16) DEFAULT ''::character varying NOT NULL,
    mountain_fk integer,
    altitude character varying(255) DEFAULT NULL::character varying,
    exposition character varying(255) DEFAULT NULL::character varying,
    inclination character varying(255) DEFAULT NULL::character varying,
    cover_vegetation character varying(255) DEFAULT NULL::character varying,
    cover_stones character varying(255) DEFAULT NULL::character varying,
    cover_boulders character varying(255) DEFAULT NULL::character varying,
    size character varying(255) DEFAULT NULL::character varying,
    film_roll character varying(255) DEFAULT NULL::character varying,
    picture character varying(255) DEFAULT NULL::character varying,
    soil character varying(255) DEFAULT NULL::character varying,
    habitat_fk integer,
    soil_fk integer,
    phytosociety character varying(255) DEFAULT NULL::character varying,
    locality character varying(255) DEFAULT NULL::character varying,
    longitude_dec numeric(13,5) DEFAULT NULL::numeric,
    latitude_dec numeric(13,5) DEFAULT NULL::numeric
);


ALTER TABLE public.locality OWNER TO postgres;

--
-- TOC entry 1336 (class 1259 OID 32024)
-- Dependencies: 1638 1639 1640 1641 1642 1643 1644 1645 1646 1647 1648 1649 1650 1651 1652 1653 1654 1655 1656 1657 1658 1659 1660 1661 1662 1663 1664 1665 1666 1667 1668 1669 1670 1671 1672 1673 1674 1675 1676 1677 1678 1679 1680 1681 3
-- Name: metadata; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE metadata (
    metadata_id integer DEFAULT 0 NOT NULL,
    dataset_guid character varying(50) DEFAULT NULL::character varying,
    technical_contact_name character varying(50) DEFAULT ''::character varying NOT NULL,
    technical_contact_email character varying(50) DEFAULT NULL::character varying,
    technical_contact_phone character varying(50) DEFAULT ''::character varying NOT NULL,
    technical_contact_address character varying(255) DEFAULT NULL::character varying,
    content_contact_name character varying(50) DEFAULT ''::character varying NOT NULL,
    content_contact_email character varying(50) DEFAULT NULL::character varying,
    content_contact_phone character varying(50) DEFAULT NULL::character varying,
    content_contact_address character varying(255) DEFAULT NULL::character varying,
    other_provider_uddi character varying(50) DEFAULT NULL::character varying,
    dataset_title character varying(50) DEFAULT NULL::character varying,
    dataset_details text,
    dataset_coverage text,
    dataset_uri character varying(50) DEFAULT NULL::character varying,
    dataset_icon_uri character varying(50) DEFAULT NULL::character varying,
    dataset_version_major character varying(50) DEFAULT ''::character varying NOT NULL,
    dataset_creators text,
    dataset_contributors text,
    date_created timestamp without time zone,
    date_modified timestamp without time zone DEFAULT '1970-01-01 00:00:00'::timestamp without time zone NOT NULL,
    owner_organization_name character varying(255) DEFAULT NULL::character varying,
    owner_organization_abbrev character varying(50) DEFAULT NULL::character varying,
    owner_contact_person character varying(255) DEFAULT ''::character varying NOT NULL,
    owner_contact_role character varying(50) DEFAULT NULL::character varying,
    owner_address character varying(255) DEFAULT NULL::character varying,
    owner_telephone character varying(50) DEFAULT NULL::character varying,
    owner_email character varying(50) DEFAULT NULL::character varying,
    owner_uri character varying(50) DEFAULT NULL::character varying,
    owner_logo_uri character varying(255) DEFAULT NULL::character varying,
    ipr_text character varying(255) DEFAULT NULL::character varying,
    ipr_details text,
    ipr_uri character varying(255) DEFAULT NULL::character varying,
    copyright_text character varying(255) DEFAULT NULL::character varying,
    copyright_details text,
    copyright_uri character varying(255) DEFAULT NULL::character varying,
    terms_of_use_text character varying(255) DEFAULT NULL::character varying,
    terms_of_use_details text,
    terms_of_use_uri character varying(255) DEFAULT NULL::character varying,
    disclaimers_text character varying(255) DEFAULT NULL::character varying,
    disclaimers_details text,
    disclaimers_uri character varying(255) DEFAULT NULL::character varying,
    license_text character varying(255) DEFAULT NULL::character varying,
    licenses_details text,
    license_uri character varying(255) DEFAULT NULL::character varying,
    acknowledgements_text character varying(255) DEFAULT NULL::character varying,
    acknowledgements_details text,
    acknowledgements_uri character varying(255) DEFAULT NULL::character varying,
    citations_text character varying(255) DEFAULT NULL::character varying,
    citations_details text,
    citations_uri character varying(255) DEFAULT NULL::character varying,
    source_institution_id character varying(50) DEFAULT ''::character varying NOT NULL,
    source_id character varying(50) DEFAULT ''::character varying NOT NULL,
    record_basis character varying(50) DEFAULT NULL::character varying,
    kind_of_unit character varying(50) DEFAULT NULL::character varying,
    higher_taxon_rank character varying(50) DEFAULT NULL::character varying
);


ALTER TABLE public.metadata OWNER TO postgres;

--
-- TOC entry 1337 (class 1259 OID 32077)
-- Dependencies: 1682 1683 1684 1685 3
-- Name: mountain; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE mountain (
    mountain_id integer DEFAULT 0 NOT NULL,
    mountain character varying(255) DEFAULT NULL::character varying,
    mountain_range character varying(255) DEFAULT NULL::character varying,
    villayet_fk integer,
    turkish_grid character varying(255) DEFAULT NULL::character varying
);


ALTER TABLE public.mountain OWNER TO postgres;

--
-- TOC entry 1338 (class 1259 OID 32090)
-- Dependencies: 1686 1687 1688 1689 3
-- Name: observation; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE observation (
    observation_id integer DEFAULT 0 NOT NULL,
    lfd_nummer integer,
    taxon_fk integer,
    cover character(4) DEFAULT NULL::bpchar,
    locality_fk integer DEFAULT 0 NOT NULL,
    specimen_fk integer DEFAULT 0 NOT NULL
);


ALTER TABLE public.observation OWNER TO postgres;

--
-- TOC entry 1339 (class 1259 OID 32100)
-- Dependencies: 1690 1691 3
-- Name: soil; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE soil (
    soil_id integer DEFAULT 0 NOT NULL,
    soil character(255) DEFAULT NULL::bpchar
);


ALTER TABLE public.soil OWNER TO postgres;

--
-- TOC entry 1340 (class 1259 OID 32107)
-- Dependencies: 1692 1693 1694 1695 1696 1697 3
-- Name: specimen; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE specimen (
    specimen_id integer NOT NULL,
    identifier character(255) DEFAULT NULL::bpchar,
    field_number character(255) DEFAULT NULL::bpchar,
    collector character(255) DEFAULT NULL::bpchar,
    collecting_date timestamp without time zone,
    taxon_fk integer,
    confirmed_by character(255) DEFAULT NULL::bpchar,
    notes character(255) DEFAULT NULL::bpchar,
    lfd_deck_nummern integer,
    locality_fk integer,
    metadata_fk integer DEFAULT 1 NOT NULL,
    last_update timestamp without time zone
);


ALTER TABLE public.specimen OWNER TO postgres;

--
-- TOC entry 1342 (class 1259 OID 32124)
-- Dependencies: 1699 1700 1701 1702 1703 1704 1705 1706 1707 1708 1709 1710 1711 1712 1713 3
-- Name: taxon; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE taxon (
    taxon_id integer NOT NULL,
    full_name character(255) DEFAULT NULL::bpchar,
    authorteam character(128) DEFAULT NULL::bpchar,
    rank character(50) DEFAULT NULL::bpchar,
    infra_epi character(255) DEFAULT NULL::bpchar,
    genus character(255) DEFAULT NULL::bpchar,
    epitheton character(255) DEFAULT NULL::bpchar,
    species_authorteam character(255) DEFAULT NULL::bpchar,
    subspecies character(255) DEFAULT NULL::bpchar,
    subspecies_authorteam character(255) DEFAULT NULL::bpchar,
    variety character(255) DEFAULT NULL::bpchar,
    variety_authorteam character(255) DEFAULT NULL::bpchar,
    synonyms character(255) DEFAULT NULL::bpchar,
    name_excl_authors character(255) DEFAULT NULL::bpchar,
    notes character(255) DEFAULT NULL::bpchar,
    chorotype character(255) DEFAULT NULL::bpchar,
    lifeform_fk integer
);


ALTER TABLE public.taxon OWNER TO postgres;

--
-- TOC entry 1343 (class 1259 OID 32149)
-- Dependencies: 1714 1715 1716 3
-- Name: villayet; Type: TABLE; Schema: public; Owner: postgres; Tablespace: 
--

CREATE TABLE villayet (
    villayet_id integer DEFAULT 0 NOT NULL,
    villayet character(255) DEFAULT NULL::bpchar,
    country_fk integer DEFAULT 1
);


ALTER TABLE public.villayet OWNER TO postgres;

--
-- TOC entry 1341 (class 1259 OID 32122)
-- Dependencies: 1342 3
-- Name: taxon_taxon_id_seq; Type: SEQUENCE; Schema: public; Owner: postgres
--

CREATE SEQUENCE taxon_taxon_id_seq
    START WITH 1
    INCREMENT BY 1
    NO MAXVALUE
    NO MINVALUE
    CACHE 1;


ALTER TABLE public.taxon_taxon_id_seq OWNER TO postgres;

--
-- TOC entry 1765 (class 0 OID 0)
-- Dependencies: 1341
-- Name: taxon_taxon_id_seq; Type: SEQUENCE OWNED BY; Schema: public; Owner: postgres
--

ALTER SEQUENCE taxon_taxon_id_seq OWNED BY taxon.taxon_id;


--
-- TOC entry 1766 (class 0 OID 0)
-- Dependencies: 1341
-- Name: taxon_taxon_id_seq; Type: SEQUENCE SET; Schema: public; Owner: postgres
--

SELECT pg_catalog.setval('taxon_taxon_id_seq', 1, false);


--
-- TOC entry 1698 (class 2604 OID 32127)
-- Dependencies: 1342 1341 1342
-- Name: taxon_id; Type: DEFAULT; Schema: public; Owner: postgres
--

ALTER TABLE taxon ALTER COLUMN taxon_id SET DEFAULT nextval('taxon_taxon_id_seq'::regclass);


--
-- TOC entry 1748 (class 0 OID 31961)
-- Dependencies: 1331
-- Data for Name: chorotype; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY chorotype (chorotype_id, chorotype, abbreviation) FROM stdin;
1	Unknown                                                                                                                                                                                                                                                        	Unknown                                                                                                                                                                                                                                                        
2	Endemic locally                                                                                                                                                                                                                                                	End loc                                                                                                                                                                                                                                                        
3	Endemic Bati Toroslar                                                                                                                                                                                                                                          	End BT                                                                                                                                                                                                                                                         
4	Endemic Orta Toroslar                                                                                                                                                                                                                                          	End OT                                                                                                                                                                                                                                                         
5	Endemic Toroslar                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          
6	Endemic Anatolia                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          
7	Mediterranean                                                                                                                                                                                                                                                  	Med                                                                                                                                                                                                                                                            
8	East Mediterranean                                                                                                                                                                                                                                             	EMed                                                                                                                                                                                                                                                           
9	Irano-Anatolian                                                                                                                                                                                                                                                	IA                                                                                                                                                                                                                                                             
10	Euxine                                                                                                                                                                                                                                                         	Eux                                                                                                                                                                                                                                                            
11	Euro-Siberian                                                                                                                                                                                                                                                  	ES                                                                                                                                                                                                                                                             
12	Endemic Kackar                                                                                                                                                                                                                                                 	End K                                                                                                                                                                                                                                                          
13	Hyrcanian                                                                                                                                                                                                                                                      	Hyrc                                                                                                                                                                                                                                                           
14	Pontic                                                                                                                                                                                                                                                         	Pont                                                                                                                                                                                                                                                           
15	Kosmopolitan                                                                                                                                                                                                                                                   	Kosmo                                                                                                                                                                                                                                                          
16	Pluriregional                                                                                                                                                                                                                                                  	Plur                                                                                                                                                                                                                                                           
17	Sudano-Zambezian                                                                                                                                                                                                                                               	Sud                                                                                                                                                                                                                                                            
18	Saharo-Arabian                                                                                                                                                                                                                                                 	Sa-Ar                                                                                                                                                                                                                                                          
19	spec.                                                                                                                                                                                                                                                          	spec                                                                                                                                                                                                                                                           
20	circum-boreal / holarctic                                                                                                                                                                                                                                      	circ                                                                                                                                                                                                                                                           
21	holarctic                                                                                                                                                                                                                                                      	hol                                                                                                                                                                                                                                                            
22	Irano Turanian                                                                                                                                                                                                                                                 	IrTur                                                                                                                                                                                                                                                          
23	India                                                                                                                                                                                                                                                          	Ind                                                                                                                                                                                                                                                            
24	East Asia                                                                                                                                                                                                                                                      	EAs                                                                                                                                                                                                                                                            
25	North American                                                                                                                                                                                                                                                 	N Am                                                                                                                                                                                                                                                           
26	Australasia                                                                                                                                                                                                                                                    	Aus                                                                                                                                                                                                                                                            
\.


--
-- TOC entry 1749 (class 0 OID 31972)
-- Dependencies: 1332
-- Data for Name: country; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY country (country_id, iso_code, country) FROM stdin;
2	IT                                                	Italy                                                                                                                                                                                                                                                          
1	TR                                                	Turkey                                                                                                                                                                                                                                                         
\.


--
-- TOC entry 1750 (class 0 OID 31980)
-- Dependencies: 1333
-- Data for Name: genus; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY genus (genus, family) FROM stdin;
Acantholimon	Plumbaginaceae
Achillea	Asteraceae
Aethionema	Brassicaceae
Ajuga	Lamiaceae
Alchemilla	Rosaceae
Alkanna	Boraginaceae
Allium	Liliaceae
Alopecurus	Poaceae
Alyssum	Brassicaceae
Anchonium	Brassicaceae
Androsace	Primulaceae
Anthemis	Asteraceae
Anthoxanthum	Poaceae
Anthyllis	Fabaceae
Arabis	Brassicaceae
Arenaria	Caryophyllaceae
Arum	Araceae
Asperula	Rubiaceae
Asphodeline	Liliaceae
Asteraceae	Asteraceae
Astragalus	Fabaceae
Asyneuma	Campanulaceae
Aubrieta	Brassicaceae
Aurinia	Brassicaceae
Ballota	Lamiaceae
Berberis	Berberidaceae
Bolanthus	Caryophyllaceae
Bornmuellerantha	Scrophulariaceae
Brassica	Brassicaceae
Bromus	Poaceae
Bunium	Apiaceae
Bupleurum	Apiaceae
Campanula	Campanulaceae
Capsella	Brassicaceae
Carex	Cyperaceae
Centaurea	Asteraceae
Cephalaria	Dipsacaceae
Cerastium	Caryophyllaceae
Cerasus	Rosaceae
Chamaecytisus	Fabaceae
Chenopodiaceae	Chenopodiaceae
Clypeola	Brassicaceae
Colchicum	Liliaceae
Coluteocarpus	Brassicaceae
Convolvulus	Convolvulaceae
Corydalis	Papaveraceae
Cotoneaster	Rosaceae
Crepis	Asteraceae
Cruciata	Rubiaceae
Cuscuta	Cuscutaceae
Cyathophylla	Caryophyllaceae
Cyclotrichium	Lamiaceae
Cynoglossum	Boraginaceae
Cytisopsis	Fabaceae
Dactylis	Poaceae
Daphne	Thymelaeaceae
Dianthus	Caryophyllaceae
Digitalis	Scrophulariaceae
Dorystaechas	Lamiaceae
Draba	Brassicaceae
Ebenus	Fabaceae
Echinops	Asteraceae
Elytrigia	Poaceae
Epilobium	Onagraceae
Eremopoa	Poaceae
Erigeron	Asteraceae
Erodium	Geraniaceae
Eryngium	Apiaceae
Erysimum	Brassicaceae
Euphorbia	Euphorbiaceae
Euphrasia	Scrophulariaceae
Festuca	Poaceae
Fibigia	Brassicaceae
Fritillaria	Liliaceae
Fumaria	Papaveraceae
Gagea	Liliaceae
Galium	Rubiaceae
Genista	Fabaceae
Gentiana	Gentianaceae
Gentianella	Gentianaceae
Geranium	Geraniaceae
Globularia	Globulariaceae
Gypsophila	Caryophyllaceae
Hedysarum	Fabaceae
Heldreichia	Brassicaceae
Helianthemum	Cistaceae
Helichrysum	Asteraceae
Heracleum	Apiaceae
Herniaria	Caryophyllaceae
Hesperis	Brassicaceae
Hieracium	Asteraceae
Hypericum	Hypericaceae
Iberis	Brassicaceae
Inula	Asteraceae
Juniperus	Cupressaceae
Jurinella	Asteraceae
Kobresia	Cyperaceae
Koeleria	Poaceae
Lactuca	Asteraceae
Lamium	Lamiaceae
Leontodon	Asteraceae
Linaria	Scrophulariaceae
Linum	Linaceae
Logfia	Asteraceae
Lotus	Fabaceae
Malva	Malvaceae
Marrubium	Lamiaceae
Medicago	Fabaceae
Melica	Poaceae
Michauxia	Campanulaceae
Milium	Poaceae
Minuartia	Caryophyllaceae
Muscari	Liliaceae
Myosotis	Boraginaceae
Nepeta	Lamiaceae
Noaea	Chenopodiaceae
noch unbestimmt !!!	unbekannt
Omphalodes	Boraginaceae
Onobrychis	Fabaceae
Ononis	Fabaceae
Onopordum	Asteraceae
Onosma	Boraginaceae
Ornithogalum	Liliaceae
Orobanche	Orobanchaceae
Ostrya	Corylaceae
Oxyria	Polygonaceae
Papaver	Papaveraceae
Paronychia	Caryophyllaceae
Pedicularis	Scrophulariaceae
Pelargonium	Geraniaceae
Persicaria	Polygonaceae
Petrorhagia	Caryophyllaceae
Phleum	Poaceae
Phlomis	Lamiaceae
Pimpinella	Apiaceae
Plantago	Plantaginaceae
Poa	Poaceae
Polygala	Polygalaceae
Polygonum	Polygonaceae
Potentilla	Rosaceae
Prenanthes	Asteraceae
Prometheum	Crassulaceae
Pterocephalus	Dipsacaceae
Ranunculus	Ranunculaceae
Rochelia	Boraginaceae
Rosa	Rosaceae
Rumex	Polygonaceae
Salvia	Lamiaceae
Sanguisorba	Rosaceae
Saponaria	Caryophyllaceae
Satureja	Lamiaceae
Saxifraga	Saxifragaceae
Scabiosa	Dipsacaceae
Scandix	Apiaceae
Scariola	Asteraceae
Scilla	Liliaceae
Scleranthus	Caryophyllaceae
Scorzonera	Asteraceae
Scrophularia	Scrophulariaceae
Scutellaria	Lamiaceae
Secale	Poaceae
Sedum	Crassulaceae
Senecio	Asteraceae
Sesleria	Poaceae
Sideritis	Lamiaceae
Silene	Caryophyllaceae
Sorbus	Rosaceae
Stachys	Lamiaceae
Stipa	Poaceae
Stylidium	Poaceae
Swertia	Gentianaceae
Tanacetum	Asteraceae
Taraxacum	Asteraceae
Teucrium	Lamiaceae
Thesium	Santalaceae
Thlaspi	Brassicaceae
Thymus	Lamiaceae
Tragopogon	Asteraceae
Trifolium	Fabaceae
Trigonella	Fabaceae
Tripleurospermum	Asteraceae
Vavilovia	Fabaceae
Verbascum	Scrophulariaceae
Veronica	Scrophulariaceae
Vicia	Fabaceae
Viola	Violaceae
Xeranthemum	Asteraceae
Ziziphora	Lamiaceae
\.


--
-- TOC entry 1751 (class 0 OID 31987)
-- Dependencies: 1334
-- Data for Name: lifeform; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY lifeform (id, lifeform_id, lebi_abk, lifeform, abbreviation, test) FROM stdin;
1	Unknown                                                                                                                                                                                                                                                        	Unknown                                                                                                                                                                                                                                                        	Unknown                                                                                                                                                                                                                                                        	Unknown                                                                                                                                                                                                                                                        	\N
2	suffr                                                                                                                                                                                                                                                          	suffr                                                                                                                                                                                                                                                          	Chamaephyt                                                                                                                                                                                                                                                     	Ch                                                                                                                                                                                                                                                             	\N
3	rep                                                                                                                                                                                                                                                            	rep                                                                                                                                                                                                                                                            	Hemicryptophyt                                                                                                                                                                                                                                                 	H                                                                                                                                                                                                                                                              	\N
4	rept                                                                                                                                                                                                                                                           	rept                                                                                                                                                                                                                                                           	Geophyt                                                                                                                                                                                                                                                        	G                                                                                                                                                                                                                                                              	\N
5	rhiz                                                                                                                                                                                                                                                           	rhiz                                                                                                                                                                                                                                                           	Therophyt                                                                                                                                                                                                                                                      	T                                                                                                                                                                                                                                                              	\N
6	bulb                                                                                                                                                                                                                                                           	bulb                                                                                                                                                                                                                                                           	Nanophanerophyt                                                                                                                                                                                                                                                	NP                                                                                                                                                                                                                                                             	\N
7	frut                                                                                                                                                                                                                                                           	frut                                                                                                                                                                                                                                                           	Phanerophyt                                                                                                                                                                                                                                                    	P                                                                                                                                                                                                                                                              	\N
8	acanth                                                                                                                                                                                                                                                         	acanth                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
9	ros                                                                                                                                                                                                                                                            	ros                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
10	sem                                                                                                                                                                                                                                                            	sem                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
11	scap                                                                                                                                                                                                                                                           	scap                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
12	scand                                                                                                                                                                                                                                                          	scand                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
13	caesp                                                                                                                                                                                                                                                          	caesp                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
14	pulv                                                                                                                                                                                                                                                           	pulv                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
15	sapr                                                                                                                                                                                                                                                           	sapr                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
16	succ                                                                                                                                                                                                                                                           	succ                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
17	herb                                                                                                                                                                                                                                                           	herb                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	\N
\.


--
-- TOC entry 1752 (class 0 OID 32000)
-- Dependencies: 1335
-- Data for Name: locality; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY locality (locality_id, locality_abrev, mountain_fk, altitude, exposition, inclination, cover_vegetation, cover_stones, cover_boulders, size, film_roll, picture, soil, habitat_fk, soil_fk, phytosociety, locality, longitude_dec, latitude_dec) FROM stdin;
1	D158	34	2150	SW	15	60			100			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2150m	\N	\N
2	D159	34	2200	S	20	90			100			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2200m	\N	\N
3	D16	8	2000	O	25	50			25			\N	16	2	\N	Lycian Akdaglari above Gömbe, Akdag, ascent to Uyluk Tepesi, fine soil- rich screes. Subalpine, 2000m	\N	\N
4	D160	34	2200	SW	25	80			100			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2200m	\N	\N
5	D161	34	2050	SW	25	80			100			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2050m	\N	\N
6	D162	34	2000	SW	25	85			100			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2000m	\N	\N
7	D163	33	2100	SW	25	70	10	10	100			\N	68	1	\N	Dogu Karadeniz Daglari, Ovitdagi Geçedi, Lat.40°33´88´´N, long.040°53´32´´E, 2100m	\N	\N
8	D17	8	1900	O	30	60			30			\N	16	2	\N	Lycian Akdaglari above Gömbe, Akdag, ascent to Uyluk Tepesi, fine soil- rich screes, with boulders. Subalpine, 1900m	\N	\N
9	D18	9	2400	W	5	50			20			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2400m	\N	\N
10	D19	9	2400	N	20	50			30			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2400m	\N	\N
11	D2	4	2100	NO	6	50	25		40			\N	57	5	\N	Sandras Dagi above Agla, Altýnsivri summit. Lat.37°03´N, long.028°48´E, 2100m	\N	\N
12	D20	9	2400	W	15	60			40			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2400m	\N	\N
13	D200	40	0									\N	0	17	\N	Doganbey - Seferihisar, Psammophytic coastal vegetation.\nLat.38°06´25´´N, long. 026°51´12´´E, 0m	\N	\N
14	D202	3	950									\N	0	5	\N	Sandras Dagi, road Agla, Pinus brutia forest, above Yayla Köyü\nLat. 37°01´86´´N, long. 28°45´54´´E, \nrocky slopes, 950m	\N	\N
15	D118	20	2625			60			100			\N	14	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2625m	\N	\N
16	D119	20	2550	NO	40	55			90			\N	61	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2550m	\N	\N
17	D120	20	2470	NO	6	65			100			\N	61	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2470m	\N	\N
18	D121	20	2480	N	5	80			90			\N	61	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2480m	\N	\N
19	D203	4	1150									\N	0	5	\N	Sandras Dagi above Agla, Lat. 37°01´86´´N, long. 28°45´54´´E, \nRocky slopes with Pinus nigra subsp. pallasiana (1150m and higher), 1150m	\N	\N
20	D204	4	1800									\N	0	14	\N	Sandras Dagi above Agla, Çiralý below Altýn Sifri. Flat, scree- and fine soil- rich alluvial gravelly plain with stands of Centaurea ensiformis, Trifolio Polygonetalia community, 1800m	\N	\N
21	D205	4	1900									\N	56	3	\N	Sandras Dagi above Agla, Ascent from the saddle between Çiçekbaba Tepesi and Altýnsivri summit.\nLat.37°03´N, long.028°48´E, 1900m	\N	\N
22	D206	4	1900-2100									\N	29	3	\N	Sandras Dagi above Agla, Ascent from Çiralý to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 19002100m	\N	\N
23	D207	4	2100									\N	3	5	\N	Sandras Dagi above Agla, Çiçekbaba Tepesi, summit plataeau, 2100m	\N	\N
24	D208	4	1800									\N	9	5	\N	Sandras Dagi above Agla, Akköprü Çögenli (=saddle between Altýnsivri and Çiçekbaba Tepesi). Lat.37°03´N, long.028°48´E, 1800m	\N	\N
25	D209	6	630									\N	29	2	\N	d. Fethiye, Boncuk Daglari, Surroundig of Geyran. Lat.36°47´72´´N, long. 029°07´03´´E, 630m	\N	\N
26	D21	9	2500	W	35	30			25			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2500m	\N	\N
27	D210	6	630									\N	0	2	\N	d. Fethiye, Boncuk Daglari, Surroundig of Geyran. Lat.36°47´72´´N, long. 029°07´03´´E,\nCreek, flushes, tuff, 630m	\N	\N
28	D211	8	1700									\N	29	6	\N	Lycian Akdaglari above Gömbe, Area between the Þubasý Yayla and Çukurbag, 1700m	\N	\N
29	D212	7	1500									\N	9	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, near roadside, ascent to Þubasý Yayla, 1500m	\N	\N
30	D213	8	1900									\N	58	2	\N	Lycian Akdaglari above Gömbe, Akdag, between Uçarsu and Uyluk Tepesiç, 1900m	\N	\N
31	D214	10	1600									\N	0	1	\N	Foothills of the Beydaglari SE of Elmali, Ancient byzantine site between Küçük Sögle village and Kýzlar sivrisi. Arable fields, 1600m	\N	\N
32	D122	20	2440	N	6	50			80			\N	61	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2440m	\N	\N
33	D123	22	2200	S	7	80			100			\N	66	2	\N	Aladaglari, Kayacik Deresi, 2200m	\N	\N
34	D124	29	2120	NO	8	70			80			\N	66	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2120m	\N	\N
35	D215	10	1200									\N	0	1	\N	Foothills of the Beydaglari SE of Elmali, c. 2-2,5 km W of Küçük Sögle village. Steppe remnants, fallow fields, arable land, 1200m	\N	\N
36	D216	10	1250-1600									\N	0	1	\N	Foothills of the Beydaglari SE of Elmali, Between Küçük Sögle village and Kýzlar sivrisi. 2.5-6km SE Küçük Sögle. Mosaic of open Juniperus forest, steppe remnants, fallow fields and arable land, 12501600m	\N	\N
37	D217	11	1700									\N	1	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, Enlightened Pinus brutia / P. nigra subsp. pallasiana forests with Cedrus libani , 1700m	\N	\N
38	D218	16	2200									\N	47	2	\N	Geyik Daglari, Akdagi, 2200m	\N	\N
39	D219	16	2100									\N	26	2	\N	Geyik Daglari, Akdagi, 2100m	\N	\N
40	D22	9	2500	W	25	45			35			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2500m	\N	\N
41	D220	17	2200-2400									\N	2	6	\N	Geyik Daglari, Büyük Geyik Dagi, 22002400m	\N	\N
42	D221	17	2400									\N	5	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2400m	\N	\N
43	D222	19	2100									\N	9	2	\N	Oyuklu Dagi N of Ermenek, 2100m	\N	\N
44	D223	22	2200-2400									\N	63	2	\N	Aladaglari, Kayacik Deresi, between Kayacýk and Narpýz Bogazý, 22002400m	\N	\N
45	D224	23	2620									\N	65	2	\N	Aladaglari, upper Narpiz Deresi, 2620m	\N	\N
46	D225	23	2600									\N	22	2	\N	Aladaglari, upper Narpiz Deresi, 2600m	\N	\N
47	D226	27	1900									\N	67	2	\N	Aladaglari, Emli Vadisi, 1900m	\N	\N
48	D227	29	2200									\N	41	2	\N	Aladaglari, Çimbar Bogazý, 2200m	\N	\N
49	D228	32	1200									\N	0	16	\N	Yusufeli - Olur, slopes along the road between Ýþhan village (ruined Georgian church) and the Oltu Çayý valley bottom. Artemisia steppe, 1200m	\N	\N
50	D229	34	2700									\N	70	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2700m	\N	\N
51	D23	9	2450	N	15	55			40			\N	16	2	\N	Beydaglari, Kizlar sivrisi, 2450m	\N	\N
52	D230	34	2400									\N	22	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2400m	\N	\N
53	D231	34	2300									\N	5	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2300m	\N	\N
54	D232	34	2500									\N	57	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2500m	\N	\N
55	D233	34	2200									\N	57	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2200m	\N	\N
56	D234	34	2650									\N	28	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2650m	\N	\N
57	D235	34	2100									\N	45	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, 2100m	\N	\N
58	D236	35	1100									\N	0	1	\N	Dogu Karadeniz Daglari, Altindere Vadisi Milli Park above Maçka, Slope below the Sümela monastery, 1100m	\N	\N
59	D238	20	2400									\N	62	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, around Karagöl, 2400m	\N	\N
60	D1	4	2100	OSO	0-2	40			60			\N	57	5	\N	Sandras Dagi above Agla, Altýnsivri summit. Lat.37°03´N, long.028°48´E, 2100m	\N	\N
61	D10	8	2400	N	40	40			35			\N	16	6	\N	Lycian Akdaglari above Gömbe, Area between the Þubasý Yayla and an unnamed lateral summit of Uyluk Tepe, 2400m	\N	\N
62	D100	20	2630	S	10	80			80			\N	61	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, around Karagöl, 2630m	\N	\N
63	D101	20	2360	N	8	85			60			\N	17	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Lat.37°26´09´´N, long.34°34´85´´E, 2360m	\N	\N
64	D102	20	2360	N	12	80			70			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Lat.37°26´09´´N, long.34°34´85´´E, 2360m	\N	\N
65	D103	20	2350	O	10	80			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2350m	\N	\N
66	D104	20	2400	NO	4	70			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2400m	\N	\N
67	D105	20	2400	NW	3	70			70			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2400m	\N	\N
68	D106	20	2080	N	10	80			100			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2080m	\N	\N
69	D107	20	2100	NW	4	80			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2100m	\N	\N
70	D108	20	2380	W	5	70			90			\N	47	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2380m	\N	\N
71	D109	20	2400	W	5	70			80			\N	17	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2400m	\N	\N
72	D11	7	1800	O	10	75			60			\N	30	6	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, Lat.36°32´N, long.029°36´E, 1800m	\N	\N
73	D110	20	2200	O	6	65			100			\N	16	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2200m	\N	\N
74	D111	20	2220	O	8	75			80			\N	16	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2220m	\N	\N
75	D112	20	2300	SO	9	60			70			\N	47	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2300m	\N	\N
76	D113	20	2640	SW	9	60			90			\N	62	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, Karagöl area, 2640m	\N	\N
77	D114	20	2635	S	8	60			80			\N	62	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, Karagöl area, 2635m	\N	\N
78	D115	20	2630	S	7	65			90			\N	62	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, Karagöl area, 2630m	\N	\N
79	D116	20	2620			45			100			\N	44	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2620m	\N	\N
80	D117	20	2620			60			100			\N	44	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2620m	\N	\N
81	D12	7	1800	S	25	40			50			\N	10	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, Lat.36°32´N, long.029°36´E\nThorn cushion dominated community, 1800m	\N	\N
82	D125	29	2150	N	15	50	20	10	80			\N	66	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2150m	\N	\N
83	D126	29	2240	W	17	50			100			\N	66	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2240m	\N	\N
84	D127	29	2240	W	20	70			100			\N	66	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2240m	\N	\N
85	D128	29	2240	N	15	65			100			\N	66	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2240m	\N	\N
86	D129	29	2100	NO	2	50			80			\N	64	2	\N	Aladaglari, N of Karayalak (below Yalak Bogazý), 2100m	\N	\N
87	D13	7	1800	S	25	60			30			\N	10	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, Lat.36°32´N, long.029°36´E\nThorn cushion dominated community, 1800m	\N	\N
88	D130	29	2000	W	2	60			100			\N	47	2	\N	Aladaglari, 2000m	\N	\N
89	D131	29	2020	W	5	65			80			\N	47	2	\N	Aladaglari, 2020m	\N	\N
90	D132	24	2600	W	3	40			80			\N	17	2	\N	Aladaglari, northern part (?Black Aladaglari?), Rocky outcrops of the Saçkaya (3100m) facing Maden Bogazý. Lat.37°53´63´´N, long.035°08´70´´E, 2600m	\N	\N
91	D133	24	2600	NW	5	45			80			\N	61	2	\N	Aladaglari, northern part (?Black Aladaglari?), 2600m	\N	\N
92	D134	24	2580	NW	7	40			80			\N	61	2	\N	Aladaglari, northern part (?Black Aladaglari?), 2580m	\N	\N
93	D135	24	2580	NW	6	45			100			\N	47	2	\N	Aladaglari, northern part (?Black Aladaglari?), 2580m	\N	\N
94	D136	24	2580	N	2	55			100			\N	61	2	\N	Aladaglari, northern part (?Black Aladaglari?), 2580m	\N	\N
95	D137	24	2320	NW	8	70			80			\N	61	2	\N	Aladaglari, northern part (?Black Aladaglari?), 2320m	\N	\N
96	D138	27	2260	SW	10	60			100			\N	61	2	\N	Aladaglari, Emli Vadisi, 2260m	\N	\N
97	D139	27	2270	SW	8	70			100			\N	47	2	\N	Aladaglari, Emli Vadisi, 2270m	\N	\N
98	D14	7	1850	N	20	70			40			\N	10	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, Lat.36°32´N, long.029°36´E\nThorn cushion dominated community, 1850m	\N	\N
99	D140	27	2250	SW	8	65			80			\N	61	2	\N	Aladaglari, Emli Vadisi, 2250m	\N	\N
100	D141	29	1720	NW	25	65			100			\N	68	2	\N	Aladaglari, W of the main Aladaglarý range, 1720m	\N	\N
101	D142	26	2240	S	12	70			100			\N	47	2	\N	Aladaglari, lower Yalak Deresi, 2240m	\N	\N
102	D143	26	2220	S	10	70			80			\N	61	2	\N	Aladaglari, lower Yalak Deresi, 2220m	\N	\N
103	D144	26	2250	SW	8	75			100			\N	47	2	\N	Aladaglari, lower Yalak Deresi, 2250m	\N	\N
104	D145	26	2260	SW	6	60			100			\N	47	2	\N	Aladaglari, lower Yalak Deresi, 2260m	\N	\N
105	D146	26	2250	S	15	75			100			\N	47	2	\N	Aladaglari, lower Yalak Deresi, 2250m	\N	\N
106	D147	26	2100	O	17	75			100			\N	61	2	\N	Aladaglari, lower Yalak Deresi, 2100m	\N	\N
107	D148	26	2100	W	15	60			60			\N	61	2	\N	Aladaglari, lower Yalak Deresi, 2100m	\N	\N
108	D149	26	2050	W	10	70			70			\N	47	2	\N	Aladaglari, lower Yalak Deresi, 2050m	\N	\N
109	D15	8	1900	O	20	40			80			\N	16	6	\N	Lycian Akdaglari above Gömbe, Akdag, ascent to Uyluk Tepesi, fine soil- rich screes with boulders. Subalpine, 1900m	\N	\N
110	D150	29	1700	W	2	70			100			\N	68	2	\N	Aladaglari, 1700m	\N	\N
111	D151	34	2120	SO	45	90			120			\N	69	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, near Yaylalar (Hevek), Büyük Çay valley 0.6-2 km above Olgunlar, 2120m	\N	\N
112	D152	34	2100	S	55	95			100			\N	69	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, near Yaylalar (Hevek), Büyük Çay valley 0.6-2km above Olgunlar, 2100m	\N	\N
113	D153	34	2100	SO	60	85			100			\N	69	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, near Yaylalar (Hevek), Büyük Çay valley 0.6-2km above Olgunlar, 2100m	\N	\N
114	D154	34	2140	S	35	85			100			\N	69	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, near Yaylalar (Hevek), Büyük Çay valley 0.6-2km above Olgunlar, 2140m	\N	\N
115	D155	34	2200	SO	65	95			100			\N	69	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, near Yaylalar (Hevek), Büyük Çay valley 0.6-2km above Olgunlar, 2200m	\N	\N
116	D156	34	2520	O	5	100			15			\N	21	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, 2520m	\N	\N
117	D157	34	2100	SW	20	85			80			\N	11	15	\N	Dogu Karadeniz Daglari, central Kaçkar Daglari, Düpedüz Deresi, entrance of the valley above Olgunlar (near Yaylalar), 2100m	\N	\N
118	D24	9	2600	W	10	55			60			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit and saddle between it and the main range, 2600m	\N	\N
119	D29	9	2650	NO	5	50			20			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit. Subalpine, 2650m	\N	\N
120	D30	9	2650	O	2	70			20			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit. Subalpine, 2650m	\N	\N
121	D31	11	2140	S	20	70			40			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 2140m	\N	\N
122	D32	11	2100	SW	20	50			30			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 2100m	\N	\N
123	D25	9	2650	NO	15	45			60			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit and saddle between it and the main range, 2650m	\N	\N
124	D26	9	2620	W	20	55			30			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit and saddle between it and the main range, 2620m	\N	\N
125	D27	9	2650	N	5	60			40			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit and saddle between it and the main range, 2650m	\N	\N
126	D28	9	2650	S	10	55			20			\N	16	2	\N	Beydaglari, Kizlar sivrisi, Aktepe summit and saddle between it and the main range, 2650m	\N	\N
127	D3	4	2000	OSO	42	50	40		30			\N	57	5	\N	Sandras Dagi above Agla, Altýnsivri summit. Lat.37°03´N, long.028°48´E, 2000m	\N	\N
128	D33	11	2100	S	40	60			30			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 2100m	\N	\N
129	D34	11	1920	O	40	40			30			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1920m	\N	\N
130	D35	11	1900	O	30	45			25			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1900m	\N	\N
131	D36	11	1870	O	30	50			30			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1870m	\N	\N
132	D37	11	1850	SO	20	50			40			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1850m	\N	\N
133	D38	11	1820	SO	10	55			30			\N	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1820m	\N	\N
134	D39	12	2540	W	S	55			40			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2540m	\N	\N
135	D4	4	2000	O	11	70			25			\N	57	5	\N	Sandras Dagi above Agla, Altýnsivri summit. Lat.37°03´N, long.028°48´E, 2000m	\N	\N
136	D40	12	2500	W	10	55			40			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2500m	\N	\N
137	D41	12	2500	N	15	60			40			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2500m	\N	\N
138	D42	12	2510	O	10	55			40			\N	59	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2510m	\N	\N
139	D43	12	2480	N	20	70			45			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2480m	\N	\N
140	D70	16	2130	SW	10	90			60			\N	49	6	\N	Geyik Daglari, Akdagi, Lat. 36°55´38´´N, long. 032°08´52´´E, 2130m	\N	\N
141	D71	16	2200	S	10	55			60			\N	49	6	\N	Geyik Daglari, Akdagi, Lat. 36°55´38´´N, long. 032°08´52´´E, 2200m	\N	\N
142	D72	16	2000	O	S	60			60			\N	49	6	\N	Geyik Daglari, Akdagi, Lat. 36°55´38´´N, long. 032°08´52´´E, 2000m	\N	\N
143	D44	12	2500	NO	15	50			40			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2500m	\N	\N
144	D45	12	2520	N	15	55			40			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2520m	\N	\N
145	D46	12	2500	N	25	60			60			\N	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2500m	\N	\N
146	D47	12	2500	N	15	60			55			\N	47	2	\N	Beydaglari, Bakirli Dagi above Saklikent, Lat.36°49´60´´N, long. 030°20´22´´E, 2500m	\N	\N
147	D48	12	2400	W	5	50			50			\N	47	8	\N	Beydaglari, Bakirli Dagi above Saklikent, Rocky slopes along the road from Saklýkent to the observatory, disturbed land, 2400m	\N	\N
148	D49	12	2080	NW	10	60			55			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 2080m	\N	\N
149	D5	4	2200	NW	22	20		60	10			\N	8	3	\N	Sandras Dagi above Agla, Çiçekbaba Tepesi, summit plateau, 2200m	\N	\N
150	D50	12	2070	W	15	70			60			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 2070m	\N	\N
151	D51	12	2050	W	20	80			50			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 2050m	\N	\N
152	D52	12	2080	W	10	40			50			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 2080m	\N	\N
153	D53	12	2070	W	10	85			50			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 2070m	\N	\N
154	D54	12	1880	O	10	70			60			\N	47	3	\N	Beydaglari, Bakirli Dagi above Saklikent, 1880m	\N	\N
155	D55	14	1820	O	10	40			40			\N	56	2	\N	Beydaglari, below Saklikent, Road to Antalya, 1820m	\N	\N
156	D56	15	2420	O	20	60			50			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2420m	\N	\N
157	D57	15	2380	O	25	50			55			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2380m	\N	\N
158	D58	15	2370	O	15	50			40			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2370m	\N	\N
159	D64	15	2160	S	5	65			60			\N	17	2	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, 2160m	\N	\N
160	D65	15	2160	O	20	70			60			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, 2160m	\N	\N
161	D66	15	2150	O	15	60			65			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, 2150m	\N	\N
162	D69	15	2300			90			40			\N	15	2	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Trifolio- Polygonetea community, 2300m	\N	\N
163	D59	15	2340	O	5	50			40			\N	17	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2340m	\N	\N
164	D6	4	1850			60			20			\N	0	14	\N	Sandras Dagi above Agla, Çiralý below Altýn Sifri. Flat, scree- and fine soil- rich alluvial gravelly plain with stands of Centaurea ensiformis and degraded Pinus nigra, Trifolio Polygonetalia community, 1850m	\N	\N
165	D60	15	2000	NO	15	50	30	5	50			\N	17	3	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2000m	\N	\N
166	D61	15	2020	N	10	70	25	5	60			\N	17	3	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2020m	\N	\N
167	D62	15	2020	N	5	75			55			\N	47	8	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2020m	\N	\N
168	D63	15	2120	NO	10	70		20	50			\N	47	2	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Range above the firewatch tower (ascent from Yeniþarbademli village), 2120m	\N	\N
169	D67	15	2360	O	2	95			40			\N	15	2	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Trifolio- Polygonetea community, 2360m	\N	\N
170	D68	15	2340	NW	5	95			45			\N	15	2	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, Trifolio- Polygonetea community, 2340m	\N	\N
171	D7	8	2400	NO	60	40	20	10	50			\N	20	6	\N	Lycian Akdaglari above Gömbe, Area between the Þubasý Yayla and an unnamed lateral summit of Uyluk Tepe. Thorn cushion communities, 2400m	\N	\N
172	D73	17	2720	W	20	50			60			\N	60	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2720m	\N	\N
173	D74	17	2640	W	20	55			50			\N	60	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2640m	\N	\N
174	D75	17	2560	W	25	40			50			\N	17	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2560m	\N	\N
175	D76	17	2400	NW	20	90			50			\N	60	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2400m	\N	\N
176	D77	17	2130	N	20	85			60			\N	60	6	\N	Geyik Daglari, Büyük Geyik Dagi, 2130m	\N	\N
177	D79	19	2200	NO	15	60			80			\N	61	2	\N	Oyuklu Dagi N of Ermenek, 2200m	\N	\N
178	D99	20	2620	W	5	80			70			\N	44	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2620m	\N	\N
179	M237	11	1850									\N	0	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, shortly beyond the timberline, 1850m	\N	\N
180	M238	11	2100									Kalk	7	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 2100m	\N	\N
181	D8	8	2400	N	50	40			40			\N	16	6	\N	Lycian Akdaglari above Gömbe, Area between the Þubasý Yayla and an unnamed lateral summit of Uyluk Tepe, 2400m	\N	\N
182	D80	19	2200	NO	20	65			70			\N	61	2	\N	Oyuklu Dagi N of Ermenek, 2200m	\N	\N
183	D81	19	2320	S	15	50			60			\N	61	2	\N	Oyuklu Dagi N of Ermenek, 2320m	\N	\N
184	D82	19	2300	S	15	40			50			\N	61	2	\N	Oyuklu Dagi N of Ermenek, 2300m	\N	\N
185	D83	19	1900	N	10	80			50			\N	61	2	\N	Oyuklu Dagi N of Ermenek, 1900m	\N	\N
186	D84	20	2400	O	15	70			50			\N	49	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Thorn cushion communities around Karagöl, 2400m	\N	\N
187	D85	20	2400	W	10	65			50			\N	49	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Thorn cushion communities around Karagöl, 2400m	\N	\N
188	D86	20	2400	N	20	85			50			\N	49	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Thorn cushion communities around Karagöl, 2400m	\N	\N
189	D87	20	2400	O	5	60			40			\N	49	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Thorn cushion communities around Karagöl, 2400m	\N	\N
190	D88	20	2620	S	5	60			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, Lat.37°24´32´´N, long.034°33´70´´E, around Karagöl, 2620m	\N	\N
191	D89	20	2700	S	4	55			80			\N	17	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, fine soil- rich, with stands of Marrubium globosum subsp. globosum, 2700m	\N	\N
192	D9	8	2400	NW	35	40			30			\N	16	6	\N	Lycian Akdaglari above Gömbe, Area between the Þubasý Yayla and an unnamed lateral summit of Uyluk Tepe, 2400m	\N	\N
193	D90	20	2700	W	8	60			70			\N	17	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2700m	\N	\N
194	D91	20	2700	S	10	50			50			\N	37	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2700m	\N	\N
195	D92	20	2600	O	2	80			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, around Karagöl, 2600m	\N	\N
196	D93	20	2600	N	10	70			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, around Karagöl, 2600m	\N	\N
197	D94	20	2600	NO	5	80			60			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2600m	\N	\N
198	D95	20	2600	O	10	60			70			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2600m	\N	\N
199	D96	20	2620	O	10	80			80			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2620m	\N	\N
200	D97	20	2650	O	10	80			70			\N	61	9	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2650m	\N	\N
201	D98	20	2620			90			90			\N	44	6	\N	d. Ulukisla, Bolkar Daglari above Meydan, around Karagöl, 2620m	\N	\N
202	M1	4	1950	O	27	35		15	15			Ophiolit Blöcke mit relativ viel Feinerde	29	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 1950m	\N	\N
203	M10	7	1800	S	30	70		15	20	7	35,36	Kalk	17	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, N edge, 1800m	\N	\N
204	M100	20	2650	NW	0,5	90	3	0	60			\N	18	12	Marrubium heterodon Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2650m	\N	\N
205	M101	20	2650	NW	0,5	90	3	0	60			\N	18	12	Marrubium heterodon Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2650m	\N	\N
206	M24	11	2050	W	35	40	50	5	60	11	1	Kalk	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, W side (ascent from Yukari Beycik), summit region above timberline, 2050m	\N	\N
207	M240	12	2400	O								Kalk	0	2	\N	Beydaglari, Bakirli Dagi above Sakklikent, next to the observatory, 2400m	\N	\N
208	M241	12	2300									Kalk	19	2	\N	Beydaglari, Bakirli Dagi above Saklikent, road leading to the observatory, 2300m	\N	\N
209	M242	15	1950									\N	0	0	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, area above firewatch tower, 1950m	\N	\N
210	M243	15	2100									\N	0	0	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, 2100m	\N	\N
211	M244	18	2050									\N	0	0	\N	Geyik Daglari, 2050m	\N	\N
212	M245	16	2100									\N	0	0	\N	Geyik Daglari, Akdagi, 2100m	\N	\N
213	M246	16	2250									\N	0	0	\N	Geyik Daglari, Akdagi, 2250m	\N	\N
214	M247	16	2200									\N	0	0	\N	Geyik Daglari, Akdagi, 2200m	\N	\N
215	M248	17	?									\N	0	0	\N	Geyik Daglari, Büyük Geyik Dagi, m	\N	\N
216	M249	17	2600							14	2,3	\N	0	0	\N	Geyik Daglari, Büyük Geyik Dagi, 2600m	\N	\N
217	M25	11	2000	W	35	45	45	5	40			Kalk	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, W side (ascent from Yukari Beycik), summit region above timberline, 2000m	\N	\N
218	M250	19	1900									\N	0	0	\N	Oyuklu Dagi N of Ermenek, 1900m	\N	\N
219	M251	19	2400									\N	0	0	\N	Oyuklu Dagi N of Ermenek, 2400m	\N	\N
220	M252	20	2650									\N	0	0	\N	d. Ulukisla, Bolkar Daglari above Meydan, around tarn Karagöl, 2650m	\N	\N
221	M11	7	1800	S	30	75		10	20	7	35,36	Kalk	17	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, N edge, 1800m	\N	\N
222	M12	7	1810	N	2	85		5	30	8	2,3	Kalk, Doline mit viel Feinerde.	32	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1810m	\N	\N
223	M253	20	2620									\N	0	0	\N	d. Ulukisla, Bolkar Daglari above MeydanN 37°24?32?? O 34°33?70??, 2620m	\N	\N
224	M254	20	2700									\N	0	0	\N	d. Ulukisla, Bolkar Daglari above Meydan, 2700m	\N	\N
225	M255	20	2600									\N	34	0	\N	d. Ulukisla, Bolkar Daglari above Meydan, slopes along the road from Meydan to tarn Karagöl, 2600m	\N	\N
226	M256	21	2720									\N	0	0	\N	d. Ulukisla, Bolkar Daglari, slopes along the road from Meydan to tarn Karagöl, 2720m	\N	\N
227	M257	21	1850									\N	0	12	\N	d. Ulukisla, Bolkar Daglari, slopes along the road from Meydan to tarn Karagöl, 1850m	\N	\N
228	M258	20	1600									\N	0	0	\N	d. Ulukisla, Bolkar Daglari above Meydan, slopes along the road from Meydan to tarn Karagöl, 1600m	\N	\N
229	M102	20	2650	SW	1	70	15	1	80			\N	17	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2650m	\N	\N
230	M103	20	1650	SWS	22	75	8	2	100	16	33	\N	16	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 1650m	\N	\N
231	M104	20	2650	SW	17	70	7	15	80	16	33	\N	20	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2650m	\N	\N
232	M105	20	2700	N	22	70	15	10	40	16	32	\N	48	10	\N	d. Ulukisla, Bolkar Daglari above Meydan, step crevice in cliff SE of tarn Karagöl, 2700m	\N	\N
233	M106	20	2660	NO	0,5	90	2	1	100			\N	49	10	Marrubium heterodon Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2660m	\N	\N
234	M107	20	2650	SW	5	80	6	2	100			\N	49	7	Marrubium heterodon Ges.	d. Ulukisla, Bolkar Daglari above Meydan, basin and adjoining slopes around tarn Karagöl, 2650m	\N	\N
235	M13	7	1810	N	2	85		5	20	8	2,3	Kalk, Doline mit viel Feinerde.	32	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1810m	\N	\N
236	M213	2	6									\N	0	0	\N	c. 10 km NW Brindisi, Italy. Close to the sea., 6m	\N	\N
237	M214	3	~100									\N	57	0	\N	Sandras Dagi, road Agla - Serce Gedigi, 100m	\N	\N
238	M236	11	1700									\N	55	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1700m	\N	\N
239	M108	21	2620	N	6	55	30	8	60			\N	17	10	Marrubium cephalatum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl. N37°24´67´´, O34°33´23´´, 2620m	\N	\N
240	M109	21	2600	N	5	65	25	4	60			\N	17	10	Marrubium cephalatum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2600m	\N	\N
241	M110	21	2550	NW	5	60	25	8	60			\N	47	10	Marrubium cephalatum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2550m	\N	\N
242	M111	21	2550	NW	5	55	30	10	60			\N	17	10	Marrubium cephalatum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2550m	\N	\N
243	M112	39	2900	N	22	97	1	1	8	17	27,33	\N	50	6	Kü´s Staudenflur	Aladaglari, lower Narpiz Deresi, next to fountain, 2900m	\N	\N
244	M113	39	2890	N	42	95	1	2	8	17	33	\N	50	6	Kü´s Staudenflur	Aladaglari, lower Narpiz Deresi, next to fountain, 2890m	\N	\N
245	M114	39	2900	N	19	50	40	5	80			\N	51	6	Silene caryophylloides Ges.	Aladaglari, lower Narpiz Deresi, east of fountain, 2900m	\N	\N
246	M115	22	2450	S	11	55	25	16	100	17	35	\N	52	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, northern slope, 2450m	\N	\N
247	M116	22	2500	S	19	45	20	25	80	18	2,3	\N	52	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, northern slope, 2500m	\N	\N
248	M117	22	2550	S	14	65	10	15	80			\N	52	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, northern slope, 2550m	\N	\N
249	M118	22	2600	S	17	60	10	20	100			\N	52	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, northern slope, 2600m	\N	\N
250	M239	12	2400									\N	0	2	\N	Beydaglari, Bakirli Dagi above Saklikent, close to the observatory, 2400m	\N	\N
251	M259	22	2100									\N	0	0	\N	Aladaglari, Kayacik Deresi, entrance to Kayaçik Bogazi, 2100m	\N	\N
252	M39	12	2430	O	27	70	14	15	40			Kalk	40	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2430m	\N	\N
253	M119	24	2520	O	6	65	8	0	100			\N	53	2	Astragalus condensatus Ges.	Aladaglari, northern part (?Black Aladaglari?), 2520m	\N	\N
254	M120	24	2450	NO	17	60	12	10	100			\N	53	2	Astragalus condensatus Ges.	Aladaglari, northern part (?Black Aladaglari?), 2450m	\N	\N
255	M121	24	2400	NO	14	70	10	10	80			\N	52	2	Astragalus condensatus Ges.	Aladaglari, northern part (?Black Aladaglari?), 2400m	\N	\N
256	M122	24	2310	N	17	55	15	15	100			\N	43	2	Astragalus condensatus Ges.	Aladaglari, northern part (?Black Aladaglari?), 2310m	\N	\N
257	M123	24	2300	NO	17	70	15	5	100			\N	17	2	Astragalus condensatus Ges.	Aladaglari, northern part (?Black Aladaglari?), 2300m	\N	\N
258	M130	22	2400	NW	27	30	30	30	100	18	3	\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, southern slope, 2400m	\N	\N
259	M131	22	2490	NW	16	50	25	10	100			\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, southern slope, 2490m	\N	\N
260	M132	22	2500	NWN	13	70	12	8	100	18	5,6	\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, southern slope, 2500m	\N	\N
261	M133	22	2510	NWN	15	65	10	20	100	18	7	\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, southern slope, 2510m	\N	\N
262	M134	22	2550	NW	19	65	20	8	100	18	7	\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, southern slope, 2550m	\N	\N
263	M135	22	2600	NW	19	60	22	10	100	18	7	\N	7	2	Silene caryophylloides Ges.	Aladaglari, Kayacik Deresi, entrance to Narpiz Bogazi gorge, below ridge of southern slope, 2600m	\N	\N
264	M136	27	2100	NO	18	40	30	20	100	19	10	\N	7	6	Silene caryophylloides Ges.	Aladaglari, Emli Vadisi, upper valley at entrance to Parmakaya valley, 2100m	\N	\N
265	M137	27	2170	NO	45	40	30	10	100	19	10	\N	7	6	Silene caryophylloides Ges.	Aladaglari, Emli Vadisi, upper valley at entrance to Parmakaya valley, 2170m	\N	\N
266	M138	27	2150	N	14	70	12	12	80	19	15,16	\N	54	6	Silene caryophylloides Ges.	Aladaglari, Emli Vadisi, upper valley behind entrance to Parmakaya valley, 2150m	\N	\N
267	M139	27	2200	N	25	80			100			\N	7	6	Silene caryophylloides Ges.	Aladaglari, Emli Vadisi, upper valley above Siyirma Bogazi. N37°45´52´´ O35°09´59´´, 2200m	\N	\N
268	M14	8	2500	O	35	50		5	30			Kalk (Calcit Mineral ->2)	13	2	\N	Lycian Akdaglari above Gömbe, eastern slope of Ak Dag, 2500m	\N	\N
269	M140	27	2250	NO	30	60			80			\N	7	6	Silene caryophylloides Ges.	Aladaglari, Emli Vadisi, upper valley above Siyirma Bogazi. N37°45´52´´ O35°09´59´´, 2250m	\N	\N
270	M141	25	2580	W	22	30	7	60	60	21	12	\N	23	6	\N	Aladaglari, upper Yalak Deresi between Yalak Bogazi and Çelik Buyduran Pass, 2580m	\N	\N
271	M142	26	2350	N	19	60	22	10	100	21	13	\N	7	6	Silene caryophylloides Ges.	Aladaglari, lower Yalak Deresi, before entrance to gorge, 2350m	\N	\N
272	M143	26	2400	NON	9	80	5	10	100			\N	7	6	Silene caryophylloides Ges.	Aladaglari, lower Yalak Deresi, before entrance to gorge, 2400m	\N	\N
273	M144	26	2410	N	14	70	15	10	100			\N	7	6	Silene caryophylloides Ges.	Aladaglari, lower Yalak Deresi, before entrance to gorge, 2410m	\N	\N
274	M15	9	2300	NW	6	80		2	35	9	12,13	Stark verdichteter Kalk (fast Marmor) mit Feinerde, lehmig	33	2	\N	Beydaglari, Kizlar sivrisi, W slope below Aktepe summit, 2300m	\N	\N
275	M16	9	2350	NW	20	75		5	50	9	16,17	Stark verdichteter Kalk (fast Marmor) mit viel dunkler Feinerde.	34	2	\N	Beydaglari, Kizlar sivrisi, W slope below Aktepe summit, 2350m	\N	\N
276	M17	9	2300	SO	14	80			30			Kalksteine, kaum Feinerde	35	2	\N	Beydaglari, Kizlar sivrisi, W slope below Aktepe summit, 2300m	\N	\N
277	M18	9	2300	S	17	90			40			Kalksteine, kaum Feinerde	35	2	\N	Beydaglari, Kizlar sivrisi, W slope below Aktepe summit, 2300m	\N	\N
278	M19	9	2300	NNO	42	80		5	40	9	36,37	Kalk, dunkle Feinerde unter Steinen	6	2	\N	Beydaglari, Kizlar sivrisi, western scree slope far beneath the summit, 2300m	\N	\N
279	M202	4	740							1	29	Ophiolit.	56	3	\N	Sandras Dagi above Agla, 740m	\N	\N
280	M204	4	1150	S	30					2	16	Ophiolit	0	3	\N	Sandras Dagi above Agla, Çiçekbaba Tepesi, 1150m	\N	\N
281	M207	4	1780									Ophiolit	11	3	\N	Sandras Dagi above Agla, Çiçekbaba Tepesi, 1780m	\N	\N
282	M2	4	2180	O	27	40		40	10			Ophiolit Blöcke mit relativ viel Feinerde	29	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 2180m	\N	\N
283	M20	9	2250	W	33	65			36	10	5	Kalk, terassiert	7	2	\N	Beydaglari, Kizlar sivrisi, western scree slope far beneath the summit, 2250m	\N	\N
284	M200	40	0							1	16	Ophiolit	0	3	\N	Doganbey - Seferihisar. N 38°06´25´´ O 26°51´03´´ near the sea., 0m	\N	\N
285	M201	5	20									Kalk Schotter	0	2	\N	Sandras Dagi25km before Köyegiz Göki. N 37°00´92´´ O 28°28´57´´\n, 20m	\N	\N
286	M203	3	950									Ophiolit	11	3	\N	Sandras Dagi, road Agla - Serce Gedigi, above (=N) Yayla Köyü Agla. N 37°01´86´´ O 28°45´54´´, 950m	\N	\N
287	M205	4	1900									Ophiolit	0	3	\N	Sandras Dagi above Agla, plateau below Çiçekbaba Tepesi, 1900m	\N	\N
288	M206	4	2000									Ophiolit, feuchte feinerdereiche ebene Fläche	25	3	\N	Sandras Dagi above Agla, Çiçekbaba Tepesi, 2000m	\N	\N
289	M208	4	1950							3	1	Ophiolit	0	3	\N	Sandras Dagi above Agla, summit region of Altinsivrisi, 1950m	\N	\N
290	M209	4	2100									Ophiolit	0	3	\N	Sandras Dagi above Agla, summit region of Altinsivrisi, 2100m	\N	\N
291	M21	9	2200	W	31	45			40	4	21	Kalk, wenig terassiert	6	2	\N	Beydaglari, Kizlar sivrisi, western scree slope far beneath the summit, 2200m	\N	\N
292	M210	4	2120		10							Ophiolit, feucht, feinerdereich	22	3	\N	Sandras Dagi above Agla, summit region of Altinsivrisi, 2120m	\N	\N
293	M211	4	2150									Ophiolit	0	3	\N	Sandras Dagi above Agla, summit region of Altinsivrisi, 2150m	\N	\N
294	M212	4	2200						75	3	21,22	Ophiolit	0	3	\N	Sandras Dagi above Agla, summit region of Altinsivrisi, 2200m	\N	\N
295	M215	4	1900									Ophiolit Geröll mit Feinerde	11	3	\N	Sandras Dagi above Agla, eastern slope of Altinsivrisi, 1900m	\N	\N
296	M216	4	1800									Ophiolit	0	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Ciçekbaba Tepesi, 1800m	\N	\N
297	M217	4	2150									Ophiolit	0	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Ciçekbaba Tepesi, 2150m	\N	\N
298	M218	4	2150									\N	0	3	\N	Sandras Dagi above Agla, Ciçekbaba Tepesi, 2150m	\N	\N
299	M219	4	1850									Ophiolit	0	3	\N	Sandras Dagi above Agla, saddle between Çiçekbaba Tepesi and Altinsivri, 1850m	\N	\N
300	M22	9	2350	SW	17	70		5	50			\N	34	2	\N	Beydaglari, Kizlar sivrisi, W slope below Aktepe summit, 2350m	\N	\N
301	M220	8	2100									Mergel	0	18	\N	Lycian Akdaglari above Gömbe, behind Subasi Yayla, 2100m	\N	\N
302	M221	8	1600									\N	0	2	\N	Lycian Akdaglari above Gömbe, road to Subasi Yayla, 1600m	\N	\N
303	M222	8	2800									Kalk	0	2	\N	Lycian Akdaglari above Gömbe, 2800m	\N	\N
304	M223	8	2300	S								Kalk	13	2	\N	Lycian Akdaglari above Gömbe, 2300m	\N	\N
305	M224	7	1700							7	14	\N	0	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1700m	\N	\N
306	M225	7	1800	S								Kalk	20	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1800m	\N	\N
307	M226	7	1830	O								Kalk Blockhalde	9	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1830m	\N	\N
308	M227	7	1830	NO								Kalk, Schutthalde	13	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, 1830m	\N	\N
309	M228	8	1900	N						8	11	\N	12	0	\N	Lycian Akdaglari above Gömbe, close to Uçarsu waterfall, 1900m	\N	\N
310	M229	8	2000									Kallk	0	2	\N	Lycian Akdaglari above Gömbe, close to Uçarsu waterfall, 2000m	\N	\N
311	M23	9	~ 1800	NNO	9	40	50		100			\N	36	2	\N	Beydaglari, Kizlar sivrisi, Yayla Ekizce, 1800m	\N	\N
312	M230	8	?									\N	16	0	\N	Lycian Akdaglari above Gömbe, Uçarsu waterfall, m	\N	\N
313	M231	8	2300									Kalk (Calcit Mineral 2)	23	2	\N	Lycian Akdaglari above Gömbe, 2300m	\N	\N
314	M232	8	1300									Böschung	19	0	\N	Lycian Akdaglari above Gömbe, road between Uçarsu and Gömbe, 1300m	\N	\N
315	M233	9	2100	N								Riffkalk, festgelegter Rohschutt	7	2	\N	Beydaglari, Kizlar sivrisi, 2100m	\N	\N
316	M234	9	2600-3000									\N	0	0	\N	Beydaglari, Kizlar sivrisi, 26003000m	\N	\N
317	M235	11	1600									\N	55	0	\N	d. Kemer, Beydaglari, Tahtali Dagi, 1600m	\N	\N
318	M26	11	2000	W	31	35	40	20	50			Kalk	37	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, W side (ascent from Yukari Beycik), summit region above timberline, 2000m	\N	\N
319	M260	39	2500									\N	0	0	\N	Aladaglari, lower Narpiz Deresi, waterfall Narpiz Bogazi, 2500m	\N	\N
320	M261	39	2800									\N	0	0	\N	Aladaglari, lower Narpiz DeresiStaudenflur, Kürschner, 2800m	\N	\N
321	M262	22	2400									\N	0	0	\N	Aladaglari, Kayacik DeresiKaraçik Derese, 2400m	\N	\N
322	M263	9	2200									\N	0	0	\N	Beydaglari, Kizlar sivrisi, 2200m	\N	\N
323	M264	9	2200									\N	13	0	\N	Beydaglari, Kizlar sivrisi, 2200m	\N	\N
324	M27	11	1900	W	27	30	40	20	40			Kalk	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, W side (ascent from Yukari Beycik), summit region above timberline, 1900m	\N	\N
325	M28	11	1900	W	27	35	50	10	40			Kalk	17	2	\N	d. Kemer, Beydaglari, Tahtali Dagi, W side (ascent from Yukari Beycik), summit region above timberline, 1900m	\N	\N
326	M29	12	2500	SO	17	90	4	6	30	12	4,5	Kalk	17	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2500m	\N	\N
327	M3	4	2180	W	3	60		10	15			Ophiolit	29	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 2180m	\N	\N
328	M30	12	2450	S	17	80	10	5	30			Kalk	38	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2450m	\N	\N
329	M31	12	2450	S	11	95	3	1	40	12	13,14	Kalk	29	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2450m	\N	\N
330	M32	12	2500	NNO	17	85	10	3	50			Kalk	13	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2500m	\N	\N
331	M33	12	2490	SO	14	90	5	3	60			Kalk	33	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2490m	\N	\N
332	M34	12	2500	SO	17	85	8	5	60			Kalk	33	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2500m	\N	\N
333	M35	12	2510	SO	27	80	10	8	60			Kalk	38	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2510m	\N	\N
334	M36	12	2500	SO	22	85	8	5	50			Kalk	40	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2500m	\N	\N
335	M37	12	2450	ONO	22	80	10	5	50			Kalk	40	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2450m	\N	\N
336	M38	12	2450	O	22	85	5	5	35			Kalk	40	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2450m	\N	\N
337	M4	4	2180	SW	1	75		20	8			Ophiolit, viel Feinerde	29	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 2180m	\N	\N
338	M40	12	2400	O	22	70	10	15	35			Kalk	40	2	\N	Beydaglari, Bakirli Dagi above Saklikent, summit region, 2400m	\N	\N
339	M41	12	2400	W	27	65	22	5	40			Kalk. Feinerdereich, locker.	41	2	\N	Beydaglari, Bakirli Dagi above Saklikent, rocky slopes along the road from Saklikent to the observatory, 2400m	\N	\N
340	M42	12	2400	W	27	70	18	5	40			Kalk. Feinerdereich, locker.	41	2	\N	Beydaglari, Bakirli Dagi above Saklikent, rocky slopes along the road from Saklikent to the observatory, 2400m	\N	\N
341	M43	12	2300	W	2	90	8		50			Kalk. Feinerdereich, locker.	42	2	\N	Beydaglari, Bakirli Dagi above Saklikent, rocky slopes along the road from Saklikent to the observatory, 2300m	\N	\N
342	M44	12	2300	W	2	90	8		50			Kalk. Feinerdereich, locker.	42	2	\N	Beydaglari, Bakirli Dagi above Saklikent, rocky slopes along the road from Saklikent to the observatory, 2300m	\N	\N
343	M45	12	2200	W	9	90	8		50			Kalk. Feinerdereich, locker.	43	2	\N	Beydaglari, Bakirli Dagi above Saklikent, rocky slopes along the road from Saklikent to the observatory, 2200m	\N	\N
344	M46	12	1950	N	1	80	8		50			Kalk. Sehr feinerdereiche Doline.	44	2	\N	Beydaglari, Bakirli Dagi above Saklikent, bottom end of slope along the road from Saklikent to the observatory, 1950m	\N	\N
345	M47	12	1950	N	1	93	2		29			Kalk. Sehr feinerdereiche Doline.	44	2	\N	Beydaglari, Bakirli Dagi above Saklikent, bottom end of slope along the road from Saklikent to the observatory, 1950m	\N	\N
346	M48	12	1950	N	1	80	6		30			Kalk	44	2	\N	Beydaglari, Bakirli Dagi above Saklikent, bottom end of slope along the road from Saklikent to the observatory, 1950m	\N	\N
347	M49	12	1950	N	2	80	18		20			Kalk.	44	2	\N	Beydaglari, Bakirli Dagi above Saklikent, bottom end of slope along the road from Saklikent to the observatory, 1950m	\N	\N
348	M50	12	1950	N	7	80	15		40			Kalkstein bedeckte Feinerde.	41	2	\N	Beydaglari, Bakirli Dagi above SaklikentSakklikent, 1950m	\N	\N
349	M51	12	1900	NW	14	92	7		30			Ophiolit	33	3	\N	Beydaglari, Bakirli Dagi above SaklikentSakklikent, 1900m	\N	\N
350	M6	8	2500	WSW	27	60		25	12			Mergel	30	18	\N	Lycian Akdaglari above Gömbe, above Subasi Yayla, 2500m	\N	\N
351	M65	16	2100	N	3	30	20	30	40	13	14	\N	46	6	\N	Geyik Daglari, Akdagi, cirque system at northern foothill, 2100m	\N	\N
352	M5	4	2180	S	6	60		5	40			Ophiolit, keine offene Feinerde, sondern kleine 2x3cm Steine	29	3	\N	Sandras Dagi above Agla, ascent from Çirali to the Çiçekbaba Tepesi (main summit), valley below the eastern slope of the summit, 2180m	\N	\N
353	M52	15	2500	SO	14	60	25	12	40			Dolomit	33	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2500m	\N	\N
354	M53	15	2450	OSO	14	65	25	5	30			Dolomit	33	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2450m	\N	\N
355	M54	15	2420	SO	6	80	5	2	40			Dolomit	10	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2420m	\N	\N
356	M55	15	2400	SO	3	70	15		30			Dolomit	10	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2400m	\N	\N
357	M56	15	2200	O	27	50	20	10	50	12	31	Dolomit + Kalk	20	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2200m	\N	\N
358	M57	15	2250	S	17	70	15	5	40			Dolomitschutt und etwas Ophiolit	40	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2250m	\N	\N
359	M58	15	2280	S	17	80	8	5	50			Dolomit	40	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2280m	\N	\N
360	M59	15	2360	O	2	95			50			Ophiolit (+ etwas Dolomit)	45	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, saddle range above the firewatch tower (ascent from Yenisarbademli village), 2360m	\N	\N
361	M60	15	2340	WNW	4	95			50			Ophiolit (+ etwas Dolomit)	45	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, saddle range above the firewatch tower (ascent from Yenisarbademli village), 2340m	\N	\N
362	M61	15	2300		0	95			50			\N	15	6	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2300m	\N	\N
363	M67	16	2100	W	5	40	20	20	50	13	14	\N	7	6	\N	Geyik Daglari, Akdagi, northern foothill, 2100m	\N	\N
364	M68	16	2250	N	19	35	20	15	80	13	16,17	\N	20	6	\N	Geyik Daglari, Akdagi, northern foothill, 2250m	\N	\N
365	M7	8	2500	W	60	40		25	15			Mergel	30	18	\N	Lycian Akdaglari above Gömbe, above Subasi Yayla, 2500m	\N	\N
366	M62	15	2250	O	14	75	12	5	50			Ophiolit	20	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2250m	\N	\N
367	M63	15	2080	O	11	80	5		40			Ophiolit ?	20	12	\N	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi, range above the firewatch tower (ascent from Yenisarbademli village), 2080m	\N	\N
368	M64	16	2100		41	25	20	40	60	13	14	\N	46	6	\N	Geyik Daglari, Akdagi, cirque system at northern foothill, 2100m	\N	\N
369	M66	16	2100	SW	2	35	20	35	50	13	14	\N	46	6	\N	Geyik Daglari, Akdagi, cirque system at northern foothill, 2100m	\N	\N
370	M69	17	2850	W	22	55		32	40	14	1	\N	1	6	\N	Geyik Daglari, Büyük Geyik Dagi, ascent to the summit along the main ridge, 2850m	\N	\N
371	M70	17	2600	W	22	60		25	40			\N	3	6	\N	Geyik Daglari, Büyük Geyik Dagi, ascent to the summit along the main ridge, 2600m	\N	\N
372	M71	17	2400	NW	14	90	3	2	40			\N	15	6	\N	Geyik Daglari, Büyük Geyik Dagi, ascent to the summit along the main ridge, 2400m	\N	\N
373	M72	17	2300	NWN	17	60	10	20	40			\N	39	6	\N	Geyik Daglari, Büyük Geyik Dagiüber Yayla zwischen Ak Dag und Geyik, 2300m	\N	\N
374	M73	17	2000		0	50		20	80			\N	47	6	\N	Geyik Daglari, Büyük Geyik Dagi, plateau between central lake and northern exit to Anatolia, 2000m	\N	\N
375	M74	19	2280	O	24	35	20	35	60	14	15	\N	41	6	\N	Oyuklu Dagi N of Ermenek, ascent to summit plateau, 2280m	\N	\N
376	M75	19	2100	O	31	50	15	20	40	14	23	\N	41	2	\N	Oyuklu Dagi N of Ermenek, ascent to summit plateau, 2100m	\N	\N
377	M76	19	2050	O	17	45	10	30	50			\N	41	2	\N	Oyuklu Dagi N of Ermenek, ascent to summit plateau, 2050m	\N	\N
378	M77	20	2675	N	14	60	15	15	20			\N	23	9	Sesleria phleoides Ges.	d. Ulukisla, Bolkar Daglari above Meydan, scree slope S of tarn Karagöl, 2675m	\N	\N
379	M78	20	2690	N	19	60	10	20	40	15	8	\N	23	9	Sesleria phleoides Ges.	d. Ulukisla, Bolkar Daglari above Meydan, scree slope S of tarn Karagöl, 2690m	\N	\N
380	M79	20	2750	N	31	50	10	25	40	5	8	\N	23	9	Sesleria phleoides Ges.	d. Ulukisla, Bolkar Daglari above Meydan, scree slope S of tarn Karagöl, 2750m	\N	\N
381	M8	8	2400	NW	23	40		20	30			Mergel	31	2	\N	Lycian Akdaglari above Gömbe, above Subasi Yayla, 2400m	\N	\N
382	M80	20	2900	N	11	85	2	7	25	15	18,19,20	\N	24	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2900m	\N	\N
383	M81	20	2930	N	1	75	10	5	8	15	28	\N	24	10	Sesleria phleoides Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2930m	\N	\N
384	M82	20	2900	NO	2	80	8	6	30	15	34	\N	24	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2900m	\N	\N
385	M83	20	2880	W	2	75	3	15	50			\N	24	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2880m	\N	\N
386	M84	20	2900	N	19	50	10	35				\N	23	10	\N	d. Ulukisla, Bolkar Daglari above Meydanim hinteren kar. siehe karte, 2900m	\N	\N
387	M85	20	2700	N	1	98	0	0	6	15	35,36	\N	22	10	\N	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2700m	\N	\N
388	M86	20	2700	NW	22	75	10	5	40	15	37	\N	48	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2700m	\N	\N
389	M87	20	2750	N	9	70	8	12	10	16	7	\N	23	10	Sesleria phleoides Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2750m	\N	\N
390	M88	20	2750	N	22	65	10	15	30	16	8	\N	23	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2750m	\N	\N
391	M9	7	1800	S	30	70		20	20	7	35,36	Kalk	17	2	\N	Lycian Akdaglari above Gömbe, around Yesil Göl, N edge, 1800m	\N	\N
392	M89	20	2750	N	6	98	0	0	10			\N	48	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2750m	\N	\N
393	M90	20	2760	N	14	90	2	2	40	16	14,15	\N	24	10	Kobresia Ges.	d. Ulukisla, Bolkar Daglari above Meydan, cirque system around tarn Karagöl, between Tahtakaya and Egerkaya, 2760m	\N	\N
394	M91	21	2360	NO	6	70	3	5	100			\N	33	12	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2360m	\N	\N
395	M92	21	2400	SO	19	40	40	10	100			\N	35	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl. N37°25´40´´ O34°34´05´´, 2400m	\N	\N
396	M93	21	2080	N	27	80	8	0	100			\N	34	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl. N37°27´47´´ O34°36´82´´, 2080m	\N	\N
397	M94	21	2090	N	24	85	5	0	100			\N	34	7	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2090m	\N	\N
398	M95	21	2350	SO	17	70	15	5	100			\N	20	10	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to Meydan, 2350m	\N	\N
399	M96	21	2380	NW	6	90	1	4	100			\N	33	12	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2380m	\N	\N
400	M97	21	2200	NWN	17	85	5	0	100			\N	34	0	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to Meydan, 2200m	\N	\N
401	M98	21	2120	NO	27	75	8	0	100			\N	34	12	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to tarn Karagöl, 2120m	\N	\N
402	M99	21	2350	SO	27	60	10	20	100			\N	20	10	Hypericum kotschyanum Ges.	d. Ulukisla, Bolkar Daglari, upper Arpalik (Maden) Deresi, slopes along the road from Darbogaz to Meydan, 2350m	\N	\N
\.


--
-- TOC entry 1753 (class 0 OID 32024)
-- Dependencies: 1336
-- Data for Name: metadata; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY metadata (metadata_id, dataset_guid, technical_contact_name, technical_contact_email, technical_contact_phone, technical_contact_address, content_contact_name, content_contact_email, content_contact_phone, content_contact_address, other_provider_uddi, dataset_title, dataset_details, dataset_coverage, dataset_uri, dataset_icon_uri, dataset_version_major, dataset_creators, dataset_contributors, date_created, date_modified, owner_organization_name, owner_organization_abbrev, owner_contact_person, owner_contact_role, owner_address, owner_telephone, owner_email, owner_uri, owner_logo_uri, ipr_text, ipr_details, ipr_uri, copyright_text, copyright_details, copyright_uri, terms_of_use_text, terms_of_use_details, terms_of_use_uri, disclaimers_text, disclaimers_details, disclaimers_uri, license_text, licenses_details, license_uri, acknowledgements_text, acknowledgements_details, acknowledgements_uri, citations_text, citations_details, citations_uri, source_institution_id, source_id, record_basis, kind_of_unit, higher_taxon_rank) FROM stdin;
1	\N	Markus Döring	m.doering@bgbm.org	+ 55 555 555 555	Botanic Garden & Botanical Museum Berlin-Dahlem, Königin-Luise-Str.6-8, 14191 Berlin, Germany	Markus Döring	m.doering@bgbm.org	+ 55 555 555 555	Botanic Garden & Botanical Museum Berlin-Dahlem, Königin-Luise-Str.6-8, 14191 Berlin, Germany	\N	PonTaurus collection	This database is only a demonstrating database for learning to use the BioCASe Provider Software. Please do not use this data for anything.	This database is testing data and does not cover anything.	http://www.biocase.org	http://www.biocase.org/images/bdi_logo.gif	2.0	Javier de la Torre, Markus Döring	CedocBiv BCN	2000-09-21 00:00:00	2001-03-01 00:00:00			Markus Döring	Researcher	Botanic Garden & Botanical Museum Berlin-Dahlem, Königin-Luise-Str.6-8, 14191 Berlin, Germany	+ 55 555 555 555	m.doering@bgbm.org	http://www.bgbm.org/biodivinf/staff/m.doering	http://www.biocase.org/images/bdi_logo.gif	IPR Text to be completed	\N	http://www.bgbm.org/disclaim_e.htm		\N	\N	This is a testing database anythign can be done	\N	\N		\N	\N	General Public License	\N	http://www.gnu.org/copyleft/gpl.html	Our families and friends for their support :D	\N	\N	BioCASE database	\N	\N	BIOCASE	BioCASE training Facilities	PreservedSpecimen	wholeorganisms	familia
\.


--
-- TOC entry 1754 (class 0 OID 32077)
-- Dependencies: 1337
-- Data for Name: mountain; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY mountain (mountain_id, mountain, mountain_range, villayet_fk, turkish_grid) FROM stdin;
1	unbekannt	unbekannt	\N	
2	c. 10 km NW Brindisi	Brindisi	1	
3	Sandras Dagi, road Agla	Sandras	2	C2
4	Sandras Dagi above Agla	Sandras	2	C2
5	Sandras Dagi	Sandras	2	C2
6	d. Fethiye, Boncuk Daglari	Fethiye	2	C2
7	Lycian Akdaglari above Gömbe, around Ye¼il Göl	Akdag	2	C2
8	Lycian Akdaglari above Gömbe	Akdag	2	C2
9	Beydaglari, Kizlar sivrisi	Kizlar	3	C2
10	Foothills of the Beydaglari SE of Elmali	Kizlar	3	C2
11	d. Kemer, Beydaglari, Tahtali Dagi	Tahtali	3	C3
12	Beydaglari, Bakirli Dagi above Saklikent	Bakirli	3	C3
13	Beydaglari, Bakirli Dagi area	Bakirli	3	C3
14	Beydaglari, below Saklikent	Bakirli	3	C3
15	Dedegöl Daglari, Dipoyraz (Dedegöl) Dagi	Dedegöl	6	C3
16	Geyik Daglari, Akdagi	Geyik	3	C4
17	Geyik Daglari, Büyük Geyik Dagi	Geyik	3	C4
18	Geyik Daglari	Geyik	3	C4
19	Oyuklu Dagi N of Ermenek	Oyuklu	5	C4
20	d. Ulukisla, Bolkar Daglari above Meydan	Bolkar	4	C5
21	d. Ulukisla, Bolkar Daglari	Bolkar	4	C5
22	Aladaglari, Kayacik Deresi	Aladaglari	9	C5
23	Aladaglari, upper Narpiz Deresi	Aladaglari	9	C5
24	Aladaglari, northern part (?Black Aladaglari?)	Aladaglari	4	C5
25	Aladaglari, upper Yalak Deresi	Aladaglari	4	C5
26	Aladaglari, lower Yalak Deresi	Aladaglari	4	C5
27	Aladaglari, Emli Vadisi	Aladaglari	4	C5
28	Aladaglari, Karamük Bogazi	Aladaglari	4	C5
29	Aladaglari	Aladaglari	4	C5
30	Çoruh valley NE ?spir	Çoruh	10	A8
31	Çoruh valley near Tekkale	Çoruh	11	A8
32	Yusufeli - Olur	Çoruh	11	A8
33	Dogu Karadeniz Daglari, Ovitdagi Geçedi	Kaçkar	12	A8
34	Dogu Karadeniz Daglari, central Kaçkar Daglari	Kaçkar	11	A8
35	Dogu Karadeniz Daglari, Altindere Vadisi Milli Park above Maçka	Kaçkar	13	A7
36	Yassihüyük (ancient site of Gordion)	Gordion	14	B4
37	c. 10 km ENE Afyon	Afyon	15	B3
39	Aladaglari, lower Narpiz Deresi	Aladaglari	9	C5
40	Doganbey - Seferihisar	Seaside	16	B1
\.


--
-- TOC entry 1755 (class 0 OID 32090)
-- Dependencies: 1338
-- Data for Name: observation; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY observation (observation_id, lfd_nummer, taxon_fk, cover, locality_fk, specimen_fk) FROM stdin;
1	5319	265	1   	125	0
2	5319	265	+   	126	0
3	5320	119	.   	123	0
4	5321	12	+   	123	0
5	5321	12	+   	125	0
6	5322	30	+   	123	0
7	5323	913	+   	123	0
8	5323	913	+   	125	0
9	5324	265	+   	125	0
10	5325	504	+   	125	0
11	5327	336	1   	126	0
12	5329	493	+   	118	0
13	5329	493	+   	123	0
14	5329	493	+   	124	0
15	5329	493	+   	125	0
16	5329	493	1m  	126	0
17	5330	363	1   	126	0
18	5331	794	1   	126	0
19	5332	56	3   	119	0
20	5332	56	4   	120	0
21	5333	288	+   	119	0
22	5333	288	1m  	120	0
23	5334	394	+   	119	0
24	5334	394	+   	120	0
25	5335	412	+   	119	0
26	5336	304	1   	119	0
27	5336	304	+   	120	0
28	5336	304	+   	122	0
29	5336	304	1m  	128	0
30	5337	437	1   	119	0
31	5337	437	1m  	120	0
32	5338	493	+   	119	0
33	5339	577	+   	119	0
34	5340	195	1   	119	0
35	5340	195	1   	121	0
36	5340	195	2a  	122	0
37	5340	195	2a  	128	0
38	5341	119	+   	119	0
39	5341	119	+   	120	0
40	5342	363	+   	119	0
41	5342	363	+   	120	0
42	5343	319	+   	119	0
43	5343	319	1m  	120	0
44	5344	492	+   	119	0
45	5344	492	+   	120	0
46	5345	19	+   	119	0
47	5345	19	1   	120	0
48	5346	286	+   	119	0
49	5346	286	+   	120	0
50	5347	265	1m  	119	0
51	5347	265	1   	120	0
52	5348	123	+   	119	0
53	5348	123	+   	120	0
54	5349	184	1   	119	0
55	5349	184	2b  	120	0
56	5349	184	2a  	121	0
57	5349	184	1   	122	0
58	5349	184	1   	128	0
59	5349	184	2a  	129	0
60	5349	184	2b  	130	0
61	5349	184	1   	131	0
62	5349	184	1   	132	0
63	5349	184	2a  	133	0
64	5350	409	1m  	121	0
65	5350	409	+   	128	0
66	5350	409	1m  	131	0
67	5350	409	1m  	132	0
68	5350	409	1   	133	0
69	5351	829	1   	119	0
70	5351	829	1   	120	0
71	5352	429	+   	119	0
72	5353	320	+   	119	0
73	5353	320	1m  	120	0
74	5354	336	1   	120	0
75	5355	236	1m  	120	0
76	5357	204	1m  	120	0
77	5358	281	1m  	120	0
78	5359	794	1   	120	0
79	5360	298	+   	120	0
80	5361	358	+   	120	0
81	5362	913	+   	120	0
82	5363	829	3   	121	0
83	5363	829	1   	122	0
84	5363	829	3   	128	0
85	5363	829	2a  	129	0
86	5363	829	2a  	131	0
87	5363	829	1   	132	0
88	5363	829	1   	133	0
89	5364	759	+   	121	0
90	5364	759	+   	122	0
91	5364	759	+   	133	0
92	5365	144	+   	121	0
93	5365	144	2a  	122	0
94	5365	144	+   	128	0
95	5365	144	1   	129	0
96	5365	144	1   	130	0
97	5365	144	1   	131	0
98	5365	144	1   	132	0
99	5365	144	3   	133	0
100	5366	30	+   	121	0
101	5366	30	+   	122	0
102	5366	30	+   	128	0
103	5366	30	+   	129	0
104	5366	30	+   	130	0
105	5366	30	+   	131	0
106	5366	30	+   	132	0
107	5366	30	+   	133	0
108	5367	381	1   	121	0
109	5367	381	+   	133	0
110	5368	290	1m  	121	0
111	5368	290	+   	129	0
112	5368	290	+   	130	0
113	5368	290	1   	131	0
114	5368	290	1m  	132	0
115	5368	290	1m  	133	0
116	5369	393	1   	121	0
117	5369	393	+   	122	0
118	5370	418	+   	121	0
119	5370	418	+   	130	0
120	5371	1101	1m  	121	0
121	5371	1101	+   	122	0
122	5371	1101	+   	128	0
123	5371	1101	+   	129	0
124	5371	1101	+   	133	0
125	5372	273	+   	121	0
126	5372	273	+   	122	0
127	5372	273	+   	128	0
128	5373	363	+   	121	0
129	5373	363	+   	122	0
130	5373	363	1   	128	0
131	5375	495	1m  	121	0
132	5375	495	+   	122	0
133	5375	495	+   	128	0
134	5375	495	1m  	129	0
135	5375	495	1m  	130	0
136	5375	495	1m  	131	0
137	5375	495	1m  	132	0
138	5377	418	1m  	121	0
139	5378	103	+   	121	0
140	5379	273	+   	121	0
141	5379	273	+   	122	0
142	5379	273	+   	128	0
143	5379	273	1m  	129	0
144	5379	273	+   	131	0
145	5380	161	1   	121	0
146	5380	161	+   	122	0
147	5380	161	+   	128	0
148	5380	161	1   	129	0
149	5380	161	+   	130	0
150	5380	161	+   	132	0
151	5381	490	+   	121	0
152	5381	490	+   	128	0
153	5381	490	+   	129	0
154	5381	490	+   	130	0
155	5381	490	+   	131	0
156	5381	490	+   	132	0
157	5381	490	+   	133	0
158	5382	759	1m  	121	0
159	5382	759	+   	122	0
160	5382	759	+   	128	0
161	5382	759	+   	132	0
162	5383	937	+   	121	0
163	5383	937	+   	128	0
164	5383	937	+   	132	0
165	5384	429	+   	121	0
166	5384	429	+   	122	0
167	5384	429	+   	128	0
168	5385	100	+   	121	0
169	5385	100	1   	129	0
170	5385	100	1   	130	0
171	5385	100	1   	131	0
172	5385	100	+   	132	0
173	5386	279	+   	121	0
174	5386	279	+   	122	0
175	5386	279	1m  	129	0
176	5387	277	+   	121	0
177	5387	277	+   	128	0
178	5387	277	+   	129	0
179	5387	277	1m  	132	0
180	5388	324	+   	121	0
181	5388	324	+   	122	0
182	5388	324	+   	128	0
183	5388	324	+   	129	0
184	5388	324	+   	132	0
185	5388	324	+   	133	0
186	5389	12	+   	121	0
187	5389	12	+   	122	0
188	5389	12	+   	128	0
189	5390	242	+   	121	0
190	5390	242	1m  	132	0
191	5391	423	1m  	121	0
192	5392	18	1   	121	0
193	5392	18	1   	122	0
194	5392	18	+   	128	0
195	5393	198	a   	121	0
196	5393	198	+   	129	0
197	5393	198	+   	131	0
198	5393	198	+   	132	0
199	5393	198	1m  	133	0
200	5394	516	+   	122	0
201	5394	516	1m  	128	0
202	5395	127	+   	122	0
203	5395	127	1m  	128	0
204	5396	381	+   	122	0
205	5396	381	+   	128	0
206	5397	48	1   	122	0
207	5397	48	+   	128	0
208	5397	48	1   	129	0
209	5397	48	1   	130	0
210	5397	48	1   	131	0
211	5397	48	1   	132	0
212	5398	346	1   	122	0
213	5398	346	1   	129	0
214	5398	346	1   	130	0
215	5398	346	2a  	131	0
216	5398	346	1   	132	0
217	5399	1119	+   	122	0
218	5399	1119	+   	128	0
219	5400	436	+   	122	0
220	5400	436	1m  	128	0
221	5400	436	+   	129	0
222	5400	436	+   	130	0
223	5400	436	+   	133	0
224	5401	570	1m  	122	0
225	5401	570	+   	128	0
226	5402	756	+   	128	0
227	5403	100	+   	128	0
228	5404	363	+   	129	0
229	5404	363	+   	130	0
230	5404	363	+   	131	0
231	5404	363	+   	132	0
232	5405	219	.   	129	0
233	5406	429	1m  	129	0
234	5406	429	1m  	130	0
235	5406	429	1m  	132	0
236	5406	429	+   	133	0
237	5407	409	1m  	129	0
238	5407	409	1m  	130	0
239	5407	409	1m  	132	0
240	5407	409	+   	133	0
241	5408	167	1   	129	0
242	5408	167	1   	130	0
243	5408	167	1m  	131	0
244	5408	167	1m  	132	0
245	5408	167	1   	133	0
246	5409	219	1m  	129	0
247	5409	219	+   	130	0
248	5410	495	+   	133	0
249	5412	363	+   	129	0
250	5412	363	+   	130	0
251	5412	363	+   	131	0
252	5412	363	+   	132	0
253	5413	612	+   	129	0
254	5414	548	1   	130	0
255	5414	548	2b  	132	0
256	5415	358	1   	130	0
257	5415	358	1   	131	0
258	5415	358	1   	132	0
259	5415	358	1   	133	0
260	5416	392	1   	130	0
261	5416	392	1   	131	0
262	5416	392	1   	132	0
263	5416	392	1   	133	0
264	5417	606	+   	130	0
265	5417	606	+   	131	0
266	5417	606	+   	132	0
267	5417	606	1   	133	0
268	5418	79	+   	130	0
269	5418	79	+   	131	0
270	5418	79	1m  	133	0
271	5419	318	+   	130	0
272	5419	318	+   	131	0
273	5420	564	r   	130	0
274	5421	1104	r   	130	0
275	5421	1104	+   	132	0
276	5422	990	+   	129	0
277	5422	990	1   	130	0
278	5422	990	1m  	131	0
279	5422	990	1   	132	0
280	5423	616	+   	131	0
281	5423	616	+   	133	0
282	5424	496	1m  	131	0
283	5424	496	+   	132	0
284	5424	496	+   	133	0
285	5425	982	+   	131	0
286	5425	982	+   	132	0
287	5425	982	+   	133	0
288	5426	290	.   	131	0
289	5427	178	1   	133	0
290	5428	32	+   	133	0
291	5430	920	+   	131	0
292	5431	620	+   	131	0
293	5432	346	1   	133	0
294	5433	26	+   	133	0
295	5434	22	+   	133	0
296	5436	184	2b  	134	0
297	5436	184	2a  	136	0
298	5436	184	3   	137	0
299	5436	184	1   	138	0
300	5436	184	1   	139	0
301	5436	184	1   	143	0
302	5436	184	1   	144	0
303	5436	184	2a  	145	0
304	5436	184	1   	146	0
305	5437	389	2a  	134	0
306	5437	389	1   	136	0
307	5437	389	1   	137	0
308	5437	389	2a  	139	0
309	5437	389	2a  	143	0
310	5437	389	1   	144	0
311	5437	389	1   	145	0
312	5437	389	1m  	146	0
313	5438	30	1   	134	0
314	5438	30	1   	136	0
315	5438	30	+   	137	0
316	5438	30	1m  	139	0
317	5438	30	1   	143	0
318	5438	30	1   	144	0
319	5438	30	1   	145	0
320	5438	30	1   	146	0
321	5439	119	+   	134	0
322	5439	119	+   	136	0
323	5439	119	+   	143	0
324	5439	119	+   	144	0
325	5440	19	+   	134	0
326	5440	19	1   	139	0
327	5440	19	+   	143	0
328	5440	19	+   	144	0
329	5440	19	+   	145	0
330	5440	19	+   	146	0
331	5441	388	+   	134	0
332	5441	388	+   	136	0
333	5441	388	+   	137	0
334	5441	388	1m  	139	0
335	5441	388	+   	143	0
336	5441	388	2a  	144	0
337	5441	388	2a  	145	0
338	5441	388	+   	146	0
339	5442	178	+   	134	0
340	5442	178	+   	136	0
341	5443	324	1   	134	0
342	5443	324	2b  	136	0
343	5443	324	2a  	137	0
344	5443	324	1   	138	0
345	5443	324	2b  	139	0
346	5443	324	1   	144	0
347	5443	324	2a  	145	0
348	5443	324	2b  	146	0
349	5444	1101	.   	134	0
350	5444	1101	+   	143	0
351	5444	1101	+   	146	0
352	5445	239	+   	134	0
353	5445	239	1   	136	0
354	5445	239	1   	139	0
355	5445	239	1m  	143	0
356	5445	239	1m  	145	0
357	5445	239	1   	146	0
358	5446	394	1   	134	0
359	5446	394	1   	136	0
360	5446	394	1   	139	0
361	5446	394	1   	143	0
362	5446	394	1   	144	0
363	5446	394	1   	145	0
364	5447	526	1m  	134	0
365	5447	526	+   	136	0
366	5447	526	1m  	139	0
367	5447	526	1m  	143	0
368	5447	526	+   	144	0
369	5447	526	1m  	145	0
370	5447	526	1m  	146	0
371	5448	363	+   	134	0
372	5448	363	1   	136	0
373	5448	363	1   	139	0
374	5448	363	+   	143	0
375	5448	363	1   	144	0
376	5448	363	1   	145	0
377	5448	363	1   	146	0
378	5450	430	+   	134	0
379	5450	430	+   	136	0
380	5450	430	+   	139	0
381	5450	430	+   	143	0
382	5450	430	1m  	144	0
383	5450	430	1m  	145	0
384	5451	510	1m  	134	0
385	5451	510	1m  	136	0
386	5451	510	+   	143	0
387	5451	510	+   	144	0
388	5451	510	+   	146	0
389	5452	279	1m  	134	0
390	5452	279	1   	137	0
391	5452	279	1   	138	0
392	5452	279	1   	139	0
393	5452	279	1m  	145	0
394	5452	279	1m  	146	0
395	5454	21	1   	134	0
396	5455	1101	1m  	134	0
397	5455	1101	.   	146	0
398	5456	490	1m  	134	0
399	5456	490	+   	136	0
400	5456	490	+   	139	0
401	5456	490	1m  	143	0
402	5456	490	1   	144	0
403	5456	490	1   	146	0
404	5457	653	1m  	134	0
405	5458	269	1m  	134	0
406	5458	269	+   	138	0
407	5458	269	+   	146	0
408	5459	937	1m  	134	0
409	5459	937	+   	136	0
410	5459	937	+   	137	0
411	5459	937	1m  	138	0
412	5459	937	+   	139	0
413	5459	937	+   	145	0
414	5460	491	+   	134	0
415	5460	491	+   	139	0
416	5460	491	+   	146	0
417	5461	12	+   	134	0
418	5462	79	+   	134	0
419	5462	79	+   	136	0
420	5462	79	1   	137	0
421	5462	79	+   	143	0
422	5462	79	+   	144	0
423	5462	79	+   	145	0
424	5462	79	1   	154	0
425	5463	427	1   	134	0
426	5463	427	2a  	136	0
427	5463	427	2b  	137	0
428	5463	427	3   	138	0
429	5463	427	+   	139	0
430	5463	427	1   	146	0
431	5464	290	1m  	134	0
432	5464	290	1m  	136	0
433	5464	290	1m  	137	0
434	5464	290	1   	138	0
435	5464	290	1m  	139	0
436	5464	290	1m  	145	0
437	5464	290	1m  	146	0
438	5465	829	2b  	134	0
439	5465	829	2a  	136	0
440	5465	829	+   	138	0
441	5465	829	2a  	143	0
442	5465	829	2b  	144	0
443	5465	829	3   	145	0
444	5465	829	3   	146	0
445	5467	195	+   	134	0
446	5467	195	+   	136	0
447	5467	195	+   	137	0
448	5467	195	2b  	138	0
449	5467	195	+   	139	0
450	5468	125	1m  	136	0
451	5469	890	+   	136	0
452	5469	890	+   	143	0
453	5469	890	+   	144	0
454	5469	890	+   	145	0
455	5469	890	+   	146	0
456	5470	390	1   	136	0
457	5470	390	1   	137	0
458	5470	390	1   	139	0
459	5470	390	+   	143	0
460	5470	390	1   	145	0
461	5470	390	1   	146	0
462	5471	302	1m  	136	0
463	5471	302	1   	138	0
464	5471	302	+   	143	0
465	5471	302	+   	146	0
466	5472	319	1m  	136	0
467	5472	319	1   	137	0
468	5472	319	1   	138	0
469	5472	319	1m  	139	0
470	5472	319	1   	145	0
471	5472	319	1   	146	0
472	5473	363	.   	136	0
473	5474	523	+   	136	0
474	5474	523	+   	143	0
475	5474	523	+   	144	0
476	5475	17	2a  	136	0
477	5475	17	1   	137	0
478	5475	17	+   	139	0
479	5475	17	1   	143	0
480	5475	17	1   	144	0
481	5475	17	1   	145	0
482	5475	17	1   	146	0
483	5476	348	2b  	136	0
484	5476	348	+   	146	0
485	5477	375	+   	136	0
486	5477	375	+   	139	0
487	5478	437	1   	137	0
488	5479	412	1   	137	0
489	5480	421	1m  	137	0
490	5480	421	1   	138	0
491	5480	421	1m  	145	0
492	5481	302	1m  	137	0
493	5481	302	1m  	138	0
494	5482	12	+   	137	0
495	5482	12	+   	138	0
496	5482	12	1m  	139	0
497	5482	12	+   	143	0
498	5482	12	1m  	144	0
499	5482	12	1m  	145	0
500	5482	12	+   	146	0
501	5483	652	+   	137	0
502	5483	652	+   	138	0
503	5484	829	1   	137	0
504	5485	281	+   	137	0
505	5485	281	1   	139	0
506	5485	281	1   	143	0
507	5485	281	+   	144	0
508	5485	281	1   	145	0
509	5485	281	1   	146	0
510	5486	361	+   	138	0
511	5487	115	1   	138	0
512	5487	115	1   	143	0
513	5487	115	1m  	144	0
514	5488	550	1m  	138	0
515	5489	236	1m  	139	0
516	5489	236	1   	145	0
517	5489	236	1   	146	0
518	5490	103	1m  	139	0
519	5490	103	1m  	145	0
520	5490	103	1m  	146	0
521	5491	894	1m  	139	0
522	5491	894	+   	146	0
523	5492	300	1   	139	0
524	5492	300	+   	143	0
525	5492	300	a   	144	0
526	5492	300	1   	145	0
527	5492	300	a   	146	0
528	5493	26	1m  	139	0
529	5494	302	+   	139	0
530	5495	490	.   	139	0
531	5496	718	+   	139	0
532	5497	356	+   	139	0
533	5497	356	1   	146	0
534	5498	298	+   	139	0
535	5498	298	a   	143	0
536	5498	298	+   	144	0
537	5499	85	+   	139	0
538	5501	608	1m  	139	0
539	5502	829	3   	139	0
540	5503	56	2b  	143	0
541	5503	56	2a  	144	0
542	5503	56	2b  	146	0
543	5504	214	1   	143	0
544	5504	214	1   	144	0
545	5504	214	1   	145	0
546	5504	214	1   	146	0
547	5505	490	.   	143	0
548	5506	913	+   	143	0
549	5506	913	1m  	144	0
550	5506	913	+   	145	0
551	5506	913	+   	146	0
552	5507	308	+   	144	0
553	5508	336	+   	145	0
554	5508	336	+   	146	0
555	5509	430	+   	146	0
556	5510	218	+   	145	0
557	5510	218	+   	146	0
558	5511	879	+   	146	0
559	5512	26	+   	145	0
560	5512	26	+   	146	0
561	5513	330	+   	145	0
562	5513	330	+   	146	0
563	5514	114	1   	143	0
564	5514	114	1m  	144	0
565	5515	829	3   	147	0
566	5515	829	1   	150	0
567	5515	829	1   	151	0
568	5515	829	+   	152	0
569	5515	829	+   	153	0
570	5516	348	2a  	147	0
571	5516	348	3   	148	0
572	5516	348	3   	150	0
573	5516	348	3   	151	0
574	5516	348	2a  	152	0
575	5516	348	1   	153	0
576	5517	496	2a  	147	0
577	5517	496	1   	150	0
578	5517	496	1   	151	0
579	5517	496	1   	152	0
580	5517	496	+   	153	0
581	5517	496	1   	154	0
582	5518	195	1   	147	0
583	5518	195	1   	148	0
584	5518	195	+   	150	0
585	5518	195	+   	152	0
586	5518	195	+   	153	0
587	5519	302	1   	147	0
588	5520	430	1   	147	0
589	5521	599	1   	147	0
590	5521	599	1m  	148	0
591	5521	599	+   	150	0
592	5521	599	+   	154	0
593	5522	336	.   	147	0
594	5523	198	1   	147	0
595	5523	198	+   	150	0
596	5523	198	1m  	151	0
597	5523	198	1   	152	0
598	5523	198	1   	154	0
599	5524	44	1m  	147	0
600	5525	937	1m  	147	0
601	5525	937	+   	148	0
602	5525	937	1m  	151	0
603	5525	937	+   	152	0
604	5525	937	1m  	154	0
605	5526	440	1   	147	0
606	5526	440	1m  	150	0
607	5527	443	1   	147	0
608	5528	761	+   	147	0
609	5528	761	1   	154	0
610	5529	408	+   	147	0
611	5530	30	1m  	147	0
612	5530	30	2b  	148	0
613	5530	30	2b  	150	0
614	5530	30	1m  	151	0
615	5530	30	2a  	152	0
616	5530	30	1   	153	0
617	5530	30	1   	154	0
618	5531	18	1   	147	0
619	5532	898	1   	147	0
620	5532	898	1   	152	0
621	5532	898	1m  	153	0
622	5533	31	1m  	147	0
623	5534	391	+   	147	0
624	5535	1118	+   	147	0
625	5536	465	1m  	147	0
626	5537	336	1m  	147	0
627	5537	336	1   	150	0
628	5537	336	1   	151	0
629	5537	336	1   	153	0
630	5537	336	1   	154	0
631	5538	1144	1m  	147	0
632	5539	408	+   	147	0
633	5541	479	1m  	147	0
634	5542	1142	+   	147	0
635	5543	918	1m  	147	0
636	5544	146	+   	147	0
637	5545	51	+   	147	0
638	5545	51	+   	151	0
639	5545	51	+   	152	0
640	5545	51	+   	153	0
641	5546	178	a   	147	0
642	5546	178	1   	148	0
643	5546	178	1   	150	0
644	5546	178	1m  	151	0
645	5546	178	1   	152	0
646	5546	178	1   	153	0
647	5547	389	a   	147	0
648	5548	346	1   	147	0
649	5548	346	+   	152	0
650	5549	15	+   	147	0
651	5549	15	+   	150	0
652	5549	15	+   	152	0
653	5549	15	1   	154	0
654	5550	125	.   	148	0
655	5551	242	1m  	148	0
656	5552	412	1   	148	0
657	5552	412	1   	150	0
658	5552	412	+   	152	0
659	5553	21	1   	148	0
660	5553	21	1   	150	0
661	5554	348	.   	148	0
662	5555	430	1   	148	0
663	5555	430	1   	150	0
664	5555	430	1   	151	0
665	5555	430	1m  	152	0
666	5555	430	+   	153	0
667	5556	184	2a  	148	0
668	5556	184	1   	150	0
669	5556	184	1   	151	0
670	5556	184	+   	152	0
671	5556	184	+   	153	0
672	5556	184	+   	154	0
673	5557	643	1   	148	0
674	5557	643	2a  	150	0
675	5557	643	1   	151	0
676	5557	643	1   	152	0
677	5557	643	+   	153	0
678	5558	324	1   	148	0
679	5558	324	1   	150	0
680	5559	356	+   	148	0
681	5559	356	+   	150	0
682	5559	356	+   	151	0
683	5559	356	+   	152	0
684	5559	356	+   	154	0
685	5560	390	1   	148	0
686	5560	390	1   	150	0
687	5561	420	1m  	148	0
688	5561	420	1m  	150	0
689	5562	829	1   	148	0
690	5563	216	1m  	148	0
691	5564	707	+   	148	0
692	5565	125	1   	148	0
693	5565	125	+   	150	0
694	5565	125	+   	151	0
695	5565	125	+   	152	0
696	5566	287	+   	148	0
697	5566	287	a   	150	0
698	5566	287	a   	151	0
699	5566	287	2b  	154	0
700	5567	277	1m  	150	0
701	5567	277	a   	151	0
702	5567	277	+   	152	0
703	5567	277	a   	153	0
704	5568	436	+   	150	0
705	5568	436	+   	151	0
706	5569	370	1m  	150	0
707	5569	370	1m  	152	0
708	5569	370	1m  	153	0
709	5570	381	+   	150	0
710	5571	440	+   	150	0
711	5571	440	+   	152	0
712	5572	1170	1m  	150	0
713	5572	1170	+   	152	0
714	5573	21	.   	150	0
715	5575	57	1m  	151	0
716	5575	57	+   	154	0
717	5576	761	+   	151	0
718	5577	302	1m  	151	0
719	5578	593	+   	151	0
720	5579	732	+   	151	0
721	5579	732	1m  	154	0
722	5581	15	2b  	151	0
723	5582	1110	+   	151	0
724	5582	1110	+   	155	0
725	5584	833	1   	151	0
726	5584	833	+   	153	0
727	5585	348	.   	151	0
728	5586	756	+   	151	0
729	5587	216	1m  	152	0
730	5587	216	+   	153	0
731	5588	855	1   	152	0
732	5588	855	+   	153	0
733	5589	616	1m  	152	0
734	5590	103	1   	152	0
735	5591	504	1   	152	0
736	5591	504	+   	153	0
737	5592	824	+   	152	0
738	5593	490	1m  	152	0
739	5594	51	1   	152	0
740	5594	51	+   	153	0
741	5595	165	1m  	152	0
742	5595	165	1   	154	0
743	5596	408	+   	152	0
744	5596	408	+   	153	0
745	5596	408	1   	154	0
746	5597	15	4   	153	0
747	5598	920	2a  	153	0
748	5600	510	1m  	154	0
749	5601	7	1   	154	0
750	5602	643	2b  	154	0
751	5602	643	1   	155	0
752	5604	32	1   	154	0
753	5605	937	2a  	154	0
754	5606	15	.   	154	0
755	5607	430	1   	154	0
756	5608	694	1m  	154	0
757	5609	434	+   	154	0
758	5610	873	+   	154	0
759	5611	273	1m  	154	0
760	5612	412	1   	154	0
761	5613	682	1m  	154	0
762	5613	682	1m  	155	0
763	5614	358	1m  	154	0
764	5615	302	+   	154	0
765	5616	427	1   	154	0
766	5617	829	.   	154	0
767	5618	834	2b  	154	0
768	5619	829	3   	154	0
769	5620	829	2a  	155	0
770	5621	314	1   	155	0
771	5622	937	2b  	155	0
772	5623	1142	+   	155	0
773	5624	287	1   	155	0
774	5625	792	2a  	155	0
775	5626	51	1m  	155	0
776	5627	732	1m  	155	0
777	5628	669	1m  	155	0
778	5630	670	+   	155	0
779	5631	905	1m  	155	0
780	5632	12	1m  	155	0
781	5633	671	+   	155	0
782	5634	846	1m  	155	0
783	5635	429	+   	155	0
784	5636	821	1m  	155	0
785	5637	389	1   	155	0
786	5640	7	1m  	155	0
787	5641	26	+   	155	0
788	5642	813	+   	155	0
789	5643	212	+   	155	0
790	5644	17	1m  	155	0
791	5645	820	+   	155	0
792	5646	144	2a  	156	0
793	5646	144	2a  	157	0
794	5646	144	2a  	158	0
795	5646	144	2a  	163	0
796	5647	56	2b  	156	0
797	5647	56	3   	157	0
798	5647	56	2b  	158	0
799	5648	346	1   	156	0
800	5648	346	2a  	157	0
801	5648	346	1   	158	0
802	5648	346	3   	163	0
803	5649	30	1   	156	0
804	5649	30	1   	157	0
805	5649	30	1   	158	0
806	5649	30	1   	163	0
807	5650	19	1   	156	0
808	5650	19	1   	157	0
809	5650	19	1   	158	0
810	5650	19	+   	163	0
811	5651	324	1m  	156	0
812	5651	324	1   	157	0
813	5651	324	+   	158	0
814	5651	324	2a  	163	0
815	5652	527	1m  	156	0
816	5652	527	1m  	157	0
817	5652	527	1m  	158	0
818	5653	1164	1   	156	0
819	5653	1164	2a  	157	0
820	5653	1164	1   	158	0
821	5653	1164	1   	163	0
822	5654	79	1   	156	0
823	5654	79	+   	158	0
824	5654	79	+   	163	0
825	5655	418	1m  	156	0
826	5656	130	1m  	156	0
827	5656	130	+   	158	0
828	5656	130	+   	163	0
829	5657	305	1m  	156	0
830	5657	305	+   	158	0
831	5658	389	1m  	156	0
832	5658	389	+   	163	0
833	5658	389	1   	160	0
834	5658	389	1   	161	0
835	5659	287	+   	156	0
836	5660	375	+   	156	0
837	5660	375	1m  	158	0
838	5661	394	1   	156	0
839	5661	394	1   	157	0
840	5661	394	1   	158	0
841	5661	394	+   	163	0
842	5662	119	+   	156	0
843	5662	119	+   	158	0
844	5663	275	+   	156	0
845	5663	275	+   	157	0
846	5664	746	+   	156	0
847	5665	11	1   	156	0
848	5665	11	1   	157	0
849	5665	11	+   	158	0
850	5666	713	1   	156	0
851	5666	713	1m  	158	0
852	5667	128	+   	156	0
853	5668	188	1   	156	0
854	5669	504	+   	156	0
855	5669	504	+   	157	0
856	5670	863	1m  	156	0
857	5670	863	1m  	158	0
858	5670	863	1m  	163	0
859	5671	380	1m  	156	0
860	5671	380	+   	163	0
861	5672	765	+   	156	0
862	5672	765	+   	158	0
863	5673	414	+   	156	0
864	5673	414	+   	157	0
865	5673	414	+   	158	0
866	5673	414	+   	163	0
867	5674	190	+   	156	0
868	5674	190	1   	163	0
869	5675	236	1m  	156	0
870	5675	236	+   	163	0
871	5676	279	+   	156	0
872	5676	279	+   	157	0
873	5677	176	+   	156	0
874	5677	176	+   	158	0
875	5678	455	+   	157	0
876	5679	616	1   	157	0
877	5680	213	1   	157	0
878	5681	153	1   	157	0
879	5681	153	+   	158	0
880	5682	426	+   	157	0
881	5683	167	1   	157	0
882	5684	169	1m  	157	0
883	5685	388	1m  	157	0
884	5686	119	+   	157	0
885	5687	26	+   	157	0
886	5687	26	1   	163	0
887	5689	888	+   	157	0
888	5689	888	+   	158	0
889	5689	888	+   	163	0
890	5690	48	1   	157	0
891	5691	260	1m  	157	0
892	5691	260	+   	158	0
893	5692	223	1m  	157	0
894	5693	277	a   	157	0
895	5693	277	+   	158	0
896	5694	330	1m  	158	0
897	5694	330	1   	163	0
898	5695	286	+   	158	0
899	5695	286	+   	163	0
900	5696	866	a   	157	0
901	5696	866	+   	158	0
902	5697	330	.   	158	0
903	5698	57	1   	163	0
904	5699	758	+   	158	0
905	5699	758	+   	163	0
906	5700	599	1m  	163	0
907	5701	708	+   	163	0
908	5702	420	1   	163	0
909	5703	356	+   	163	0
910	5704	304	+   	163	0
911	5705	166	1m  	163	0
912	5706	26	1   	163	0
913	5708	12	+   	163	0
914	5709	937	+   	163	0
915	5710	261	2b  	165	0
916	5710	261	2a  	166	0
917	5710	261	2b  	167	0
918	5710	261	2b  	168	0
919	5710	261	2b  	159	0
920	5710	261	2a  	160	0
921	5710	261	1   	161	0
922	5711	170	1   	165	0
923	5711	170	1   	166	0
924	5711	170	2a  	167	0
925	5711	170	1   	159	0
926	5712	61	1   	165	0
927	5712	61	+   	161	0
928	5713	872	1m  	165	0
929	5713	872	2a  	168	0
930	5713	872	1   	159	0
931	5713	872	a   	160	0
932	5714	432	1   	165	0
933	5714	432	1   	166	0
934	5714	432	1   	167	0
935	5714	432	1   	168	0
936	5714	432	1   	159	0
937	5715	151	1   	165	0
938	5715	151	1   	166	0
939	5715	151	1   	167	0
940	5715	151	1   	168	0
941	5715	151	+   	159	0
942	5716	381	1m  	165	0
943	5716	381	1m  	166	0
944	5716	381	1m  	167	0
945	5716	381	1m  	168	0
946	5716	381	1m  	159	0
947	5716	381	+   	160	0
948	5716	381	1   	161	0
949	5717	356	1   	165	0
950	5717	356	1   	166	0
951	5717	356	+   	168	0
952	5717	356	+   	160	0
953	5717	356	+   	161	0
954	5718	304	+   	165	0
955	5718	304	+   	166	0
956	5718	304	+   	168	0
957	5718	304	+   	159	0
958	5719	279	1m  	165	0
959	5719	279	+   	166	0
960	5719	279	+   	167	0
961	5719	279	+   	168	0
962	5719	279	+   	160	0
963	5719	279	+   	161	0
964	5720	1101	1m  	165	0
965	5720	1101	+   	166	0
966	5720	1101	+   	167	0
967	5720	1101	+   	168	0
968	5720	1101	+   	159	0
969	5720	1101	+   	160	0
970	5720	1101	+   	161	0
971	5721	186	1   	165	0
972	5721	186	+   	166	0
973	5721	186	1   	167	0
974	5721	186	1   	168	0
975	5721	186	1   	159	0
976	5721	186	+   	160	0
977	5722	31	+   	165	0
978	5722	31	+   	166	0
979	5722	31	1   	167	0
980	5722	31	+   	168	0
981	5722	31	+   	159	0
982	5723	479	+   	165	0
983	5723	479	+   	166	0
984	5723	479	1m  	167	0
985	5723	479	1   	168	0
986	5723	479	+   	159	0
987	5724	12	+   	165	0
988	5724	12	+   	166	0
989	5724	12	+   	167	0
990	5724	12	1m  	168	0
991	5724	12	+   	160	0
992	5724	12	+   	161	0
993	5725	11	+   	165	0
994	5725	11	+   	166	0
995	5726	247	1m  	165	0
996	5726	247	1m  	168	0
997	5727	370	+   	165	0
998	5727	370	+   	167	0
999	5727	370	+   	168	0
1000	5728	732	+   	165	0
1001	5729	647	1m  	165	0
1002	5729	647	1m  	167	0
1003	5729	647	+   	168	0
1004	5730	130	+   	165	0
1005	5730	130	+   	167	0
1006	5730	130	+   	168	0
1007	5731	420	+   	165	0
1008	5731	420	1m  	166	0
1009	5731	420	1m  	168	0
1010	5731	420	1   	159	0
1011	5731	420	1   	160	0
1012	5731	420	1   	161	0
1013	5732	352	2a  	165	0
1014	5732	352	2b  	166	0
1015	5732	352	3   	167	0
1016	5732	352	3   	168	0
1017	5732	352	3   	159	0
1018	5732	352	1   	160	0
1019	5732	352	+   	161	0
1020	5733	726	+   	165	0
1021	5733	726	1m  	166	0
1022	5733	726	+   	167	0
1023	5733	726	1m  	159	0
1024	5734	79	+   	165	0
1025	5734	79	+   	166	0
1026	5734	79	+   	167	0
1027	5734	79	+   	168	0
1028	5734	79	+   	159	0
1029	5734	79	+   	160	0
1030	5734	79	1   	161	0
1031	5735	144	a   	165	0
1032	5735	144	2a  	168	0
1033	5735	144	1   	159	0
1034	5735	144	2a  	160	0
1035	5735	144	2b  	161	0
1036	5736	937	a   	165	0
1037	5736	937	+   	166	0
1038	5736	937	2b  	167	0
1039	5736	937	1   	168	0
1040	5736	937	+   	159	0
1041	5736	937	1   	160	0
1042	5736	937	1   	161	0
1043	5737	178	1   	166	0
1044	5737	178	2b  	167	0
1045	5737	178	a   	160	0
1046	5737	178	+   	161	0
1047	5738	290	1   	166	0
1048	5738	290	+   	168	0
1049	5738	290	1   	160	0
1050	5738	290	1   	161	0
1051	5739	236	+   	165	0
1052	5739	236	1m  	166	0
1053	5739	236	+   	167	0
1054	5739	236	+   	168	0
1055	5739	236	+   	159	0
1056	5740	863	1m  	166	0
1057	5740	863	1m  	167	0
1058	5740	863	1   	168	0
1059	5740	863	1m  	159	0
1060	5740	863	1m  	160	0
1061	5741	282	1   	166	0
1062	5741	282	1   	168	0
1063	5741	282	1   	159	0
1064	5742	189	+   	166	0
1065	5742	189	+   	159	0
1066	5743	576	+   	166	0
1067	5743	576	+   	167	0
1068	5743	576	+   	159	0
1069	5744	30	+   	165	0
1070	5744	30	+   	166	0
1071	5744	30	+   	167	0
1072	5744	30	+   	168	0
1073	5744	30	+   	159	0
1074	5744	30	1   	160	0
1075	5744	30	1   	161	0
1076	5745	612	+   	167	0
1077	5746	408	+   	167	0
1078	5746	408	+   	168	0
1079	5746	408	+   	159	0
1080	5747	7	+   	167	0
1081	5748	170	+   	167	0
1082	5749	190	1   	167	0
1083	5749	190	1   	160	0
1084	5750	19	1m  	168	0
1085	5750	19	+   	159	0
1086	5750	19	+   	160	0
1087	5750	19	+   	161	0
1088	5751	282	.   	168	0
1089	5752	283	1   	168	0
1090	5753	7	1m  	168	0
1091	5753	7	1   	159	0
1092	5754	103	+   	168	0
1093	5754	103	+   	159	0
1094	5755	746	+   	168	0
1095	5756	216	1m  	168	0
1096	5757	293	+   	168	0
1097	5758	866	+   	168	0
1098	5758	866	+   	160	0
1099	5758	866	a   	161	0
1100	5759	599	1m  	159	0
1101	5759	599	+   	160	0
1102	5760	380	+   	165	0
1103	5760	380	+   	159	0
1104	5760	380	+   	160	0
1105	5760	380	+   	161	0
1106	5761	57	2b  	160	0
1107	5761	57	2a  	161	0
1108	5762	401	1   	160	0
1109	5763	338	1   	160	0
1110	5763	338	1   	161	0
1111	5764	324	+   	160	0
1112	5764	324	1   	161	0
1113	5765	167	1   	160	0
1114	5765	167	1   	161	0
1115	5766	203	1m  	160	0
1116	5766	203	2a  	161	0
1117	5767	626	+   	160	0
1118	5769	358	1   	160	0
1119	5769	358	1   	161	0
1120	5770	287	1   	160	0
1121	5770	287	1   	161	0
1122	5771	184	1   	160	0
1123	5771	184	2b  	161	0
1124	5772	26	1m  	160	0
1125	5772	26	1m  	161	0
1126	5773	661	a   	160	0
1127	5773	661	1m  	161	0
1128	5774	26	1m  	161	0
1129	5775	496	+   	161	0
1130	5776	616	+   	161	0
1131	5777	66	1   	169	0
1132	5777	66	1   	170	0
1133	5777	66	1   	162	0
1134	5778	765	2a  	169	0
1135	5778	765	2a  	170	0
1136	5779	282	4   	169	0
1137	5779	282	3   	170	0
1138	5779	282	3   	162	0
1139	5780	186	1   	169	0
1140	5780	186	1   	170	0
1141	5781	19	1m  	169	0
1142	5781	19	2a  	170	0
1143	5782	302	+   	169	0
1144	5782	302	1   	170	0
1145	5782	302	+   	162	0
1146	5783	338	2a  	169	0
1147	5783	338	2a  	170	0
1148	5784	216	+   	169	0
1149	5784	216	1m  	162	0
1150	5785	863	1m  	169	0
1151	5785	863	+   	170	0
1152	5785	863	2a  	162	0
1153	5786	30	1   	169	0
1154	5786	30	1   	170	0
1155	5786	30	1   	162	0
1156	5787	12	1m  	169	0
1157	5787	12	+   	170	0
1158	5789	888	1m  	169	0
1159	5789	888	+   	162	0
1160	5790	426	1m  	169	0
1161	5791	399	1m  	169	0
1162	5792	279	+   	169	0
1163	5793	872	+   	169	0
1164	5794	375	+   	170	0
1165	5795	290	+   	170	0
1166	5796	236	1m  	170	0
1167	5797	57	2a  	170	0
1168	5798	144	+   	170	0
1169	5799	394	+   	170	0
1170	5800	247	+   	170	0
1171	5801	1101	+   	170	0
1172	5802	324	+   	170	0
1173	5803	339	1m  	162	0
1174	5804	33	2a  	162	0
1175	5805	283	2b  	162	0
1176	5806	381	1   	162	0
1177	5807	14	2b  	162	0
1178	5808	504	+   	162	0
1179	5809	192	3   	140	0
1180	5809	192	2a  	141	0
1181	5809	192	2b  	142	0
1182	5810	599	1m  	140	0
1183	5811	113	1m  	140	0
1184	5812	283	+   	140	0
1185	5813	443	1m  	140	0
1186	5813	443	1m  	142	0
1187	5814	504	+   	140	0
1188	5815	237	+   	140	0
1189	5816	251	1m  	140	0
1190	5816	251	1m  	141	0
1191	5817	361	1m  	140	0
1192	5817	361	1m  	141	0
1193	5818	248	1m  	140	0
1194	5819	732	+   	140	0
1195	5819	732	+   	141	0
1196	5820	302	1m  	140	0
1197	5820	302	1m  	141	0
1198	5821	253	+   	140	0
1199	5822	380	1m  	140	0
1200	5822	380	1m  	142	0
1201	5823	132	1m  	140	0
1202	5823	132	1m  	141	0
1203	5824	336	1m  	140	0
1204	5825	287	1   	140	0
1205	5825	287	3   	141	0
1206	5825	287	+   	142	0
1207	5826	269	+   	140	0
1208	5826	269	1m  	141	0
1209	5827	1115	a   	140	0
1210	5828	144	a   	140	0
1211	5828	144	1   	141	0
1212	5828	144	+   	142	0
1213	5829	31	1m  	141	0
1214	5829	31	+   	142	0
1215	5830	382	1m  	141	0
1216	5830	382	1m  	142	0
1217	5831	434	+   	141	0
1218	5832	12	+   	141	0
1219	5832	12	1m  	142	0
1220	5833	1121	+   	141	0
1221	5834	336	1m  	141	0
1222	5835	128	1m  	142	0
1223	5836	184	1   	142	0
1224	5837	408	1m  	142	0
1225	5838	336	1m  	142	0
1226	5839	242	1m  	142	0
1227	5840	178	1m  	142	0
1228	5841	128	1   	142	0
1229	5842	273	1   	142	0
1230	5843	203	+   	142	0
1231	5844	188	+   	142	0
1232	5845	616	1   	142	0
1233	5846	50	1   	142	0
1234	5847	32	+   	142	0
1235	5848	79	+   	142	0
1236	5849	245	+   	142	0
1237	5850	77	+   	142	0
1238	5851	418	+   	142	0
1239	5852	302	+   	142	0
1240	5853	560	+   	142	0
1241	5854	167	+   	142	0
1242	5855	348	3   	142	0
1243	5856	818	3   	172	0
1244	5856	818	3   	173	0
1245	5856	818	5   	175	0
1246	5856	818	5   	176	0
1247	5857	302	1m  	172	0
1248	5857	302	+   	175	0
1249	5857	302	1   	176	0
1250	5858	279	+   	172	0
1251	5858	279	2a  	173	0
1252	5858	279	1m  	175	0
1253	5859	30	+   	172	0
1254	5859	30	1   	175	0
1255	5859	30	1m  	176	0
1256	5860	319	+   	172	0
1257	5860	319	1m  	173	0
1258	5860	319	+   	175	0
1259	5860	319	1   	176	0
1260	5861	895	1m  	172	0
1261	5861	895	1   	173	0
1262	5861	895	+   	174	0
1263	5861	895	1m  	175	0
1264	5861	895	+   	176	0
1265	5862	303	+   	172	0
1266	5862	303	1m  	175	0
1267	5863	932	1m  	173	0
1268	5863	932	+   	174	0
1269	5864	33	1   	173	0
1270	5865	367	1   	173	0
1271	5865	367	1   	174	0
1272	5866	190	+   	173	0
1273	5867	302	1m  	173	0
1274	5868	828	1   	173	0
1275	5869	11	2a  	174	0
1276	5870	1164	1   	174	0
1277	5871	95	1m  	174	0
1278	5872	302	+   	174	0
1279	5873	375	+   	174	0
1280	5874	512	+   	174	0
1281	5875	523	+   	174	0
1282	5876	393	+   	174	0
1283	5877	81	+   	174	0
1284	5878	424	+   	174	0
1285	5879	829	2b  	174	0
1286	5880	793	+   	174	0
1287	5881	12	+   	175	0
1288	5882	361	+   	175	0
1289	5882	361	1   	176	0
1290	5883	520	1   	176	0
1291	5884	7	+   	176	0
1292	5885	220	1   	176	0
1293	5886	216	1m  	177	0
1294	5887	394	1m  	177	0
1295	5887	394	1   	182	0
1296	5887	394	1   	183	0
1297	5887	394	1   	184	0
1298	5887	394	+   	185	0
1299	5888	381	+   	177	0
1300	5888	381	+   	182	0
1301	5889	773	+   	177	0
1302	5890	437	1m  	177	0
1303	5890	437	+   	182	0
1304	5891	619	1m  	177	0
1305	5891	619	1m  	182	0
1306	5892	30	1m  	177	0
1307	5892	30	1m  	182	0
1308	5892	30	2a  	183	0
1309	5892	30	1m  	184	0
1310	5892	30	1m  	185	0
1311	5893	1117	1   	177	0
1312	5893	1117	+   	182	0
1313	5894	11	1m  	177	0
1314	5894	11	+   	182	0
1315	5894	11	1   	183	0
1316	5894	11	1m  	184	0
1317	5894	11	+   	185	0
1318	5895	367	+   	177	0
1319	5895	367	1   	182	0
1320	5896	424	+   	177	0
1321	5896	424	1   	182	0
1322	5897	19	1   	177	0
1323	5898	827	1   	177	0
1324	5898	827	1m  	183	0
1325	5898	827	1   	184	0
1326	5899	914	1m  	177	0
1327	5899	914	1m  	182	0
1328	5899	914	1m  	183	0
1329	5899	914	1   	184	0
1330	5899	914	1m  	185	0
1331	5900	128	+   	177	0
1332	5901	184	1   	177	0
1333	5901	184	1   	182	0
1334	5901	184	+   	184	0
1335	5901	184	2b  	185	0
1336	5902	551	r   	177	0
1337	5903	329	1   	177	0
1338	5903	329	1   	182	0
1339	5903	329	+   	183	0
1340	5903	329	+   	185	0
1341	5904	829	2b  	177	0
1342	5904	829	1   	182	0
1343	5904	829	2a  	183	0
1344	5904	829	2b  	184	0
1345	5905	56	3   	177	0
1346	5905	56	3   	182	0
1347	5905	56	2b  	183	0
1348	5905	56	2a  	184	0
1349	5905	56	a   	185	0
1350	5906	527	+   	177	0
1351	5906	527	1m  	182	0
1352	5906	527	1m  	183	0
1353	5906	527	1m  	184	0
1354	5908	192	2a  	177	0
1355	5908	192	2a  	182	0
1356	5908	192	1   	183	0
1357	5908	192	2a  	184	0
1358	5909	144	+   	177	0
1359	5909	144	2a  	182	0
1360	5909	144	1   	183	0
1361	5909	144	+   	184	0
1362	5909	144	1   	185	0
1363	5910	165	1m  	182	0
1364	5910	165	+   	183	0
1365	5910	165	+   	184	0
1366	5910	165	+   	185	0
1367	5911	153	1   	182	0
1368	5912	389	2a  	182	0
1369	5913	937	1   	182	0
1370	5914	904	1m  	182	0
1371	5915	375	a   	182	0
1372	5916	296	a   	177	0
1373	5916	296	a   	182	0
1374	5917	513	1m  	183	0
1375	5917	513	1   	184	0
1376	5918	1164	1   	183	0
1377	5918	1164	1   	184	0
1378	5919	512	1m  	183	0
1379	5919	512	1m  	184	0
1380	5920	380	1m  	183	0
1381	5920	380	+   	184	0
1382	5921	367	+   	183	0
1383	5921	367	+   	184	0
1384	5922	827	.   	183	0
1385	5923	437	1   	183	0
1386	5923	437	1   	184	0
1387	5924	492	1m  	183	0
1388	5924	492	+   	184	0
1389	5925	310	+   	183	0
1390	5925	310	1   	184	0
1391	5926	287	1   	183	0
1392	5926	287	+   	184	0
1393	5926	287	2a  	185	0
1394	5927	31	+   	183	0
1395	5927	31	1m  	184	0
1396	5928	73	+   	183	0
1397	5929	338	2b  	185	0
1398	5930	57	2b  	185	0
1399	5931	349	1   	185	0
1400	5932	178	2b  	185	0
1401	5933	348	2b  	185	0
1402	5934	198	+   	185	0
1403	5935	358	1m  	185	0
1404	5936	382	2a  	185	0
1405	5937	127	1m  	185	0
1406	5938	362	2a  	185	0
1407	5939	100	+   	185	0
1408	5940	418	1m  	185	0
1409	5941	872	+   	185	0
1410	5942	991	+   	185	0
1411	5943	694	+   	185	0
1412	5944	356	1m  	185	0
1413	5945	21	2a  	185	0
1414	5946	1117	1m  	185	0
1415	5947	273	1   	185	0
1416	5948	510	+   	185	0
1417	5949	569	1   	185	0
1418	5950	240	+   	186	0
1419	5951	350	4   	186	0
1420	5951	350	3   	187	0
1421	5951	350	3   	188	0
1422	5951	350	3   	189	0
1423	5952	190	2a  	186	0
1424	5952	190	2b  	187	0
1425	5952	190	1   	188	0
1426	5952	190	1   	189	0
1427	5953	188	1   	186	0
1428	5953	188	1   	187	0
1429	5953	188	2a  	188	0
1430	5954	305	1m  	186	0
1431	5955	732	1   	186	0
1432	5955	732	+   	187	0
1433	5956	362	1   	186	0
1434	5956	362	+   	187	0
1435	5956	362	2a  	188	0
1436	5956	362	1m  	189	0
1437	5957	362	1m  	186	0
1438	5958	446	1m  	186	0
1439	5959	736	1m  	186	0
1440	5959	736	1m  	187	0
1441	5960	184	1   	186	0
1442	5960	184	1   	188	0
1443	5960	184	1   	189	0
1444	5961	434	+   	186	0
1445	5962	156	+   	186	0
1446	5963	644	+   	186	0
1447	5963	644	+   	187	0
1448	5964	153	+   	186	0
1449	5964	153	2a  	188	0
1450	5965	14	1m  	186	0
1451	5966	21	1m  	186	0
1452	5966	21	+   	187	0
1453	5967	21	1m  	186	0
1454	5967	21	+   	187	0
1455	5968	31	+   	186	0
1456	5969	165	1m  	186	0
1457	5969	165	+   	187	0
1458	5969	165	1m  	188	0
1459	5969	165	1   	189	0
1460	5970	753	+   	186	0
1461	5970	753	+   	187	0
1462	5971	609	+   	186	0
1463	5971	609	+   	187	0
1464	5972	254	+   	186	0
1465	5972	254	+   	187	0
1466	5972	254	1m  	188	0
1467	5972	254	1m  	189	0
1468	5973	336	+   	186	0
1469	5974	811	+   	186	0
1470	5975	599	+   	186	0
1471	5976	616	1   	186	0
1472	5976	616	+   	189	0
1473	5977	73	a   	186	0
1474	5978	287	+   	187	0
1475	5978	287	1   	188	0
1476	5979	117	1   	187	0
1477	5979	117	1   	188	0
1478	5980	113	1m  	187	0
1479	5980	113	+   	188	0
1480	5981	608	1   	187	0
1481	5981	608	1   	188	0
1482	5982	465	1m  	187	0
1483	5983	30	1m  	187	0
1484	5983	30	2a  	188	0
1485	5983	30	+   	189	0
1486	5984	56	2a  	187	0
1487	5984	56	3   	188	0
1488	5984	56	2a  	189	0
1489	5985	608	1   	187	0
1490	5986	758	+   	187	0
1491	5987	382	2a  	188	0
1492	5987	382	1   	189	0
1493	5988	527	+   	188	0
1494	5988	527	+   	189	0
1495	5989	11	+   	188	0
1496	5990	324	2b  	188	0
1497	5991	236	1m  	188	0
1498	5992	356	1   	188	0
1499	5993	424	1   	188	0
1500	5994	305	.   	188	0
1501	5995	425	+   	188	0
1502	5996	7	2a  	188	0
1503	5997	470	1m  	188	0
1504	5998	437	1m  	188	0
1505	5999	198	1   	188	0
1506	6000	720	1m  	188	0
1507	6001	408	+   	188	0
1508	6001	408	+   	189	0
1509	6002	12	1m  	188	0
1510	6002	12	+   	189	0
1511	6003	1145	1m  	188	0
1512	6004	4	1m  	188	0
1513	6005	219	1m  	188	0
1514	6006	144	1   	188	0
1515	6006	144	+   	189	0
1516	6007	780	+   	188	0
1517	6008	15	1m  	188	0
1518	6008	15	2b  	189	0
1519	6009	1103	1m  	188	0
1520	6010	319	+   	188	0
1521	6011	77	2b  	189	0
1522	6012	50	1   	189	0
1523	6013	273	1   	189	0
1524	6014	765	1m  	189	0
1525	6015	357	+   	189	0
1526	6016	497	+   	189	0
1527	6017	394	1   	188	0
1528	6017	394	1   	189	0
1529	6018	240	+   	188	0
1530	6019	829	2b  	190	0
1531	6019	829	1   	194	0
1532	6019	829	2b  	195	0
1533	6020	645	1m  	190	0
1534	6021	271	2a  	190	0
1535	6022	254	2a  	190	0
1536	6022	254	1   	194	0
1537	6022	254	2a  	195	0
1538	6023	259	1   	190	0
1539	6023	259	+   	195	0
1540	6024	619	2a  	190	0
1541	6025	190	2a  	190	0
1542	6025	190	2a  	191	0
1543	6025	190	1   	193	0
1544	6025	190	2a  	195	0
1545	6026	305	1   	190	0
1546	6026	305	1   	195	0
1547	6027	512	1m  	190	0
1548	6027	512	a   	191	0
1549	6027	512	1m  	193	0
1550	6027	512	1m  	195	0
1551	6028	79	1m  	190	0
1552	6028	79	1m  	195	0
1553	6029	492	1m  	190	0
1554	6029	492	1m  	193	0
1555	6029	492	1m  	195	0
1556	6030	708	1m  	190	0
1557	6031	30	1m  	190	0
1558	6031	30	1m  	191	0
1559	6031	30	1m  	193	0
1560	6031	30	1m  	194	0
1561	6031	30	1m  	195	0
1562	6032	356	1m  	190	0
1563	6032	356	1   	195	0
1564	6033	213	1m  	190	0
1565	6033	213	a   	191	0
1566	6033	213	+   	193	0
1567	6033	213	+   	195	0
1568	6034	111	1   	190	0
1569	6034	111	1   	191	0
1570	6034	111	1m  	195	0
1571	6035	50	1   	190	0
1572	6035	50	2b  	195	0
1573	6036	542	1m  	190	0
1574	6036	542	+   	195	0
1575	6037	362	1   	190	0
1576	6037	362	+   	195	0
1577	6038	732	1   	190	0
1578	6039	248	1m  	190	0
1579	6040	382	1   	190	0
1580	6041	361	+   	190	0
1581	6041	361	+   	195	0
1582	6042	342	1   	190	0
1583	6042	342	1m  	195	0
1584	6043	437	+   	190	0
1585	6043	437	+   	195	0
1586	6044	11	1m  	190	0
1587	6044	11	1m  	191	0
1588	6044	11	+   	194	0
1589	6044	11	1m  	195	0
1590	6045	324	1   	190	0
1591	6045	324	1   	195	0
1592	6046	336	1   	190	0
1593	6046	336	+   	195	0
1594	6047	356	1   	190	0
1595	6047	356	+   	195	0
1596	6048	236	1m  	190	0
1597	6049	350	2a  	190	0
1598	6049	350	2a  	195	0
1599	6050	451	1   	190	0
1600	6051	184	2b  	190	0
1601	6051	184	2a  	194	0
1602	6051	184	2a  	195	0
1603	6052	144	2a  	190	0
1604	6052	144	1   	191	0
1605	6052	144	+   	193	0
1606	6052	144	+   	194	0
1607	6052	144	2a  	195	0
1608	6053	616	2a  	190	0
1609	6053	616	2a  	191	0
1610	6053	616	+   	195	0
1611	6054	95	+   	190	0
1612	6054	95	1   	191	0
1613	6054	95	+   	194	0
1614	6055	56	2a  	190	0
1615	6055	56	3   	191	0
1616	6055	56	3   	193	0
1617	6055	56	3   	194	0
1618	6055	56	2b  	195	0
1619	6056	15	1m  	190	0
1620	6056	15	+   	195	0
1621	6057	380	1m  	190	0
1622	6057	380	+   	191	0
1623	6057	380	+   	193	0
1624	6057	380	+   	195	0
1625	6058	219	1   	190	0
1626	6059	12	1m  	190	0
1627	6059	12	+   	195	0
1628	6060	7	1m  	190	0
1629	6060	7	+   	195	0
1630	6061	338	1m  	190	0
1631	6061	338	+   	195	0
1632	6062	420	1m  	190	0
1633	6062	420	1m  	195	0
1634	6063	518	+   	190	0
1635	6063	518	2a  	193	0
1636	6063	518	1m  	195	0
1637	6064	828	1m  	190	0
1638	6064	828	+   	195	0
1639	6065	937	+   	190	0
1640	6065	937	+   	195	0
1641	6066	527	1m  	190	0
1642	6066	527	2a  	191	0
1643	6066	527	2a  	193	0
1644	6066	527	1m  	194	0
1645	6066	527	1m  	195	0
1646	6067	804	+   	191	0
1647	6067	804	1m  	193	0
1648	6067	804	1m  	195	0
1649	6068	245	1m  	191	0
1650	6068	245	+   	193	0
1651	6068	245	+   	194	0
1652	6069	986	1m  	191	0
1653	6069	986	+   	193	0
1654	6070	119	1   	191	0
1655	6070	119	+   	193	0
1656	6070	119	+   	194	0
1657	6071	410	1m  	191	0
1658	6071	410	+   	193	0
1659	6072	223	1   	191	0
1660	6072	223	2b  	194	0
1661	6072	223	1   	195	0
1662	6073	494	1m  	191	0
1663	6073	494	1m  	194	0
1664	6074	438	1m  	191	0
1665	6074	438	+   	193	0
1666	6074	438	1m  	194	0
1667	6074	438	+   	195	0
1668	6075	444	1m  	191	0
1669	6075	444	+   	193	0
1670	6076	19	1m  	191	0
1671	6076	19	2a  	193	0
1672	6076	19	1m  	194	0
1673	6077	437	+   	191	0
1674	6078	1136	+   	191	0
1675	6078	1136	2a  	193	0
1676	6078	1136	2a  	194	0
1677	6078	1136	+   	195	0
1678	6079	644	2a  	194	0
1679	6079	644	1m  	195	0
1680	6080	512	+   	191	0
1681	6081	259	1m  	191	0
1682	6082	359	1   	191	0
1683	6082	359	+   	193	0
1684	6082	359	1m  	194	0
1685	6083	366	1   	191	0
1686	6083	366	2a  	193	0
1687	6083	366	+   	194	0
1688	6083	366	1m  	195	0
1689	6084	50	1   	191	0
1690	6084	50	2b  	193	0
1691	6085	114	+   	191	0
1692	6086	324	1   	191	0
1693	6087	398	+   	191	0
1694	6087	398	a   	194	0
1695	6088	319	+   	193	0
1696	6089	155	2a  	193	0
1697	6090	378	a   	190	0
1698	6090	378	2b  	191	0
1699	6091	305	2a  	193	0
1700	6092	169	2a  	194	0
1701	6093	827	2b  	194	0
1702	6094	418	+   	194	0
1703	6094	418	+   	195	0
1704	6095	394	+   	194	0
1705	6096	310	1m  	194	0
1706	6097	121	1m  	194	0
1707	6098	143	1m  	194	0
1708	6099	219	1m  	194	0
1709	6100	153	+   	194	0
1710	6101	198	2a  	195	0
1711	6102	382	1m  	195	0
1712	6103	378	2a  	195	0
1713	6104	827	1m  	195	0
1714	6105	410	+   	195	0
1715	6106	407	+   	195	0
1716	6107	403	+   	195	0
1717	6109	56	2a  	196	0
1718	6109	56	1   	198	0
1719	6109	56	2b  	199	0
1720	6109	56	2b  	200	0
1721	6110	324	2a  	196	0
1722	6110	324	1   	198	0
1723	6110	324	2a  	199	0
1724	6110	324	2a  	200	0
1725	6111	190	2a  	197	0
1726	6111	190	2a  	198	0
1727	6111	190	2a  	199	0
1728	6111	190	1   	200	0
1729	6112	144	2b  	196	0
1730	6112	144	2a  	197	0
1731	6112	144	2a  	198	0
1732	6112	144	2a  	199	0
1733	6112	144	2a  	200	0
1734	6112	144	+   	178	0
1735	6113	382	1m  	196	0
1736	6113	382	2a  	197	0
1737	6113	382	1   	198	0
1738	6113	382	+   	201	0
1739	6113	382	+   	178	0
1740	6114	50	2a  	196	0
1741	6114	50	2a  	199	0
1742	6114	50	1   	200	0
1743	6115	223	1   	196	0
1744	6116	527	2a  	196	0
1745	6116	527	2a  	198	0
1746	6116	527	+   	199	0
1747	6116	527	1m  	200	0
1748	6116	527	2a  	201	0
1749	6116	527	1m  	178	0
1750	6117	184	2a  	196	0
1751	6117	184	2b  	198	0
1752	6117	184	1   	199	0
1753	6117	184	2b  	200	0
1754	6118	213	1m  	196	0
1755	6118	213	+   	198	0
1756	6118	213	+   	199	0
1757	6118	213	1m  	200	0
1758	6119	111	1m  	196	0
1759	6119	111	1m  	198	0
1760	6119	111	1m  	199	0
1761	6119	111	1m  	200	0
1762	6120	644	1m  	196	0
1763	6120	644	1m  	200	0
1764	6121	424	2a  	196	0
1765	6121	424	1   	198	0
1766	6121	424	1   	199	0
1767	6121	424	2a  	200	0
1768	6122	119	+   	196	0
1769	6122	119	+   	200	0
1770	6123	12	1m  	196	0
1771	6123	12	1m  	197	0
1772	6123	12	+   	198	0
1773	6123	12	1m  	199	0
1774	6123	12	+   	200	0
1775	6124	95	1m  	196	0
1776	6124	95	1m  	200	0
1777	6125	418	1m  	196	0
1778	6125	418	1m  	199	0
1779	6126	236	1m  	196	0
1780	6126	236	1m  	197	0
1781	6126	236	+   	198	0
1782	6126	236	1m  	199	0
1783	6126	236	+   	200	0
1784	6126	236	2a  	201	0
1785	6126	236	+   	178	0
1786	6127	259	2a  	196	0
1787	6127	259	1m  	197	0
1788	6127	259	+   	198	0
1789	6127	259	1m  	200	0
1790	6128	366	+   	196	0
1791	6129	986	+   	196	0
1792	6129	986	1m  	197	0
1793	6129	986	+   	199	0
1794	6130	245	+   	196	0
1795	6131	420	+   	196	0
1796	6132	359	1m  	196	0
1797	6132	359	+   	199	0
1798	6132	359	+   	200	0
1799	6133	616	1   	196	0
1800	6133	616	1   	198	0
1801	6133	616	1   	199	0
1802	6133	616	2a  	200	0
1803	6133	616	+   	178	0
1804	6134	389	1   	196	0
1805	6134	389	1   	198	0
1806	6134	389	2a  	199	0
1807	6134	389	2a  	200	0
1808	6135	403	1m  	196	0
1809	6135	403	1m  	199	0
1810	6136	275	1m  	196	0
1811	6136	275	1m  	197	0
1812	6136	275	1m  	199	0
1813	6136	275	+   	200	0
1814	6137	142	1m  	196	0
1815	6138	373	1m  	196	0
1816	6138	373	1m  	200	0
1817	6140	888	+   	196	0
1818	6140	888	+   	200	0
1819	6141	408	+   	196	0
1820	6142	114	+   	196	0
1821	6142	114	+   	200	0
1822	6143	219	+   	196	0
1823	6143	219	1m  	198	0
1824	6143	219	1m  	199	0
1825	6143	219	1m  	200	0
1826	6144	382	1m  	196	0
1827	6144	382	2b  	197	0
1828	6144	382	1   	198	0
1829	6144	382	2b  	178	0
1830	6146	310	1m  	196	0
1831	6147	153	2a  	196	0
1832	6147	153	1   	197	0
1833	6147	153	1   	198	0
1834	6147	153	+   	199	0
1835	6147	153	1   	200	0
1836	6149	30	2a  	196	0
1837	6149	30	1m  	197	0
1838	6149	30	1m  	198	0
1839	6149	30	1m  	199	0
1840	6149	30	1m  	200	0
1841	6149	30	1m  	201	0
1842	6149	30	1m  	178	0
1843	6150	11	1m  	196	0
1844	6150	11	+   	198	0
1845	6150	11	1m  	200	0
1846	6150	11	1m  	201	0
1847	6150	11	+   	178	0
1848	6151	829	1   	196	0
1849	6151	829	3   	198	0
1850	6151	829	3   	199	0
1851	6151	829	3   	200	0
1852	6151	829	+   	201	0
1853	6151	829	2a  	178	0
1854	6152	57	3   	197	0
1855	6153	872	2a  	197	0
1856	6154	542	+   	197	0
1857	6154	542	+   	199	0
1858	6154	542	+   	201	0
1859	6154	542	+   	178	0
1860	6155	305	2a  	197	0
1861	6155	305	+   	198	0
1862	6155	305	+   	199	0
1863	6155	305	1m  	200	0
1864	6155	305	2a  	201	0
1865	6155	305	2a  	178	0
1866	6156	504	1m  	197	0
1867	6156	504	+   	201	0
1868	6156	504	+   	178	0
1869	6157	319	+   	197	0
1870	6157	319	1m  	201	0
1871	6157	319	1m  	178	0
1872	6158	518	1m  	197	0
1873	6158	518	1m  	201	0
1874	6159	14	2a  	197	0
1875	6160	423	1   	197	0
1876	6160	423	1m  	178	0
1877	6161	618	1   	197	0
1878	6162	338	+   	197	0
1879	6163	437	+   	197	0
1880	6163	437	+   	178	0
1881	6164	888	+   	197	0
1882	6164	888	+   	178	0
1883	6165	765	+   	197	0
1884	6165	765	1m  	200	0
1885	6166	366	1   	197	0
1886	6166	366	+   	199	0
1887	6166	366	1   	200	0
1888	6167	410	+   	198	0
1889	6167	410	+   	199	0
1890	6168	645	+   	198	0
1891	6168	645	1m  	201	0
1892	6168	645	1m  	178	0
1893	6169	356	1m  	198	0
1894	6169	356	1m  	199	0
1895	6169	356	+   	200	0
1896	6169	356	1m  	201	0
1897	6169	356	1m  	178	0
1898	6170	362	1m  	198	0
1899	6170	362	+   	199	0
1900	6170	362	1   	200	0
1901	6171	361	1m  	198	0
1902	6171	361	+   	199	0
1903	6171	361	1m  	201	0
1904	6172	79	1m  	198	0
1905	6172	79	1m  	199	0
1906	6173	512	+   	198	0
1907	6174	437	+   	198	0
1908	6174	437	+   	199	0
1909	6174	437	+   	200	0
1910	6175	165	+   	199	0
1911	6175	165	+   	200	0
1912	6176	188	1   	199	0
1913	6177	7	1m  	199	0
1914	6177	7	+   	201	0
1915	6177	7	+   	178	0
1916	6178	350	1   	199	0
1917	6178	350	1   	200	0
1918	6179	198	2a  	199	0
1919	6179	198	2a  	200	0
1920	6180	937	+   	199	0
1921	6180	937	+   	200	0
1922	6180	937	1m  	201	0
1923	6180	937	+   	178	0
1924	6181	7	1m  	199	0
1925	6181	7	+   	201	0
1926	6182	492	1m  	199	0
1927	6182	492	1m  	200	0
1928	6182	492	1m  	201	0
1929	6183	19	1m  	200	0
1930	6184	1136	2a  	200	0
1931	6185	15	1m  	200	0
1932	6186	297	+   	199	0
1933	6186	297	+   	200	0
1934	6187	248	2b  	201	0
1935	6187	248	2a  	178	0
1936	6188	380	1m  	201	0
1937	6188	380	+   	178	0
1938	6189	338	1   	201	0
1939	6189	338	+   	178	0
1940	6190	12	1m  	201	0
1941	6190	12	+   	178	0
1942	6191	250	+   	201	0
1943	6192	893	1m  	201	0
1944	6192	893	+   	178	0
1945	6193	451	2a  	201	0
1946	6193	451	2a  	178	0
1947	6194	338	2b  	201	0
1948	6194	338	1   	178	0
1949	6195	863	2a  	201	0
1950	6195	863	+   	178	0
1951	6196	338	1   	201	0
1952	6196	338	+   	178	0
1953	6197	39	2a  	201	0
1954	6198	338	1   	201	0
1955	6199	828	1   	201	0
1956	6199	828	1   	178	0
1957	6200	732	+   	178	0
1958	6201	254	+   	178	0
1959	6203	117	1m  	62	0
1960	6205	423	2a  	62	0
1961	6206	194	3   	201	0
1962	6206	194	3   	178	0
1963	6206	194	3   	62	0
1964	6207	937	2a  	62	0
1965	6208	254	2a  	62	0
1966	6209	39	2a  	62	0
1967	6210	305	2a  	62	0
1968	6211	380	1m  	62	0
1969	6212	708	1m  	62	0
1970	6213	253	1m  	62	0
1971	6214	361	1m  	62	0
1972	6215	437	1m  	62	0
1973	6216	12	1m  	62	0
1974	6217	410	1m  	62	0
1975	6218	248	2a  	62	0
1976	6219	492	1m  	62	0
1977	6220	50	1   	62	0
1978	6221	7	1m  	62	0
1979	6222	236	1m  	62	0
1980	6223	828	1   	62	0
1981	6224	198	3   	62	0
1982	6225	356	1m  	62	0
1983	6226	893	+   	62	0
1984	6227	527	2a  	62	0
1985	6228	362	1   	62	0
1986	6229	616	1   	62	0
1987	6230	165	1   	62	0
1988	6231	863	1m  	62	0
1989	6232	79	1m  	62	0
1990	6233	418	1m  	62	0
1991	6234	350	2a  	62	0
1992	6235	829	2b  	62	0
1993	6236	144	2a  	62	0
1994	6237	30	1m  	62	0
1995	6239	872	1m  	63	0
1996	6239	872	2a  	64	0
1997	6239	872	2a  	65	0
1998	6240	829	3   	63	0
1999	6240	829	1   	64	0
2000	6240	829	1   	65	0
2001	6241	350	2a  	63	0
2002	6241	350	3   	64	0
2003	6241	350	4   	65	0
2004	6242	275	1m  	63	0
2005	6242	275	1m  	64	0
2006	6243	57	2a  	63	0
2007	6243	57	1   	64	0
2008	6243	57	+   	65	0
2009	6244	694	1   	63	0
2010	6244	694	1   	64	0
2011	6245	254	1m  	63	0
2012	6245	254	1m  	64	0
2013	6245	254	2a  	65	0
2014	6246	436	+   	63	0
2015	6247	362	+   	63	0
2016	6248	273	+   	63	0
2017	6249	57	1m  	63	0
2018	6249	57	+   	65	0
2019	6250	741	+   	63	0
2020	6250	741	1m  	64	0
2021	6251	4	2b  	63	0
2022	6251	4	1   	64	0
2023	6251	4	+   	65	0
2024	6252	720	1   	63	0
2025	6252	720	+   	64	0
2026	6253	21	2a  	63	0
2027	6253	21	2b  	64	0
2028	6253	21	2a  	65	0
2029	6254	600	1   	63	0
2030	6254	600	1   	64	0
2031	6255	437	1m  	63	0
2032	6255	437	+   	64	0
2033	6256	30	2a  	63	0
2034	6256	30	2a  	64	0
2035	6256	30	2a  	65	0
2036	6257	215	1m  	63	0
2037	6257	215	+   	64	0
2038	6258	890	+   	63	0
2039	6259	198	2a  	63	0
2040	6259	198	1m  	64	0
2041	6259	198	1m  	65	0
2042	6260	389	1   	63	0
2043	6260	389	1   	64	0
2044	6261	863	2a  	63	0
2045	6261	863	1m  	64	0
2046	6262	130	1m  	63	0
2047	6262	130	1m  	64	0
2048	6262	130	1m  	65	0
2049	6263	194	1   	63	0
2050	6263	194	1   	64	0
2051	6263	194	+   	65	0
2052	6264	184	2a  	63	0
2053	6264	184	2b  	64	0
2054	6264	184	2a  	65	0
2055	6265	362	1m  	63	0
2056	6265	362	1m  	64	0
2057	6266	144	1   	63	0
2058	6266	144	+   	65	0
2059	6267	73	1   	63	0
2060	6267	73	1   	65	0
2061	6268	119	+   	63	0
2062	6269	324	1   	63	0
2063	6270	561	+   	63	0
2064	6270	561	+   	64	0
2065	6271	986	+   	63	0
2066	6271	986	1m  	64	0
2067	6272	619	+   	63	0
2068	6272	619	+   	64	0
2069	6273	7	2b  	64	0
2070	6273	7	+   	65	0
2071	6275	382	1   	64	0
2072	6277	165	1m  	64	0
2073	6277	165	1m  	65	0
2074	6278	79	+   	63	0
2075	6278	79	1m  	64	0
2076	6280	356	+   	64	0
2077	6281	12	1m  	64	0
2078	6281	12	+   	65	0
2079	6282	709	1   	64	0
2080	6283	693	+   	64	0
2081	6284	160	+   	63	0
2082	6284	160	+   	64	0
2083	6285	357	+   	64	0
2084	6285	357	1m  	65	0
2085	6286	305	+   	64	0
2086	6288	418	+   	64	0
2087	6289	984	+   	64	0
2088	6290	271	2a  	65	0
2089	6291	188	2b  	65	0
2090	6292	380	1m  	65	0
2091	6293	424	1   	65	0
2092	6294	179	2a  	65	0
2093	6295	283	1m  	65	0
2094	6296	492	+   	65	0
2095	6297	328	1   	65	0
2096	6298	305	1m  	65	0
2097	6299	247	1m  	65	0
2098	6300	21	2a  	65	0
2099	6301	465	+   	65	0
2100	6302	599	+   	65	0
2101	6303	761	+   	65	0
2102	6304	243	+   	65	0
2103	6305	362	2a  	65	0
2104	6306	446	1m  	65	0
2105	6307	483	1   	65	0
2106	6308	917	+   	65	0
2107	6309	15	2a  	65	0
2108	6310	199	1   	65	0
2109	6311	829	1   	65	0
2110	6312	362	1m  	65	0
2111	6313	382	1m  	65	0
2112	6314	693	+   	65	0
2113	6315	453	+   	65	0
2114	6316	362	1   	66	0
2115	6317	305	1   	66	0
2116	6317	305	+   	67	0
2117	6318	243	+   	66	0
2118	6318	243	+   	67	0
2119	6319	77	+   	66	0
2120	6319	77	+   	68	0
2121	6320	25	1m  	66	0
2122	6321	25	1m  	66	0
2123	6322	759	1   	66	0
2124	6323	742	1m  	66	0
2125	6324	616	1   	66	0
2126	6324	616	1   	68	0
2127	6324	616	1   	69	0
2128	6325	418	1m  	66	0
2129	6326	15	1m  	66	0
2130	6326	15	1m  	67	0
2131	6327	12	1m  	66	0
2132	6328	899	1   	66	0
2133	6329	340	+   	66	0
2134	6329	340	1m  	68	0
2135	6330	271	1m  	66	0
2136	6331	380	1m  	66	0
2137	6331	380	1m  	67	0
2138	6331	380	1m  	69	0
2139	6332	1169	+   	66	0
2140	6333	203	+   	66	0
2141	6334	357	1m  	66	0
2142	6334	357	1m  	68	0
2143	6335	296	1m  	66	0
2144	6336	164	1   	66	0
2145	6336	164	+   	67	0
2146	6336	164	2a  	68	0
2147	6336	164	1m  	69	0
2148	6337	50	+   	66	0
2149	6338	741	+   	66	0
2150	6339	111	1m  	66	0
2151	6339	111	+   	68	0
2152	6339	111	+   	69	0
2153	6340	107	1m  	66	0
2154	6341	184	2a  	66	0
2155	6341	184	+   	67	0
2156	6341	184	2a  	68	0
2157	6341	184	2a  	69	0
2158	6342	287	2a  	66	0
2159	6342	287	2a  	67	0
2160	6342	287	2a  	68	0
2161	6342	287	2a  	69	0
2162	6343	199	2b  	66	0
2163	6343	199	2a  	68	0
2164	6343	199	+   	69	0
2165	6344	362	1m  	66	0
2166	6344	362	1   	68	0
2167	6344	362	+   	69	0
2168	6345	362	1m  	66	0
2169	6345	362	1m  	67	0
2170	6345	362	1m  	68	0
2171	6345	362	1   	69	0
2172	6346	254	2a  	66	0
2173	6346	254	1   	67	0
2174	6346	254	2a  	68	0
2175	6346	254	1m  	69	0
2176	6347	190	2a  	66	0
2177	6347	190	2b  	67	0
2178	6347	190	1   	68	0
2179	6347	190	2a  	69	0
2180	6348	179	2a  	66	0
2181	6348	179	2a  	67	0
2182	6348	179	+   	68	0
2183	6348	179	1m  	69	0
2184	6349	273	1m  	66	0
2185	6350	328	1   	66	0
2186	6351	30	1m  	66	0
2187	6351	30	1m  	67	0
2188	6351	30	1m  	68	0
2189	6351	30	1m  	69	0
2190	6352	188	1   	66	0
2191	6352	188	1   	68	0
2192	6353	351	3   	66	0
2193	6353	351	1   	67	0
2194	6353	351	3   	68	0
2195	6353	351	3   	69	0
2196	6355	198	2a  	66	0
2197	6355	198	1   	67	0
2198	6355	198	1   	68	0
2199	6355	198	1   	69	0
2200	6356	215	+   	66	0
2201	6357	275	+   	66	0
2202	6357	275	1m  	68	0
2203	6358	872	1   	66	0
2204	6358	872	1   	68	0
2205	6359	236	+   	66	0
2206	6360	56	2b  	66	0
2207	6360	56	2a  	67	0
2208	6360	56	2a  	68	0
2209	6360	56	2a  	69	0
2210	6361	144	2a  	66	0
2211	6361	144	1   	67	0
2212	6361	144	+   	68	0
2213	6361	144	1   	69	0
2214	6362	446	1m  	67	0
2215	6363	104	1m  	67	0
2216	6364	133	1m  	67	0
2217	6365	1114	1m  	67	0
2218	6366	644	1m  	67	0
2219	6367	693	+   	67	0
2220	6368	21	1m  	67	0
2221	6369	283	+   	67	0
2222	6370	812	1   	67	0
2223	6371	760	1   	67	0
2224	6372	829	3   	67	0
2225	6373	795	1   	68	0
2226	6373	795	1   	69	0
2227	6374	725	1m  	68	0
2228	6374	725	1m  	69	0
2229	6375	79	1m  	68	0
2230	6375	79	+   	69	0
2231	6376	305	1m  	68	0
2232	6376	305	1m  	69	0
2233	6377	59	1m  	68	0
2234	6377	59	+   	69	0
2235	6378	119	+   	68	0
2236	6379	553	+   	68	0
2237	6380	408	+   	68	0
2238	6380	408	+   	69	0
2239	6381	720	1m  	68	0
2240	6381	720	+   	69	0
2241	6382	389	1   	68	0
2242	6383	338	+   	68	0
2243	6384	381	1   	68	0
2244	6384	381	+   	69	0
2245	6385	219	+   	68	0
2246	6386	215	+   	68	0
2247	6387	50	+   	68	0
2248	6388	509	+   	68	0
2249	6389	21	1m  	68	0
2250	6389	21	+   	69	0
2251	6390	318	+   	68	0
2252	6391	219	+   	68	0
2253	6391	219	1m  	69	0
2254	6392	26	2a  	68	0
2255	6392	26	2a  	69	0
2256	6393	377	1m  	68	0
2257	6393	377	1m  	69	0
2258	6394	4	1m  	68	0
2259	6395	350	2a  	68	0
2260	6395	350	1   	69	0
2261	6396	688	1   	68	0
2262	6396	688	2a  	69	0
2263	6397	285	1m  	68	0
2264	6397	285	1m  	69	0
2265	6398	848	1m  	68	0
2266	6399	527	+   	68	0
2267	6400	455	a   	68	0
2268	6401	290	a   	68	0
2269	6402	790	2b  	69	0
2270	6403	328	1   	70	0
2271	6403	328	+   	73	0
2272	6403	328	1m  	74	0
2273	6404	637	r   	70	0
2274	6405	18	+   	70	0
2275	6406	890	+   	70	0
2276	6406	890	1m  	71	0
2277	6407	14	1m  	70	0
2278	6407	14	1m  	71	0
2279	6408	26	+   	70	0
2280	6409	509	1m  	70	0
2281	6409	509	+   	71	0
2282	6410	128	+   	70	0
2283	6410	128	+   	71	0
2284	6412	144	2a  	70	0
2285	6412	144	1   	71	0
2286	6412	144	1   	73	0
2287	6412	144	+   	74	0
2288	6412	144	2a  	75	0
2289	6413	829	2b  	70	0
2290	6413	829	2a  	71	0
2291	6413	829	2b  	75	0
2292	6414	350	3   	70	0
2293	6414	350	2b  	71	0
2294	6414	350	3   	73	0
2295	6414	350	2b  	74	0
2296	6414	350	2b  	75	0
2297	6415	190	2a  	70	0
2298	6415	190	1   	71	0
2299	6415	190	1   	73	0
2300	6415	190	2a  	74	0
2301	6415	190	2a  	75	0
2302	6416	254	2a  	70	0
2303	6416	254	2a  	71	0
2304	6416	254	2a  	73	0
2305	6416	254	1m  	74	0
2306	6416	254	2a  	75	0
2307	6417	184	2a  	70	0
2308	6417	184	2a  	71	0
2309	6417	184	2a  	73	0
2310	6417	184	1   	74	0
2311	6417	184	1   	75	0
2312	6418	381	1m  	70	0
2313	6418	381	1m  	71	0
2314	6418	381	1m  	73	0
2315	6418	381	+   	75	0
2316	6419	382	1   	70	0
2317	6419	382	+   	71	0
2318	6419	382	+   	73	0
2319	6420	357	1m  	70	0
2320	6420	357	2a  	73	0
2321	6420	357	1m  	74	0
2322	6420	357	1m  	75	0
2323	6421	15	1m  	70	0
2324	6421	15	1m  	73	0
2325	6421	15	1m  	74	0
2326	6421	15	+   	75	0
2327	6422	30	1m  	70	0
2328	6422	30	1m  	71	0
2329	6422	30	1m  	73	0
2330	6422	30	1m  	74	0
2331	6422	30	1m  	75	0
2332	6423	21	1m  	70	0
2333	6423	21	+   	71	0
2334	6423	21	+   	74	0
2335	6423	21	+   	75	0
2336	6424	26	2a  	70	0
2337	6424	26	+   	71	0
2338	6424	26	1m  	73	0
2339	6424	26	1m  	74	0
2340	6424	26	1m  	75	0
2341	6425	616	1   	70	0
2342	6425	616	+   	71	0
2343	6426	167	1m  	70	0
2344	6426	167	+   	71	0
2345	6426	167	1   	73	0
2346	6426	167	1   	74	0
2347	6426	167	1m  	75	0
2348	6427	305	1m  	70	0
2349	6427	305	+   	71	0
2350	6427	305	1   	73	0
2351	6427	305	+   	74	0
2352	6427	305	+   	75	0
2353	6428	362	1m  	70	0
2354	6428	362	1m  	71	0
2355	6428	362	+   	73	0
2356	6429	872	1m  	70	0
2357	6429	872	1m  	71	0
2358	6429	872	+   	74	0
2359	6429	872	1m  	75	0
2360	6430	56	2a  	70	0
2361	6430	56	2b  	71	0
2362	6430	56	2b  	73	0
2363	6430	56	3   	74	0
2364	6431	236	1   	70	0
2365	6431	236	+   	71	0
2366	6431	236	+   	75	0
2367	6432	437	1m  	70	0
2368	6432	437	+   	71	0
2369	6433	198	1m  	70	0
2370	6433	198	+   	71	0
2371	6433	198	1   	73	0
2372	6433	198	+   	74	0
2373	6434	243	1m  	70	0
2374	6434	243	+   	73	0
2375	6435	315	+   	70	0
2376	6435	315	+   	74	0
2377	6435	315	+   	75	0
2378	6436	77	+   	70	0
2379	6436	77	1   	73	0
2380	6437	213	+   	70	0
2381	6438	765	1m  	70	0
2382	6438	765	+   	71	0
2383	6439	410	+   	70	0
2384	6439	410	+   	71	0
2385	6439	410	+   	73	0
2386	6439	410	+   	74	0
2387	6440	22	+   	70	0
2388	6441	188	2a  	71	0
2389	6441	188	+   	73	0
2390	6441	188	1   	75	0
2391	6442	324	2a  	71	0
2392	6443	179	1   	71	0
2393	6443	179	1   	73	0
2394	6443	179	1   	74	0
2395	6443	179	1   	75	0
2396	6444	215	1m  	71	0
2397	6444	215	+   	73	0
2398	6444	215	+   	74	0
2399	6445	111	1m  	71	0
2400	6445	111	1m  	73	0
2401	6446	4	2a  	71	0
2402	6447	418	1m  	71	0
2403	6447	418	+   	74	0
2404	6448	50	2a  	71	0
2405	6448	50	1   	73	0
2406	6448	50	+   	74	0
2407	6448	50	+   	75	0
2408	6449	446	1m  	71	0
2409	6449	446	1m  	73	0
2410	6449	446	+   	74	0
2411	6449	446	+   	75	0
2412	6450	318	+   	71	0
2413	6450	318	+   	73	0
2414	6450	318	1   	74	0
2415	6451	389	+   	71	0
2416	6451	389	+   	73	0
2417	6452	410	+   	71	0
2418	6452	410	+   	73	0
2419	6452	410	+   	74	0
2420	6453	243	+   	71	0
2421	6453	243	+   	73	0
2422	6454	26	+   	71	0
2423	6455	283	1m  	71	0
2424	6456	287	+   	71	0
2425	6456	287	+   	73	0
2426	6456	287	2a  	74	0
2427	6456	287	1   	75	0
2428	6457	199	2a  	73	0
2429	6457	199	2a  	74	0
2430	6457	199	1   	75	0
2431	6458	203	2a  	73	0
2432	6458	203	2a  	74	0
2433	6458	203	1   	75	0
2434	6459	290	1m  	73	0
2435	6459	290	+   	74	0
2436	6460	285	+   	73	0
2437	6460	285	+   	74	0
2438	6461	725	1m  	73	0
2439	6461	725	1m  	74	0
2440	6462	848	+   	73	0
2441	6463	25	+   	73	0
2442	6463	25	+   	74	0
2443	6464	450	1m  	73	0
2444	6464	450	+   	74	0
2445	6465	884	+   	73	0
2446	6465	884	+   	74	0
2447	6466	336	+   	73	0
2448	6467	795	1m  	73	0
2449	6467	795	1   	74	0
2450	6468	619	+   	73	0
2451	6468	619	+   	75	0
2452	6469	350	+   	73	0
2453	6470	760	a   	73	0
2454	6470	760	1   	74	0
2455	6471	497	a   	73	0
2456	6471	497	1m  	74	0
2457	6472	57	1m  	74	0
2458	6473	340	+   	74	0
2459	6475	362	1   	74	0
2460	6475	362	1   	75	0
2461	6476	553	1m  	74	0
2462	6477	669	1m  	74	0
2463	6478	670	1m  	74	0
2464	6479	25	1m  	74	0
2465	6480	283	+   	74	0
2466	6481	829	+   	74	0
2467	6482	743	+   	74	0
2468	6483	107	+   	75	0
2469	6484	31	+   	75	0
2470	6485	599	1m  	75	0
2471	6486	380	1m  	75	0
2472	6487	644	1m  	75	0
2473	6488	670	1   	75	0
2474	6489	248	+   	75	0
2475	6490	382	1m  	75	0
2476	6491	576	1m  	75	0
2477	6492	349	1   	75	0
2478	6493	828	+   	76	0
2479	6493	828	1   	77	0
2480	6493	828	+   	78	0
2481	6494	190	2b  	76	0
2482	6494	190	2b  	77	0
2483	6494	190	2a  	78	0
2484	6495	254	2b  	76	0
2485	6495	254	1   	77	0
2486	6495	254	2b  	78	0
2487	6496	198	2a  	76	0
2488	6496	198	2a  	77	0
2489	6496	198	2b  	78	0
2490	6497	527	1m  	76	0
2491	6497	527	1m  	77	0
2492	6497	527	1m  	78	0
2493	6498	350	3   	76	0
2494	6498	350	3   	77	0
2495	6498	350	3   	78	0
2496	6499	863	1m  	76	0
2497	6499	863	1   	77	0
2498	6499	863	+   	78	0
2499	6500	518	+   	76	0
2500	6500	518	+   	77	0
2501	6500	518	+   	78	0
2502	6501	236	1m  	76	0
2503	6501	236	+   	77	0
2504	6501	236	+   	78	0
2505	6502	356	1m  	76	0
2506	6502	356	1   	77	0
2507	6502	356	1m  	78	0
2508	6503	420	2a  	76	0
2509	6503	420	2b  	77	0
2510	6503	420	1   	78	0
2511	6504	492	1m  	76	0
2512	6504	492	+   	77	0
2513	6504	492	+   	78	0
2514	6505	144	2a  	76	0
2515	6505	144	2a  	77	0
2516	6505	144	1   	78	0
2517	6506	509	+   	76	0
2518	6507	937	+   	76	0
2519	6507	937	2b  	77	0
2520	6507	937	+   	78	0
2521	6508	362	2a  	76	0
2522	6508	362	+   	77	0
2523	6508	362	+   	78	0
2524	6509	608	+   	76	0
2525	6509	608	+   	77	0
2526	6509	608	+   	78	0
2527	6510	167	1   	76	0
2528	6510	167	+   	77	0
2529	6510	167	1   	78	0
2530	6511	616	1   	76	0
2531	6511	616	1   	78	0
2532	6512	773	1m  	76	0
2533	6512	773	+   	77	0
2534	6513	361	1m  	76	0
2535	6513	361	+   	77	0
2536	6513	361	+   	78	0
2537	6514	188	1   	76	0
2538	6515	117	1   	76	0
2539	6515	117	+   	77	0
2540	6515	117	1   	78	0
2541	6516	542	1m  	76	0
2542	6516	542	+   	77	0
2543	6516	542	+   	78	0
2544	6517	12	1m  	76	0
2545	6517	12	+   	77	0
2546	6517	12	+   	78	0
2547	6518	133	1m  	76	0
2548	6518	133	+   	78	0
2549	6519	50	1   	76	0
2550	6519	50	1   	78	0
2551	6520	79	1   	76	0
2552	6520	79	+   	77	0
2553	6520	79	1   	78	0
2554	6521	56	2a  	76	0
2555	6521	56	1   	78	0
2556	6522	184	1   	76	0
2557	6522	184	+   	78	0
2558	6523	618	1m  	76	0
2559	6524	619	1m  	76	0
2560	6525	382	1m  	76	0
2561	6526	553	+   	76	0
2562	6526	553	+   	78	0
2563	6527	373	1m  	76	0
2564	6528	111	1m  	76	0
2565	6528	111	+   	77	0
2566	6528	111	+   	78	0
2567	6529	418	1m  	76	0
2568	6529	418	1m  	77	0
2569	6529	418	1m  	78	0
2570	6530	377	1m  	76	0
2571	6531	253	+   	76	0
2572	6531	253	1   	77	0
2573	6532	30	1m  	76	0
2574	6532	30	1m  	77	0
2575	6532	30	1m  	78	0
2576	6533	986	+   	77	0
2577	6533	986	+   	78	0
2578	6534	159	2a  	77	0
2579	6534	159	+   	78	0
2580	6535	710	+   	77	0
2581	6536	39	1m  	77	0
2582	6537	458	+   	77	0
2583	6538	7	+   	77	0
2584	6539	101	+   	77	0
2585	6540	153	1m  	78	0
2586	6541	340	1   	78	0
2587	6542	324	1   	78	0
2588	6543	194	3   	79	0
2589	6543	194	3   	80	0
2590	6543	194	2b  	15	0
2591	6544	236	+   	79	0
2592	6544	236	+   	80	0
2593	6544	236	1m  	15	0
2594	6545	811	2b  	79	0
2595	6546	361	1m  	79	0
2596	6547	305	2a  	79	0
2597	6547	305	1   	80	0
2598	6548	449	1m  	79	0
2599	6549	451	2b  	79	0
2600	6549	451	2a  	80	0
2601	6550	542	1m  	79	0
2602	6551	466	1m  	79	0
2603	6552	770	1m  	79	0
2604	6553	303	1m  	79	0
2605	6554	71	+   	79	0
2606	6555	886	2a  	79	0
2607	6556	527	+   	79	0
2608	6556	527	+   	80	0
2609	6556	527	2b  	15	0
2610	6557	765	+   	79	0
2611	6557	765	+   	80	0
2612	6558	420	1m  	79	0
2613	6559	248	2a  	79	0
2614	6559	248	2a  	80	0
2615	6560	575	1m  	79	0
2616	6561	492	1m  	79	0
2617	6561	492	1m  	80	0
2618	6562	382	1   	79	0
2619	6562	382	1   	80	0
2620	6563	133	+   	79	0
2621	6563	133	+   	80	0
2622	6563	133	+   	15	0
2623	6564	509	1m  	79	0
2624	6564	509	+   	80	0
2625	6565	577	+   	79	0
2626	6566	12	1m  	79	0
2627	6566	12	+   	80	0
2628	6566	12	+   	15	0
2629	6567	7	1m  	79	0
2630	6567	7	1m  	80	0
2631	6568	2143	+   	79	0
2632	6569	577	+   	79	0
2633	6570	338	+   	79	0
2634	6570	338	2b  	80	0
2635	6571	350	+   	79	0
2636	6572	863	+   	79	0
2637	6572	863	+   	80	0
2638	6573	937	+   	80	0
2639	6573	937	+   	15	0
2640	6574	366	1   	80	0
2641	6575	30	1m  	80	0
2642	6575	30	1m  	15	0
2643	6576	319	+   	80	0
2644	6577	437	+   	80	0
2645	6578	804	+   	80	0
2646	6579	804	+   	80	0
2647	6580	420	+   	80	0
2648	6581	542	1m  	80	0
2649	6582	616	1   	15	0
2650	6583	50	1   	15	0
2651	6584	56	2b  	15	0
2652	6585	184	2a  	15	0
2653	6586	188	1   	15	0
2654	6587	518	+   	15	0
2655	6588	1121	+   	15	0
2656	6589	167	1m  	15	0
2657	6590	133	+   	15	0
2658	6591	542	+   	15	0
2659	6592	111	+   	15	0
2660	6593	710	+   	15	0
2661	6594	144	1   	15	0
2662	6595	420	1m  	15	0
2663	6596	198	1   	15	0
2664	6597	12	+   	15	0
2665	6598	79	1m  	15	0
2666	6599	770	1   	15	0
2667	6600	324	1   	15	0
2668	6601	829	1   	15	0
2669	6602	382	1   	15	0
2670	6603	492	1m  	15	0
2671	6604	254	+   	15	0
2672	6605	418	+   	15	0
2673	6606	159	+   	15	0
2674	6607	219	a   	15	0
2675	6608	356	+   	15	0
2676	6609	986	+   	15	0
2677	6610	56	2b  	16	0
2678	6610	56	2b  	17	0
2679	6610	56	3   	18	0
2680	6610	56	2a  	32	0
2681	6611	829	2a  	16	0
2682	6611	829	2b  	17	0
2683	6611	829	1   	32	0
2684	6612	190	1   	16	0
2685	6612	190	1   	17	0
2686	6612	190	+   	18	0
2687	6612	190	1   	32	0
2688	6613	191	1   	16	0
2689	6613	191	+   	18	0
2690	6613	191	+   	32	0
2691	6614	153	1   	16	0
2692	6614	153	+   	18	0
2693	6615	50	1   	16	0
2694	6615	50	1   	18	0
2695	6616	909	+   	16	0
2696	6617	12	1m  	16	0
2697	6617	12	+   	17	0
2698	6617	12	+   	18	0
2699	6618	15	+   	16	0
2700	6618	15	1m  	17	0
2701	6618	15	2a  	18	0
2702	6619	236	+   	16	0
2703	6619	236	1m  	17	0
2704	6619	236	+   	18	0
2705	6620	518	+   	16	0
2706	6620	518	+   	18	0
2707	6621	366	1   	16	0
2708	6621	366	+   	17	0
2709	6621	366	1   	18	0
2710	6621	366	1   	32	0
2711	6622	305	1m  	16	0
2712	6622	305	1m  	17	0
2713	6622	305	+   	32	0
2714	6623	423	1   	16	0
2715	6623	423	+   	18	0
2716	6624	437	1m  	16	0
2717	6625	128	1m  	16	0
2718	6625	128	+   	17	0
2719	6625	128	+   	18	0
2720	6626	159	+   	16	0
2721	6627	111	+   	16	0
2722	6627	111	+   	17	0
2723	6627	111	1m  	32	0
2724	6628	357	1m  	16	0
2725	6628	357	1m  	18	0
2726	6629	219	+   	16	0
2727	6629	219	+   	17	0
2728	6629	219	+   	18	0
2729	6630	616	1   	16	0
2730	6630	616	2a  	17	0
2731	6631	381	+   	16	0
2732	6631	381	1   	17	0
2733	6631	381	+   	18	0
2734	6632	144	1   	16	0
2735	6632	144	+   	17	0
2736	6632	144	2a  	18	0
2737	6632	144	1   	32	0
2738	6633	19	1   	16	0
2739	6633	19	1m  	32	0
2740	6634	275	+   	16	0
2741	6634	275	+   	17	0
2742	6634	275	1m  	18	0
2743	6635	319	+   	16	0
2744	6636	418	1m  	16	0
2745	6636	418	1m  	18	0
2746	6637	30	1m  	16	0
2747	6637	30	1m  	17	0
2748	6637	30	1m  	18	0
2749	6637	30	1m  	32	0
2750	6638	324	1   	16	0
2751	6638	324	1   	17	0
2752	6638	324	2a  	32	0
2753	6639	254	+   	16	0
2754	6639	254	2a  	17	0
2755	6639	254	2b  	18	0
2756	6639	254	+   	32	0
2757	6640	527	1m  	16	0
2758	6640	527	1m  	17	0
2759	6640	527	1m  	18	0
2760	6642	245	+   	16	0
2761	6643	119	+   	16	0
2762	6643	119	+   	18	0
2763	6644	273	+   	16	0
2764	6645	415	+   	16	0
2765	6645	415	+   	18	0
2766	6646	340	1   	17	0
2767	6647	389	1   	17	0
2768	6647	389	1   	18	0
2769	6647	389	+   	32	0
2770	6648	184	2a  	17	0
2771	6648	184	2a  	18	0
2772	6648	184	2a  	32	0
2773	6649	167	1   	17	0
2774	6649	167	+   	18	0
2775	6650	25	+   	17	0
2776	6650	25	+   	32	0
2777	6651	760	1   	17	0
2778	6651	760	1   	18	0
2779	6652	287	1   	17	0
2780	6653	198	1m  	17	0
2781	6654	509	+   	17	0
2782	6655	350	2a  	17	0
2783	6655	350	3   	32	0
2784	6656	986	+   	18	0
2785	6657	487	2a  	18	0
2786	6659	377	2a  	18	0
2787	6659	377	+   	32	0
2788	6660	804	1m  	18	0
2789	6661	1136	1   	18	0
2790	6661	1136	+   	32	0
2791	6662	444	1m  	18	0
2792	6663	872	1m  	18	0
2793	6664	424	1   	18	0
2794	6665	11	1m  	18	0
2795	6666	438	1m  	18	0
2796	6667	382	+   	18	0
2797	6668	57	2a  	32	0
2798	6669	114	1m  	32	0
2799	6670	356	1m  	32	0
2800	6671	243	1   	32	0
2801	6672	215	1m  	32	0
2802	6673	576	1m  	32	0
2803	6674	492	+   	32	0
2804	6675	26	1m  	32	0
2805	6676	338	+   	32	0
2806	6677	644	1m  	33	0
2807	6677	644	1m  	83	0
2808	6677	644	+   	84	0
2809	6677	644	+   	85	0
2810	6678	730	1m  	33	0
2811	6678	730	+   	34	0
2812	6678	730	+   	82	0
2813	6678	730	1m  	85	0
2814	6678	730	1m  	86	0
2815	6679	164	1   	33	0
2816	6679	164	1   	34	0
2817	6679	164	1   	82	0
2818	6679	164	1m  	83	0
2819	6679	164	1m  	84	0
2820	6679	164	+   	86	0
2821	6680	7	1m  	33	0
2822	6680	7	+   	34	0
2823	6680	7	+   	84	0
2824	6681	545	+   	33	0
2825	6681	545	2a  	86	0
2826	6682	188	1   	33	0
2827	6682	188	2a  	34	0
2828	6682	188	1   	82	0
2829	6682	188	1   	83	0
2830	6682	188	1   	84	0
2831	6682	188	1   	85	0
2832	6683	132	1m  	33	0
2833	6683	132	1m  	83	0
2834	6683	132	+   	84	0
2835	6683	132	+   	85	0
2836	6684	380	+   	33	0
2837	6684	380	+   	83	0
2838	6684	380	+   	84	0
2839	6685	1169	+   	33	0
2840	6685	1169	+   	83	0
2841	6685	1169	+   	84	0
2842	6686	223	1   	33	0
2843	6686	223	1   	84	0
2844	6686	223	2a  	86	0
2845	6687	79	1m  	33	0
2846	6687	79	+   	82	0
2847	6687	79	1m  	83	0
2848	6687	79	1m  	84	0
2849	6687	79	+   	85	0
2850	6687	79	+   	86	0
2851	6688	400	1m  	33	0
2852	6689	606	1   	33	0
2853	6689	606	1m  	83	0
2854	6689	606	+   	86	0
2855	6690	275	1m  	33	0
2856	6690	275	+   	34	0
2857	6690	275	1m  	82	0
2858	6690	275	+   	83	0
2859	6690	275	+   	85	0
2860	6690	275	+   	86	0
2861	6691	619	1   	33	0
2862	6692	179	1   	33	0
2863	6692	179	1   	34	0
2864	6692	179	1   	82	0
2865	6693	513	+   	33	0
2866	6694	271	1m  	33	0
2867	6694	271	1m  	34	0
2868	6695	732	+   	33	0
2869	6695	732	+   	86	0
2870	6696	356	+   	33	0
2871	6696	356	+   	84	0
2872	6696	356	+   	85	0
2873	6697	113	+   	33	0
2874	6698	523	+   	33	0
2875	6698	523	+   	82	0
2876	6699	201	1m  	33	0
2877	6699	201	+   	34	0
2878	6700	448	+   	33	0
2879	6701	410	+   	33	0
2880	6702	917	1m  	33	0
2881	6702	917	1m  	34	0
2882	6702	917	+   	82	0
2883	6702	917	+   	83	0
2884	6702	917	+   	84	0
2885	6702	917	+   	85	0
2886	6702	917	+   	86	0
2887	6703	26	1m  	33	0
2888	6703	26	+   	34	0
2889	6703	26	1m  	82	0
2890	6704	184	2a  	33	0
2891	6704	184	1   	84	0
2892	6704	184	2a  	86	0
2893	6705	7	1m  	33	0
2894	6705	7	+   	34	0
2895	6706	872	1   	33	0
2896	6706	872	+   	82	0
2897	6707	30	1m  	33	0
2898	6707	30	1m  	34	0
2899	6707	30	1m  	82	0
2900	6707	30	+   	83	0
2901	6707	30	+   	84	0
2902	6707	30	+   	85	0
2903	6707	30	1m  	86	0
2904	6708	4	1   	33	0
2905	6708	4	1   	34	0
2906	6708	4	+   	82	0
2907	6708	4	1m  	83	0
2908	6708	4	+   	84	0
2909	6708	4	+   	85	0
2910	6708	4	+   	86	0
2911	6709	410	+   	33	0
2912	6710	14	+   	33	0
2913	6710	14	+   	85	0
2914	6711	56	2b  	33	0
2915	6711	56	2b  	82	0
2916	6711	56	2a  	83	0
2917	6711	56	2a  	84	0
2918	6711	56	2a  	86	0
2919	6712	190	2a  	33	0
2920	6712	190	2a  	34	0
2921	6712	190	1   	82	0
2922	6712	190	1   	83	0
2923	6712	190	2a  	84	0
2924	6712	190	+   	85	0
2925	6712	190	1   	86	0
2926	6713	345	3   	33	0
2927	6713	345	2a  	83	0
2928	6713	345	2a  	84	0
2929	6713	345	2b  	85	0
2930	6713	345	2b  	86	0
2931	6714	790	2b  	33	0
2932	6714	790	1   	85	0
2933	6715	4	1m  	33	0
2934	6715	4	+   	82	0
2935	6716	287	1   	33	0
2936	6716	287	2a  	34	0
2937	6716	287	+   	82	0
2938	6716	287	+   	83	0
2939	6716	287	2a  	84	0
2940	6716	287	2a  	85	0
2941	6716	287	+   	86	0
2942	6717	937	1   	33	0
2943	6717	937	+   	34	0
2944	6717	937	+   	82	0
2945	6717	937	1   	83	0
2946	6717	937	+   	84	0
2947	6717	937	+   	85	0
2948	6717	937	+   	86	0
2949	6718	318	2a  	33	0
2950	6718	318	+   	34	0
2951	6718	318	+   	83	0
2952	6718	318	+   	84	0
2953	6718	318	+   	85	0
2954	6719	181	1   	33	0
2955	6719	181	2a  	34	0
2956	6719	181	2a  	82	0
2957	6719	181	1   	84	0
2958	6720	560	1m  	33	0
2959	6720	560	1m  	86	0
2960	6721	198	+   	33	0
2961	6721	198	+   	34	0
2962	6721	198	+   	84	0
2963	6721	198	+   	85	0
2964	6721	198	+   	86	0
2965	6722	144	+   	33	0
2966	6722	144	1   	34	0
2967	6722	144	1   	82	0
2968	6722	144	+   	84	0
2969	6722	144	+   	85	0
2970	6722	144	1   	86	0
2971	6723	315	1   	33	0
2972	6723	315	+   	34	0
2973	6723	315	1   	82	0
2974	6723	315	+   	86	0
2975	6724	77	a   	33	0
2976	6724	77	+   	83	0
2977	6724	77	1   	86	0
2978	6725	805	a   	33	0
2979	6725	805	2a  	86	0
2980	6726	561	a   	33	0
2981	6726	561	a   	82	0
2982	6726	561	+   	84	0
2983	6727	328	2a  	34	0
2984	6727	328	2a  	83	0
2985	6727	328	1   	84	0
2986	6728	73	2a  	34	0
2987	6728	73	+   	82	0
2988	6728	73	1   	83	0
2989	6728	73	1   	84	0
2990	6728	73	1   	85	0
2991	6730	848	+   	34	0
2992	6731	790	2b  	34	0
2993	6732	937	1   	34	0
2994	6732	937	+   	83	0
2995	6732	937	+   	84	0
2996	6732	937	+   	85	0
2997	6733	348	3   	34	0
2998	6733	348	2a  	82	0
2999	6733	348	2a  	83	0
3000	6733	348	2a  	84	0
3001	6733	348	2b  	85	0
3002	6733	348	1   	86	0
3003	6734	829	+   	34	0
3004	6734	829	1   	83	0
3005	6734	829	1   	84	0
3006	6734	829	+   	85	0
3007	6735	107	+   	34	0
3008	6736	373	1m  	34	0
3009	6736	373	1m  	82	0
3010	6736	373	1m  	85	0
3011	6737	255	1m  	34	0
3012	6737	255	1m  	82	0
3013	6738	861	+   	34	0
3014	6738	861	1   	82	0
3015	6739	45	1   	82	0
3016	6739	45	+   	85	0
3017	6739	45	+   	86	0
3018	6740	418	1m  	82	0
3019	6741	403	1m  	82	0
3020	6741	403	+   	85	0
3021	6742	455	1m  	82	0
3022	6743	356	+   	82	0
3023	6743	356	+   	83	0
3024	6743	356	+   	84	0
3025	6743	356	+   	85	0
3026	6744	527	+   	82	0
3027	6744	527	+   	83	0
3028	6744	527	+   	84	0
3029	6744	527	+   	86	0
3030	6745	215	1m  	82	0
3031	6745	215	1m  	85	0
3032	6746	215	+   	82	0
3033	6747	986	1m  	82	0
3034	6748	15	2a  	82	0
3035	6748	15	1   	83	0
3036	6748	15	1   	84	0
3037	6749	59	1   	82	0
3038	6749	59	1   	86	0
3039	6750	306	+   	82	0
3040	6750	306	+   	83	0
3041	6751	366	1   	82	0
3042	6751	366	1   	83	0
3043	6751	366	+   	84	0
3044	6751	366	+   	86	0
3045	6752	4	1m  	82	0
3046	6752	4	+   	83	0
3047	6753	296	1m  	83	0
3048	6753	296	+   	84	0
3049	6754	31	1m  	83	0
3050	6754	31	1   	84	0
3051	6754	31	+   	85	0
3052	6755	492	1m  	83	0
3053	6756	130	1m  	83	0
3054	6756	130	1m  	84	0
3055	6757	771	1m  	83	0
3056	6757	771	+   	84	0
3057	6758	389	1   	83	0
3058	6758	389	1   	84	0
3059	6758	389	1   	85	0
3060	6759	406	+   	83	0
3061	6759	406	+   	84	0
3062	6760	12	1m  	84	0
3063	6760	12	+   	85	0
3064	6761	509	+   	84	0
3065	6762	357	+   	84	0
3066	6763	130	+   	84	0
3067	6764	634	+   	84	0
3068	6765	741	+   	84	0
3069	6766	576	1m  	85	0
3070	6767	119	+   	85	0
3071	6767	119	+   	86	0
3072	6768	382	1m  	86	0
3073	6769	245	+   	86	0
3074	6770	289	+   	86	0
3075	6771	616	1   	86	0
3076	6772	147	1   	86	0
3077	6773	840	2a  	86	0
3078	6774	888	+   	86	0
3079	6775	153	2a  	86	0
3080	6776	287	2a  	88	0
3081	6776	287	+   	89	0
3082	6777	345	2b  	88	0
3083	6777	345	2b  	89	0
3084	6778	190	1   	88	0
3085	6778	190	2a  	89	0
3086	6779	790	2a  	88	0
3087	6779	790	2a  	89	0
3088	6780	184	2a  	88	0
3089	6780	184	2a  	89	0
3090	6781	77	2a  	88	0
3091	6781	77	1   	89	0
3092	6782	400	1m  	88	0
3093	6782	400	+   	89	0
3094	6783	357	1m  	88	0
3095	6783	357	+   	89	0
3096	6784	179	1   	88	0
3097	6784	179	+   	89	0
3098	6785	73	1   	88	0
3099	6786	937	1   	88	0
3100	6786	937	+   	89	0
3101	6787	144	1   	88	0
3102	6787	144	1   	89	0
3103	6788	164	1m  	88	0
3104	6788	164	1m  	89	0
3105	6789	201	+   	88	0
3106	6790	45	+   	88	0
3107	6791	450	1m  	88	0
3108	6791	450	+   	89	0
3109	6792	859	+   	88	0
3110	6792	859	+   	89	0
3111	6793	853	+   	88	0
3112	6794	619	2a  	88	0
3113	6794	619	1   	89	0
3114	6795	32	+   	88	0
3115	6796	377	+   	88	0
3116	6796	377	+   	89	0
3117	6797	732	+   	88	0
3118	6797	732	+   	89	0
3119	6798	315	+   	88	0
3120	6799	318	+   	88	0
3121	6799	318	+   	89	0
3122	6800	614	+   	88	0
3123	6800	614	+   	89	0
3124	6801	573	+   	88	0
3125	6802	44	+   	88	0
3126	6802	44	1m  	89	0
3127	6803	130	1m  	88	0
3128	6803	130	1m  	89	0
3129	6804	483	+   	88	0
3130	6805	21	1m  	88	0
3131	6805	21	1m  	89	0
3132	6806	132	+   	88	0
3133	6806	132	+   	89	0
3134	6807	21	1m  	88	0
3135	6807	21	1m  	89	0
3136	6808	338	+   	88	0
3137	6809	362	+   	88	0
3138	6809	362	+   	89	0
3139	6810	30	1m  	88	0
3140	6810	30	1m  	89	0
3141	6811	380	1m  	89	0
3142	6812	576	1m  	89	0
3143	6813	861	+   	89	0
3144	6814	771	+   	89	0
3145	6815	275	+   	90	0
3146	6815	275	1m  	91	0
3147	6816	790	2a  	90	0
3148	6816	790	2a  	91	0
3149	6816	790	2a  	92	0
3150	6816	790	2a  	93	0
3151	6816	790	2a  	94	0
3152	6817	56	2a  	90	0
3153	6817	56	2a  	91	0
3154	6817	56	2a  	92	0
3155	6817	56	2a  	93	0
3156	6818	345	1   	90	0
3157	6818	345	2a  	91	0
3158	6818	345	2a  	92	0
3159	6818	345	2a  	93	0
3160	6818	345	2a  	94	0
3161	6818	345	3   	95	0
3162	6819	373	1m  	90	0
3163	6819	373	+   	91	0
3164	6819	373	+   	92	0
3165	6819	373	+   	95	0
3166	6820	616	1   	90	0
3167	6820	616	1m  	91	0
3168	6820	616	+   	92	0
3169	6820	616	1   	94	0
3170	6820	616	+   	95	0
3171	6821	21	1m  	90	0
3172	6821	21	+   	91	0
3173	6822	356	+   	90	0
3174	6822	356	1   	91	0
3175	6822	356	1m  	92	0
3176	6822	356	+   	93	0
3177	6822	356	+   	94	0
3178	6822	356	+   	95	0
3179	6823	437	1m  	90	0
3180	6823	437	+   	91	0
3181	6823	437	1m  	92	0
3182	6823	437	+   	93	0
3183	6823	437	+   	94	0
3184	6824	4	1   	90	0
3185	6824	4	1   	91	0
3186	6824	4	a   	93	0
3187	6824	4	1   	94	0
3188	6824	4	1   	95	0
3189	6825	12	1m  	90	0
3190	6825	12	+   	91	0
3191	6825	12	1m  	92	0
3192	6825	12	1m  	93	0
3193	6825	12	1m  	95	0
3194	6826	319	+   	90	0
3195	6826	319	+   	91	0
3196	6826	319	+   	92	0
3197	6827	577	1m  	90	0
3198	6827	577	+   	91	0
3199	6827	577	+   	92	0
3200	6827	577	+   	93	0
3201	6827	577	+   	94	0
3202	6827	577	+   	95	0
3203	6828	305	1m  	90	0
3204	6828	305	1m  	93	0
3205	6828	305	+   	94	0
3206	6829	188	1   	90	0
3207	6829	188	1   	91	0
3208	6829	188	1   	92	0
3209	6829	188	1   	93	0
3210	6829	188	1   	94	0
3211	6829	188	+   	95	0
3212	6830	22	1m  	90	0
3213	6831	1145	1m  	90	0
3214	6831	1145	+   	91	0
3215	6832	119	+   	90	0
3216	6832	119	+   	91	0
3217	6832	119	+   	92	0
3218	6833	366	1   	90	0
3219	6833	366	+   	91	0
3220	6833	366	1   	92	0
3221	6833	366	1   	93	0
3222	6833	366	1   	94	0
3223	6833	366	+   	95	0
3224	6834	30	1m  	90	0
3225	6834	30	1m  	91	0
3226	6834	30	1m  	92	0
3227	6834	30	1   	93	0
3228	6834	30	1   	94	0
3229	6834	30	1m  	95	0
3230	6835	829	1   	90	0
3231	6835	829	+   	91	0
3232	6835	829	+   	92	0
3233	6835	829	+   	93	0
3234	6835	829	1   	94	0
3235	6835	829	1   	95	0
3236	6836	509	+   	90	0
3237	6836	509	+   	94	0
3238	6837	190	+   	90	0
3239	6837	190	1   	91	0
3240	6837	190	+   	92	0
3241	6837	190	+   	93	0
3242	6837	190	1   	94	0
3243	6837	190	1   	95	0
3244	6838	144	+   	90	0
3245	6838	144	+   	91	0
3246	6838	144	+   	92	0
3247	6838	144	+   	93	0
3248	6838	144	2a  	94	0
3249	6838	144	1   	95	0
3250	6839	255	a   	90	0
3251	6839	255	1   	92	0
3252	6839	255	1m  	93	0
3253	6839	255	+   	95	0
3254	6840	198	a   	90	0
3255	6840	198	+   	93	0
3256	6840	198	+   	94	0
3257	6840	198	+   	95	0
3258	6841	423	1m  	91	0
3259	6841	423	1   	92	0
3260	6841	423	+   	93	0
3261	6842	289	+   	91	0
3262	6842	289	1m  	92	0
3263	6842	289	+   	93	0
3264	6844	512	+   	91	0
3265	6845	1113	1m  	91	0
3266	6845	1113	1   	92	0
3267	6845	1113	+   	94	0
3268	6846	130	1   	91	0
3269	6846	130	1m  	92	0
3270	6846	130	+   	93	0
3271	6846	130	+   	94	0
3272	6846	130	+   	95	0
3273	6847	215	+   	91	0
3274	6847	215	1m  	94	0
3275	6847	215	1m  	95	0
3276	6848	565	+   	91	0
3277	6849	357	+   	92	0
3278	6849	357	+   	94	0
3279	6850	1136	1   	92	0
3280	6850	1136	1   	93	0
3281	6851	512	+   	92	0
3282	6851	512	+   	93	0
3283	6851	512	+   	94	0
3284	6852	899	+   	91	0
3285	6852	899	+   	92	0
3286	6852	899	+   	94	0
3287	6853	516	+   	92	0
3288	6853	516	+   	93	0
3289	6854	57	1   	93	0
3290	6855	130	+   	93	0
3291	6855	130	+   	94	0
3292	6855	130	+   	95	0
3293	6856	410	+   	93	0
3294	6857	356	+   	93	0
3295	6857	356	+   	94	0
3296	6857	356	+   	95	0
3297	6858	340	+   	94	0
3298	6859	21	2a  	94	0
3299	6859	21	1m  	95	0
3300	6860	879	+   	94	0
3301	6861	167	1m  	95	0
3302	6862	634	1m  	95	0
3303	6863	732	+   	95	0
3304	6864	937	1m  	95	0
3305	6865	694	1   	95	0
3306	6866	179	1m  	95	0
3307	6867	318	+   	95	0
3308	6868	279	1m  	95	0
3309	6870	181	1   	95	0
3310	6871	7	2a  	95	0
3311	6872	248	1   	95	0
3312	6873	361	1m  	95	0
3313	6874	741	1m  	95	0
3314	6875	1169	+   	95	0
3315	6876	861	1m  	95	0
3316	6877	573	+   	95	0
3317	6878	731	+   	95	0
3318	6880	336	+   	95	0
3319	6881	328	+   	95	0
3320	6882	56	2b  	96	0
3321	6882	56	2b  	97	0
3322	6882	56	3   	99	0
3323	6883	287	2a  	96	0
3324	6883	287	2a  	97	0
3325	6883	287	3   	99	0
3326	6884	350	2b  	96	0
3327	6884	350	2b  	97	0
3328	6884	350	1   	99	0
3329	6885	389	+   	96	0
3330	6885	389	+   	97	0
3331	6885	389	1   	99	0
3332	6886	167	1   	96	0
3333	6886	167	1   	97	0
3334	6886	167	1   	99	0
3335	6887	190	1   	96	0
3336	6887	190	1   	97	0
3337	6887	190	+   	99	0
3338	6888	324	2b  	96	0
3339	6888	324	2b  	97	0
3340	6888	324	2a  	99	0
3341	6889	527	1   	96	0
3342	6889	527	1   	97	0
3343	6889	527	1   	99	0
3344	6890	937	1   	96	0
3345	6890	937	1   	97	0
3346	6890	937	+   	99	0
3347	6891	198	+   	96	0
3348	6891	198	+   	97	0
3349	6891	198	+   	99	0
3350	6892	181	+   	96	0
3351	6892	181	+   	97	0
3352	6892	181	1   	99	0
3353	6893	30	1m  	96	0
3354	6893	30	+   	97	0
3355	6893	30	1   	99	0
3356	6894	99	1   	96	0
3357	6894	99	2a  	97	0
3358	6894	99	1   	99	0
3359	6895	7	+   	96	0
3360	6895	7	+   	99	0
3361	6896	357	+   	96	0
3362	6896	357	1   	97	0
3363	6896	357	+   	99	0
3364	6897	4	1m  	96	0
3365	6897	4	1   	97	0
3366	6897	4	2a  	99	0
3367	6898	829	1   	96	0
3368	6898	829	1   	97	0
3369	6898	829	1   	99	0
3370	6899	12	+   	96	0
3371	6900	80	1m  	96	0
3372	6900	80	+   	97	0
3373	6900	80	1m  	99	0
3374	6901	45	1   	96	0
3375	6901	45	+   	99	0
3376	6902	509	1m  	96	0
3377	6902	509	+   	97	0
3378	6902	509	+   	99	0
3379	6904	318	1   	96	0
3380	6904	318	+   	97	0
3381	6904	318	1   	99	0
3382	6905	188	1   	96	0
3383	6905	188	1   	97	0
3384	6907	15	+   	96	0
3385	6907	15	+   	97	0
3386	6907	15	1   	99	0
3387	6908	289	+   	96	0
3388	6908	289	+   	97	0
3389	6908	289	+   	99	0
3390	6909	380	1m  	96	0
3391	6909	380	+   	97	0
3392	6909	380	1m  	99	0
3393	6910	244	+   	96	0
3394	6911	144	1   	96	0
3395	6911	144	2a  	97	0
3396	6911	144	1   	99	0
3397	6912	253	1m  	96	0
3398	6913	373	+   	96	0
3399	6914	512	+   	96	0
3400	6914	512	1m  	97	0
3401	6914	512	+   	99	0
3402	6915	111	+   	96	0
3403	6915	111	+   	97	0
3404	6916	606	+   	96	0
3405	6917	174	a   	96	0
3406	6918	255	1   	96	0
3407	6918	255	+   	97	0
3408	6918	255	+   	99	0
3409	6919	20	+   	96	0
3410	6919	20	+   	97	0
3411	6919	20	+   	99	0
3412	6920	230	+   	96	0
3413	6921	356	+   	96	0
3414	6921	356	+   	97	0
3415	6921	356	+   	99	0
3416	6922	540	1m  	96	0
3417	6922	540	1m  	97	0
3418	6922	540	1m  	99	0
3419	6923	560	+   	96	0
3420	6923	560	+   	99	0
3421	6924	420	+   	96	0
3422	6925	377	1   	96	0
3423	6925	377	1   	97	0
3424	6925	377	1   	99	0
3425	6926	275	1m  	96	0
3426	6926	275	+   	97	0
3427	6926	275	1m  	99	0
3428	6927	437	+   	96	0
3429	6928	328	1   	96	0
3430	6928	328	2b  	97	0
3431	6928	328	+   	99	0
3432	6929	492	+   	96	0
3433	6930	904	+   	96	0
3434	6930	904	1m  	99	0
3435	6931	400	1m  	96	0
3436	6931	400	+   	97	0
3437	6931	400	+   	99	0
3438	6932	918	+   	96	0
3439	6932	918	2a  	97	0
3440	6932	918	+   	99	0
3441	6933	236	+   	97	0
3442	6933	236	+   	99	0
3443	6934	130	1m  	97	0
3444	6935	139	+   	97	0
3445	6936	44	+   	97	0
3446	6937	314	1   	97	0
3447	6937	314	1   	99	0
3448	6938	48	1   	97	0
3449	6938	48	+   	99	0
3450	6939	206	1m  	97	0
3451	6940	424	a   	97	0
3452	6941	986	+   	99	0
3453	6942	1146	1m  	99	0
3454	6943	985	+   	99	0
3455	6944	879	+   	99	0
3456	6945	426	1   	99	0
3457	6946	79	1m  	99	0
3458	6947	418	+   	99	0
3459	6948	362	+   	99	0
3460	6949	1101	+   	99	0
3461	6950	144	2a  	100	0
3462	6951	561	1   	100	0
3463	6952	318	2b  	100	0
3464	6953	829	2a  	100	0
3465	6954	838	1   	100	0
3466	6955	829	1   	100	0
3467	6956	179	1   	100	0
3468	6957	48	2a  	100	0
3469	6958	356	1   	100	0
3470	6959	872	+   	100	0
3471	6960	428	1m  	100	0
3472	6961	752	+   	100	0
3473	6962	805	1   	100	0
3474	6963	450	+   	100	0
3475	6964	492	1m  	100	0
3476	6965	357	1   	100	0
3477	6966	457	1   	100	0
3478	6967	667	+   	100	0
3479	6968	408	1m  	100	0
3480	6969	174	1   	100	0
3481	6970	403	1m  	100	0
3482	6971	689	1   	100	0
3483	6972	206	+   	100	0
3484	6973	130	+   	100	0
3485	6974	362	2a  	100	0
3486	6975	128	1m  	100	0
3487	6976	864	1m  	100	0
3488	6977	55	1   	100	0
3489	6978	30	1m  	100	0
3490	6979	342	1m  	100	0
3491	6980	578	1   	100	0
3492	6981	208	+   	100	0
3493	6982	184	1   	100	0
3494	6983	810	1   	100	0
3495	6984	44	1   	100	0
3496	6985	57	1m  	100	0
3497	6986	606	+   	100	0
3498	6987	57	+   	100	0
3499	6988	884	1m  	100	0
3500	6989	599	+   	100	0
3501	6990	104	+   	100	0
3502	6991	79	+   	100	0
3503	6992	819	+   	100	0
3504	6993	279	1m  	100	0
3505	6994	7	1m  	100	0
3506	6995	472	+   	100	0
3507	6996	458	+   	100	0
3508	6997	497	+   	100	0
3509	6998	904	1m  	100	0
3510	6999	15	1m  	100	0
3511	7000	21	1m  	100	0
3512	7001	898	+   	100	0
3513	7002	403	+   	100	0
3514	7003	853	1m  	100	0
3515	7004	400	+   	100	0
3516	7005	651	+   	100	0
3517	7006	860	+   	100	0
3518	7007	287	1   	100	0
3519	7008	931	1   	100	0
3520	7009	848	+   	100	0
3521	7010	882	+   	100	0
3522	7011	573	+   	100	0
3523	7012	504	+   	100	0
3524	7013	672	+   	100	0
3525	7014	56	2b  	101	0
3526	7014	56	2b  	102	0
3527	7014	56	3   	103	0
3528	7014	56	2b  	104	0
3529	7014	56	+   	105	0
3530	7014	56	2b  	106	0
3531	7015	345	3   	101	0
3532	7015	345	2b  	102	0
3533	7015	345	2b  	103	0
3534	7015	345	2a  	104	0
3535	7015	345	3   	105	0
3536	7015	345	1   	106	0
3537	7016	287	2a  	101	0
3538	7016	287	2b  	102	0
3539	7016	287	2a  	103	0
3540	7016	287	1   	104	0
3541	7016	287	2a  	105	0
3542	7016	287	2a  	106	0
3543	7017	190	2a  	101	0
3544	7017	190	2a  	102	0
3545	7017	190	2a  	103	0
3546	7017	190	2a  	104	0
3547	7017	190	1   	105	0
3548	7017	190	2a  	106	0
3549	7018	834	1   	8	0
3550	7020	362	1   	101	0
3551	7020	362	+   	102	0
3552	7020	362	+   	103	0
3553	7020	362	1   	105	0
3554	7021	167	1   	101	0
3555	7021	167	1   	102	0
3556	7021	167	1m  	103	0
3557	7021	167	+   	104	0
3558	7021	167	1   	105	0
3559	7021	167	1   	106	0
3560	7022	144	1   	101	0
3561	7022	144	2a  	102	0
3562	7022	144	+   	103	0
3563	7022	144	+   	104	0
3564	7022	144	1   	105	0
3565	7022	144	+   	106	0
3566	7023	937	1   	101	0
3567	7023	937	1   	102	0
3568	7023	937	+   	103	0
3569	7023	937	+   	104	0
3570	7023	937	+   	105	0
3571	7023	937	+   	106	0
3572	7024	512	1m  	101	0
3573	7024	512	1m  	103	0
3574	7024	512	1m  	105	0
3575	7024	512	+   	106	0
3576	7025	861	2a  	101	0
3577	7025	861	+   	102	0
3578	7025	861	1   	103	0
3579	7025	861	2a  	104	0
3580	7025	861	1   	105	0
3581	7026	366	1   	101	0
3582	7026	366	1   	102	0
3583	7026	366	1   	103	0
3584	7026	366	1   	104	0
3585	7026	366	+   	105	0
3586	7027	899	1   	101	0
3587	7027	899	+   	102	0
3588	7027	899	+   	103	0
3589	7027	899	1   	104	0
3590	7027	899	1   	105	0
3591	7028	223	+   	101	0
3592	7028	223	+   	102	0
3593	7028	223	+   	103	0
3594	7028	223	1   	105	0
3595	7029	181	1   	101	0
3596	7029	181	1   	102	0
3597	7029	181	1   	103	0
3598	7029	181	1   	104	0
3599	7029	181	+   	105	0
3600	7029	181	+   	106	0
3601	7030	208	+   	101	0
3602	7030	208	+   	103	0
3603	7030	208	+   	105	0
3604	7030	208	+   	106	0
3605	7031	179	2a  	101	0
3606	7031	179	1   	102	0
3607	7031	179	2a  	103	0
3608	7031	179	2b  	104	0
3609	7031	179	2a  	105	0
3610	7031	179	+   	106	0
3611	7032	45	1   	101	0
3612	7032	45	+   	103	0
3613	7032	45	1   	105	0
3614	7032	45	1   	106	0
3615	7033	73	1   	101	0
3616	7033	73	+   	102	0
3617	7033	73	+   	103	0
3618	7033	73	+   	104	0
3619	7033	73	2a  	105	0
3620	7033	73	1   	106	0
3621	7034	4	1m  	101	0
3622	7034	4	1   	103	0
3623	7034	4	2a  	104	0
3624	7034	4	1   	105	0
3625	7034	4	2a  	106	0
3626	7035	356	1   	101	0
3627	7035	356	+   	102	0
3628	7035	356	1   	105	0
3629	7035	356	+   	106	0
3630	7036	1101	1m  	101	0
3631	7036	1101	+   	102	0
3632	7036	1101	+   	104	0
3633	7036	1101	+   	105	0
3634	7036	1101	+   	106	0
3635	7037	275	1m  	101	0
3636	7037	275	+   	105	0
3637	7037	275	1m  	106	0
3638	7038	342	+   	101	0
3639	7038	342	1m  	102	0
3640	7038	342	1m  	106	0
3641	7039	30	+   	101	0
3642	7039	30	1m  	102	0
3643	7039	30	2a  	103	0
3644	7039	30	+   	104	0
3645	7039	30	1m  	105	0
3646	7039	30	1m  	106	0
3647	7040	790	1   	101	0
3648	7040	790	+   	102	0
3649	7040	790	+   	104	0
3650	7040	790	+   	105	0
3651	7041	15	+   	101	0
3652	7041	15	+   	102	0
3653	7041	15	+   	103	0
3654	7041	15	+   	104	0
3655	7041	15	1m  	105	0
3656	7041	15	+   	106	0
3657	7042	730	1m  	101	0
3658	7042	730	+   	102	0
3659	7042	730	1m  	103	0
3660	7042	730	1m  	104	0
3661	7042	730	1m  	105	0
3662	7042	730	+   	106	0
3663	7043	577	+   	101	0
3664	7044	305	+   	101	0
3665	7044	305	1m  	102	0
3666	7044	305	1   	103	0
3667	7044	305	+   	104	0
3668	7044	305	1   	105	0
3669	7045	408	1   	101	0
3670	7045	408	1m  	102	0
3671	7045	408	1m  	103	0
3672	7045	408	+   	104	0
3673	7045	408	1   	105	0
3674	7046	634	+   	101	0
3675	7046	634	+   	105	0
3676	7047	184	1   	101	0
3677	7047	184	1   	102	0
3678	7047	184	1   	103	0
3679	7047	184	+   	104	0
3680	7047	184	1   	105	0
3681	7047	184	1   	106	0
3682	7048	215	1m  	101	0
3683	7048	215	+   	102	0
3684	7048	215	+   	105	0
3685	7048	215	+   	106	0
3686	7050	7	1m  	101	0
3687	7050	7	+   	102	0
3688	7050	7	1m  	103	0
3689	7050	7	1m  	105	0
3690	7050	7	+   	106	0
3691	7051	26	+   	101	0
3692	7051	26	+   	102	0
3693	7051	26	+   	104	0
3694	7051	26	+   	106	0
3695	7052	26	+   	101	0
3696	7052	26	+   	102	0
3697	7052	26	+   	104	0
3698	7052	26	+   	106	0
3699	7053	128	+   	101	0
3700	7053	128	+   	102	0
3701	7053	128	+   	103	0
3702	7053	128	+   	105	0
3703	7053	128	+   	106	0
3704	7054	328	1   	101	0
3705	7054	328	1   	102	0
3706	7054	328	1   	103	0
3707	7054	328	1   	104	0
3708	7054	328	1   	105	0
3709	7055	848	+   	101	0
3710	7055	848	+   	106	0
3711	7057	318	+   	101	0
3712	7057	318	+   	102	0
3713	7057	318	+   	103	0
3714	7057	318	+   	104	0
3715	7057	318	+   	105	0
3716	7057	318	2b  	106	0
3717	7058	418	+   	101	0
3718	7058	418	+   	102	0
3719	7058	418	1m  	103	0
3720	7058	418	+   	104	0
3721	7059	540	1m  	102	0
3722	7059	540	1m  	103	0
3723	7059	540	+   	105	0
3724	7060	198	1m  	102	0
3725	7060	198	+   	103	0
3726	7060	198	+   	105	0
3727	7060	198	1m  	106	0
3728	7061	619	1m  	102	0
3729	7061	619	a   	105	0
3730	7062	188	1   	103	0
3731	7062	188	1   	105	0
3732	7062	188	1   	106	0
3733	7063	206	+   	103	0
3734	7063	206	+   	104	0
3735	7064	215	1m  	103	0
3736	7064	215	+   	105	0
3737	7065	133	+   	104	0
3738	7066	1147	1m  	104	0
3739	7067	420	+   	105	0
3740	7068	357	+   	105	0
3741	7068	357	+   	106	0
3742	7069	48	1   	105	0
3743	7070	80	1m  	105	0
3744	7071	829	1   	105	0
3745	7072	863	1m  	105	0
3746	7073	829	2b  	105	0
3747	7073	829	2a  	106	0
3748	7074	255	+   	105	0
3749	7074	255	1   	106	0
3750	7075	872	1m  	106	0
3751	7076	77	1   	106	0
3752	7077	79	1m  	106	0
3753	7078	314	1   	106	0
3754	7079	289	1m  	106	0
3755	7080	12	+   	106	0
3756	7081	606	1   	106	0
3757	7082	630	1   	106	0
3758	7083	380	1m  	106	0
3759	7084	11	1m  	106	0
3760	7085	805	1   	106	0
3761	7086	373	1m  	106	0
3762	7087	986	+   	106	0
3763	7088	527	+   	106	0
3764	7089	561	+   	106	0
3765	7090	377	+   	106	0
3766	7091	306	1m  	106	0
3767	7092	147	1   	106	0
3768	7093	819	+   	106	0
3769	7094	56	2a  	107	0
3770	7094	56	1   	108	0
3771	7095	345	2b  	107	0
3772	7095	345	2b  	108	0
3773	7096	190	2a  	107	0
3774	7096	190	2a  	108	0
3775	7097	287	2a  	107	0
3776	7097	287	2a  	108	0
3777	7098	790	2a  	107	0
3778	7098	790	2a  	108	0
3779	7099	937	1   	107	0
3780	7100	318	1   	107	0
3781	7100	318	+   	108	0
3782	7101	79	1m  	107	0
3783	7101	79	1m  	108	0
3784	7102	167	+   	107	0
3785	7102	167	1   	108	0
3786	7103	255	+   	107	0
3787	7103	255	+   	108	0
3788	7104	198	1m  	107	0
3789	7104	198	1m  	108	0
3790	7105	77	1   	107	0
3791	7105	77	1   	108	0
3792	7106	208	+   	107	0
3793	7106	208	+   	108	0
3794	7107	342	1m  	107	0
3795	7107	342	+   	108	0
3796	7108	410	1m  	107	0
3797	7108	410	1m  	108	0
3798	7109	144	1   	107	0
3799	7109	144	1   	108	0
3800	7110	805	1   	107	0
3801	7110	805	1   	108	0
3802	7111	30	1m  	107	0
3803	7111	30	1m  	108	0
3804	7112	380	1m  	107	0
3805	7112	380	1m  	108	0
3806	7113	59	+   	107	0
3807	7113	59	1   	108	0
3808	7114	11	+   	107	0
3809	7114	11	+   	108	0
3810	7115	184	+   	107	0
3811	7116	188	1   	107	0
3812	7116	188	1   	108	0
3813	7117	1136	1   	107	0
3814	7117	1136	1   	108	0
3815	7118	4	1   	107	0
3816	7119	147	1   	107	0
3817	7119	147	1   	108	0
3818	7120	12	1m  	107	0
3819	7120	12	1m  	108	0
3820	7121	1101	+   	107	0
3821	7121	1101	+   	108	0
3822	7122	113	+   	107	0
3823	7123	128	+   	107	0
3824	7123	128	+   	108	0
3825	7124	130	+   	107	0
3826	7124	130	+   	108	0
3827	7125	243	+   	107	0
3828	7125	243	+   	108	0
3829	7126	512	1m  	107	0
3830	7126	512	+   	108	0
3831	7127	357	1   	107	0
3832	7127	357	1m  	108	0
3833	7129	606	+   	107	0
3834	7129	606	+   	108	0
3835	7130	73	1   	107	0
3836	7131	273	+   	107	0
3837	7131	273	1m  	108	0
3838	7132	410	+   	107	0
3839	7132	410	+   	108	0
3840	7133	829	1   	107	0
3841	7133	829	2a  	108	0
3842	7134	389	+   	107	0
3843	7134	389	+   	108	0
3844	7135	181	a   	107	0
3845	7136	7	+   	108	0
3846	7137	328	2a  	108	0
3847	7138	15	1m  	108	0
3848	7139	373	1m  	108	0
3849	7140	275	+   	108	0
3850	7141	45	+   	108	0
3851	7142	223	1   	108	0
3852	7143	377	+   	108	0
3853	7144	861	a   	108	0
3854	7145	880	1m  	110	0
3855	7146	164	1   	110	0
3856	7147	428	1   	110	0
3857	7148	483	1   	110	0
3858	7149	380	1m  	110	0
3859	7150	48	1   	110	0
3860	7151	594	2a  	110	0
3861	7152	77	1   	110	0
3862	7153	853	2a  	110	0
3863	7154	901	1   	110	0
3864	7155	188	1m  	110	0
3865	7156	357	+   	110	0
3866	7157	59	+   	110	0
3867	7158	32	+   	110	0
3868	7159	497	1   	110	0
3869	7160	667	1   	110	0
3870	7161	606	1   	110	0
3871	7162	900	1m  	110	0
3872	7163	14	1m  	110	0
3873	7164	338	1   	110	0
3874	7165	240	1   	110	0
3875	7166	130	1m  	110	0
3876	7167	601	+   	110	0
3877	7168	287	+   	110	0
3878	7169	79	1m  	110	0
3879	7170	289	1m  	110	0
3880	7171	184	1   	110	0
3881	7172	752	+   	110	0
3882	7173	805	1   	110	0
3883	7174	147	1m  	110	0
3884	7175	651	1   	110	0
3885	7176	113	1m  	110	0
3886	7177	1148	+   	110	0
3887	7178	128	+   	110	0
3888	7179	1140	1m  	110	0
3889	7180	366	1   	110	0
3890	7181	424	1   	110	0
3891	7182	1149	1m  	110	0
3892	7183	44	+   	110	0
3893	7184	147	+   	110	0
3894	7185	31	1m  	110	0
3895	7186	1169	+   	110	0
3896	7187	243	+   	110	0
3897	7188	21	1m  	110	0
3898	7189	921	1m  	110	0
3899	7190	458	+   	110	0
3900	7191	144	+   	110	0
3901	7192	56	1   	110	0
3902	7193	345	2a  	110	0
3903	7194	362	+   	110	0
3904	7195	930	1   	110	0
3905	7196	578	+   	110	0
3906	7197	689	+   	110	0
3907	7198	672	1   	110	0
3908	7199	848	1   	110	0
3909	7200	338	+   	110	0
3910	7201	898	+   	110	0
3911	7202	779	+   	110	0
3912	7203	318	+   	110	0
3913	7204	859	2a  	110	0
3914	7205	22	1m  	110	0
3915	7206	921	1m  	110	0
3916	7207	283	+   	110	0
3917	7208	30	1m  	110	0
3918	7209	926	1m  	110	0
3919	7210	578	+   	110	0
3920	7211	479	+   	110	0
3921	7212	836	3   	111	0
3922	7212	836	3   	112	0
3923	7212	836	3   	113	0
3924	7212	836	2b  	114	0
3925	7212	836	2b  	115	0
3926	7213	83	1   	111	0
3927	7213	83	1   	112	0
3928	7213	83	2a  	113	0
3929	7213	83	1   	114	0
3930	7213	83	2a  	115	0
3931	7214	403	2a  	111	0
3932	7214	403	1   	112	0
3933	7214	403	2a  	113	0
3934	7214	403	2a  	114	0
3935	7214	403	2a  	115	0
3936	7215	843	1   	111	0
3937	7215	843	+   	112	0
3938	7215	843	1   	113	0
3939	7215	843	+   	114	0
3940	7215	843	1   	115	0
3941	7216	45	1   	111	0
3942	7216	45	+   	112	0
3943	7216	45	+   	113	0
3944	7216	45	+   	114	0
3945	7217	202	2b  	111	0
3946	7217	202	2a  	112	0
3947	7217	202	2b  	113	0
3948	7217	202	2a  	114	0
3949	7217	202	2a  	115	0
3955	7219	904	2b  	111	0
3956	7219	904	2a  	112	0
3957	7219	904	2a  	113	0
3958	7219	904	1   	114	0
3959	7219	904	1   	115	0
3960	7220	283	1   	111	0
3961	7220	283	+   	112	0
3962	7220	283	1   	113	0
3963	7220	283	1   	114	0
3964	7220	283	1   	115	0
3965	7221	803	1   	111	0
3966	7221	803	+   	113	0
3967	7222	234	1   	111	0
3968	7222	234	+   	112	0
3969	7222	234	+   	113	0
3970	7223	472	1m  	111	0
3971	7223	472	2a  	112	0
3972	7223	472	1   	113	0
3973	7223	472	+   	114	0
3974	7223	472	1   	115	0
3975	7224	2140	1   	111	0
3976	7224	2140	+   	112	0
3977	7224	2140	1   	113	0
3978	7224	2140	+   	114	0
3979	7224	2140	2a  	115	0
3980	7225	475	1m  	111	0
3981	7225	475	+   	112	0
3985	7227	698	1   	111	0
3986	7227	698	1   	112	0
3987	7228	256	+   	111	0
3988	7228	256	+   	112	0
3989	7228	256	1   	113	0
3990	7228	256	1   	114	0
3991	7229	858	1   	111	0
3992	7229	858	1   	112	0
3993	7229	858	1   	113	0
3994	7229	858	1   	114	0
3995	7229	858	1   	115	0
3996	7230	689	1   	111	0
3997	7230	689	2a  	112	0
3998	7230	689	1   	113	0
3999	7231	772	1   	111	0
4000	7231	772	+   	112	0
4001	7231	772	+   	113	0
4002	7231	772	+   	115	0
4003	7232	12	1m  	111	0
4004	7232	12	+   	112	0
4005	7232	12	1m  	113	0
4006	7232	12	+   	115	0
4007	7233	380	1m  	111	0
4008	7233	380	1m  	112	0
4009	7233	380	1m  	113	0
4010	7233	380	+   	114	0
4011	7233	380	1m  	115	0
4012	7234	908	1   	111	0
4013	7234	908	1   	112	0
4014	7234	908	1   	113	0
4015	7234	908	1   	114	0
4016	7234	908	1   	115	0
4017	7235	68	1   	111	0
4018	7235	68	+   	112	0
4019	7236	712	1   	111	0
4020	7236	712	1   	112	0
4021	7236	712	+   	113	0
4022	7236	712	+   	115	0
4023	7237	884	1   	111	0
4024	7237	884	1   	112	0
4025	7237	884	1   	113	0
4026	7237	884	1   	114	0
4027	7237	884	+   	115	0
4028	7238	362	2a  	111	0
4029	7238	362	2a  	112	0
4030	7238	362	2a  	113	0
4031	7238	362	+   	114	0
4032	7238	362	2a  	115	0
4033	7239	767	1   	111	0
4034	7239	767	+   	112	0
4035	7239	767	1   	113	0
4036	7239	767	1   	114	0
4037	7239	767	1   	115	0
4038	7240	815	1   	111	0
4039	7241	822	1   	111	0
4040	7241	822	+   	112	0
4041	7241	822	+   	113	0
4042	7242	739	1   	111	0
4043	7242	739	+   	112	0
4044	7242	739	+   	113	0
4045	7242	739	+   	114	0
4046	7242	739	+   	115	0
4047	7243	403	1   	111	0
4048	7243	403	+   	112	0
4049	7243	403	1   	113	0
4050	7243	403	1   	114	0
4051	7243	403	+   	115	0
4057	7246	878	1m  	111	0
4058	7246	878	+   	112	0
4059	7246	878	1   	113	0
4060	7246	878	1   	114	0
4061	7246	878	1   	115	0
4062	7247	784	1   	111	0
4063	7247	784	1   	112	0
4064	7248	665	+   	111	0
4065	7248	665	+   	113	0
4066	7248	665	1   	114	0
4067	7249	621	+   	111	0
4068	7249	621	+   	112	0
4069	7250	458	+   	111	0
4070	7251	458	1   	111	0
4071	7251	458	1   	112	0
4072	7251	458	1   	113	0
4073	7251	458	1   	114	0
4074	7251	458	1   	115	0
4075	7252	925	1m  	111	0
4076	7252	925	+   	112	0
4077	7252	925	+   	113	0
4078	7253	76	1   	111	0
4079	7253	76	a   	113	0
4080	7253	76	+   	115	0
4081	7254	295	1m  	111	0
4082	7254	295	1m  	112	0
4083	7254	295	1m  	113	0
4084	7254	295	+   	114	0
4085	7254	295	+   	115	0
4086	7255	687	1   	111	0
4087	7255	687	+   	112	0
4088	7256	166	+   	111	0
4089	7256	166	1   	112	0
4090	7256	166	1   	113	0
4091	7256	166	2a  	114	0
4092	7256	166	1   	115	0
4093	7257	862	1   	111	0
4094	7257	862	1   	112	0
4095	7257	862	1   	113	0
4096	7257	862	+   	114	0
4097	7257	862	+   	115	0
4098	7258	170	1   	111	0
4099	7258	170	2a  	112	0
4100	7258	170	1   	113	0
4101	7258	170	2a  	114	0
4102	7258	170	2a  	115	0
4103	7259	623	+   	111	0
4104	7260	336	+   	111	0
4108	7262	814	1   	111	0
4109	7262	814	+   	112	0
4110	7262	814	+   	113	0
4111	7262	814	+   	114	0
4113	7264	889	2a  	111	0
4114	7265	651	1m  	111	0
4115	7265	651	+   	112	0
4116	7266	606	1   	111	0
4117	7266	606	+   	112	0
4118	7266	606	2a  	115	0
4119	7267	603	1   	111	0
4120	7267	603	+   	113	0
4121	7267	603	1   	115	0
4122	7268	576	1m  	111	0
4123	7268	576	+   	112	0
4134	7272	7	1   	111	0
4135	7272	7	1   	112	0
4136	7272	7	1   	113	0
4137	7272	7	1   	114	0
4138	7272	7	1   	115	0
4139	7273	283	+   	111	0
4140	7273	283	+   	112	0
4141	7273	283	1   	113	0
4142	7273	283	+   	115	0
4143	7274	1106	+   	111	0
4144	7274	1106	+   	114	0
4148	7276	699	+   	111	0
4149	7276	699	+   	113	0
4150	7277	683	+   	111	0
4151	7277	683	+   	112	0
4152	7277	683	a   	113	0
4153	7277	683	+   	115	0
4154	7278	79	+   	111	0
4155	7278	79	+   	113	0
4156	7278	79	+   	114	0
4158	7280	690	1   	112	0
4159	7280	690	+   	113	0
4160	7280	690	1   	114	0
4161	7280	690	+   	115	0
4164	7282	614	1   	112	0
4165	7283	39	+   	112	0
4166	7284	425	+   	112	0
4167	7285	766	a   	111	0
4168	7285	766	1   	114	0
4173	7287	64	1   	113	0
4174	7287	64	1   	114	0
4175	7287	64	3   	115	0
4178	7289	780	+   	113	0
4179	7290	44	+   	113	0
4180	7290	44	1   	115	0
4181	7291	809	1   	113	0
4182	7291	809	1   	114	0
4183	7292	696	+   	113	0
4184	7292	696	+   	114	0
4185	7293	695	+   	113	0
4186	7293	695	+   	114	0
4187	7294	2137	+   	113	0
4188	7295	362	1   	113	0
4189	7296	623	2a  	114	0
4190	7296	623	1   	115	0
4192	7298	44	+   	114	0
4193	7299	817	+   	114	0
4194	7300	236	+   	114	0
4195	7301	654	+   	114	0
4196	7301	654	1m  	115	0
4197	7302	659	2a  	115	0
4198	7303	457	1   	115	0
4200	7305	450	1   	115	0
4201	7306	318	1   	115	0
4202	7307	249	1   	115	0
4203	7308	987	1   	116	0
4208	7313	929	2b  	116	0
4220	7326	928	1   	116	0
4221	7327	927	2a  	116	0
4223	7329	798	2b  	116	0
4224	7330	734	2a  	116	0
4226	7332	924	1m  	116	0
4227	7333	691	2a  	116	0
4232	7338	911	2b  	116	0
4233	7339	686	+   	116	0
4234	7340	837	3   	117	0
4235	7340	837	3   	1	0
4236	7340	837	3   	2	0
4237	7340	837	2b  	4	0
4238	7340	837	3   	5	0
4239	7340	837	3   	6	0
4240	7341	83	2a  	117	0
4241	7341	83	2a  	1	0
4242	7341	83	2a  	2	0
4243	7341	83	2a  	4	0
4244	7341	83	2a  	5	0
4245	7341	83	2a  	6	0
4246	7342	878	1   	117	0
4247	7342	878	+   	1	0
4248	7342	878	+   	2	0
4249	7342	878	1   	4	0
4250	7342	878	1   	5	0
4251	7342	878	+   	6	0
4252	7343	283	1   	117	0
4253	7343	283	1   	1	0
4254	7343	283	+   	2	0
4255	7343	283	1   	4	0
4256	7343	283	1   	5	0
4257	7343	283	1   	6	0
4258	7344	458	1   	117	0
4259	7344	458	+   	1	0
4260	7344	458	+   	5	0
4261	7344	458	+   	6	0
4268	7346	822	1   	117	0
4269	7346	822	+   	1	0
4270	7346	822	+   	2	0
4271	7347	665	+   	117	0
4272	7347	665	+   	1	0
4273	7347	665	+   	2	0
4274	7347	665	1   	4	0
4275	7347	665	+   	5	0
4276	7347	665	+   	6	0
4277	7348	908	1   	117	0
4278	7348	908	1   	1	0
4279	7348	908	1   	2	0
4280	7348	908	1   	4	0
4281	7348	908	1   	5	0
4282	7348	908	1   	6	0
4283	7350	362	1   	117	0
4284	7350	362	1   	1	0
4285	7350	362	+   	2	0
4286	7350	362	1   	4	0
4287	7350	362	2a  	5	0
4288	7350	362	1   	6	0
4295	7353	862	1   	117	0
4296	7353	862	+   	1	0
4297	7353	862	+   	2	0
4298	7353	862	+   	4	0
4299	7353	862	1   	5	0
4300	7353	862	1   	6	0
4301	7354	380	1m  	117	0
4302	7354	380	1m  	1	0
4303	7354	380	1m  	2	0
4304	7354	380	1m  	4	0
4305	7354	380	1m  	5	0
4306	7354	380	1m  	6	0
4307	7355	613	1m  	117	0
4308	7355	613	1m  	1	0
4309	7355	613	1m  	4	0
4310	7355	613	+   	5	0
4311	7355	613	+   	6	0
4312	7356	576	1m  	117	0
4313	7356	576	+   	2	0
4314	7356	576	+   	4	0
4315	7356	576	1   	5	0
4316	7356	576	+   	6	0
4321	7358	937	+   	117	0
4322	7358	937	+   	1	0
4323	7358	937	+   	4	0
4324	7358	937	2a  	5	0
4325	7358	937	+   	6	0
4326	7359	809	1   	117	0
4327	7359	809	+   	1	0
4328	7359	809	+   	4	0
4329	7359	809	1   	5	0
4330	7359	809	+   	6	0
4331	7360	772	+   	117	0
4332	7360	772	+   	1	0
4333	7360	772	1   	2	0
4334	7360	772	+   	5	0
4335	7360	772	+   	6	0
4336	7361	295	1m  	117	0
4337	7361	295	+   	1	0
4338	7361	295	1m  	2	0
4339	7361	295	+   	4	0
4340	7361	295	+   	5	0
4341	7362	166	1   	117	0
4342	7362	166	1   	1	0
4343	7362	166	1   	2	0
4344	7362	166	1   	4	0
4345	7362	166	1   	5	0
4346	7362	166	+   	6	0
4347	7363	884	1   	117	0
4348	7363	884	+   	1	0
4349	7363	884	1   	2	0
4350	7363	884	+   	4	0
4351	7363	884	1   	5	0
4352	7363	884	+   	6	0
4353	7364	767	1m  	117	0
4354	7364	767	+   	1	0
4355	7364	767	1m  	2	0
4356	7364	767	1m  	4	0
4357	7364	767	+   	5	0
4358	7365	623	1   	117	0
4359	7365	623	1   	1	0
4360	7365	623	1   	2	0
4361	7365	623	1   	4	0
4362	7365	623	1   	5	0
4363	7365	623	1   	6	0
4364	7366	881	1   	117	0
4365	7366	881	+   	1	0
4366	7366	881	1   	5	0
4367	7366	881	+   	6	0
4368	7367	737	+   	117	0
4369	7367	737	+   	2	0
4374	7369	816	+   	117	0
4375	7369	816	+   	2	0
4376	7369	816	2a  	4	0
4377	7369	816	+   	5	0
4378	7370	11	1m  	117	0
4379	7370	11	+   	2	0
4380	7370	11	+   	5	0
4381	7371	705	+   	117	0
4387	7373	659	1   	117	0
4388	7373	659	1   	1	0
4389	7373	659	1   	2	0
4390	7373	659	1   	4	0
4391	7373	659	1   	5	0
4392	7373	659	1   	6	0
4393	7374	814	+   	117	0
4394	7375	623	1   	117	0
4395	7375	623	1   	1	0
4396	7375	623	+   	2	0
4397	7375	623	2a  	4	0
4398	7375	623	1   	5	0
4399	7375	623	1   	6	0
4400	7376	44	1   	117	0
4401	7376	44	+   	1	0
4402	7376	44	1   	2	0
4403	7376	44	+   	4	0
4404	7376	44	+   	5	0
4405	7376	44	1   	6	0
4412	7379	695	1   	117	0
4413	7379	695	1   	2	0
4414	7380	711	+   	117	0
4417	7382	571	+   	117	0
4418	7383	722	+   	117	0
4424	7385	475	1m  	117	0
4425	7385	475	+   	1	0
4426	7385	475	1   	2	0
4427	7385	475	+   	4	0
4428	7385	475	1   	5	0
4429	7385	475	+   	6	0
4430	7386	315	1   	117	0
4431	7386	315	1   	2	0
4432	7386	315	2a  	4	0
4433	7386	315	2a  	5	0
4434	7386	315	2a  	6	0
4435	7387	698	+   	117	0
4436	7387	698	+   	2	0
4437	7388	854	1   	117	0
4438	7388	854	1   	1	0
4439	7388	854	+   	2	0
4440	7388	854	+   	4	0
4441	7388	854	1   	5	0
4442	7388	854	1   	6	0
4443	7389	2140	a   	117	0
4444	7389	2140	2a  	1	0
4445	7389	2140	2a  	2	0
4446	7389	2140	2a  	4	0
4447	7389	2140	+   	6	0
4448	7390	403	a   	117	0
4449	7390	403	1   	1	0
4450	7390	403	2a  	2	0
4451	7390	403	2a  	4	0
4452	7390	403	2a  	5	0
4453	7390	403	1   	6	0
4454	7391	234	a   	117	0
4455	7391	234	1   	1	0
4456	7391	234	2a  	2	0
4457	7391	234	2b  	4	0
4458	7391	234	2a  	5	0
4459	7391	234	2a  	6	0
4460	7392	603	+   	117	0
4461	7392	603	+   	5	0
4462	7392	603	1   	6	0
4463	7393	362	+   	1	0
4464	7394	202	+   	1	0
4465	7394	202	1   	2	0
4466	7394	202	1   	4	0
4467	7394	202	1   	5	0
4468	7394	202	+   	6	0
4474	7397	76	a   	117	0
4475	7397	76	1   	1	0
4476	7397	76	1   	2	0
4477	7397	76	2a  	4	0
4478	7398	458	1   	1	0
4479	7398	458	1   	4	0
4480	7398	458	1   	5	0
4481	7399	766	1m  	1	0
4482	7399	766	1   	2	0
4483	7399	766	1   	4	0
4484	7399	766	+   	5	0
4485	7400	450	+   	1	0
4486	7401	318	2a  	2	0
4487	7401	318	+   	4	0
4488	7402	249	1   	2	0
4489	7402	249	1   	5	0
4490	7403	739	1   	4	0
4491	7403	739	1   	6	0
4492	7404	403	1   	4	0
4493	7404	403	1   	6	0
4494	7405	684	2a  	4	0
4495	7405	684	1   	5	0
4496	7406	425	+   	4	0
4497	7407	843	1   	4	0
4498	7407	843	1   	5	0
4499	7407	843	2b  	6	0
4500	7409	904	1m  	5	0
4501	7410	880	2a  	5	0
4502	7410	880	+   	6	0
4503	7411	64	1   	5	0
4506	7413	858	+   	5	0
4507	7414	803	1   	6	0
4508	7415	188	+   	7	0
4509	7416	598	2a  	7	0
4510	7417	44	1   	7	0
4511	7418	523	1m  	7	0
4512	7419	7	1   	7	0
4513	7420	472	1   	7	0
4514	7421	665	1   	7	0
4515	7422	2138	+   	7	0
4516	7423	12	1m  	7	0
4517	7424	166	1   	7	0
4518	7425	424	1m  	7	0
4519	7426	917	1m  	7	0
4520	7427	1143	1   	7	0
4521	7428	897	1m  	7	0
4522	7429	883	+   	7	0
4523	7430	51	+   	7	0
4524	7431	740	1   	7	0
4525	7432	899	+   	7	0
4526	7433	203	1   	7	0
4527	7434	151	1   	7	0
4528	7435	130	1m  	7	0
4529	7436	883	+   	7	0
4530	7437	256	+   	7	0
4531	7438	884	+   	7	0
4532	7439	403	+   	7	0
4533	7440	772	+   	7	0
4534	7441	873	1   	7	0
4535	7442	283	1m  	7	0
4536	7443	39	+   	7	0
4537	7444	739	1   	7	0
4538	7445	243	1m  	7	0
4539	7446	367	+   	7	0
4540	7447	823	+   	7	0
4541	7448	854	+   	7	0
4542	7449	278	+   	7	0
4543	7450	836	3   	7	0
4544	7451	835	2a  	7	0
4545	7452	920	1   	7	0
4546	7453	910	1m  	7	0
4547	7454	619	a   	7	0
4548	7455	2140	a   	7	0
4549	7456	601	+   	86	0
4550	7523	1167	.   	98	0
4551	7531	718	.   	120	0
4552	7532	190	.   	120	0
4553	7586	509	.   	176	0
4554	7630	648	.   	115	0
4555	7638	871	.   	115	0
4556	7639	408	.   	115	0
4557	7650	39	.   	116	0
4558	7663	170	1   	111	0
4559	7663	170	2a  	112	0
4560	7663	170	1   	113	0
4561	7663	170	2a  	114	0
4562	7663	170	2a  	115	0
4563	7667	356	+   	117	0
4564	7669	324	1   	75	0
4565	7671	305	.   	188	0
4566	7672	305	1   	188	0
4567	7673	256	1m  	188	0
4568	7674	362	+   	188	0
4569	7675	356	.   	188	0
4570	7676	282	.   	168	0
4571	7678	518	.   	193	0
4572	7679	184	.   	177	0
4573	7680	192	.   	140	0
4574	7681	1164	.   	170	0
4575	7682	186	.   	165	0
4576	7683	1164	.   	156	0
4577	7684	169	.   	157	0
4578	7685	829	.   	134	0
4579	7686	290	.   	134	0
4580	7687	1110	.   	139	0
4581	7688	197	.   	139	0
4582	7689	523	1m  	122	0
4583	7689	523	+   	128	0
4584	7690	356	.   	109	0
4585	7692	932	.   	149	0
4586	7693	436	.   	150	0
4587	7694	436	.   	150	0
4588	7695	436	.   	150	0
4589	7696	424	.   	177	0
4590	7697	490	.   	136	0
4591	7698	662	.   	81	0
4592	7699	219	+   	11	0
4593	7700	1120	+   	127	0
4594	7701	408	+   	166	0
4595	7701	408	+   	167	0
4596	7704	394	.   	134	0
4597	7705	380	.   	140	0
4598	7706	124	+   	11	0
4599	7706	124	+   	127	0
4600	7707	239	+   	186	0
4601	7708	223	.   	84	0
4602	7709	23	1m  	127	0
4603	7710	26	+   	60	0
4604	7711	26	1   	163	0
4605	7712	18	+   	188	0
4606	7713	15	2a  	68	0
4607	7713	15	2a  	69	0
4608	7714	30	+   	68	0
4609	7715	393	.   	177	0
4610	7716	470	+   	60	0
4611	71	1141	2a  	202	0
4612	71	1141	2a  	282	0
4613	71	1141	2a  	327	0
4614	71	1141	2a  	337	0
4615	71	1141	2b  	352	0
4616	72	61	1   	202	0
4617	72	61	1   	327	0
4618	72	61	+   	352	0
4619	73	489	1   	202	1398
4620	73	489	1   	282	1398
4621	73	489	1   	352	1398
4622	74	371	1m  	202	0
4623	74	371	1m  	282	0
4624	74	371	+   	327	0
4625	74	371	+   	337	0
4626	74	371	+   	352	0
4627	75	145	1m  	202	129
4628	75	145	+   	282	129
4629	75	145	+   	327	129
4630	75	145	1m  	337	129
4631	76	23	1m  	327	107
4632	77	791	1   	202	0
4633	77	791	1   	282	0
4634	77	791	+   	327	0
4635	77	791	+   	352	0
4636	78	90	1m  	202	1431
4637	78	90	+   	282	1431
4638	78	90	1m  	337	1431
4639	78	90	+   	352	1431
4640	79	184	1   	202	0
4641	79	184	1   	282	0
4642	79	184	1   	327	0
4643	80	178	+   	202	0
4644	80	178	+   	282	0
4645	80	178	+   	352	0
4646	81	257	1   	202	0
4647	81	257	+   	282	0
4648	81	257	+   	352	0
4649	82	168	+   	202	1364
4650	82	168	+   	282	1364
4651	82	168	+   	327	1364
4652	83	494	+   	327	1477
4653	84	124	1   	202	1410
4654	84	124	1   	282	1410
4655	84	124	1   	327	1410
4656	85	548	+   	327	1340
4657	85	548	1m  	337	1340
4658	85	548	+   	352	1340
4659	86	89	1m  	202	0
4660	86	89	+   	282	0
4661	86	89	+   	327	0
4662	87	90	+   	202	0
4663	87	90	+   	282	0
4664	88	733	1   	202	1465
4665	88	733	1   	282	1465
4666	88	733	1   	327	1465
4667	88	733	+   	337	1465
4668	88	733	1   	352	1465
4669	89	186	+   	202	1387
4670	89	186	+   	282	1387
4671	90	596	+   	202	0
4672	90	596	+   	327	0
4673	91	58	+   	202	1420
4674	91	58	+   	282	1420
4675	91	58	2a  	327	1420
4676	91	58	1   	337	1420
4677	91	58	1   	352	1420
4678	92	102	+   	202	1443
4679	92	102	+   	282	1443
4680	93	102	+   	327	1353
4681	93	102	+   	337	1353
4682	94	807	+   	202	0
4683	94	807	1   	282	0
4684	94	807	1   	327	0
4685	94	807	1   	337	0
4686	94	807	+   	352	0
4687	95	48	r   	282	1467
4688	96	237	+   	202	82
4689	96	237	1m  	282	82
4690	96	237	+   	327	82
4691	97	263	+   	282	0
4692	98	80	1m  	327	1338
4693	99	553	+   	327	0
4694	100	241	+   	327	0
4695	101	760	+   	327	0
4696	102	437	1m  	327	0
4697	102	437	1   	337	0
4698	102	437	1   	352	0
4699	103	530	1m  	327	1339
4700	104	496	+   	327	0
4701	105	204	+   	337	1499
4702	106	282	2b  	337	1521
4703	106	282	2a  	352	1521
4704	107	990	+   	337	1510
4705	108	124	1   	337	1528
4706	108	124	1   	352	1528
4707	109	517	1m  	337	0
4708	110	140	1m  	352	7
4709	111	102	1m  	352	18
4710	112	12	1m  	352	28
4711	113	304	1   	352	38
4712	114	517	1m  	352	49
4713	115	124	1   	352	60
4714	116	418	+   	352	0
4715	137	937	+   	381	0
4716	138	269	1m  	381	345
4717	139	287	2b  	350	0
4718	139	287	2b  	365	0
4719	139	287	2a  	381	0
4720	140	119	1m  	350	0
4721	140	119	+   	365	0
4722	141	375	+   	350	248
4723	141	375	+   	365	248
4724	142	48	+   	350	0
4725	142	48	1   	365	0
4726	142	48	+   	381	0
4727	143	829	1   	350	269
4728	143	829	1   	365	269
4729	143	829	+   	381	269
4730	144	130	1m  	350	209
4731	144	130	2a  	365	209
4732	145	1166	2a  	350	222
4733	145	1166	+   	365	222
4734	147	195	1   	350	253
4735	148	279	1m  	350	285
4736	148	279	+   	365	285
4737	148	279	+   	381	285
4738	149	210	2a  	350	286
4739	149	210	1m  	365	286
4740	150	1103	+   	350	297
4741	151	493	1m  	350	309
4742	151	493	1m  	365	309
4743	152	269	+   	350	323
4744	152	269	1m  	381	323
4745	153	141	+   	350	335
4746	154	144	+   	365	0
4747	154	144	1   	381	0
4748	155	394	+   	365	0
4749	156	482	1m  	350	0
4750	156	482	1m  	365	0
4751	157	356	+   	381	0
4752	158	184	+   	350	0
4753	158	184	+   	365	0
4754	159	437	+   	365	280
4755	159	437	1m  	381	280
4756	160	363	1   	381	341
4757	161	514	1m  	381	342
4758	162	141	1m  	381	0
4759	163	19	1m  	381	343
4760	164	286	+   	381	361
4761	165	188	1   	381	374
4762	166	490	1m  	381	401
4763	167	237	r   	381	417
4764	183	829	1   	391	514
4765	183	829	+   	203	514
4766	183	829	+   	221	514
4767	184	348	+   	391	543
4768	184	348	1   	203	543
4769	184	348	+   	221	543
4770	185	144	+   	391	0
4771	185	144	+   	203	0
4772	185	144	1   	221	0
4773	186	287	3   	391	0
4774	186	287	2b  	203	0
4775	186	287	2b  	221	0
4776	187	48	+   	391	0
4777	187	48	1   	203	0
4778	187	48	1   	221	0
4779	188	488	1m  	391	515
4780	188	488	1m  	203	515
4781	188	488	1m  	221	515
4782	189	178	2a  	391	566
4783	189	178	1   	203	566
4784	189	178	2a  	221	566
4785	191	79	1m  	391	516
4786	191	79	1m  	203	516
4787	191	79	1m  	221	516
4788	192	427	1   	391	551
4789	192	427	1   	203	551
4790	192	427	+   	221	551
4791	193	755	+   	391	0
4792	193	755	1   	203	0
4793	194	400	+   	391	513
4794	194	400	+   	203	513
4795	194	400	+   	221	513
4796	195	274	1m  	391	520
4797	195	274	1m  	203	520
4798	195	274	1m  	221	520
4799	196	1139	1m  	391	521
4800	196	1139	1m  	203	521
4801	196	1139	1m  	221	521
4802	197	146	1m  	391	524
4803	197	146	+   	203	524
4804	198	50	1m  	391	517
4805	198	50	1m  	203	517
4806	198	50	1m  	221	517
4807	199	231	1m  	391	525
4808	199	231	1m  	203	525
4809	199	231	1m  	221	525
4810	200	599	1m  	391	526
4811	200	599	1m  	203	526
4812	200	599	+   	221	526
4813	201	279	+   	391	528
4814	202	165	1   	391	529
4815	202	165	1   	203	529
4816	202	165	1   	221	529
4817	203	367	1m  	391	530
4818	203	367	1m  	203	530
4819	203	367	1m  	221	530
4820	204	31	1   	391	522
4821	204	31	1   	203	522
4822	204	31	1m  	221	522
4823	205	12	1m  	391	523
4824	205	12	1m  	203	523
4825	205	12	1m  	221	523
4826	206	336	+   	391	531
4827	206	336	+   	203	531
4828	207	356	1m  	391	532
4829	207	356	1m  	203	532
4830	207	356	1m  	221	532
4831	208	196	+   	391	535
4832	208	196	+   	203	535
4833	208	196	+   	221	535
4834	209	391	1m  	391	533
4835	209	391	+   	203	533
4836	209	391	+   	221	533
4837	210	269	1m  	391	0
4838	210	269	+   	203	0
4839	211	434	+   	391	536
4840	211	434	+   	203	536
4841	212	116	+   	391	537
4842	212	116	+   	203	537
4843	212	116	+   	221	537
4844	213	529	r   	391	538
4845	214	514	1m  	391	540
4846	215	488	r   	391	542
4847	216	482	1m  	391	544
4848	216	482	1m  	203	544
4849	216	482	1m  	221	544
4850	217	2144	+   	221	545
4851	218	243	+   	203	546
4852	218	243	1m  	221	546
4853	224	287	3   	222	0
4854	224	287	2b  	235	0
4855	225	195	3   	222	265
4856	225	195	1   	235	265
4857	226	427	+   	222	0
4858	226	427	2a  	235	0
4859	227	529	+   	222	0
4860	228	937	+   	222	0
4861	228	937	1   	235	0
4862	229	246	1m  	222	0
4863	229	246	1m  	235	0
4864	230	593	1m  	222	0
4865	230	593	1m  	235	0
4866	231	431	1m  	222	552
4867	231	431	1m  	235	552
4868	232	50	1m  	222	0
4869	232	50	1m  	235	0
4870	233	492	1m  	222	553
4871	233	492	1   	235	553
4872	234	253	1m  	222	555
4873	234	253	+   	235	555
4874	235	269	+   	222	554
4875	236	269	1m  	222	0
4876	236	269	+   	235	0
4877	237	443	1m  	222	557
4878	237	443	+   	235	557
4879	238	514	1m  	222	541
4880	239	132	1   	222	558
4881	239	132	1m  	235	558
4882	240	303	1m  	222	559
4883	240	303	1m  	235	559
4884	241	599	+   	222	0
4885	241	599	+   	235	0
4886	242	568	1m  	222	560
4887	243	12	1m  	222	561
4888	243	12	1m  	235	561
4889	244	1166	1m  	222	562
4890	244	1166	1m  	235	562
4891	245	116	+   	222	564
4892	245	116	+   	235	564
4893	246	165	1   	235	0
4894	247	31	2b  	235	0
4895	248	178	1   	235	0
4896	275	287	2b  	268	0
4897	276	716	1   	268	0
4898	277	48	1   	268	0
4899	278	570	1m  	268	0
4900	279	9	1m  	268	583
4901	280	195	+   	268	584
4902	281	104	+   	268	585
4903	282	363	+   	268	586
4904	283	269	1m  	268	0
4905	284	279	+   	268	587
4906	285	514	1m  	268	589
4907	286	445	+   	268	590
4908	287	196	+   	268	591
4909	288	156	2a  	268	593
4910	289	356	1m  	268	0
4911	290	178	+   	268	594
4912	291	116	+   	268	0
4913	292	175	+   	268	595
4914	293	522	r   	268	596
4915	294	577	r   	268	597
4916	295	514	r   	268	598
4917	296	937	1   	268	0
4918	297	375	r   	268	599
4919	303	324	+   	275	606
4920	304	829	2a  	274	607
4921	304	829	+   	275	607
4922	305	56	2a  	274	609
4923	305	56	2a  	275	609
4924	307	195	+   	274	266
4925	307	195	1   	275	266
4926	308	184	1   	274	632
4927	308	184	1   	275	632
4928	309	30	1m  	274	625
4929	309	30	1m  	275	625
4930	310	21	3   	274	627
4931	311	17	2a  	274	623
4932	312	12	1m  	274	621
4933	313	510	1m  	275	643
4934	314	526	+   	275	646
4935	315	236	+   	275	0
4936	316	363	1m  	274	613
4937	317	429	+   	275	647
4938	318	389	1   	274	610
4939	319	394	1m  	274	611
4940	320	437	+   	274	628
4941	321	319	1   	275	649
4942	322	320	a   	274	0
4943	322	320	1m  	275	0
4944	323	492	1   	275	652
4945	324	278	r   	275	681
4946	325	412	1   	274	618
4947	326	130	+   	274	617
4948	326	130	+   	275	617
4949	327	302	1m  	274	631
4950	327	302	1m  	275	631
4951	328	273	+   	274	633
4952	329	408	+   	274	636
4953	329	408	+   	275	636
4954	330	336	+   	274	638
4955	331	412	1   	275	619
4956	332	48	+   	274	0
4957	333	287	r   	274	0
4958	333	287	1   	275	0
4959	334	829	1   	274	640
4960	335	496	a   	274	0
4961	335	496	+   	275	0
4962	336	20	3   	275	641
4963	337	19	1   	275	642
4964	338	286	+   	275	0
4965	339	50	1m  	275	519
4966	340	94	1m  	275	648
4967	341	279	1   	275	588
4968	342	536	+   	275	650
4969	343	366	+   	277	676
4970	344	17	3   	276	624
4971	344	17	4   	277	624
4972	345	12	1   	276	622
4973	345	12	2a  	277	622
4974	346	619	2a  	276	653
4975	346	619	1   	277	653
4976	347	234	2b  	276	654
4977	347	234	1   	277	654
4978	348	496	1   	276	661
4979	348	496	2a  	277	661
4980	349	394	1m  	276	612
4981	349	394	+   	277	612
4982	350	389	+   	277	0
4983	351	214	+   	276	659
4984	351	214	+   	277	659
4985	352	829	+   	276	608
4986	352	829	+   	277	608
4987	353	829	1   	276	655
4988	353	829	1   	277	655
4989	354	490	1m  	276	662
4990	354	490	+   	277	662
4991	355	937	1m  	276	0
4992	355	937	+   	277	0
4993	356	573	+   	276	660
4994	357	481	1   	276	656
4995	358	26	1m  	276	665
4996	358	26	1m  	277	665
4997	359	17	+   	276	658
4998	360	363	+   	276	615
4999	361	130	+   	276	0
5000	362	184	+   	276	0
5001	363	214	r   	276	664
5002	364	245	a   	276	667
5003	364	245	+   	277	667
5004	365	366	+   	276	668
5005	366	434	1m  	277	669
5006	367	166	1   	277	673
5007	368	573	+   	277	674
5008	369	243	+   	277	675
5009	370	794	r   	291	570
5010	371	470	+   	291	695
5011	372	17	3   	278	0
5012	372	17	3   	283	0
5013	372	17	2b  	291	0
5014	373	30	2b  	278	626
5015	373	30	1   	291	626
5016	374	19	1   	278	0
5017	375	469	2a  	278	657
5018	376	26	1   	291	666
5019	377	287	+   	283	0
5020	377	287	+   	291	0
5021	378	195	+   	278	0
5022	379	829	+   	278	0
5023	379	829	+   	283	0
5024	379	829	+   	291	0
5025	380	829	+   	283	0
5026	380	829	r   	291	0
5027	381	56	1   	283	0
5028	381	56	1   	291	0
5029	382	184	1   	283	0
5030	382	184	1   	291	0
5031	383	236	1m  	278	685
5032	384	302	1m  	278	630
5033	385	363	1m  	278	616
5034	385	363	1   	283	616
5035	385	363	1m  	291	616
5036	386	434	+   	278	671
5037	387	394	1m  	283	573
5038	387	394	1m  	291	573
5039	388	389	+   	278	0
5040	388	389	+   	283	0
5041	388	389	+   	291	0
5042	389	496	1   	283	0
5043	389	496	+   	291	0
5044	390	489	1m  	278	683
5045	390	489	+   	283	683
5046	390	489	1m  	291	683
5047	391	319	1   	278	682
5048	392	279	1m  	278	0
5049	392	279	1m  	291	0
5050	393	336	1   	278	639
5051	394	50	1   	278	0
5052	395	137	1m  	291	697
5053	396	524	+   	291	696
5054	397	429	+   	278	688
5055	397	429	+   	283	688
5056	397	429	1   	291	688
5057	398	65	+   	278	686
5058	399	281	+   	278	0
5059	399	281	r   	283	0
5060	400	412	+   	278	620
5061	400	412	+   	283	620
5062	401	510	1m  	278	644
5063	402	526	1m  	278	0
5064	402	526	+   	283	0
5065	402	526	+   	291	0
5066	403	219	1m  	283	0
5067	403	219	+   	291	0
5068	404	119	+   	283	693
5069	405	320	1m  	283	334
5070	406	524	+   	283	694
5071	407	273	+   	283	634
5072	408	358	+   	283	692
5073	408	358	+   	291	692
5074	409	363	+   	291	701
5075	410	522	a   	291	0
5076	411	570	+   	291	0
5077	412	137	r   	291	698
5078	413	273	1m  	291	699
5079	414	166	+   	291	0
5080	415	288	+   	291	0
5081	417	394	1m  	300	0
5082	418	17	2b  	300	0
5083	419	937	1m  	300	0
5084	420	375	+   	300	0
5085	421	184	1   	300	0
5086	422	829	1   	300	0
5087	423	56	2a  	300	0
5088	424	26	1m  	300	0
5089	425	794	+   	300	0
5090	426	195	+   	300	0
5091	427	287	+   	300	0
5092	428	286	+   	300	0
5093	429	48	1   	300	0
5094	430	30	1m  	300	0
5095	431	273	+   	300	0
5096	432	130	+   	300	0
5097	433	829	+   	300	0
5098	434	166	1m  	300	0
5099	435	408	+   	300	635
5100	436	245	r   	300	0
5101	437	367	1m  	300	687
5102	438	119	+   	300	0
5103	439	429	+   	300	0
5104	440	496	r   	300	0
5105	441	214	+   	300	0
5106	442	195	+   	311	0
5107	443	190	2a  	311	700
5108	444	287	2a  	311	0
5109	445	17	1   	311	0
5110	446	30	+   	311	0
5111	447	348	+   	311	0
5112	448	242	+   	311	722
5113	449	937	1m  	311	0
5114	450	138	1m  	311	706
5115	451	599	1m  	311	707
5116	452	178	+   	311	0
5117	453	336	+   	311	0
5118	454	48	1   	311	0
5119	455	253	1m  	311	712
5120	456	166	1m  	311	0
5121	457	79	1m  	311	710
5122	458	537	+   	311	717
5123	459	196	+   	311	714
5124	460	132	1m  	311	720
5125	461	454	1m  	311	703
5126	462	443	1m  	311	716
5127	463	119	1m  	311	0
5128	464	408	+   	311	715
5129	465	584	1m  	311	0
5130	466	269	1m  	311	709
5131	467	434	+   	311	0
5132	469	592	+   	311	711
5133	470	380	+   	311	718
5134	471	104	+   	311	719
5135	472	109	+   	311	721
5136	490	30	+   	206	747
5137	491	17	2b  	206	0
5138	491	17	2b  	217	0
5139	492	937	1   	206	731
5140	492	937	1   	217	731
5141	493	269	1m  	206	0
5142	493	269	+   	217	0
5143	494	429	1   	206	689
5144	494	429	+   	217	689
5145	495	48	1   	206	0
5146	495	48	+   	217	0
5147	496	176	a   	206	0
5148	497	279	1m  	206	0
5149	497	279	1m  	217	0
5150	498	277	r   	206	0
5151	498	277	a   	217	0
5152	499	416	+   	206	732
5153	499	416	1m  	217	732
5154	500	100	1m  	206	733
5155	500	100	1m  	217	733
5156	501	163	+   	206	734
5157	501	163	+   	217	734
5158	502	262	+   	206	736
5159	502	262	+   	217	736
5160	503	12	1m  	206	764
5161	503	12	+   	217	764
5162	504	829	+   	206	738
5163	504	829	+   	217	738
5164	505	490	+   	206	739
5165	505	490	+   	217	739
5166	506	144	+   	206	0
5167	506	144	+   	217	0
5168	507	304	+   	206	740
5169	507	304	1m  	217	740
5170	508	489	+   	206	684
5171	508	489	1m  	217	684
5172	509	356	+   	206	741
5173	509	356	+   	217	741
5174	510	123	+   	206	742
5175	510	123	+   	217	742
5176	511	510	+   	206	0
5177	512	79	+   	206	0
5178	512	79	+   	217	0
5179	513	195	+   	206	267
5180	513	195	+   	217	267
5181	514	45	1   	206	744
5182	514	45	+   	217	744
5183	515	363	+   	206	745
5184	515	363	+   	217	745
5185	516	756	+   	206	746
5186	516	756	+   	217	746
5187	517	19	+   	206	0
5188	517	19	+   	217	0
5189	518	794	+   	206	0
5190	518	794	+   	217	0
5191	519	167	1   	206	0
5192	519	167	+   	217	0
5193	520	30	+   	217	0
5194	521	177	+   	217	755
5195	522	393	1m  	217	756
5196	523	990	+   	217	737
5197	524	363	+   	217	757
5198	525	184	1   	206	0
5199	525	184	1   	217	0
5200	526	286	r   	217	758
5201	527	26	+   	217	754
5202	529	1104	+   	318	752
5203	529	1104	+   	324	752
5204	529	1104	2a  	325	752
5205	530	168	+   	318	0
5206	531	937	+   	318	0
5207	531	937	+   	324	0
5208	531	937	1m  	325	0
5209	532	510	+   	318	0
5210	532	510	+   	324	0
5211	532	510	+   	325	0
5212	533	73	+   	318	0
5213	534	429	+   	318	761
5214	534	429	1m  	324	761
5215	534	429	1   	325	761
5216	535	416	1m  	318	0
5217	535	416	1m  	324	0
5218	536	149	+   	318	0
5219	537	17	1   	318	0
5220	537	17	1   	324	0
5221	537	17	1   	325	0
5222	538	318	+   	318	0
5223	539	269	1m  	318	0
5224	540	279	1m  	318	0
5225	540	279	1m  	324	0
5226	540	279	1m  	325	0
5227	541	262	+   	318	735
5228	541	262	+   	324	735
5229	542	829	+   	318	0
5230	542	829	+   	325	0
5231	543	348	+   	318	0
5232	543	348	+   	325	0
5233	544	48	+   	318	0
5234	544	48	1   	324	0
5235	544	48	+   	325	0
5236	545	116	1m  	318	0
5237	545	116	1m  	324	0
5238	545	116	+   	325	0
5239	546	366	1m  	318	0
5240	546	366	+   	325	0
5241	547	363	1m  	318	0
5242	547	363	1m  	324	0
5243	547	363	+   	325	0
5244	548	756	+   	318	770
5245	548	756	+   	324	770
5246	548	756	+   	325	770
5247	549	100	1m  	318	0
5248	549	100	1m  	324	0
5249	549	100	1m  	325	0
5250	550	1100	r   	318	769
5251	550	1100	+   	324	769
5252	551	163	+   	318	768
5253	551	163	+   	324	768
5254	551	163	+   	325	768
5255	552	495	1m  	318	767
5256	552	495	1m  	325	767
5257	553	123	1m  	318	0
5258	553	123	1m  	324	0
5259	553	123	1m  	325	0
5260	554	144	+   	318	0
5261	554	144	+   	324	0
5262	554	144	+   	325	0
5263	556	19	1m  	318	0
5264	556	19	+   	324	0
5265	557	100	+   	318	771
5266	558	15	+   	318	753
5267	559	26	+   	318	0
5268	559	26	+   	324	0
5269	560	904	+   	324	766
5270	561	356	1m  	324	0
5271	562	794	+   	324	0
5272	562	794	+   	325	0
5273	563	184	+   	324	0
5274	564	489	1m  	324	762
5275	565	290	1m  	325	763
5276	566	456	+   	324	0
5277	566	456	+   	325	0
5278	567	1165	+   	324	759
5279	572	329	+   	329	820
5280	573	17	3   	326	787
5281	573	17	3   	328	787
5282	573	17	4   	329	787
5283	574	427	2a  	326	0
5284	574	427	2a  	328	0
5285	574	427	1   	329	0
5286	575	213	+   	326	781
5287	575	213	+   	328	781
5288	576	829	2a  	326	798
5289	576	829	2a  	328	798
5290	577	829	1   	329	818
5291	578	570	1m  	326	0
5292	578	570	+   	328	0
5293	579	389	+   	326	0
5294	579	389	+   	328	0
5295	579	389	+   	329	0
5296	580	394	1m  	326	873
5297	580	394	1m  	328	873
5298	580	394	+   	329	873
5299	581	184	1   	326	782
5300	581	184	1   	328	782
5301	582	324	1   	326	786
5302	582	324	1   	328	786
5303	582	324	1   	329	786
5304	583	290	1m  	326	783
5305	583	290	+   	329	783
5306	584	969	+   	326	785
5307	584	969	+   	329	785
5308	585	125	1   	326	779
5309	585	125	+   	328	779
5310	586	969	1m  	326	777
5311	586	969	+   	329	777
5312	587	269	1m  	326	776
5313	587	269	1m  	328	776
5314	587	269	1m  	329	776
5315	588	388	+   	326	0
5316	588	388	1   	328	0
5317	588	388	1   	329	0
5318	589	363	1m  	326	780
5319	589	363	1m  	328	780
5320	589	363	1m  	329	780
5321	590	279	1m  	326	791
5322	590	279	1m  	328	791
5323	590	279	1m  	329	791
5324	591	213	r   	326	790
5325	592	79	1m  	326	789
5326	592	79	1m  	328	789
5327	593	510	+   	326	793
5328	593	510	a   	328	793
5329	594	30	+   	326	792
5330	594	30	+   	328	792
5331	595	21	1   	326	788
5332	596	12	1m  	326	795
5333	597	11	1m  	326	794
5334	598	348	+   	329	819
5335	599	56	a   	326	0
5336	600	434	+   	326	0
5337	600	434	+   	328	0
5338	600	434	+   	329	0
5339	601	550	+   	326	796
5340	602	412	1m  	326	797
5341	603	490	1m  	328	799
5342	604	195	+   	328	800
5343	605	116	1m  	328	808
5344	606	167	1m  	328	0
5345	607	206	+   	328	802
5346	608	213	r   	326	803
5347	608	213	+   	328	803
5348	609	504	+   	329	804
5349	610	498	1   	328	805
5350	611	937	+   	328	821
5351	611	937	1   	329	821
5352	612	236	+   	328	806
5353	613	829	+   	328	0
5354	613	829	+   	329	0
5355	614	363	+   	329	817
5356	615	304	1m  	329	809
5357	616	115	r   	329	811
5358	617	115	+   	329	812
5359	618	492	1m  	329	813
5360	619	184	1m  	329	815
5361	620	356	r   	329	810
5362	621	123	+   	329	814
5363	622	208	a   	329	816
5364	623	549	r   	332	845
5365	624	427	+   	330	0
5366	624	427	1   	331	0
5367	624	427	1   	332	0
5368	624	427	1   	333	0
5369	624	427	1   	334	0
5370	625	829	2a  	330	0
5371	625	829	+   	331	0
5372	625	829	+   	332	0
5373	625	829	1   	333	0
5374	625	829	+   	334	0
5375	626	829	+   	330	0
5376	626	829	+   	331	0
5377	626	829	+   	332	0
5378	626	829	+   	333	0
5379	626	829	+   	334	0
5380	627	324	1   	330	0
5381	627	324	+   	332	0
5382	627	324	1   	333	0
5383	627	324	r   	334	0
5384	628	329	+   	330	0
5385	629	144	r   	330	0
5386	630	184	1   	330	0
5387	630	184	+   	331	0
5388	631	184	+   	330	0
5389	631	184	+   	332	0
5390	631	184	+   	333	0
5391	631	184	+   	334	0
5392	632	937	+   	330	0
5393	632	937	1m  	331	0
5394	632	937	1m  	332	0
5395	632	937	+   	333	0
5396	632	937	1m  	334	0
5397	633	323	r   	330	822
5398	634	236	+   	330	0
5399	635	279	1m  	330	0
5400	635	279	1m  	331	0
5401	635	279	1m  	332	0
5402	635	279	1m  	333	0
5403	635	279	1m  	334	0
5404	636	195	+   	333	0
5405	637	17	2b  	330	0
5406	637	17	4   	331	0
5407	637	17	4   	332	0
5408	637	17	3   	333	0
5409	637	17	4   	334	0
5410	638	26	+   	331	844
5411	638	26	1m  	332	844
5412	638	26	+   	334	844
5413	639	21	1   	330	0
5414	639	21	1   	331	0
5415	639	21	+   	332	0
5416	639	21	+   	333	0
5417	639	21	1   	334	0
5418	640	12	1m  	330	0
5419	640	12	1m  	331	0
5420	640	12	1m  	332	0
5421	640	12	1m  	333	0
5422	640	12	1m  	334	0
5423	641	30	1m  	330	0
5424	641	30	1m  	333	0
5425	641	30	+   	334	0
5426	642	11	1m  	330	0
5427	642	11	+   	332	0
5428	642	11	+   	333	0
5429	642	11	+   	334	0
5430	643	304	+   	332	0
5431	643	304	+   	333	0
5432	643	304	+   	334	0
5433	644	394	1m  	330	0
5434	644	394	+   	331	0
5435	644	394	1m  	333	0
5436	645	490	1m  	330	0
5437	645	490	1m  	332	0
5438	645	490	1m  	333	0
5439	645	490	1m  	334	0
5440	646	491	+   	330	832
5441	646	491	a   	333	832
5442	647	213	+   	330	0
5443	647	213	+   	332	0
5444	648	125	+   	333	0
5445	649	290	1m  	330	0
5446	649	290	+   	332	0
5447	649	290	1m  	333	0
5448	649	290	+   	334	0
5449	650	399	1m  	330	823
5450	650	399	1m  	331	823
5451	650	399	1m  	332	823
5452	650	399	+   	334	823
5453	651	412	1m  	330	0
5454	651	412	2a  	331	0
5455	651	412	1m  	332	0
5456	651	412	+   	334	0
5457	652	380	+   	330	842
5458	652	380	+   	331	842
5459	652	380	+   	332	842
5460	652	380	1m  	333	842
5461	652	380	+   	334	842
5462	653	389	1   	330	0
5463	653	389	+   	331	0
5464	653	389	+   	332	0
5465	653	389	+   	333	0
5466	653	389	+   	334	0
5467	654	388	+   	330	0
5468	654	388	+   	331	0
5469	654	388	+   	332	0
5470	654	388	+   	333	0
5471	654	388	+   	334	0
5472	655	363	1m  	331	0
5473	655	363	1m  	332	0
5474	655	363	1m  	333	0
5475	655	363	+   	334	0
5476	656	363	+   	331	0
5477	656	363	+   	332	0
5478	656	363	+   	333	0
5479	656	363	+   	334	0
5480	657	79	1m  	333	0
5481	658	664	+   	330	0
5482	659	269	1m  	330	0
5483	659	269	1m  	331	0
5484	659	269	1m  	332	0
5485	659	269	1m  	333	0
5486	659	269	1m  	334	0
5487	660	161	+   	330	824
5488	661	119	+   	330	825
5489	662	429	+   	330	826
5490	663	81	+   	330	0
5491	663	81	1m  	331	0
5492	663	81	1m  	332	0
5493	663	81	+   	334	0
5494	664	526	+   	330	0
5495	665	94	+   	330	827
5496	666	510	+   	330	0
5497	666	510	+   	332	0
5498	666	510	+   	333	0
5499	667	524	+   	330	829
5500	667	524	+   	331	829
5501	667	524	+   	332	829
5502	667	524	+   	333	829
5503	667	524	+   	334	829
5504	668	356	+   	330	0
5505	668	356	+   	331	0
5506	668	356	+   	333	0
5507	668	356	+   	334	0
5508	669	213	1   	331	0
5509	669	213	1   	332	0
5510	669	213	1m  	333	0
5511	669	213	1   	334	0
5512	670	214	1m  	330	830
5513	671	756	+   	330	831
5514	671	756	+   	331	831
5515	671	756	+   	332	831
5516	671	756	1   	334	831
5517	672	113	+   	331	834
5518	673	113	+   	332	835
5519	673	113	1m  	333	835
5520	673	113	+   	334	835
5521	674	114	+   	330	833
5522	675	1110	+   	330	840
5523	675	1110	+   	331	840
5524	675	1110	+   	332	840
5525	675	1110	r   	333	840
5526	675	1110	+   	334	840
5527	676	213	1m  	331	841
5528	676	213	1m  	332	841
5529	676	213	+   	333	841
5530	676	213	1   	334	841
5531	677	550	1m  	331	0
5532	677	550	+   	332	0
5533	677	550	+   	334	0
5534	678	544	+   	331	871
5535	678	544	+   	332	871
5536	678	544	+   	334	871
5537	679	167	+   	331	0
5538	679	167	+   	332	0
5539	679	167	+   	333	0
5540	679	167	+   	334	0
5541	685	30	1m  	335	0
5542	685	30	+   	252	0
5543	686	17	3   	335	0
5544	686	17	3   	336	0
5545	686	17	2b  	252	0
5546	686	17	2a  	338	0
5547	687	21	1m  	336	0
5548	687	21	1   	252	0
5549	687	21	1   	338	0
5550	688	19	1m  	335	0
5551	688	19	+   	336	0
5552	688	19	+   	252	0
5553	689	26	+   	336	0
5554	689	26	+   	252	0
5555	689	26	1   	338	0
5556	690	12	1m  	335	0
5557	690	12	1m  	336	0
5558	690	12	1m  	252	0
5559	690	12	1m  	338	0
5560	691	11	+   	252	0
5561	691	11	+   	338	0
5562	692	348	2a  	336	0
5563	692	348	2b  	252	0
5564	692	348	2a  	338	0
5565	693	829	1   	335	0
5566	693	829	+   	336	0
5567	693	829	1   	252	0
5568	693	829	1   	338	0
5569	694	829	+   	335	0
5570	694	829	+   	252	0
5571	695	324	1   	335	0
5572	695	324	1   	336	0
5573	695	324	+   	252	0
5574	695	324	+   	338	0
5575	696	427	1   	335	0
5576	696	427	2a  	336	0
5577	696	427	1   	252	0
5578	696	427	2a  	338	0
5579	697	184	+   	336	0
5580	698	184	+   	336	0
5581	698	184	1   	252	0
5582	698	184	+   	338	0
5583	699	937	+   	335	0
5584	699	937	1m  	336	0
5585	699	937	+   	252	0
5586	699	937	1m  	338	0
5587	700	388	+   	335	0
5588	700	388	+   	336	0
5589	700	388	+   	252	0
5590	700	388	+   	338	0
5591	701	389	+   	335	0
5592	701	389	+   	336	0
5593	701	389	+   	252	0
5594	701	389	+   	338	0
5595	702	394	+   	335	0
5596	702	394	+   	252	0
5597	702	394	+   	338	0
5598	703	969	+   	335	0
5599	704	195	1   	335	0
5600	704	195	+   	336	0
5601	704	195	+   	252	0
5602	705	490	1m  	335	0
5603	705	490	1m  	336	0
5604	705	490	+   	252	0
5605	706	491	+   	336	0
5606	706	491	1m  	252	0
5607	706	491	1m  	338	0
5608	707	399	1m  	336	0
5609	707	399	1m  	252	0
5610	707	399	1m  	338	0
5611	708	412	+   	335	0
5612	708	412	1m  	336	0
5613	708	412	+   	252	0
5614	709	113	+   	336	0
5615	710	290	+   	335	0
5616	710	290	1m  	336	0
5617	710	290	1m  	252	0
5618	710	290	1m  	338	0
5619	711	363	+   	335	0
5620	711	363	+   	336	0
5621	712	363	+   	338	0
5622	713	269	1m  	335	0
5623	713	269	1m  	336	0
5624	713	269	1m  	252	0
5625	713	269	1m  	338	0
5626	714	380	+   	336	0
5627	714	380	+   	338	0
5628	715	236	+   	335	0
5629	715	236	+   	336	0
5630	716	79	+   	335	0
5631	716	79	+   	336	0
5632	716	79	1m  	252	0
5633	716	79	1m  	338	0
5634	717	81	+   	335	0
5635	717	81	+   	338	0
5636	718	526	+   	335	0
5637	719	524	+   	335	0
5638	720	510	+   	336	0
5639	720	510	+   	252	0
5640	721	213	+   	335	0
5641	721	213	+   	252	0
5642	721	213	+   	338	0
5643	722	434	+   	335	0
5644	723	114	+   	335	846
5645	724	391	+   	335	0
5646	724	391	+   	336	0
5647	724	391	1   	252	0
5648	724	391	+   	338	0
5649	725	429	1   	335	0
5650	726	421	a   	335	0
5651	727	356	+   	336	0
5652	728	522	+   	336	0
5653	729	213	+   	335	0
5654	729	213	1m  	336	0
5655	729	213	1   	252	0
5656	729	213	1   	338	0
5657	730	214	1m  	335	0
5658	731	213	+   	335	0
5659	731	213	1m  	336	0
5660	731	213	1m  	252	0
5661	731	213	+   	338	0
5662	732	279	+   	335	0
5663	732	279	1m  	336	0
5664	732	279	1m  	252	0
5665	732	279	1m  	338	0
5666	733	218	r   	252	0
5667	734	756	+   	338	0
5668	735	21	1m  	341	875
5669	735	21	1m  	342	875
5670	735	21	1m  	348	875
5671	736	904	1m  	344	920
5672	736	904	+   	346	920
5673	736	904	+   	347	920
5674	737	17	2b  	339	849
5675	737	17	2b  	340	849
5676	737	17	4   	341	849
5677	737	17	4   	342	849
5678	737	17	3   	343	849
5679	738	30	a   	339	876
5680	738	30	1m  	341	876
5681	738	30	1m  	342	876
5682	738	30	+   	343	876
5683	739	470	+   	339	853
5684	739	470	1m  	341	853
5685	739	470	1m  	342	853
5686	739	470	+   	343	853
5687	739	470	2a  	348	853
5688	740	26	1m  	341	878
5689	740	26	1m  	342	878
5690	740	26	1m  	343	878
5691	741	12	a   	339	880
5692	741	12	1m  	341	880
5693	741	12	1m  	342	880
5694	741	12	1m  	343	880
5695	741	12	1m  	344	880
5696	741	12	+   	345	880
5697	741	12	1m  	346	880
5698	741	12	1m  	347	880
5699	741	12	1m  	348	880
5700	742	11	+   	342	0
5701	743	337	+   	341	868
5702	743	337	1m  	342	868
5703	743	337	1m  	343	868
5704	743	337	1m  	344	868
5705	743	337	1m  	346	868
5706	743	337	1m  	347	868
5707	743	337	1m  	348	868
5708	744	829	+   	339	913
5709	744	829	+   	341	913
5710	744	829	+   	342	913
5711	744	829	+   	343	913
5712	744	829	+   	344	913
5713	744	829	+   	345	913
5714	744	829	+   	347	913
5715	744	829	1   	348	913
5716	745	829	+   	344	0
5717	745	829	+   	346	0
5718	745	829	+   	347	0
5719	745	829	+   	348	0
5720	746	324	+   	339	0
5721	746	324	+   	340	0
5722	746	324	1   	343	0
5723	746	324	+   	348	0
5724	747	427	1   	339	0
5725	747	427	1   	340	0
5726	747	427	1   	341	0
5727	747	427	+   	342	0
5728	747	427	1   	343	0
5729	747	427	+   	344	0
5730	747	427	+   	345	0
5731	747	427	+   	346	0
5732	747	427	+   	348	0
5733	748	184	1   	339	0
5734	748	184	1   	340	0
5735	748	184	+   	342	0
5736	748	184	1   	343	0
5737	748	184	+   	348	0
5738	749	184	+   	340	906
5739	749	184	1   	341	906
5740	749	184	+   	342	906
5741	749	184	1   	343	906
5742	749	184	+   	344	906
5743	750	195	1   	341	0
5744	750	195	1   	342	0
5745	750	195	+   	343	0
5746	750	195	4   	344	0
5747	750	195	+   	345	0
5748	750	195	4   	346	0
5749	750	195	2a  	347	0
5750	751	161	1   	339	0
5751	751	161	1   	340	0
5752	752	156	a   	339	862
5753	752	156	+   	342	862
5754	752	156	1   	344	862
5755	752	156	+   	345	862
5756	752	156	1   	346	862
5757	752	156	1   	347	862
5758	752	156	1   	348	862
5759	753	234	+   	341	883
5760	753	234	+   	342	883
5761	753	234	1   	343	883
5762	753	234	1   	348	883
5763	754	388	+   	339	0
5764	754	388	+   	340	0
5765	754	388	+   	341	0
5766	754	388	+   	343	0
5767	754	388	+   	344	0
5768	754	388	+   	345	0
5769	754	388	+   	346	0
5770	755	389	+   	341	0
5771	755	389	+   	343	0
5772	756	394	1m  	341	874
5773	756	394	+   	342	874
5774	756	394	1m  	343	874
5775	756	394	+   	348	874
5776	757	414	1m  	343	889
5777	758	218	+   	339	861
5778	759	490	1m  	339	0
5779	759	490	+   	341	0
5780	759	490	1m  	342	0
5781	759	490	1m  	343	0
5782	759	490	+   	344	0
5783	760	498	+   	339	851
5784	760	498	+   	340	851
5785	760	498	+   	342	851
5786	760	498	+   	344	851
5787	760	498	+   	346	851
5788	760	498	1m  	347	851
5789	760	498	1m  	348	851
5790	761	167	+   	339	0
5791	761	167	+   	340	0
5792	761	167	1m  	348	0
5793	762	276	+   	339	859
5794	763	363	+   	343	0
5795	763	363	+   	344	0
5796	763	363	+   	346	0
5797	763	363	+   	348	0
5798	764	363	+   	342	0
5799	764	363	+   	343	0
5800	764	363	+   	344	0
5801	765	279	1m  	339	911
5802	765	279	1m  	340	911
5803	765	279	1m  	344	911
5804	765	279	+   	346	911
5805	766	302	+   	339	857
5806	766	302	1m  	340	857
5807	766	302	1m  	341	857
5808	766	302	+   	342	857
5809	766	302	+   	343	857
5810	766	302	1m  	344	857
5811	766	302	1m  	345	857
5812	766	302	1m  	346	857
5813	766	302	1m  	347	857
5814	766	302	+   	348	857
5815	767	269	1m  	339	0
5816	767	269	1m  	340	0
5817	767	269	1m  	341	0
5818	767	269	1m  	342	0
5819	767	269	1m  	343	0
5820	767	269	1m  	344	0
5821	767	269	1m  	346	0
5822	767	269	1m  	348	0
5823	768	356	1m  	339	854
5824	768	356	+   	340	854
5825	768	356	+   	342	854
5826	769	213	1m  	339	0
5827	769	213	+   	343	0
5828	769	213	+   	346	0
5829	770	937	+   	339	0
5830	770	937	1m  	340	0
5831	770	937	+   	341	0
5832	770	937	+   	342	0
5833	770	937	1m  	344	0
5834	770	937	1m  	345	0
5835	770	937	1m  	346	0
5836	770	937	1m  	347	0
5837	770	937	+   	348	0
5838	771	522	r   	339	858
5839	772	526	+   	339	852
5840	772	526	+   	340	852
5841	773	511	1m  	343	903
5842	774	509	r   	339	856
5843	774	509	1m  	340	856
5844	775	287	+   	341	0
5845	775	287	1m  	342	0
5846	775	287	3   	347	0
5847	775	287	2a  	348	0
5848	776	288	1m  	339	855
5849	776	288	1m  	340	855
5850	776	288	+   	343	855
5851	777	290	+   	340	0
5852	778	429	+   	339	0
5853	778	429	+   	343	0
5854	779	218	a   	339	0
5855	780	550	+   	340	0
5856	781	125	+   	339	0
5857	781	125	1   	340	0
5858	782	133	1m  	341	881
5859	782	133	1m  	342	881
5860	783	236	1m  	339	938
5861	783	236	+   	341	938
5862	783	236	+   	342	938
5863	783	236	+   	343	938
5864	783	236	+   	344	938
5865	783	236	+   	346	938
5866	785	94	+   	339	860
5867	786	664	a   	339	0
5868	787	1102	a   	340	866
5869	787	1102	+   	341	866
5870	787	1102	+   	342	866
5871	787	1102	+   	343	866
5872	788	599	1m  	341	867
5873	788	599	1m  	342	867
5874	788	599	1m  	348	867
5875	789	434	+   	340	864
5876	789	434	+   	341	864
5877	789	434	1m  	342	864
5878	789	434	1m  	343	864
5879	790	436	+   	342	865
5880	790	436	1m  	343	865
5881	790	436	1m  	348	865
5882	791	504	+   	344	908
5883	791	504	+   	346	908
5884	791	504	+   	348	908
5885	792	130	r   	341	884
5886	792	130	+   	342	884
5887	792	130	+   	343	884
5888	792	130	+   	344	884
5889	793	243	+   	341	869
5890	793	243	+   	342	869
5891	793	243	+   	344	869
5892	793	243	+   	346	869
5893	794	573	1m  	344	921
5894	794	573	1m  	346	921
5895	795	213	+   	339	848
5896	796	573	1m  	341	872
5897	796	573	+   	342	872
5898	797	103	1m  	344	891
5899	797	103	1m  	346	891
5900	797	103	1m  	347	891
5901	797	103	1m  	348	891
5902	798	245	1   	341	870
5903	798	245	1m  	342	870
5904	798	245	+   	347	870
5905	798	245	+   	348	870
5906	799	544	1m  	341	0
5907	799	544	1m  	342	0
5908	800	380	1m  	339	843
5909	800	380	1m  	340	843
5910	800	380	1m  	341	843
5911	800	380	1m  	342	843
5912	800	380	1m  	343	843
5913	800	380	1m  	347	843
5914	800	380	1m  	348	843
5915	801	69	1m  	346	917
5916	802	54	+   	344	918
5917	802	54	1m  	345	918
5918	802	54	+   	346	918
5919	803	348	+   	344	916
5920	803	348	+   	346	916
5921	804	115	+   	341	885
5922	804	115	1m  	342	885
5923	805	178	a   	342	886
5924	805	178	a   	344	886
5925	805	178	+   	346	886
5926	805	178	1   	347	886
5927	805	178	1   	348	886
5928	806	198	+   	344	887
5929	806	198	+   	346	887
5930	806	198	1m  	348	887
5931	807	552	+   	348	892
5932	808	300	a   	339	0
5933	808	300	a   	340	0
5934	809	197	a   	341	893
5935	809	197	r   	342	893
5936	810	18	a   	341	894
5937	810	18	a   	342	894
5938	811	56	2a  	343	0
5939	812	434	+   	343	899
5940	813	242	+   	343	900
5941	814	119	+   	343	0
5942	815	375	1m  	343	901
5943	816	456	+   	343	0
5944	816	456	a   	344	0
5945	816	456	+   	346	0
5946	817	204	+   	343	904
5947	818	369	1m  	344	907
5948	818	369	+   	345	907
5949	818	369	1m  	346	907
5950	819	435	1m  	344	909
5951	819	435	1m  	346	909
5952	820	51	1m  	344	910
5953	820	51	+   	346	910
5954	821	44	+   	344	912
5955	821	44	+   	345	912
5956	821	44	+   	346	912
5957	822	196	+   	344	914
5958	822	196	+   	347	914
5959	823	6	+   	344	915
5960	823	6	+   	346	915
5961	823	6	1m  	347	915
5962	824	31	1m  	344	0
5963	824	31	1m  	346	0
5964	825	25	a   	344	919
5965	825	25	+   	346	919
5966	826	319	a   	344	923
5967	826	319	+   	346	923
5968	827	225	a   	344	922
5969	827	225	+   	346	922
5970	828	467	4   	345	571
5971	828	467	+   	346	571
5972	829	429	+   	344	0
5973	829	429	+   	345	0
5974	829	429	+   	346	0
5975	829	429	+   	348	0
5976	830	462	+   	346	924
5977	831	25	1   	347	925
5978	832	465	1m  	347	926
5979	832	465	+   	348	926
5980	833	348	r   	347	927
5981	834	138	+   	348	928
5982	835	415	+   	348	930
5983	836	498	1m  	348	936
5984	837	73	a   	347	937
5985	840	352	2b  	349	1021
5986	841	498	+   	349	0
5987	842	125	+   	349	0
5988	843	30	2b  	349	935
5989	844	429	1m  	349	933
5990	845	363	1m  	349	0
5991	846	188	+   	349	905
5992	847	184	1m  	349	0
5993	848	599	1m  	349	0
5994	849	51	1m  	349	0
5995	850	414	1m  	349	0
5996	851	178	+   	349	0
5997	852	389	+   	349	0
5998	853	204	+   	349	0
5999	854	454	+   	349	0
6000	855	195	+   	349	0
6001	856	337	+   	349	0
6002	857	573	1m  	349	0
6003	858	21	1m  	349	0
6004	859	470	2a  	349	0
6005	860	152	+   	349	929
6006	861	616	1m  	349	931
6007	862	468	3   	349	934
6008	863	527	2b  	353	939
6009	863	527	+   	354	939
6010	863	527	r   	356	939
6011	864	144	1   	353	0
6012	864	144	2a  	354	0
6013	864	144	1   	356	0
6014	865	190	3   	355	979
6015	865	190	2b  	356	979
6016	866	190	1   	353	958
6017	866	190	1   	354	958
6018	867	324	+   	353	941
6019	867	324	+   	354	941
6020	867	324	1   	356	941
6021	868	184	1   	353	956
6022	868	184	+   	354	956
6023	869	56	1   	353	990
6024	869	56	+   	354	990
6025	870	318	+   	353	988
6026	870	318	+   	354	988
6027	871	829	+   	353	940
6028	871	829	+   	354	940
6029	871	829	1   	356	940
6030	872	19	1m  	353	947
6031	872	19	1m  	354	947
6032	873	30	1m  	353	942
6033	873	30	2b  	354	942
6034	873	30	+   	355	942
6035	873	30	1m  	356	942
6036	874	11	1m  	353	946
6037	874	11	1m  	354	946
6038	875	28	2b  	355	971
6039	875	28	1m  	356	971
6040	876	12	1m  	355	972
6041	876	12	1m  	356	972
6042	877	26	1m  	355	981
6043	877	26	1m  	356	981
6044	878	616	1m  	353	963
6045	878	616	1m  	354	963
6046	878	616	1m  	356	963
6047	879	394	1m  	353	0
6048	879	394	+   	354	0
6049	879	394	+   	356	0
6050	880	393	1m  	354	967
6051	881	260	1m  	353	949
6052	881	260	1m  	354	949
6053	882	286	1m  	353	0
6054	882	286	1m  	354	0
6055	883	305	1m  	353	944
6056	883	305	1m  	354	944
6057	884	276	+   	353	991
6058	884	276	+   	354	991
6059	885	558	+   	353	0
6060	886	79	1m  	353	964
6061	886	79	1m  	354	964
6062	887	389	+   	353	989
6063	887	389	+   	354	989
6064	888	492	1m  	353	950
6065	888	492	+   	354	950
6066	888	492	1m  	355	950
6067	888	492	1m  	356	950
6068	889	493	1m  	353	951
6069	890	119	1m  	353	945
6070	891	245	+   	353	948
6071	891	245	+   	354	948
6072	892	330	1m  	353	952
6073	892	330	1m  	354	952
6074	893	414	1m  	353	953
6075	893	414	1m  	354	953
6076	894	375	1m  	353	954
6077	894	375	+   	354	954
6078	895	437	+   	353	955
6079	895	437	+   	355	955
6080	896	523	1m  	353	959
6081	897	279	+   	353	960
6082	898	130	1m  	353	961
6083	898	130	1m  	354	961
6084	898	130	1m  	355	961
6085	898	130	1m  	356	961
6086	899	418	+   	353	987
6087	900	435	1m  	355	983
6088	900	435	+   	356	983
6089	901	937	1m  	353	986
6090	901	937	+   	354	986
6091	901	937	1m  	355	986
6092	901	937	2a  	356	986
6093	902	279	1m  	354	969
6094	903	57	1m  	354	965
6095	904	203	+   	354	968
6096	905	356	+   	354	970
6097	905	356	+   	356	970
6098	906	511	1m  	355	973
6099	906	511	+   	356	973
6100	907	863	2a  	355	974
6101	907	863	1   	356	974
6102	908	131	+   	355	976
6103	908	131	+   	356	976
6104	909	828	1m  	355	977
6105	909	828	+   	356	977
6106	910	304	2a  	355	978
6107	910	304	1   	356	978
6108	911	236	+   	355	980
6109	912	435	+   	355	984
6110	920	352	a   	366	1059
6111	922	277	1m  	357	1005
6112	922	277	+   	366	1005
6113	923	144	1   	357	0
6114	923	144	1   	366	0
6115	923	144	+   	367	0
6116	924	937	1   	357	0
6117	924	937	a   	366	0
6118	924	937	+   	367	0
6119	925	184	1   	357	957
6120	925	184	1   	366	957
6121	926	190	+   	357	0
6122	926	190	1   	367	0
6123	927	318	+   	357	0
6124	928	30	2a  	357	0
6125	928	30	1m  	366	0
6126	928	30	1m  	367	0
6127	929	19	1m  	357	0
6128	929	19	1m  	366	0
6129	930	26	1m  	357	1009
6130	931	245	+   	357	0
6131	932	167	+   	357	0
6132	933	389	1   	357	0
6133	934	130	1   	357	0
6134	935	57	2a  	357	966
6135	935	57	1   	366	966
6136	935	57	2a  	367	966
6137	936	456	1   	357	995
6138	936	456	1   	366	995
6139	936	456	1   	367	995
6140	937	437	+   	357	0
6141	938	418	1   	357	998
6142	938	418	1   	367	998
6143	939	358	1m  	357	996
6144	939	358	1m  	366	996
6145	940	282	2a  	357	997
6146	941	290	1m  	357	999
6147	942	80	1   	357	1000
6148	943	420	+   	357	1001
6149	944	863	1m  	357	975
6150	944	863	1   	367	975
6151	945	496	1   	357	1002
6152	946	381	+   	357	1003
6153	946	381	1m  	367	1003
6154	947	163	+   	357	1004
6155	947	163	+   	366	1004
6156	948	400	+   	357	1006
6157	949	356	1   	357	0
6158	949	356	+   	366	0
6159	950	375	1   	357	0
6160	951	79	1   	357	0
6161	952	203	1   	357	0
6162	952	203	2a  	366	0
6163	953	412	1   	357	1008
6164	954	90	+   	357	1007
6165	954	90	+   	366	1007
6166	955	333	+   	366	0
6167	955	333	+   	367	0
6168	956	247	+   	366	1042
6169	957	282	2a  	366	1043
6170	958	352	2a  	366	1045
6171	959	261	2a  	366	1044
6172	959	261	1   	367	1044
6173	961	151	1   	366	1041
6174	961	151	2a  	367	1041
6175	962	279	+   	366	1046
6176	962	279	+   	367	1046
6177	963	381	1   	366	1048
6178	964	62	1   	366	1049
6179	965	408	+   	366	1050
6180	966	236	+   	366	0
6181	966	236	1   	367	0
6182	967	420	1   	366	1051
6183	968	170	2a  	367	0
6184	969	189	1   	367	0
6185	970	198	1   	367	0
6186	971	363	+   	367	1057
6187	972	866	+   	367	0
6188	973	283	1   	367	0
6189	974	178	3   	367	0
6190	975	287	1   	367	0
6191	976	324	+   	358	0
6192	976	324	1   	359	0
6193	977	829	+   	358	1025
6194	977	829	+   	359	1025
6195	978	144	1   	358	0
6196	979	287	1   	358	0
6197	979	287	+   	359	0
6198	980	527	1   	358	0
6199	981	213	1   	358	1028
6200	981	213	1   	359	1028
6201	982	200	1   	358	0
6202	983	314	r   	358	1027
6203	984	30	2b  	358	0
6204	984	30	2a  	359	0
6205	985	19	1m  	358	0
6206	985	19	1m  	359	0
6207	986	26	1m  	358	0
6208	986	26	1m  	359	0
6209	987	11	1   	358	1024
6210	988	90	+   	358	0
6211	989	1110	+   	358	1014
6212	989	1110	+   	359	1014
6213	990	187	1   	358	1033
6214	990	187	1   	359	1033
6215	991	167	1   	358	0
6216	991	167	1   	359	0
6217	992	260	1   	358	0
6218	992	260	1   	359	0
6219	993	236	+   	358	0
6220	993	236	+   	359	0
6221	994	380	+   	358	0
6222	994	380	1m  	359	0
6223	995	496	1   	358	1071
6224	995	496	+   	359	1071
6225	996	276	1   	358	0
6226	997	616	1   	358	0
6227	998	456	1   	358	0
6228	998	456	1   	359	0
6229	999	388	+   	358	0
6230	999	388	+   	359	0
6231	1000	80	1m  	358	0
6232	1000	80	+   	359	0
6233	1001	804	1   	358	1015
6234	1001	804	1   	359	1015
6235	1002	492	1   	358	1016
6236	1002	492	+   	359	1016
6237	1003	493	+   	358	1018
6238	1004	169	1   	358	1019
6239	1005	330	1m  	358	1020
6240	1006	937	1   	358	0
6241	1007	523	+   	358	1022
6242	1008	130	1   	358	962
6243	1008	130	1   	359	962
6244	1009	234	+   	358	1023
6245	1010	375	+   	358	0
6246	1011	304	1   	358	0
6247	1011	304	1   	359	0
6248	1012	363	+   	358	1026
6249	1012	363	+   	359	1026
6250	1013	356	+   	358	0
6251	1013	356	+   	359	0
6252	1014	1139	1m  	359	1047
6253	1015	178	2a  	359	1029
6254	1016	599	1m  	359	1030
6255	1017	184	1   	358	1031
6256	1017	184	1m  	359	1031
6257	1018	479	1m  	359	1034
6258	1019	198	+   	359	0
6259	1020	57	1m  	358	0
6260	1020	57	1m  	359	0
6261	1021	333	1   	359	0
6262	1022	399	r   	359	0
6263	1023	189	+   	358	1035
6264	1023	189	1   	359	1035
6265	1024	283	1m  	362	1065
6266	1025	765	1m  	360	1036
6267	1025	765	2a  	361	1036
6268	1026	282	4   	360	1038
6269	1026	282	3   	361	1038
6270	1026	282	2b  	362	1038
6271	1027	187	1   	360	1056
6272	1027	187	1   	361	1056
6273	1028	66	1   	360	1052
6274	1028	66	1   	361	1052
6275	1028	66	1   	362	1052
6276	1029	333	1   	360	0
6277	1029	333	1m  	361	0
6278	1030	216	1   	360	1039
6279	1031	33	1m  	362	1063
6280	1032	19	1m  	360	0
6281	1032	19	1m  	361	0
6282	1033	12	1m  	360	1068
6283	1033	12	1m  	361	1068
6284	1034	30	1   	360	0
6285	1034	30	1m  	361	0
6286	1034	30	2a  	362	0
6287	1035	26	1m  	361	1053
6288	1035	26	1m  	362	1053
6289	1036	21	2a  	361	1058
6290	1037	395	+   	360	1040
6291	1038	456	1   	360	1069
6292	1038	456	1   	361	1069
6293	1039	399	1   	360	1070
6294	1039	399	+   	361	1070
6295	1040	302	+   	360	567
6296	1041	863	2a  	360	1054
6297	1041	863	2a  	361	1054
6298	1041	863	1   	362	1054
6299	1042	236	1   	361	0
6300	1043	290	+   	361	1055
6301	1044	395	2b  	362	1067
6302	1045	90	1   	362	0
6303	1046	502	+   	362	1066
6304	1047	283	+   	362	1064
6305	1048	339	+   	362	1062
6306	1049	432	+   	362	1061
6307	1050	287	1   	368	1072
6308	1050	287	1   	351	1072
6309	1050	287	+   	369	1072
6310	1050	287	1m  	363	1072
6311	1051	144	1   	368	0
6312	1051	144	1   	351	0
6313	1051	144	+   	369	0
6314	1051	144	2a  	363	0
6315	1052	527	1m  	368	1073
6316	1052	527	1   	351	1073
6317	1052	527	1   	369	1073
6318	1052	527	1m  	363	1073
6319	1053	937	+   	368	1074
6320	1054	192	2a  	368	1075
6321	1054	192	1   	351	1075
6322	1054	192	1   	369	1075
6323	1054	192	2a  	363	1075
6324	1055	829	+   	368	1078
6325	1055	829	+   	351	1078
6326	1055	829	1   	369	1078
6327	1055	829	+   	363	1078
6328	1056	829	1   	368	1077
6329	1056	829	+   	351	1077
6330	1056	829	+   	369	1077
6331	1056	829	1   	363	1077
6332	1057	348	2a  	368	1076
6333	1057	348	2b  	351	1076
6334	1057	348	2a  	369	1076
6335	1057	348	1   	363	1076
6336	1058	48	r   	368	0
6337	1058	48	+   	369	0
6338	1058	48	1   	363	0
6339	1059	165	1   	368	1087
6340	1059	165	1   	351	1087
6341	1059	165	1m  	369	1087
6342	1059	165	1   	363	1087
6343	1060	443	1m  	368	1080
6344	1060	443	1m  	351	1080
6345	1061	111	1m  	368	1086
6346	1061	111	1m  	351	1086
6347	1061	111	1   	363	1086
6348	1062	302	1   	368	1079
6349	1062	302	1   	351	1079
6350	1062	302	1   	369	1079
6351	1062	302	+   	363	1079
6352	1063	296	1   	368	1082
6353	1064	130	1   	368	1083
6354	1064	130	1m  	351	1083
6355	1064	130	1m  	363	1083
6356	1065	50	1m  	369	1085
6357	1065	50	2a  	363	1085
6358	1066	1110	1   	368	1088
6359	1066	1110	1   	351	1088
6360	1066	1110	+   	369	1088
6361	1066	1110	+   	363	1088
6362	1067	81	+   	368	1089
6363	1067	81	+   	369	1089
6364	1067	81	+   	363	1089
6365	1068	188	1m  	368	1090
6366	1068	188	1m  	351	1090
6367	1068	188	1   	369	1090
6368	1068	188	1   	363	1090
6369	1069	116	1   	368	1091
6370	1069	116	1m  	351	1091
6371	1069	116	1   	363	1091
6372	1070	273	+   	368	1092
6373	1071	366	+   	368	1096
6374	1071	366	1   	351	1096
6375	1071	366	1   	369	1096
6376	1072	366	1   	363	0
6377	1073	465	1m  	368	1093
6378	1073	465	1m  	351	1093
6379	1074	904	1m  	368	1094
6380	1074	904	1m  	351	1094
6381	1074	904	1m  	369	1094
6382	1074	904	1m  	363	1094
6383	1075	26	1   	368	1095
6384	1075	26	1   	351	1095
6385	1075	26	1m  	369	1095
6386	1075	26	1   	363	1095
6387	1076	203	1m  	369	1124
6388	1077	119	+   	369	1123
6389	1077	119	+   	363	1123
6390	1078	380	+   	368	1097
6391	1078	380	1   	351	1097
6392	1078	380	+   	369	1097
6393	1078	380	+   	363	1097
6394	1079	188	1   	368	1098
6395	1079	188	1m  	351	1098
6396	1079	188	1   	369	1098
6397	1079	188	1   	363	1098
6398	1080	393	+   	368	1099
6399	1081	502	1   	368	1100
6400	1081	502	1   	351	1100
6401	1082	79	1m  	368	1102
6402	1082	79	1m  	351	1102
6403	1082	79	1m  	369	1102
6404	1082	79	1m  	363	1102
6405	1083	401	+   	369	1115
6406	1083	401	+   	363	1115
6407	1084	393	1   	351	1103
6408	1084	393	1m  	369	1103
6409	1085	1169	+   	351	1107
6410	1086	143	+   	369	1109
6411	1087	273	+   	369	1110
6412	1088	245	1   	369	1112
6413	1088	245	+   	363	1112
6414	1089	208	+   	369	1113
6415	1090	173	2a  	369	1114
6416	1091	513	1   	369	1117
6417	1092	457	r   	369	1116
6418	1093	242	+   	369	1118
6419	1093	242	+   	363	1118
6420	1094	488	r   	369	1119
6421	1095	828	+   	369	1120
6422	1096	375	+   	369	1121
6423	1096	375	+   	363	1121
6424	1097	178	1   	369	1122
6425	1097	178	1   	363	1122
6426	1098	363	1   	369	1125
6427	1098	363	1   	363	1125
6428	1103	1103	+   	369	1126
6429	1103	1103	1   	363	1126
6430	1104	279	1   	368	1127
6431	1104	279	1   	351	1127
6432	1104	279	1   	369	1127
6433	1104	279	1   	363	1127
6434	1105	19	1   	363	0
6435	1106	12	1   	363	1130
6436	1107	27	1m  	363	1131
6437	1108	11	1   	363	1132
6438	1109	458	1   	363	1129
6439	1110	1164	1   	369	0
6440	1110	1164	1m  	363	0
6441	1111	287	2a  	364	0
6442	1112	192	2a  	364	1141
6443	1113	144	2a  	364	0
6444	1114	173	1m  	364	0
6445	1115	208	1m  	364	0
6446	1116	302	1m  	364	1133
6447	1117	279	1m  	364	0
6448	1118	363	1m  	364	1135
6449	1119	130	1   	364	1136
6450	1120	103	1m  	364	1138
6451	1121	986	1   	364	1139
6452	1122	488	1   	364	1142
6453	1123	437	+   	364	1143
6454	1124	279	+   	364	1144
6455	1125	269	+   	364	0
6456	1134	818	3   	370	1149
6457	1134	818	3   	371	1149
6458	1134	818	5   	372	1149
6459	1134	818	3   	373	1149
6460	1135	279	1   	370	0
6461	1135	279	1   	372	0
6462	1135	279	1   	373	0
6463	1136	500	1   	370	1150
6464	1136	500	1m  	371	1150
6465	1136	500	1   	372	1150
6466	1136	500	1   	373	1150
6467	1137	302	1m  	370	1152
6468	1137	302	1   	371	1152
6469	1137	302	1   	372	1152
6470	1137	302	1   	373	1152
6471	1138	303	1m  	370	1153
6472	1139	319	1   	370	1154
6473	1139	319	+   	371	1154
6474	1139	319	+   	372	1154
6475	1139	319	+   	373	1154
6476	1140	320	+   	370	1155
6477	1141	363	1m  	371	0
6478	1141	363	1   	373	0
6479	1142	520	1m  	371	1166
6480	1143	356	1m  	371	1158
6481	1143	356	+   	372	1158
6482	1144	932	1   	371	0
6483	1144	932	+   	373	0
6484	1147	30	2a  	371	1159
6485	1147	30	1   	372	1159
6486	1147	30	1m  	373	1159
6487	1148	13	1   	371	1160
6488	1149	214	+   	371	1162
6489	1150	1103	1   	371	1165
6490	1150	1103	1   	373	1165
6491	1151	192	a   	371	0
6492	1152	463	a   	371	0
6493	1153	361	1m  	372	1167
6494	1154	277	1   	372	0
6495	1155	7	1m  	373	1168
6496	1156	220	1   	373	1169
6497	1157	12	1   	373	1170
6498	1158	129	a   	373	0
6499	1159	466	1   	373	1171
6500	1160	140	+   	368	0
6501	1160	140	+   	371	0
6502	1161	192	1m  	374	1176
6503	1162	178	2b  	374	1177
6504	1163	348	2b  	374	1201
6505	1164	1164	1m  	374	1178
6506	1165	130	1m  	374	1181
6507	1166	510	1m  	374	1182
6508	1167	311	1m  	374	1183
6509	1168	341	+   	374	1184
6510	1169	31	1m  	374	1186
6511	1170	479	1m  	374	1187
6512	1171	334	+   	374	1189
6513	1172	576	1m  	374	1190
6514	1173	361	1m  	374	0
6515	1174	443	1m  	374	1191
6516	1175	418	+   	374	1192
6517	1176	251	1   	374	1193
6518	1177	560	1m  	374	1194
6519	1178	361	a   	374	1195
6520	1179	492	+   	374	1196
6521	1180	588	+   	374	1197
6522	1181	599	1m  	374	1198
6523	1182	381	1   	374	1200
6524	1183	287	+   	375	0
6525	1183	287	2a  	376	0
6526	1183	287	2a  	377	0
6527	1184	192	2a  	375	1204
6528	1184	192	1   	376	1204
6529	1184	192	+   	377	1204
6530	1185	527	2a  	375	1205
6531	1185	527	+   	377	1205
6532	1186	56	1   	375	0
6533	1187	144	1   	375	1225
6534	1187	144	1   	376	1225
6535	1187	144	1   	377	1225
6536	1188	418	1   	375	1206
6537	1189	302	1m  	375	1209
6538	1189	302	1m  	376	1209
6539	1189	302	1m  	377	1209
6540	1190	167	1   	375	0
6541	1190	167	1m  	376	0
6542	1190	167	1m  	377	0
6543	1191	290	1m  	375	1245
6544	1192	50	1   	375	1207
6545	1192	50	1m  	376	1207
6546	1192	50	1   	377	1207
6547	1193	319	1m  	375	1208
6548	1194	362	1m  	375	1211
6549	1195	616	1m  	375	1212
6550	1195	616	1m  	376	1212
6551	1195	616	1   	377	1212
6552	1196	394	1   	375	1213
6553	1197	534	1   	375	1214
6554	1198	433	+   	375	1215
6555	1199	153	1   	375	1217
6556	1200	522	r   	375	1240
6557	1200	522	r   	377	1240
6558	1201	367	+   	375	1218
6559	1202	363	+   	375	1219
6560	1203	424	+   	375	1221
6561	1204	7	+   	376	0
6562	1204	7	1m  	377	0
6563	1205	12	1m  	376	1254
6564	1205	12	1m  	377	1254
6565	1206	15	1m  	375	1233
6566	1206	15	2a  	376	1233
6567	1207	19	1   	375	0
6568	1208	26	1   	375	1235
6569	1208	26	1   	376	1235
6570	1209	904	1m  	375	0
6571	1209	904	1m  	377	0
6572	1210	265	+   	375	1222
6573	1210	265	+   	376	1222
6574	1211	1103	+   	375	1226
6575	1211	1103	+   	376	1226
6576	1212	1164	1   	375	1227
6577	1213	510	+   	375	1228
6578	1214	619	1   	375	1229
6579	1215	534	+   	375	1230
6580	1216	340	r   	375	1231
6581	1216	340	1m  	376	1231
6582	1217	219	+   	375	1237
6583	1217	219	1   	376	1237
6584	1218	569	1   	376	1246
6585	1219	969	1   	376	1255
6586	1219	969	1   	377	1255
6587	1220	445	1   	376	1256
6588	1221	273	1m  	376	1252
6589	1221	273	1m  	377	1252
6590	1222	256	+   	376	1247
6591	1223	318	+   	376	0
6592	1223	318	+   	377	0
6593	1224	937	+   	376	0
6594	1224	937	+   	377	0
6595	1225	184	1   	376	1249
6596	1226	367	1m  	376	1258
6597	1226	367	1m  	377	1258
6598	1227	314	r   	376	0
6599	1228	380	1m  	377	1253
6600	1229	545	+   	377	1257
6601	1230	25	+   	377	1244
6602	1231	356	+   	376	1243
6603	1231	356	1   	377	1243
6604	1232	296	+   	377	0
6605	1233	544	+   	377	1250
6606	1234	392	1   	377	1259
6607	1243	5	2a  	378	1265
6608	1243	5	2a  	379	1265
6609	1243	5	2a  	380	1265
6610	1244	19	2a  	378	1278
6611	1244	19	2a  	379	1278
6612	1244	19	1   	380	1278
6613	1245	30	2a  	378	1274
6614	1245	30	2a  	379	1274
6615	1246	11	1m  	378	1277
6616	1246	11	1m  	379	1277
6617	1247	470	1m  	379	1291
6618	1248	324	+   	378	1280
6619	1249	236	1   	378	1266
6620	1249	236	+   	379	1266
6621	1249	236	1   	380	1266
6622	1250	373	1   	378	1267
6623	1250	373	1m  	379	1267
6624	1250	373	1   	380	1267
6625	1251	82	1m  	378	1279
6626	1251	82	1m  	379	1279
6627	1251	82	1m  	380	1279
6628	1252	1136	2a  	378	1270
6629	1252	1136	1m  	379	1270
6630	1252	1136	+   	380	1270
6631	1253	461	+   	378	1271
6632	1253	461	+   	380	1271
6633	1254	424	1   	378	1269
6634	1254	424	+   	379	1269
6635	1254	424	+   	380	1269
6636	1255	405	1m  	378	1281
6637	1255	405	+   	379	1281
6638	1255	405	1m  	380	1281
6639	1256	110	1   	378	1273
6640	1256	110	1m  	379	1273
6641	1256	110	1   	380	1273
6642	1257	319	1m  	378	1275
6643	1257	319	1m  	379	1275
6644	1257	319	1m  	380	1275
6645	1258	363	1m  	378	1272
6646	1258	363	2a  	379	1272
6647	1258	363	2a  	380	1272
6648	1259	407	1   	378	1283
6649	1260	398	a   	378	0
6650	1260	398	+   	379	0
6651	1261	539	a   	378	1309
6652	1262	298	1   	379	1284
6653	1262	298	1   	380	1284
6654	1263	286	1m  	379	1286
6655	1263	286	1m  	380	1286
6656	1264	211	+   	379	1287
6657	1264	211	+   	380	1287
6658	1265	410	+   	379	1288
6659	1265	410	1   	380	1288
6660	1266	500	+   	380	1293
6661	1267	272	1   	380	1294
6662	1268	65	a   	380	1298
6663	1269	196	a   	380	1295
6664	1270	12	1m  	380	1300
6665	1271	11	2a  	380	1303
6666	1272	11	1m  	380	1304
6667	1273	299	a   	380	1296
6668	1274	383	1m  	380	1297
6669	1275	459	1   	380	1299
6670	1276	127	+   	379	1301
6671	1276	127	1m  	380	1301
6672	1289	5	1m  	382	1319
6673	1289	5	2a  	383	1319
6674	1289	5	1m  	384	1319
6675	1289	5	1   	385	1319
6676	1290	506	3   	382	1318
6677	1290	506	3   	384	1318
6678	1290	506	3   	385	1318
6679	1291	505	3   	382	1321
6680	1291	505	3   	383	1321
6681	1291	505	2a  	384	1321
6682	1291	505	1m  	385	1321
6683	1292	11	1m  	382	1324
6684	1292	11	1m  	383	1324
6685	1292	11	1m  	384	1324
6686	1292	11	1m  	386	1324
6687	1293	30	1m  	382	1322
6688	1293	30	1m  	385	1322
6689	1293	30	1m  	386	1322
6690	1294	5	1   	384	1337
6691	1294	5	1   	385	1337
6692	1295	19	1   	385	0
6693	1296	804	1   	382	1327
6694	1296	804	2a  	384	1327
6695	1296	804	1m  	385	1327
6696	1296	804	1   	386	1327
6697	1297	405	1m  	382	1282
6698	1297	405	2a  	384	1282
6699	1297	405	1m  	385	1282
6700	1298	398	1   	382	1326
6701	1298	398	+   	383	1326
6702	1298	398	1   	384	1326
6703	1298	398	1m  	385	1326
6704	1298	398	1   	386	1326
6705	1299	1136	2a  	382	0
6706	1299	1136	1   	383	0
6707	1299	1136	2a  	384	0
6708	1299	1136	2a  	385	0
6709	1299	1136	1   	386	0
6710	1300	297	1   	382	1285
6711	1300	297	1   	383	1285
6712	1300	297	1   	384	1285
6713	1300	297	1m  	385	1285
6714	1300	297	1m  	386	1285
6715	1301	211	+   	382	0
6716	1301	211	r   	383	0
6717	1301	211	+   	384	0
6718	1301	211	+   	386	0
6719	1302	373	1   	382	1268
6720	1302	373	1   	383	1268
6721	1302	373	1   	384	1268
6722	1302	373	1   	386	1268
6723	1303	394	1m  	382	1328
6724	1304	82	1m  	382	0
6725	1304	82	1   	384	0
6726	1305	34	1   	382	1329
6727	1305	34	1   	384	1329
6728	1306	765	1m  	382	1330
6729	1307	407	+   	382	1331
6730	1307	407	1m  	383	1331
6731	1308	110	1   	382	0
6732	1308	110	1m  	384	0
6733	1308	110	1   	385	0
6734	1308	110	1   	386	0
6735	1309	212	1   	383	1332
6736	1309	212	1   	385	1332
6737	1310	964	1   	383	1333
6738	1312	424	+   	383	0
6739	1312	424	+   	384	0
6740	1312	424	1   	385	0
6741	1312	424	1   	386	0
6742	1313	212	1   	383	1334
6743	1314	461	+   	383	0
6744	1314	461	+   	384	0
6745	1315	407	1   	383	1335
6746	1316	438	1   	384	1341
6747	1316	438	1m  	385	1341
6748	1317	449	1   	384	1343
6749	1318	531	1   	384	1345
6750	1318	531	2a  	385	1345
6751	1319	397	1m  	384	1346
6752	1319	397	1m  	385	1346
6753	1320	56	+   	384	0
6754	1321	437	1   	385	1347
6755	1322	366	1m  	385	1348
6756	1323	410	1   	385	1349
6757	1323	410	1m  	386	1349
6758	1324	410	2a  	386	1289
6759	1325	324	+   	386	1350
6760	1326	397	1   	386	1351
6761	1327	452	1   	386	1352
6762	1328	319	2a  	387	1358
6763	1329	250	3   	387	1357
6764	1330	33	2a  	387	1356
6765	1331	765	1m  	387	0
6766	1332	398	a   	387	0
6767	1333	506	3   	387	0
6768	1334	11	1m  	387	1359
6769	1335	449	1   	387	0
6770	1336	437	+   	387	1360
6771	1337	395	1m  	387	1361
6772	1338	366	1   	387	0
6773	1339	72	+   	387	1362
6774	1340	35	+   	387	1363
6775	1341	30	1   	387	0
6776	1342	5	2b  	388	1365
6777	1342	5	2b  	390	1365
6778	1342	5	1m  	392	1365
6779	1342	5	1m  	393	1365
6780	1343	5	2a  	388	1366
6781	1343	5	3   	389	1366
6782	1344	506	2a  	388	0
6783	1344	506	2b  	390	0
6784	1344	506	2b  	392	0
6785	1344	506	4   	393	0
6786	1345	505	3   	389	0
6787	1345	505	2a  	390	0
6788	1345	505	4   	392	0
6789	1345	505	2a  	393	0
6790	1346	19	1m  	388	0
6791	1347	11	2b  	388	1367
6792	1348	56	+   	388	0
6793	1348	56	1   	390	0
6794	1348	56	1   	392	0
6795	1349	324	1   	388	1368
6796	1350	144	+   	388	0
6797	1351	398	1   	388	0
6798	1351	398	1m  	389	0
6799	1351	398	1m  	390	0
6800	1351	398	1   	393	0
6801	1352	410	1m  	389	0
6802	1352	410	1   	390	0
6803	1352	410	+   	392	0
6804	1353	405	1m  	388	0
6805	1353	405	1m  	393	0
6806	1354	1136	1m  	388	0
6807	1354	1136	1   	389	0
6808	1354	1136	2a  	390	0
6809	1354	1136	1   	392	0
6810	1354	1136	2a  	393	0
6811	1355	618	1   	388	1369
6812	1356	366	1m  	388	0
6813	1356	366	+   	393	0
6814	1357	986	1m  	393	1370
6815	1358	373	1   	388	0
6816	1358	373	1   	390	0
6817	1358	373	+   	392	0
6818	1358	373	1   	393	0
6819	1359	250	1   	388	0
6820	1359	250	1m  	393	0
6821	1360	424	+   	388	0
6822	1360	424	1   	389	0
6823	1360	424	1   	390	0
6824	1360	424	+   	392	0
6825	1360	424	1   	393	0
6826	1361	286	1m  	388	0
6827	1362	765	1m  	388	0
6828	1362	765	1m  	389	0
6829	1362	765	1m  	390	0
6830	1362	765	1m  	392	0
6831	1362	765	a   	393	0
6832	1363	34	1m  	388	1262
6833	1363	34	+   	389	1262
6834	1363	34	1   	390	1262
6835	1363	34	1   	392	1262
6836	1363	34	1m  	393	1262
6837	1364	110	1   	388	0
6838	1364	110	+   	393	0
6839	1365	297	1   	388	0
6840	1365	297	1   	389	0
6841	1365	297	1   	390	0
6842	1365	297	+   	392	0
6843	1365	297	1   	393	0
6844	1366	804	1   	388	0
6845	1366	804	1m  	390	0
6846	1366	804	1   	392	0
6847	1368	394	+   	388	1380
6848	1368	394	1   	390	1380
6849	1369	82	1m  	388	0
6850	1369	82	1m  	389	0
6851	1369	82	1   	390	0
6852	1369	82	1m  	393	0
6853	1370	236	1   	388	0
6854	1371	319	1m  	388	1372
6855	1372	503	+   	388	1373
6856	1373	449	1   	388	1344
6857	1374	828	1   	388	1374
6858	1375	1158	+   	388	1376
6859	1376	357	1m  	388	1377
6860	1376	357	1m  	389	1377
6861	1376	357	1m  	390	1377
6862	1376	357	1   	392	1377
6863	1376	357	1   	393	1377
6864	1377	437	+   	388	1378
6865	1378	259	1   	388	1379
6866	1379	437	1   	393	1396
6867	1380	267	+   	389	1383
6868	1380	267	1m  	390	1383
6869	1380	267	+   	392	1383
6870	1381	397	1m  	389	1381
6871	1381	397	1m  	390	1381
6872	1381	397	1m  	392	1381
6873	1381	397	1m  	393	1381
6874	1382	407	1   	389	1382
6875	1383	153	+   	389	1384
6876	1383	153	1   	390	1384
6877	1383	153	+   	392	1384
6878	1384	279	1m  	389	1385
6879	1384	279	1   	393	1385
6880	1385	279	1m  	389	0
6881	1385	279	1   	390	0
6882	1385	279	1   	392	0
6883	1385	279	1m  	393	0
6884	1386	964	1   	389	0
6885	1387	512	+   	389	1389
6886	1387	512	+   	392	1389
6887	1388	212	+   	389	1390
6888	1388	212	1   	390	1390
6889	1388	212	1   	392	1390
6890	1388	212	1   	393	1390
6891	1389	438	1m  	390	1342
6892	1390	24	+   	390	1391
6893	1391	268	1m  	390	1392
6894	1392	212	+   	392	1393
6895	1393	212	+   	390	0
6896	1394	319	1   	390	1395
6897	1394	319	1m  	392	1395
6898	1395	531	1   	390	0
6899	1396	518	1   	393	1397
6900	1397	134	+   	390	1394
6901	1398	18	2b  	394	1399
6902	1398	18	3   	399	1399
6903	1399	30	1m  	394	1400
6904	1399	30	1m  	399	1400
6905	1400	21	2b  	394	1401
6906	1400	21	2b  	399	1401
6907	1401	26	1   	394	1424
6908	1401	26	1   	399	1424
6909	1402	7	1   	394	0
6910	1403	26	+   	399	1529
6911	1404	190	1   	394	1402
6912	1404	190	1   	399	1402
6913	1405	829	2a  	394	0
6914	1405	829	1   	399	0
6915	1406	351	2a  	394	1418
6916	1406	351	2b  	399	1418
6917	1407	328	r   	394	569
6918	1408	56	2a  	399	0
6919	1409	179	1   	394	1403
6920	1410	760	+   	394	1404
6921	1410	760	+   	399	1404
6922	1411	351	+   	399	0
6923	1412	254	1   	394	1313
6924	1412	254	1m  	399	1313
6925	1413	57	2a  	394	1405
6926	1413	57	+   	399	1405
6927	1414	446	1m  	394	1406
6928	1414	446	1m  	399	1406
6929	1415	370	1m  	394	1407
6930	1415	370	1m  	399	1407
6931	1416	456	+   	394	1408
6932	1416	456	1   	399	1408
6933	1417	380	1m  	394	0
6934	1417	380	1m  	399	0
6935	1418	128	+   	394	1411
6936	1418	128	+   	399	1411
6937	1420	305	1m  	394	1413
6938	1420	305	1m  	399	1413
6939	1421	185	1   	394	1414
6940	1421	185	1   	399	1414
6941	1422	165	1m  	394	0
6942	1422	165	1   	399	0
6943	1423	689	1   	394	1415
6944	1423	689	+   	399	1415
6945	1424	357	1   	394	1416
6946	1424	357	1m  	399	1416
6947	1425	284	r   	394	1417
6948	1426	450	+   	394	1419
6949	1427	198	+   	394	1421
6950	1427	198	1   	399	1421
6951	1428	188	a   	394	1422
6952	1429	208	+   	394	1423
6953	1429	208	+   	399	1423
6954	1430	111	+   	394	1425
6955	1430	111	+   	399	1425
6956	1431	483	+   	394	1427
6957	1432	492	r   	394	1426
6958	1433	408	1   	394	1428
6959	1434	408	+   	394	1429
6960	1435	86	+   	394	1430
6961	1435	86	1m  	399	1430
6962	1436	450	1m  	394	1432
6963	1437	428	+   	394	1433
6964	1438	243	1   	394	1434
6965	1438	243	1   	399	1434
6966	1439	492	+   	394	1435
6967	1439	492	1m  	399	1435
6968	1440	524	1   	394	1437
6969	1440	524	1   	399	1437
6970	1441	560	1   	394	1438
6971	1441	560	1m  	399	1438
6972	1442	599	1m  	394	1439
6973	1443	422	+   	394	1440
6974	1444	199	+   	394	1441
6975	1445	271	+   	394	0
6976	1446	437	+   	394	1442
6977	1447	794	+   	394	0
6978	1447	794	+   	399	0
6979	1448	576	1   	394	1444
6980	1449	284	+   	394	1445
6981	1450	419	r   	394	1446
6982	1450	419	+   	399	1446
6983	1451	595	a   	394	0
6984	1452	516	+   	394	1448
6985	1453	213	a   	394	0
6986	1453	213	+   	399	0
6987	1454	54	a   	394	1449
6988	1455	199	r   	394	1451
6989	1456	619	+   	394	0
6990	1456	619	1m  	399	0
6991	1457	453	+   	394	1452
6992	1457	453	+   	399	1452
6993	1458	738	+   	394	1450
6994	1459	31	1m  	399	0
6995	1460	500	1m  	399	1530
6996	1461	558	1m  	399	0
6997	1462	147	1   	399	0
6998	1463	54	+   	399	1531
6999	1464	434	+   	399	1532
7000	1465	111	+   	399	0
7001	1466	240	1m  	399	1533
7002	1467	397	+   	399	0
7003	1468	15	2b  	395	1482
7004	1468	15	3   	398	1482
7005	1468	15	2b  	402	1482
7006	1469	21	2a  	398	8
7007	1469	21	1m  	402	8
7008	1470	30	1m  	398	0
7009	1470	30	1m  	402	0
7010	1471	26	1m  	398	9
7011	1472	26	1m  	402	32
7012	1473	56	1   	395	0
7013	1473	56	2a  	398	0
7014	1473	56	1   	402	0
7015	1474	351	+   	395	0
7016	1474	351	2b  	398	0
7017	1474	351	2a  	402	0
7018	1475	829	1   	398	0
7019	1476	328	1   	395	1453
7020	1476	328	1   	398	1453
7021	1476	328	+   	402	1453
7022	1477	287	1   	395	0
7023	1477	287	1   	398	0
7024	1477	287	1   	402	0
7025	1478	559	+   	395	0
7026	1478	559	+   	398	0
7027	1478	559	1   	402	0
7028	1479	185	1m  	395	0
7029	1479	185	+   	398	0
7030	1479	185	1m  	402	0
7031	1480	528	+   	395	1455
7032	1481	144	1   	395	0
7033	1481	144	1   	398	0
7034	1481	144	+   	402	0
7035	1482	45	+   	395	1463
7036	1483	254	1m  	395	0
7037	1483	254	1m  	398	0
7038	1483	254	1m  	402	0
7039	1484	380	1m  	395	1456
7040	1485	165	1m  	395	1457
7041	1485	165	1m  	398	1457
7042	1485	165	1m  	402	1457
7043	1486	488	+   	395	1458
7044	1486	488	+   	398	1458
7045	1487	107	r   	395	1459
7046	1488	1101	+   	395	1460
7047	1488	1101	+   	398	1460
7048	1488	1101	+   	402	1460
7049	1489	362	1   	395	1461
7050	1489	362	+   	398	1461
7051	1489	362	+   	402	1461
7052	1490	296	1m  	395	1462
7053	1490	296	+   	398	1462
7054	1491	219	+   	395	1464
7055	1491	219	+   	398	1464
7056	1492	512	1m  	395	1468
7057	1493	509	1m  	395	1469
7058	1494	98	+   	395	1512
7059	1495	357	+   	395	0
7060	1495	357	1m  	398	0
7061	1495	357	1m  	402	0
7062	1496	208	+   	395	0
7063	1496	208	+   	398	0
7064	1496	208	+   	402	0
7065	1497	135	+   	395	1471
7066	1498	619	1m  	395	1470
7067	1498	619	1m  	398	1470
7068	1498	619	+   	402	1470
7069	1499	135	r   	395	1485
7070	1500	773	+   	395	1472
7071	1500	773	+   	398	1472
7072	1500	773	+   	402	1472
7073	1501	77	1m  	395	1473
7074	1501	77	+   	402	1473
7075	1502	101	1m  	395	1474
7076	1502	101	+   	398	1474
7077	1503	561	r   	395	0
7078	1503	561	+   	398	0
7079	1503	561	+   	402	0
7080	1504	135	1   	395	1454
7081	1504	135	+   	398	1454
7082	1505	594	a   	395	0
7083	1506	245	+   	395	1475
7084	1507	382	1m  	395	0
7085	1507	382	+   	402	0
7086	1508	1169	1m  	395	1476
7087	1508	1169	1m  	398	1476
7088	1509	1169	1m  	395	1478
7089	1509	1169	1m  	398	1478
7090	1509	1169	+   	402	1478
7091	1510	133	1m  	395	1479
7092	1510	133	1m  	398	1479
7093	1510	133	1m  	402	1479
7094	1511	616	1m  	395	1480
7095	1512	275	1m  	395	1481
7096	1513	533	a   	395	0
7097	1514	31	1m  	395	1483
7098	1514	31	1m  	398	1483
7099	1514	31	1m  	402	1483
7100	1515	488	+   	395	1484
7101	1515	488	+   	398	1484
7102	1516	937	r   	395	1486
7103	1517	445	+   	398	2
7104	1517	445	+   	402	2
7105	1518	497	+   	398	3
7106	1518	497	+   	402	3
7107	1519	351	+   	398	0
7108	1520	760	+   	398	0
7109	1520	760	1   	402	0
7110	1521	50	+   	398	0
7111	1522	240	1m  	398	1534
7112	1522	240	1m  	402	1534
7113	1523	168	1   	398	0
7114	1523	168	1   	402	0
7115	1524	44	+   	398	4
7116	1524	44	+   	402	4
7117	1525	428	+   	398	5
7118	1526	342	+   	398	6
7119	1526	342	+   	402	6
7120	1527	213	+   	398	0
7121	1528	1111	1   	402	22
7122	1529	416	+   	402	30
7123	1530	483	+   	402	26
7124	1531	44	+   	402	25
7125	1532	135	+   	402	24
7126	1533	96	1m  	402	23
7127	1534	227	+   	402	27
7128	1535	315	+   	402	29
7129	1536	901	1m  	402	31
7130	1539	15	3   	396	0
7131	1539	15	4   	397	0
7132	1540	30	1m  	396	0
7133	1540	30	1m  	397	0
7134	1541	4	1m  	396	1500
7135	1541	4	1m  	397	1500
7136	1542	21	1m  	396	0
7137	1543	12	1m  	397	1519
7138	1544	144	+   	396	0
7139	1544	144	+   	397	0
7140	1545	56	1   	396	0
7141	1545	56	2a  	397	0
7142	1546	561	+   	396	0
7143	1546	561	+   	397	0
7144	1547	528	1   	396	0
7145	1547	528	1   	397	0
7146	1548	45	+   	396	1494
7147	1548	45	+   	397	1494
7148	1549	533	+   	396	1504
7149	1549	533	+   	397	1504
7150	1550	559	+   	396	0
7151	1550	559	+   	397	0
7152	1551	314	r   	396	1491
7153	1552	357	1m  	396	0
7154	1552	357	1m  	397	0
7155	1553	275	1m  	396	0
7156	1553	275	1m  	397	0
7157	1554	455	1   	396	1492
7158	1555	419	1m  	396	1447
7159	1555	419	1m  	397	1447
7160	1556	79	1m  	396	1501
7161	1556	79	1m  	397	1501
7162	1557	111	+   	396	0
7163	1557	111	+   	397	0
7164	1558	342	1m  	396	1508
7165	1558	342	1m  	397	1508
7166	1559	199	+   	396	0
7167	1559	199	1m  	397	0
7168	1560	119	+   	396	1505
7169	1560	119	+   	397	1505
7170	1561	456	1m  	396	1409
7171	1561	456	1m  	397	1409
7172	1562	290	+   	396	1490
7173	1563	538	+   	397	1523
7174	1564	403	+   	396	1496
7175	1564	403	+   	397	1496
7176	1565	969	1m  	396	1497
7177	1565	969	+   	397	1497
7178	1566	50	1m  	396	1502
7179	1566	50	1m  	397	1502
7180	1567	560	+   	396	0
7181	1568	59	1   	396	1503
7182	1568	59	1   	397	1503
7183	1569	254	1m  	396	0
7184	1569	254	1m  	397	0
7185	1570	185	1m  	396	0
7186	1570	185	1m  	397	0
7187	1571	273	+   	396	1495
7188	1571	273	+   	397	1495
7189	1572	96	+   	396	1498
7190	1573	77	+   	396	0
7191	1574	208	+   	396	0
7192	1574	208	+   	397	0
7193	1575	492	+   	396	1507
7194	1575	492	+   	397	1507
7195	1576	198	+   	396	0
7196	1576	198	+   	397	0
7197	1577	188	+   	396	0
7198	1577	188	1   	397	0
7199	1578	389	+   	396	1489
7200	1578	389	+   	397	1489
7201	1579	165	1m  	396	0
7202	1579	165	1m  	397	0
7203	1580	147	1   	396	1493
7204	1580	147	1   	397	1493
7205	1581	378	a   	396	1506
7206	1582	430	r   	396	1509
7207	1583	168	1   	396	1487
7208	1583	168	1   	397	1487
7209	1584	219	1m  	397	0
7210	1585	215	+   	397	1511
7211	1586	98	1m  	397	0
7212	1587	285	+   	396	1517
7213	1587	285	1   	397	1517
7214	1588	207	+   	397	1514
7215	1589	57	+   	397	0
7216	1590	351	+   	397	0
7217	1591	351	+   	397	1518
7218	1592	114	+   	397	1513
7219	1593	305	1m  	396	1515
7220	1593	305	1m  	397	1515
7221	1594	357	r   	397	1516
7222	1595	356	+   	396	0
7223	1595	356	+   	397	0
7224	1596	366	+   	396	0
7225	1596	366	1m  	397	0
7226	1597	986	+   	397	1520
7227	1598	437	+   	396	0
7228	1598	437	+   	397	0
7229	1599	160	r   	397	1522
7230	1600	268	+   	397	1525
7231	1601	206	+   	397	1526
7232	1602	15	3   	400	0
7233	1602	15	3   	401	0
7234	1603	30	2a  	400	0
7235	1603	30	1m  	401	0
7236	1604	31	1m  	400	0
7237	1604	31	+   	401	0
7238	1605	4	1m  	400	0
7239	1605	4	1m  	401	0
7240	1606	21	2b  	400	0
7241	1606	21	2a  	401	0
7242	1607	7	a   	400	0
7243	1607	7	2a  	401	0
7244	1608	528	1   	400	0
7245	1608	528	+   	401	0
7246	1609	559	1   	400	0
7247	1609	559	1   	401	0
7248	1610	287	1   	400	0
7249	1610	287	1   	401	0
7250	1611	351	1   	400	0
7251	1611	351	2a  	401	0
7252	1612	56	2a  	400	0
7253	1612	56	2a  	401	0
7254	1613	144	1   	400	0
7255	1614	179	+   	400	0
7256	1614	179	+   	401	0
7257	1615	561	+   	401	0
7258	1616	45	+   	401	0
7259	1617	199	1   	400	0
7260	1617	199	1   	401	0
7261	1618	198	1   	400	0
7262	1618	198	+   	401	0
7263	1619	275	1m  	400	0
7264	1620	254	1m  	400	0
7265	1620	254	2a  	401	0
7266	1621	57	+   	400	0
7267	1621	57	+   	401	0
7268	1622	185	1m  	400	0
7269	1622	185	1m  	401	0
7270	1623	397	+   	401	0
7271	1624	380	1m  	400	0
7272	1625	356	1m  	400	0
7273	1625	356	1m  	401	0
7274	1626	79	+   	401	0
7275	1627	50	1m  	400	0
7276	1627	50	+   	401	0
7277	1628	208	+   	400	0
7278	1628	208	+   	401	0
7279	1629	437	1m  	400	0
7280	1629	437	1m  	401	0
7281	1630	986	1m  	400	0
7282	1631	357	1m  	400	0
7283	1631	357	1m  	401	0
7284	1632	829	1m  	400	0
7285	1633	284	+   	400	12
7286	1634	147	+   	400	0
7287	1634	147	+   	401	0
7288	1635	119	+   	400	0
7289	1635	119	+   	401	0
7290	1636	165	1m  	400	0
7291	1636	165	1m  	401	0
7292	1637	492	+   	400	0
7293	1638	305	+   	400	0
7294	1638	305	1m  	401	0
7295	1639	206	+   	400	0
7296	1639	206	1m  	401	0
7297	1640	215	1m  	400	15
7298	1640	215	1m  	401	15
7299	1641	370	+   	400	0
7300	1641	370	+   	401	0
7301	1642	188	+   	400	0
7302	1642	188	1m  	401	0
7303	1643	59	1   	400	0
7304	1643	59	+   	401	0
7305	1644	408	1m  	400	16
7306	1645	366	1m  	400	0
7307	1646	456	1m  	400	0
7308	1646	456	+   	401	0
7309	1647	160	+   	400	17
7310	1648	273	+   	400	14
7311	1649	77	+   	400	0
7312	1650	285	1   	400	0
7313	1650	285	+   	401	0
7314	1651	243	+   	400	0
7315	1651	243	1m  	401	0
7316	1652	111	+   	400	0
7317	1652	111	1m  	401	0
7318	1653	538	+   	400	0
7319	1654	57	+   	400	10
7320	1655	378	1m  	400	11
7321	1656	389	+   	400	13
7322	1657	560	+   	401	0
7323	1658	290	1m  	401	0
7324	1659	533	+   	401	0
7325	1660	969	1m  	401	19
7326	1661	795	+   	401	0
7327	1662	203	+   	401	20
7328	1663	314	+   	401	0
7329	1664	419	+   	400	0
7330	1664	419	+   	401	0
7331	1665	760	+   	400	0
7332	1665	760	+   	401	0
7333	1666	403	+   	401	0
7334	1667	446	1m  	401	0
7335	1668	398	r   	401	0
7336	1669	1169	1m  	400	0
7337	1669	1169	1m  	401	0
7338	1670	100	1m  	401	21
7339	1671	362	+   	400	0
7340	1671	362	+   	401	0
7341	1672	351	+   	401	0
7342	1673	512	+   	401	0
7343	1677	194	2b  	205	62
7344	1677	194	2b  	229	62
7345	1677	194	2a  	230	62
7346	1677	194	+   	231	62
7347	1678	324	+   	205	0
7348	1678	324	1   	229	0
7349	1679	451	1m  	204	37
7350	1679	451	1m  	205	37
7351	1679	451	+   	229	37
7352	1680	338	2b  	204	39
7353	1680	338	2a  	205	39
7354	1680	338	1m  	229	39
7355	1681	828	+   	205	50
7356	1681	828	1m  	229	50
7357	1681	828	+   	230	50
7358	1682	395	3   	204	36
7359	1682	395	2a  	205	36
7360	1683	381	2a  	229	69
7361	1683	381	1m  	230	69
7362	1683	381	1m  	231	69
7363	1684	305	2a  	204	40
7364	1684	305	1m  	205	40
7365	1684	305	1m  	229	40
7366	1684	305	1m  	230	40
7367	1684	305	1m  	231	40
7368	1685	282	1m  	204	41
7369	1686	283	1   	205	42
7370	1687	576	1m  	205	43
7371	1688	361	1m  	205	44
7372	1689	1109	1m  	205	45
7373	1690	437	1m  	204	46
7374	1690	437	1m  	205	46
7375	1691	12	1m  	204	47
7376	1691	12	1m  	205	47
7377	1691	12	1m  	229	47
7378	1691	12	1m  	230	47
7379	1691	12	1m  	231	47
7380	1692	366	+   	205	48
7381	1692	366	+   	229	48
7382	1692	366	+   	230	48
7383	1692	366	+   	231	48
7384	1693	133	1m  	205	51
7385	1694	560	+   	205	0
7386	1695	575	+   	204	52
7387	1696	236	+   	205	53
7388	1696	236	+   	229	53
7389	1696	236	1m  	230	53
7390	1696	236	+   	231	53
7391	1697	765	1m  	205	0
7392	1697	765	+   	229	0
7393	1697	765	1m  	231	0
7394	1698	362	+   	205	54
7395	1698	362	+   	229	54
7396	1698	362	+   	230	54
7397	1698	362	+   	231	54
7398	1699	248	1m  	204	55
7399	1699	248	1m  	205	55
7400	1699	248	1m  	229	55
7401	1700	244	+   	205	56
7402	1700	244	+   	229	56
7403	1701	492	1m  	205	57
7404	1701	492	1m  	229	57
7405	1701	492	1m  	230	57
7406	1702	542	+   	205	58
7407	1702	542	+   	229	58
7408	1702	542	1m  	230	58
7409	1703	39	2a  	205	59
7410	1703	39	+   	229	59
7411	1704	420	+   	205	61
7412	1704	420	1m  	229	61
7413	1704	420	2a  	230	61
7414	1705	418	+   	205	63
7415	1706	319	2a  	204	64
7416	1706	319	2a  	205	64
7417	1707	434	1m  	205	65
7418	1707	434	1m  	229	65
7419	1708	356	1   	205	66
7420	1708	356	1   	229	66
7421	1708	356	1   	230	66
7422	1708	356	1   	231	66
7423	1709	56	2a  	229	0
7424	1709	56	2b  	231	0
7425	1710	829	1   	229	0
7426	1710	829	1   	230	0
7427	1710	829	+   	231	0
7428	1711	351	2a  	229	0
7429	1711	351	3   	230	0
7430	1711	351	1   	231	0
7431	1712	144	1   	229	0
7432	1712	144	1   	230	0
7433	1712	144	1   	231	0
7434	1713	184	1   	229	0
7435	1713	184	1   	230	0
7436	1713	184	1   	231	0
7437	1714	30	1m  	229	0
7438	1714	30	2a  	230	0
7439	1714	30	1m  	231	0
7440	1715	527	+   	229	77
7441	1715	527	1   	231	77
7442	1716	50	1m  	229	0
7443	1716	50	+   	230	0
7444	1716	50	+   	231	0
7445	1717	111	1m  	229	0
7446	1717	111	+   	230	0
7447	1717	111	+   	231	0
7448	1718	356	1m  	229	0
7449	1718	356	1m  	230	0
7450	1718	356	1m  	231	0
7451	1719	616	+   	229	104
7452	1719	616	+   	230	104
7453	1719	616	+   	231	104
7454	1720	7	1m  	205	67
7455	1720	7	1m  	229	67
7456	1721	198	1   	229	0
7457	1721	198	1   	231	0
7458	1722	937	+   	229	0
7459	1722	937	+   	230	0
7460	1722	937	+   	231	0
7461	1723	460	r   	229	68
7462	1724	760	+   	229	0
7463	1724	760	+   	231	0
7464	1725	254	1m  	230	0
7465	1725	254	1m  	231	0
7466	1726	389	1m  	230	70
7467	1726	389	1m  	231	70
7468	1727	863	1m  	230	72
7469	1728	126	+   	229	73
7470	1728	126	+   	230	73
7471	1728	126	+   	231	73
7472	1729	123	+   	230	74
7473	1730	188	1m  	230	0
7474	1730	188	+   	231	0
7475	1731	2143	1m  	231	0
7476	1732	510	1m  	231	0
7477	1733	1101	+   	231	78
7478	1734	95	+   	231	0
7479	1735	245	+   	231	0
7480	1736	402	+   	231	0
7481	1737	119	+   	231	76
7482	1738	11	1m  	231	0
7483	1739	19	1m  	231	79
7484	1740	378	1m  	231	80
7485	1741	400	+   	231	75
7486	1742	167	+   	231	0
7487	1743	169	+   	231	81
7488	1744	219	+   	231	0
7489	1745	12	1m  	232	97
7490	1746	33	+   	232	89
7491	1747	5	1m  	232	91
7492	1748	30	2a  	232	0
7493	1749	10	2b  	232	88
7494	1750	475	1m  	232	90
7495	1751	986	1m  	232	0
7496	1752	298	+   	232	0
7497	1753	503	+   	232	93
7498	1754	272	2a  	232	100
7499	1755	79	1m  	232	0
7500	1756	319	2b  	232	87
7501	1757	155	+   	232	86
7502	1758	283	+   	232	92
7503	1760	562	+   	232	0
7504	1761	110	+   	232	85
7505	1762	424	+   	232	0
7506	1763	618	+   	232	0
7507	1764	366	+   	232	96
7508	1765	383	+   	232	98
7509	1766	405	+   	232	99
7510	1767	539	+   	232	103
7511	1768	1158	a   	232	0
7512	1769	527	r   	232	0
7513	1770	461	+   	232	0
7514	1771	373	1m  	232	0
7515	1772	451	+   	233	0
7516	1772	451	1m  	234	0
7517	1773	338	2b  	233	0
7518	1773	338	2a  	234	0
7519	1774	395	2a  	233	0
7520	1774	395	2b  	234	0
7521	1775	1109	+   	233	0
7522	1775	1109	+   	234	0
7523	1776	437	1m  	233	0
7524	1776	437	1m  	234	0
7525	1777	12	1m  	233	0
7526	1777	12	1m  	234	0
7527	1778	366	+   	233	0
7528	1778	366	+   	234	0
7529	1779	560	1m  	233	0
7530	1779	560	+   	234	0
7531	1780	248	1m  	233	0
7532	1780	248	1m  	234	0
7533	1781	39	+   	233	0
7534	1781	39	+   	234	0
7535	1782	542	+   	233	0
7536	1783	30	2a  	233	0
7537	1783	30	1m  	234	0
7538	1784	7	2b  	233	0
7539	1784	7	1m  	234	0
7540	1785	194	2b  	233	0
7541	1785	194	3   	234	0
7542	1786	765	1m  	234	0
7543	1787	305	1m  	233	0
7544	1787	305	1m  	234	0
7545	1788	937	1m  	233	0
7546	1788	937	1m  	234	0
7547	1789	527	+   	233	0
7548	1789	527	+   	234	0
7549	1790	147	+   	233	0
7550	1790	147	+   	234	0
7551	1791	618	+   	233	0
7552	1792	71	+   	233	101
7553	1793	375	+   	233	0
7554	1794	254	+   	233	0
7555	1795	420	+   	233	0
7556	1796	155	+   	234	0
7557	1797	492	1m  	234	0
7558	1798	828	+   	234	0
7559	1799	236	+   	234	0
7560	1800	30	1   	239	0
7561	1800	30	1   	240	0
7562	1800	30	1   	241	0
7563	1800	30	1m  	242	0
7564	1801	19	2a  	239	0
7565	1801	19	2a  	240	0
7566	1801	19	2b  	241	0
7567	1801	19	1   	242	0
7568	1802	56	1   	239	0
7569	1802	56	1   	240	0
7570	1802	56	1   	241	0
7571	1802	56	1   	242	0
7572	1803	191	1   	239	108
7573	1803	191	2a  	240	108
7574	1803	191	1   	241	108
7575	1803	191	1   	242	108
7576	1804	423	1   	239	106
7577	1804	423	2a  	240	106
7578	1804	423	+   	241	106
7579	1804	423	+   	242	106
7580	1805	184	+   	239	0
7581	1805	184	+   	240	0
7582	1805	184	1   	241	0
7583	1805	184	1   	242	0
7584	1806	487	+   	239	110
7585	1806	487	+   	240	110
7586	1806	487	+   	241	110
7587	1806	487	+   	242	110
7588	1807	829	+   	239	0
7589	1807	829	+   	240	0
7590	1808	111	1m  	239	0
7591	1808	111	1   	240	0
7592	1808	111	1m  	241	0
7593	1809	245	+   	239	0
7594	1809	245	+   	240	0
7595	1809	245	+   	241	0
7596	1809	245	+   	242	0
7597	1810	342	1m  	239	115
7598	1810	342	1m  	240	115
7599	1810	342	1m  	241	115
7600	1811	527	1   	239	0
7601	1811	527	2a  	240	0
7602	1811	527	+   	241	0
7603	1811	527	1   	242	0
7604	1812	492	1m  	239	0
7605	1812	492	+   	240	0
7606	1813	275	1m  	239	0
7607	1813	275	1m  	240	0
7608	1813	275	1m  	241	0
7609	1813	275	1m  	242	0
7610	1814	259	1m  	239	0
7611	1814	259	1m  	240	0
7612	1814	259	1m  	241	0
7613	1814	259	1m  	242	0
7614	1815	50	1   	239	121
7615	1815	50	1   	240	121
7616	1815	50	1   	241	121
7617	1815	50	1   	242	121
7618	1816	219	1   	239	0
7619	1816	219	+   	240	0
7620	1816	219	+   	241	0
7621	1816	219	1m  	242	0
7622	1817	114	1m  	239	1527
7623	1817	114	1m  	240	1527
7624	1817	114	+   	241	1527
7625	1817	114	+   	242	1527
7626	1818	127	+   	239	0
7627	1818	127	+   	240	0
7628	1818	127	+   	241	0
7629	1818	127	+   	242	0
7630	1819	1101	1   	239	113
7631	1819	1101	1   	240	113
7632	1819	1101	1   	241	113
7633	1819	1101	1   	242	113
7634	1820	616	1   	239	111
7635	1820	616	1   	240	111
7636	1820	616	1   	241	111
7637	1820	616	1   	242	111
7638	1821	324	1   	239	114
7639	1821	324	1   	240	114
7640	1821	324	1   	241	114
7641	1821	324	1   	242	114
7642	1822	1136	+   	239	0
7643	1823	357	+   	239	0
7644	1823	357	+   	240	0
7645	1823	357	+   	241	0
7646	1823	357	+   	242	0
7647	1824	382	1   	239	0
7648	1824	382	+   	240	0
7649	1824	382	1m  	241	0
7650	1824	382	1m  	242	0
7651	1825	439	1   	239	0
7652	1825	439	+   	240	0
7653	1825	439	1m  	241	0
7654	1825	439	1m  	242	0
7655	1826	305	+   	239	0
7656	1826	305	1   	240	0
7657	1826	305	1   	241	0
7658	1826	305	1   	242	0
7659	1827	366	+   	239	0
7660	1827	366	+   	240	0
7661	1827	366	1   	241	0
7662	1827	366	+   	242	0
7663	1828	418	+   	239	0
7664	1828	418	+   	240	0
7665	1828	418	1m  	241	0
7666	1828	418	1m  	242	0
7667	1829	153	2b  	239	109
7668	1830	223	1   	239	0
7669	1830	223	a   	240	0
7670	1830	223	+   	241	0
7671	1830	223	1   	242	0
7672	1831	444	1m  	239	117
7673	1831	444	+   	240	117
7674	1831	444	1m  	241	117
7675	1831	444	1m  	242	117
7676	1832	286	1m  	239	0
7677	1833	119	+   	239	0
7678	1833	119	+   	240	0
7679	1833	119	+   	241	0
7680	1834	398	+   	239	0
7681	1834	398	a   	240	0
7682	1835	437	+   	239	116
7683	1835	437	+   	240	116
7684	1835	437	1m  	241	116
7685	1835	437	1m  	242	116
7686	1836	11	+   	239	0
7687	1836	11	+   	240	0
7688	1836	11	+   	241	0
7689	1836	11	1m  	242	0
7690	1837	15	1   	239	0
7691	1837	15	1m  	240	0
7692	1837	15	1m  	241	0
7693	1837	15	1m  	242	0
7694	1838	95	+   	239	0
7695	1838	95	1m  	240	0
7696	1839	273	1m  	239	119
7697	1839	273	+   	240	119
7698	1839	273	+   	241	119
7699	1839	273	+   	242	119
7700	1840	518	1m  	239	120
7701	1840	518	1m  	240	120
7702	1840	518	1m  	241	120
7703	1840	518	1m  	242	120
7704	1841	560	+   	239	0
7705	1841	560	+   	240	0
7706	1841	560	+   	241	0
7707	1841	560	+   	242	0
7708	1842	213	+   	239	0
7709	1842	213	+   	240	0
7710	1842	213	+   	241	0
7711	1842	213	+   	242	0
7712	1843	144	+   	239	0
7713	1843	144	+   	240	0
7714	1843	144	+   	241	0
7715	1843	144	1   	242	0
7716	1844	77	a   	239	0
7717	1845	389	a   	239	0
7718	1845	389	1m  	242	0
7719	1846	559	1   	240	0
7720	1847	236	+   	239	0
7721	1847	236	+   	240	0
7722	1847	236	1m  	241	0
7723	1847	236	+   	242	0
7724	1848	206	+   	240	0
7725	1849	487	1   	241	0
7726	1849	487	1   	242	0
7727	1850	169	+   	242	0
7728	1851	55	+   	242	0
7729	1852	147	1m  	242	0
7730	1853	91	a   	242	112
7731	1854	424	+   	240	0
7732	1876	506	3   	243	143
7733	1876	506	3   	244	143
7734	1877	505	1m  	243	142
7735	1877	505	1m  	244	142
7736	1878	11	2b  	243	141
7737	1878	11	2a  	244	141
7738	1879	30	1m  	243	140
7739	1879	30	1m  	244	140
7740	1880	20	2b  	243	139
7741	1880	20	2a  	244	139
7742	1881	4	2a  	244	190
7743	1882	56	1   	244	0
7744	1883	1136	1   	243	160
7745	1883	1136	1   	244	160
7746	1884	324	1   	243	145
7747	1884	324	1   	244	145
7748	1885	410	2b  	243	148
7749	1885	410	2a  	244	148
7750	1886	308	1m  	243	156
7751	1886	308	1m  	244	156
7752	1887	275	1m  	243	151
7753	1887	275	1m  	244	151
7754	1888	765	1m  	243	147
7755	1888	765	1m  	244	147
7756	1889	298	+   	243	155
7757	1889	298	+   	244	155
7758	1890	373	1m  	243	189
7759	1890	373	1m  	244	189
7760	1891	41	1   	243	146
7761	1891	41	1   	244	146
7762	1892	95	+   	243	149
7763	1892	95	+   	244	149
7764	1893	128	+   	243	150
7765	1893	128	+   	244	150
7766	1894	363	1m  	243	153
7767	1894	363	1m  	244	153
7768	1895	397	1m  	243	154
7769	1895	397	1m  	244	154
7770	1896	357	+   	243	157
7771	1897	275	+   	243	159
7772	1897	275	1m  	244	159
7773	1898	512	1m  	243	161
7774	1898	512	1m  	244	161
7775	1899	363	1m  	243	191
7776	1899	363	1   	244	191
7777	1900	20	2b  	245	0
7778	1901	12	1m  	245	173
7779	1902	16	1m  	245	186
7780	1903	324	1   	245	0
7781	1904	424	1   	245	0
7782	1905	56	+   	245	0
7783	1906	805	+   	245	187
7784	1907	55	1   	245	170
7785	1908	385	1m  	245	166
7786	1909	84	1m  	245	169
7787	1910	114	+   	245	172
7788	1911	134	+   	245	171
7789	1912	512	+   	245	0
7790	1913	373	1m  	245	0
7791	1914	382	1m  	245	164
7792	1915	616	a   	245	165
7793	1916	397	1m  	245	167
7794	1917	255	1   	245	174
7795	1918	1138	+   	245	175
7796	1919	60	+   	245	188
7797	1920	410	1   	245	177
7798	1921	1103	+   	245	176
7799	1922	418	1   	245	178
7800	1923	205	+   	245	179
7801	1924	357	+   	245	180
7802	1925	527	+   	245	0
7803	1926	110	+   	245	182
7804	1927	400	+   	245	181
7805	1928	524	+   	245	184
7806	1929	1136	1   	245	0
7807	1930	236	+   	245	0
7808	1931	275	1m  	245	152
7809	1932	26	1m  	246	245
7810	1932	26	1m  	248	245
7811	1933	20	2a  	246	246
7812	1933	20	2b  	248	246
7813	1933	20	2a  	249	246
7814	1934	12	1m  	246	229
7815	1934	12	1m  	248	229
7816	1935	15	2b  	246	250
7817	1935	15	2a  	247	250
7818	1935	15	2a  	248	250
7819	1935	15	2a  	249	250
7820	1936	4	1m  	246	247
7821	1936	4	1   	247	247
7822	1936	4	2a  	248	247
7823	1936	4	2a  	249	247
7824	1937	11	1m  	246	201
7825	1938	12	1m  	246	249
7826	1938	12	1m  	248	249
7827	1939	144	+   	246	0
7828	1939	144	+   	247	0
7829	1939	144	+   	248	0
7830	1940	318	a   	246	279
7831	1940	318	+   	248	279
7832	1940	318	1   	249	279
7833	1941	314	r   	246	251
7834	1942	527	1   	246	252
7835	1942	527	+   	247	252
7836	1942	527	+   	248	252
7837	1942	527	+   	249	252
7838	1943	287	+   	246	0
7839	1943	287	1   	247	0
7840	1943	287	+   	248	0
7841	1943	287	+   	249	0
7842	1944	345	+   	246	228
7843	1945	191	+   	246	234
7844	1945	191	1   	247	234
7845	1945	191	+   	248	234
7846	1945	191	1   	249	234
7847	1946	181	1   	246	196
7848	1946	181	1   	248	196
7849	1946	181	1   	249	196
7850	1947	184	1   	246	233
7851	1948	188	1   	248	281
7852	1949	164	1m  	246	219
7853	1949	164	1m  	247	219
7854	1949	164	1m  	248	219
7855	1949	164	1m  	249	219
7856	1950	168	1   	246	193
7857	1950	168	1   	247	193
7858	1951	289	1m  	246	210
7859	1952	805	1   	246	206
7860	1952	805	+   	247	206
7861	1953	77	+   	246	199
7862	1954	143	+   	246	192
7863	1955	418	1   	246	211
7864	1955	418	1   	247	211
7865	1955	418	+   	248	211
7866	1955	418	+   	249	211
7867	1956	513	1m  	246	208
7868	1956	513	+   	248	208
7869	1957	616	+   	246	0
7870	1958	560	1m  	246	0
7871	1959	524	+   	246	231
7872	1959	524	1m  	247	231
7873	1959	524	1m  	248	231
7874	1960	273	+   	246	227
7875	1961	255	+   	246	200
7876	1961	255	+   	247	200
7877	1961	255	1   	248	200
7878	1962	79	1m  	246	203
7879	1962	79	+   	248	203
7880	1963	362	1   	246	242
7881	1963	362	1   	247	242
7882	1963	362	1   	248	242
7883	1963	362	1   	249	242
7884	1964	212	+   	246	197
7885	1965	201	+   	246	217
7886	1965	201	1   	247	217
7887	1965	201	1   	248	217
7888	1965	201	1   	249	217
7889	1966	380	1m  	246	230
7890	1966	380	1m  	248	230
7891	1966	380	1m  	249	230
7892	1967	359	+   	246	212
7893	1967	359	+   	249	212
7894	1968	373	1m  	246	202
7895	1968	373	1m  	247	202
7896	1968	373	1m  	248	202
7897	1968	373	1m  	249	202
7898	1969	232	1   	246	204
7899	1969	232	1   	247	204
7900	1970	275	1m  	246	213
7901	1971	389	+   	246	215
7902	1971	389	+   	248	215
7903	1971	389	1   	249	215
7904	1972	385	1m  	246	216
7905	1972	385	+   	248	216
7906	1972	385	+   	249	216
7907	1973	236	+   	246	218
7908	1974	437	+   	246	220
7909	1975	2135	1m  	246	223
7910	1975	2135	1m  	247	223
7911	1975	2135	1m  	248	223
7912	1976	545	1   	246	225
7913	1976	545	1   	248	225
7914	1976	545	+   	249	225
7915	1977	425	r   	246	236
7916	1978	413	1   	246	238
7917	1978	413	1   	248	238
7918	1978	413	1   	249	238
7919	1979	123	1   	246	239
7920	1980	1101	+   	246	241
7921	1980	1101	+   	248	241
7922	1981	1103	+   	246	243
7923	1982	275	+   	246	244
7924	1983	561	+   	246	0
7925	1983	561	1   	247	0
7926	1983	561	+   	248	0
7927	1983	561	1   	249	0
7928	1984	45	1   	247	263
7929	1984	45	1   	248	263
7930	1985	148	+   	247	255
7931	1985	148	+   	248	255
7932	1986	937	r   	246	270
7933	1986	937	r   	247	270
7934	1986	937	+   	249	270
7935	1987	249	1   	247	254
7936	1987	249	a   	249	254
7937	1988	541	1   	247	271
7938	1989	105	1m  	247	262
7939	1989	105	+   	248	262
7940	1989	105	+   	249	262
7941	1990	64	1   	247	260
7942	1990	64	a   	249	260
7943	1991	174	+   	247	259
7944	1992	356	+   	247	261
7945	1992	356	+   	248	261
7946	1992	356	1   	249	261
7947	1993	551	1m  	247	258
7948	1993	551	+   	249	258
7949	1994	340	1   	247	275
7950	1994	340	1   	248	275
7951	1994	340	1   	249	275
7952	1995	306	1   	247	274
7953	1995	306	1   	248	274
7954	1995	306	+   	249	274
7955	1996	509	1m  	247	256
7956	1997	48	+   	247	264
7957	1997	48	+   	248	264
7958	1997	48	+   	249	264
7959	1998	296	1m  	247	272
7960	1998	296	+   	248	272
7961	1998	296	+   	249	272
7962	1999	345	1   	247	273
7963	1999	345	1   	248	273
7964	1999	345	1   	249	273
7965	2000	416	1m  	247	276
7966	2001	223	+   	247	277
7967	2001	223	+   	249	277
7968	2002	487	1   	248	278
7969	2003	619	+   	248	0
7970	2003	619	+   	249	0
7971	2004	279	1m  	247	534
7972	2004	279	1m  	248	534
7973	2004	279	1m  	249	534
7974	2005	400	1   	248	282
7975	2005	400	1   	249	282
7976	2006	455	a   	246	284
7977	2006	455	+   	248	284
7978	2007	257	+   	249	283
7979	2008	190	3   	253	287
7980	2009	324	1   	253	303
7981	2010	345	2b  	253	304
7982	2011	56	+   	253	0
7983	2012	144	+   	253	0
7984	2013	345	1   	253	305
7985	2014	215	1m  	253	293
7986	2015	248	1m  	253	296
7987	2016	30	1m  	253	288
7988	2017	12	1m  	253	289
7989	2018	7	1m  	253	0
7990	2019	30	1m  	253	290
7991	2020	307	1m  	253	295
7992	2021	123	1   	253	298
7993	2022	198	+   	253	294
7994	2023	937	1   	253	291
7995	2024	362	1m  	253	301
7996	2025	366	+   	253	302
7997	2026	39	+   	253	292
7998	2027	188	+   	253	0
7999	2028	356	1   	253	0
8000	2029	560	1m  	253	0
8001	2030	563	+   	253	0
8002	2031	426	+   	253	299
8003	2032	580	1m  	253	300
8004	2033	110	+   	253	306
8005	2034	20	1   	254	322
8006	2034	20	1m  	255	322
8007	2034	20	2a  	256	322
8008	2034	20	1m  	257	322
8009	2035	12	1m  	254	0
8010	2035	12	1m  	255	0
8011	2036	12	1m  	254	0
8012	2036	12	1m  	255	0
8013	2037	30	1   	254	0
8014	2037	30	1m  	255	0
8015	2037	30	1m  	256	0
8016	2037	30	1m  	257	0
8017	2038	19	1m  	254	308
8018	2038	19	1m  	255	308
8019	2038	19	1m  	256	308
8020	2038	19	1m  	257	308
8021	2039	3	1m  	254	312
8022	2040	7	1m  	254	0
8023	2041	345	2b  	254	0
8024	2041	345	2a  	255	0
8025	2041	345	+   	256	0
8026	2041	345	1   	257	0
8027	2042	345	1   	254	0
8028	2042	345	1   	255	0
8029	2042	345	+   	256	0
8030	2042	345	+   	257	0
8031	2043	790	1   	254	310
8032	2043	790	1   	256	310
8033	2043	790	1   	257	310
8034	2044	144	1   	254	0
8035	2044	144	+   	255	0
8036	2044	144	+   	256	0
8037	2044	144	1   	257	0
8038	2045	56	2a  	255	0
8039	2045	56	1   	256	0
8040	2045	56	2b  	257	0
8041	2046	4	1   	254	0
8042	2046	4	1   	255	0
8043	2046	4	1m  	256	0
8044	2046	4	1   	257	0
8045	2047	619	1m  	254	0
8046	2047	619	1m  	255	0
8047	2048	215	1m  	254	0
8048	2048	215	1m  	255	0
8049	2048	215	+   	256	0
8050	2048	215	+   	257	0
8051	2049	184	1   	254	0
8052	2049	184	1   	255	0
8053	2049	184	+   	256	0
8054	2049	184	1   	257	0
8055	2050	188	1   	254	0
8056	2050	188	1   	255	0
8057	2050	188	+   	256	0
8058	2050	188	1   	257	0
8059	2051	275	1m  	254	0
8060	2051	275	1m  	255	0
8061	2051	275	1m  	256	0
8062	2051	275	1m  	257	0
8063	2052	123	1   	254	0
8064	2052	123	1m  	255	0
8065	2052	123	1m  	256	0
8066	2052	123	1   	257	0
8067	2053	527	+   	256	336
8068	2053	527	+   	257	336
8069	2054	190	1   	254	0
8070	2054	190	+   	256	0
8071	2054	190	1   	257	0
8072	2055	512	1m  	254	324
8073	2055	512	1m  	255	324
8074	2055	512	1m  	256	324
8075	2055	512	1m  	257	324
8076	2056	255	1   	254	0
8077	2056	255	+   	255	0
8078	2056	255	1   	256	0
8079	2056	255	+   	257	0
8080	2057	307	1m  	254	0
8081	2057	307	+   	255	0
8082	2058	2142	+   	254	307
8083	2059	232	1   	254	0
8084	2059	232	+   	255	0
8085	2059	232	+   	256	0
8086	2059	232	1   	257	0
8087	2060	181	1   	254	0
8088	2060	181	1   	255	0
8089	2061	426	1   	254	0
8090	2061	426	+   	255	0
8091	2061	426	+   	256	0
8092	2061	426	+   	257	0
8093	2062	1108	+   	254	311
8094	2063	332	+   	254	314
8095	2063	332	+   	256	314
8096	2063	332	1m  	257	314
8097	2064	167	1m  	254	0
8098	2064	167	1m  	255	0
8099	2064	167	1   	256	0
8100	2064	167	1m  	257	0
8101	2065	227	+   	254	316
8102	2065	227	+   	255	316
8103	2066	362	+   	254	0
8104	2066	362	+   	255	0
8105	2066	362	1   	256	0
8106	2066	362	1   	257	0
8107	2067	2135	+   	257	337
8108	2068	15	2a  	255	0
8109	2068	15	2a  	256	0
8110	2068	15	2a  	257	0
8111	2069	937	+   	256	0
8112	2069	937	+   	257	0
8113	2070	236	+   	255	0
8114	2071	219	1m  	255	318
8115	2072	100	+   	255	319
8116	2073	560	1m  	254	0
8117	2073	560	+   	255	0
8118	2073	560	+   	256	0
8119	2074	356	1   	254	0
8120	2074	356	1   	255	0
8121	2074	356	1   	256	0
8122	2074	356	1   	257	0
8123	2075	563	+   	254	0
8124	2075	563	+   	255	0
8125	2075	563	+   	256	0
8126	2075	563	+   	257	0
8127	2076	98	+   	255	320
8128	2077	21	1m  	254	321
8129	2077	21	2b  	255	321
8130	2077	21	2a  	256	321
8131	2077	21	2a  	257	321
8132	2078	487	1   	255	0
8133	2078	487	1   	256	0
8134	2078	487	+   	257	0
8135	2079	26	1m  	255	326
8136	2079	26	1m  	256	326
8137	2080	418	+   	255	0
8138	2080	418	+   	256	0
8139	2080	418	+   	257	0
8140	2081	100	+   	255	325
8141	2081	100	+   	257	325
8142	2082	564	+   	255	0
8143	2083	540	+   	255	327
8144	2083	540	+   	257	327
8145	2084	279	+   	256	0
8146	2085	509	+   	256	0
8147	2085	509	+   	257	0
8148	2086	73	r   	256	333
8149	2086	73	+   	257	333
8150	2087	45	+   	256	0
8151	2087	45	1   	257	0
8152	2088	403	r   	256	331
8153	2089	829	a   	255	329
8154	2089	829	+   	256	329
8155	2089	829	+   	257	329
8156	2090	286	+   	256	328
8157	2090	286	1m  	257	328
8158	2091	335	+   	256	332
8159	2092	59	1   	256	0
8160	2092	59	1   	257	0
8161	2093	373	1m  	256	0
8162	2093	373	1m  	257	0
8163	2094	137	1m  	256	330
8164	2094	137	+   	257	330
8165	2095	455	r   	256	0
8166	2096	1136	1   	256	0
8167	2097	580	+   	254	0
8168	2097	580	+   	256	0
8169	2097	580	+   	257	0
8170	2098	179	a   	257	338
8171	2100	19	1m  	258	0
8172	2100	19	1m  	259	0
8173	2100	19	1m  	260	0
8174	2100	19	1m  	261	0
8175	2100	19	1m  	263	0
8176	2101	12	1m  	258	0
8177	2101	12	1m  	259	0
8178	2101	12	1m  	260	0
8179	2101	12	1m  	261	0
8180	2101	12	1m  	262	0
8181	2101	12	1m  	263	0
8182	2102	12	1m  	260	0
8183	2102	12	1m  	261	0
8184	2102	12	1m  	262	0
8185	2102	12	1m  	263	0
8186	2103	11	1m  	259	385
8187	2103	11	1m  	260	385
8188	2103	11	1m  	261	385
8189	2103	11	1m  	262	385
8190	2103	11	1m  	263	385
8191	2104	4	1m  	258	372
8192	2104	4	1m  	259	372
8193	2104	4	+   	262	372
8194	2104	4	+   	263	372
8195	2105	16	2a  	258	371
8196	2105	16	2a  	259	371
8197	2105	16	2b  	260	371
8198	2105	16	2b  	261	371
8199	2105	16	2b  	262	371
8200	2105	16	2a  	263	371
8201	2106	324	+   	258	370
8202	2106	324	+   	263	370
8203	2107	324	1   	259	382
8204	2108	144	+   	258	0
8205	2108	144	+   	259	0
8206	2108	144	+   	260	0
8207	2108	144	+   	261	0
8208	2108	144	+   	262	0
8209	2109	527	+   	258	386
8210	2109	527	1m  	259	386
8211	2109	527	1   	260	386
8212	2109	527	1   	261	386
8213	2109	527	1   	262	386
8214	2109	527	1   	263	386
8215	2110	805	2a  	258	0
8216	2110	805	2a  	259	0
8217	2110	805	2a  	260	0
8218	2110	805	1   	261	0
8219	2110	805	2a  	262	0
8220	2110	805	1   	263	0
8221	2111	59	1   	258	0
8222	2111	59	1   	259	0
8223	2111	59	1   	260	0
8224	2111	59	1   	261	0
8225	2111	59	1   	262	0
8226	2111	59	1   	263	0
8227	2112	418	1   	258	0
8228	2112	418	1   	259	0
8229	2112	418	1   	260	0
8230	2112	418	1   	261	0
8231	2112	418	1   	262	0
8232	2112	418	1   	263	0
8233	2113	255	1   	258	0
8234	2113	255	1   	259	0
8235	2113	255	1m  	263	0
8236	2114	373	1m  	258	0
8237	2114	373	1   	259	0
8238	2114	373	1m  	260	0
8239	2114	373	1m  	261	0
8240	2114	373	1m  	262	0
8241	2114	373	1m  	263	0
8242	2115	452	+   	258	365
8243	2116	279	+   	259	0
8244	2116	279	+   	260	0
8245	2117	444	1m  	258	346
8246	2118	227	+   	258	0
8247	2118	227	+   	261	0
8248	2118	227	+   	263	0
8249	2119	265	+   	258	348
8250	2119	265	1m  	260	348
8251	2119	265	1m  	261	348
8252	2119	265	1m  	262	348
8253	2120	212	+   	258	349
8254	2120	212	+   	260	349
8255	2120	212	+   	261	349
8256	2120	212	+   	262	349
8257	2120	212	+   	263	349
8258	2121	147	+   	258	363
8259	2121	147	1   	259	363
8260	2121	147	2a  	260	363
8261	2121	147	2a  	261	363
8262	2121	147	1   	262	363
8263	2122	357	+   	258	350
8264	2123	558	+   	259	0
8265	2123	558	+   	260	0
8266	2123	558	+   	261	0
8267	2123	558	+   	262	0
8268	2123	558	+   	263	0
8269	2124	356	+   	258	362
8270	2124	356	+   	259	362
8271	2124	356	+   	263	362
8272	2125	2135	+   	258	355
8273	2125	2135	1m  	259	355
8274	2125	2135	1m  	260	355
8275	2125	2135	1m  	261	355
8276	2125	2135	1m  	262	355
8277	2126	286	+   	258	0
8278	2126	286	+   	259	0
8279	2126	286	1m  	261	0
8280	2126	286	+   	262	0
8281	2126	286	+   	263	0
8282	2127	114	1m  	258	354
8283	2127	114	+   	259	354
8284	2127	114	+   	262	354
8285	2127	114	+   	263	354
8286	2128	400	+   	258	352
8287	2129	1138	1   	258	364
8288	2130	275	1m  	258	369
8289	2130	275	1m  	259	369
8290	2130	275	1m  	260	369
8291	2130	275	1m  	261	369
8292	2130	275	1m  	262	369
8293	2130	275	1m  	263	369
8294	2131	385	+   	259	0
8295	2131	385	+   	263	0
8296	2132	381	+   	258	357
8297	2132	381	+   	260	357
8298	2133	512	1m  	258	0
8299	2133	512	1m  	259	0
8300	2133	512	1m  	261	0
8301	2133	512	1m  	262	0
8302	2133	512	1m  	263	0
8303	2134	273	1m  	258	359
8304	2134	273	1m  	260	359
8305	2134	273	+   	261	359
8306	2134	273	+   	262	359
8307	2134	273	+   	263	359
8308	2135	91	1m  	258	360
8309	2136	382	+   	258	366
8310	2137	1101	+   	258	0
8311	2137	1101	1m  	259	0
8312	2137	1101	1m  	260	0
8313	2137	1101	1m  	261	0
8314	2138	1101	1m  	259	379
8315	2138	1101	1m  	260	379
8316	2138	1101	+   	262	379
8317	2138	1101	+   	263	379
8318	2139	429	+   	259	375
8319	2139	429	+   	263	375
8320	2140	437	+   	259	380
8321	2140	437	1m  	260	380
8322	2140	437	1m  	261	380
8323	2140	437	1m  	262	380
8324	2140	437	1m  	263	380
8325	2141	120	+   	259	376
8326	2141	120	+   	260	376
8327	2141	120	+   	262	376
8328	2142	343	+   	259	373
8329	2143	565	+   	258	0
8330	2143	565	1m  	259	0
8331	2143	565	1m  	260	0
8332	2143	565	1m  	261	0
8333	2143	565	1m  	262	0
8334	2143	565	1m  	263	0
8335	2144	1136	+   	259	377
8336	2145	393	+   	259	381
8337	2145	393	1   	260	381
8338	2146	413	1m  	259	383
8339	2146	413	1   	260	383
8340	2146	413	1m  	262	383
8341	2147	110	1m  	260	388
8342	2147	110	+   	262	388
8343	2148	232	+   	259	0
8344	2148	232	+   	260	0
8345	2148	232	+   	262	0
8346	2148	232	+   	263	0
8347	2149	79	+   	258	0
8348	2149	79	+   	261	0
8349	2150	236	+   	259	0
8350	2150	236	+   	262	0
8351	2150	236	1   	263	0
8352	2151	377	1   	260	389
8353	2151	377	2a  	261	389
8354	2151	377	1   	262	389
8355	2152	96	+   	260	390
8356	2152	96	+   	262	390
8357	2153	986	1m  	261	0
8358	2154	297	+   	260	395
8359	2154	297	1m  	261	395
8360	2154	297	+   	262	395
8361	2155	55	1   	261	392
8362	2156	95	+   	258	394
8363	2156	95	1m  	261	394
8364	2156	95	1m  	262	394
8365	2156	95	1m  	263	394
8366	2157	142	+   	261	393
8367	2158	455	r   	261	0
8368	2159	410	1m  	261	397
8369	2159	410	1   	263	397
8370	2160	499	1m  	261	398
8371	2161	1113	+   	262	402
8372	2162	1138	+   	262	403
8373	2162	1138	+   	263	403
8374	2163	84	+   	263	404
8375	2164	509	a   	262	0
8376	2164	509	+   	263	0
8377	2165	554	a   	262	405
8378	2165	554	+   	263	405
8379	2166	208	+   	261	0
8380	2167	30	1m  	266	437
8381	2168	513	1m  	264	0
8382	2168	513	1m  	265	0
8383	2169	4	1   	264	0
8384	2169	4	1   	265	0
8385	2169	4	2b  	266	0
8386	2170	16	2a  	264	0
8387	2170	16	2a  	265	0
8388	2170	16	3   	266	0
8389	2171	12	1m  	264	0
8390	2171	12	1m  	266	0
8391	2172	11	1m  	264	0
8392	2172	11	+   	266	0
8393	2173	19	1   	264	412
8394	2174	15	1m  	264	416
8395	2174	15	1m  	265	416
8396	2175	318	+   	264	0
8397	2176	287	+   	264	0
8398	2176	287	+   	265	0
8399	2177	56	+   	264	0
8400	2177	56	+   	265	0
8401	2178	527	1   	264	0
8402	2178	527	1   	265	0
8403	2178	527	+   	266	0
8404	2179	805	2a  	264	0
8405	2179	805	1   	265	0
8406	2179	805	1   	266	0
8407	2180	314	1   	266	0
8408	2181	167	1m  	264	0
8409	2181	167	1m  	265	0
8410	2181	167	1m  	266	0
8411	2182	147	1   	264	0
8412	2182	147	+   	265	0
8413	2183	562	1m  	264	0
8414	2183	562	1m  	265	0
8415	2184	560	+   	264	0
8416	2184	560	1m  	265	0
8417	2185	512	1m  	264	0
8418	2185	512	1m  	265	0
8419	2185	512	1m  	266	0
8420	2186	79	+   	264	0
8421	2187	524	+   	264	410
8422	2188	524	1m  	265	426
8423	2189	275	1m  	264	0
8424	2189	275	1m  	265	0
8425	2189	275	1m  	266	0
8426	2190	373	1m  	264	0
8427	2190	373	1m  	265	0
8428	2190	373	1m  	266	0
8429	2191	455	1   	264	0
8430	2191	455	1   	265	0
8431	2191	455	1   	266	0
8432	2192	255	+   	264	0
8433	2192	255	1m  	265	0
8434	2192	255	+   	266	0
8435	2193	137	+   	264	0
8436	2194	168	1   	264	415
8437	2194	168	1   	265	415
8438	2195	389	+   	264	414
8439	2195	389	1   	265	414
8440	2196	264	+   	264	409
8441	2196	264	1m  	265	409
8442	2196	264	1m  	266	409
8443	2197	1136	1   	264	0
8444	2197	1136	+   	265	0
8445	2198	232	+   	264	0
8446	2198	232	+   	265	0
8447	2199	1101	1   	264	408
8448	2199	1101	1   	265	408
8449	2200	184	+   	264	0
8450	2200	184	+   	265	0
8451	2201	513	1m  	264	0
8452	2201	513	1m  	265	0
8453	2202	439	+   	264	407
8454	2202	439	+   	265	407
8455	2203	273	+   	264	0
8456	2203	273	1m  	265	0
8457	2203	273	+   	266	0
8458	2204	95	1m  	264	391
8459	2204	95	1m  	265	391
8460	2205	123	+   	264	411
8461	2205	123	+   	265	411
8462	2206	236	+   	264	0
8463	2206	236	1m  	265	0
8464	2206	236	1m  	266	0
8465	2207	400	+   	264	413
8466	2208	566	+   	264	0
8467	2208	566	1m  	265	0
8468	2208	566	1m  	266	0
8469	2209	2135	a   	265	0
8470	2210	403	+   	265	0
8471	2211	256	+   	265	418
8472	2212	306	1   	265	419
8473	2213	511	+   	265	424
8474	2214	456	+   	265	425
8475	2215	188	1   	265	0
8476	2215	188	1m  	266	0
8477	2216	418	+   	264	0
8478	2216	418	1   	265	0
8479	2216	418	+   	266	0
8480	2217	545	+   	265	422
8481	2218	416	+   	265	420
8482	2219	413	+   	265	421
8483	2219	413	+   	266	421
8484	2220	279	+   	265	427
8485	2220	279	+   	266	427
8486	2221	80	+   	265	0
8487	2222	380	1m  	266	0
8488	2223	765	1m  	266	0
8489	2224	297	1   	266	0
8490	2225	426	+   	266	0
8491	2226	110	1m  	266	0
8492	2227	356	1   	266	0
8493	2228	181	+   	266	0
8494	2229	230	1   	266	429
8495	2230	437	1m  	266	0
8496	2231	319	1m  	266	436
8497	2232	55	+   	266	435
8498	2233	377	+   	266	434
8499	2234	98	1   	266	0
8500	2235	111	+   	266	433
8501	2236	85	+   	266	431
8502	2237	439	+   	266	430
8503	2238	99	+   	266	432
8504	2239	16	1   	267	441
8505	2239	16	1m  	269	441
8506	2240	20	3   	267	440
8507	2240	20	2b  	269	440
8508	2241	4	2a  	267	0
8509	2241	4	2b  	269	0
8510	2242	11	1   	267	0
8511	2242	11	+   	269	0
8512	2243	19	1   	267	0
8513	2243	19	1   	269	0
8514	2244	144	1   	267	0
8515	2244	144	1   	269	0
8516	2245	805	1   	267	0
8517	2245	805	1   	269	0
8518	2246	986	1m  	267	462
8519	2246	986	+   	269	462
8520	2247	275	1m  	267	0
8521	2247	275	1m  	269	0
8522	2248	455	1   	267	451
8523	2248	455	1   	269	451
8524	2249	527	+   	267	0
8525	2249	527	+   	269	0
8526	2250	439	1m  	267	447
8527	2251	439	1m  	267	457
8528	2252	562	1m  	267	0
8529	2252	562	1m  	269	0
8530	2253	164	1   	267	456
8531	2253	164	1   	269	456
8532	2254	129	1m  	267	0
8533	2255	99	+   	267	0
8534	2256	373	1m  	267	0
8535	2256	373	1m  	269	0
8536	2257	566	+   	267	0
8537	2258	567	+   	267	0
8538	2259	308	1m  	267	0
8539	2260	255	1   	267	0
8540	2260	255	1   	269	0
8541	2261	385	+   	267	0
8542	2261	385	+   	269	0
8543	2262	279	1m  	267	0
8544	2262	279	+   	269	0
8545	2263	324	+   	267	568
8546	2263	324	1   	269	568
8547	2264	95	1m  	267	0
8548	2265	56	+   	267	0
8549	2266	512	1m  	267	0
8550	2267	73	+   	267	0
8551	2268	492	1m  	267	0
8552	2269	418	+   	267	0
8553	2269	418	+   	269	0
8554	2270	509	1m  	267	0
8555	2271	380	1m  	267	459
8556	2271	380	1m  	269	459
8557	2272	184	+   	267	0
8558	2273	30	1   	267	0
8559	2273	30	+   	269	0
8560	2274	188	1   	267	448
8561	2275	265	+   	267	0
8562	2276	413	1m  	267	449
8563	2277	110	+   	267	0
8564	2277	110	1m  	269	0
8565	2278	232	+   	267	453
8566	2279	366	+   	267	0
8567	2279	366	+   	269	0
8568	2280	80	+   	267	442
8569	2280	80	1m  	269	442
8570	2281	565	+   	267	0
8571	2282	437	1m  	267	454
8572	2283	410	+   	267	460
8573	2284	314	+   	267	452
8574	2285	139	+   	267	458
8575	2286	368	+   	267	463
8576	2287	318	1   	267	0
8577	2287	318	+   	269	0
8578	2288	45	+   	267	0
8579	2289	356	+   	267	0
8580	2289	356	2a  	269	0
8581	2290	79	+   	267	0
8582	2290	79	+   	269	0
8583	2291	424	+   	267	0
8584	2291	424	1m  	269	0
8585	2292	439	1   	267	455
8586	2293	400	1   	269	443
8587	2294	191	+   	269	445
8588	2295	287	1   	269	0
8589	2296	904	1m  	269	0
8590	2297	368	+   	269	446
8591	2298	111	+   	269	444
8592	2299	98	+   	269	0
8593	2300	389	+   	269	0
8594	2301	243	+   	269	438
8595	2302	94	+   	267	0
8596	2303	20	2b  	270	500
8597	2304	512	1m  	270	0
8598	2305	10	1m  	270	509
8599	2306	383	1m  	270	495
8600	2307	306	+   	270	498
8601	2308	64	1   	270	506
8602	2309	343	1   	270	508
8603	2310	373	1m  	270	493
8604	2311	356	+   	270	499
8605	2312	255	+   	270	503
8606	2313	286	1m  	270	497
8607	2314	299	+   	270	496
8608	2315	272	1   	270	510
8609	2316	221	+   	270	504
8610	2317	368	+   	270	492
8611	2318	367	1m  	270	507
8612	2319	95	+   	270	0
8613	2320	212	+   	270	501
8614	2321	279	1m  	270	502
8615	2322	11	1m  	272	0
8616	2322	11	1m  	273	0
8617	2323	20	3   	271	0
8618	2323	20	3   	272	0
8619	2323	20	3   	273	0
8620	2324	4	1   	271	469
8621	2324	4	1   	272	469
8622	2324	4	1   	273	469
8623	2325	30	1m  	272	0
8624	2325	30	1m  	273	0
8625	2326	12	1m  	271	470
8626	2326	12	1m  	272	470
8627	2326	12	1m  	273	470
8628	2327	20	1m  	271	0
8629	2327	20	1m  	272	0
8630	2327	20	1m  	273	0
8631	2328	15	+   	271	491
8632	2328	15	1   	272	491
8633	2328	15	1   	273	491
8634	2329	144	2a  	271	0
8635	2329	144	+   	272	0
8636	2329	144	1   	273	0
8637	2330	324	1   	271	473
8638	2330	324	+   	272	473
8639	2330	324	+   	273	473
8640	2331	56	1   	271	0
8641	2331	56	+   	272	0
8642	2331	56	+   	273	0
8643	2332	191	1   	272	479
8644	2332	191	+   	273	479
8645	2333	254	1   	271	0
8646	2333	254	1m  	273	0
8647	2334	181	1   	271	0
8648	2335	527	+   	271	478
8649	2335	527	1m  	272	478
8650	2335	527	+   	273	478
8651	2336	373	1m  	271	0
8652	2336	373	1m  	272	0
8653	2336	373	1m  	273	0
8654	2337	319	1m  	271	471
8655	2338	418	1   	271	0
8656	2338	418	1m  	272	0
8657	2338	418	1   	273	0
8658	2339	403	1   	271	465
8659	2339	403	1   	272	465
8660	2339	403	1   	273	465
8661	2340	426	+   	271	468
8662	2340	426	+   	272	468
8663	2340	426	+   	273	468
8664	2341	455	+   	271	0
8665	2341	455	+   	272	0
8666	2341	455	+   	273	0
8667	2342	123	1m  	271	466
8668	2342	123	1m  	272	466
8669	2342	123	1m  	273	466
8670	2343	64	1m  	271	464
8671	2344	275	1m  	271	0
8672	2344	275	1m  	272	0
8673	2344	275	1m  	273	0
8674	2345	356	1   	271	474
8675	2345	356	+   	272	474
8676	2345	356	1   	273	474
8677	2346	215	1m  	271	467
8678	2346	215	1m  	272	467
8679	2346	215	1m  	273	467
8680	2347	512	1m  	271	0
8681	2347	512	1m  	272	0
8682	2347	512	1m  	273	0
8683	2348	167	+   	271	475
8684	2349	362	1m  	271	476
8685	2349	362	+   	273	476
8686	2350	296	a   	271	477
8687	2350	296	+   	272	477
8688	2350	296	+   	273	477
8689	2351	513	1m  	272	0
8690	2351	513	1m  	273	0
8691	2352	385	1m  	272	0
8692	2352	385	1m  	273	0
8693	2353	59	1   	272	0
8694	2353	59	1   	273	0
8695	2354	805	1   	272	0
8696	2354	805	1   	273	0
8697	2355	567	+   	272	0
8698	2356	1136	1   	272	0
8699	2356	1136	1   	273	0
8700	2357	566	1m  	272	0
8701	2357	566	1m  	273	0
8702	2358	394	1   	272	485
8703	2358	394	1m  	273	485
8704	2359	95	+   	272	0
8705	2359	95	+   	273	0
8706	2360	129	1m  	272	0
8707	2360	129	1m  	273	0
8708	2361	147	+   	272	0
8709	2361	147	1   	273	0
8710	2362	487	1   	272	0
8711	2363	492	1m  	272	0
8712	2363	492	1m  	273	0
8713	2364	110	+   	272	481
8714	2364	110	+   	273	481
8715	2365	245	+   	272	490
8716	2366	167	+   	272	0
8717	2366	167	1m  	273	0
8718	2367	565	+   	272	0
8719	2367	565	+   	273	0
8720	2368	297	+   	272	0
8721	2368	297	+   	273	0
8722	2369	232	1   	272	488
8723	2369	232	+   	273	488
8724	2370	366	+   	272	489
8725	2370	366	+   	273	489
8726	2371	318	+   	272	0
8727	2371	318	+   	273	0
8728	2372	206	+   	272	0
8729	2372	206	+   	273	0
8730	2373	273	1m  	272	0
8731	2373	273	+   	273	0
8732	2374	265	+   	272	482
8733	2375	212	+   	272	486
8734	2375	212	+   	273	486
8735	2376	548	+   	272	484
8736	2377	437	+   	272	480
8737	2377	437	1m  	273	480
8738	2378	413	1m  	272	487
8739	2378	413	1m  	273	487
8740	2379	509	+   	273	0
8741	2380	208	+   	271	0
8742	2380	208	+   	273	0
8743	2381	986	a   	271	0
8744	2381	986	+   	273	0
8745	2382	73	+   	273	0
8746	2383	12	1m  	393	0
8747	2384	30	1m  	388	0
8748	2384	30	1   	389	0
8749	2384	30	1   	390	0
8750	2384	30	1m  	392	0
8751	2384	30	2a  	393	0
8752	2385	11	1m  	389	1388
8753	2385	11	1   	390	1388
8754	2385	11	1   	392	1388
8755	2385	11	1m  	393	1388
8756	2386	19	1m  	380	1292
8757	2389	479	1m  	374	1185
8758	2390	59	1   	246	226
8759	2391	195	+   	381	268
8760	2392	72	+   	233	102
8761	2393	123	1   	364	1137
8762	2394	130	+   	206	743
8763	2394	130	+   	217	743
8764	2395	1164	+   	375	1220
8765	2396	381	1m  	374	1179
8766	2397	311	1m  	374	1180
8767	2398	400	+   	265	423
8768	2399	381	1   	351	1104
8769	2399	381	1m  	369	1104
8770	2400	366	1m  	245	168
8771	2401	394	1   	383	1336
8772	2402	437	+   	274	629
8773	2403	437	+   	276	670
8774	2404	499	1   	263	399
8775	2405	418	1   	263	400
8776	2406	418	1   	368	1101
8777	2406	418	1   	351	1101
8778	2409	505	3   	243	144
8779	2409	505	3   	244	144
8780	2410	505	1m  	382	1323
8781	2410	505	1m  	385	1323
8782	2410	505	1m  	386	1323
8783	2412	549	1m  	311	713
8784	2413	130	1m  	318	0
8785	2413	130	1m  	324	0
8786	2413	130	1m  	325	0
8787	2414	387	1   	358	1017
8788	2414	387	+   	359	1017
8789	2415	132	1m  	341	882
8790	2415	132	1m  	342	882
8791	2416	14	1m  	355	982
8792	2416	14	1m  	356	982
8793	2417	393	1m  	363	1105
8794	2419	363	+   	375	1216
8795	2420	2135	1m  	263	356
8796	2421	297	1   	263	396
8797	2423	363	1m  	275	614
8798	2425	412	1m  	342	888
8799	2427	510	+   	283	645
8800	2427	510	+   	291	645
8801	2428	195	1   	329	801
8802	2429	18	1m  	344	850
8803	2429	18	2b  	348	850
8804	2430	30	1m  	344	877
8805	2430	30	a   	345	877
8806	2430	30	1m  	346	877
8807	2430	30	1m  	347	877
8808	2430	30	1m  	348	877
8809	2431	26	1m  	344	879
8810	2431	26	1m  	346	879
8811	2431	26	1m  	348	879
8812	2432	273	1   	363	1111
8813	2433	13	1   	373	1161
8814	2434	214	1   	373	1163
8815	2435	265	+   	377	1223
8816	2436	340	+   	377	1232
8817	2437	15	1m  	377	1234
8818	2438	26	1   	377	1236
8819	2439	219	1m  	377	1238
8820	2440	256	1   	377	1248
8821	2441	11	1m  	385	1325
8822	2442	357	1   	244	158
8823	2443	212	1   	247	198
8824	2443	212	+   	248	198
8825	2443	212	1   	249	198
8826	2444	223	1   	248	205
8827	2444	223	1   	249	205
8828	2445	805	2a  	248	207
8829	2445	805	1   	249	207
8830	2446	275	1m  	247	214
8831	2446	275	1m  	248	214
8832	2446	275	1m  	249	214
8833	2447	437	1m  	248	221
8834	2448	2135	1m  	249	224
8835	2449	516	1m  	249	232
8836	2450	425	+   	248	237
8837	2451	1101	+   	248	240
8838	2451	1101	+   	249	240
8839	2452	509	1m  	249	257
8840	2453	3	1m  	256	313
8841	2454	227	+   	256	317
8842	2454	227	+   	257	317
8843	2455	444	1   	259	347
8844	2456	357	+   	259	351
8845	2456	357	1   	260	351
8846	2456	357	1   	261	351
8847	2456	357	1   	262	351
8848	2456	357	1   	263	351
8849	2457	400	1m  	259	353
8850	2457	400	1   	260	353
8851	2457	400	+   	261	353
8852	2457	400	1   	262	353
8853	2457	400	1   	263	353
8854	2458	214	1m  	261	358
8855	2458	214	1m  	262	358
8856	2458	214	1m  	263	358
8857	2459	382	1   	259	367
8858	2459	382	1   	260	367
8859	2460	382	1   	263	368
8860	2461	1136	2a  	260	378
8861	2461	1136	1   	261	378
8862	2461	1136	1   	262	378
8863	2461	1136	1   	263	378
8864	2462	416	1m  	263	384
8865	2463	342	+   	256	315
8866	2463	342	1m  	257	315
8867	2465	5	2b  	386	1320
8868	2466	26	1   	318	773
8869	2466	26	1   	324	773
8870	2466	26	1   	325	773
8871	2467	1107	1   	202	1466
8872	2467	1107	1   	282	1466
8873	2467	1107	1   	327	1466
8874	2467	1107	+   	337	1466
8875	2467	1107	1   	352	1466
8876	2470	50	1   	368	1084
8877	2470	50	1   	351	1084
8878	5000	807	2b  	60	0
8879	5000	807	2a  	11	0
8880	5000	807	1   	127	0
8881	5000	807	1   	135	0
8882	5001	124	2a  	60	0
8883	5001	124	1   	11	0
8884	5001	124	1   	127	0
8885	5001	124	1   	149	0
8886	5001	124	1   	164	0
8887	5002	678	1   	60	0
8888	5002	678	+   	11	0
8889	5003	530	1m  	60	0
8890	5003	530	1m  	11	0
8891	5003	530	+   	164	0
8892	5004	358	1   	60	0
8893	5004	358	1m  	11	0
8894	5004	358	+   	127	0
8895	5004	358	1   	135	0
8896	5004	358	+   	149	0
8897	5004	358	+   	164	0
8898	5005	257	+   	60	0
8899	5006	245	1   	60	0
8900	5007	735	1   	60	0
8901	5007	735	1   	11	0
8902	5007	735	+   	135	0
8903	5008	80	+   	60	0
8904	5008	80	+   	11	0
8905	5008	80	1m  	164	0
8906	5009	429	1   	60	0
8907	5009	429	+   	11	0
8908	5009	429	1m  	135	0
8909	5010	1141	1   	60	0
8910	5010	1141	2a  	11	0
8911	5010	1141	2a  	127	0
8912	5010	1141	3   	135	0
8913	5011	263	+   	60	0
8914	5011	263	+   	11	0
8915	5011	263	+   	135	0
8916	5011	263	1m  	149	0
8917	5011	263	+   	164	0
8918	5012	58	1   	60	0
8919	5012	58	1   	11	0
8920	5012	58	1   	127	0
8921	5012	58	+   	135	0
8922	5013	791	+   	60	0
8923	5013	791	1   	127	0
8924	5013	791	+   	135	0
8925	5013	791	1   	149	0
8926	5014	489	1m  	60	0
8927	5014	489	+   	11	0
8928	5014	489	1m  	127	0
8929	5014	489	1   	135	0
8930	5014	489	1   	149	0
8931	5014	489	+   	164	0
8932	5015	892	+   	60	0
8933	5015	892	1   	11	0
8934	5015	892	+   	127	0
8935	5015	892	2a  	135	0
8936	5015	892	1m  	164	0
8937	5016	418	+   	60	0
8938	5016	418	1   	11	0
8939	5016	418	1   	127	0
8940	5016	418	1   	135	0
8941	5017	937	1   	60	0
8942	5017	937	+   	11	0
8943	5018	102	+   	60	0
8944	5018	102	+   	11	0
8945	5018	102	+   	127	0
8946	5018	102	1   	135	0
8947	5018	102	+   	149	0
8948	5019	102	.   	60	0
8949	5020	606	1   	60	0
8950	5020	606	1   	11	0
8951	5020	606	+   	127	0
8952	5020	606	1   	135	0
8953	5021	89	+   	60	0
8954	5021	89	1m  	127	0
8955	5022	553	+   	60	0
8956	5023	988	1   	60	0
8957	5023	988	2a  	11	0
8958	5023	988	1   	127	0
8959	5024	145	1m  	60	0
8960	5024	145	1m  	11	0
8961	5024	145	1m  	127	0
8962	5024	145	+   	149	0
8963	5024	145	1m  	164	0
8964	5025	184	1   	60	0
8965	5025	184	2a  	11	0
8966	5025	184	2a  	127	0
8967	5025	184	1   	135	0
8968	5026	416	+   	60	0
8969	5026	416	1m  	11	0
8970	5027	290	+   	60	0
8971	5028	38	r   	60	0
8972	5029	237	+   	60	0
8973	5030	596	+   	60	0
8974	5030	596	1m  	11	0
8975	5030	596	1m  	127	0
8976	5030	596	1   	135	0
8977	5030	596	1   	149	0
8978	5031	62	+   	60	0
8979	5031	62	2a  	11	0
8980	5031	62	1   	127	0
8981	5031	62	1   	135	0
8982	5032	728	+   	60	0
8983	5032	728	1m  	11	0
8984	5033	178	+   	60	0
8985	5033	178	+   	127	0
8986	5034	596	.   	60	0
8987	5035	30	1m  	60	0
8988	5036	25	+   	60	0
8989	5036	25	1m  	11	0
8990	5037	26	1   	60	0
8991	5037	26	1m  	11	0
8992	5037	26	1m  	127	0
8993	5038	22	+   	60	0
8994	5039	12	1m  	60	0
8995	5039	12	1   	11	0
8996	5039	12	1m  	127	0
8997	5039	12	1   	135	0
8998	5039	12	+   	164	0
8999	5040	4	+   	60	0
9000	5041	237	1m  	127	0
9001	5044	919	1m  	127	0
9002	5045	218	+   	11	0
9003	5045	218	1m  	127	0
9004	5047	1122	r   	11	0
9005	5048	760	2a  	127	0
9006	5049	198	1   	127	0
9007	5050	496	+   	127	0
9008	5050	496	+   	135	0
9009	5051	937	+   	127	0
9010	5051	937	+   	164	0
9011	5053	262	+   	127	0
9012	5053	262	+   	149	0
9013	5055	570	1m  	135	0
9014	5055	570	1   	164	0
9015	5056	204	1   	135	0
9016	5057	515	1m  	135	0
9017	5057	515	1   	164	0
9018	5058	92	1m  	149	0
9019	5059	372	2a  	149	0
9020	5060	282	1   	149	0
9021	5060	282	1   	164	0
9022	5062	519	1m  	149	0
9023	5063	429	1m  	149	0
9024	5064	617	+   	149	0
9025	5065	494	1m  	149	0
9026	5066	102	.   	149	0
9027	5067	30	+   	149	0
9028	5068	847	2b  	164	0
9029	5069	58	1   	164	0
9030	5070	241	1   	164	0
9031	5071	733	1   	164	0
9032	5072	288	1m  	164	0
9033	5073	456	1   	164	0
9034	5074	706	1   	164	0
9035	5075	186	1m  	164	0
9036	5077	1105	r   	164	0
9037	5078	51	+   	164	0
9038	5079	7	+   	164	0
9039	5080	738	1   	164	0
9040	5081	247	r   	164	0
9041	5082	358	1   	171	0
9042	5082	358	1   	181	0
9043	5083	437	+   	171	0
9044	5083	437	1m  	181	0
9045	5083	437	1   	192	0
9046	5083	437	1   	61	0
9047	5084	119	1   	171	0
9048	5084	119	+   	181	0
9049	5085	130	1m  	171	0
9050	5085	130	1   	181	0
9051	5086	727	+   	171	0
9052	5087	394	+   	171	0
9053	5087	394	1   	181	0
9054	5088	11	+   	171	0
9055	5088	11	1m  	181	0
9056	5089	493	+   	171	0
9057	5089	493	1   	181	0
9058	5089	493	1   	192	0
9059	5089	493	1   	61	0
9060	5090	184	1   	171	0
9061	5090	184	1   	181	0
9062	5090	184	1m  	192	0
9063	5090	184	+   	61	0
9064	5091	116	+   	171	0
9065	5092	375	1   	171	0
9066	5092	375	+   	181	0
9067	5093	829	2a  	171	0
9068	5093	829	2b  	181	0
9069	5093	829	+   	192	0
9070	5093	829	+   	61	0
9071	5094	829	.   	171	0
9072	5095	56	1   	171	0
9073	5096	287	r   	181	0
9074	5096	287	2a  	192	0
9075	5096	287	2a  	61	0
9076	5096	287	2a  	72	0
9077	5096	287	1   	81	0
9078	5096	287	+   	87	0
9079	5096	287	1   	98	0
9080	5096	287	+   	109	0
9081	5096	287	2a  	3	0
9082	5096	287	1   	8	0
9083	5097	504	1m  	181	0
9084	5097	504	1m  	192	0
9085	5098	216	+   	181	0
9086	5099	429	+   	181	0
9087	5100	412	+   	181	0
9088	5101	523	+   	181	0
9089	5102	144	r   	181	0
9090	5102	144	1   	192	0
9091	5102	144	1   	61	0
9092	5102	144	+   	81	0
9093	5102	144	+   	87	0
9094	5102	144	+   	98	0
9095	5102	144	1   	109	0
9096	5102	144	1   	3	0
9097	5102	144	+   	8	0
9098	5103	937	+   	181	0
9099	5103	937	+   	192	0
9100	5103	937	+   	61	0
9101	5104	302	+   	192	0
9102	5104	302	+   	61	0
9103	5105	356	+   	192	0
9104	5105	356	+   	81	0
9105	5105	356	+   	87	0
9106	5106	363	1m  	192	0
9107	5106	363	1   	61	0
9108	5108	48	1   	192	0
9109	5108	48	2a  	61	0
9110	5108	48	+   	72	0
9111	5108	48	2a  	81	0
9112	5108	48	2a  	87	0
9113	5108	48	1   	98	0
9114	5108	48	2a  	109	0
9115	5108	48	1   	3	0
9116	5108	48	2b  	8	0
9117	5109	195	1   	61	0
9118	5109	195	3   	72	0
9119	5109	195	1   	98	0
9120	5110	269	+   	192	0
9121	5110	269	+   	61	0
9122	5111	19	+   	192	0
9123	5111	19	+   	61	0
9124	5112	514	1m  	192	0
9125	5112	514	+   	61	0
9126	5114	829	+   	72	0
9127	5115	431	+   	72	0
9128	5115	431	1   	98	0
9129	5116	57	+   	72	0
9130	5117	178	1   	72	0
9131	5117	178	1   	81	0
9132	5117	178	1   	87	0
9133	5117	178	1   	98	0
9134	5117	178	1   	109	0
9135	5117	178	1   	3	0
9136	5117	178	1   	8	0
9137	5118	865	+   	72	0
9138	5119	841	1m  	72	0
9139	5120	44	+   	72	0
9140	5120	44	+   	98	0
9141	5121	751	1m  	72	0
9142	5122	363	1m  	72	0
9143	5123	750	1m  	72	0
9144	5124	841	1m  	72	0
9145	5125	32	1m  	72	0
9146	5126	593	+   	72	0
9147	5127	138	1m  	72	0
9148	5128	31	1m  	72	0
9149	5129	465	+   	72	0
9150	5130	216	1   	72	0
9151	5131	165	+   	72	0
9152	5132	436	1   	72	0
9153	5133	434	+   	72	0
9154	5134	492	1m  	72	0
9155	5135	251	1m  	72	0
9156	5136	577	+   	72	0
9157	5137	304	1   	72	0
9158	5138	12	1   	72	0
9159	5139	443	1m  	72	0
9160	5140	599	1m  	72	0
9161	5141	132	1m  	72	0
9162	5142	408	+   	72	0
9163	5143	607	+   	72	0
9164	5144	391	1m  	72	0
9165	5145	380	1m  	72	0
9166	5146	104	+   	72	0
9167	5147	800	1m  	72	0
9168	5148	812	+   	72	0
9169	5150	18	+   	72	0
9170	5151	18	1   	72	0
9171	5152	488	+   	72	0
9172	5153	184	+   	72	0
9173	5154	348	+   	72	0
9174	5155	336	+   	72	0
9175	5155	336	1m  	81	0
9176	5155	336	+   	87	0
9177	5155	336	1m  	98	0
9178	5155	336	+   	109	0
9179	5155	336	+   	8	0
9180	5156	242	+   	72	0
9181	5157	937	+   	72	0
9182	5158	316	+   	72	0
9183	5159	716	+   	72	0
9184	5160	649	a   	72	0
9185	5161	246	1   	72	0
9186	5163	488	1m  	81	0
9187	5163	488	1   	87	0
9188	5164	488	.   	81	0
9189	5165	427	+   	81	0
9190	5165	427	2a  	98	0
9191	5165	427	+   	109	0
9192	5166	79	+   	81	0
9193	5166	79	1m  	87	0
9194	5167	302	+   	81	0
9195	5167	302	1   	98	0
9196	5167	302	1   	109	0
9197	5167	302	1   	3	0
9198	5167	302	+   	8	0
9199	5168	274	+   	81	0
9200	5168	274	1   	98	0
9201	5169	302	1   	81	0
9202	5169	302	1   	87	0
9203	5170	50	+   	81	0
9204	5170	50	1m  	87	0
9205	5170	50	+   	109	0
9206	5170	50	1m  	3	0
9207	5171	391	+   	81	0
9208	5172	363	.   	81	0
9209	5173	363	1   	81	0
9210	5174	1139	1   	81	0
9211	5174	1139	+   	87	0
9212	5174	1139	+   	8	0
9213	5175	570	+   	81	0
9214	5175	570	+   	109	0
9215	5175	570	+   	3	0
9216	5175	570	+   	8	0
9217	5176	146	1m  	81	0
9218	5176	146	+   	87	0
9219	5177	279	1   	192	0
9220	5177	279	1   	61	0
9221	5177	279	1m  	81	0
9222	5177	279	1m  	87	0
9223	5177	279	1m  	98	0
9224	5177	279	1   	109	0
9225	5177	279	1m  	3	0
9226	5177	279	+   	8	0
9227	5178	117	+   	81	0
9228	5178	117	+   	87	0
9229	5178	117	+   	109	0
9230	5178	117	1   	3	0
9231	5178	117	+   	8	0
9232	5179	31	1   	81	0
9233	5179	31	+   	87	0
9234	5179	31	+   	8	0
9235	5180	22	1   	81	0
9236	5180	22	1   	87	0
9237	5182	992	+   	81	0
9238	5183	490	+   	81	0
9239	5184	833	1   	81	0
9240	5184	833	3   	98	0
9241	5185	829	+   	98	0
9242	5186	363	.   	81	0
9243	5186	363	1m  	87	0
9244	5187	443	.   	81	0
9245	5188	104	+   	81	0
9246	5188	104	+   	87	0
9247	5189	599	1m  	81	0
9248	5189	599	+   	8	0
9249	5190	184	1m  	81	0
9250	5190	184	+   	87	0
9251	5190	184	1   	109	0
9252	5190	184	2a  	8	0
9253	5191	165	1m  	81	0
9254	5191	165	1   	87	0
9255	5191	165	1   	98	0
9256	5191	165	+   	109	0
9257	5191	165	1   	3	0
9258	5191	165	1   	8	0
9259	5193	330	1   	81	0
9260	5193	330	1   	87	0
9261	5193	330	+   	109	0
9262	5193	330	+   	8	0
9263	5194	443	1m  	81	0
9264	5194	443	+   	87	0
9265	5195	26	1   	81	0
9266	5195	26	1   	87	0
9267	5195	26	+   	98	0
9268	5196	982	+   	81	0
9269	5196	982	+   	87	0
9270	5197	599	+   	81	0
9271	5198	130	r   	81	0
9272	5199	842	r   	81	0
9273	5200	829	2a  	81	0
9274	5200	829	3   	87	0
9275	5201	242	+   	81	0
9276	5201	242	1m  	87	0
9277	5202	456	1   	87	0
9278	5203	198	+   	87	0
9279	5203	198	1m  	3	0
9280	5204	488	.   	87	0
9281	5205	358	+   	87	0
9282	5205	358	1m  	109	0
9283	5205	358	+   	3	0
9284	5205	358	1m  	8	0
9285	5206	94	+   	87	0
9286	5206	94	+   	109	0
9287	5206	94	1m  	3	0
9288	5206	94	+   	8	0
9289	5207	257	+   	87	0
9290	5207	257	+   	109	0
9291	5208	579	1m  	87	0
9292	5209	130	+   	87	0
9293	5209	130	+   	109	0
9294	5210	1110	+   	87	0
9295	5210	1110	+   	109	0
9296	5210	1110	+   	3	0
9297	5210	1110	+   	8	0
9298	5211	418	+   	98	0
9299	5212	363	1   	98	0
9300	5213	25	+   	98	0
9301	5214	653	+   	98	0
9302	5215	390	+   	98	0
9303	5217	50	+   	98	0
9304	5218	504	+   	98	0
9305	5219	186	1m  	98	0
9306	5219	186	1m  	8	0
9307	5220	1103	+   	98	0
9308	5221	188	1   	98	0
9309	5221	188	1   	109	0
9310	5221	188	+   	3	0
9311	5221	188	1   	8	0
9312	5222	318	1m  	98	0
9313	5222	318	+   	8	0
9314	5223	156	+   	98	0
9315	5224	363	.   	98	0
9316	5225	873	1   	98	0
9317	5225	873	1   	8	0
9318	5226	823	+   	98	0
9319	5227	277	1   	109	0
9320	5227	277	1m  	3	0
9321	5227	277	1m  	8	0
9322	5228	348	2a  	109	0
9323	5228	348	1   	3	0
9324	5229	794	1   	109	0
9325	5229	794	1   	3	0
9326	5230	829	2a  	109	0
9327	5230	829	2a  	3	0
9328	5230	829	2a  	8	0
9329	5233	79	1   	109	0
9330	5233	79	1m  	3	0
9331	5233	79	1   	8	0
9332	5234	390	1   	109	0
9333	5234	390	1m  	3	0
9334	5234	390	+   	8	0
9335	5235	26	1m  	109	0
9336	5235	26	1m  	3	0
9337	5235	26	1   	8	0
9338	5237	73	+   	109	0
9339	5238	363	1   	109	0
9340	5238	363	1   	3	0
9341	5238	363	1   	8	0
9342	5239	223	+   	109	0
9343	5240	363	.   	109	0
9344	5240	363	+   	3	0
9345	5240	363	+   	8	0
9346	5241	412	+   	109	0
9347	5242	496	1m  	109	0
9348	5242	496	1m  	3	0
9349	5242	496	1m  	8	0
9350	5243	219	+   	109	0
9351	5244	1139	+   	109	0
9352	5245	204	+   	109	0
9353	5246	130	.   	109	0
9354	5247	363	1   	109	0
9355	5248	363	.   	109	0
9356	5249	1101	+   	109	0
9357	5250	400	+   	109	0
9358	5250	400	+   	8	0
9359	5251	356	+   	109	0
9360	5251	356	1m  	3	0
9361	5251	356	+   	8	0
9362	5252	982	+   	109	0
9363	5253	26	+   	109	0
9364	5255	390	+   	109	0
9365	5256	26	+   	109	0
9366	5257	418	+   	109	0
9367	5257	418	1m  	3	0
9368	5259	918	+   	109	0
9369	5259	918	+   	3	0
9370	5259	918	+   	8	0
9371	5261	363	.   	109	0
9372	5262	616	1m  	3	0
9373	5263	130	1   	3	0
9374	5263	130	1m  	8	0
9375	5264	363	.   	3	0
9376	5265	204	+   	3	0
9377	5266	493	1   	3	0
9378	5267	161	1m  	3	0
9379	5267	161	1m  	8	0
9380	5268	216	1m  	3	0
9381	5270	380	+   	8	0
9382	5271	27	+   	8	0
9383	5272	423	1m  	8	0
9384	5273	56	3   	9	0
9385	5273	56	2a  	10	0
9386	5273	56	3   	12	0
9387	5273	56	3   	51	0
9388	5273	56	3   	118	0
9389	5273	56	3   	123	0
9390	5273	56	3   	125	0
9391	5273	56	2b  	126	0
9392	5274	1101	1   	9	0
9393	5274	1101	+   	118	0
9394	5275	394	2a  	9	0
9395	5275	394	1   	10	0
9396	5275	394	1   	12	0
9397	5275	394	1   	51	0
9398	5275	394	1m  	118	0
9399	5275	394	1m  	123	0
9400	5275	394	1   	125	0
9401	5275	394	1m  	126	0
9402	5276	429	1m  	9	0
9403	5276	429	1   	10	0
9404	5276	429	1m  	12	0
9405	5276	429	1m  	26	0
9406	5276	429	1m  	40	0
9407	5276	429	1m  	51	0
9408	5276	429	1m  	118	0
9409	5276	429	+   	124	0
9410	5276	429	+   	125	0
9411	5277	304	1m  	9	0
9412	5277	304	1   	12	0
9413	5277	304	1   	40	0
9414	5277	304	1   	118	0
9415	5277	304	+   	123	0
9416	5277	304	1m  	124	0
9417	5277	304	1   	126	0
9418	5278	336	1m  	9	0
9419	5279	492	1   	9	0
9420	5279	492	+   	10	0
9421	5279	492	1m  	40	0
9422	5279	492	1   	51	0
9423	5279	492	1m  	118	0
9424	5279	492	1   	123	0
9425	5279	492	+   	124	0
9426	5279	492	1m  	125	0
9427	5279	492	1m  	126	0
9428	5280	437	+   	9	0
9429	5280	437	1   	10	0
9430	5280	437	1   	12	0
9431	5280	437	1   	26	0
9432	5280	437	1m  	40	0
9433	5280	437	1   	118	0
9434	5280	437	+   	123	0
9435	5280	437	+   	124	0
9436	5280	437	1m  	125	0
9437	5280	437	1m  	126	0
9438	5281	363	1   	9	0
9439	5281	363	1   	10	0
9440	5281	363	1   	12	0
9441	5281	363	2a  	26	0
9442	5281	363	1   	40	0
9443	5281	363	+   	51	0
9444	5281	363	1   	118	0
9445	5281	363	1   	123	0
9446	5281	363	1   	124	0
9447	5281	363	1   	125	0
9448	5282	184	2a  	9	0
9449	5282	184	1   	10	0
9450	5282	184	1   	12	0
9451	5282	184	2a  	51	0
9452	5282	184	1   	118	0
9453	5282	184	1   	123	0
9454	5282	184	2a  	125	0
9455	5282	184	1   	126	0
9456	5283	195	1   	9	0
9457	5283	195	1   	10	0
9458	5283	195	1m  	12	0
9459	5283	195	1m  	40	0
9460	5283	195	1m  	51	0
9461	5283	195	1   	118	0
9462	5283	195	2a  	126	0
9463	5284	26	1   	9	0
9464	5284	26	1   	10	0
9465	5284	26	1   	12	0
9466	5284	26	1   	26	0
9467	5284	26	+   	51	0
9468	5284	26	+   	118	0
9469	5284	26	+   	123	0
9470	5284	26	+   	124	0
9471	5284	26	+   	125	0
9472	5285	937	+   	9	0
9473	5286	119	+   	9	0
9474	5286	119	+   	12	0
9475	5286	119	+   	51	0
9476	5286	119	+   	118	0
9477	5286	119	1m  	123	0
9478	5286	119	+   	124	0
9479	5286	119	+   	125	0
9480	5287	375	+   	9	0
9481	5287	375	+   	12	0
9482	5287	375	+   	51	0
9483	5287	375	+   	118	0
9484	5287	375	+   	123	0
9485	5287	375	a   	126	0
9486	5288	492	1   	12	0
9487	5289	319	+   	9	0
9488	5289	319	+   	10	0
9489	5289	319	1m  	12	0
9490	5289	319	1   	40	0
9491	5289	319	+   	118	0
9492	5289	319	+   	123	0
9493	5289	319	+   	124	0
9494	5289	319	+   	126	0
9495	5290	523	+   	9	0
9496	5290	523	+   	10	0
9497	5290	523	1m  	12	0
9498	5290	523	+   	26	0
9499	5290	523	1   	51	0
9500	5290	523	+   	118	0
9501	5290	523	1m  	123	0
9502	5290	523	+   	124	0
9503	5290	523	+   	125	0
9504	5291	510	1m  	9	0
9505	5291	510	1m  	40	0
9506	5291	510	+   	118	0
9507	5291	510	+   	123	0
9508	5291	510	1m  	126	0
9509	5292	526	1m  	9	0
9510	5292	526	+   	12	0
9511	5292	526	1m  	118	0
9512	5292	526	1m  	123	0
9513	5292	526	+   	124	0
9514	5292	526	+   	125	0
9515	5292	526	1m  	126	0
9516	5293	204	+   	9	0
9517	5293	204	+   	10	0
9518	5293	204	+   	12	0
9519	5293	204	+   	118	0
9520	5293	204	+   	123	0
9521	5294	829	1   	9	0
9522	5294	829	2b  	10	0
9523	5294	829	1   	26	0
9524	5294	829	2a  	51	0
9525	5294	829	1   	123	0
9526	5295	794	1   	9	0
9527	5295	794	2a  	10	0
9528	5295	794	1   	12	0
9529	5295	794	2b  	26	0
9530	5295	794	2b  	40	0
9531	5295	794	1   	51	0
9532	5295	794	+   	118	0
9533	5295	794	+   	123	0
9534	5295	794	2a  	124	0
9535	5295	794	+   	125	0
9536	5296	236	1m  	9	0
9537	5297	913	+   	9	0
9538	5297	913	+   	12	0
9539	5298	19	+   	9	0
9540	5298	19	1   	10	0
9541	5298	19	1   	12	0
9542	5298	19	1   	26	0
9543	5298	19	1   	40	0
9544	5298	19	1   	51	0
9545	5299	26	+   	9	0
9546	5299	26	+   	10	0
9547	5299	26	+   	12	0
9548	5299	26	+   	26	0
9549	5300	236	1m  	10	0
9550	5300	236	1m  	118	0
9551	5300	236	+   	123	0
9552	5300	236	1   	124	0
9553	5300	236	+   	125	0
9554	5300	236	+   	126	0
9555	5301	286	+   	10	0
9556	5301	286	1   	12	0
9557	5301	286	+   	26	0
9558	5301	286	1   	40	0
9559	5301	286	+   	124	0
9560	5301	286	+   	126	0
9561	5302	389	1m  	10	0
9562	5302	389	+   	12	0
9563	5302	389	+   	26	0
9564	5302	389	+   	51	0
9565	5303	490	+   	10	0
9566	5304	363	.   	10	0
9567	5305	320	+   	10	0
9568	5305	320	+   	40	0
9569	5305	320	1m  	124	0
9570	5306	408	+   	12	0
9571	5306	408	+   	118	0
9572	5306	408	+   	123	0
9573	5306	408	+   	124	0
9574	5306	408	+   	119	0
9575	5307	577	1m  	12	0
9576	5307	577	+   	123	0
9577	5307	577	+   	124	0
9578	5307	577	+   	125	0
9579	5307	577	a   	126	0
9580	5308	50	1   	12	0
9581	5309	896	+   	12	0
9582	5309	896	+   	26	0
9583	5309	896	+   	40	0
9584	5310	412	+   	12	0
9585	5310	412	+   	26	0
9586	5310	412	+   	123	0
9587	5311	829	1   	12	0
9588	5311	829	2a  	40	0
9589	5311	829	+   	118	0
9590	5311	829	1   	124	0
9591	5311	829	+   	125	0
9592	5312	829	.   	12	0
9593	5312	829	1   	126	0
9594	5313	123	+   	26	0
9595	5313	123	+   	126	0
9596	5314	281	1   	26	0
9597	5315	932	+   	40	0
9598	5317	288	1   	118	0
9599	5317	288	1   	123	0
9600	5317	288	1   	124	0
9601	5317	288	+   	125	0
9602	5317	288	1   	126	0
9603	5318	19	1   	118	0
9604	5318	19	1   	123	0
9605	5318	19	1   	124	0
9606	5318	19	+   	125	0
9607	5318	19	+   	126	0
9608	5319	265	1m  	118	0
9609	5319	265	1m  	123	0
9610	5319	265	+   	124	0
\.


--
-- TOC entry 1756 (class 0 OID 32100)
-- Dependencies: 1339
-- Data for Name: soil; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY soil (soil_id, soil) FROM stdin;
1	Unknown soil.                                                                                                                                                                                                                                                  
2	Limestone.                                                                                                                                                                                                                                                     
3	Ophiolite.                                                                                                                                                                                                                                                     
4	Serpentine.                                                                                                                                                                                                                                                    
5	Ophiolite, serpentine.                                                                                                                                                                                                                                         
6	Limestone and dolomite.                                                                                                                                                                                                                                        
7	Marble, dolomite, ophiolite mix.                                                                                                                                                                                                                               
8	Limestone, schist and ophiolite.                                                                                                                                                                                                                               
9	Limestone, dolomite and marble.                                                                                                                                                                                                                                
10	Dolomite and marble.                                                                                                                                                                                                                                           
11	Marble.                                                                                                                                                                                                                                                        
12	Dolomitic (chiefly) and ophiolitic deposits.                                                                                                                                                                                                                   
13	Conglomerate rocks.                                                                                                                                                                                                                                            
14	Ultramafic soils.                                                                                                                                                                                                                                              
15	Granite.                                                                                                                                                                                                                                                       
16	Schist.                                                                                                                                                                                                                                                        
17	Coastal sands.                                                                                                                                                                                                                                                 
18	Mergel.                                                                                                                                                                                                                                                        
19	Till, with ophiolitic (chiefly) and dolomitic deposits, partly adjoining to conglomerate rock.                                                                                                                                                                 
\.


--
-- TOC entry 1757 (class 0 OID 32107)
-- Dependencies: 1340
-- Data for Name: specimen; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY specimen (specimen_id, identifier, field_number, collector, collecting_date, taxon_fk, confirmed_by, notes, lfd_deck_nummern, locality_fk, metadata_fk, last_update) FROM stdin;
1	Markus Döring                                                                                                                                                                                                                                                  	1                                                                                                                                                                                                                                                              	Markus Döring                                                                                                                                                                                                                                                  	1999-06-18 00:00:00	158	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1	284	1	2001-03-01 00:00:00
2	Markus Döring                                                                                                                                                                                                                                                  	1035                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	445	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1517	398	1	2001-03-01 00:00:00
3	Markus Döring                                                                                                                                                                                                                                                  	1036                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	497	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1518	398	1	2001-03-01 00:00:00
4	Markus Döring                                                                                                                                                                                                                                                  	1037                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	44	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1524	398	1	2001-03-01 00:00:00
5	Markus Döring                                                                                                                                                                                                                                                  	1038                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	428	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1525	398	1	2001-03-01 00:00:00
6	Markus Döring                                                                                                                                                                                                                                                  	1039                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	342	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1526	398	1	2001-03-01 00:00:00
7	Markus Döring                                                                                                                                                                                                                                                  	104                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	140	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	110	352	1	2001-03-01 00:00:00
8	Markus Döring                                                                                                                                                                                                                                                  	1040                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1542	398	1	2001-03-01 00:00:00
9	Markus Döring                                                                                                                                                                                                                                                  	1041                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1471	398	1	2001-03-01 00:00:00
10	Markus Döring                                                                                                                                                                                                                                                  	1042                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	57	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1654	400	1	2001-03-01 00:00:00
11	Markus Döring                                                                                                                                                                                                                                                  	1043                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	378	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1655	400	1	2001-03-01 00:00:00
12	Markus Döring                                                                                                                                                                                                                                                  	1044                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	284	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1633	400	1	2001-03-01 00:00:00
13	Markus Döring                                                                                                                                                                                                                                                  	1045                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1656	400	1	2001-03-01 00:00:00
14	Markus Döring                                                                                                                                                                                                                                                  	1046                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1648	400	1	2001-03-01 00:00:00
15	Markus Döring                                                                                                                                                                                                                                                  	1047                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	215	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1640	400	1	2001-03-01 00:00:00
16	Markus Döring                                                                                                                                                                                                                                                  	1048                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1644	400	1	2001-03-01 00:00:00
17	Markus Döring                                                                                                                                                                                                                                                  	1049                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	160	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1647	400	1	2001-03-01 00:00:00
18	Markus Döring                                                                                                                                                                                                                                                  	105                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	102	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	111	352	1	2001-03-01 00:00:00
19	Markus Döring                                                                                                                                                                                                                                                  	1050                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	969	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1660	401	1	2001-03-01 00:00:00
20	Markus Döring                                                                                                                                                                                                                                                  	1051                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	203	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1662	401	1	2001-03-01 00:00:00
21	Markus Döring                                                                                                                                                                                                                                                  	1052                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1670	401	1	2001-03-01 00:00:00
22	Markus Döring                                                                                                                                                                                                                                                  	1054                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	1111	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1528	402	1	2001-03-01 00:00:00
23	Markus Döring                                                                                                                                                                                                                                                  	1055                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	96	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1533	402	1	2001-03-01 00:00:00
24	Markus Döring                                                                                                                                                                                                                                                  	1056                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1532	402	1	2001-03-01 00:00:00
25	Markus Döring                                                                                                                                                                                                                                                  	1057                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	44	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1531	402	1	2001-03-01 00:00:00
26	Markus Döring                                                                                                                                                                                                                                                  	1058                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	483	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1530	402	1	2001-03-01 00:00:00
27	Markus Döring                                                                                                                                                                                                                                                  	1059                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	227	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1534	402	1	2001-03-01 00:00:00
28	Markus Döring                                                                                                                                                                                                                                                  	106                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	112	352	1	2001-03-01 00:00:00
29	Markus Döring                                                                                                                                                                                                                                                  	1060                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	315	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1535	402	1	2001-03-01 00:00:00
30	Markus Döring                                                                                                                                                                                                                                                  	1061                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	416	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1529	402	1	2001-03-01 00:00:00
31	Markus Döring                                                                                                                                                                                                                                                  	1062                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	901	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1536	402	1	2001-03-01 00:00:00
32	Markus Döring                                                                                                                                                                                                                                                  	1063                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1472	402	1	2001-03-01 00:00:00
33	Markus Döring                                                                                                                                                                                                                                                  	1065                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	556	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1676	226	1	2001-03-01 00:00:00
34	Markus Döring                                                                                                                                                                                                                                                  	1066                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	191	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1674	225	1	2001-03-01 00:00:00
35	Markus Döring                                                                                                                                                                                                                                                  	1067                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	423	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1675	225	1	2001-03-01 00:00:00
36	Markus Döring                                                                                                                                                                                                                                                  	1068                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	395	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1682	204	1	2001-03-01 00:00:00
37	Markus Döring                                                                                                                                                                                                                                                  	1069                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	451	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1772	204	1	2001-03-01 00:00:00
38	Markus Döring                                                                                                                                                                                                                                                  	107                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	304	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	113	352	1	2001-03-01 00:00:00
39	Markus Döring                                                                                                                                                                                                                                                  	1070                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	338	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1680	204	1	2001-03-01 00:00:00
40	Markus Döring                                                                                                                                                                                                                                                  	1071                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	305	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1684	204	1	2001-03-01 00:00:00
41	Markus Döring                                                                                                                                                                                                                                                  	1072                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1685	204	1	2001-03-01 00:00:00
42	Markus Döring                                                                                                                                                                                                                                                  	1073                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	283	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1686	205	1	2001-03-01 00:00:00
43	Markus Döring                                                                                                                                                                                                                                                  	1074                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	576	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1687	205	1	2001-03-01 00:00:00
44	Markus Döring                                                                                                                                                                                                                                                  	1075                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	361	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1688	205	1	2001-03-01 00:00:00
45	Markus Döring                                                                                                                                                                                                                                                  	1076                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	1109	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1689	205	1	2001-03-01 00:00:00
46	Markus Döring                                                                                                                                                                                                                                                  	1077                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1776	204	1	2001-03-01 00:00:00
47	Markus Döring                                                                                                                                                                                                                                                  	1078                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1777	204	1	2001-03-01 00:00:00
48	Markus Döring                                                                                                                                                                                                                                                  	1079                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1692	205	1	2001-03-01 00:00:00
49	Markus Döring                                                                                                                                                                                                                                                  	108                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	517	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	114	352	1	2001-03-01 00:00:00
50	Markus Döring                                                                                                                                                                                                                                                  	1080                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	828	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1681	205	1	2001-03-01 00:00:00
51	Markus Döring                                                                                                                                                                                                                                                  	1081                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	133	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1693	205	1	2001-03-01 00:00:00
52	Markus Döring                                                                                                                                                                                                                                                  	1082                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	575	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1695	204	1	2001-03-01 00:00:00
53	Markus Döring                                                                                                                                                                                                                                                  	1083                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1696	205	1	2001-03-01 00:00:00
54	Markus Döring                                                                                                                                                                                                                                                  	1084                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1698	205	1	2001-03-01 00:00:00
55	Markus Döring                                                                                                                                                                                                                                                  	1085                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	248	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1780	204	1	2001-03-01 00:00:00
56	Markus Döring                                                                                                                                                                                                                                                  	1086                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	244	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1700	205	1	2001-03-01 00:00:00
57	Markus Döring                                                                                                                                                                                                                                                  	1087                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1797	205	1	2001-03-01 00:00:00
58	Markus Döring                                                                                                                                                                                                                                                  	1088                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	542	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1782	205	1	2001-03-01 00:00:00
59	Markus Döring                                                                                                                                                                                                                                                  	1089                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	39	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1781	205	1	2001-03-01 00:00:00
60	Markus Döring                                                                                                                                                                                                                                                  	109                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	124	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	115	352	1	2001-03-01 00:00:00
61	Markus Döring                                                                                                                                                                                                                                                  	1090                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	420	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1704	205	1	2001-03-01 00:00:00
62	Markus Döring                                                                                                                                                                                                                                                  	1091                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	194	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1785	205	1	2001-03-01 00:00:00
63	Markus Döring                                                                                                                                                                                                                                                  	1092                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1705	205	1	2001-03-01 00:00:00
64	Markus Döring                                                                                                                                                                                                                                                  	1093                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1706	204	1	2001-03-01 00:00:00
65	Markus Döring                                                                                                                                                                                                                                                  	1094                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1707	205	1	2001-03-01 00:00:00
66	Markus Döring                                                                                                                                                                                                                                                  	1095                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1708	205	1	2001-03-01 00:00:00
67	Markus Döring                                                                                                                                                                                                                                                  	1096                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	478	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1720	205	1	2001-03-01 00:00:00
68	Markus Döring                                                                                                                                                                                                                                                  	1097                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	460	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1723	229	1	2001-03-01 00:00:00
69	Markus Döring                                                                                                                                                                                                                                                  	1098                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1683	229	1	2001-03-01 00:00:00
70	Markus Döring                                                                                                                                                                                                                                                  	1099                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1726	230	1	2001-03-01 00:00:00
71	Markus Döring                                                                                                                                                                                                                                                  	11                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	5	286	1	2001-03-01 00:00:00
72	Markus Döring                                                                                                                                                                                                                                                  	1100                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	447	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1727	230	1	2001-03-01 00:00:00
73	Markus Döring                                                                                                                                                                                                                                                  	1101                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	126	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1728	229	1	2001-03-01 00:00:00
74	Markus Döring                                                                                                                                                                                                                                                  	1102                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1729	230	1	2001-03-01 00:00:00
75	Markus Döring                                                                                                                                                                                                                                                  	1103                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1741	231	1	2001-03-01 00:00:00
76	Markus Döring                                                                                                                                                                                                                                                  	1104                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1737	231	1	2001-03-01 00:00:00
77	Markus Döring                                                                                                                                                                                                                                                  	1105                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1715	229	1	2001-03-01 00:00:00
78	Markus Döring                                                                                                                                                                                                                                                  	1106                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1733	231	1	2001-03-01 00:00:00
79	Markus Döring                                                                                                                                                                                                                                                  	1107                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1739	231	1	2001-03-01 00:00:00
80	Markus Döring                                                                                                                                                                                                                                                  	1108                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	378	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1740	231	1	2001-03-01 00:00:00
81	Markus Döring                                                                                                                                                                                                                                                  	1109                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1743	231	1	2001-03-01 00:00:00
82	Markus Döring                                                                                                                                                                                                                                                  	110a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	237	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	96	202	1	2001-03-01 00:00:00
83	Markus Döring                                                                                                                                                                                                                                                  	110b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	372	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	120	298	1	2001-03-01 00:00:00
84	Markus Döring                                                                                                                                                                                                                                                  	111                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	92	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	121	298	1	2001-03-01 00:00:00
85	Markus Döring                                                                                                                                                                                                                                                  	1110                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1761	232	1	2001-03-01 00:00:00
86	Markus Döring                                                                                                                                                                                                                                                  	1111                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	155	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1796	232	1	2001-03-01 00:00:00
87	Markus Döring                                                                                                                                                                                                                                                  	1112                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1756	232	1	2001-03-01 00:00:00
88	Markus Döring                                                                                                                                                                                                                                                  	1113                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	10	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1749	232	1	2001-03-01 00:00:00
89	Markus Döring                                                                                                                                                                                                                                                  	1114                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	33	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1746	232	1	2001-03-01 00:00:00
90	Markus Döring                                                                                                                                                                                                                                                  	1115                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	475	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1750	232	1	2001-03-01 00:00:00
91	Markus Döring                                                                                                                                                                                                                                                  	1116                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1747	232	1	2001-03-01 00:00:00
92	Markus Döring                                                                                                                                                                                                                                                  	1117                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1758	232	1	2001-03-01 00:00:00
93	Markus Döring                                                                                                                                                                                                                                                  	1118                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	503	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1753	232	1	2001-03-01 00:00:00
94	Markus Döring                                                                                                                                                                                                                                                  	1119                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	250	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1759	232	1	2001-03-01 00:00:00
95	Markus Döring                                                                                                                                                                                                                                                  	112                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	932	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	124	298	1	2001-03-01 00:00:00
96	Markus Döring                                                                                                                                                                                                                                                  	1120                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1764	232	1	2001-03-01 00:00:00
97	Markus Döring                                                                                                                                                                                                                                                  	1121                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1745	232	1	2001-03-01 00:00:00
98	Markus Döring                                                                                                                                                                                                                                                  	1122                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	383	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1765	232	1	2001-03-01 00:00:00
99	Markus Döring                                                                                                                                                                                                                                                  	1123                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	405	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1766	232	1	2001-03-01 00:00:00
100	Markus Döring                                                                                                                                                                                                                                                  	1124                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	272	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1754	232	1	2001-03-01 00:00:00
101	Markus Döring                                                                                                                                                                                                                                                  	1125a                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	71	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1792	233	1	2001-03-01 00:00:00
102	Markus Döring                                                                                                                                                                                                                                                  	1125b                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	72	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2392	233	1	2001-03-01 00:00:00
103	Markus Döring                                                                                                                                                                                                                                                  	1126                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	539	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1767	232	1	2001-03-01 00:00:00
104	Markus Döring                                                                                                                                                                                                                                                  	1127                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1719	229	1	2001-03-01 00:00:00
105	Markus Döring                                                                                                                                                                                                                                                  	1128                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	270	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1855	227	1	2001-03-01 00:00:00
106	Markus Döring                                                                                                                                                                                                                                                  	1129                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	423	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1804	239	1	2001-03-01 00:00:00
107	Markus Döring                                                                                                                                                                                                                                                  	113                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	23	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	76	327	1	2001-03-01 00:00:00
108	Markus Döring                                                                                                                                                                                                                                                  	1130                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	191	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1803	239	1	2001-03-01 00:00:00
109	Markus Döring                                                                                                                                                                                                                                                  	1131                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	153	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1829	239	1	2001-03-01 00:00:00
110	Markus Döring                                                                                                                                                                                                                                                  	1132                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	487	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1806	239	1	2001-03-01 00:00:00
111	Markus Döring                                                                                                                                                                                                                                                  	1133                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1820	239	1	2001-03-01 00:00:00
112	Markus Döring                                                                                                                                                                                                                                                  	1134                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	91	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1853	242	1	2001-03-01 00:00:00
113	Markus Döring                                                                                                                                                                                                                                                  	1135                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1819	239	1	2001-03-01 00:00:00
114	Markus Döring                                                                                                                                                                                                                                                  	1136                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1821	239	1	2001-03-01 00:00:00
115	Markus Döring                                                                                                                                                                                                                                                  	1137                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	342	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1810	239	1	2001-03-01 00:00:00
116	Markus Döring                                                                                                                                                                                                                                                  	1138                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1835	239	1	2001-03-01 00:00:00
117	Markus Döring                                                                                                                                                                                                                                                  	1139                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	444	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1831	239	1	2001-03-01 00:00:00
118	Markus Döring                                                                                                                                                                                                                                                  	114                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	241	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	65	296	1	2001-03-01 00:00:00
119	Markus Döring                                                                                                                                                                                                                                                  	1140                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1839	239	1	2001-03-01 00:00:00
120	Markus Döring                                                                                                                                                                                                                                                  	1141                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	518	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1840	239	1	2001-03-01 00:00:00
121	Markus Döring                                                                                                                                                                                                                                                  	1142                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1815	239	1	2001-03-01 00:00:00
122	Markus Döring                                                                                                                                                                                                                                                  	1143                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	193	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1856	228	1	2001-03-01 00:00:00
123	Markus Döring                                                                                                                                                                                                                                                  	1144                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	378	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1857	228	1	2001-03-01 00:00:00
124	Markus Döring                                                                                                                                                                                                                                                  	1145                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	805	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1860	251	1	2001-03-01 00:00:00
125	Markus Döring                                                                                                                                                                                                                                                  	1146                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1859	251	1	2001-03-01 00:00:00
126	Markus Döring                                                                                                                                                                                                                                                  	1147                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	16	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1858	251	1	2001-03-01 00:00:00
127	Markus Döring                                                                                                                                                                                                                                                  	1148                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	209	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1861	251	1	2001-03-01 00:00:00
128	Markus Döring                                                                                                                                                                                                                                                  	1149                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1862	251	1	2001-03-01 00:00:00
129	Markus Döring                                                                                                                                                                                                                                                  	115                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	145	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	75	202	1	2001-03-01 00:00:00
130	Markus Döring                                                                                                                                                                                                                                                  	1150                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	385	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2473	251	1	2001-03-01 00:00:00
131	Markus Döring                                                                                                                                                                                                                                                  	1151                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	108	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1864	251	1	2001-03-01 00:00:00
132	Markus Döring                                                                                                                                                                                                                                                  	1152                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	368	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1865	251	1	2001-03-01 00:00:00
133	Markus Döring                                                                                                                                                                                                                                                  	1153                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	64	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1866	319	1	2001-03-01 00:00:00
134	Markus Döring                                                                                                                                                                                                                                                  	1154                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	41	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1867	319	1	2001-03-01 00:00:00
135	Markus Döring                                                                                                                                                                                                                                                  	1155                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	306	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1868	319	1	2001-03-01 00:00:00
136	Markus Döring                                                                                                                                                                                                                                                  	1156                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	224	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1869	319	1	2001-03-01 00:00:00
137	Markus Döring                                                                                                                                                                                                                                                  	1157                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	10	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1871	319	1	2001-03-01 00:00:00
138	Markus Döring                                                                                                                                                                                                                                                  	1158                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1872	320	1	2001-03-01 00:00:00
139	Markus Döring                                                                                                                                                                                                                                                  	1159                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1900	243	1	2001-03-01 00:00:00
140	Markus Döring                                                                                                                                                                                                                                                  	1160                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1879	243	1	2001-03-01 00:00:00
141	Markus Döring                                                                                                                                                                                                                                                  	1161                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1878	243	1	2001-03-01 00:00:00
142	Markus Döring                                                                                                                                                                                                                                                  	1162                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	505	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1877	243	1	2001-03-01 00:00:00
143	Markus Döring                                                                                                                                                                                                                                                  	1163a                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	506	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1876	243	1	2001-03-01 00:00:00
144	Markus Döring                                                                                                                                                                                                                                                  	1163b                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	505	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2409	243	1	2001-03-01 00:00:00
145	Markus Döring                                                                                                                                                                                                                                                  	1164                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1884	243	1	2001-03-01 00:00:00
146	Markus Döring                                                                                                                                                                                                                                                  	1165                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	41	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1891	243	1	2001-03-01 00:00:00
147	Markus Döring                                                                                                                                                                                                                                                  	1166                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	765	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2223	243	1	2001-03-01 00:00:00
148	Markus Döring                                                                                                                                                                                                                                                  	1167                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1885	243	1	2001-03-01 00:00:00
149	Markus Döring                                                                                                                                                                                                                                                  	1168                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	95	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1892	243	1	2001-03-01 00:00:00
150	Markus Döring                                                                                                                                                                                                                                                  	1169                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	128	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1893	243	1	2001-03-01 00:00:00
151	Markus Döring                                                                                                                                                                                                                                                  	1171                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1887	243	1	2001-03-01 00:00:00
152	Markus Döring                                                                                                                                                                                                                                                  	1171x114                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1931	245	1	2001-03-01 00:00:00
153	Markus Döring                                                                                                                                                                                                                                                  	1172                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1894	243	1	2001-03-01 00:00:00
154	Markus Döring                                                                                                                                                                                                                                                  	1173                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	397	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1895	243	1	2001-03-01 00:00:00
155	Markus Döring                                                                                                                                                                                                                                                  	1174                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	298	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1889	243	1	2001-03-01 00:00:00
156	Markus Döring                                                                                                                                                                                                                                                  	1175                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	308	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1886	243	1	2001-03-01 00:00:00
157	Markus Döring                                                                                                                                                                                                                                                  	1176                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1896	243	1	2001-03-01 00:00:00
158	Markus Döring                                                                                                                                                                                                                                                  	1176x113                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2442	244	1	2001-03-01 00:00:00
159	Markus Döring                                                                                                                                                                                                                                                  	1177                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1897	243	1	2001-03-01 00:00:00
160	Markus Döring                                                                                                                                                                                                                                                  	1178                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	1136	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1929	243	1	2001-03-01 00:00:00
161	Markus Döring                                                                                                                                                                                                                                                  	1179                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	512	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1898	243	1	2001-03-01 00:00:00
162	Markus Döring                                                                                                                                                                                                                                                  	1180                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	508	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1874	320	1	2001-03-01 00:00:00
163	Markus Döring                                                                                                                                                                                                                                                  	1181                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	250	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1873	320	1	2001-03-01 00:00:00
164	Markus Döring                                                                                                                                                                                                                                                  	1182                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	382	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1914	245	1	2001-03-01 00:00:00
165	Markus Döring                                                                                                                                                                                                                                                  	1183                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1957	245	1	2001-03-01 00:00:00
166	Markus Döring                                                                                                                                                                                                                                                  	1184                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	385	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1908	245	1	2001-03-01 00:00:00
167	Markus Döring                                                                                                                                                                                                                                                  	1185a                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	397	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1916	245	1	2001-03-01 00:00:00
168	Markus Döring                                                                                                                                                                                                                                                  	1185b                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2400	245	1	2001-03-01 00:00:00
169	Markus Döring                                                                                                                                                                                                                                                  	1186                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	84	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1909	245	1	2001-03-01 00:00:00
170	Markus Döring                                                                                                                                                                                                                                                  	1187                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	55	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1907	245	1	2001-03-01 00:00:00
171	Markus Döring                                                                                                                                                                                                                                                  	1188                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	134	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1911	245	1	2001-03-01 00:00:00
172	Markus Döring                                                                                                                                                                                                                                                  	1189                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1910	245	1	2001-03-01 00:00:00
173	Markus Döring                                                                                                                                                                                                                                                  	1190                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1901	245	1	2001-03-01 00:00:00
174	Markus Döring                                                                                                                                                                                                                                                  	1191                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	255	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1917	245	1	2001-03-01 00:00:00
175	Markus Döring                                                                                                                                                                                                                                                  	1192                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	411	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1918	245	1	2001-03-01 00:00:00
176	Markus Döring                                                                                                                                                                                                                                                  	1193                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1921	245	1	2001-03-01 00:00:00
177	Markus Döring                                                                                                                                                                                                                                                  	1194                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1920	245	1	2001-03-01 00:00:00
178	Markus Döring                                                                                                                                                                                                                                                  	1195                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1922	245	1	2001-03-01 00:00:00
179	Markus Döring                                                                                                                                                                                                                                                  	1196                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	205	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1923	245	1	2001-03-01 00:00:00
180	Markus Döring                                                                                                                                                                                                                                                  	1197                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1924	245	1	2001-03-01 00:00:00
181	Markus Döring                                                                                                                                                                                                                                                  	1198                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1927	245	1	2001-03-01 00:00:00
182	Markus Döring                                                                                                                                                                                                                                                  	1199                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1926	245	1	2001-03-01 00:00:00
183	Markus Döring                                                                                                                                                                                                                                                  	120                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	423	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	134	301	1	2001-03-01 00:00:00
184	Markus Döring                                                                                                                                                                                                                                                  	1200                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1928	245	1	2001-03-01 00:00:00
185	Markus Döring                                                                                                                                                                                                                                                  	1201                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2418	245	1	2001-03-01 00:00:00
186	Markus Döring                                                                                                                                                                                                                                                  	1202                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	16	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1902	245	1	2001-03-01 00:00:00
187	Markus Döring                                                                                                                                                                                                                                                  	1203                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	805	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1906	245	1	2001-03-01 00:00:00
188	Markus Döring                                                                                                                                                                                                                                                  	1204                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	60	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1919	245	1	2001-03-01 00:00:00
189	Markus Döring                                                                                                                                                                                                                                                  	1205                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	373	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1890	243	1	2001-03-01 00:00:00
190	Markus Döring                                                                                                                                                                                                                                                  	1206                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1881	244	1	2001-03-01 00:00:00
191	Markus Döring                                                                                                                                                                                                                                                  	1207                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-06 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1899	243	1	2001-03-01 00:00:00
192	Markus Döring                                                                                                                                                                                                                                                  	1208                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	143	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1954	246	1	2001-03-01 00:00:00
193	Markus Döring                                                                                                                                                                                                                                                  	1209                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	168	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1950	246	1	2001-03-01 00:00:00
194	Markus Döring                                                                                                                                                                                                                                                  	120x1                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	423	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	273	313	1	2001-03-01 00:00:00
195	Markus Döring                                                                                                                                                                                                                                                  	121                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	155	301	1	2001-03-01 00:00:00
196	Markus Döring                                                                                                                                                                                                                                                  	1210                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	181	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1946	246	1	2001-03-01 00:00:00
197	Markus Döring                                                                                                                                                                                                                                                  	1211                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1964	246	1	2001-03-01 00:00:00
198	Markus Döring                                                                                                                                                                                                                                                  	1211x116                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2443	247	1	2001-03-01 00:00:00
199	Markus Döring                                                                                                                                                                                                                                                  	1212                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	77	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1953	246	1	2001-03-01 00:00:00
200	Markus Döring                                                                                                                                                                                                                                                  	1213                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	255	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2113	246	1	2001-03-01 00:00:00
201	Markus Döring                                                                                                                                                                                                                                                  	1214                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1937	246	1	2001-03-01 00:00:00
202	Markus Döring                                                                                                                                                                                                                                                  	1215                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	373	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1968	246	1	2001-03-01 00:00:00
203	Markus Döring                                                                                                                                                                                                                                                  	1216                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2149	246	1	2001-03-01 00:00:00
204	Markus Döring                                                                                                                                                                                                                                                  	1217                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	232	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2148	246	1	2001-03-01 00:00:00
205	Markus Döring                                                                                                                                                                                                                                                  	1217x117                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	223	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2444	248	1	2001-03-01 00:00:00
206	Markus Döring                                                                                                                                                                                                                                                  	1218                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	805	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2110	246	1	2001-03-01 00:00:00
207	Markus Döring                                                                                                                                                                                                                                                  	1218x117                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	805	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2445	248	1	2001-03-01 00:00:00
208	Markus Döring                                                                                                                                                                                                                                                  	1219                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	513	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1956	246	1	2001-03-01 00:00:00
209	Markus Döring                                                                                                                                                                                                                                                  	122                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	144	350	1	2001-03-01 00:00:00
210	Markus Döring                                                                                                                                                                                                                                                  	1220                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	289	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1951	246	1	2001-03-01 00:00:00
211	Markus Döring                                                                                                                                                                                                                                                  	1221                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1955	246	1	2001-03-01 00:00:00
212	Markus Döring                                                                                                                                                                                                                                                  	1222                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	359	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1967	246	1	2001-03-01 00:00:00
213	Markus Döring                                                                                                                                                                                                                                                  	1223                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1970	246	1	2001-03-01 00:00:00
214	Markus Döring                                                                                                                                                                                                                                                  	1223x116                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2446	247	1	2001-03-01 00:00:00
215	Markus Döring                                                                                                                                                                                                                                                  	1224                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1971	246	1	2001-03-01 00:00:00
216	Markus Döring                                                                                                                                                                                                                                                  	1225                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	385	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2131	246	1	2001-03-01 00:00:00
217	Markus Döring                                                                                                                                                                                                                                                  	1226                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	201	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1965	246	1	2001-03-01 00:00:00
218	Markus Döring                                                                                                                                                                                                                                                  	1227                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1930	246	1	2001-03-01 00:00:00
219	Markus Döring                                                                                                                                                                                                                                                  	1228                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1949	246	1	2001-03-01 00:00:00
220	Markus Döring                                                                                                                                                                                                                                                  	1229                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1974	246	1	2001-03-01 00:00:00
221	Markus Döring                                                                                                                                                                                                                                                  	1229x117                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2447	248	1	2001-03-01 00:00:00
222	Markus Döring                                                                                                                                                                                                                                                  	123                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	1166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	190	350	1	2001-03-01 00:00:00
223	Markus Döring                                                                                                                                                                                                                                                  	1230                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	2135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1975	246	1	2001-03-01 00:00:00
224	Markus Döring                                                                                                                                                                                                                                                  	1230x118                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	2135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2448	249	1	2001-03-01 00:00:00
225	Markus Döring                                                                                                                                                                                                                                                  	1231                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	545	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1976	246	1	2001-03-01 00:00:00
226	Markus Döring                                                                                                                                                                                                                                                  	1232                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	59	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2111	246	1	2001-03-01 00:00:00
227	Markus Döring                                                                                                                                                                                                                                                  	1233                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1960	246	1	2001-03-01 00:00:00
228	Markus Döring                                                                                                                                                                                                                                                  	1234                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	345	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1944	246	1	2001-03-01 00:00:00
229	Markus Döring                                                                                                                                                                                                                                                  	1235                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1934	246	1	2001-03-01 00:00:00
230	Markus Döring                                                                                                                                                                                                                                                  	1236                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1966	246	1	2001-03-01 00:00:00
231	Markus Döring                                                                                                                                                                                                                                                  	1237                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1959	246	1	2001-03-01 00:00:00
232	Markus Döring                                                                                                                                                                                                                                                  	1237x118                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	516	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2449	249	1	2001-03-01 00:00:00
233	Markus Döring                                                                                                                                                                                                                                                  	1238                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1947	246	1	2001-03-01 00:00:00
234	Markus Döring                                                                                                                                                                                                                                                  	1239                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	191	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1945	246	1	2001-03-01 00:00:00
235	Markus Döring                                                                                                                                                                                                                                                  	124                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	146	350	1	2001-03-01 00:00:00
236	Markus Döring                                                                                                                                                                                                                                                  	1240                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	425	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1977	246	1	2001-03-01 00:00:00
237	Markus Döring                                                                                                                                                                                                                                                  	1240x                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	425	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2450	248	1	2001-03-01 00:00:00
238	Markus Döring                                                                                                                                                                                                                                                  	1241                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	413	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1978	246	1	2001-03-01 00:00:00
239	Markus Döring                                                                                                                                                                                                                                                  	1242                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1979	246	1	2001-03-01 00:00:00
240	Markus Döring                                                                                                                                                                                                                                                  	1242x117                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2451	248	1	2001-03-01 00:00:00
241	Markus Döring                                                                                                                                                                                                                                                  	1243                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1980	246	1	2001-03-01 00:00:00
242	Markus Döring                                                                                                                                                                                                                                                  	1244                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1963	246	1	2001-03-01 00:00:00
243	Markus Döring                                                                                                                                                                                                                                                  	1245                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1981	246	1	2001-03-01 00:00:00
244	Markus Döring                                                                                                                                                                                                                                                  	1246                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1982	246	1	2001-03-01 00:00:00
245	Markus Döring                                                                                                                                                                                                                                                  	1247                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1932	246	1	2001-03-01 00:00:00
246	Markus Döring                                                                                                                                                                                                                                                  	1248                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1933	246	1	2001-03-01 00:00:00
247	Markus Döring                                                                                                                                                                                                                                                  	1249                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1936	246	1	2001-03-01 00:00:00
248	Markus Döring                                                                                                                                                                                                                                                  	125                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	375	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	141	350	1	2001-03-01 00:00:00
249	Markus Döring                                                                                                                                                                                                                                                  	1250                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1938	246	1	2001-03-01 00:00:00
250	Markus Döring                                                                                                                                                                                                                                                  	1251                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1935	246	1	2001-03-01 00:00:00
251	Markus Döring                                                                                                                                                                                                                                                  	1252                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	314	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1941	246	1	2001-03-01 00:00:00
252	Markus Döring                                                                                                                                                                                                                                                  	1253                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1942	246	1	2001-03-01 00:00:00
253	Markus Döring                                                                                                                                                                                                                                                  	126                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	147	350	1	2001-03-01 00:00:00
254	Markus Döring                                                                                                                                                                                                                                                  	1260                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	249	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1987	247	1	2001-03-01 00:00:00
255	Markus Döring                                                                                                                                                                                                                                                  	1261                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	148	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1985	247	1	2001-03-01 00:00:00
256	Markus Döring                                                                                                                                                                                                                                                  	1262                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	509	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2085	247	1	2001-03-01 00:00:00
257	Markus Döring                                                                                                                                                                                                                                                  	1262x118                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	509	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2452	249	1	2001-03-01 00:00:00
258	Markus Döring                                                                                                                                                                                                                                                  	1263                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	551	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1993	247	1	2001-03-01 00:00:00
259	Markus Döring                                                                                                                                                                                                                                                  	1264                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	174	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1991	247	1	2001-03-01 00:00:00
260	Markus Döring                                                                                                                                                                                                                                                  	1265                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	64	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1990	247	1	2001-03-01 00:00:00
261	Markus Döring                                                                                                                                                                                                                                                  	1266                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1992	247	1	2001-03-01 00:00:00
262	Markus Döring                                                                                                                                                                                                                                                  	1267                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	105	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1989	247	1	2001-03-01 00:00:00
263	Markus Döring                                                                                                                                                                                                                                                  	1268                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	45	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1984	247	1	2001-03-01 00:00:00
264	Markus Döring                                                                                                                                                                                                                                                  	1269                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	48	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1997	247	1	2001-03-01 00:00:00
265	Markus Döring                                                                                                                                                                                                                                                  	126x                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	225	222	1	2001-03-01 00:00:00
266	Markus Döring                                                                                                                                                                                                                                                  	126x15                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	378	274	1	2001-03-01 00:00:00
267	Markus Döring                                                                                                                                                                                                                                                  	126x25                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	513	217	1	2001-03-01 00:00:00
268	Markus Döring                                                                                                                                                                                                                                                  	126x8                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2391	381	1	2001-03-01 00:00:00
269	Markus Döring                                                                                                                                                                                                                                                  	127                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	347	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	143	350	1	2001-03-01 00:00:00
270	Markus Döring                                                                                                                                                                                                                                                  	1270                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	556	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1986	246	1	2001-03-01 00:00:00
271	Markus Döring                                                                                                                                                                                                                                                  	1271                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	541	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1988	247	1	2001-03-01 00:00:00
272	Markus Döring                                                                                                                                                                                                                                                  	1272                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	296	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1998	247	1	2001-03-01 00:00:00
273	Markus Döring                                                                                                                                                                                                                                                  	1273                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	350	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1999	247	1	2001-03-01 00:00:00
274	Markus Döring                                                                                                                                                                                                                                                  	1274                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	306	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1995	247	1	2001-03-01 00:00:00
275	Markus Döring                                                                                                                                                                                                                                                  	1275                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	340	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1994	247	1	2001-03-01 00:00:00
276	Markus Döring                                                                                                                                                                                                                                                  	1276                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	416	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2000	247	1	2001-03-01 00:00:00
277	Markus Döring                                                                                                                                                                                                                                                  	1277                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	223	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2001	247	1	2001-03-01 00:00:00
278	Markus Döring                                                                                                                                                                                                                                                  	1278                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	487	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2002	248	1	2001-03-01 00:00:00
279	Markus Döring                                                                                                                                                                                                                                                  	1279                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	318	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1940	246	1	2001-03-01 00:00:00
280	Markus Döring                                                                                                                                                                                                                                                  	128                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	159	365	1	2001-03-01 00:00:00
281	Markus Döring                                                                                                                                                                                                                                                  	1280                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1948	248	1	2001-03-01 00:00:00
282	Markus Döring                                                                                                                                                                                                                                                  	1281                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2005	248	1	2001-03-01 00:00:00
283	Markus Döring                                                                                                                                                                                                                                                  	1282                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	257	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2007	249	1	2001-03-01 00:00:00
284	Markus Döring                                                                                                                                                                                                                                                  	1283                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	455	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2158	246	1	2001-03-01 00:00:00
285	Markus Döring                                                                                                                                                                                                                                                  	129                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	148	350	1	2001-03-01 00:00:00
286	Markus Döring                                                                                                                                                                                                                                                  	130                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	210	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	149	350	1	2001-03-01 00:00:00
287	Markus Döring                                                                                                                                                                                                                                                  	1300                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	190	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2054	253	1	2001-03-01 00:00:00
288	Markus Döring                                                                                                                                                                                                                                                  	1301                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2016	253	1	2001-03-01 00:00:00
289	Markus Döring                                                                                                                                                                                                                                                  	1302                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2017	253	1	2001-03-01 00:00:00
290	Markus Döring                                                                                                                                                                                                                                                  	1303                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2019	253	1	2001-03-01 00:00:00
291	Markus Döring                                                                                                                                                                                                                                                  	1304                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	556	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2069	253	1	2001-03-01 00:00:00
292	Markus Döring                                                                                                                                                                                                                                                  	1305                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	39	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2026	253	1	2001-03-01 00:00:00
293	Markus Döring                                                                                                                                                                                                                                                  	1306                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	215	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2014	253	1	2001-03-01 00:00:00
294	Markus Döring                                                                                                                                                                                                                                                  	1307                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	198	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2022	253	1	2001-03-01 00:00:00
295	Markus Döring                                                                                                                                                                                                                                                  	1308                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	307	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2020	253	1	2001-03-01 00:00:00
296	Markus Döring                                                                                                                                                                                                                                                  	1309                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	248	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2015	253	1	2001-03-01 00:00:00
297	Markus Döring                                                                                                                                                                                                                                                  	131                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	150	350	1	2001-03-01 00:00:00
298	Markus Döring                                                                                                                                                                                                                                                  	1310                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2021	253	1	2001-03-01 00:00:00
299	Markus Döring                                                                                                                                                                                                                                                  	1311                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	426	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2061	253	1	2001-03-01 00:00:00
300	Markus Döring                                                                                                                                                                                                                                                  	1312                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	580	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2097	253	1	2001-03-01 00:00:00
301	Markus Döring                                                                                                                                                                                                                                                  	1313                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2024	253	1	2001-03-01 00:00:00
302	Markus Döring                                                                                                                                                                                                                                                  	1314                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2025	253	1	2001-03-01 00:00:00
303	Markus Döring                                                                                                                                                                                                                                                  	1315                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2009	253	1	2001-03-01 00:00:00
304	Markus Döring                                                                                                                                                                                                                                                  	1316                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	345	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2010	253	1	2001-03-01 00:00:00
305	Markus Döring                                                                                                                                                                                                                                                  	1317                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	345	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2042	253	1	2001-03-01 00:00:00
306	Markus Döring                                                                                                                                                                                                                                                  	1318a                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2033	253	1	2001-03-01 00:00:00
307	Markus Döring                                                                                                                                                                                                                                                  	1318b                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	2142	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2058	254	1	2001-03-01 00:00:00
308	Markus Döring                                                                                                                                                                                                                                                  	1319                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2100	254	1	2001-03-01 00:00:00
309	Markus Döring                                                                                                                                                                                                                                                  	132                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	493	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	151	350	1	2001-03-01 00:00:00
310	Markus Döring                                                                                                                                                                                                                                                  	1320                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	790	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2043	254	1	2001-03-01 00:00:00
311	Markus Döring                                                                                                                                                                                                                                                  	1321                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	1108	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2062	254	1	2001-03-01 00:00:00
312	Markus Döring                                                                                                                                                                                                                                                  	1322                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	3	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2039	254	1	2001-03-01 00:00:00
313	Markus Döring                                                                                                                                                                                                                                                  	1322x122                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2453	256	1	2001-03-01 00:00:00
314	Markus Döring                                                                                                                                                                                                                                                  	1323                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	332	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2063	254	1	2001-03-01 00:00:00
315	Markus Döring                                                                                                                                                                                                                                                  	1323x122                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	342	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2463	256	1	2001-03-01 00:00:00
316	Markus Döring                                                                                                                                                                                                                                                  	1324                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	227	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2065	254	1	2001-03-01 00:00:00
317	Markus Döring                                                                                                                                                                                                                                                  	1324x122                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	227	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2118	256	1	2001-03-01 00:00:00
318	Markus Döring                                                                                                                                                                                                                                                  	1325                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	219	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2071	255	1	2001-03-01 00:00:00
319	Markus Döring                                                                                                                                                                                                                                                  	1326                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2072	255	1	2001-03-01 00:00:00
320	Markus Döring                                                                                                                                                                                                                                                  	1327                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	98	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2076	255	1	2001-03-01 00:00:00
321	Markus Döring                                                                                                                                                                                                                                                  	1328                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2077	254	1	2001-03-01 00:00:00
322	Markus Döring                                                                                                                                                                                                                                                  	1329                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2034	254	1	2001-03-01 00:00:00
323	Markus Döring                                                                                                                                                                                                                                                  	133                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	269	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	152	350	1	2001-03-01 00:00:00
324	Markus Döring                                                                                                                                                                                                                                                  	1330                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	512	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2133	254	1	2001-03-01 00:00:00
325	Markus Döring                                                                                                                                                                                                                                                  	1331                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2081	255	1	2001-03-01 00:00:00
326	Markus Döring                                                                                                                                                                                                                                                  	1332                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2079	255	1	2001-03-01 00:00:00
327	Markus Döring                                                                                                                                                                                                                                                  	1333                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	540	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2083	255	1	2001-03-01 00:00:00
328	Markus Döring                                                                                                                                                                                                                                                  	1334                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	286	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2090	256	1	2001-03-01 00:00:00
329	Markus Döring                                                                                                                                                                                                                                                  	1335                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2089	255	1	2001-03-01 00:00:00
330	Markus Döring                                                                                                                                                                                                                                                  	1336                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	137	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2094	256	1	2001-03-01 00:00:00
331	Markus Döring                                                                                                                                                                                                                                                  	1337                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	403	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2088	256	1	2001-03-01 00:00:00
332	Markus Döring                                                                                                                                                                                                                                                  	1338                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	335	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2091	256	1	2001-03-01 00:00:00
333	Markus Döring                                                                                                                                                                                                                                                  	1339                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	73	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2086	256	1	2001-03-01 00:00:00
334	Markus Döring                                                                                                                                                                                                                                                  	133x20                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	320	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	405	283	1	2001-03-01 00:00:00
335	Markus Döring                                                                                                                                                                                                                                                  	134                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	141	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	162	350	1	2001-03-01 00:00:00
336	Markus Döring                                                                                                                                                                                                                                                  	1340                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2053	256	1	2001-03-01 00:00:00
337	Markus Döring                                                                                                                                                                                                                                                  	1341                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	2135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2067	257	1	2001-03-01 00:00:00
338	Markus Döring                                                                                                                                                                                                                                                  	1342                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	179	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2098	257	1	2001-03-01 00:00:00
339	Markus Döring                                                                                                                                                                                                                                                  	1343                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	201	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2099	321	1	2001-03-01 00:00:00
340	Markus Döring                                                                                                                                                                                                                                                  	1353                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-08 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2472	321	1	2001-03-01 00:00:00
341	Markus Döring                                                                                                                                                                                                                                                  	136                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	160	381	1	2001-03-01 00:00:00
342	Markus Döring                                                                                                                                                                                                                                                  	137                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	514	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	161	381	1	2001-03-01 00:00:00
343	Markus Döring                                                                                                                                                                                                                                                  	139                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	163	381	1	2001-03-01 00:00:00
344	Markus Döring                                                                                                                                                                                                                                                  	14                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	171	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	6	280	1	2001-03-01 00:00:00
345	Markus Döring                                                                                                                                                                                                                                                  	140                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	269	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	138	381	1	2001-03-01 00:00:00
346	Markus Döring                                                                                                                                                                                                                                                  	1400                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	444	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2117	258	1	2001-03-01 00:00:00
347	Markus Döring                                                                                                                                                                                                                                                  	1400x131                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	444	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2455	259	1	2001-03-01 00:00:00
348	Markus Döring                                                                                                                                                                                                                                                  	1401                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	265	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2119	258	1	2001-03-01 00:00:00
349	Markus Döring                                                                                                                                                                                                                                                  	1402                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2120	258	1	2001-03-01 00:00:00
350	Markus Döring                                                                                                                                                                                                                                                  	1403                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2122	258	1	2001-03-01 00:00:00
351	Markus Döring                                                                                                                                                                                                                                                  	1403x131                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2456	259	1	2001-03-01 00:00:00
352	Markus Döring                                                                                                                                                                                                                                                  	1404                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2128	258	1	2001-03-01 00:00:00
353	Markus Döring                                                                                                                                                                                                                                                  	1404x131                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2457	259	1	2001-03-01 00:00:00
354	Markus Döring                                                                                                                                                                                                                                                  	1405                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2127	258	1	2001-03-01 00:00:00
355	Markus Döring                                                                                                                                                                                                                                                  	1406                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	2135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2125	258	1	2001-03-01 00:00:00
356	Markus Döring                                                                                                                                                                                                                                                  	1406x135                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	2135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2420	263	1	2001-03-01 00:00:00
357	Markus Döring                                                                                                                                                                                                                                                  	1407                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2132	258	1	2001-03-01 00:00:00
358	Markus Döring                                                                                                                                                                                                                                                  	1407x133                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2458	261	1	2001-03-01 00:00:00
359	Markus Döring                                                                                                                                                                                                                                                  	1408                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2134	258	1	2001-03-01 00:00:00
360	Markus Döring                                                                                                                                                                                                                                                  	1409                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	91	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2135	258	1	2001-03-01 00:00:00
361	Markus Döring                                                                                                                                                                                                                                                  	141                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	286	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	164	381	1	2001-03-01 00:00:00
362	Markus Döring                                                                                                                                                                                                                                                  	1410                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2124	258	1	2001-03-01 00:00:00
363	Markus Döring                                                                                                                                                                                                                                                  	1411                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	147	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2121	258	1	2001-03-01 00:00:00
364	Markus Döring                                                                                                                                                                                                                                                  	1412                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	411	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2129	258	1	2001-03-01 00:00:00
365	Markus Döring                                                                                                                                                                                                                                                  	1413                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	452	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2115	258	1	2001-03-01 00:00:00
366	Markus Döring                                                                                                                                                                                                                                                  	1414                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	382	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2136	258	1	2001-03-01 00:00:00
367	Markus Döring                                                                                                                                                                                                                                                  	1414x131                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	382	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2459	259	1	2001-03-01 00:00:00
368	Markus Döring                                                                                                                                                                                                                                                  	1414x135                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	382	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2460	263	1	2001-03-01 00:00:00
369	Markus Döring                                                                                                                                                                                                                                                  	1415                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2130	258	1	2001-03-01 00:00:00
370	Markus Döring                                                                                                                                                                                                                                                  	1416                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2106	258	1	2001-03-01 00:00:00
371	Markus Döring                                                                                                                                                                                                                                                  	1417                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	16	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2170	258	1	2001-03-01 00:00:00
372	Markus Döring                                                                                                                                                                                                                                                  	1418                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2169	258	1	2001-03-01 00:00:00
373	Markus Döring                                                                                                                                                                                                                                                  	1419                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	343	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2142	259	1	2001-03-01 00:00:00
374	Markus Döring                                                                                                                                                                                                                                                  	142                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	165	381	1	2001-03-01 00:00:00
375	Markus Döring                                                                                                                                                                                                                                                  	1420                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2139	259	1	2001-03-01 00:00:00
376	Markus Döring                                                                                                                                                                                                                                                  	1421                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	120	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2141	259	1	2001-03-01 00:00:00
377	Markus Döring                                                                                                                                                                                                                                                  	1422                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	1136	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2144	259	1	2001-03-01 00:00:00
378	Markus Döring                                                                                                                                                                                                                                                  	1422x132                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	1136	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2461	260	1	2001-03-01 00:00:00
379	Markus Döring                                                                                                                                                                                                                                                  	1423                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2138	259	1	2001-03-01 00:00:00
380	Markus Döring                                                                                                                                                                                                                                                  	1424                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2140	259	1	2001-03-01 00:00:00
381	Markus Döring                                                                                                                                                                                                                                                  	1425                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2145	259	1	2001-03-01 00:00:00
382	Markus Döring                                                                                                                                                                                                                                                  	1426                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2107	259	1	2001-03-01 00:00:00
383	Markus Döring                                                                                                                                                                                                                                                  	1427                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	413	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2146	259	1	2001-03-01 00:00:00
384	Markus Döring                                                                                                                                                                                                                                                  	1427x135                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	416	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2462	263	1	2001-03-01 00:00:00
385	Markus Döring                                                                                                                                                                                                                                                  	1428                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2103	259	1	2001-03-01 00:00:00
386	Markus Döring                                                                                                                                                                                                                                                  	1429                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2109	258	1	2001-03-01 00:00:00
387	Markus Döring                                                                                                                                                                                                                                                  	143                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	171	304	1	2001-03-01 00:00:00
388	Markus Döring                                                                                                                                                                                                                                                  	1430                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2226	260	1	2001-03-01 00:00:00
389	Markus Döring                                                                                                                                                                                                                                                  	1431                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	377	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2151	260	1	2001-03-01 00:00:00
390	Markus Döring                                                                                                                                                                                                                                                  	1432                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	96	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2152	260	1	2001-03-01 00:00:00
391	Markus Döring                                                                                                                                                                                                                                                  	1433                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	95	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2204	264	1	2001-03-01 00:00:00
392	Markus Döring                                                                                                                                                                                                                                                  	1434                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	55	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2155	261	1	2001-03-01 00:00:00
393	Markus Döring                                                                                                                                                                                                                                                  	1435                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	142	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2157	261	1	2001-03-01 00:00:00
394	Markus Döring                                                                                                                                                                                                                                                  	1436                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	95	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2156	258	1	2001-03-01 00:00:00
395	Markus Döring                                                                                                                                                                                                                                                  	1437                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	297	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2368	260	1	2001-03-01 00:00:00
396	Markus Döring                                                                                                                                                                                                                                                  	1437x135                                                                                                                                                                                                                                                       	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	297	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2421	263	1	2001-03-01 00:00:00
397	Markus Döring                                                                                                                                                                                                                                                  	1438                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2159	261	1	2001-03-01 00:00:00
398	Markus Döring                                                                                                                                                                                                                                                  	1439                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	499	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2160	261	1	2001-03-01 00:00:00
399	Markus Döring                                                                                                                                                                                                                                                  	1439ax135                                                                                                                                                                                                                                                      	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	499	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2404	263	1	2001-03-01 00:00:00
400	Markus Döring                                                                                                                                                                                                                                                  	1439bx135                                                                                                                                                                                                                                                      	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2405	263	1	2001-03-01 00:00:00
401	Markus Döring                                                                                                                                                                                                                                                  	144                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	490	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	166	381	1	2001-03-01 00:00:00
402	Markus Döring                                                                                                                                                                                                                                                  	1440                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	390	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2161	262	1	2001-03-01 00:00:00
403	Markus Döring                                                                                                                                                                                                                                                  	1441                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	411	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2162	262	1	2001-03-01 00:00:00
404	Markus Döring                                                                                                                                                                                                                                                  	1442                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	84	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2163	263	1	2001-03-01 00:00:00
405	Markus Döring                                                                                                                                                                                                                                                  	1443                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-09 00:00:00	554	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2165	262	1	2001-03-01 00:00:00
406	Markus Döring                                                                                                                                                                                                                                                  	145                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	116	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	168	303	1	2001-03-01 00:00:00
407	Markus Döring                                                                                                                                                                                                                                                  	1450                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	439	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2202	264	1	2001-03-01 00:00:00
408	Markus Döring                                                                                                                                                                                                                                                  	1451                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2199	264	1	2001-03-01 00:00:00
409	Markus Döring                                                                                                                                                                                                                                                  	1452                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	264	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2196	264	1	2001-03-01 00:00:00
410	Markus Döring                                                                                                                                                                                                                                                  	1453                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2187	264	1	2001-03-01 00:00:00
411	Markus Döring                                                                                                                                                                                                                                                  	1454                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2205	264	1	2001-03-01 00:00:00
412	Markus Döring                                                                                                                                                                                                                                                  	1455                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2173	264	1	2001-03-01 00:00:00
413	Markus Döring                                                                                                                                                                                                                                                  	1456                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2207	264	1	2001-03-01 00:00:00
414	Markus Döring                                                                                                                                                                                                                                                  	1457                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2195	264	1	2001-03-01 00:00:00
415	Markus Döring                                                                                                                                                                                                                                                  	1458                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	168	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2194	264	1	2001-03-01 00:00:00
416	Markus Döring                                                                                                                                                                                                                                                  	1459                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2174	264	1	2001-03-01 00:00:00
417	Markus Döring                                                                                                                                                                                                                                                  	146                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	237	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	167	381	1	2001-03-01 00:00:00
418	Markus Döring                                                                                                                                                                                                                                                  	1460                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	256	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2211	265	1	2001-03-01 00:00:00
419	Markus Döring                                                                                                                                                                                                                                                  	1461                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	306	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2212	265	1	2001-03-01 00:00:00
420	Markus Döring                                                                                                                                                                                                                                                  	1462                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	416	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2218	265	1	2001-03-01 00:00:00
421	Markus Döring                                                                                                                                                                                                                                                  	1463                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	413	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2219	265	1	2001-03-01 00:00:00
422	Markus Döring                                                                                                                                                                                                                                                  	1464a                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	545	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2217	265	1	2001-03-01 00:00:00
423	Markus Döring                                                                                                                                                                                                                                                  	1464b                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2398	265	1	2001-03-01 00:00:00
424	Markus Döring                                                                                                                                                                                                                                                  	1465                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	511	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2213	265	1	2001-03-01 00:00:00
425	Markus Döring                                                                                                                                                                                                                                                  	1466                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2214	265	1	2001-03-01 00:00:00
426	Markus Döring                                                                                                                                                                                                                                                  	1467                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2188	265	1	2001-03-01 00:00:00
427	Markus Döring                                                                                                                                                                                                                                                  	1468                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2220	265	1	2001-03-01 00:00:00
428	Markus Döring                                                                                                                                                                                                                                                  	147                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	320	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	172	304	1	2001-03-01 00:00:00
429	Markus Döring                                                                                                                                                                                                                                                  	1470                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	230	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2229	266	1	2001-03-01 00:00:00
430	Markus Döring                                                                                                                                                                                                                                                  	1471                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	439	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2237	266	1	2001-03-01 00:00:00
431	Markus Döring                                                                                                                                                                                                                                                  	1472                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	85	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2236	266	1	2001-03-01 00:00:00
432	Markus Döring                                                                                                                                                                                                                                                  	1473                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	99	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2238	266	1	2001-03-01 00:00:00
433	Markus Döring                                                                                                                                                                                                                                                  	1474                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	111	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2235	266	1	2001-03-01 00:00:00
434	Markus Döring                                                                                                                                                                                                                                                  	1475                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	377	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2233	266	1	2001-03-01 00:00:00
435	Markus Döring                                                                                                                                                                                                                                                  	1476                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	55	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2232	266	1	2001-03-01 00:00:00
436	Markus Döring                                                                                                                                                                                                                                                  	1477                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2231	266	1	2001-03-01 00:00:00
437	Markus Döring                                                                                                                                                                                                                                                  	1478                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2167	266	1	2001-03-01 00:00:00
438	Markus Döring                                                                                                                                                                                                                                                  	1479                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	243	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2301	269	1	2001-03-01 00:00:00
439	Markus Döring                                                                                                                                                                                                                                                  	148                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	170	303	1	2001-03-01 00:00:00
440	Markus Döring                                                                                                                                                                                                                                                  	1480                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2240	267	1	2001-03-01 00:00:00
441	Markus Döring                                                                                                                                                                                                                                                  	1481                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	16	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2239	267	1	2001-03-01 00:00:00
442	Markus Döring                                                                                                                                                                                                                                                  	1482                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	80	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2280	267	1	2001-03-01 00:00:00
443	Markus Döring                                                                                                                                                                                                                                                  	1483                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2293	269	1	2001-03-01 00:00:00
444	Markus Döring                                                                                                                                                                                                                                                  	1484                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	111	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2298	269	1	2001-03-01 00:00:00
445	Markus Döring                                                                                                                                                                                                                                                  	1485                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	191	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2294	269	1	2001-03-01 00:00:00
446	Markus Döring                                                                                                                                                                                                                                                  	1486                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2297	269	1	2001-03-01 00:00:00
447	Markus Döring                                                                                                                                                                                                                                                  	1487                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	439	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2250	267	1	2001-03-01 00:00:00
448	Markus Döring                                                                                                                                                                                                                                                  	1488                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2215	267	1	2001-03-01 00:00:00
449	Markus Döring                                                                                                                                                                                                                                                  	1489                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	413	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2276	267	1	2001-03-01 00:00:00
450	Markus Döring                                                                                                                                                                                                                                                  	149                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	173	304	1	2001-03-01 00:00:00
451	Markus Döring                                                                                                                                                                                                                                                  	1490                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	455	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2248	267	1	2001-03-01 00:00:00
452	Markus Döring                                                                                                                                                                                                                                                  	1491                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	314	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2284	267	1	2001-03-01 00:00:00
453	Markus Döring                                                                                                                                                                                                                                                  	1492                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	232	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2278	267	1	2001-03-01 00:00:00
454	Markus Döring                                                                                                                                                                                                                                                  	1493                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2282	267	1	2001-03-01 00:00:00
455	Markus Döring                                                                                                                                                                                                                                                  	1494                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	439	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2292	267	1	2001-03-01 00:00:00
456	Markus Döring                                                                                                                                                                                                                                                  	1495                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2253	267	1	2001-03-01 00:00:00
457	Markus Döring                                                                                                                                                                                                                                                  	1496                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	439	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2251	267	1	2001-03-01 00:00:00
458	Markus Döring                                                                                                                                                                                                                                                  	1497                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	139	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2285	267	1	2001-03-01 00:00:00
459	Markus Döring                                                                                                                                                                                                                                                  	1498                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2271	267	1	2001-03-01 00:00:00
460	Markus Döring                                                                                                                                                                                                                                                  	1499                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2283	267	1	2001-03-01 00:00:00
461	Markus Döring                                                                                                                                                                                                                                                  	150                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	121	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	169	303	1	2001-03-01 00:00:00
462	Markus Döring                                                                                                                                                                                                                                                  	1500                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	986	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2246	267	1	2001-03-01 00:00:00
463	Markus Döring                                                                                                                                                                                                                                                  	1501                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	368	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2286	267	1	2001-03-01 00:00:00
464	Markus Döring                                                                                                                                                                                                                                                  	1502                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	64	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2343	271	1	2001-03-01 00:00:00
465	Markus Döring                                                                                                                                                                                                                                                  	1503                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	403	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2339	271	1	2001-03-01 00:00:00
466	Markus Döring                                                                                                                                                                                                                                                  	1504                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2342	271	1	2001-03-01 00:00:00
467	Markus Döring                                                                                                                                                                                                                                                  	1505                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	215	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2346	271	1	2001-03-01 00:00:00
468	Markus Döring                                                                                                                                                                                                                                                  	1506                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	426	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2340	271	1	2001-03-01 00:00:00
469	Markus Döring                                                                                                                                                                                                                                                  	1507                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2324	271	1	2001-03-01 00:00:00
470	Markus Döring                                                                                                                                                                                                                                                  	1508                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2326	271	1	2001-03-01 00:00:00
471	Markus Döring                                                                                                                                                                                                                                                  	1509                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2337	271	1	2001-03-01 00:00:00
472	Markus Döring                                                                                                                                                                                                                                                  	151                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-27 00:00:00	755	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	193	302	1	2001-03-01 00:00:00
473	Markus Döring                                                                                                                                                                                                                                                  	1510                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2330	271	1	2001-03-01 00:00:00
474	Markus Döring                                                                                                                                                                                                                                                  	1511                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2345	271	1	2001-03-01 00:00:00
475	Markus Döring                                                                                                                                                                                                                                                  	1512                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	167	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2348	271	1	2001-03-01 00:00:00
476	Markus Döring                                                                                                                                                                                                                                                  	1513                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2349	271	1	2001-03-01 00:00:00
477	Markus Döring                                                                                                                                                                                                                                                  	1514                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	296	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2350	271	1	2001-03-01 00:00:00
478	Markus Döring                                                                                                                                                                                                                                                  	1515                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2335	271	1	2001-03-01 00:00:00
479	Markus Döring                                                                                                                                                                                                                                                  	1516                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	191	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2332	272	1	2001-03-01 00:00:00
480	Markus Döring                                                                                                                                                                                                                                                  	1517                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2377	272	1	2001-03-01 00:00:00
481	Markus Döring                                                                                                                                                                                                                                                  	1518                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2364	272	1	2001-03-01 00:00:00
482	Markus Döring                                                                                                                                                                                                                                                  	1519                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	265	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2374	272	1	2001-03-01 00:00:00
483	Markus Döring                                                                                                                                                                                                                                                  	152                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	136	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	174	305	1	2001-03-01 00:00:00
484	Markus Döring                                                                                                                                                                                                                                                  	1520                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	548	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2376	272	1	2001-03-01 00:00:00
485	Markus Döring                                                                                                                                                                                                                                                  	1521                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2358	272	1	2001-03-01 00:00:00
486	Markus Döring                                                                                                                                                                                                                                                  	1522                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2375	272	1	2001-03-01 00:00:00
487	Markus Döring                                                                                                                                                                                                                                                  	1523                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	413	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2378	272	1	2001-03-01 00:00:00
488	Markus Döring                                                                                                                                                                                                                                                  	1524                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	232	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2369	272	1	2001-03-01 00:00:00
489	Markus Döring                                                                                                                                                                                                                                                  	1525                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2370	272	1	2001-03-01 00:00:00
490	Markus Döring                                                                                                                                                                                                                                                  	1526                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2365	272	1	2001-03-01 00:00:00
491	Markus Döring                                                                                                                                                                                                                                                  	1527                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2328	271	1	2001-03-01 00:00:00
492	Markus Döring                                                                                                                                                                                                                                                  	1528                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	368	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2317	270	1	2001-03-01 00:00:00
493	Markus Döring                                                                                                                                                                                                                                                  	1529                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	373	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2310	270	1	2001-03-01 00:00:00
494	Markus Döring                                                                                                                                                                                                                                                  	153                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	246	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	175	305	1	2001-03-01 00:00:00
495	Markus Döring                                                                                                                                                                                                                                                  	1530                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	383	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2306	270	1	2001-03-01 00:00:00
496	Markus Döring                                                                                                                                                                                                                                                  	1531                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	299	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2314	270	1	2001-03-01 00:00:00
497	Markus Döring                                                                                                                                                                                                                                                  	1532                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	286	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2313	270	1	2001-03-01 00:00:00
498	Markus Döring                                                                                                                                                                                                                                                  	1533                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	306	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2307	270	1	2001-03-01 00:00:00
499	Markus Döring                                                                                                                                                                                                                                                  	1534                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2311	270	1	2001-03-01 00:00:00
500	Markus Döring                                                                                                                                                                                                                                                  	1535                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2323	270	1	2001-03-01 00:00:00
501	Markus Döring                                                                                                                                                                                                                                                  	1536                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2320	270	1	2001-03-01 00:00:00
502	Markus Döring                                                                                                                                                                                                                                                  	1537                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2321	270	1	2001-03-01 00:00:00
503	Markus Döring                                                                                                                                                                                                                                                  	1538                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	255	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2312	270	1	2001-03-01 00:00:00
504	Markus Döring                                                                                                                                                                                                                                                  	1539                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	221	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2316	270	1	2001-03-01 00:00:00
505	Markus Döring                                                                                                                                                                                                                                                  	154                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	210	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	177	305	1	2001-03-01 00:00:00
506	Markus Döring                                                                                                                                                                                                                                                  	1540                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	64	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2308	270	1	2001-03-01 00:00:00
507	Markus Döring                                                                                                                                                                                                                                                  	1541                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	367	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2318	270	1	2001-03-01 00:00:00
508	Markus Döring                                                                                                                                                                                                                                                  	1542                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	343	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2309	270	1	2001-03-01 00:00:00
509	Markus Döring                                                                                                                                                                                                                                                  	1543                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	10	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2305	270	1	2001-03-01 00:00:00
510	Markus Döring                                                                                                                                                                                                                                                  	1544                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-12 00:00:00	272	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2315	270	1	2001-03-01 00:00:00
511	Markus Döring                                                                                                                                                                                                                                                  	155                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	841	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	178	305	1	2001-03-01 00:00:00
512	Markus Döring                                                                                                                                                                                                                                                  	156                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	179	305	1	2001-03-01 00:00:00
513	Markus Döring                                                                                                                                                                                                                                                  	157                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	194	391	1	2001-03-01 00:00:00
514	Markus Döring                                                                                                                                                                                                                                                  	158                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	183	391	1	2001-03-01 00:00:00
515	Markus Döring                                                                                                                                                                                                                                                  	159                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	188	391	1	2001-03-01 00:00:00
516	Markus Döring                                                                                                                                                                                                                                                  	161                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	191	391	1	2001-03-01 00:00:00
517	Markus Döring                                                                                                                                                                                                                                                  	162                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	198	391	1	2001-03-01 00:00:00
518	Markus Döring                                                                                                                                                                                                                                                  	162x1                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	267	312	1	2001-03-01 00:00:00
519	Markus Döring                                                                                                                                                                                                                                                  	162x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	394	275	1	2001-03-01 00:00:00
520	Markus Döring                                                                                                                                                                                                                                                  	163                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	274	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	195	391	1	2001-03-01 00:00:00
521	Markus Döring                                                                                                                                                                                                                                                  	164                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	1139	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	196	391	1	2001-03-01 00:00:00
522	Markus Döring                                                                                                                                                                                                                                                  	165                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	31	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	204	391	1	2001-03-01 00:00:00
523	Markus Döring                                                                                                                                                                                                                                                  	166                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	205	391	1	2001-03-01 00:00:00
524	Markus Döring                                                                                                                                                                                                                                                  	167                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	146	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	197	391	1	2001-03-01 00:00:00
525	Markus Döring                                                                                                                                                                                                                                                  	168                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	231	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	199	391	1	2001-03-01 00:00:00
526	Markus Döring                                                                                                                                                                                                                                                  	169                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	241	391	1	2001-03-01 00:00:00
527	Markus Döring                                                                                                                                                                                                                                                  	17                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	7	280	1	2001-03-01 00:00:00
528	Markus Döring                                                                                                                                                                                                                                                  	170                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	201	391	1	2001-03-01 00:00:00
529	Markus Döring                                                                                                                                                                                                                                                  	171                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	202	391	1	2001-03-01 00:00:00
530	Markus Döring                                                                                                                                                                                                                                                  	172                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	367	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	203	391	1	2001-03-01 00:00:00
531	Markus Döring                                                                                                                                                                                                                                                  	173                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	336	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	206	391	1	2001-03-01 00:00:00
532	Markus Döring                                                                                                                                                                                                                                                  	174                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	207	391	1	2001-03-01 00:00:00
533	Markus Döring                                                                                                                                                                                                                                                  	175                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	391	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	724	391	1	2001-03-01 00:00:00
534	Markus Döring                                                                                                                                                                                                                                                  	1755                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-07 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2004	247	1	2001-03-01 00:00:00
535	Markus Döring                                                                                                                                                                                                                                                  	176                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	208	391	1	2001-03-01 00:00:00
536	Markus Döring                                                                                                                                                                                                                                                  	177                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	211	391	1	2001-03-01 00:00:00
537	Markus Döring                                                                                                                                                                                                                                                  	178                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	116	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	212	391	1	2001-03-01 00:00:00
538	Markus Döring                                                                                                                                                                                                                                                  	179                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	529	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	213	391	1	2001-03-01 00:00:00
539	Markus Döring                                                                                                                                                                                                                                                  	18                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	38	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	8	280	1	2001-03-01 00:00:00
540	Markus Döring                                                                                                                                                                                                                                                  	180                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	514	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	214	391	1	2001-03-01 00:00:00
541	Markus Döring                                                                                                                                                                                                                                                  	180x                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	514	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	238	222	1	2001-03-01 00:00:00
542	Markus Döring                                                                                                                                                                                                                                                  	181                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	215	391	1	2001-03-01 00:00:00
543	Markus Döring                                                                                                                                                                                                                                                  	182a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	184	391	1	2001-03-01 00:00:00
544	Markus Döring                                                                                                                                                                                                                                                  	182b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	220	391	1	2001-03-01 00:00:00
545	Markus Döring                                                                                                                                                                                                                                                  	183                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	106	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	217	221	1	2001-03-01 00:00:00
546	Markus Döring                                                                                                                                                                                                                                                  	184                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	243	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	218	203	1	2001-03-01 00:00:00
547	Markus Döring                                                                                                                                                                                                                                                  	185                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	221	308	1	2001-03-01 00:00:00
548	Markus Döring                                                                                                                                                                                                                                                  	186a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	509	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	222	308	1	2001-03-01 00:00:00
549	Markus Döring                                                                                                                                                                                                                                                  	186b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	44	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2411	308	1	2001-03-01 00:00:00
550	Markus Döring                                                                                                                                                                                                                                                  	187                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	223	308	1	2001-03-01 00:00:00
551	Markus Döring                                                                                                                                                                                                                                                  	188                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	427	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	226	391	1	2001-03-01 00:00:00
552	Markus Döring                                                                                                                                                                                                                                                  	189                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	431	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	231	222	1	2001-03-01 00:00:00
553	Markus Döring                                                                                                                                                                                                                                                  	190                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	233	222	1	2001-03-01 00:00:00
554	Markus Döring                                                                                                                                                                                                                                                  	191                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	269	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	283	222	1	2001-03-01 00:00:00
555	Markus Döring                                                                                                                                                                                                                                                  	192                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	253	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	234	222	1	2001-03-01 00:00:00
556	Markus Döring                                                                                                                                                                                                                                                  	192x1                                                                                                                                                                                                                                                          	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	253	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	258	309	1	2001-03-01 00:00:00
557	Markus Döring                                                                                                                                                                                                                                                  	193                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	443	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	237	222	1	2001-03-01 00:00:00
558	Markus Döring                                                                                                                                                                                                                                                  	194                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	132	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	239	222	1	2001-03-01 00:00:00
559	Markus Döring                                                                                                                                                                                                                                                  	195                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	303	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	240	222	1	2001-03-01 00:00:00
560	Markus Döring                                                                                                                                                                                                                                                  	196                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	568	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	242	222	1	2001-03-01 00:00:00
561	Markus Döring                                                                                                                                                                                                                                                  	197                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	243	222	1	2001-03-01 00:00:00
562	Markus Döring                                                                                                                                                                                                                                                  	198                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	1166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	244	222	1	2001-03-01 00:00:00
563	Markus Döring                                                                                                                                                                                                                                                  	198x                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	1166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	264	310	1	2001-03-01 00:00:00
564	Markus Döring                                                                                                                                                                                                                                                  	199                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	116	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	291	222	1	2001-03-01 00:00:00
565	Markus Döring                                                                                                                                                                                                                                                  	20                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	9	280	1	2001-03-01 00:00:00
566	Markus Döring                                                                                                                                                                                                                                                  	200                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	180	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	189	391	1	2001-03-01 00:00:00
567	Markus Döring                                                                                                                                                                                                                                                  	2001                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1040	360	1	2001-03-01 00:00:00
568	Markus Döring                                                                                                                                                                                                                                                  	2003                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-10 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2263	267	1	2001-03-01 00:00:00
569	Markus Döring                                                                                                                                                                                                                                                  	2004                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	326	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1407	394	1	2001-03-01 00:00:00
570	Markus Döring                                                                                                                                                                                                                                                  	2005                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	794	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	370	291	1	2001-03-01 00:00:00
571	Markus Döring                                                                                                                                                                                                                                                  	2009                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	467	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	828	345	1	2001-03-01 00:00:00
572	Markus Döring                                                                                                                                                                                                                                                  	201                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	175	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	249	307	1	2001-03-01 00:00:00
573	Markus Döring                                                                                                                                                                                                                                                  	2013                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	417	283	1	2001-03-01 00:00:00
574	Markus Döring                                                                                                                                                                                                                                                  	202                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	250	307	1	2001-03-01 00:00:00
575	Markus Döring                                                                                                                                                                                                                                                  	203                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	251	307	1	2001-03-01 00:00:00
576	Markus Döring                                                                                                                                                                                                                                                  	204                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	9	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	252	307	1	2001-03-01 00:00:00
577	Markus Döring                                                                                                                                                                                                                                                  	205                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-28 00:00:00	27	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	253	307	1	2001-03-01 00:00:00
578	Markus Döring                                                                                                                                                                                                                                                  	206                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	313	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2426	310	1	2001-03-01 00:00:00
579	Markus Döring                                                                                                                                                                                                                                                  	207                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	376	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	261	310	1	2001-03-01 00:00:00
580	Markus Döring                                                                                                                                                                                                                                                  	208                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	379	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	254	309	1	2001-03-01 00:00:00
581	Markus Döring                                                                                                                                                                                                                                                  	209                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	431	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	260	309	1	2001-03-01 00:00:00
582	Markus Döring                                                                                                                                                                                                                                                  	211                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	358	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	268	312	1	2001-03-01 00:00:00
583	Markus Döring                                                                                                                                                                                                                                                  	212                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	9	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	279	268	1	2001-03-01 00:00:00
584	Markus Döring                                                                                                                                                                                                                                                  	213                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	280	268	1	2001-03-01 00:00:00
585	Markus Döring                                                                                                                                                                                                                                                  	214                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	104	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	281	268	1	2001-03-01 00:00:00
586	Markus Döring                                                                                                                                                                                                                                                  	215                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	282	268	1	2001-03-01 00:00:00
587	Markus Döring                                                                                                                                                                                                                                                  	216                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	392	268	1	2001-03-01 00:00:00
588	Markus Döring                                                                                                                                                                                                                                                  	216x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	341	275	1	2001-03-01 00:00:00
589	Markus Döring                                                                                                                                                                                                                                                  	217                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	514	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	285	268	1	2001-03-01 00:00:00
590	Markus Döring                                                                                                                                                                                                                                                  	218                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	448	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	286	268	1	2001-03-01 00:00:00
591	Markus Döring                                                                                                                                                                                                                                                  	219                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	287	268	1	2001-03-01 00:00:00
592	Markus Döring                                                                                                                                                                                                                                                  	22                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	10	280	1	2001-03-01 00:00:00
593	Markus Döring                                                                                                                                                                                                                                                  	220                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	156	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	288	268	1	2001-03-01 00:00:00
594	Markus Döring                                                                                                                                                                                                                                                  	221                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	178	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	290	268	1	2001-03-01 00:00:00
595	Markus Döring                                                                                                                                                                                                                                                  	222                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	175	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	292	268	1	2001-03-01 00:00:00
596	Markus Döring                                                                                                                                                                                                                                                  	223                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	522	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	293	268	1	2001-03-01 00:00:00
597	Markus Döring                                                                                                                                                                                                                                                  	224                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	577	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	294	268	1	2001-03-01 00:00:00
598	Markus Döring                                                                                                                                                                                                                                                  	225                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	514	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	295	268	1	2001-03-01 00:00:00
599	Markus Döring                                                                                                                                                                                                                                                  	226                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	375	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	297	268	1	2001-03-01 00:00:00
600	Markus Döring                                                                                                                                                                                                                                                  	227                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	550	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	298	310	1	2001-03-01 00:00:00
601	Markus Döring                                                                                                                                                                                                                                                  	228                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	522	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	266	310	1	2001-03-01 00:00:00
602	Markus Döring                                                                                                                                                                                                                                                  	229                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	272	313	1	2001-03-01 00:00:00
603	Markus Döring                                                                                                                                                                                                                                                  	230                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	237	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	271	313	1	2001-03-01 00:00:00
604	Markus Döring                                                                                                                                                                                                                                                  	231                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-29 00:00:00	277	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	274	313	1	2001-03-01 00:00:00
605	Markus Döring                                                                                                                                                                                                                                                  	232                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-30 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	299	314	1	2001-03-01 00:00:00
606	Markus Döring                                                                                                                                                                                                                                                  	233                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	303	275	1	2001-03-01 00:00:00
607	Markus Döring                                                                                                                                                                                                                                                  	234                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	347	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	433	274	1	2001-03-01 00:00:00
608	Markus Döring                                                                                                                                                                                                                                                  	234x                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	347	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	352	276	1	2001-03-01 00:00:00
609	Markus Döring                                                                                                                                                                                                                                                  	235                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	56	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	381	274	1	2001-03-01 00:00:00
610	Markus Döring                                                                                                                                                                                                                                                  	236                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	318	274	1	2001-03-01 00:00:00
611	Markus Döring                                                                                                                                                                                                                                                  	237                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	319	274	1	2001-03-01 00:00:00
612	Markus Döring                                                                                                                                                                                                                                                  	237x17                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	349	276	1	2001-03-01 00:00:00
613	Markus Döring                                                                                                                                                                                                                                                  	238                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	316	274	1	2001-03-01 00:00:00
614	Markus Döring                                                                                                                                                                                                                                                  	238x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2423	275	1	2001-03-01 00:00:00
615	Markus Döring                                                                                                                                                                                                                                                  	238x17                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	360	276	1	2001-03-01 00:00:00
616	Markus Döring                                                                                                                                                                                                                                                  	238x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	385	278	1	2001-03-01 00:00:00
617	Markus Döring                                                                                                                                                                                                                                                  	239                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	432	274	1	2001-03-01 00:00:00
618	Markus Döring                                                                                                                                                                                                                                                  	240                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	325	274	1	2001-03-01 00:00:00
619	Markus Döring                                                                                                                                                                                                                                                  	240x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	331	275	1	2001-03-01 00:00:00
620	Markus Döring                                                                                                                                                                                                                                                  	240x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	400	278	1	2001-03-01 00:00:00
621	Markus Döring                                                                                                                                                                                                                                                  	241                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	312	274	1	2001-03-01 00:00:00
622	Markus Döring                                                                                                                                                                                                                                                  	241x17                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	345	276	1	2001-03-01 00:00:00
623	Markus Döring                                                                                                                                                                                                                                                  	242                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	418	274	1	2001-03-01 00:00:00
624	Markus Döring                                                                                                                                                                                                                                                  	242x17                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	344	276	1	2001-03-01 00:00:00
625	Markus Döring                                                                                                                                                                                                                                                  	243                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	309	274	1	2001-03-01 00:00:00
626	Markus Döring                                                                                                                                                                                                                                                  	243x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	373	278	1	2001-03-01 00:00:00
627	Markus Döring                                                                                                                                                                                                                                                  	244                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	310	274	1	2001-03-01 00:00:00
628	Markus Döring                                                                                                                                                                                                                                                  	245a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	320	274	1	2001-03-01 00:00:00
629	Markus Döring                                                                                                                                                                                                                                                  	245b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2402	274	1	2001-03-01 00:00:00
630	Markus Döring                                                                                                                                                                                                                                                  	246                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	384	278	1	2001-03-01 00:00:00
631	Markus Döring                                                                                                                                                                                                                                                  	246x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	327	275	1	2001-03-01 00:00:00
632	Markus Döring                                                                                                                                                                                                                                                  	247                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	382	274	1	2001-03-01 00:00:00
633	Markus Döring                                                                                                                                                                                                                                                  	248                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	328	274	1	2001-03-01 00:00:00
634	Markus Döring                                                                                                                                                                                                                                                  	248x20                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	431	283	1	2001-03-01 00:00:00
635	Markus Döring                                                                                                                                                                                                                                                  	249                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	435	300	1	2001-03-01 00:00:00
636	Markus Döring                                                                                                                                                                                                                                                  	249x16                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	329	275	1	2001-03-01 00:00:00
637	Markus Döring                                                                                                                                                                                                                                                  	25                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	229	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	11	280	1	2001-03-01 00:00:00
638	Markus Döring                                                                                                                                                                                                                                                  	250                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	336	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	330	274	1	2001-03-01 00:00:00
639	Markus Döring                                                                                                                                                                                                                                                  	250x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	336	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	393	278	1	2001-03-01 00:00:00
640	Markus Döring                                                                                                                                                                                                                                                  	251                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	347	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	334	274	1	2001-03-01 00:00:00
641	Markus Döring                                                                                                                                                                                                                                                  	252                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	20	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	336	275	1	2001-03-01 00:00:00
642	Markus Döring                                                                                                                                                                                                                                                  	253                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	374	275	1	2001-03-01 00:00:00
643	Markus Döring                                                                                                                                                                                                                                                  	254                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	313	275	1	2001-03-01 00:00:00
644	Markus Döring                                                                                                                                                                                                                                                  	254x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	401	278	1	2001-03-01 00:00:00
645	Markus Döring                                                                                                                                                                                                                                                  	254x20                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2427	283	1	2001-03-01 00:00:00
646	Markus Döring                                                                                                                                                                                                                                                  	255                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	526	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	314	275	1	2001-03-01 00:00:00
647	Markus Döring                                                                                                                                                                                                                                                  	256                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	317	275	1	2001-03-01 00:00:00
648	Markus Döring                                                                                                                                                                                                                                                  	257                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	94	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	340	275	1	2001-03-01 00:00:00
649	Markus Döring                                                                                                                                                                                                                                                  	258                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	321	275	1	2001-03-01 00:00:00
650	Markus Döring                                                                                                                                                                                                                                                  	259                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	536	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	342	275	1	2001-03-01 00:00:00
651	Markus Döring                                                                                                                                                                                                                                                  	26                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	304	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	12	280	1	2001-03-01 00:00:00
652	Markus Döring                                                                                                                                                                                                                                                  	260                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	323	275	1	2001-03-01 00:00:00
653	Markus Döring                                                                                                                                                                                                                                                  	261                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	619	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	346	276	1	2001-03-01 00:00:00
654	Markus Döring                                                                                                                                                                                                                                                  	262                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	234	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	347	276	1	2001-03-01 00:00:00
655	Markus Döring                                                                                                                                                                                                                                                  	263                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	347	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	353	276	1	2001-03-01 00:00:00
656	Markus Döring                                                                                                                                                                                                                                                  	264                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	481	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	357	276	1	2001-03-01 00:00:00
657	Markus Döring                                                                                                                                                                                                                                                  	264x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	469	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	375	278	1	2001-03-01 00:00:00
658	Markus Döring                                                                                                                                                                                                                                                  	265                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	359	276	1	2001-03-01 00:00:00
659	Markus Döring                                                                                                                                                                                                                                                  	266                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	351	276	1	2001-03-01 00:00:00
660	Markus Döring                                                                                                                                                                                                                                                  	267                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	573	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	356	276	1	2001-03-01 00:00:00
661	Markus Döring                                                                                                                                                                                                                                                  	268                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	496	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	348	276	1	2001-03-01 00:00:00
662	Markus Döring                                                                                                                                                                                                                                                  	269                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	490	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	354	276	1	2001-03-01 00:00:00
663	Markus Döring                                                                                                                                                                                                                                                  	27                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	257	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	81	287	1	2001-03-01 00:00:00
664	Markus Döring                                                                                                                                                                                                                                                  	270                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	441	276	1	2001-03-01 00:00:00
665	Markus Döring                                                                                                                                                                                                                                                  	271                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	358	276	1	2001-03-01 00:00:00
666	Markus Döring                                                                                                                                                                                                                                                  	271x21                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	424	291	1	2001-03-01 00:00:00
667	Markus Döring                                                                                                                                                                                                                                                  	272                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	436	276	1	2001-03-01 00:00:00
668	Markus Döring                                                                                                                                                                                                                                                  	273                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	365	276	1	2001-03-01 00:00:00
669	Markus Döring                                                                                                                                                                                                                                                  	274                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	366	277	1	2001-03-01 00:00:00
670	Markus Döring                                                                                                                                                                                                                                                  	274x17                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2403	276	1	2001-03-01 00:00:00
671	Markus Döring                                                                                                                                                                                                                                                  	274x19                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	386	278	1	2001-03-01 00:00:00
672	Markus Döring                                                                                                                                                                                                                                                  	275                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2469	277	1	2001-03-01 00:00:00
673	Markus Döring                                                                                                                                                                                                                                                  	276                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	166	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	414	277	1	2001-03-01 00:00:00
674	Markus Döring                                                                                                                                                                                                                                                  	277                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	573	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	368	277	1	2001-03-01 00:00:00
675	Markus Döring                                                                                                                                                                                                                                                  	278                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	243	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	369	277	1	2001-03-01 00:00:00
676	Markus Döring                                                                                                                                                                                                                                                  	279                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	343	277	1	2001-03-01 00:00:00
677	Markus Döring                                                                                                                                                                                                                                                  	28                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	102	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	21	288	1	2001-03-01 00:00:00
678	Markus Döring                                                                                                                                                                                                                                                  	280                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	1165	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	300	315	1	2001-03-01 00:00:00
679	Markus Döring                                                                                                                                                                                                                                                  	282                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	336	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	302	315	1	2001-03-01 00:00:00
680	Markus Döring                                                                                                                                                                                                                                                  	283                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	301	315	1	2001-03-01 00:00:00
681	Markus Döring                                                                                                                                                                                                                                                  	285                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-02 00:00:00	278	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	324	275	1	2001-03-01 00:00:00
682	Markus Döring                                                                                                                                                                                                                                                  	286                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	391	278	1	2001-03-01 00:00:00
683	Markus Döring                                                                                                                                                                                                                                                  	287                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	390	278	1	2001-03-01 00:00:00
684	Markus Döring                                                                                                                                                                                                                                                  	287x24                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	508	206	1	2001-03-01 00:00:00
685	Markus Döring                                                                                                                                                                                                                                                  	288                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	383	278	1	2001-03-01 00:00:00
686	Markus Döring                                                                                                                                                                                                                                                  	289                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	65	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	398	278	1	2001-03-01 00:00:00
687	Markus Döring                                                                                                                                                                                                                                                  	291                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	367	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	437	300	1	2001-03-01 00:00:00
688	Markus Döring                                                                                                                                                                                                                                                  	292                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	397	278	1	2001-03-01 00:00:00
689	Markus Döring                                                                                                                                                                                                                                                  	292x24                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	494	206	1	2001-03-01 00:00:00
690	Markus Döring                                                                                                                                                                                                                                                  	293                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	29	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2387	322	1	2001-03-01 00:00:00
691	Markus Döring                                                                                                                                                                                                                                                  	294                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2388	323	1	2001-03-01 00:00:00
692	Markus Döring                                                                                                                                                                                                                                                  	296                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	358	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	408	283	1	2001-03-01 00:00:00
693	Markus Döring                                                                                                                                                                                                                                                  	298                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	404	283	1	2001-03-01 00:00:00
694	Markus Döring                                                                                                                                                                                                                                                  	299                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	406	283	1	2001-03-01 00:00:00
695	Markus Döring                                                                                                                                                                                                                                                  	300                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	470	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	371	291	1	2001-03-01 00:00:00
696	Markus Döring                                                                                                                                                                                                                                                  	301                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	396	291	1	2001-03-01 00:00:00
697	Markus Döring                                                                                                                                                                                                                                                  	302                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	137	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	395	291	1	2001-03-01 00:00:00
698	Markus Döring                                                                                                                                                                                                                                                  	303                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	137	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	412	291	1	2001-03-01 00:00:00
699	Markus Döring                                                                                                                                                                                                                                                  	304                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	413	291	1	2001-03-01 00:00:00
700	Markus Döring                                                                                                                                                                                                                                                  	305                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	190	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	443	311	1	2001-03-01 00:00:00
701	Markus Döring                                                                                                                                                                                                                                                  	306                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	409	291	1	2001-03-01 00:00:00
702	Markus Döring                                                                                                                                                                                                                                                  	307                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	416	316	1	2001-03-01 00:00:00
703	Markus Döring                                                                                                                                                                                                                                                  	308                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	454	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	461	311	1	2001-03-01 00:00:00
704	Markus Döring                                                                                                                                                                                                                                                  	309                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	65	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2471	311	1	2001-03-01 00:00:00
705	Markus Döring                                                                                                                                                                                                                                                  	31                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	15	287	1	2001-03-01 00:00:00
706	Markus Döring                                                                                                                                                                                                                                                  	310                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	138	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	450	311	1	2001-03-01 00:00:00
707	Markus Döring                                                                                                                                                                                                                                                  	311                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	451	311	1	2001-03-01 00:00:00
708	Markus Döring                                                                                                                                                                                                                                                  	312                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	370	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	468	311	1	2001-03-01 00:00:00
709	Markus Döring                                                                                                                                                                                                                                                  	313                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	269	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	466	311	1	2001-03-01 00:00:00
710	Markus Döring                                                                                                                                                                                                                                                  	314                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	457	311	1	2001-03-01 00:00:00
711	Markus Döring                                                                                                                                                                                                                                                  	315                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	592	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	469	311	1	2001-03-01 00:00:00
712	Markus Döring                                                                                                                                                                                                                                                  	316a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	253	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	455	311	1	2001-03-01 00:00:00
713	Markus Döring                                                                                                                                                                                                                                                  	316b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	549	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2412	311	1	2001-03-01 00:00:00
714	Markus Döring                                                                                                                                                                                                                                                  	317                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	459	311	1	2001-03-01 00:00:00
715	Markus Döring                                                                                                                                                                                                                                                  	318                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	464	311	1	2001-03-01 00:00:00
716	Markus Döring                                                                                                                                                                                                                                                  	319                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	443	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	462	311	1	2001-03-01 00:00:00
717	Markus Döring                                                                                                                                                                                                                                                  	320                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	537	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	458	311	1	2001-03-01 00:00:00
718	Markus Döring                                                                                                                                                                                                                                                  	321                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	470	311	1	2001-03-01 00:00:00
719	Markus Döring                                                                                                                                                                                                                                                  	322                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	104	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	471	311	1	2001-03-01 00:00:00
720	Markus Döring                                                                                                                                                                                                                                                  	323                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	132	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	460	311	1	2001-03-01 00:00:00
721	Markus Döring                                                                                                                                                                                                                                                  	324                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	109	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	472	311	1	2001-03-01 00:00:00
722	Markus Döring                                                                                                                                                                                                                                                  	325                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-04 00:00:00	242	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	448	311	1	2001-03-01 00:00:00
723	Markus Döring                                                                                                                                                                                                                                                  	326                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	321	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	474	317	1	2001-03-01 00:00:00
724	Markus Döring                                                                                                                                                                                                                                                  	327                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	152	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	480	238	1	2001-03-01 00:00:00
725	Markus Döring                                                                                                                                                                                                                                                  	328                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	293	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	479	238	1	2001-03-01 00:00:00
726	Markus Döring                                                                                                                                                                                                                                                  	329                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	409	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	481	238	1	2001-03-01 00:00:00
727	Markus Döring                                                                                                                                                                                                                                                  	330                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	93	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	487	179	1	2001-03-01 00:00:00
728	Markus Döring                                                                                                                                                                                                                                                  	331                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	77	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	485	179	1	2001-03-01 00:00:00
729	Markus Döring                                                                                                                                                                                                                                                  	332                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	85	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	483	179	1	2001-03-01 00:00:00
730	Markus Döring                                                                                                                                                                                                                                                  	333                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	149	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	536	179	1	2001-03-01 00:00:00
731	Markus Döring                                                                                                                                                                                                                                                  	334                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	937	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	492	206	1	2001-03-01 00:00:00
732	Markus Döring                                                                                                                                                                                                                                                  	336                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	416	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	499	206	1	2001-03-01 00:00:00
733	Markus Döring                                                                                                                                                                                                                                                  	337                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	500	206	1	2001-03-01 00:00:00
734	Markus Döring                                                                                                                                                                                                                                                  	338                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	163	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	501	206	1	2001-03-01 00:00:00
735	Markus Döring                                                                                                                                                                                                                                                  	339                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	262	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	541	318	1	2001-03-01 00:00:00
736	Markus Döring                                                                                                                                                                                                                                                  	339x24                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	262	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	502	206	1	2001-03-01 00:00:00
737	Markus Döring                                                                                                                                                                                                                                                  	340                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	990	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	523	217	1	2001-03-01 00:00:00
738	Markus Döring                                                                                                                                                                                                                                                  	341                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	504	206	1	2001-03-01 00:00:00
739	Markus Döring                                                                                                                                                                                                                                                  	342                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	490	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	505	206	1	2001-03-01 00:00:00
740	Markus Döring                                                                                                                                                                                                                                                  	343                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	304	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	507	206	1	2001-03-01 00:00:00
741	Markus Döring                                                                                                                                                                                                                                                  	344                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	561	206	1	2001-03-01 00:00:00
742	Markus Döring                                                                                                                                                                                                                                                  	345a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	510	206	1	2001-03-01 00:00:00
743	Markus Döring                                                                                                                                                                                                                                                  	345b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2413	206	1	2001-03-01 00:00:00
744	Markus Döring                                                                                                                                                                                                                                                  	346                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	45	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	514	206	1	2001-03-01 00:00:00
745	Markus Döring                                                                                                                                                                                                                                                  	347                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	547	206	1	2001-03-01 00:00:00
746	Markus Döring                                                                                                                                                                                                                                                  	348                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	756	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	516	206	1	2001-03-01 00:00:00
747	Markus Döring                                                                                                                                                                                                                                                  	349a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	490	206	1	2001-03-01 00:00:00
748	Markus Döring                                                                                                                                                                                                                                                  	349b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	473	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	482	238	1	2001-03-01 00:00:00
749	Markus Döring                                                                                                                                                                                                                                                  	35                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	442	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	13	287	1	2001-03-01 00:00:00
750	Markus Döring                                                                                                                                                                                                                                                  	350                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	473	317	1	2001-03-01 00:00:00
751	Markus Döring                                                                                                                                                                                                                                                  	351                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	476	238	1	2001-03-01 00:00:00
752	Markus Döring                                                                                                                                                                                                                                                  	352                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	1104	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	529	318	1	2001-03-01 00:00:00
753	Markus Döring                                                                                                                                                                                                                                                  	353                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	558	318	1	2001-03-01 00:00:00
754	Markus Döring                                                                                                                                                                                                                                                  	354                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	527	217	1	2001-03-01 00:00:00
755	Markus Döring                                                                                                                                                                                                                                                  	355                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	177	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	521	217	1	2001-03-01 00:00:00
756	Markus Döring                                                                                                                                                                                                                                                  	356                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	522	217	1	2001-03-01 00:00:00
757	Markus Döring                                                                                                                                                                                                                                                  	357                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	524	217	1	2001-03-01 00:00:00
758	Markus Döring                                                                                                                                                                                                                                                  	358                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	286	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	882	217	1	2001-03-01 00:00:00
759	Markus Döring                                                                                                                                                                                                                                                  	359                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	1165	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	567	324	1	2001-03-01 00:00:00
760	Markus Döring                                                                                                                                                                                                                                                  	36                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	523	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	17	287	1	2001-03-01 00:00:00
761	Markus Döring                                                                                                                                                                                                                                                  	360                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	534	318	1	2001-03-01 00:00:00
762	Markus Döring                                                                                                                                                                                                                                                  	361                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	564	324	1	2001-03-01 00:00:00
763	Markus Döring                                                                                                                                                                                                                                                  	362                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	565	325	1	2001-03-01 00:00:00
764	Markus Döring                                                                                                                                                                                                                                                  	363                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	503	206	1	2001-03-01 00:00:00
765	Markus Döring                                                                                                                                                                                                                                                  	364                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	475	238	1	2001-03-01 00:00:00
766	Markus Döring                                                                                                                                                                                                                                                  	365                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	904	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	560	324	1	2001-03-01 00:00:00
767	Markus Döring                                                                                                                                                                                                                                                  	366                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	495	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	552	318	1	2001-03-01 00:00:00
768	Markus Döring                                                                                                                                                                                                                                                  	367                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	163	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	551	318	1	2001-03-01 00:00:00
769	Markus Döring                                                                                                                                                                                                                                                  	368                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	1100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	550	318	1	2001-03-01 00:00:00
770	Markus Döring                                                                                                                                                                                                                                                  	369                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	756	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	548	318	1	2001-03-01 00:00:00
771	Markus Döring                                                                                                                                                                                                                                                  	370                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	100	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	557	318	1	2001-03-01 00:00:00
772	Markus Döring                                                                                                                                                                                                                                                  	371                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	570	250	1	2001-03-01 00:00:00
773	Markus Döring                                                                                                                                                                                                                                                  	371x26                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-08 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2466	318	1	2001-03-01 00:00:00
774	Markus Döring                                                                                                                                                                                                                                                  	372                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	388	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	588	250	1	2001-03-01 00:00:00
775	Markus Döring                                                                                                                                                                                                                                                  	373a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	81	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	717	250	1	2001-03-01 00:00:00
776	Markus Döring                                                                                                                                                                                                                                                  	373b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	269	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	659	326	1	2001-03-01 00:00:00
777	Markus Döring                                                                                                                                                                                                                                                  	374a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	969	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	586	326	1	2001-03-01 00:00:00
778	Markus Döring                                                                                                                                                                                                                                                  	374b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	568	250	1	2001-03-01 00:00:00
779	Markus Döring                                                                                                                                                                                                                                                  	375                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	125	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	781	326	1	2001-03-01 00:00:00
780	Markus Döring                                                                                                                                                                                                                                                  	376                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	655	326	1	2001-03-01 00:00:00
781	Markus Döring                                                                                                                                                                                                                                                  	377                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	575	326	1	2001-03-01 00:00:00
782	Markus Döring                                                                                                                                                                                                                                                  	378                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	581	326	1	2001-03-01 00:00:00
783	Markus Döring                                                                                                                                                                                                                                                  	379                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	583	326	1	2001-03-01 00:00:00
784	Markus Döring                                                                                                                                                                                                                                                  	38                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	14	287	1	2001-03-01 00:00:00
785	Markus Döring                                                                                                                                                                                                                                                  	380                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	969	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	703	326	1	2001-03-01 00:00:00
786	Markus Döring                                                                                                                                                                                                                                                  	381                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	746	326	1	2001-03-01 00:00:00
787	Markus Döring                                                                                                                                                                                                                                                  	382                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	573	326	1	2001-03-01 00:00:00
788	Markus Döring                                                                                                                                                                                                                                                  	383                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	687	326	1	2001-03-01 00:00:00
789	Markus Döring                                                                                                                                                                                                                                                  	384                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	657	326	1	2001-03-01 00:00:00
790	Markus Döring                                                                                                                                                                                                                                                  	385                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	591	326	1	2001-03-01 00:00:00
791	Markus Döring                                                                                                                                                                                                                                                  	386                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	590	326	1	2001-03-01 00:00:00
792	Markus Döring                                                                                                                                                                                                                                                  	387                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	594	326	1	2001-03-01 00:00:00
793	Markus Döring                                                                                                                                                                                                                                                  	388                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	720	326	1	2001-03-01 00:00:00
794	Markus Döring                                                                                                                                                                                                                                                  	389                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	691	326	1	2001-03-01 00:00:00
795	Markus Döring                                                                                                                                                                                                                                                  	390                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	640	326	1	2001-03-01 00:00:00
796	Markus Döring                                                                                                                                                                                                                                                  	391                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	550	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	601	326	1	2001-03-01 00:00:00
797	Markus Döring                                                                                                                                                                                                                                                  	392                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	602	326	1	2001-03-01 00:00:00
798	Markus Döring                                                                                                                                                                                                                                                  	393                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	693	326	1	2001-03-01 00:00:00
799	Markus Döring                                                                                                                                                                                                                                                  	394                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	490	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	759	328	1	2001-03-01 00:00:00
800	Markus Döring                                                                                                                                                                                                                                                  	395                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	855	328	1	2001-03-01 00:00:00
801	Markus Döring                                                                                                                                                                                                                                                  	395x31                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	195	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2428	329	1	2001-03-01 00:00:00
802	Markus Döring                                                                                                                                                                                                                                                  	396                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	206	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	607	328	1	2001-03-01 00:00:00
803	Markus Döring                                                                                                                                                                                                                                                  	397                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	608	326	1	2001-03-01 00:00:00
804	Markus Döring                                                                                                                                                                                                                                                  	397x31                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	504	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	609	329	1	2001-03-01 00:00:00
805	Markus Döring                                                                                                                                                                                                                                                  	398                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	498	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	610	328	1	2001-03-01 00:00:00
806	Markus Döring                                                                                                                                                                                                                                                  	399                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	612	328	1	2001-03-01 00:00:00
807	Markus Döring                                                                                                                                                                                                                                                  	4                                                                                                                                                                                                                                                              	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	122	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2	285	1	2001-03-01 00:00:00
808	Markus Döring                                                                                                                                                                                                                                                  	400                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	116	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	545	328	1	2001-03-01 00:00:00
809	Markus Döring                                                                                                                                                                                                                                                  	401                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	304	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	615	329	1	2001-03-01 00:00:00
810	Markus Döring                                                                                                                                                                                                                                                  	402                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	620	329	1	2001-03-01 00:00:00
811	Markus Döring                                                                                                                                                                                                                                                  	403                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	115	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	616	329	1	2001-03-01 00:00:00
812	Markus Döring                                                                                                                                                                                                                                                  	404                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	115	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	617	329	1	2001-03-01 00:00:00
813	Markus Döring                                                                                                                                                                                                                                                  	405                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	618	329	1	2001-03-01 00:00:00
814	Markus Döring                                                                                                                                                                                                                                                  	406                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	621	329	1	2001-03-01 00:00:00
815	Markus Döring                                                                                                                                                                                                                                                  	407                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	619	329	1	2001-03-01 00:00:00
816	Markus Döring                                                                                                                                                                                                                                                  	408                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	208	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	622	329	1	2001-03-01 00:00:00
817	Markus Döring                                                                                                                                                                                                                                                  	409                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	614	329	1	2001-03-01 00:00:00
818	Markus Döring                                                                                                                                                                                                                                                  	410                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	577	329	1	2001-03-01 00:00:00
819	Markus Döring                                                                                                                                                                                                                                                  	411                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	692	329	1	2001-03-01 00:00:00
820	Markus Döring                                                                                                                                                                                                                                                  	412                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	329	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	572	329	1	2001-03-01 00:00:00
821	Markus Döring                                                                                                                                                                                                                                                  	413                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	770	328	1	2001-03-01 00:00:00
822	Markus Döring                                                                                                                                                                                                                                                  	414                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	323	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	633	330	1	2001-03-01 00:00:00
823	Markus Döring                                                                                                                                                                                                                                                  	415                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	399	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	707	330	1	2001-03-01 00:00:00
824	Markus Döring                                                                                                                                                                                                                                                  	416                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	161	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	751	330	1	2001-03-01 00:00:00
825	Markus Döring                                                                                                                                                                                                                                                  	417                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	661	330	1	2001-03-01 00:00:00
826	Markus Döring                                                                                                                                                                                                                                                  	418                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	778	330	1	2001-03-01 00:00:00
827	Markus Döring                                                                                                                                                                                                                                                  	419                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	94	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	665	330	1	2001-03-01 00:00:00
828	Markus Döring                                                                                                                                                                                                                                                  	42                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	142	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	25	281	1	2001-03-01 00:00:00
829	Markus Döring                                                                                                                                                                                                                                                  	420                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	667	330	1	2001-03-01 00:00:00
830	Markus Döring                                                                                                                                                                                                                                                  	421                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	730	330	1	2001-03-01 00:00:00
831	Markus Döring                                                                                                                                                                                                                                                  	422                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	756	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	671	330	1	2001-03-01 00:00:00
832	Markus Döring                                                                                                                                                                                                                                                  	423                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	491	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	706	330	1	2001-03-01 00:00:00
833	Markus Döring                                                                                                                                                                                                                                                  	424                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	674	330	1	2001-03-01 00:00:00
834	Markus Döring                                                                                                                                                                                                                                                  	424x33                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	113	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	672	331	1	2001-03-01 00:00:00
835	Markus Döring                                                                                                                                                                                                                                                  	424x34                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	113	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	709	332	1	2001-03-01 00:00:00
836	Markus Döring                                                                                                                                                                                                                                                  	425                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	680	207	1	2001-03-01 00:00:00
837	Markus Döring                                                                                                                                                                                                                                                  	426                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	681	207	1	2001-03-01 00:00:00
838	Markus Döring                                                                                                                                                                                                                                                  	427                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	682	207	1	2001-03-01 00:00:00
839	Markus Döring                                                                                                                                                                                                                                                  	428                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	683	207	1	2001-03-01 00:00:00
840	Markus Döring                                                                                                                                                                                                                                                  	429                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	1110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	675	330	1	2001-03-01 00:00:00
841	Markus Döring                                                                                                                                                                                                                                                  	430                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	669	331	1	2001-03-01 00:00:00
842	Markus Döring                                                                                                                                                                                                                                                  	431                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	714	330	1	2001-03-01 00:00:00
843	Markus Döring                                                                                                                                                                                                                                                  	431x41                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	800	339	1	2001-03-01 00:00:00
844	Markus Döring                                                                                                                                                                                                                                                  	432                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	689	331	1	2001-03-01 00:00:00
845	Markus Döring                                                                                                                                                                                                                                                  	433                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	549	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	623	332	1	2001-03-01 00:00:00
846	Markus Döring                                                                                                                                                                                                                                                  	434                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-11 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	723	335	1	2001-03-01 00:00:00
847	Markus Döring                                                                                                                                                                                                                                                  	435                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	421	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	684	207	1	2001-03-01 00:00:00
848	Markus Döring                                                                                                                                                                                                                                                  	436                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	795	339	1	2001-03-01 00:00:00
849	Markus Döring                                                                                                                                                                                                                                                  	437                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	737	339	1	2001-03-01 00:00:00
850	Markus Döring                                                                                                                                                                                                                                                  	437x46                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	18	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2429	344	1	2001-03-01 00:00:00
851	Markus Döring                                                                                                                                                                                                                                                  	438                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	498	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	841	339	1	2001-03-01 00:00:00
852	Markus Döring                                                                                                                                                                                                                                                  	439                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	526	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	718	339	1	2001-03-01 00:00:00
853	Markus Döring                                                                                                                                                                                                                                                  	440                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	470	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	739	339	1	2001-03-01 00:00:00
854	Markus Döring                                                                                                                                                                                                                                                  	441                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	768	339	1	2001-03-01 00:00:00
855	Markus Döring                                                                                                                                                                                                                                                  	442                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	288	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	776	339	1	2001-03-01 00:00:00
856	Markus Döring                                                                                                                                                                                                                                                  	443                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	509	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	774	339	1	2001-03-01 00:00:00
857	Markus Döring                                                                                                                                                                                                                                                  	444                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	766	339	1	2001-03-01 00:00:00
858	Markus Döring                                                                                                                                                                                                                                                  	445                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	522	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	771	339	1	2001-03-01 00:00:00
859	Markus Döring                                                                                                                                                                                                                                                  	446                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	276	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	762	339	1	2001-03-01 00:00:00
860	Markus Döring                                                                                                                                                                                                                                                  	447                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	94	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	785	339	1	2001-03-01 00:00:00
861	Markus Döring                                                                                                                                                                                                                                                  	448                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	218	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	758	339	1	2001-03-01 00:00:00
862	Markus Döring                                                                                                                                                                                                                                                  	449                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	156	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	752	339	1	2001-03-01 00:00:00
863	Markus Döring                                                                                                                                                                                                                                                  	45                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	515	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	24	281	1	2001-03-01 00:00:00
864	Markus Döring                                                                                                                                                                                                                                                  	450                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	789	340	1	2001-03-01 00:00:00
865	Markus Döring                                                                                                                                                                                                                                                  	451                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	436	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	790	342	1	2001-03-01 00:00:00
866	Markus Döring                                                                                                                                                                                                                                                  	452                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	1102	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	787	340	1	2001-03-01 00:00:00
867	Markus Döring                                                                                                                                                                                                                                                  	453                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	788	341	1	2001-03-01 00:00:00
868	Markus Döring                                                                                                                                                                                                                                                  	454                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	337	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	856	341	1	2001-03-01 00:00:00
869	Markus Döring                                                                                                                                                                                                                                                  	455                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	243	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	793	341	1	2001-03-01 00:00:00
870	Markus Döring                                                                                                                                                                                                                                                  	456                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	798	341	1	2001-03-01 00:00:00
871	Markus Döring                                                                                                                                                                                                                                                  	457                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	544	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	678	331	1	2001-03-01 00:00:00
872	Markus Döring                                                                                                                                                                                                                                                  	458                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	573	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	857	341	1	2001-03-01 00:00:00
873	Markus Döring                                                                                                                                                                                                                                                  	459                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-10 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	702	326	1	2001-03-01 00:00:00
874	Markus Döring                                                                                                                                                                                                                                                  	459x45                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	756	343	1	2001-03-01 00:00:00
875	Markus Döring                                                                                                                                                                                                                                                  	460                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	858	341	1	2001-03-01 00:00:00
876	Markus Döring                                                                                                                                                                                                                                                  	461                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	738	339	1	2001-03-01 00:00:00
877	Markus Döring                                                                                                                                                                                                                                                  	461x46                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2430	344	1	2001-03-01 00:00:00
878	Markus Döring                                                                                                                                                                                                                                                  	462                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	740	341	1	2001-03-01 00:00:00
879	Markus Döring                                                                                                                                                                                                                                                  	462x46                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2431	344	1	2001-03-01 00:00:00
880	Markus Döring                                                                                                                                                                                                                                                  	463                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	741	339	1	2001-03-01 00:00:00
881	Markus Döring                                                                                                                                                                                                                                                  	464a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	133	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	782	341	1	2001-03-01 00:00:00
882	Markus Döring                                                                                                                                                                                                                                                  	464b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	132	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2415	341	1	2001-03-01 00:00:00
883	Markus Döring                                                                                                                                                                                                                                                  	465                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	234	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	753	341	1	2001-03-01 00:00:00
884	Markus Döring                                                                                                                                                                                                                                                  	466                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	792	341	1	2001-03-01 00:00:00
885	Markus Döring                                                                                                                                                                                                                                                  	467                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	115	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	804	341	1	2001-03-01 00:00:00
886	Markus Döring                                                                                                                                                                                                                                                  	468                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	178	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	851	342	1	2001-03-01 00:00:00
887	Markus Döring                                                                                                                                                                                                                                                  	469                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	198	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	970	344	1	2001-03-01 00:00:00
888	Markus Döring                                                                                                                                                                                                                                                  	469x44                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2425	342	1	2001-03-01 00:00:00
889	Markus Döring                                                                                                                                                                                                                                                  	469x45                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	1138	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	850	343	1	2001-03-01 00:00:00
890	Markus Döring                                                                                                                                                                                                                                                  	470                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	421	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	784	339	1	2001-03-01 00:00:00
891	Markus Döring                                                                                                                                                                                                                                                  	471                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	797	344	1	2001-03-01 00:00:00
892	Markus Döring                                                                                                                                                                                                                                                  	472                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	552	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	807	348	1	2001-03-01 00:00:00
893	Markus Döring                                                                                                                                                                                                                                                  	473                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	197	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	809	341	1	2001-03-01 00:00:00
894	Markus Döring                                                                                                                                                                                                                                                  	474                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	18	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	810	341	1	2001-03-01 00:00:00
895	Markus Döring                                                                                                                                                                                                                                                  	475a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	2	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	838	208	1	2001-03-01 00:00:00
896	Markus Döring                                                                                                                                                                                                                                                  	475b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	477	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2407	208	1	2001-03-01 00:00:00
897	Markus Döring                                                                                                                                                                                                                                                  	475c                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2408	208	1	2001-03-01 00:00:00
898	Markus Döring                                                                                                                                                                                                                                                  	476                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	17	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	839	208	1	2001-03-01 00:00:00
899	Markus Döring                                                                                                                                                                                                                                                  	477                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	812	343	1	2001-03-01 00:00:00
900	Markus Döring                                                                                                                                                                                                                                                  	478                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	242	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	813	343	1	2001-03-01 00:00:00
901	Markus Döring                                                                                                                                                                                                                                                  	479                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	375	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	815	343	1	2001-03-01 00:00:00
902	Markus Döring                                                                                                                                                                                                                                                  	48                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	19	288	1	2001-03-01 00:00:00
903	Markus Döring                                                                                                                                                                                                                                                  	480                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	511	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	773	343	1	2001-03-01 00:00:00
904	Markus Döring                                                                                                                                                                                                                                                  	481                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	204	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	853	343	1	2001-03-01 00:00:00
905	Markus Döring                                                                                                                                                                                                                                                  	482                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	846	349	1	2001-03-01 00:00:00
906	Markus Döring                                                                                                                                                                                                                                                  	483                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	847	340	1	2001-03-01 00:00:00
907	Markus Döring                                                                                                                                                                                                                                                  	484                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	369	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	818	344	1	2001-03-01 00:00:00
908	Markus Döring                                                                                                                                                                                                                                                  	485                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	504	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	791	344	1	2001-03-01 00:00:00
909	Markus Döring                                                                                                                                                                                                                                                  	486                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	435	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	819	344	1	2001-03-01 00:00:00
910	Markus Döring                                                                                                                                                                                                                                                  	487                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	51	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	849	344	1	2001-03-01 00:00:00
911	Markus Döring                                                                                                                                                                                                                                                  	488                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	765	339	1	2001-03-01 00:00:00
912	Markus Döring                                                                                                                                                                                                                                                  	489                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	44	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	821	344	1	2001-03-01 00:00:00
913	Markus Döring                                                                                                                                                                                                                                                  	490                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	744	339	1	2001-03-01 00:00:00
914	Markus Döring                                                                                                                                                                                                                                                  	491                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	822	344	1	2001-03-01 00:00:00
915	Markus Döring                                                                                                                                                                                                                                                  	492                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	6	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	823	344	1	2001-03-01 00:00:00
916	Markus Döring                                                                                                                                                                                                                                                  	493                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	803	344	1	2001-03-01 00:00:00
917	Markus Döring                                                                                                                                                                                                                                                  	494                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	69	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	801	346	1	2001-03-01 00:00:00
918	Markus Döring                                                                                                                                                                                                                                                  	495                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	54	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	802	344	1	2001-03-01 00:00:00
919	Markus Döring                                                                                                                                                                                                                                                  	497                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	25	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	825	344	1	2001-03-01 00:00:00
920	Markus Döring                                                                                                                                                                                                                                                  	498                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	904	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	736	344	1	2001-03-01 00:00:00
921	Markus Döring                                                                                                                                                                                                                                                  	499                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	573	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	794	344	1	2001-03-01 00:00:00
922	Markus Döring                                                                                                                                                                                                                                                  	500                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	225	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	827	344	1	2001-03-01 00:00:00
923	Markus Döring                                                                                                                                                                                                                                                  	501                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	826	344	1	2001-03-01 00:00:00
924	Markus Döring                                                                                                                                                                                                                                                  	503                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	462	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	830	346	1	2001-03-01 00:00:00
925	Markus Döring                                                                                                                                                                                                                                                  	504                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	25	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	831	347	1	2001-03-01 00:00:00
926	Markus Döring                                                                                                                                                                                                                                                  	505                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	465	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	832	348	1	2001-03-01 00:00:00
927	Markus Döring                                                                                                                                                                                                                                                  	506                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	833	347	1	2001-03-01 00:00:00
928	Markus Döring                                                                                                                                                                                                                                                  	507                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	138	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	834	348	1	2001-03-01 00:00:00
929	Markus Döring                                                                                                                                                                                                                                                  	508a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	152	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	860	349	1	2001-03-01 00:00:00
930	Markus Döring                                                                                                                                                                                                                                                  	508b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	835	348	1	2001-03-01 00:00:00
931	Markus Döring                                                                                                                                                                                                                                                  	509                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	861	349	1	2001-03-01 00:00:00
932	Markus Döring                                                                                                                                                                                                                                                  	51                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	553	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	22	288	1	2001-03-01 00:00:00
933	Markus Döring                                                                                                                                                                                                                                                  	510                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	429	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	844	349	1	2001-03-01 00:00:00
934	Markus Döring                                                                                                                                                                                                                                                  	511                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	468	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	862	349	1	2001-03-01 00:00:00
935	Markus Döring                                                                                                                                                                                                                                                  	512                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	843	349	1	2001-03-01 00:00:00
936	Markus Döring                                                                                                                                                                                                                                                  	513                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	498	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	836	348	1	2001-03-01 00:00:00
937	Markus Döring                                                                                                                                                                                                                                                  	514                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	73	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	837	347	1	2001-03-01 00:00:00
938	Markus Döring                                                                                                                                                                                                                                                  	515                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	783	339	1	2001-03-01 00:00:00
939	Markus Döring                                                                                                                                                                                                                                                  	516                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	980	353	1	2001-03-01 00:00:00
940	Markus Döring                                                                                                                                                                                                                                                  	517                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	871	353	1	2001-03-01 00:00:00
941	Markus Döring                                                                                                                                                                                                                                                  	518                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	867	353	1	2001-03-01 00:00:00
942	Markus Döring                                                                                                                                                                                                                                                  	519                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	984	353	1	2001-03-01 00:00:00
943	Markus Döring                                                                                                                                                                                                                                                  	52                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	80	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	18	288	1	2001-03-01 00:00:00
944	Markus Döring                                                                                                                                                                                                                                                  	520                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	305	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	883	353	1	2001-03-01 00:00:00
945	Markus Döring                                                                                                                                                                                                                                                  	521                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	890	353	1	2001-03-01 00:00:00
946	Markus Döring                                                                                                                                                                                                                                                  	522                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	874	353	1	2001-03-01 00:00:00
947	Markus Döring                                                                                                                                                                                                                                                  	523                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1032	353	1	2001-03-01 00:00:00
948	Markus Döring                                                                                                                                                                                                                                                  	524                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	931	353	1	2001-03-01 00:00:00
949	Markus Döring                                                                                                                                                                                                                                                  	525                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	260	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	881	353	1	2001-03-01 00:00:00
950	Markus Döring                                                                                                                                                                                                                                                  	526                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	888	353	1	2001-03-01 00:00:00
951	Markus Döring                                                                                                                                                                                                                                                  	527                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	493	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	889	353	1	2001-03-01 00:00:00
952	Markus Döring                                                                                                                                                                                                                                                  	528                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	330	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	892	353	1	2001-03-01 00:00:00
953	Markus Döring                                                                                                                                                                                                                                                  	529                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	1138	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	893	353	1	2001-03-01 00:00:00
954	Markus Döring                                                                                                                                                                                                                                                  	530                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	375	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1010	353	1	2001-03-01 00:00:00
955	Markus Döring                                                                                                                                                                                                                                                  	531                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	895	353	1	2001-03-01 00:00:00
956	Markus Döring                                                                                                                                                                                                                                                  	532                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	868	353	1	2001-03-01 00:00:00
957	Markus Döring                                                                                                                                                                                                                                                  	532x56                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	925	357	1	2001-03-01 00:00:00
958	Markus Döring                                                                                                                                                                                                                                                  	533                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	190	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	866	353	1	2001-03-01 00:00:00
959	Markus Döring                                                                                                                                                                                                                                                  	534                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	523	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	896	353	1	2001-03-01 00:00:00
960	Markus Döring                                                                                                                                                                                                                                                  	535                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	897	353	1	2001-03-01 00:00:00
961	Markus Döring                                                                                                                                                                                                                                                  	536                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	934	353	1	2001-03-01 00:00:00
962	Markus Döring                                                                                                                                                                                                                                                  	536x57                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1008	358	1	2001-03-01 00:00:00
963	Markus Döring                                                                                                                                                                                                                                                  	537                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	997	353	1	2001-03-01 00:00:00
964	Markus Döring                                                                                                                                                                                                                                                  	538                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	886	353	1	2001-03-01 00:00:00
965	Markus Döring                                                                                                                                                                                                                                                  	539                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	57	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	903	354	1	2001-03-01 00:00:00
966	Markus Döring                                                                                                                                                                                                                                                  	539x56                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	57	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	935	357	1	2001-03-01 00:00:00
967	Markus Döring                                                                                                                                                                                                                                                  	540                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	880	354	1	2001-03-01 00:00:00
968	Markus Döring                                                                                                                                                                                                                                                  	541                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	203	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	904	354	1	2001-03-01 00:00:00
969	Markus Döring                                                                                                                                                                                                                                                  	542                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	902	354	1	2001-03-01 00:00:00
970	Markus Döring                                                                                                                                                                                                                                                  	543                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1013	354	1	2001-03-01 00:00:00
971	Markus Döring                                                                                                                                                                                                                                                  	544                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	28	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	875	355	1	2001-03-01 00:00:00
972	Markus Döring                                                                                                                                                                                                                                                  	545                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	876	355	1	2001-03-01 00:00:00
973	Markus Döring                                                                                                                                                                                                                                                  	546                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	511	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	906	355	1	2001-03-01 00:00:00
974	Markus Döring                                                                                                                                                                                                                                                  	547                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	447	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	907	355	1	2001-03-01 00:00:00
975	Markus Döring                                                                                                                                                                                                                                                  	547x56                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	447	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	944	357	1	2001-03-01 00:00:00
976	Markus Döring                                                                                                                                                                                                                                                  	548                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	131	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	908	355	1	2001-03-01 00:00:00
977	Markus Döring                                                                                                                                                                                                                                                  	549                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	828	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	909	355	1	2001-03-01 00:00:00
978	Markus Döring                                                                                                                                                                                                                                                  	550                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	304	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1011	355	1	2001-03-01 00:00:00
979	Markus Döring                                                                                                                                                                                                                                                  	551                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	190	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	926	355	1	2001-03-01 00:00:00
980	Markus Döring                                                                                                                                                                                                                                                  	552                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	634	355	1	2001-03-01 00:00:00
981	Markus Döring                                                                                                                                                                                                                                                  	553a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	877	355	1	2001-03-01 00:00:00
982	Markus Döring                                                                                                                                                                                                                                                  	553b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	14	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2416	355	1	2001-03-01 00:00:00
983	Markus Döring                                                                                                                                                                                                                                                  	554                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	435	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	900	355	1	2001-03-01 00:00:00
984	Markus Döring                                                                                                                                                                                                                                                  	555                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	435	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	912	355	1	2001-03-01 00:00:00
985	Markus Döring                                                                                                                                                                                                                                                  	556                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	170	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	913	209	1	2001-03-01 00:00:00
986	Markus Döring                                                                                                                                                                                                                                                  	557                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	937	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1006	353	1	2001-03-01 00:00:00
987	Markus Döring                                                                                                                                                                                                                                                  	558                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	899	353	1	2001-03-01 00:00:00
988	Markus Döring                                                                                                                                                                                                                                                  	559                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	318	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	927	353	1	2001-03-01 00:00:00
989	Markus Döring                                                                                                                                                                                                                                                  	560                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	933	353	1	2001-03-01 00:00:00
990	Markus Döring                                                                                                                                                                                                                                                  	561                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	56	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1320	353	1	2001-03-01 00:00:00
991	Markus Döring                                                                                                                                                                                                                                                  	562                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	276	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	884	353	1	2001-03-01 00:00:00
992	Markus Döring                                                                                                                                                                                                                                                  	562x                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	276	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	918	210	1	2001-03-01 00:00:00
993	Markus Döring                                                                                                                                                                                                                                                  	563                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	914	210	1	2001-03-01 00:00:00
994	Markus Döring                                                                                                                                                                                                                                                  	564                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	203	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	952	210	1	2001-03-01 00:00:00
995	Markus Döring                                                                                                                                                                                                                                                  	565                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	998	357	1	2001-03-01 00:00:00
996	Markus Döring                                                                                                                                                                                                                                                  	566                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	358	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	939	357	1	2001-03-01 00:00:00
997	Markus Döring                                                                                                                                                                                                                                                  	567                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	940	357	1	2001-03-01 00:00:00
998	Markus Döring                                                                                                                                                                                                                                                  	568                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	938	357	1	2001-03-01 00:00:00
999	Markus Döring                                                                                                                                                                                                                                                  	569                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	941	357	1	2001-03-01 00:00:00
1000	Markus Döring                                                                                                                                                                                                                                                  	570                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	80	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1000	357	1	2001-03-01 00:00:00
1001	Markus Döring                                                                                                                                                                                                                                                  	571                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	420	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	943	357	1	2001-03-01 00:00:00
1002	Markus Döring                                                                                                                                                                                                                                                  	572                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	484	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	945	357	1	2001-03-01 00:00:00
1003	Markus Döring                                                                                                                                                                                                                                                  	573                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	946	357	1	2001-03-01 00:00:00
1004	Markus Döring                                                                                                                                                                                                                                                  	574                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	163	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	947	357	1	2001-03-01 00:00:00
1005	Markus Döring                                                                                                                                                                                                                                                  	575                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	277	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	922	357	1	2001-03-01 00:00:00
1006	Markus Döring                                                                                                                                                                                                                                                  	576                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	400	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	948	357	1	2001-03-01 00:00:00
1007	Markus Döring                                                                                                                                                                                                                                                  	577                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	90	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	954	357	1	2001-03-01 00:00:00
1008	Markus Döring                                                                                                                                                                                                                                                  	578                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	412	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	953	357	1	2001-03-01 00:00:00
1009	Markus Döring                                                                                                                                                                                                                                                  	579                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	930	357	1	2001-03-01 00:00:00
1010	Markus Döring                                                                                                                                                                                                                                                  	58                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	23	288	1	2001-03-01 00:00:00
1011	Markus Döring                                                                                                                                                                                                                                                  	580                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	333	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	955	210	1	2001-03-01 00:00:00
1012	Markus Döring                                                                                                                                                                                                                                                  	581                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	200	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	917	210	1	2001-03-01 00:00:00
1013	Markus Döring                                                                                                                                                                                                                                                  	582                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-15 00:00:00	571	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	919	210	1	2001-03-01 00:00:00
1014	Markus Döring                                                                                                                                                                                                                                                  	583                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	1110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	989	358	1	2001-03-01 00:00:00
1015	Markus Döring                                                                                                                                                                                                                                                  	584                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	804	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1001	358	1	2001-03-01 00:00:00
1016	Markus Döring                                                                                                                                                                                                                                                  	585a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1002	358	1	2001-03-01 00:00:00
1017	Markus Döring                                                                                                                                                                                                                                                  	585b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	387	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2414	358	1	2001-03-01 00:00:00
1018	Markus Döring                                                                                                                                                                                                                                                  	586                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	493	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1003	358	1	2001-03-01 00:00:00
1019	Markus Döring                                                                                                                                                                                                                                                  	587                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1004	358	1	2001-03-01 00:00:00
1020	Markus Döring                                                                                                                                                                                                                                                  	588                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	330	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1005	358	1	2001-03-01 00:00:00
1021	Markus Döring                                                                                                                                                                                                                                                  	589                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-12 00:00:00	352	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	840	349	1	2001-03-01 00:00:00
1022	Markus Döring                                                                                                                                                                                                                                                  	590                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	523	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1007	358	1	2001-03-01 00:00:00
1023	Markus Döring                                                                                                                                                                                                                                                  	591                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	234	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1009	358	1	2001-03-01 00:00:00
1024	Markus Döring                                                                                                                                                                                                                                                  	592                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	987	358	1	2001-03-01 00:00:00
1025	Markus Döring                                                                                                                                                                                                                                                  	593                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	977	358	1	2001-03-01 00:00:00
1026	Markus Döring                                                                                                                                                                                                                                                  	594                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1012	358	1	2001-03-01 00:00:00
1027	Markus Döring                                                                                                                                                                                                                                                  	595                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	314	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	983	358	1	2001-03-01 00:00:00
1028	Markus Döring                                                                                                                                                                                                                                                  	596                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	213	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	981	358	1	2001-03-01 00:00:00
1029	Markus Döring                                                                                                                                                                                                                                                  	597                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	178	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	974	359	1	2001-03-01 00:00:00
1030	Markus Döring                                                                                                                                                                                                                                                  	598                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1016	359	1	2001-03-01 00:00:00
1031	Markus Döring                                                                                                                                                                                                                                                  	599                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1017	358	1	2001-03-01 00:00:00
1032	Markus Döring                                                                                                                                                                                                                                                  	60                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	58	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	20	288	1	2001-03-01 00:00:00
1033	Markus Döring                                                                                                                                                                                                                                                  	600                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	187	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	990	358	1	2001-03-01 00:00:00
1034	Markus Döring                                                                                                                                                                                                                                                  	601                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	479	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1018	359	1	2001-03-01 00:00:00
1035	Markus Döring                                                                                                                                                                                                                                                  	602                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	189	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1023	358	1	2001-03-01 00:00:00
1036	Markus Döring                                                                                                                                                                                                                                                  	603                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	765	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1025	360	1	2001-03-01 00:00:00
1037	Markus Döring                                                                                                                                                                                                                                                  	604                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	960	366	1	2001-03-01 00:00:00
1038	Markus Döring                                                                                                                                                                                                                                                  	604x60                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1026	361	1	2001-03-01 00:00:00
1039	Markus Döring                                                                                                                                                                                                                                                  	605                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	216	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1030	360	1	2001-03-01 00:00:00
1040	Markus Döring                                                                                                                                                                                                                                                  	606                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	395	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1037	360	1	2001-03-01 00:00:00
1041	Markus Döring                                                                                                                                                                                                                                                  	607                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	151	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	961	366	1	2001-03-01 00:00:00
1042	Markus Döring                                                                                                                                                                                                                                                  	608                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	247	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	956	366	1	2001-03-01 00:00:00
1043	Markus Döring                                                                                                                                                                                                                                                  	609                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	957	366	1	2001-03-01 00:00:00
1044	Markus Döring                                                                                                                                                                                                                                                  	610                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	261	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	959	366	1	2001-03-01 00:00:00
1045	Markus Döring                                                                                                                                                                                                                                                  	611                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	352	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	958	366	1	2001-03-01 00:00:00
1046	Markus Döring                                                                                                                                                                                                                                                  	612                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	962	366	1	2001-03-01 00:00:00
1047	Markus Döring                                                                                                                                                                                                                                                  	613                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	1139	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1014	359	1	2001-03-01 00:00:00
1048	Markus Döring                                                                                                                                                                                                                                                  	614                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	963	366	1	2001-03-01 00:00:00
1049	Markus Döring                                                                                                                                                                                                                                                  	615                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	62	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	964	366	1	2001-03-01 00:00:00
1050	Markus Döring                                                                                                                                                                                                                                                  	616                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	965	366	1	2001-03-01 00:00:00
1051	Markus Döring                                                                                                                                                                                                                                                  	617                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	420	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	967	366	1	2001-03-01 00:00:00
1052	Markus Döring                                                                                                                                                                                                                                                  	618                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	66	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1028	360	1	2001-03-01 00:00:00
1053	Markus Döring                                                                                                                                                                                                                                                  	619                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1035	361	1	2001-03-01 00:00:00
1054	Markus Döring                                                                                                                                                                                                                                                  	620                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	447	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1041	360	1	2001-03-01 00:00:00
1055	Markus Döring                                                                                                                                                                                                                                                  	621                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1043	361	1	2001-03-01 00:00:00
1056	Markus Döring                                                                                                                                                                                                                                                  	622                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	187	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1027	360	1	2001-03-01 00:00:00
1057	Markus Döring                                                                                                                                                                                                                                                  	623                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	971	367	1	2001-03-01 00:00:00
1058	Markus Döring                                                                                                                                                                                                                                                  	624                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1036	361	1	2001-03-01 00:00:00
1059	Markus Döring                                                                                                                                                                                                                                                  	625                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	352	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	920	366	1	2001-03-01 00:00:00
1060	Markus Döring                                                                                                                                                                                                                                                  	626                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	1164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	921	361	1	2001-03-01 00:00:00
1061	Markus Döring                                                                                                                                                                                                                                                  	627                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	432	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1049	362	1	2001-03-01 00:00:00
1062	Markus Döring                                                                                                                                                                                                                                                  	628                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	339	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1048	362	1	2001-03-01 00:00:00
1063	Markus Döring                                                                                                                                                                                                                                                  	629                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	33	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1031	362	1	2001-03-01 00:00:00
1064	Markus Döring                                                                                                                                                                                                                                                  	630                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	283	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1047	362	1	2001-03-01 00:00:00
1065	Markus Döring                                                                                                                                                                                                                                                  	631                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	283	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1024	362	1	2001-03-01 00:00:00
1066	Markus Döring                                                                                                                                                                                                                                                  	632                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	502	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1046	362	1	2001-03-01 00:00:00
1067	Markus Döring                                                                                                                                                                                                                                                  	633                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	395	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1044	362	1	2001-03-01 00:00:00
1068	Markus Döring                                                                                                                                                                                                                                                  	634                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1033	360	1	2001-03-01 00:00:00
1069	Markus Döring                                                                                                                                                                                                                                                  	635                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1038	360	1	2001-03-01 00:00:00
1070	Markus Döring                                                                                                                                                                                                                                                  	636                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	399	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1039	360	1	2001-03-01 00:00:00
1071	Markus Döring                                                                                                                                                                                                                                                  	640                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-16 00:00:00	484	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	995	358	1	2001-03-01 00:00:00
1072	Markus Döring                                                                                                                                                                                                                                                  	641                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	287	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1477	368	1	2001-03-01 00:00:00
1073	Markus Döring                                                                                                                                                                                                                                                  	642                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1052	368	1	2001-03-01 00:00:00
1074	Markus Döring                                                                                                                                                                                                                                                  	643                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	556	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1053	368	1	2001-03-01 00:00:00
1075	Markus Döring                                                                                                                                                                                                                                                  	644                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	192	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1054	368	1	2001-03-01 00:00:00
1076	Markus Döring                                                                                                                                                                                                                                                  	645                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1057	368	1	2001-03-01 00:00:00
1077	Markus Döring                                                                                                                                                                                                                                                  	646                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1056	368	1	2001-03-01 00:00:00
1078	Markus Döring                                                                                                                                                                                                                                                  	647                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	346	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1055	368	1	2001-03-01 00:00:00
1079	Markus Döring                                                                                                                                                                                                                                                  	648                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1062	368	1	2001-03-01 00:00:00
1080	Markus Döring                                                                                                                                                                                                                                                  	649                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	443	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1060	368	1	2001-03-01 00:00:00
1081	Markus Döring                                                                                                                                                                                                                                                  	65                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	90	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	87	289	1	2001-03-01 00:00:00
1082	Markus Döring                                                                                                                                                                                                                                                  	650                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	296	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1063	368	1	2001-03-01 00:00:00
1083	Markus Döring                                                                                                                                                                                                                                                  	651                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1064	368	1	2001-03-01 00:00:00
1084	Markus Döring                                                                                                                                                                                                                                                  	652                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2470	368	1	2001-03-01 00:00:00
1085	Markus Döring                                                                                                                                                                                                                                                  	652x66                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1065	369	1	2001-03-01 00:00:00
1086	Markus Döring                                                                                                                                                                                                                                                  	653                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	111	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1061	368	1	2001-03-01 00:00:00
1087	Markus Döring                                                                                                                                                                                                                                                  	654                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	165	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1059	368	1	2001-03-01 00:00:00
1088	Markus Döring                                                                                                                                                                                                                                                  	655                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	1110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1066	368	1	2001-03-01 00:00:00
1089	Markus Döring                                                                                                                                                                                                                                                  	656                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	81	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1067	368	1	2001-03-01 00:00:00
1090	Markus Döring                                                                                                                                                                                                                                                  	657                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1068	368	1	2001-03-01 00:00:00
1091	Markus Döring                                                                                                                                                                                                                                                  	658                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	116	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1069	368	1	2001-03-01 00:00:00
1092	Markus Döring                                                                                                                                                                                                                                                  	659                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1070	368	1	2001-03-01 00:00:00
1093	Markus Döring                                                                                                                                                                                                                                                  	660                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	465	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1073	368	1	2001-03-01 00:00:00
1094	Markus Döring                                                                                                                                                                                                                                                  	661                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	904	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1074	368	1	2001-03-01 00:00:00
1095	Markus Döring                                                                                                                                                                                                                                                  	662                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1075	368	1	2001-03-01 00:00:00
1096	Markus Döring                                                                                                                                                                                                                                                  	663                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	366	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1072	368	1	2001-03-01 00:00:00
1097	Markus Döring                                                                                                                                                                                                                                                  	664                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1078	368	1	2001-03-01 00:00:00
1098	Markus Döring                                                                                                                                                                                                                                                  	665                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1079	368	1	2001-03-01 00:00:00
1099	Markus Döring                                                                                                                                                                                                                                                  	666                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1080	368	1	2001-03-01 00:00:00
1100	Markus Döring                                                                                                                                                                                                                                                  	667a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	502	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1081	368	1	2001-03-01 00:00:00
1101	Markus Döring                                                                                                                                                                                                                                                  	667b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2406	368	1	2001-03-01 00:00:00
1102	Markus Döring                                                                                                                                                                                                                                                  	668                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1082	368	1	2001-03-01 00:00:00
1103	Markus Döring                                                                                                                                                                                                                                                  	669a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1084	351	1	2001-03-01 00:00:00
1104	Markus Döring                                                                                                                                                                                                                                                  	669b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2399	351	1	2001-03-01 00:00:00
1105	Markus Döring                                                                                                                                                                                                                                                  	669x67                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	393	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2417	363	1	2001-03-01 00:00:00
1106	Markus Döring                                                                                                                                                                                                                                                  	67                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	371	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	74	290	1	2001-03-01 00:00:00
1107	Markus Döring                                                                                                                                                                                                                                                  	670                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	1169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1085	351	1	2001-03-01 00:00:00
1108	Markus Döring                                                                                                                                                                                                                                                  	671                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	220	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1099	212	1	2001-03-01 00:00:00
1109	Markus Döring                                                                                                                                                                                                                                                  	672                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	143	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1086	369	1	2001-03-01 00:00:00
1110	Markus Döring                                                                                                                                                                                                                                                  	673                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1087	369	1	2001-03-01 00:00:00
1111	Markus Döring                                                                                                                                                                                                                                                  	673x67                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2432	363	1	2001-03-01 00:00:00
1112	Markus Döring                                                                                                                                                                                                                                                  	674                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1088	369	1	2001-03-01 00:00:00
1113	Markus Döring                                                                                                                                                                                                                                                  	675                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	208	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1115	369	1	2001-03-01 00:00:00
1114	Markus Döring                                                                                                                                                                                                                                                  	676                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	173	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1090	369	1	2001-03-01 00:00:00
1115	Markus Döring                                                                                                                                                                                                                                                  	677                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	401	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1083	369	1	2001-03-01 00:00:00
1116	Markus Döring                                                                                                                                                                                                                                                  	678                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	457	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1092	369	1	2001-03-01 00:00:00
1117	Markus Döring                                                                                                                                                                                                                                                  	679                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	513	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1091	369	1	2001-03-01 00:00:00
1118	Markus Döring                                                                                                                                                                                                                                                  	680                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	242	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1093	369	1	2001-03-01 00:00:00
1119	Markus Döring                                                                                                                                                                                                                                                  	681                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1094	369	1	2001-03-01 00:00:00
1120	Markus Döring                                                                                                                                                                                                                                                  	682                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	335	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1095	369	1	2001-03-01 00:00:00
1121	Markus Döring                                                                                                                                                                                                                                                  	683                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	375	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1096	369	1	2001-03-01 00:00:00
1122	Markus Döring                                                                                                                                                                                                                                                  	684                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	178	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1097	369	1	2001-03-01 00:00:00
1123	Markus Döring                                                                                                                                                                                                                                                  	685                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1077	369	1	2001-03-01 00:00:00
1124	Markus Döring                                                                                                                                                                                                                                                  	686                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	203	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1076	369	1	2001-03-01 00:00:00
1125	Markus Döring                                                                                                                                                                                                                                                  	687                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1098	369	1	2001-03-01 00:00:00
1126	Markus Döring                                                                                                                                                                                                                                                  	688                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1103	369	1	2001-03-01 00:00:00
1127	Markus Döring                                                                                                                                                                                                                                                  	689                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1117	368	1	2001-03-01 00:00:00
1128	Markus Döring                                                                                                                                                                                                                                                  	69                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	1141	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	28	292	1	2001-03-01 00:00:00
1129	Markus Döring                                                                                                                                                                                                                                                  	690                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	458	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1109	363	1	2001-03-01 00:00:00
1130	Markus Döring                                                                                                                                                                                                                                                  	691                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1106	363	1	2001-03-01 00:00:00
1131	Markus Döring                                                                                                                                                                                                                                                  	692                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	27	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1107	363	1	2001-03-01 00:00:00
1132	Markus Döring                                                                                                                                                                                                                                                  	693                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1108	363	1	2001-03-01 00:00:00
1133	Markus Döring                                                                                                                                                                                                                                                  	694                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1116	364	1	2001-03-01 00:00:00
1134	Markus Döring                                                                                                                                                                                                                                                  	695                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	256	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1101	213	1	2001-03-01 00:00:00
1135	Markus Döring                                                                                                                                                                                                                                                  	696                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1118	364	1	2001-03-01 00:00:00
1136	Markus Döring                                                                                                                                                                                                                                                  	697a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1119	364	1	2001-03-01 00:00:00
1137	Markus Döring                                                                                                                                                                                                                                                  	697b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	123	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2393	364	1	2001-03-01 00:00:00
1138	Markus Döring                                                                                                                                                                                                                                                  	698                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1120	364	1	2001-03-01 00:00:00
1139	Markus Döring                                                                                                                                                                                                                                                  	699                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	986	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1121	364	1	2001-03-01 00:00:00
1140	Markus Döring                                                                                                                                                                                                                                                  	70                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	372	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	29	292	1	2001-03-01 00:00:00
1141	Markus Döring                                                                                                                                                                                                                                                  	700                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	192	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1112	364	1	2001-03-01 00:00:00
1142	Markus Döring                                                                                                                                                                                                                                                  	701                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1122	364	1	2001-03-01 00:00:00
1143	Markus Döring                                                                                                                                                                                                                                                  	702                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1123	364	1	2001-03-01 00:00:00
1144	Markus Döring                                                                                                                                                                                                                                                  	703                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1124	364	1	2001-03-01 00:00:00
1145	Markus Döring                                                                                                                                                                                                                                                  	704                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1100	212	1	2001-03-01 00:00:00
1146	Markus Döring                                                                                                                                                                                                                                                  	705                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-19 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1102	214	1	2001-03-01 00:00:00
1147	Markus Döring                                                                                                                                                                                                                                                  	706                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	221	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1130	215	1	2001-03-01 00:00:00
1148	Markus Döring                                                                                                                                                                                                                                                  	707                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	463	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1131	215	1	2001-03-01 00:00:00
1149	Markus Döring                                                                                                                                                                                                                                                  	708                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	818	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1134	370	1	2001-03-01 00:00:00
1150	Markus Döring                                                                                                                                                                                                                                                  	709                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	500	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1136	370	1	2001-03-01 00:00:00
1151	Markus Döring                                                                                                                                                                                                                                                  	71                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	263	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	97	292	1	2001-03-01 00:00:00
1152	Markus Döring                                                                                                                                                                                                                                                  	710                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1137	370	1	2001-03-01 00:00:00
1153	Markus Döring                                                                                                                                                                                                                                                  	711                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	303	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1138	370	1	2001-03-01 00:00:00
1154	Markus Döring                                                                                                                                                                                                                                                  	712                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1139	370	1	2001-03-01 00:00:00
1155	Markus Döring                                                                                                                                                                                                                                                  	713                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	320	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1140	370	1	2001-03-01 00:00:00
1156	Markus Döring                                                                                                                                                                                                                                                  	714                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	932	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1144	216	1	2001-03-01 00:00:00
1157	Markus Döring                                                                                                                                                                                                                                                  	715                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1146	216	1	2001-03-01 00:00:00
1158	Markus Döring                                                                                                                                                                                                                                                  	716                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1143	371	1	2001-03-01 00:00:00
1159	Markus Döring                                                                                                                                                                                                                                                  	717                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1147	371	1	2001-03-01 00:00:00
1160	Markus Döring                                                                                                                                                                                                                                                  	718                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	13	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1148	371	1	2001-03-01 00:00:00
1161	Markus Döring                                                                                                                                                                                                                                                  	718x72                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	13	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2433	373	1	2001-03-01 00:00:00
1162	Markus Döring                                                                                                                                                                                                                                                  	719                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1149	371	1	2001-03-01 00:00:00
1163	Markus Döring                                                                                                                                                                                                                                                  	719x72                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	214	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2434	373	1	2001-03-01 00:00:00
1164	Markus Döring                                                                                                                                                                                                                                                  	72                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	31	292	1	2001-03-01 00:00:00
1165	Markus Döring                                                                                                                                                                                                                                                  	720                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1150	371	1	2001-03-01 00:00:00
1166	Markus Döring                                                                                                                                                                                                                                                  	721                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	520	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1142	371	1	2001-03-01 00:00:00
1167	Markus Döring                                                                                                                                                                                                                                                  	722                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	361	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1173	372	1	2001-03-01 00:00:00
1168	Markus Döring                                                                                                                                                                                                                                                  	723                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	7	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1155	373	1	2001-03-01 00:00:00
1169	Markus Döring                                                                                                                                                                                                                                                  	724                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	220	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1156	373	1	2001-03-01 00:00:00
1170	Markus Döring                                                                                                                                                                                                                                                  	725                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1157	373	1	2001-03-01 00:00:00
1171	Markus Döring                                                                                                                                                                                                                                                  	726                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	466	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1159	373	1	2001-03-01 00:00:00
1172	Markus Döring                                                                                                                                                                                                                                                  	727                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1127	215	1	2001-03-01 00:00:00
1173	Markus Döring                                                                                                                                                                                                                                                  	728                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	342	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1132	215	1	2001-03-01 00:00:00
1174	Markus Döring                                                                                                                                                                                                                                                  	729                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-20 00:00:00	296	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1232	215	1	2001-03-01 00:00:00
1175	Markus Döring                                                                                                                                                                                                                                                  	73                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	252	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	32	292	1	2001-03-01 00:00:00
1176	Markus Döring                                                                                                                                                                                                                                                  	731                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	192	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1161	374	1	2001-03-01 00:00:00
1177	Markus Döring                                                                                                                                                                                                                                                  	732                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	178	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1162	374	1	2001-03-01 00:00:00
1178	Markus Döring                                                                                                                                                                                                                                                  	733a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	1164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1164	374	1	2001-03-01 00:00:00
1179	Markus Döring                                                                                                                                                                                                                                                  	733b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2396	374	1	2001-03-01 00:00:00
1180	Markus Döring                                                                                                                                                                                                                                                  	733c                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	311	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2397	374	1	2001-03-01 00:00:00
1181	Markus Döring                                                                                                                                                                                                                                                  	734                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	130	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1165	374	1	2001-03-01 00:00:00
1182	Markus Döring                                                                                                                                                                                                                                                  	735                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1166	374	1	2001-03-01 00:00:00
1183	Markus Döring                                                                                                                                                                                                                                                  	736                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	311	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1167	374	1	2001-03-01 00:00:00
1184	Markus Döring                                                                                                                                                                                                                                                  	737                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	341	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1168	374	1	2001-03-01 00:00:00
1185	Markus Döring                                                                                                                                                                                                                                                  	738a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	479	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2389	374	1	2001-03-01 00:00:00
1186	Markus Döring                                                                                                                                                                                                                                                  	738b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	31	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1169	374	1	2001-03-01 00:00:00
1187	Markus Döring                                                                                                                                                                                                                                                  	739                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	479	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1170	374	1	2001-03-01 00:00:00
1188	Markus Döring                                                                                                                                                                                                                                                  	74                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	49	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	94	293	1	2001-03-01 00:00:00
1189	Markus Döring                                                                                                                                                                                                                                                  	740                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	334	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1171	374	1	2001-03-01 00:00:00
1190	Markus Döring                                                                                                                                                                                                                                                  	741                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	576	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1172	374	1	2001-03-01 00:00:00
1191	Markus Döring                                                                                                                                                                                                                                                  	742                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	443	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1174	374	1	2001-03-01 00:00:00
1192	Markus Döring                                                                                                                                                                                                                                                  	743                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1175	374	1	2001-03-01 00:00:00
1193	Markus Döring                                                                                                                                                                                                                                                  	744                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	251	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1176	374	1	2001-03-01 00:00:00
1194	Markus Döring                                                                                                                                                                                                                                                  	745                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1177	374	1	2001-03-01 00:00:00
1195	Markus Döring                                                                                                                                                                                                                                                  	746                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	361	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1178	374	1	2001-03-01 00:00:00
1196	Markus Döring                                                                                                                                                                                                                                                  	747                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1179	374	1	2001-03-01 00:00:00
1197	Markus Döring                                                                                                                                                                                                                                                  	748                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	588	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1180	374	1	2001-03-01 00:00:00
1198	Markus Döring                                                                                                                                                                                                                                                  	749                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1181	374	1	2001-03-01 00:00:00
1199	Markus Döring                                                                                                                                                                                                                                                  	75                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	760	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	101	293	1	2001-03-01 00:00:00
1200	Markus Döring                                                                                                                                                                                                                                                  	750                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	381	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1182	374	1	2001-03-01 00:00:00
1201	Markus Döring                                                                                                                                                                                                                                                  	751                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-21 00:00:00	348	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1163	374	1	2001-03-01 00:00:00
1202	Markus Döring                                                                                                                                                                                                                                                  	752                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	338	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1239	218	1	2001-03-01 00:00:00
1203	Markus Döring                                                                                                                                                                                                                                                  	753                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	349	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1240	218	1	2001-03-01 00:00:00
1204	Markus Döring                                                                                                                                                                                                                                                  	754                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	192	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1184	375	1	2001-03-01 00:00:00
1205	Markus Döring                                                                                                                                                                                                                                                  	755                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	527	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1185	375	1	2001-03-01 00:00:00
1206	Markus Döring                                                                                                                                                                                                                                                  	756                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	418	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1188	375	1	2001-03-01 00:00:00
1207	Markus Döring                                                                                                                                                                                                                                                  	757                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1192	375	1	2001-03-01 00:00:00
1208	Markus Döring                                                                                                                                                                                                                                                  	758                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1193	375	1	2001-03-01 00:00:00
1209	Markus Döring                                                                                                                                                                                                                                                  	759                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	302	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1189	375	1	2001-03-01 00:00:00
1210	Markus Döring                                                                                                                                                                                                                                                  	76                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	89	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	86	294	1	2001-03-01 00:00:00
1211	Markus Döring                                                                                                                                                                                                                                                  	760                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	362	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1194	375	1	2001-03-01 00:00:00
1212	Markus Döring                                                                                                                                                                                                                                                  	761                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1195	375	1	2001-03-01 00:00:00
1213	Markus Döring                                                                                                                                                                                                                                                  	762                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1196	375	1	2001-03-01 00:00:00
1214	Markus Döring                                                                                                                                                                                                                                                  	763                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	534	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1197	375	1	2001-03-01 00:00:00
1215	Markus Döring                                                                                                                                                                                                                                                  	764a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	433	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1198	375	1	2001-03-01 00:00:00
1216	Markus Döring                                                                                                                                                                                                                                                  	764b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2419	375	1	2001-03-01 00:00:00
1217	Markus Döring                                                                                                                                                                                                                                                  	765                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	153	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1199	375	1	2001-03-01 00:00:00
1218	Markus Döring                                                                                                                                                                                                                                                  	766                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	367	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1201	375	1	2001-03-01 00:00:00
1219	Markus Döring                                                                                                                                                                                                                                                  	767a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1202	375	1	2001-03-01 00:00:00
1220	Markus Döring                                                                                                                                                                                                                                                  	767b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	1164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2395	375	1	2001-03-01 00:00:00
1221	Markus Döring                                                                                                                                                                                                                                                  	768                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	424	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1203	375	1	2001-03-01 00:00:00
1222	Markus Döring                                                                                                                                                                                                                                                  	769                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	265	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1210	375	1	2001-03-01 00:00:00
1223	Markus Döring                                                                                                                                                                                                                                                  	769x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	265	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2435	377	1	2001-03-01 00:00:00
1224	Markus Döring                                                                                                                                                                                                                                                  	77                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	57	294	1	2001-03-01 00:00:00
1225	Markus Döring                                                                                                                                                                                                                                                  	770                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	144	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1712	375	1	2001-03-01 00:00:00
1226	Markus Döring                                                                                                                                                                                                                                                  	771                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	1103	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1211	375	1	2001-03-01 00:00:00
1227	Markus Döring                                                                                                                                                                                                                                                  	772                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	1164	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1212	375	1	2001-03-01 00:00:00
1228	Markus Döring                                                                                                                                                                                                                                                  	773                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	510	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1213	375	1	2001-03-01 00:00:00
1229	Markus Döring                                                                                                                                                                                                                                                  	774                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	619	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1214	375	1	2001-03-01 00:00:00
1230	Markus Döring                                                                                                                                                                                                                                                  	775                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	534	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1215	375	1	2001-03-01 00:00:00
1231	Markus Döring                                                                                                                                                                                                                                                  	776                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	340	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1216	375	1	2001-03-01 00:00:00
1232	Markus Döring                                                                                                                                                                                                                                                  	776x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	340	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2436	377	1	2001-03-01 00:00:00
1233	Markus Döring                                                                                                                                                                                                                                                  	777                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1206	375	1	2001-03-01 00:00:00
1234	Markus Döring                                                                                                                                                                                                                                                  	777x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2437	377	1	2001-03-01 00:00:00
1235	Markus Döring                                                                                                                                                                                                                                                  	778                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1208	375	1	2001-03-01 00:00:00
1236	Markus Döring                                                                                                                                                                                                                                                  	778x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2438	377	1	2001-03-01 00:00:00
1237	Markus Döring                                                                                                                                                                                                                                                  	779                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	219	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1217	375	1	2001-03-01 00:00:00
1238	Markus Döring                                                                                                                                                                                                                                                  	779x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	219	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2439	377	1	2001-03-01 00:00:00
1239	Markus Döring                                                                                                                                                                                                                                                  	78                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	58	294	1	2001-03-01 00:00:00
1240	Markus Döring                                                                                                                                                                                                                                                  	780                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	522	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1200	375	1	2001-03-01 00:00:00
1241	Markus Döring                                                                                                                                                                                                                                                  	781                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	513	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1241	218	1	2001-03-01 00:00:00
1242	Markus Döring                                                                                                                                                                                                                                                  	782                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	310	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1242	219	1	2001-03-01 00:00:00
1243	Markus Döring                                                                                                                                                                                                                                                  	783                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	356	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1231	376	1	2001-03-01 00:00:00
1244	Markus Döring                                                                                                                                                                                                                                                  	784                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	25	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1230	377	1	2001-03-01 00:00:00
1245	Markus Döring                                                                                                                                                                                                                                                  	785                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1191	375	1	2001-03-01 00:00:00
1246	Markus Döring                                                                                                                                                                                                                                                  	786                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	569	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1218	376	1	2001-03-01 00:00:00
1247	Markus Döring                                                                                                                                                                                                                                                  	787                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	256	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1222	376	1	2001-03-01 00:00:00
1248	Markus Döring                                                                                                                                                                                                                                                  	787x76                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	256	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2440	377	1	2001-03-01 00:00:00
1249	Markus Döring                                                                                                                                                                                                                                                  	788                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	184	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1225	376	1	2001-03-01 00:00:00
1250	Markus Döring                                                                                                                                                                                                                                                  	789                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	544	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1233	377	1	2001-03-01 00:00:00
1251	Markus Döring                                                                                                                                                                                                                                                  	79                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	229	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	59	295	1	2001-03-01 00:00:00
1252	Markus Döring                                                                                                                                                                                                                                                  	790                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1221	376	1	2001-03-01 00:00:00
1253	Markus Döring                                                                                                                                                                                                                                                  	791                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1228	377	1	2001-03-01 00:00:00
1254	Markus Döring                                                                                                                                                                                                                                                  	792                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1205	376	1	2001-03-01 00:00:00
1255	Markus Döring                                                                                                                                                                                                                                                  	793                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	969	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1219	376	1	2001-03-01 00:00:00
1256	Markus Döring                                                                                                                                                                                                                                                  	794                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	445	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1220	376	1	2001-03-01 00:00:00
1257	Markus Döring                                                                                                                                                                                                                                                  	795                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	545	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1229	377	1	2001-03-01 00:00:00
1258	Markus Döring                                                                                                                                                                                                                                                  	796                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	367	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1226	376	1	2001-03-01 00:00:00
1259	Markus Döring                                                                                                                                                                                                                                                  	797                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-23 00:00:00	392	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1234	377	1	2001-03-01 00:00:00
1260	Markus Döring                                                                                                                                                                                                                                                  	798                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	449	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1235	220	1	2001-03-01 00:00:00
1261	Markus Döring                                                                                                                                                                                                                                                  	799                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	34	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1236	220	1	2001-03-01 00:00:00
1262	Markus Döring                                                                                                                                                                                                                                                  	799x86                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	34	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1363	388	1	2001-03-01 00:00:00
1263	Markus Döring                                                                                                                                                                                                                                                  	8                                                                                                                                                                                                                                                              	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	322	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	3	279	1	2001-03-01 00:00:00
1264	Markus Döring                                                                                                                                                                                                                                                  	80                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	219	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	60	295	1	2001-03-01 00:00:00
1265	Markus Döring                                                                                                                                                                                                                                                  	800                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1243	378	1	2001-03-01 00:00:00
1266	Markus Döring                                                                                                                                                                                                                                                  	801                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	236	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1249	378	1	2001-03-01 00:00:00
1267	Markus Döring                                                                                                                                                                                                                                                  	802                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	373	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1250	378	1	2001-03-01 00:00:00
1268	Markus Döring                                                                                                                                                                                                                                                  	802x80                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	373	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1358	382	1	2001-03-01 00:00:00
1269	Markus Döring                                                                                                                                                                                                                                                  	803                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	424	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1312	378	1	2001-03-01 00:00:00
1270	Markus Döring                                                                                                                                                                                                                                                  	804                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	1136	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1252	378	1	2001-03-01 00:00:00
1271	Markus Döring                                                                                                                                                                                                                                                  	805                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	461	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1314	378	1	2001-03-01 00:00:00
1272	Markus Döring                                                                                                                                                                                                                                                  	806                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1258	378	1	2001-03-01 00:00:00
1273	Markus Döring                                                                                                                                                                                                                                                  	807                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	110	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1364	378	1	2001-03-01 00:00:00
1274	Markus Döring                                                                                                                                                                                                                                                  	808                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1245	378	1	2001-03-01 00:00:00
1275	Markus Döring                                                                                                                                                                                                                                                  	809                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1257	378	1	2001-03-01 00:00:00
1276	Markus Döring                                                                                                                                                                                                                                                  	81                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	494	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	61	295	1	2001-03-01 00:00:00
1277	Markus Döring                                                                                                                                                                                                                                                  	810                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1246	378	1	2001-03-01 00:00:00
1278	Markus Döring                                                                                                                                                                                                                                                  	811                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1244	378	1	2001-03-01 00:00:00
1279	Markus Döring                                                                                                                                                                                                                                                  	812                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	82	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1304	378	1	2001-03-01 00:00:00
1280	Markus Döring                                                                                                                                                                                                                                                  	813                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1248	378	1	2001-03-01 00:00:00
1281	Markus Döring                                                                                                                                                                                                                                                  	814                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	405	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1255	378	1	2001-03-01 00:00:00
1282	Markus Döring                                                                                                                                                                                                                                                  	814x80                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	405	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1353	382	1	2001-03-01 00:00:00
1283	Markus Döring                                                                                                                                                                                                                                                  	815                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	407	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1259	378	1	2001-03-01 00:00:00
1284	Markus Döring                                                                                                                                                                                                                                                  	816                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	298	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1262	379	1	2001-03-01 00:00:00
1285	Markus Döring                                                                                                                                                                                                                                                  	816x80                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	297	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1365	382	1	2001-03-01 00:00:00
1286	Markus Döring                                                                                                                                                                                                                                                  	817                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	286	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1263	379	1	2001-03-01 00:00:00
1287	Markus Döring                                                                                                                                                                                                                                                  	818                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	211	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1301	379	1	2001-03-01 00:00:00
1288	Markus Döring                                                                                                                                                                                                                                                  	819                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1265	379	1	2001-03-01 00:00:00
1289	Markus Döring                                                                                                                                                                                                                                                  	819x84                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1324	386	1	2001-03-01 00:00:00
1290	Markus Döring                                                                                                                                                                                                                                                  	82                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-20 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	35	293	1	2001-03-01 00:00:00
1291	Markus Döring                                                                                                                                                                                                                                                  	820                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	470	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1247	379	1	2001-03-01 00:00:00
1292	Markus Döring                                                                                                                                                                                                                                                  	820x79                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	19	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2386	380	1	2001-03-01 00:00:00
1293	Markus Döring                                                                                                                                                                                                                                                  	821                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	500	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1266	380	1	2001-03-01 00:00:00
1294	Markus Döring                                                                                                                                                                                                                                                  	822                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	272	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1267	380	1	2001-03-01 00:00:00
1295	Markus Döring                                                                                                                                                                                                                                                  	823                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	196	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1269	380	1	2001-03-01 00:00:00
1296	Markus Döring                                                                                                                                                                                                                                                  	824                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	299	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1273	380	1	2001-03-01 00:00:00
1297	Markus Döring                                                                                                                                                                                                                                                  	825                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	383	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1274	380	1	2001-03-01 00:00:00
1298	Markus Döring                                                                                                                                                                                                                                                  	826                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	65	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1268	380	1	2001-03-01 00:00:00
1299	Markus Döring                                                                                                                                                                                                                                                  	827                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	459	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1275	380	1	2001-03-01 00:00:00
1300	Markus Döring                                                                                                                                                                                                                                                  	828                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1270	380	1	2001-03-01 00:00:00
1301	Markus Döring                                                                                                                                                                                                                                                  	829                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	127	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1276	379	1	2001-03-01 00:00:00
1302	Markus Döring                                                                                                                                                                                                                                                  	83                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	517	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	66	297	1	2001-03-01 00:00:00
1303	Markus Döring                                                                                                                                                                                                                                                  	830                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1271	380	1	2001-03-01 00:00:00
1304	Markus Döring                                                                                                                                                                                                                                                  	831                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1272	380	1	2001-03-01 00:00:00
1305	Markus Döring                                                                                                                                                                                                                                                  	832                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	618	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1277	380	1	2001-03-01 00:00:00
1306	Markus Döring                                                                                                                                                                                                                                                  	833                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	159	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1278	380	1	2001-03-01 00:00:00
1307	Markus Döring                                                                                                                                                                                                                                                  	834                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	360	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1279	380	1	2001-03-01 00:00:00
1308	Markus Döring                                                                                                                                                                                                                                                  	835                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	159	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1280	380	1	2001-03-01 00:00:00
1309	Markus Döring                                                                                                                                                                                                                                                  	836                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-26 00:00:00	539	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1261	378	1	2001-03-01 00:00:00
1310	Markus Döring                                                                                                                                                                                                                                                  	837                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	271	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1282	223	1	2001-03-01 00:00:00
1311	Markus Döring                                                                                                                                                                                                                                                  	838                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	619	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1281	223	1	2001-03-01 00:00:00
1312	Markus Döring                                                                                                                                                                                                                                                  	839                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	254	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1283	223	1	2001-03-01 00:00:00
1313	Markus Döring                                                                                                                                                                                                                                                  	839x91                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	254	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1620	394	1	2001-03-01 00:00:00
1314	Markus Döring                                                                                                                                                                                                                                                  	84                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	553	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	99	297	1	2001-03-01 00:00:00
1315	Markus Döring                                                                                                                                                                                                                                                  	840                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	1114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1284	223	1	2001-03-01 00:00:00
1316	Markus Döring                                                                                                                                                                                                                                                  	841                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	444	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1285	223	1	2001-03-01 00:00:00
1317	Markus Döring                                                                                                                                                                                                                                                  	842                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	506	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1286	223	1	2001-03-01 00:00:00
1318	Markus Döring                                                                                                                                                                                                                                                  	843                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	506	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1333	382	1	2001-03-01 00:00:00
1319	Markus Döring                                                                                                                                                                                                                                                  	844                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1289	382	1	2001-03-01 00:00:00
1320	Markus Döring                                                                                                                                                                                                                                                  	844x84                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2465	386	1	2001-03-01 00:00:00
1321	Markus Döring                                                                                                                                                                                                                                                  	845                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	505	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1291	382	1	2001-03-01 00:00:00
1322	Markus Döring                                                                                                                                                                                                                                                  	846a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1341	382	1	2001-03-01 00:00:00
1323	Markus Döring                                                                                                                                                                                                                                                  	846b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	505	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2410	382	1	2001-03-01 00:00:00
1324	Markus Döring                                                                                                                                                                                                                                                  	847                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1292	382	1	2001-03-01 00:00:00
1325	Markus Döring                                                                                                                                                                                                                                                  	847x83                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2441	385	1	2001-03-01 00:00:00
1326	Markus Döring                                                                                                                                                                                                                                                  	848                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	398	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1298	382	1	2001-03-01 00:00:00
1327	Markus Döring                                                                                                                                                                                                                                                  	849                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	804	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1366	382	1	2001-03-01 00:00:00
1328	Markus Döring                                                                                                                                                                                                                                                  	850                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1303	382	1	2001-03-01 00:00:00
1329	Markus Döring                                                                                                                                                                                                                                                  	851                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	34	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1305	382	1	2001-03-01 00:00:00
1330	Markus Döring                                                                                                                                                                                                                                                  	852                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	765	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1331	382	1	2001-03-01 00:00:00
1331	Markus Döring                                                                                                                                                                                                                                                  	853                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	407	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1307	382	1	2001-03-01 00:00:00
1332	Markus Döring                                                                                                                                                                                                                                                  	854                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1393	383	1	2001-03-01 00:00:00
1333	Markus Döring                                                                                                                                                                                                                                                  	855                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	964	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1310	383	1	2001-03-01 00:00:00
1334	Markus Döring                                                                                                                                                                                                                                                  	857                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1313	383	1	2001-03-01 00:00:00
1335	Markus Döring                                                                                                                                                                                                                                                  	858a                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	407	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1315	383	1	2001-03-01 00:00:00
1336	Markus Döring                                                                                                                                                                                                                                                  	858b                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2401	383	1	2001-03-01 00:00:00
1337	Markus Döring                                                                                                                                                                                                                                                  	859                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1294	384	1	2001-03-01 00:00:00
1338	Markus Döring                                                                                                                                                                                                                                                  	85a                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	80	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	98	327	1	2001-03-01 00:00:00
1339	Markus Döring                                                                                                                                                                                                                                                  	85b                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	530	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	103	327	1	2001-03-01 00:00:00
1340	Markus Döring                                                                                                                                                                                                                                                  	86                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	548	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	85	327	1	2001-03-01 00:00:00
1341	Markus Döring                                                                                                                                                                                                                                                  	860                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	438	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1316	384	1	2001-03-01 00:00:00
1342	Markus Döring                                                                                                                                                                                                                                                  	860x88                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	438	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1389	390	1	2001-03-01 00:00:00
1343	Markus Döring                                                                                                                                                                                                                                                  	861                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	449	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1335	384	1	2001-03-01 00:00:00
1344	Markus Döring                                                                                                                                                                                                                                                  	861x86                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	449	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1373	388	1	2001-03-01 00:00:00
1345	Markus Döring                                                                                                                                                                                                                                                  	862                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	531	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1395	384	1	2001-03-01 00:00:00
1346	Markus Döring                                                                                                                                                                                                                                                  	863                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	397	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1319	384	1	2001-03-01 00:00:00
1347	Markus Döring                                                                                                                                                                                                                                                  	864                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1321	385	1	2001-03-01 00:00:00
1348	Markus Döring                                                                                                                                                                                                                                                  	865                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1338	385	1	2001-03-01 00:00:00
1349	Markus Döring                                                                                                                                                                                                                                                  	866                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	410	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1323	385	1	2001-03-01 00:00:00
1350	Markus Döring                                                                                                                                                                                                                                                  	867                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1325	386	1	2001-03-01 00:00:00
1351	Markus Döring                                                                                                                                                                                                                                                  	868                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	397	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1326	386	1	2001-03-01 00:00:00
1352	Markus Döring                                                                                                                                                                                                                                                  	869                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	452	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1327	386	1	2001-03-01 00:00:00
1353	Markus Döring                                                                                                                                                                                                                                                  	87                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	102	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	93	327	1	2001-03-01 00:00:00
1354	Markus Döring                                                                                                                                                                                                                                                  	870                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1287	224	1	2001-03-01 00:00:00
1355	Markus Döring                                                                                                                                                                                                                                                  	871                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-27 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1288	224	1	2001-03-01 00:00:00
1356	Markus Döring                                                                                                                                                                                                                                                  	872                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	33	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1330	387	1	2001-03-01 00:00:00
1357	Markus Döring                                                                                                                                                                                                                                                  	873                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	250	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1359	387	1	2001-03-01 00:00:00
1358	Markus Döring                                                                                                                                                                                                                                                  	874                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1328	387	1	2001-03-01 00:00:00
1359	Markus Döring                                                                                                                                                                                                                                                  	875                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1334	387	1	2001-03-01 00:00:00
1360	Markus Döring                                                                                                                                                                                                                                                  	876                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1336	387	1	2001-03-01 00:00:00
1361	Markus Döring                                                                                                                                                                                                                                                  	877                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	543	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1337	387	1	2001-03-01 00:00:00
1362	Markus Döring                                                                                                                                                                                                                                                  	878                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	72	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1339	387	1	2001-03-01 00:00:00
1363	Markus Döring                                                                                                                                                                                                                                                  	879                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	35	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1340	387	1	2001-03-01 00:00:00
1364	Markus Döring                                                                                                                                                                                                                                                  	88                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	168	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	82	202	1	2001-03-01 00:00:00
1365	Markus Döring                                                                                                                                                                                                                                                  	880                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1342	388	1	2001-03-01 00:00:00
1366	Markus Döring                                                                                                                                                                                                                                                  	881                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	5	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1343	388	1	2001-03-01 00:00:00
1367	Markus Döring                                                                                                                                                                                                                                                  	882                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1347	388	1	2001-03-01 00:00:00
1368	Markus Döring                                                                                                                                                                                                                                                  	883                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	324	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1349	388	1	2001-03-01 00:00:00
1369	Markus Döring                                                                                                                                                                                                                                                  	884                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	618	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1355	388	1	2001-03-01 00:00:00
1370	Markus Döring                                                                                                                                                                                                                                                  	885                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	986	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1357	393	1	2001-03-01 00:00:00
1371	Markus Döring                                                                                                                                                                                                                                                  	886                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	382	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1367	388	1	2001-03-01 00:00:00
1372	Markus Döring                                                                                                                                                                                                                                                  	887                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1371	388	1	2001-03-01 00:00:00
1373	Markus Döring                                                                                                                                                                                                                                                  	888                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	503	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1372	388	1	2001-03-01 00:00:00
1374	Markus Döring                                                                                                                                                                                                                                                  	889                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	828	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1374	388	1	2001-03-01 00:00:00
1375	Markus Döring                                                                                                                                                                                                                                                  	89                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	519	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	122	297	1	2001-03-01 00:00:00
1376	Markus Döring                                                                                                                                                                                                                                                  	890                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	1158	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1375	388	1	2001-03-01 00:00:00
1377	Markus Döring                                                                                                                                                                                                                                                  	891                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1376	388	1	2001-03-01 00:00:00
1378	Markus Döring                                                                                                                                                                                                                                                  	892                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1377	388	1	2001-03-01 00:00:00
1379	Markus Döring                                                                                                                                                                                                                                                  	893                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	259	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1378	388	1	2001-03-01 00:00:00
1380	Markus Döring                                                                                                                                                                                                                                                  	894                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	394	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1368	388	1	2001-03-01 00:00:00
1381	Markus Döring                                                                                                                                                                                                                                                  	895                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	397	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1623	389	1	2001-03-01 00:00:00
1382	Markus Döring                                                                                                                                                                                                                                                  	896                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	407	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1382	389	1	2001-03-01 00:00:00
1383	Markus Döring                                                                                                                                                                                                                                                  	897                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	267	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1380	389	1	2001-03-01 00:00:00
1384	Markus Döring                                                                                                                                                                                                                                                  	898                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	153	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1383	389	1	2001-03-01 00:00:00
1385	Markus Döring                                                                                                                                                                                                                                                  	899                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	279	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1384	389	1	2001-03-01 00:00:00
1386	Markus Döring                                                                                                                                                                                                                                                  	9                                                                                                                                                                                                                                                              	Markus Döring                                                                                                                                                                                                                                                  	1999-06-19 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	4	279	1	2001-03-01 00:00:00
1387	Markus Döring                                                                                                                                                                                                                                                  	90                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	186	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	89	202	1	2001-03-01 00:00:00
1388	Markus Döring                                                                                                                                                                                                                                                  	900                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	11	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	2385	389	1	2001-03-01 00:00:00
1389	Markus Döring                                                                                                                                                                                                                                                  	901                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	512	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1387	389	1	2001-03-01 00:00:00
1390	Markus Döring                                                                                                                                                                                                                                                  	902                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1388	389	1	2001-03-01 00:00:00
1391	Markus Döring                                                                                                                                                                                                                                                  	903                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	24	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1390	390	1	2001-03-01 00:00:00
1392	Markus Döring                                                                                                                                                                                                                                                  	904                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	268	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1391	390	1	2001-03-01 00:00:00
1393	Markus Döring                                                                                                                                                                                                                                                  	905                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	212	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1392	392	1	2001-03-01 00:00:00
1394	Markus Döring                                                                                                                                                                                                                                                  	906                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	134	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1397	390	1	2001-03-01 00:00:00
1395	Markus Döring                                                                                                                                                                                                                                                  	907                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	319	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1394	390	1	2001-03-01 00:00:00
1396	Markus Döring                                                                                                                                                                                                                                                  	908                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1379	393	1	2001-03-01 00:00:00
1397	Markus Döring                                                                                                                                                                                                                                                  	909                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-28 00:00:00	518	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1396	393	1	2001-03-01 00:00:00
1398	Markus Döring                                                                                                                                                                                                                                                  	91                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	489	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	73	202	1	2001-03-01 00:00:00
1399	Markus Döring                                                                                                                                                                                                                                                  	910                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	18	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1398	394	1	2001-03-01 00:00:00
1400	Markus Döring                                                                                                                                                                                                                                                  	911                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	30	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1603	394	1	2001-03-01 00:00:00
1401	Markus Döring                                                                                                                                                                                                                                                  	912                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	21	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1400	394	1	2001-03-01 00:00:00
1402	Markus Döring                                                                                                                                                                                                                                                  	913                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	190	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1404	394	1	2001-03-01 00:00:00
1403	Markus Döring                                                                                                                                                                                                                                                  	914                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	179	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1409	394	1	2001-03-01 00:00:00
1404	Markus Döring                                                                                                                                                                                                                                                  	915                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	760	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1724	394	1	2001-03-01 00:00:00
1405	Markus Döring                                                                                                                                                                                                                                                  	916                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	57	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1413	394	1	2001-03-01 00:00:00
1406	Markus Döring                                                                                                                                                                                                                                                  	917                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	446	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1414	394	1	2001-03-01 00:00:00
1407	Markus Döring                                                                                                                                                                                                                                                  	918                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	370	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1415	394	1	2001-03-01 00:00:00
1408	Markus Döring                                                                                                                                                                                                                                                  	919                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1646	394	1	2001-03-01 00:00:00
1409	Markus Döring                                                                                                                                                                                                                                                  	919x93                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	456	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1561	396	1	2001-03-01 00:00:00
1410	Markus Döring                                                                                                                                                                                                                                                  	92                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	124	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	84	202	1	2001-03-01 00:00:00
1411	Markus Döring                                                                                                                                                                                                                                                  	920                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	128	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1418	394	1	2001-03-01 00:00:00
1412	Markus Döring                                                                                                                                                                                                                                                  	921                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1419	394	1	2001-03-01 00:00:00
1413	Markus Döring                                                                                                                                                                                                                                                  	922                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	305	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1420	394	1	2001-03-01 00:00:00
1414	Markus Döring                                                                                                                                                                                                                                                  	923                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	185	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1479	394	1	2001-03-01 00:00:00
1415	Markus Döring                                                                                                                                                                                                                                                  	924                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	689	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1423	394	1	2001-03-01 00:00:00
1416	Markus Döring                                                                                                                                                                                                                                                  	925                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1495	394	1	2001-03-01 00:00:00
1417	Markus Döring                                                                                                                                                                                                                                                  	926                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	284	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1425	394	1	2001-03-01 00:00:00
1418	Markus Döring                                                                                                                                                                                                                                                  	928                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	351	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1711	394	1	2001-03-01 00:00:00
1419	Markus Döring                                                                                                                                                                                                                                                  	929                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	450	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1426	394	1	2001-03-01 00:00:00
1420	Markus Döring                                                                                                                                                                                                                                                  	93                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	58	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	91	202	1	2001-03-01 00:00:00
1421	Markus Döring                                                                                                                                                                                                                                                  	930                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	198	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1576	394	1	2001-03-01 00:00:00
1422	Markus Döring                                                                                                                                                                                                                                                  	931                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	188	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1577	394	1	2001-03-01 00:00:00
1423	Markus Döring                                                                                                                                                                                                                                                  	932                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	208	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1496	394	1	2001-03-01 00:00:00
1424	Markus Döring                                                                                                                                                                                                                                                  	933                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1401	394	1	2001-03-01 00:00:00
1425	Markus Döring                                                                                                                                                                                                                                                  	934                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	111	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1465	394	1	2001-03-01 00:00:00
1426	Markus Döring                                                                                                                                                                                                                                                  	935                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1432	394	1	2001-03-01 00:00:00
1427	Markus Döring                                                                                                                                                                                                                                                  	936                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	483	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1431	394	1	2001-03-01 00:00:00
1428	Markus Döring                                                                                                                                                                                                                                                  	937                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1433	394	1	2001-03-01 00:00:00
1429	Markus Döring                                                                                                                                                                                                                                                  	938                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	408	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1434	394	1	2001-03-01 00:00:00
1430	Markus Döring                                                                                                                                                                                                                                                  	939                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	86	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1435	394	1	2001-03-01 00:00:00
1431	Markus Döring                                                                                                                                                                                                                                                  	94                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	90	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	78	202	1	2001-03-01 00:00:00
1432	Markus Döring                                                                                                                                                                                                                                                  	940                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	450	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1436	394	1	2001-03-01 00:00:00
1433	Markus Döring                                                                                                                                                                                                                                                  	941                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	428	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1437	394	1	2001-03-01 00:00:00
1434	Markus Döring                                                                                                                                                                                                                                                  	942                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	243	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1651	394	1	2001-03-01 00:00:00
1435	Markus Döring                                                                                                                                                                                                                                                  	943                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1439	394	1	2001-03-01 00:00:00
1436	Markus Döring                                                                                                                                                                                                                                                  	943x94                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2464	397	1	2001-03-01 00:00:00
1437	Markus Döring                                                                                                                                                                                                                                                  	944                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	524	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1440	394	1	2001-03-01 00:00:00
1438	Markus Döring                                                                                                                                                                                                                                                  	945                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	1	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1441	394	1	2001-03-01 00:00:00
1439	Markus Döring                                                                                                                                                                                                                                                  	946                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	599	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1442	394	1	2001-03-01 00:00:00
1440	Markus Döring                                                                                                                                                                                                                                                  	947                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	422	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1443	394	1	2001-03-01 00:00:00
1441	Markus Döring                                                                                                                                                                                                                                                  	948                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	199	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1444	394	1	2001-03-01 00:00:00
1442	Markus Döring                                                                                                                                                                                                                                                  	949                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	437	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1598	394	1	2001-03-01 00:00:00
1443	Markus Döring                                                                                                                                                                                                                                                  	95                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	102	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	92	202	1	2001-03-01 00:00:00
1444	Markus Döring                                                                                                                                                                                                                                                  	950                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	576	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1448	394	1	2001-03-01 00:00:00
1445	Markus Döring                                                                                                                                                                                                                                                  	951                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	284	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1449	394	1	2001-03-01 00:00:00
1446	Markus Döring                                                                                                                                                                                                                                                  	952                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	419	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1450	394	1	2001-03-01 00:00:00
1447	Markus Döring                                                                                                                                                                                                                                                  	952x93                                                                                                                                                                                                                                                         	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	419	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1555	396	1	2001-03-01 00:00:00
1448	Markus Döring                                                                                                                                                                                                                                                  	953                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	516	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1452	394	1	2001-03-01 00:00:00
1449	Markus Döring                                                                                                                                                                                                                                                  	954                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	54	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1454	394	1	2001-03-01 00:00:00
1450	Markus Döring                                                                                                                                                                                                                                                  	955                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	738	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1458	394	1	2001-03-01 00:00:00
1451	Markus Döring                                                                                                                                                                                                                                                  	956                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	199	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1559	394	1	2001-03-01 00:00:00
1452	Markus Döring                                                                                                                                                                                                                                                  	957                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-29 00:00:00	453	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1457	394	1	2001-03-01 00:00:00
1453	Markus Döring                                                                                                                                                                                                                                                  	958                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	326	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1476	395	1	2001-03-01 00:00:00
1454	Markus Döring                                                                                                                                                                                                                                                  	959                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1504	395	1	2001-03-01 00:00:00
1455	Markus Döring                                                                                                                                                                                                                                                  	960                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	528	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1547	395	1	2001-03-01 00:00:00
1456	Markus Döring                                                                                                                                                                                                                                                  	961                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	380	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1624	395	1	2001-03-01 00:00:00
1457	Markus Döring                                                                                                                                                                                                                                                  	962                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	165	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1422	395	1	2001-03-01 00:00:00
1458	Markus Döring                                                                                                                                                                                                                                                  	963                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1486	395	1	2001-03-01 00:00:00
1459	Markus Döring                                                                                                                                                                                                                                                  	964                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	107	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1487	395	1	2001-03-01 00:00:00
1460	Markus Döring                                                                                                                                                                                                                                                  	965                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	1101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1488	395	1	2001-03-01 00:00:00
1461	Markus Döring                                                                                                                                                                                                                                                  	966                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	363	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1671	395	1	2001-03-01 00:00:00
1462	Markus Döring                                                                                                                                                                                                                                                  	967                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	296	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1490	395	1	2001-03-01 00:00:00
1463	Markus Döring                                                                                                                                                                                                                                                  	968                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	45	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1482	395	1	2001-03-01 00:00:00
1464	Markus Döring                                                                                                                                                                                                                                                  	969                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	219	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1491	395	1	2001-03-01 00:00:00
1465	Markus Döring                                                                                                                                                                                                                                                  	96a                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	733	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	88	202	1	2001-03-01 00:00:00
1466	Markus Döring                                                                                                                                                                                                                                                  	96b                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	1107	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	2467	202	1	2001-03-01 00:00:00
1467	Markus Döring                                                                                                                                                                                                                                                  	97                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	48	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	277	282	1	2001-03-01 00:00:00
1468	Markus Döring                                                                                                                                                                                                                                                  	970                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	512	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1673	395	1	2001-03-01 00:00:00
1469	Markus Döring                                                                                                                                                                                                                                                  	971                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	509	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1493	395	1	2001-03-01 00:00:00
1470	Markus Döring                                                                                                                                                                                                                                                  	973                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	619	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1498	395	1	2001-03-01 00:00:00
1471	Markus Döring                                                                                                                                                                                                                                                  	974                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1497	395	1	2001-03-01 00:00:00
1472	Markus Döring                                                                                                                                                                                                                                                  	975                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	773	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1500	395	1	2001-03-01 00:00:00
1473	Markus Döring                                                                                                                                                                                                                                                  	976                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	77	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1573	395	1	2001-03-01 00:00:00
1474	Markus Döring                                                                                                                                                                                                                                                  	977                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	101	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1502	395	1	2001-03-01 00:00:00
1475	Markus Döring                                                                                                                                                                                                                                                  	978                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	245	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1506	395	1	2001-03-01 00:00:00
1476	Markus Döring                                                                                                                                                                                                                                                  	979                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	1169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1508	395	1	2001-03-01 00:00:00
1477	Markus Döring                                                                                                                                                                                                                                                  	98                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	494	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	83	327	1	2001-03-01 00:00:00
1478	Markus Döring                                                                                                                                                                                                                                                  	980                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	1169	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1509	395	1	2001-03-01 00:00:00
1479	Markus Döring                                                                                                                                                                                                                                                  	981                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	133	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1510	395	1	2001-03-01 00:00:00
1480	Markus Döring                                                                                                                                                                                                                                                  	982                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	616	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1511	395	1	2001-03-01 00:00:00
1481	Markus Döring                                                                                                                                                                                                                                                  	983                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	275	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1619	395	1	2001-03-01 00:00:00
1482	Markus Döring                                                                                                                                                                                                                                                  	984                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	15	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1602	395	1	2001-03-01 00:00:00
1483	Markus Döring                                                                                                                                                                                                                                                  	985                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	31	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1514	395	1	2001-03-01 00:00:00
1484	Markus Döring                                                                                                                                                                                                                                                  	986                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	488	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1515	395	1	2001-03-01 00:00:00
1485	Markus Döring                                                                                                                                                                                                                                                  	987                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	135	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1499	395	1	2001-03-01 00:00:00
1486	Markus Döring                                                                                                                                                                                                                                                  	988                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	937	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1516	395	1	2001-03-01 00:00:00
1487	Markus Döring                                                                                                                                                                                                                                                  	989                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	168	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1583	396	1	2001-03-01 00:00:00
1488	Markus Döring                                                                                                                                                                                                                                                  	99                                                                                                                                                                                                                                                             	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	145	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	68	297	1	2001-03-01 00:00:00
1489	Markus Döring                                                                                                                                                                                                                                                  	990                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	389	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1578	396	1	2001-03-01 00:00:00
1490	Markus Döring                                                                                                                                                                                                                                                  	991                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	290	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1562	396	1	2001-03-01 00:00:00
1491	Markus Döring                                                                                                                                                                                                                                                  	992                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	314	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1663	396	1	2001-03-01 00:00:00
1492	Markus Döring                                                                                                                                                                                                                                                  	993                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	455	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1554	396	1	2001-03-01 00:00:00
1493	Markus Döring                                                                                                                                                                                                                                                  	994                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	147	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1462	396	1	2001-03-01 00:00:00
1494	Markus Döring                                                                                                                                                                                                                                                  	995                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	45	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1548	396	1	2001-03-01 00:00:00
1495	Markus Döring                                                                                                                                                                                                                                                  	996                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	273	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1571	396	1	2001-03-01 00:00:00
1496	Markus Döring                                                                                                                                                                                                                                                  	997                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	403	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1666	396	1	2001-03-01 00:00:00
1497	Markus Döring                                                                                                                                                                                                                                                  	998                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	969	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1565	396	1	2001-03-01 00:00:00
1498	Markus Döring                                                                                                                                                                                                                                                  	999                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	96	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1572	396	1	2001-03-01 00:00:00
1499	Markus Döring                                                                                                                                                                                                                                                  	100                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	204	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	105	337	1	2001-03-01 00:00:00
1500	Markus Döring                                                                                                                                                                                                                                                  	1000                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	4	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1541	396	1	2001-03-01 00:00:00
1501	Markus Döring                                                                                                                                                                                                                                                  	1001                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	79	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1556	396	1	2001-03-01 00:00:00
1502	Markus Döring                                                                                                                                                                                                                                                  	1002                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	50	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1566	396	1	2001-03-01 00:00:00
1503	Markus Döring                                                                                                                                                                                                                                                  	1003                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	59	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1568	396	1	2001-03-01 00:00:00
1504	Markus Döring                                                                                                                                                                                                                                                  	1004                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	533	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1513	396	1	2001-03-01 00:00:00
1505	Markus Döring                                                                                                                                                                                                                                                  	1005                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	119	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1635	396	1	2001-03-01 00:00:00
1506	Markus Döring                                                                                                                                                                                                                                                  	1006                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	378	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1581	396	1	2001-03-01 00:00:00
1507	Markus Döring                                                                                                                                                                                                                                                  	1007                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	492	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1637	396	1	2001-03-01 00:00:00
1508	Markus Döring                                                                                                                                                                                                                                                  	1008                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	342	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1558	396	1	2001-03-01 00:00:00
1509	Markus Döring                                                                                                                                                                                                                                                  	1009                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	430	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1582	396	1	2001-03-01 00:00:00
1510	Markus Döring                                                                                                                                                                                                                                                  	101                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	990	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	107	337	1	2001-03-01 00:00:00
1511	Markus Döring                                                                                                                                                                                                                                                  	1010                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	215	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1585	397	1	2001-03-01 00:00:00
1512	Markus Döring                                                                                                                                                                                                                                                  	1011                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	98	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1586	395	1	2001-03-01 00:00:00
1513	Markus Döring                                                                                                                                                                                                                                                  	1012                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1592	397	1	2001-03-01 00:00:00
1514	Markus Döring                                                                                                                                                                                                                                                  	1013                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	207	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1588	397	1	2001-03-01 00:00:00
1515	Markus Döring                                                                                                                                                                                                                                                  	1014                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	305	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1593	396	1	2001-03-01 00:00:00
1516	Markus Döring                                                                                                                                                                                                                                                  	1015                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	357	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1594	397	1	2001-03-01 00:00:00
1517	Markus Döring                                                                                                                                                                                                                                                  	1016                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	285	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1650	396	1	2001-03-01 00:00:00
1518	Markus Döring                                                                                                                                                                                                                                                  	1017                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	351	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1411	397	1	2001-03-01 00:00:00
1519	Markus Döring                                                                                                                                                                                                                                                  	1018                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	12	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1543	397	1	2001-03-01 00:00:00
1520	Markus Döring                                                                                                                                                                                                                                                  	1019                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	986	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1630	397	1	2001-03-01 00:00:00
1521	Markus Döring                                                                                                                                                                                                                                                  	102                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	282	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	106	337	1	2001-03-01 00:00:00
1522	Markus Döring                                                                                                                                                                                                                                                  	1020                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	160	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1599	397	1	2001-03-01 00:00:00
1523	Markus Döring                                                                                                                                                                                                                                                  	1021                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	538	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1653	397	1	2001-03-01 00:00:00
1524	Markus Döring                                                                                                                                                                                                                                                  	1022                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	327	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1538	398	1	2001-03-01 00:00:00
1525	Markus Döring                                                                                                                                                                                                                                                  	1023                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	266	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1600	397	1	2001-03-01 00:00:00
1526	Markus Döring                                                                                                                                                                                                                                                  	1024                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	206	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1601	397	1	2001-03-01 00:00:00
1527	Markus Döring                                                                                                                                                                                                                                                  	1025                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-08-01 00:00:00	114	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1817	239	1	2001-03-01 00:00:00
1528	Markus Döring                                                                                                                                                                                                                                                  	103                                                                                                                                                                                                                                                            	Markus Döring                                                                                                                                                                                                                                                  	1999-06-21 00:00:00	124	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	108	337	1	2001-03-01 00:00:00
1529	Markus Döring                                                                                                                                                                                                                                                  	1030                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	26	H.Scholz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	1403	399	1	2001-03-01 00:00:00
1530	Markus Döring                                                                                                                                                                                                                                                  	1031                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	500	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1460	399	1	2001-03-01 00:00:00
1531	Markus Döring                                                                                                                                                                                                                                                  	1032                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	54	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1463	399	1	2001-03-01 00:00:00
1532	Markus Döring                                                                                                                                                                                                                                                  	1033                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	434	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1464	399	1	2001-03-01 00:00:00
1533	Markus Döring                                                                                                                                                                                                                                                  	1034                                                                                                                                                                                                                                                           	Markus Döring                                                                                                                                                                                                                                                  	1999-07-31 00:00:00	240	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1466	399	1	2001-03-01 00:00:00
1534	Markus Döring                                                                                                                                                                                                                                                  	1034x95                                                                                                                                                                                                                                                        	Markus Döring                                                                                                                                                                                                                                                  	1999-07-30 00:00:00	240	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	1522	398	1	2001-03-01 00:00:00
\.


--
-- TOC entry 1758 (class 0 OID 32124)
-- Dependencies: 1342
-- Data for Name: taxon; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY taxon (taxon_id, full_name, authorteam, rank, infra_epi, genus, epitheton, species_authorteam, subspecies, subspecies_authorteam, variety, variety_authorteam, synonyms, name_excl_authors, notes, chorotype, lifeform_fk) FROM stdin;
1	noch unbestimmt !!!                                                                                                                                                                                                                                            	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	noch unbestimmt !!!                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	noch unbestimmt !!!                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	1
2	Secale anatolicum Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Secale                                                                                                                                                                                                                                                         	anatolicum                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Secale anatolicum                                                                                                                                                                                                                                              	evtl neue subsp                                                                                                                                                                                                                                                	IA                                                                                                                                                                                                                                                             	5
3	Stylidium pilosum Labill.                                                                                                                                                                                                                                      	Labill.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Stylidium                                                                                                                                                                                                                                                      	pilosum                                                                                                                                                                                                                                                        	Labill.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stylidium pilosum                                                                                                                                                                                                                                              	evtl = Trisetum ?                                                                                                                                                                                                                                              	Unknown                                                                                                                                                                                                                                                        	3
4	Sesleria alba Sm.                                                                                                                                                                                                                                              	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Sesleria                                                                                                                                                                                                                                                       	alba                                                                                                                                                                                                                                                           	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sesleria anatolica                                                                                                                                                                                                                                             	Sesleria alba                                                                                                                                                                                                                                                  	siehe Seslerietum bei Schichtl/Stern                                                                                                                                                                                                                           	End A                                                                                                                                                                                                                                                          	3
5	Sesleria phleoides Steven ex R.Roem. & Schultes                                                                                                                                                                                                                	Steven ex R.Roem. & Schultes                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Sesleria                                                                                                                                                                                                                                                       	phleoides                                                                                                                                                                                                                                                      	Steven ex R.Roem. & Schultes                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sesleria phleoides                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA / Eux                                                                                                                                                                                                                                                       	3
6	Sesleria spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Sesleria                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sesleria spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
7	Dactylis glomerata subsp. hispanica (Roth) Nyman                                                                                                                                                                                                               	(Roth) Nyman                                                                                                                    	Subspecies                                        	hispanica                                                                                                                                                                                                                                                      	Dactylis                                                                                                                                                                                                                                                       	glomerata                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	hispanica                                                                                                                                                                                                                                                      	(Roth) Nyman                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dactylis glomerata subsp. hispanica                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
9	Melica persica subsp. inaequiglumis (Boiss) Bor.                                                                                                                                                                                                               	(Boiss) Bor.                                                                                                                    	Subspecies                                        	inaequiglumis                                                                                                                                                                                                                                                  	Melica                                                                                                                                                                                                                                                         	persica                                                                                                                                                                                                                                                        	Kunth.                                                                                                                                                                                                                                                         	inaequiglumis                                                                                                                                                                                                                                                  	(Boiss) Bor.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Melica persica subsp. inaequiglumis                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
10	Poa psychrophila Boiss. & Heldr.                                                                                                                                                                                                                               	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	psychrophila                                                                                                                                                                                                                                                   	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P. cenisia                                                                                                                                                                                                                                                     	Poa psychrophila                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	4
11	Poa alpina subsp. fallax F.Herm.                                                                                                                                                                                                                               	F.Herm.                                                                                                                         	Subspecies                                        	fallax                                                                                                                                                                                                                                                         	Poa                                                                                                                                                                                                                                                            	alpina                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	fallax                                                                                                                                                                                                                                                         	F.Herm.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P. molinerii                                                                                                                                                                                                                                                   	Poa alpina subsp. fallax                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
12	Poa bulbosa agg. L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	bulbosa agg.                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa bulbosa agg.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	5
799	Pancratium maritimum L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Pancratium                                                                                                                                                                                                                                                     	maritimum                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pancratium maritimum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	4
984	Filago pyramidata L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Filago                                                                                                                                                                                                                                                         	pyramidata                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Filago pyramidata                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
13	Poa cf. diversifolia (Boiss. & Balansa) Hackel ex Boiss.                                                                                                                                                                                                       	(Boiss. & Balansa) Hackel ex Boiss.                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	cf. diversifolia                                                                                                                                                                                                                                               	(Boiss. & Balansa) Hackel ex Boiss.                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa cf. diversifolia                                                                                                                                                                                                                                           	von scholz nicht bestimmt !                                                                                                                                                                                                                                    	EMed                                                                                                                                                                                                                                                           	3
14	Poa spec.                                                                                                                                                                                                                                                      	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa spec.                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
323	Verbascum pestalozzae Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	pestalozzae                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum pestalozzae                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
559	Marrubium globosum Benth.                                                                                                                                                                                                                                      	Benth.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	globosum                                                                                                                                                                                                                                                       	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium globosum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
561	Morina persica L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Morina                                                                                                                                                                                                                                                         	persica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Morina persica                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	3
15	Elytrigia tauri (Boiss. & Balansa) Tzvelev.                                                                                                                                                                                                                    	(Boiss. & Balansa) Tzvelev.                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	tauri                                                                                                                                                                                                                                                          	(Boiss. & Balansa) Tzvelev.                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia tauri                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
16	Elytrigia libanotica (Hack.) J.Holub.                                                                                                                                                                                                                          	(Hack.) J.Holub.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	libanotica                                                                                                                                                                                                                                                     	(Hack.) J.Holub.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia libanotica                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
17	Elytrigia divaricata (Boiss. & Balansa) Nevski                                                                                                                                                                                                                 	(Boiss. & Balansa) Nevski                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	divaricata                                                                                                                                                                                                                                                     	(Boiss. & Balansa) Nevski                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Agropyron strigosus (Quetzel)                                                                                                                                                                                                                                  	Elytrigia divaricata                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
18	Elytrigia spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
19	Festuca pinifolia var. pinifolia                                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	pinifolia                                                                                                                                                                                                                                                      	Festuca                                                                                                                                                                                                                                                        	pinifolia                                                                                                                                                                                                                                                      	(Hack. ex Boiss.) Bornm.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	pinifolia                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca pinifolia var. pinifolia                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
20	Festuca anatolica subsp. anatolica                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	anatolica                                                                                                                                                                                                                                                      	Festuca                                                                                                                                                                                                                                                        	anatolica                                                                                                                                                                                                                                                      	Markgr.-Dann.                                                                                                                                                                                                                                                  	anatolica                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca anatolica subsp. anatolica                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
21	Festuca valesiaca Schleicher ex Gaudin                                                                                                                                                                                                                         	Schleicher ex Gaudin                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	valesiaca                                                                                                                                                                                                                                                      	Schleicher ex Gaudin                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca valesiaca                                                                                                                                                                                                                                              	beleg 574 ist von scholz mitbestimmt worden. überprüfen, da sideritis libanotica schon nummer 574 hat !!!                                                                                                                                                      	ES / IrTur                                                                                                                                                                                                                                                     	3
22	Festuca spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
23	Stipa spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Stipa                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
24	Stipa pulcherrima subsp. epilosa (Martinovsky) Tzvelev.                                                                                                                                                                                                        	(Martinovsky) Tzvelev.                                                                                                          	Subspecies                                        	epilosa                                                                                                                                                                                                                                                        	Stipa                                                                                                                                                                                                                                                          	pulcherrima                                                                                                                                                                                                                                                    	C.Koch                                                                                                                                                                                                                                                         	epilosa                                                                                                                                                                                                                                                        	(Martinovsky) Tzvelev.                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa pulcherrima subsp. epilosa                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
25	Stipa holosericea Trin.                                                                                                                                                                                                                                        	Trin.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Stipa                                                                                                                                                                                                                                                          	holosericea                                                                                                                                                                                                                                                    	Trin.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa holosericea                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
26	Koeleria macrantha (Ledeb.) Schult.                                                                                                                                                                                                                            	(Ledeb.) Schult.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Koeleria                                                                                                                                                                                                                                                       	macrantha                                                                                                                                                                                                                                                      	(Ledeb.) Schult.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Koeleria cristata                                                                                                                                                                                                                                              	Koeleria macrantha                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
27	Eremopoa persica (Trin.) Roshev.                                                                                                                                                                                                                               	(Trin.) Roshev.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Eremopoa                                                                                                                                                                                                                                                       	persica                                                                                                                                                                                                                                                        	(Trin.) Roshev.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eremopoa persica                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
28	Poa pratensis L.                                                                                                                                                                                                                                               	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	pratensis                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa pratensis                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
29	Bromus sect. Pnigma Dumont                                                                                                                                                                                                                                     	Dumont                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	sect. Pnigma                                                                                                                                                                                                                                                   	Dumont                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus sect. Pnigma                                                                                                                                                                                                                                            	sesleria ?                                                                                                                                                                                                                                                     	Unknown                                                                                                                                                                                                                                                        	3
30	Bromus tomentellus subsp. tomentellus                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	tomentellus                                                                                                                                                                                                                                                    	Bromus                                                                                                                                                                                                                                                         	tomentellus                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	tomentellus                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus tomentellus subsp. tomentellus                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
31	Bromus tectorum L.                                                                                                                                                                                                                                             	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	tectorum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus tectorum                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	5
32	Bromus danthoniae Trin.                                                                                                                                                                                                                                        	Trin.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	danthoniae                                                                                                                                                                                                                                                     	Trin.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus danthoniae                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
33	Phleum alpinum L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Phleum                                                                                                                                                                                                                                                         	alpinum                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Phleum alpinum                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
34	Gentiana boissieri Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Gentiana                                                                                                                                                                                                                                                       	boissieri                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gentiana boissieri                                                                                                                                                                                                                                             	nächstverwand mit G.septemfida aus dem Kackar->verwandschaft mit ES Element, alpen und himalaya.                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
35	Gentianella holosteoides (N.M.Pritchard) Greuter                                                                                                                                                                                                               	(N.M.Pritchard) Greuter                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Gentianella                                                                                                                                                                                                                                                    	holosteoides                                                                                                                                                                                                                                                   	(N.M.Pritchard) Greuter                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gentianella holosteoides                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	5
36	Gentiana septemfida Pall.                                                                                                                                                                                                                                      	Pall.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Gentiana                                                                                                                                                                                                                                                       	septemfida                                                                                                                                                                                                                                                     	Pall.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gentiana septemfida                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Eux / Hyrc                                                                                                                                                                                                                                                     	3
38	Potentilla rupestris L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	rupestris                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla rupestris                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
39	Potentilla meyeri Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	meyeri                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla meyeri                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
41	Alchemilla ellenbergiana Rothm.                                                                                                                                                                                                                                	Rothm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alchemilla                                                                                                                                                                                                                                                     	ellenbergiana                                                                                                                                                                                                                                                  	Rothm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alchemilla ellenbergiana                                                                                                                                                                                                                                       	evtl. = A.retinervis                                                                                                                                                                                                                                           	Eux                                                                                                                                                                                                                                                            	3
43	Sanguisorba minor s.l. Scop.                                                                                                                                                                                                                                   	Scop.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Sanguisorba                                                                                                                                                                                                                                                    	minor s.l.                                                                                                                                                                                                                                                     	Scop.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sanguisorba minor s.l.                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
44	Sanguisorba minor subsp. muricata (Spach) Briq.                                                                                                                                                                                                                	(Spach) Briq.                                                                                                                   	Subspecies                                        	muricata                                                                                                                                                                                                                                                       	Sanguisorba                                                                                                                                                                                                                                                    	minor                                                                                                                                                                                                                                                          	Scop.                                                                                                                                                                                                                                                          	muricata                                                                                                                                                                                                                                                       	(Spach) Briq.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sanguisorba minor subsp. muricata                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
45	Rosa pulverulenta M.Bieb.                                                                                                                                                                                                                                      	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Rosa                                                                                                                                                                                                                                                           	pulverulenta                                                                                                                                                                                                                                                   	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa pulverulenta                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	2
46	Rosa heckeliana subsp. vanheurekiana (Crép.) O.Nilsson                                                                                                                                                                                                         	(Crép.) O.Nilsson                                                                                                               	Subspecies                                        	vanheurekiana                                                                                                                                                                                                                                                  	Rosa                                                                                                                                                                                                                                                           	heckeliana                                                                                                                                                                                                                                                     	Tratt.                                                                                                                                                                                                                                                         	vanheurekiana                                                                                                                                                                                                                                                  	(Crép.) O.Nilsson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa heckeliana subsp. vanheurekiana                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
47	Rosa cf. pisiformis (H.Christ) Sosn.                                                                                                                                                                                                                           	(H.Christ) Sosn.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Rosa                                                                                                                                                                                                                                                           	cf. pisiformis                                                                                                                                                                                                                                                 	(H.Christ) Sosn.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa cf. pisiformis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	2
565	Muscari spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
631	Vitex agnus- castus L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Vitex                                                                                                                                                                                                                                                          	agnus- castus                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vitex agnus- castus                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	6
840	Astragalus spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus spec.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
48	Cerasus prostrata var. prostrata                                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	prostrata                                                                                                                                                                                                                                                      	Cerasus                                                                                                                                                                                                                                                        	prostrata                                                                                                                                                                                                                                                      	(Lab.) Ser.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	prostrata                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerasus prostrata var. prostrata                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	2
49	Ebenus laguroides var. laguroides                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	laguroides                                                                                                                                                                                                                                                     	Ebenus                                                                                                                                                                                                                                                         	laguroides                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	laguroides                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ebenus laguroides var. laguroides                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
50	Ononis adenotricha var. adenotricha                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	adenotricha                                                                                                                                                                                                                                                    	Ononis                                                                                                                                                                                                                                                         	adenotricha                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	adenotricha                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ononis adenotricha var. adenotricha                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
51	Lotus alpinus (DC.) Ramond                                                                                                                                                                                                                                     	(DC.) Ramond                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Lotus                                                                                                                                                                                                                                                          	alpinus                                                                                                                                                                                                                                                        	(DC.) Ramond                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	L. corniculatus L. var. alpinus Ser.                                                                                                                                                                                                                           	Lotus alpinus                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	2
52	Securigea orientalis (Mill.) Lassen                                                                                                                                                                                                                            	(Mill.) Lassen                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Securigea                                                                                                                                                                                                                                                      	orientalis                                                                                                                                                                                                                                                     	(Mill.) Lassen                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Coronilla orientalis Miller var. orientalis                                                                                                                                                                                                                    	Securigea orientalis                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
54	Medicago x varia Martyn                                                                                                                                                                                                                                        	Martyn                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Medicago                                                                                                                                                                                                                                                       	x varia                                                                                                                                                                                                                                                        	Martyn                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Medicago x varia                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	2
55	Anthyllis vulneraria subsp. boissieri (Sagorski) Bornm.                                                                                                                                                                                                        	(Sagorski) Bornm.                                                                                                               	Subspecies                                        	boissieri                                                                                                                                                                                                                                                      	Anthyllis                                                                                                                                                                                                                                                      	vulneraria                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	boissieri                                                                                                                                                                                                                                                      	(Sagorski) Bornm.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthyllis vulneraria subsp. boissieri                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
56	Onobrychis cornuta (L.) Desv.                                                                                                                                                                                                                                  	(L.) Desv.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Onobrychis                                                                                                                                                                                                                                                     	cornuta                                                                                                                                                                                                                                                        	(L.) Desv.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onobrychis cornuta                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
57	Onobrychis montana subsp. cadmea (Boiss.) P.W. Ball                                                                                                                                                                                                            	(Boiss.) P.W. Ball                                                                                                              	Subspecies                                        	cadmea                                                                                                                                                                                                                                                         	Onobrychis                                                                                                                                                                                                                                                     	montana                                                                                                                                                                                                                                                        	DC:                                                                                                                                                                                                                                                            	cadmea                                                                                                                                                                                                                                                         	(Boiss.) P.W. Ball                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onobrychis montana subsp. cadmea                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
58	Genista sandrasica Hartvig & Strid                                                                                                                                                                                                                             	Hartvig & Strid                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Genista                                                                                                                                                                                                                                                        	sandrasica                                                                                                                                                                                                                                                     	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Genista sandrasica                                                                                                                                                                                                                                             	= G.lydia var lydia ?                                                                                                                                                                                                                                          	End loc                                                                                                                                                                                                                                                        	2
59	Genista albida Willd.                                                                                                                                                                                                                                          	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Genista                                                                                                                                                                                                                                                        	albida                                                                                                                                                                                                                                                         	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Genista albida                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
60	Hedysarum erythroleucum Boiss.                                                                                                                                                                                                                                 	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hedysarum                                                                                                                                                                                                                                                      	erythroleucum                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hedysarum erythroleucum                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
61	Chamaecytisus eriocarpus (Boiss.) Rothm.                                                                                                                                                                                                                       	(Boiss.) Rothm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Chamaecytisus                                                                                                                                                                                                                                                  	eriocarpus                                                                                                                                                                                                                                                     	(Boiss.) Rothm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	cytisus tmoleus (QUEZEL), cytisus smyrnaeus (QUEZEL)                                                                                                                                                                                                           	Chamaecytisus eriocarpus                                                                                                                                                                                                                                       	gerald hat auf dem sandras dag fast nur Chytisopsis dorycnifolia (roter kelch) -> im feld mit chamaecytisus eriocarpus angesprochen.                                                                                                                           	EMed                                                                                                                                                                                                                                                           	2
883	Crepis cf. micrantha Czer.                                                                                                                                                                                                                                     	Czer.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	cf. micrantha                                                                                                                                                                                                                                                  	Czer.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis cf. micrantha                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
967	Alkanna attilae P.H. Davis                                                                                                                                                                                                                                     	P.H. Davis                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Alkanna                                                                                                                                                                                                                                                        	attilae                                                                                                                                                                                                                                                        	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna attilae                                                                                                                                                                                                                                                	Özkan                                                                                                                                                                                                                                                          	End BT                                                                                                                                                                                                                                                         	3
1148	Thymelaea spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Thymelaea                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymelaea spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
62	Chamaecytisus pygmaeus (Willd.) Rothm.                                                                                                                                                                                                                         	(Willd.) Rothm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Chamaecytisus                                                                                                                                                                                                                                                  	pygmaeus                                                                                                                                                                                                                                                       	(Willd.) Rothm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Chamaecytisus pygmaeus                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
64	Vicia alpestris subsp. hypoleuca (Boiss. & Noe) P.H. Davis                                                                                                                                                                                                     	(Boiss. & Noe) P.H. Davis                                                                                                       	Subspecies                                        	hypoleuca                                                                                                                                                                                                                                                      	Vicia                                                                                                                                                                                                                                                          	alpestris                                                                                                                                                                                                                                                      	Stev.                                                                                                                                                                                                                                                          	hypoleuca                                                                                                                                                                                                                                                      	(Boiss. & Noe) P.H. Davis                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vicia alpestris subsp. hypoleuca                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
65	Vavilovia formosa (Stev.) Fed.                                                                                                                                                                                                                                 	(Stev.) Fed.                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Vavilovia                                                                                                                                                                                                                                                      	formosa                                                                                                                                                                                                                                                        	(Stev.) Fed.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vavilovia formosa                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	3
66	Trifolium hybridum subsp. anatolicum (Boiss.) Hossain                                                                                                                                                                                                          	(Boiss.) Hossain                                                                                                                	Subspecies                                        	anatolicum                                                                                                                                                                                                                                                     	Trifolium                                                                                                                                                                                                                                                      	hybridum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	anatolicum                                                                                                                                                                                                                                                     	(Boiss.) Hossain                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	T. hybridum L. var. anatolicum (Boiss.) Boiss.                                                                                                                                                                                                                 	Trifolium hybridum subsp. anatolicum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	3
67	Trifolium canescens Willd.                                                                                                                                                                                                                                     	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Trifolium                                                                                                                                                                                                                                                      	canescens                                                                                                                                                                                                                                                      	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium canescens                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Unknown / IA                                                                                                                                                                                                                                                   	3
68	Trifolium ambiguum M.Bieb.                                                                                                                                                                                                                                     	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Trifolium                                                                                                                                                                                                                                                      	ambiguum                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium ambiguum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Unknown / IA                                                                                                                                                                                                                                                   	3
69	Medicago lupulina var. perennans Hal.                                                                                                                                                                                                                          	Hal.                                                                                                                            	Variety                                           	perennans                                                                                                                                                                                                                                                      	Medicago                                                                                                                                                                                                                                                       	lupulina                                                                                                                                                                                                                                                       	L                                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	perennans                                                                                                                                                                                                                                                      	Hal.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Medicago lupulina var. perennans                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	2
71	Trifolium repens var. repens                                                                                                                                                                                                                                   	                                                                                                                                	Variety                                           	repens                                                                                                                                                                                                                                                         	Trifolium                                                                                                                                                                                                                                                      	repens                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	repens                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium repens var. repens                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	3
72	Trifolium spadiceum L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Trifolium                                                                                                                                                                                                                                                      	spadiceum                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium spadiceum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
73	Cotoneaster nummularia J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                   	J.C.Fisch. & C.A.Mey.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Cotoneaster                                                                                                                                                                                                                                                    	nummularia                                                                                                                                                                                                                                                     	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cotoneaster nummularia                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
75	Vicia leucomalla Bornm.                                                                                                                                                                                                                                        	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Vicia                                                                                                                                                                                                                                                          	leucomalla                                                                                                                                                                                                                                                     	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vicia canescens subsp. leucomalla                                                                                                                                                                                                                              	Vicia leucomalla                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
76	Cephalaria gigantea (Ledeb.) Bobrov                                                                                                                                                                                                                            	(Ledeb.) Bobrov                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Cephalaria                                                                                                                                                                                                                                                     	gigantea                                                                                                                                                                                                                                                       	(Ledeb.) Bobrov                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cephalaria gigantea                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
77	Pterocephalus pinardii Boiss.                                                                                                                                                                                                                                  	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Pterocephalus                                                                                                                                                                                                                                                  	pinardii                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pterocephalus pinardii                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
79	Sedum album L.                                                                                                                                                                                                                                                 	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	album                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum album                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	2
80	Sedum ursi t´Hart                                                                                                                                                                                                                                              	t´Hart                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	ursi                                                                                                                                                                                                                                                           	t´Hart                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum laconicum Boiss. & Heldr.                                                                                                                                                                                                                                	Sedum ursi                                                                                                                                                                                                                                                     	eher Berg Begleiter                                                                                                                                                                                                                                            	End A                                                                                                                                                                                                                                                          	2
81	Sedum hispanicum var. hispanicum                                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	hispanicum                                                                                                                                                                                                                                                     	Sedum                                                                                                                                                                                                                                                          	hispanicum                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	hispanicum                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum hispanicum var. hispanicum                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
82	Sedum tenellum M.Bieb.                                                                                                                                                                                                                                         	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	tenellum                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum tenellum                                                                                                                                                                                                                                                 	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	Eux / Hyrc                                                                                                                                                                                                                                                     	2
83	Sedum spurium M.Bieb.                                                                                                                                                                                                                                          	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	spurium                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum spurium                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Eux / Hyrc                                                                                                                                                                                                                                                     	2
84	Prometheum aizoon (Fenzl) t´Hart                                                                                                                                                                                                                               	(Fenzl) t´Hart                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Prometheum                                                                                                                                                                                                                                                     	aizoon                                                                                                                                                                                                                                                         	(Fenzl) t´Hart                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosularia aizoon (Fenzl) Berger                                                                                                                                                                                                                                	Prometheum aizoon                                                                                                                                                                                                                                              	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	IA                                                                                                                                                                                                                                                             	2
85	Prometheum sempervivoides (Fisch. ex M.Bieb.) H.Ohba                                                                                                                                                                                                           	(Fisch. ex M.Bieb.) H.Ohba                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Prometheum                                                                                                                                                                                                                                                     	sempervivoides                                                                                                                                                                                                                                                 	(Fisch. ex M.Bieb.) H.Ohba                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum sempervivoides M.Bieb.                                                                                                                                                                                                                                   	Prometheum sempervivoides                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
86	Sedum rupestre L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	rupestre                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	S.reflexum L.                                                                                                                                                                                                                                                  	Sedum rupestre                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
87	Sedum pallidum var. pallidum                                                                                                                                                                                                                                   	                                                                                                                                	Variety                                           	pallidum                                                                                                                                                                                                                                                       	Sedum                                                                                                                                                                                                                                                          	pallidum                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	pallidum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum pallidum var. pallidum                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
88	Sempervivum davisii Muirhead                                                                                                                                                                                                                                   	Muirhead                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Sempervivum                                                                                                                                                                                                                                                    	davisii                                                                                                                                                                                                                                                        	Muirhead                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sempervivum davisii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
89	Prometheum serpentinicum (Werderm.) t´Hart                                                                                                                                                                                                                     	(Werderm.) t´Hart                                                                                                               	                                                  	                                                                                                                                                                                                                                                               	Prometheum                                                                                                                                                                                                                                                     	serpentinicum                                                                                                                                                                                                                                                  	(Werderm.) t´Hart                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosularia serpentinica (Werderm.) Muirhead                                                                                                                                                                                                                     	Prometheum serpentinicum                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
90	Iberis sempervirens L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Iberis                                                                                                                                                                                                                                                         	sempervirens                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Iberis sempervirens                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	2
91	Iberis simplex DC.                                                                                                                                                                                                                                             	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Iberis                                                                                                                                                                                                                                                         	simplex                                                                                                                                                                                                                                                        	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	I.taurica DC.                                                                                                                                                                                                                                                  	Iberis simplex                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
92	Hesperis kotschyi Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hesperis                                                                                                                                                                                                                                                       	kotschyi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hesperis kotschyi                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
93	Hesperis bicuspidata (Willd.) Poir.                                                                                                                                                                                                                            	(Willd.) Poir.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Hesperis                                                                                                                                                                                                                                                       	bicuspidata                                                                                                                                                                                                                                                    	(Willd.) Poir.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hesperis bicuspidata                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	5
94	Aethionema cordatum (Desf.) Boiss.                                                                                                                                                                                                                             	(Desf.) Boiss.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	cordatum                                                                                                                                                                                                                                                       	(Desf.) Boiss.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema cordatum                                                                                                                                                                                                                                            	eher Berg Begleiter                                                                                                                                                                                                                                            	IA                                                                                                                                                                                                                                                             	3
95	Aethionema oppositifolium (Pers.) Hedge                                                                                                                                                                                                                        	(Pers.) Hedge                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	oppositifolium                                                                                                                                                                                                                                                 	(Pers.) Hedge                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema oppositifolium                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
96	Aethionema capitatum Boiss. & Balansa                                                                                                                                                                                                                          	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	capitatum                                                                                                                                                                                                                                                      	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema capitatum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
98	Aethionema stylosum DC.                                                                                                                                                                                                                                        	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	stylosum                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema stylosum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
99	Aethionema coridifolium DC.                                                                                                                                                                                                                                    	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	coridifolium                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema coridifolium                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
100	Aethionema iberideum (Boiss.) Boiss.                                                                                                                                                                                                                           	(Boiss.) Boiss.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	iberideum                                                                                                                                                                                                                                                      	(Boiss.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema iberideum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
101	Aethionema arabicum (L.) O.E. Schulz                                                                                                                                                                                                                           	(L.) O.E. Schulz                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	arabicum                                                                                                                                                                                                                                                       	(L.) O.E. Schulz                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema arabicum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
102	Aethionema speciosum subsp. compactum Hartvig & Strid                                                                                                                                                                                                          	Hartvig & Strid                                                                                                                 	Subspecies                                        	compactum                                                                                                                                                                                                                                                      	Aethionema                                                                                                                                                                                                                                                     	speciosum                                                                                                                                                                                                                                                      	Boiss. & Huet                                                                                                                                                                                                                                                  	compactum                                                                                                                                                                                                                                                      	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema speciosum subsp. compactum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
103	Thlaspi papillosum Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Thlaspi                                                                                                                                                                                                                                                        	papillosum                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thlaspi papillosum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
104	Thlaspi perfoliatum L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Thlaspi                                                                                                                                                                                                                                                        	perfoliatum                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thlaspi perfoliatum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
105	Coluteocarpus vesicaria subsp. vesicaria                                                                                                                                                                                                                       	                                                                                                                                	Subspecies                                        	vesicaria                                                                                                                                                                                                                                                      	Coluteocarpus                                                                                                                                                                                                                                                  	vesicaria                                                                                                                                                                                                                                                      	(L.) Holmboe                                                                                                                                                                                                                                                   	vesicaria                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Coluteocarpus vesicaria subsp. vesicaria                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
106	Clypeola jonthlaspi L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Clypeola                                                                                                                                                                                                                                                       	jonthlaspi                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Clypeola jonthlaspi                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
107	Fibigia macrocarpa (Boiss.) Boiss.                                                                                                                                                                                                                             	(Boiss.) Boiss.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Fibigia                                                                                                                                                                                                                                                        	macrocarpa                                                                                                                                                                                                                                                     	(Boiss.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fibigia macrocarpa                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
108	Heldreichia rotundifolia Boiss.                                                                                                                                                                                                                                	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Heldreichia                                                                                                                                                                                                                                                    	rotundifolia                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Heldreichia rotundifolia                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
109	Capsella bursa-pastoris (L.) L.W.Medicus                                                                                                                                                                                                                       	(L.) L.W.Medicus                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Capsella                                                                                                                                                                                                                                                       	bursa-pastoris                                                                                                                                                                                                                                                 	(L.) L.W.Medicus                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Capsella bursa-pastoris                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Kosmo                                                                                                                                                                                                                                                          	5
110	Aurinia rupestris subsp. cyclocarpa                                                                                                                                                                                                                            	                                                                                                                                	Subspecies                                        	cyclocarpa                                                                                                                                                                                                                                                     	Aurinia                                                                                                                                                                                                                                                        	rupestris                                                                                                                                                                                                                                                      	(Boiss.) Cullen & Dudley                                                                                                                                                                                                                                       	cyclocarpa                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aurinia rupestris subsp. cyclocarpa                                                                                                                                                                                                                            	schutt-grasflur Übergang                                                                                                                                                                                                                                       	End A                                                                                                                                                                                                                                                          	3
1124	Centaurium erythraea subsp. turcicum (Velen.) Melderis                                                                                                                                                                                                         	(Velen.) Melderis                                                                                                               	Subspecies                                        	turcicum                                                                                                                                                                                                                                                       	Centaurium                                                                                                                                                                                                                                                     	erythraea                                                                                                                                                                                                                                                      	Rafn.                                                                                                                                                                                                                                                          	turcicum                                                                                                                                                                                                                                                       	(Velen.) Melderis                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurium erythraea subsp. turcicum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	5
1125	Paronychia argyroloba Stapf                                                                                                                                                                                                                                    	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Paronychia                                                                                                                                                                                                                                                     	argyroloba                                                                                                                                                                                                                                                     	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Paronychia argyroloba                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
1126	Sedum eriocarpum subsp. caricum (Carlström) t´Hart                                                                                                                                                                                                             	(Carlström) t´Hart                                                                                                              	Subspecies                                        	caricum                                                                                                                                                                                                                                                        	Sedum                                                                                                                                                                                                                                                          	eriocarpum                                                                                                                                                                                                                                                     	Sibth. & Sm.                                                                                                                                                                                                                                                   	caricum                                                                                                                                                                                                                                                        	(Carlström) t´Hart                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum caricum Carlström                                                                                                                                                                                                                                        	Sedum eriocarpum subsp. caricum                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
1127	Euphorbia anacampseros var. anacampseros                                                                                                                                                                                                                       	                                                                                                                                	Variety                                           	anacampseros                                                                                                                                                                                                                                                   	Euphorbia                                                                                                                                                                                                                                                      	anacampseros                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	anacampseros                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia anacampseros var. anacampseros                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
1128	Hieracium auriculoides Láng                                                                                                                                                                                                                                    	Láng                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	auriculoides                                                                                                                                                                                                                                                   	Láng                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella echioides X piloselloides                                                                                                                                                                                                                            	Hieracium auriculoides                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES / IA / EMed                                                                                                                                                                                                                                                 	3
1129	Muscari muscarimi L.W.Medicus                                                                                                                                                                                                                                  	L.W.Medicus                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	muscarimi                                                                                                                                                                                                                                                      	L.W.Medicus                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari muscarimi                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	4
1130	Allium reuterianum Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	reuterianum                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium reuterianum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	4
1131	Agrostis stolonifera L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Agrostis                                                                                                                                                                                                                                                       	stolonifera                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Agrostis stolonifera                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	4
1132	Alopecurus textilis Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alopecurus                                                                                                                                                                                                                                                     	textilis                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alopecurus textilis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
1133	Chaenorhinum minus subsp. anatolicum P.H. Davis                                                                                                                                                                                                                	P.H. Davis                                                                                                                      	Subspecies                                        	anatolicum                                                                                                                                                                                                                                                     	Chaenorhinum                                                                                                                                                                                                                                                   	minus                                                                                                                                                                                                                                                          	(L.) Lange                                                                                                                                                                                                                                                     	anatolicum                                                                                                                                                                                                                                                     	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Chaenorhinum minus subsp. anatolicum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	5
1134	Inula montbretiana DC.                                                                                                                                                                                                                                         	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Inula                                                                                                                                                                                                                                                          	montbretiana                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Inula montbretiana                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
1135	Bromus tomentellus subsp. nivalis                                                                                                                                                                                                                              	                                                                                                                                	Subspecies                                        	nivalis                                                                                                                                                                                                                                                        	Bromus                                                                                                                                                                                                                                                         	tomentellus                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	nivalis                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus tomentellus subsp. nivalis                                                                                                                                                                                                                              	gerald bolkar                                                                                                                                                                                                                                                  	IA                                                                                                                                                                                                                                                             	3
1136	Thymus brachychilus Jalas                                                                                                                                                                                                                                      	Jalas                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Thymus                                                                                                                                                                                                                                                         	brachychilus                                                                                                                                                                                                                                                   	Jalas                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus brachychilus                                                                                                                                                                                                                                            	Nur im Bolkar und den Aladaglari. bolkar+aladaglari\nteilweise ehemals T.leucotrichus                                                                                                                                                                           	End OT                                                                                                                                                                                                                                                         	2
1137	Arenaria cf. uninervia McNeill                                                                                                                                                                                                                                 	McNeill                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	cf. uninervia                                                                                                                                                                                                                                                  	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria cf. uninervia                                                                                                                                                                                                                                         	Gerlad Bolkar                                                                                                                                                                                                                                                  	End A                                                                                                                                                                                                                                                          	2
1138	Silene caryophylloides subsp. echinus (Boiss. & Heldr.) Coode & Cullen                                                                                                                                                                                         	(Boiss. & Heldr.) Coode & Cullen                                                                                                	Subspecies                                        	echinus                                                                                                                                                                                                                                                        	Silene                                                                                                                                                                                                                                                         	caryophylloides                                                                                                                                                                                                                                                	(Poiret) Otth                                                                                                                                                                                                                                                  	echinus                                                                                                                                                                                                                                                        	(Boiss. & Heldr.) Coode & Cullen                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene caryophylloides subsp. echinus                                                                                                                                                                                                                          	Nur im Bolkar und den Aladaglari. Gerlad Bolkar                                                                                                                                                                                                                	End T                                                                                                                                                                                                                                                          	2
1139	Sedum amplexicaule DC.                                                                                                                                                                                                                                         	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	amplexicaule                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum amplexicaule                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
1140	Fumana procumbens (Dunal) Gren. & Godr.                                                                                                                                                                                                                        	(Dunal) Gren. & Godr.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Fumana                                                                                                                                                                                                                                                         	procumbens                                                                                                                                                                                                                                                     	(Dunal) Gren. & Godr.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fumana procumbens                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Med / ES / IA                                                                                                                                                                                                                                                  	2
1141	Cytisopsis pseudocytisus subsp. reeseana (Guyot) Lassen                                                                                                                                                                                                        	(Guyot) Lassen                                                                                                                  	Subspecies                                        	reeseana                                                                                                                                                                                                                                                       	Cytisopsis                                                                                                                                                                                                                                                     	pseudocytisus                                                                                                                                                                                                                                                  	Jaub. & Spach                                                                                                                                                                                                                                                  	reeseana                                                                                                                                                                                                                                                       	(Guyot) Lassen                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	C. dorycniifolia Jaub. & Spach subsp. reeseana (Guyot) Hub.- Mor.                                                                                                                                                                                              	Cytisopsis pseudocytisus subsp. reeseana                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
1142	Secale spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Secale                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Secale spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
1143	Agrostis spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Agrostis                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Agrostis spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
1144	Taeniatherum spec.                                                                                                                                                                                                                                             	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Taeniatherum                                                                                                                                                                                                                                                   	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taeniatherum spec.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
1145	Trisetum spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Trisetum                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trisetum spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
1146	Aurinia spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Aurinia                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aurinia spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
1147	Asperula spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Asperula                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
1150	Crepis dioritica Schott & Ky. ex Boiss.                                                                                                                                                                                                                        	Schott & Ky. ex Boiss.                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	dioritica                                                                                                                                                                                                                                                      	Schott & Ky. ex Boiss.                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis dioritica                                                                                                                                                                                                                                               	Nur im Bolkar und den Aladaglari. Gerald Bolkar                                                                                                                                                                                                                	End A                                                                                                                                                                                                                                                          	3
1151	Anthemis kotschyana var. poecilolepis Boiss.                                                                                                                                                                                                                   	Boiss.                                                                                                                          	Variety                                           	poecilolepis                                                                                                                                                                                                                                                   	Anthemis                                                                                                                                                                                                                                                       	kotschyana                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	poecilolepis                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Anthemis kotschyana var. poecilolepis                                                                                                                                                                                                                          	Nur im Bolkar und den Aladaglari. Gerald Bolkar                                                                                                                                                                                                                	End T                                                                                                                                                                                                                                                          	2
1152	Astragalus pelliger Fenzl                                                                                                                                                                                                                                      	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	pelliger                                                                                                                                                                                                                                                       	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus pelliger                                                                                                                                                                                                                                            	Nur im Bolkar und den Aladaglari. Gerald Bolkar                                                                                                                                                                                                                	End T                                                                                                                                                                                                                                                          	3
1153	Androsace multiscapa Duby                                                                                                                                                                                                                                      	Duby                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Androsace                                                                                                                                                                                                                                                      	multiscapa                                                                                                                                                                                                                                                     	Duby                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Androsace multiscapa                                                                                                                                                                                                                                           	Nur im Bolkar und den Aladaglari. Gerald Bolkar                                                                                                                                                                                                                	IA                                                                                                                                                                                                                                                             	3
1154	Arenaria uninervia McNeill                                                                                                                                                                                                                                     	McNeill                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	uninervia                                                                                                                                                                                                                                                      	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria uninervia                                                                                                                                                                                                                                             	Nur im Bolkar und den Aladaglari. Gerald Bolkar                                                                                                                                                                                                                	End A                                                                                                                                                                                                                                                          	2
1155	Scutellaria orientalis var. glandulosa                                                                                                                                                                                                                         	                                                                                                                                	Variety                                           	glandulosa                                                                                                                                                                                                                                                     	Scutellaria                                                                                                                                                                                                                                                    	orientalis                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	alpina                                                                                                                                                                                                                                                         	(Boiss.) O.Schwarz                                                                                                                                                                                                                                             	glandulosa                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria orientalis subsp. alpina var. glandulosa                                                                                                                                                                                                           	Gerlad Bolkar                                                                                                                                                                                                                                                  	EMed / IA                                                                                                                                                                                                                                                      	2
1156	Gnaphalium supinum L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Gnaphalium                                                                                                                                                                                                                                                     	supinum                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Omalotheca supina                                                                                                                                                                                                                                              	Gnaphalium supinum                                                                                                                                                                                                                                             	Gerald Bolkar,\nauch in europa (alpen?)                                                                                                                                                                                                                         	circ                                                                                                                                                                                                                                                           	3
1157	Cerastium cerastoides (L.) Britton                                                                                                                                                                                                                             	(L.) Britton                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Cerastium                                                                                                                                                                                                                                                      	cerastoides                                                                                                                                                                                                                                                    	(L.) Britton                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerastium cerastoides                                                                                                                                                                                                                                          	Gerald Bolkar                                                                                                                                                                                                                                                  	ES                                                                                                                                                                                                                                                             	2
1158	Alchemilla paracompactilis Ponert                                                                                                                                                                                                                              	Ponert                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alchemilla                                                                                                                                                                                                                                                     	paracompactilis                                                                                                                                                                                                                                                	Ponert                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alchemilla paracompactilis                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
1159	Veronica pusilla Kotschy                                                                                                                                                                                                                                       	Kotschy                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	pusilla                                                                                                                                                                                                                                                        	Kotschy                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica pusilla                                                                                                                                                                                                                                               	Gerald Bolkar                                                                                                                                                                                                                                                  	IA                                                                                                                                                                                                                                                             	5
1160	Botrychium lunaria (L.) Sw.                                                                                                                                                                                                                                    	(L.) Sw.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Botrychium                                                                                                                                                                                                                                                     	lunaria                                                                                                                                                                                                                                                        	(L.) Sw.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Botrychium lunaria                                                                                                                                                                                                                                             	Gerald Bolkar,\nganz europa, aber leher S und O                                                                                                                                                                                                                 	hol / Aus                                                                                                                                                                                                                                                      	4
1161	Ranunculus brachylobus subsp. incisilobatus P.H. Davis                                                                                                                                                                                                         	P.H. Davis                                                                                                                      	Subspecies                                        	incisilobatus                                                                                                                                                                                                                                                  	Ranunculus                                                                                                                                                                                                                                                     	brachylobus                                                                                                                                                                                                                                                    	Boiss. & Hohen.                                                                                                                                                                                                                                                	incisilobatus                                                                                                                                                                                                                                                  	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ranunculus brachylobus subsp. incisilobatus                                                                                                                                                                                                                    	Gerald Bolkar                                                                                                                                                                                                                                                  	IA                                                                                                                                                                                                                                                             	3
1162	Deschampsia caespitosa (L.) P.Beauv.                                                                                                                                                                                                                           	(L.) P.Beauv.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Deschampsia                                                                                                                                                                                                                                                    	caespitosa                                                                                                                                                                                                                                                     	(L.) P.Beauv.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Deschampsia caespitosa                                                                                                                                                                                                                                         	Gerald Bolkar                                                                                                                                                                                                                                                  	ES                                                                                                                                                                                                                                                             	3
1163	Gentiana orbicularis Schur                                                                                                                                                                                                                                     	Schur                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Gentiana                                                                                                                                                                                                                                                       	orbicularis                                                                                                                                                                                                                                                    	Schur                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gentiana orbicularis                                                                                                                                                                                                                                           	Gerald Bolkar                                                                                                                                                                                                                                                  	ES                                                                                                                                                                                                                                                             	3
1164	Thymus cherlerioides Vis.                                                                                                                                                                                                                                      	Vis.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Thymus                                                                                                                                                                                                                                                         	cherlerioides                                                                                                                                                                                                                                                  	Vis.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	T. hirsutus                                                                                                                                                                                                                                                    	Thymus cherlerioides                                                                                                                                                                                                                                           	mittlerer Taurus\nteilweise ehemals T.leucotrichus                                                                                                                                                                                                              	End T                                                                                                                                                                                                                                                          	2
1165	Scrophularia candelabrum Heywood                                                                                                                                                                                                                               	Heywood                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Scrophularia                                                                                                                                                                                                                                                   	candelabrum                                                                                                                                                                                                                                                    	Heywood                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scrophularia candelabrum                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
1166	Veronica cuneifolia subsp. massicytica M.A. Fischer                                                                                                                                                                                                            	M.A. Fischer                                                                                                                    	Subspecies                                        	massicytica                                                                                                                                                                                                                                                    	Veronica                                                                                                                                                                                                                                                       	cuneifolia                                                                                                                                                                                                                                                     	D.Don                                                                                                                                                                                                                                                          	massicytica                                                                                                                                                                                                                                                    	M.A. Fischer                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica cuneifolia subsp. massicytica                                                                                                                                                                                                                         	vom Akdag                                                                                                                                                                                                                                                      	End loc                                                                                                                                                                                                                                                        	2
1167	Salvia cf. chrysophylla Stapf                                                                                                                                                                                                                                  	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	cf. chrysophylla                                                                                                                                                                                                                                               	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia cf. chrysophylla                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
1169	Minuartia meyeri (Boiss.) Bornm.                                                                                                                                                                                                                               	(Boiss.) Bornm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	meyeri                                                                                                                                                                                                                                                         	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia meyeri                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
1170	Inula spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Inula                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Inula spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
2135	Centaurea reuterana var. phrygia Bornm.                                                                                                                                                                                                                        	Bornm.                                                                                                                          	Variety                                           	phrygia                                                                                                                                                                                                                                                        	Centaurea                                                                                                                                                                                                                                                      	reuterana                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	phrygia                                                                                                                                                                                                                                                        	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Centaurea reuterana var. phrygia                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
2137	Salix spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Salix                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salix spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
2138	Cichorium intybus L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Cichorium                                                                                                                                                                                                                                                      	intybus                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cichorium intybus                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	5
2140	Helichrysum armenium DC.                                                                                                                                                                                                                                       	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Helichrysum                                                                                                                                                                                                                                                    	armenium                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Helichrysum armenium                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	2
2141	Trigonella spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Trigonella                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trigonella spec.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
2142	Carex spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Carex                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carex spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
2143	Plantago maritima L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	maritima                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plantago maritima                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	3
2144	Clypeola ciliolata Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Clypeola                                                                                                                                                                                                                                                       	ciliolata                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Clypeola ciliolata                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	5
2146	Asperula arvensis L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Asperula                                                                                                                                                                                                                                                       	arvensis                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula arvensis                                                                                                                                                                                                                                              	Özkan                                                                                                                                                                                                                                                          	Med / IA                                                                                                                                                                                                                                                       	2
2147	Bromus cappadocicus Boiss. & Balansa                                                                                                                                                                                                                           	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	cappadocicus                                                                                                                                                                                                                                                   	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus cappadocicus                                                                                                                                                                                                                                            	Özkan                                                                                                                                                                                                                                                          	ES / IA                                                                                                                                                                                                                                                        	3
2148	Sternbergia colchiciflora Waldst. & Kit.                                                                                                                                                                                                                       	Waldst. & Kit.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Sternbergia                                                                                                                                                                                                                                                    	colchiciflora                                                                                                                                                                                                                                                  	Waldst. & Kit.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sternbergia colchiciflora                                                                                                                                                                                                                                      	Özkan                                                                                                                                                                                                                                                          	ES / Med / IA                                                                                                                                                                                                                                                  	4
2149	Eremurus spectabilis M.Bieb.                                                                                                                                                                                                                                   	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Eremurus                                                                                                                                                                                                                                                       	spectabilis                                                                                                                                                                                                                                                    	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eremurus spectabilis                                                                                                                                                                                                                                           	Özkan                                                                                                                                                                                                                                                          	IrTur                                                                                                                                                                                                                                                          	4
2150	Achillea spinulifolia Fenzl ex Boiss.                                                                                                                                                                                                                          	Fenzl ex Boiss.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	spinulifolia                                                                                                                                                                                                                                                   	Fenzl ex Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea spinulifolia                                                                                                                                                                                                                                          	Özkan                                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
2151	Tanacetum cadmeum subsp. cadmeum                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	cadmeum                                                                                                                                                                                                                                                        	Tanacetum                                                                                                                                                                                                                                                      	cadmeum                                                                                                                                                                                                                                                        	(Boiss.) Heywood                                                                                                                                                                                                                                               	cadmeum                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum cadmeum subsp. cadmeum                                                                                                                                                                                                                               	Özkan                                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
2152	Orobanche arenaria M.Bieb.                                                                                                                                                                                                                                     	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	arenaria                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche arenaria                                                                                                                                                                                                                                             	Özkan                                                                                                                                                                                                                                                          	ES / IA                                                                                                                                                                                                                                                        	4
2153	Linum bienne Mill.                                                                                                                                                                                                                                             	Mill.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	bienne                                                                                                                                                                                                                                                         	Mill.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum bienne                                                                                                                                                                                                                                                   	Özkan                                                                                                                                                                                                                                                          	Med / ES / IA                                                                                                                                                                                                                                                  	2
2154	Origanum minutiflorum O.Schwartz & P.H.Davis                                                                                                                                                                                                                   	O.Schwartz & P.H.Davis                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Origanum                                                                                                                                                                                                                                                       	minutiflorum                                                                                                                                                                                                                                                   	O.Schwartz & P.H.Davis                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Origanum minutiflorum                                                                                                                                                                                                                                          	Özkan                                                                                                                                                                                                                                                          	End T                                                                                                                                                                                                                                                          	2
2155	Amelanchier parviflora subsp. dentata Browicz                                                                                                                                                                                                                  	Browicz                                                                                                                         	Subspecies                                        	dentata                                                                                                                                                                                                                                                        	Amelanchier                                                                                                                                                                                                                                                    	parviflora                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	dentata                                                                                                                                                                                                                                                        	Browicz                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Amelanchier parviflora subsp. dentata                                                                                                                                                                                                                          	Özkan                                                                                                                                                                                                                                                          	End T                                                                                                                                                                                                                                                          	6
2156	Sedum subulatum (C.A.Meyer) Boiss.                                                                                                                                                                                                                             	(C.A.Meyer) Boiss.                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	subulatum                                                                                                                                                                                                                                                      	(C.A.Meyer) Boiss.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum subulatum                                                                                                                                                                                                                                                	Özkan                                                                                                                                                                                                                                                          	Eux / Hyrc                                                                                                                                                                                                                                                     	2
2157	Lonicera nummulariifolia subsp. glandulifera                                                                                                                                                                                                                   	                                                                                                                                	Subspecies                                        	glandulifera                                                                                                                                                                                                                                                   	Lonicera                                                                                                                                                                                                                                                       	nummulariifolia                                                                                                                                                                                                                                                	Jaub. & Spach.                                                                                                                                                                                                                                                 	glandulifera                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lonicera nummulariifolia subsp. glandulifera                                                                                                                                                                                                                   	Özkan                                                                                                                                                                                                                                                          	End BT                                                                                                                                                                                                                                                         	2
2158	Tulipa aganensis DC.                                                                                                                                                                                                                                           	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Tulipa                                                                                                                                                                                                                                                         	aganensis                                                                                                                                                                                                                                                      	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tulipa aganensis                                                                                                                                                                                                                                               	Özkan                                                                                                                                                                                                                                                          	EMed / IA                                                                                                                                                                                                                                                      	4
2161	Verbascum cheiranthifolium var. heldreichii Boiss.                                                                                                                                                                                                             	Boiss.                                                                                                                          	Variety                                           	heldreichii                                                                                                                                                                                                                                                    	Verbascum                                                                                                                                                                                                                                                      	cheiranthifolium                                                                                                                                                                                                                                               	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	heldreichii                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Verbascum cheiranthifolium var. heldreichii                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
2162	Barbarea minor var. anfractuosa Hartvig & Strid                                                                                                                                                                                                                	Hartvig & Strid                                                                                                                 	Variety                                           	anfractuosa                                                                                                                                                                                                                                                    	Barbarea                                                                                                                                                                                                                                                       	minor                                                                                                                                                                                                                                                          	C.Koch                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	anfractuosa                                                                                                                                                                                                                                                    	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Barbarea minor var. anfractuosa                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
2163	Salvia microstegia Boiss. & Balansa                                                                                                                                                                                                                            	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	microstegia                                                                                                                                                                                                                                                    	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia microstegia                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
2164	Alopecurus gerardii Vill.                                                                                                                                                                                                                                      	Vill.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Alopecurus                                                                                                                                                                                                                                                     	gerardii                                                                                                                                                                                                                                                       	Vill.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alopecurus gerardii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
2500	Silene ispartensis Ghazanfar                                                                                                                                                                                                                                   	Ghazanfar                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	ispartensis                                                                                                                                                                                                                                                    	Ghazanfar                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene ispartensis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
2501	Astragalus podperae                                                                                                                                                                                                                                            	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	podperae                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	A.condensatus                                                                                                                                                                                                                                                  	Astragalus podperae                                                                                                                                                                                                                                            	mit A.condensatus vereint !\ngibts nicht mehr.                                                                                                                                                                                                                  	Unknown                                                                                                                                                                                                                                                        	2
111	Arabis androsacea Fenzl                                                                                                                                                                                                                                        	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Arabis                                                                                                                                                                                                                                                         	androsacea                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arabis androsacea                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
113	Arabis nova Vill.                                                                                                                                                                                                                                              	Vill.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Arabis                                                                                                                                                                                                                                                         	nova                                                                                                                                                                                                                                                           	Vill.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arabis nova                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
114	Erysimum kotschyanum Gay                                                                                                                                                                                                                                       	Gay                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	kotschyanum                                                                                                                                                                                                                                                    	Gay                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum kotschyanum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
115	Erysimum pallidum Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	pallidum                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum pallidum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
116	Aubrieta deltoidea (L.) DC.                                                                                                                                                                                                                                    	(L.) DC.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Aubrieta                                                                                                                                                                                                                                                       	deltoidea                                                                                                                                                                                                                                                      	(L.) DC.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aubrieta deltoidea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
117	Aubrieta canescens subsp. canescens                                                                                                                                                                                                                            	                                                                                                                                	Subspecies                                        	canescens                                                                                                                                                                                                                                                      	Aubrieta                                                                                                                                                                                                                                                       	canescens                                                                                                                                                                                                                                                      	(Boiss.) Bornm.                                                                                                                                                                                                                                                	canescens                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aubrieta canescens subsp. canescens                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
119	Draba bruniifolia var. nana (Stapf) Schulz                                                                                                                                                                                                                     	(Stapf) Schulz                                                                                                                  	Variety                                           	nana                                                                                                                                                                                                                                                           	Draba                                                                                                                                                                                                                                                          	bruniifolia                                                                                                                                                                                                                                                    	Stev.                                                                                                                                                                                                                                                          	heterocoma                                                                                                                                                                                                                                                     	(Fenzl) Coode & Cullen                                                                                                                                                                                                                                         	nana                                                                                                                                                                                                                                                           	(Stapf) Schulz                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	Draba bruniifolia subsp. heterocoma var. nana                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
120	Draba bruniifolia subsp. bruniifolia                                                                                                                                                                                                                           	                                                                                                                                	Subspecies                                        	bruniifolia                                                                                                                                                                                                                                                    	Draba                                                                                                                                                                                                                                                          	bruniifolia                                                                                                                                                                                                                                                    	Stev.                                                                                                                                                                                                                                                          	bruniifolia                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Draba bruniifolia subsp. bruniifolia                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
121	Androsace villosa L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Androsace                                                                                                                                                                                                                                                      	villosa                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Androsace villosa                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
122	Alyssum corsicum Duby                                                                                                                                                                                                                                          	Duby                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	corsicum                                                                                                                                                                                                                                                       	Duby                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum corsicum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
123	Alyssum aurantiacum Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	aurantiacum                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum aurantiacum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
124	Alyssum masmenaeum Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	masmenaeum                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum masmenaeum                                                                                                                                                                                                                                             	evtl = A.masmeanu ???                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
125	Alyssum erosulum Clementi                                                                                                                                                                                                                                      	Clementi                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	erosulum                                                                                                                                                                                                                                                       	Clementi                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum erosulum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
126	Alyssum simplex var. minus                                                                                                                                                                                                                                     	                                                                                                                                	Variety                                           	minus                                                                                                                                                                                                                                                          	Alyssum                                                                                                                                                                                                                                                        	simplex                                                                                                                                                                                                                                                        	Rudolphi                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	minus                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	A.minus (L.)Rothm. var minus                                                                                                                                                                                                                                   	Alyssum simplex var. minus                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	2
127	Alyssum argyrophyllum Schott & Kotschy                                                                                                                                                                                                                         	Schott & Kotschy                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	argyrophyllum                                                                                                                                                                                                                                                  	Schott & Kotschy                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum argyrophyllum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
128	Alyssum spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
129	Alyssum condensatum subsp. condensatum                                                                                                                                                                                                                         	                                                                                                                                	Subspecies                                        	condensatum                                                                                                                                                                                                                                                    	Alyssum                                                                                                                                                                                                                                                        	condensatum                                                                                                                                                                                                                                                    	Boiss. & Hausskn.                                                                                                                                                                                                                                              	condensatum                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum condensatum subsp. condensatum                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
130	Alyssum pateri subsp. pateri                                                                                                                                                                                                                                   	                                                                                                                                	Subspecies                                        	pateri                                                                                                                                                                                                                                                         	Alyssum                                                                                                                                                                                                                                                        	pateri                                                                                                                                                                                                                                                         	Nyár                                                                                                                                                                                                                                                           	pateri                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum pateri subsp. pateri                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
131	Hesperis spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Hesperis                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hesperis spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
132	Alyssum alyssoides (L.) L.                                                                                                                                                                                                                                     	(L.) L.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	alyssoides                                                                                                                                                                                                                                                     	(L.) L.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum alyssoides                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	5
133	Alyssum strigosum subsp. strigosum                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	strigosum                                                                                                                                                                                                                                                      	Alyssum                                                                                                                                                                                                                                                        	strigosum                                                                                                                                                                                                                                                      	Banks & Sol.                                                                                                                                                                                                                                                   	strigosum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum strigosum subsp. strigosum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
134	Anchonium elichrysifolium subsp. elichrysifolium                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	elichrysifolium                                                                                                                                                                                                                                                	Anchonium                                                                                                                                                                                                                                                      	elichrysifolium                                                                                                                                                                                                                                                	(DC.) Boiss.                                                                                                                                                                                                                                                   	elichrysifolium                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anchonium elichrysifolium subsp. elichrysifolium                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
135	Erysimum pycnophyllum Gay                                                                                                                                                                                                                                      	Gay                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	pycnophyllum                                                                                                                                                                                                                                                   	Gay                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	E.thyrsoideum Boiss. ssp thyrsoideum                                                                                                                                                                                                                           	Erysimum pycnophyllum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
136	Papaver pilosum subsp. pilosum                                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	pilosum                                                                                                                                                                                                                                                        	Papaver                                                                                                                                                                                                                                                        	pilosum                                                                                                                                                                                                                                                        	Sm.                                                                                                                                                                                                                                                            	pilosum                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P.apokrinomenon Fedde                                                                                                                                                                                                                                          	Papaver pilosum subsp. pilosum                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
137	Papaver polychaetum Schott & Kotschy                                                                                                                                                                                                                           	Schott & Kotschy                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Papaver                                                                                                                                                                                                                                                        	polychaetum                                                                                                                                                                                                                                                    	Schott & Kotschy                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Papaver polychaetum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
138	Fumaria parviflora Lam.                                                                                                                                                                                                                                        	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Fumaria                                                                                                                                                                                                                                                        	parviflora                                                                                                                                                                                                                                                     	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fumaria parviflora                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / ES / IrTur                                                                                                                                                                                                                                               	5
139	Papaver persicum Lindl.                                                                                                                                                                                                                                        	Lindl.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Papaver                                                                                                                                                                                                                                                        	persicum                                                                                                                                                                                                                                                       	Lindl.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P. tauricola Boiss.                                                                                                                                                                                                                                            	Papaver persicum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
140	Corydalis erdelii Zucc.                                                                                                                                                                                                                                        	Zucc.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Corydalis                                                                                                                                                                                                                                                      	erdelii                                                                                                                                                                                                                                                        	Zucc.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Corydalis rutifolia (Sibth. & Sm.) DC. subsp. erdelii (Zucc.) Cullen & P.H. Davis                                                                                                                                                                              	Corydalis erdelii                                                                                                                                                                                                                                              	Nr 105 auch mitbestimmt, aber nicht in deckungen und doppelt bestimmt.                                                                                                                                                                                         	EMed / IA                                                                                                                                                                                                                                                      	4
141	Corydalis cf. erdelii Zucc.                                                                                                                                                                                                                                    	Zucc.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Corydalis                                                                                                                                                                                                                                                      	cf. erdelii                                                                                                                                                                                                                                                    	Zucc.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Corydalis cf. rutifolia (Sibth. & Sm.) DC. subsp. erdelii (Zucc.) Cullen & P.H. Davis                                                                                                                                                                          	Corydalis cf. erdelii                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
142	Polygala anatolica Boiss. & Heldr.                                                                                                                                                                                                                             	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Polygala                                                                                                                                                                                                                                                       	anatolica                                                                                                                                                                                                                                                      	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygala anatolica                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
143	Polygala pruinosa subsp. megaptera Cullen                                                                                                                                                                                                                      	Cullen                                                                                                                          	Subspecies                                        	megaptera                                                                                                                                                                                                                                                      	Polygala                                                                                                                                                                                                                                                       	pruinosa                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	megaptera                                                                                                                                                                                                                                                      	Cullen                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygala pruinosa subsp. megaptera                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
144	Daphne oleoides subsp. oleoides                                                                                                                                                                                                                                	                                                                                                                                	Subspecies                                        	oleoides                                                                                                                                                                                                                                                       	Daphne                                                                                                                                                                                                                                                         	oleoides                                                                                                                                                                                                                                                       	Schreb.                                                                                                                                                                                                                                                        	oleoides                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Daphne oleoides subsp. oleoides                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	2
145	Viola sandrasea Melch.                                                                                                                                                                                                                                         	Melch.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Viola                                                                                                                                                                                                                                                          	sandrasea                                                                                                                                                                                                                                                      	Melch.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Viola sandrasea                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
146	Viola heldreichiana Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Viola                                                                                                                                                                                                                                                          	heldreichiana                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Viola heldreichiana                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	5
147	Helianthemum oelandicum subsp. canum (L.) Bonnier                                                                                                                                                                                                              	(L.) Bonnier                                                                                                                    	Subspecies                                        	canum                                                                                                                                                                                                                                                          	Helianthemum                                                                                                                                                                                                                                                   	oelandicum                                                                                                                                                                                                                                                     	(L.) DC.                                                                                                                                                                                                                                                       	canum                                                                                                                                                                                                                                                          	(L.) Bonnier                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	H.canum (L.) Baumg.                                                                                                                                                                                                                                            	Helianthemum oelandicum subsp. canum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
148	Cyclotrichium origanifolium (Labill.) Manden & Scheng.                                                                                                                                                                                                         	(Labill.) Manden & Scheng.                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Cyclotrichium                                                                                                                                                                                                                                                  	origanifolium                                                                                                                                                                                                                                                  	(Labill.) Manden & Scheng.                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cyclotrichium origanifolium                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
149	Dorystaechas hastata Boiss. & Heldr.                                                                                                                                                                                                                           	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Dorystaechas                                                                                                                                                                                                                                                   	hastata                                                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dorystaechas hastata                                                                                                                                                                                                                                           	gattungsendemit                                                                                                                                                                                                                                                	End loc                                                                                                                                                                                                                                                        	2
151	Stachys iberica var. densipilosa Bhattacharjee                                                                                                                                                                                                                 	Bhattacharjee                                                                                                                   	Variety                                           	densipilosa                                                                                                                                                                                                                                                    	Stachys                                                                                                                                                                                                                                                        	iberica                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	iberica                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	densipilosa                                                                                                                                                                                                                                                    	Bhattacharjee                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Stachys iberica subsp. iberica var. densipilosa                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
152	Stachys cretica s.l. L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Stachys                                                                                                                                                                                                                                                        	cretica s.l.                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys cretica s.l.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
153	Stachys citrina subsp. citrina                                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	citrina                                                                                                                                                                                                                                                        	Stachys                                                                                                                                                                                                                                                        	citrina                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	citrina                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys citrina subsp. citrina                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
155	Nepeta betonicifolia C.A.Mey.                                                                                                                                                                                                                                  	C.A.Mey.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	betonicifolia                                                                                                                                                                                                                                                  	C.A.Mey.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta betonicifolia                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
156	Nepeta nuda subsp. albiflora (Boiss.) Gams                                                                                                                                                                                                                     	(Boiss.) Gams                                                                                                                   	Subspecies                                        	albiflora                                                                                                                                                                                                                                                      	Nepeta                                                                                                                                                                                                                                                         	nuda                                                                                                                                                                                                                                                           	L.                                                                                                                                                                                                                                                             	albiflora                                                                                                                                                                                                                                                      	(Boiss.) Gams                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta nuda subsp. albiflora                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	ES / IA / EMed                                                                                                                                                                                                                                                 	3
158	Ballota acetabulosa (L.) Benth.                                                                                                                                                                                                                                	(L.) Benth.                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Ballota                                                                                                                                                                                                                                                        	acetabulosa                                                                                                                                                                                                                                                    	(L.) Benth.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ballota acetabulosa                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
159	Nepeta cilicia Boiss & Heldr.                                                                                                                                                                                                                                  	Boiss & Heldr.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	cilicia                                                                                                                                                                                                                                                        	Boiss & Heldr.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta cilicia                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
160	Sideritis aff. phlomoides P.H.Davis & Hub.-Mor.                                                                                                                                                                                                                	P.H.Davis & Hub.-Mor.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	aff. phlomoides                                                                                                                                                                                                                                                	P.H.Davis & Hub.-Mor.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	= S. aff. congesta                                                                                                                                                                                                                                             	Sideritis aff. phlomoides                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
161	Sideritis libanotica subsp. linearis (Benth.) Bornm.                                                                                                                                                                                                           	(Benth.) Bornm.                                                                                                                 	Subspecies                                        	linearis                                                                                                                                                                                                                                                       	Sideritis                                                                                                                                                                                                                                                      	libanotica                                                                                                                                                                                                                                                     	Labill.                                                                                                                                                                                                                                                        	linearis                                                                                                                                                                                                                                                       	(Benth.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis libanotica subsp. linearis                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
162	Sideritis pisidica Boiss. & Heldr.                                                                                                                                                                                                                             	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	pisidica                                                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis pisidica                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
163	Sideritis libanotica Labill.                                                                                                                                                                                                                                   	Labill.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	libanotica                                                                                                                                                                                                                                                     	Labill.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis libanotica                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
164	Teucrium chamaedrys subsp. tauricola Rech. f.                                                                                                                                                                                                                  	Rech. f.                                                                                                                        	Subspecies                                        	tauricola                                                                                                                                                                                                                                                      	Teucrium                                                                                                                                                                                                                                                       	chamaedrys                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	tauricola                                                                                                                                                                                                                                                      	Rech. f.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium chamaedrys subsp. tauricola                                                                                                                                                                                                                           	1556 im Pontus ? eher ssp. trapezunticum                                                                                                                                                                                                                       	End A                                                                                                                                                                                                                                                          	2
165	Teucrium chamaedrys subsp. syspirense (C.Koch) Rech.f.                                                                                                                                                                                                         	(C.Koch) Rech.f.                                                                                                                	Subspecies                                        	syspirense                                                                                                                                                                                                                                                     	Teucrium                                                                                                                                                                                                                                                       	chamaedrys                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	syspirense                                                                                                                                                                                                                                                     	(C.Koch) Rech.f.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium chamaedrys subsp. syspirense                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
166	Teucrium chamaedrys subsp. chamaedrys                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	chamaedrys                                                                                                                                                                                                                                                     	Teucrium                                                                                                                                                                                                                                                       	chamaedrys                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	chamaedrys                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium chamaedrys subsp. chamaedrys                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
167	Teucrium chamaedrys s.l. L.                                                                                                                                                                                                                                    	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Teucrium                                                                                                                                                                                                                                                       	chamaedrys s.l.                                                                                                                                                                                                                                                	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium chamaedrys s.l.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	ES / EMed / IA                                                                                                                                                                                                                                                 	2
168	Teucrium polium s.l. L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Teucrium                                                                                                                                                                                                                                                       	polium s.l.                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium polium s.l.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
169	Teucrium montanum var. parnassicum Celak                                                                                                                                                                                                                       	Celak                                                                                                                           	Variety                                           	parnassicum                                                                                                                                                                                                                                                    	Teucrium                                                                                                                                                                                                                                                       	montanum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	parnassicum                                                                                                                                                                                                                                                    	Celak                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Teucrium montanum var. parnassicum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
170	Teucrium orientale var. orientale                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	orientale                                                                                                                                                                                                                                                      	Teucrium                                                                                                                                                                                                                                                       	orientale                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	orientale                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium orientale var. orientale                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
171	Teucrium sandrasicum O.Schwarz                                                                                                                                                                                                                                 	O.Schwarz                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Teucrium                                                                                                                                                                                                                                                       	sandrasicum                                                                                                                                                                                                                                                    	O.Schwarz                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium sandrasicum                                                                                                                                                                                                                                           	sandras dag                                                                                                                                                                                                                                                    	End loc                                                                                                                                                                                                                                                        	3
173	Scutellaria orientalis var. alpina                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	alpina                                                                                                                                                                                                                                                         	Scutellaria                                                                                                                                                                                                                                                    	orientalis                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	alpina                                                                                                                                                                                                                                                         	(Boiss.) O.Schwarz                                                                                                                                                                                                                                             	alpina                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria orientalis subsp. alpina var. alpina                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
174	Scutellaria salviifolia Benth.                                                                                                                                                                                                                                 	Benth.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scutellaria                                                                                                                                                                                                                                                    	salviifolia                                                                                                                                                                                                                                                    	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria salviifolia                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
175	Scutellaria brevibracteata Stapf                                                                                                                                                                                                                               	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Scutellaria                                                                                                                                                                                                                                                    	brevibracteata                                                                                                                                                                                                                                                 	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria rubicunda Homem. subsp. brevibracteata (Stapf) Edmondson                                                                                                                                                                                           	Scutellaria brevibracteata                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
176	Ajuga chamaepitys subsp. cuneatifolia (Stapf) P.H. Davis                                                                                                                                                                                                       	(Stapf) P.H. Davis                                                                                                              	Subspecies                                        	cuneatifolia                                                                                                                                                                                                                                                   	Ajuga                                                                                                                                                                                                                                                          	chamaepitys                                                                                                                                                                                                                                                    	(L.) Schreb.                                                                                                                                                                                                                                                   	cuneatifolia                                                                                                                                                                                                                                                   	(Stapf) P.H. Davis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ajuga chamaepitys subsp. cuneatifolia                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
177	Ajuga vestita Boiss.                                                                                                                                                                                                                                           	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Ajuga                                                                                                                                                                                                                                                          	vestita                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ajuga vestita                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
178	Phlomis armeniaca Willd.                                                                                                                                                                                                                                       	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Phlomis                                                                                                                                                                                                                                                        	armeniaca                                                                                                                                                                                                                                                      	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Phlomis armeniaca                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
179	Phlomis capitata Boiss.                                                                                                                                                                                                                                        	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Phlomis                                                                                                                                                                                                                                                        	capitata                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Phlomis capitata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
180	Phlomis grandiflora var. grandiflora                                                                                                                                                                                                                           	                                                                                                                                	Variety                                           	grandiflora                                                                                                                                                                                                                                                    	Phlomis                                                                                                                                                                                                                                                        	grandiflora                                                                                                                                                                                                                                                    	H.S.Thomps.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	grandiflora                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Phlomis grandiflora var. grandiflora                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	6
181	Sideritis phlomoides Boiss. & Balansa                                                                                                                                                                                                                          	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	phlomoides                                                                                                                                                                                                                                                     	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis phlomoides                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	2
182	Satureja spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Satureja                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Satureja spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
183	Thymus leucotrichus var. leucotrichus                                                                                                                                                                                                                          	                                                                                                                                	Variety                                           	leucotrichus                                                                                                                                                                                                                                                   	Thymus                                                                                                                                                                                                                                                         	leucotrichus                                                                                                                                                                                                                                                   	Hal.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	leucotrichus                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus leucotrichus var. leucotrichus                                                                                                                                                                                                                          	im westen zu T.cherlerioides\nim Osten zu T.brachychilus gemacht -> Gerald                                                                                                                                                                                      	EMed                                                                                                                                                                                                                                                           	2
184	Thymus sipyleus var. davisianus Ronniger                                                                                                                                                                                                                       	Ronniger                                                                                                                        	Variety                                           	davisianus                                                                                                                                                                                                                                                     	Thymus                                                                                                                                                                                                                                                         	sipyleus                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	sipyleus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	davisianus                                                                                                                                                                                                                                                     	Ronniger                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Thymus sipyleus subsp. sipyleus var. davisianus                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
185	Thymus sipyleus var. sipyleus                                                                                                                                                                                                                                  	                                                                                                                                	Variety                                           	sipyleus                                                                                                                                                                                                                                                       	Thymus                                                                                                                                                                                                                                                         	sipyleus                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	sipyleus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	sipyleus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus sipyleus subsp. sipyleus var. sipyleus                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
186	Thymus longicaulis var. alternatus Jalas                                                                                                                                                                                                                       	Jalas                                                                                                                           	Variety                                           	alternatus                                                                                                                                                                                                                                                     	Thymus                                                                                                                                                                                                                                                         	longicaulis                                                                                                                                                                                                                                                    	C.Presl                                                                                                                                                                                                                                                        	chaubardii                                                                                                                                                                                                                                                     	(Rchb.f..) Jalas                                                                                                                                                                                                                                               	alternatus                                                                                                                                                                                                                                                     	Jalas                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Thymus longicaulis subsp. chaubardii var. alternatus                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
187	Thymus longicaulis var. longicaulis                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	longicaulis                                                                                                                                                                                                                                                    	Thymus                                                                                                                                                                                                                                                         	longicaulis                                                                                                                                                                                                                                                    	C.Presl                                                                                                                                                                                                                                                        	longicaulis                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	longicaulis                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus longicaulis subsp. longicaulis var. longicaulis                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	2
188	Ziziphora clinopodioides Lam.                                                                                                                                                                                                                                  	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Ziziphora                                                                                                                                                                                                                                                      	clinopodioides                                                                                                                                                                                                                                                 	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ziziphora clinopodioides                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
189	Marrubium astracanicum subsp. macrodon (Bornm.) P.H.Davis                                                                                                                                                                                                      	(Bornm.) P.H.Davis                                                                                                              	Subspecies                                        	macrodon                                                                                                                                                                                                                                                       	Marrubium                                                                                                                                                                                                                                                      	astracanicum                                                                                                                                                                                                                                                   	Jacq.                                                                                                                                                                                                                                                          	macrodon                                                                                                                                                                                                                                                       	(Bornm.) P.H.Davis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium astracanicum subsp. macrodon                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
190	Marrubium globosum subsp. globosum                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	globosum                                                                                                                                                                                                                                                       	Marrubium                                                                                                                                                                                                                                                      	globosum                                                                                                                                                                                                                                                       	Benth.                                                                                                                                                                                                                                                         	globosum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium globosum subsp. globosum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
191	Marrubium cephalanthum Boiss. & Noe                                                                                                                                                                                                                            	Boiss. & Noe                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	cephalanthum                                                                                                                                                                                                                                                   	Boiss. & Noe                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium cephalanthum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
192	Marrubium globosum subsp. micranthum (Boiss. & Heldr.) P.H.Davis                                                                                                                                                                                               	(Boiss. & Heldr.) P.H.Davis                                                                                                     	Subspecies                                        	micranthum                                                                                                                                                                                                                                                     	Marrubium                                                                                                                                                                                                                                                      	globosum                                                                                                                                                                                                                                                       	Benth.                                                                                                                                                                                                                                                         	micranthum                                                                                                                                                                                                                                                     	(Boiss. & Heldr.) P.H.Davis                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium globosum subsp. micranthum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
193	Marrubium parviflorum subsp. oligodon (Boiss.) Seybold                                                                                                                                                                                                         	(Boiss.) Seybold                                                                                                                	Subspecies                                        	oligodon                                                                                                                                                                                                                                                       	Marrubium                                                                                                                                                                                                                                                      	parviflorum                                                                                                                                                                                                                                                    	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	oligodon                                                                                                                                                                                                                                                       	(Boiss.) Seybold                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium parviflorum subsp. oligodon                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
194	Marrubium heterodon (Benth.) Boiss. & Balansa                                                                                                                                                                                                                  	(Benth.) Boiss. & Balansa                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	heterodon                                                                                                                                                                                                                                                      	(Benth.) Boiss. & Balansa                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium heterodon                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
195	Marrubium bourgaei subsp. bourgaei                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	bourgaei                                                                                                                                                                                                                                                       	Marrubium                                                                                                                                                                                                                                                      	bourgaei                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	bourgaei                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium bourgaei subsp. bourgaei                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
196	Lamium garganicum subsp. reniforme (Benth.) R.B.Mill                                                                                                                                                                                                           	(Benth.) R.B.Mill                                                                                                               	Subspecies                                        	reniforme                                                                                                                                                                                                                                                      	Lamium                                                                                                                                                                                                                                                         	garganicum                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	reniforme                                                                                                                                                                                                                                                      	(Benth.) R.B.Mill                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lamium garganicum subsp. reniforme                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
197	Salvia pisidica Benth.                                                                                                                                                                                                                                         	Benth.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	pisidica                                                                                                                                                                                                                                                       	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia pisidica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
198	Salvia argentea L.                                                                                                                                                                                                                                             	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	argentea                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia argentea                                                                                                                                                                                                                                                	= Darkos salvia                                                                                                                                                                                                                                                	Med                                                                                                                                                                                                                                                            	2
199	Salvia multicaulis Vahl                                                                                                                                                                                                                                        	Vahl                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	multicaulis                                                                                                                                                                                                                                                    	Vahl                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia multicaulis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	2
200	Salvia cadmica Boiss.                                                                                                                                                                                                                                          	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	cadmica                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia cadmica                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
201	Salvia absconditiflora Greuter & Burdet                                                                                                                                                                                                                        	Greuter & Burdet                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	absconditiflora                                                                                                                                                                                                                                                	Greuter & Burdet                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia cryptantha Montbret & Aucher ex Bentham                                                                                                                                                                                                                 	Salvia absconditiflora                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
202	Salvia verticillata subsp. verticillata                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	verticillata                                                                                                                                                                                                                                                   	Salvia                                                                                                                                                                                                                                                         	verticillata                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	verticillata                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia verticillata subsp. verticillata                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
203	Globularia trichosantha J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                  	J.C.Fisch. & C.A.Mey.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Globularia                                                                                                                                                                                                                                                     	trichosantha                                                                                                                                                                                                                                                   	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Globularia trichosantha                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
204	Thesium procumbens C.A.Meyer                                                                                                                                                                                                                                   	C.A.Meyer                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Thesium                                                                                                                                                                                                                                                        	procumbens                                                                                                                                                                                                                                                     	C.A.Meyer                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thesium procumbens                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	2
205	Thesium cilicicum Bornm.                                                                                                                                                                                                                                       	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Thesium                                                                                                                                                                                                                                                        	cilicicum                                                                                                                                                                                                                                                      	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thesium cilicicum                                                                                                                                                                                                                                              	Nur im Bolkar und den Aladaglari. AC !                                                                                                                                                                                                                         	End A                                                                                                                                                                                                                                                          	2
206	Thesium arvense Horv.                                                                                                                                                                                                                                          	Horv.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Thesium                                                                                                                                                                                                                                                        	arvense                                                                                                                                                                                                                                                        	Horv.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thesium arvense                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
207	Cuscuta approximata var. approximata                                                                                                                                                                                                                           	                                                                                                                                	Variety                                           	approximata                                                                                                                                                                                                                                                    	Cuscuta                                                                                                                                                                                                                                                        	approximata                                                                                                                                                                                                                                                    	Bab.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	approximata                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cuscuta approximata var. approximata                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
208	Cuscuta palaestina subsp. balansae (Yunck.) Plitmann                                                                                                                                                                                                           	(Yunck.) Plitmann                                                                                                               	Subspecies                                        	balansae                                                                                                                                                                                                                                                       	Cuscuta                                                                                                                                                                                                                                                        	palaestina                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	balansae                                                                                                                                                                                                                                                       	(Yunck.) Plitmann                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cuscuta palaestina subsp. balansae                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
209	Michauxia tchihatcheffii J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                 	J.C.Fisch. & C.A.Mey.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Michauxia                                                                                                                                                                                                                                                      	tchihatcheffii                                                                                                                                                                                                                                                 	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Michauxia tchihatcheffii                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
210	Asyneuma linifolium subsp. linifolium                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	linifolium                                                                                                                                                                                                                                                     	Asyneuma                                                                                                                                                                                                                                                       	linifolium                                                                                                                                                                                                                                                     	(Boiss. & Heldr.) Bornm.                                                                                                                                                                                                                                       	linifolium                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma linifolium subsp. linifolium                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
211	Asyneuma limonifolium subsp. pestalozzae (Boiss.) Damboldt                                                                                                                                                                                                     	(Boiss.) Damboldt                                                                                                               	Subspecies                                        	pestalozzae                                                                                                                                                                                                                                                    	Asyneuma                                                                                                                                                                                                                                                       	limonifolium                                                                                                                                                                                                                                                   	(L.) Janch.                                                                                                                                                                                                                                                    	pestalozzae                                                                                                                                                                                                                                                    	(Boiss.) Damboldt                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma limonifolium subsp. pestalozzae                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
212	Asyneuma limonifolium subsp. limonifolium                                                                                                                                                                                                                      	                                                                                                                                	Subspecies                                        	limonifolium                                                                                                                                                                                                                                                   	Asyneuma                                                                                                                                                                                                                                                       	limonifolium                                                                                                                                                                                                                                                   	(L.) Janch.                                                                                                                                                                                                                                                    	limonifolium                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma limonifolium subsp. limonifolium                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	3
213	Asyneuma virgatum subsp. cichoriiforme (Boiss.) Damboldt                                                                                                                                                                                                       	(Boiss.) Damboldt                                                                                                               	Subspecies                                        	cichoriiforme                                                                                                                                                                                                                                                  	Asyneuma                                                                                                                                                                                                                                                       	virgatum                                                                                                                                                                                                                                                       	(Labill.) Bornm.                                                                                                                                                                                                                                               	cichoriiforme                                                                                                                                                                                                                                                  	(Boiss.) Damboldt                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma virgatum subsp. cichoriiforme                                                                                                                                                                                                                         	evtl OC                                                                                                                                                                                                                                                        	End A                                                                                                                                                                                                                                                          	3
214	Asyneuma lobelioides (Willd.) Hand.-Mazz.                                                                                                                                                                                                                      	(Willd.) Hand.-Mazz.                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Asyneuma                                                                                                                                                                                                                                                       	lobelioides                                                                                                                                                                                                                                                    	(Willd.) Hand.-Mazz.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma lobelioides                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
215	Asyneuma rigidum subsp. rigidum                                                                                                                                                                                                                                	                                                                                                                                	Subspecies                                        	rigidum                                                                                                                                                                                                                                                        	Asyneuma                                                                                                                                                                                                                                                       	rigidum                                                                                                                                                                                                                                                        	(Willd.) Grossh.                                                                                                                                                                                                                                               	rigidum                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma rigidum subsp. rigidum                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
216	Asyneuma rigidum subsp. sibthorpianum (Schult.) Damboldt                                                                                                                                                                                                       	(Schult.) Damboldt                                                                                                              	Subspecies                                        	sibthorpianum                                                                                                                                                                                                                                                  	Asyneuma                                                                                                                                                                                                                                                       	rigidum                                                                                                                                                                                                                                                        	(Willd.) Grossh.                                                                                                                                                                                                                                               	sibthorpianum                                                                                                                                                                                                                                                  	(Schult.) Damboldt                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma rigidum subsp. sibthorpianum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
217	Asyneuma amplexicaule var. amplexicaule                                                                                                                                                                                                                        	                                                                                                                                	Variety                                           	amplexicaule                                                                                                                                                                                                                                                   	Asyneuma                                                                                                                                                                                                                                                       	amplexicaule                                                                                                                                                                                                                                                   	(Willd.) Hand.-Mazz.                                                                                                                                                                                                                                           	amplexicaule                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	amplexicaule                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma amplexicaule subsp. amplexicaule var. amplexicaule                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
218	Campanula stricta var. stricta                                                                                                                                                                                                                                 	                                                                                                                                	Variety                                           	stricta                                                                                                                                                                                                                                                        	Campanula                                                                                                                                                                                                                                                      	stricta                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	stricta                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula stricta var. stricta                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
219	Campanula stricta var. libanotica (A. DC.) Boiss.                                                                                                                                                                                                              	(A. DC.) Boiss.                                                                                                                 	Variety                                           	libanotica                                                                                                                                                                                                                                                     	Campanula                                                                                                                                                                                                                                                      	stricta                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	libanotica                                                                                                                                                                                                                                                     	(A. DC.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Campanula stricta var. libanotica                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
220	Campanula involucrata A.DC.                                                                                                                                                                                                                                    	A.DC.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Campanula                                                                                                                                                                                                                                                      	involucrata                                                                                                                                                                                                                                                    	A.DC.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula involucrata                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
221	Campanula cymbalaria Sm.                                                                                                                                                                                                                                       	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Campanula                                                                                                                                                                                                                                                      	cymbalaria                                                                                                                                                                                                                                                     	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula cymbalaria                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	5
222	Onosma lycaonica Hub.-Mor.                                                                                                                                                                                                                                     	Hub.-Mor.                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	lycaonica                                                                                                                                                                                                                                                      	Hub.-Mor.                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onosma lycaonica                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
223	Onosma roussaei DC.                                                                                                                                                                                                                                            	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	roussaei                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onosma roussaei                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
224	Omphalodes luciliae subsp. cilicica (Brand) Bornm.                                                                                                                                                                                                             	(Brand) Bornm.                                                                                                                  	Subspecies                                        	cilicica                                                                                                                                                                                                                                                       	Omphalodes                                                                                                                                                                                                                                                     	luciliae                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	cilicica                                                                                                                                                                                                                                                       	(Brand) Bornm.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Omphalodes luciliae subsp. cilicica                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	5
225	Cynoglossum stamineum Desf.                                                                                                                                                                                                                                    	Desf.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Cynoglossum                                                                                                                                                                                                                                                    	stamineum                                                                                                                                                                                                                                                      	Desf.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Solenanthus stamineum (Desf.) Wettst.                                                                                                                                                                                                                          	Cynoglossum stamineum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
226	Ziziphora tenuior L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Ziziphora                                                                                                                                                                                                                                                      	tenuior                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ziziphora tenuior                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
227	Thesium billardieri Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Thesium                                                                                                                                                                                                                                                        	billardieri                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thesium billardieri                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
229	Campanula lyrata subsp. lyrata                                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	lyrata                                                                                                                                                                                                                                                         	Campanula                                                                                                                                                                                                                                                      	lyrata                                                                                                                                                                                                                                                         	Lam.                                                                                                                                                                                                                                                           	lyrata                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula lyrata subsp. lyrata                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
230	Campanula glomerata subsp. hispida (Witasek) Hayek                                                                                                                                                                                                             	(Witasek) Hayek                                                                                                                 	Subspecies                                        	hispida                                                                                                                                                                                                                                                        	Campanula                                                                                                                                                                                                                                                      	glomerata                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	hispida                                                                                                                                                                                                                                                        	(Witasek) Hayek                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula glomerata subsp. hispida                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
231	Stachys spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Stachys                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
232	Onosma nana DC.                                                                                                                                                                                                                                                	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	nana                                                                                                                                                                                                                                                           	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onosma nana                                                                                                                                                                                                                                                    	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	End A                                                                                                                                                                                                                                                          	2
234	Onosma cinerea Schreb.                                                                                                                                                                                                                                         	Schreb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	cinerea                                                                                                                                                                                                                                                        	Schreb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	O.taurica Pallas ex Willd.                                                                                                                                                                                                                                     	Onosma cinerea                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
236	Myosotis alpestris subsp. alpestris                                                                                                                                                                                                                            	                                                                                                                                	Subspecies                                        	alpestris                                                                                                                                                                                                                                                      	Myosotis                                                                                                                                                                                                                                                       	alpestris                                                                                                                                                                                                                                                      	F.W.Schmidt                                                                                                                                                                                                                                                    	alpestris                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Myosotis alpestris subsp. alpestris                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
237	Cynoglossum lithospermifolium var. cariense                                                                                                                                                                                                                    	                                                                                                                                	Variety                                           	cariense                                                                                                                                                                                                                                                       	Cynoglossum                                                                                                                                                                                                                                                    	lithospermifolium                                                                                                                                                                                                                                              	Lam.                                                                                                                                                                                                                                                           	cariense                                                                                                                                                                                                                                                       	(Boiss.) Greuter & Burdet                                                                                                                                                                                                                                      	cariense                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Paracaryum lithospermifolium (Lam.) Grande ssp. cariense , P. myosotoides (QUEZEL)                                                                                                                                                                             	Cynoglossum lithospermifolium subsp. cariense var. cariense                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
238	Alkanna primuliflora Griseb.                                                                                                                                                                                                                                   	Griseb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Alkanna                                                                                                                                                                                                                                                        	primuliflora                                                                                                                                                                                                                                                   	Griseb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna primuliflora                                                                                                                                                                                                                                           	=A.orientalis var. leucantha\nkommt nicht in Anatolien vor !                                                                                                                                                                                                    	Pont                                                                                                                                                                                                                                                           	3
239	Alkanna cf. areolata var. areolata                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	areolata                                                                                                                                                                                                                                                       	Alkanna                                                                                                                                                                                                                                                        	cf. areolata                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	areolata                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna cf. areolata var. areolata                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
240	Alkanna spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Alkanna                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
241	Convolvulus libanoticus Boiss.                                                                                                                                                                                                                                 	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Convolvulus                                                                                                                                                                                                                                                    	libanoticus                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Convolvulus libanoticus                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
242	Noaea mucronata subsp. mucronata                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	mucronata                                                                                                                                                                                                                                                      	Noaea                                                                                                                                                                                                                                                          	mucronata                                                                                                                                                                                                                                                      	(Forssk.) Asch. & Schweinf.                                                                                                                                                                                                                                    	mucronata                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Noaea mucronata subsp. mucronata                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
243	Herniaria incana Lam.                                                                                                                                                                                                                                          	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Herniaria                                                                                                                                                                                                                                                      	incana                                                                                                                                                                                                                                                         	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Herniaria incana                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
244	Herniaria glabra L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Herniaria                                                                                                                                                                                                                                                      	glabra                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Herniaria glabra                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
245	Paronychia chionaea Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Paronychia                                                                                                                                                                                                                                                     	chionaea                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Paronychia chionaea                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
246	Polygonum cognatum C.F.W.Meissn.                                                                                                                                                                                                                               	C.F.W.Meissn.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	cognatum                                                                                                                                                                                                                                                       	C.F.W.Meissn.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum cognatum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
247	Rumex acetosella L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Rumex                                                                                                                                                                                                                                                          	acetosella                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rumex acetosella                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Kosmo                                                                                                                                                                                                                                                          	5
248	Polygonum arenastrum Bor.                                                                                                                                                                                                                                      	Bor.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	arenastrum                                                                                                                                                                                                                                                     	Bor.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum arenastrum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	5
249	Rumex scutatus L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Rumex                                                                                                                                                                                                                                                          	scutatus                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rumex scutatus                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	3
250	Persicaria bistorta subsp. carnea (C. Koch) Greuter & Burdet                                                                                                                                                                                                   	(C. Koch) Greuter & Burdet                                                                                                      	Subspecies                                        	carnea                                                                                                                                                                                                                                                         	Persicaria                                                                                                                                                                                                                                                     	bistorta                                                                                                                                                                                                                                                       	(L.) Samp.                                                                                                                                                                                                                                                     	carnea                                                                                                                                                                                                                                                         	(C. Koch) Greuter & Burdet                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum bistorta L. carneum (Koch) Coode & Cullen                                                                                                                                                                                                            	Persicaria bistorta subsp. carnea                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
251	Polygonum polycnemoides Jaub. & Spach                                                                                                                                                                                                                          	Jaub. & Spach                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	polycnemoides                                                                                                                                                                                                                                                  	Jaub. & Spach                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum polycnemoides                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
252	Polygala supina Schreb.                                                                                                                                                                                                                                        	Schreb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Polygala                                                                                                                                                                                                                                                       	supina                                                                                                                                                                                                                                                         	Schreb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygala supina                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Pont / IA / EMed                                                                                                                                                                                                                                               	3
253	Malva neglecta Wallr.                                                                                                                                                                                                                                          	Wallr.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Malva                                                                                                                                                                                                                                                          	neglecta                                                                                                                                                                                                                                                       	Wallr.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Malva neglecta                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
254	Hypericum kotschyanum Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	kotschyanum                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum kotschyanum                                                                                                                                                                                                                                          	bolkar kennart                                                                                                                                                                                                                                                 	End loc                                                                                                                                                                                                                                                        	2
255	Hypericum crenulatum Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	crenulatum                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum crenulatum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
256	Hypericum scabrum L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	scabrum                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum scabrum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	2
257	Hypericum aviculariifolium var. depilatum                                                                                                                                                                                                                      	                                                                                                                                	Variety                                           	depilatum                                                                                                                                                                                                                                                      	Hypericum                                                                                                                                                                                                                                                      	aviculariifolium                                                                                                                                                                                                                                               	Jaub. & Spach                                                                                                                                                                                                                                                  	depilatum                                                                                                                                                                                                                                                      	(Freyn & Bornm.) Robson                                                                                                                                                                                                                                        	depilatum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum aviculariifolium subsp. depilatum var. depilatum                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
258	Hypericum montbretii Spach                                                                                                                                                                                                                                     	Spach                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	montbretii                                                                                                                                                                                                                                                     	Spach                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum montbretii                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA / Pont                                                                                                                                                                                                                                                      	2
259	Hypericum linarioides Bosse                                                                                                                                                                                                                                    	Bosse                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	linarioides                                                                                                                                                                                                                                                    	Bosse                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum linarioides                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IrTur / EMed                                                                                                                                                                                                                                                   	2
260	Hypericum aviculariifolium subsp. uniflorum (Boiss. & Heldr.) Robson                                                                                                                                                                                           	(Boiss. & Heldr.) Robson                                                                                                        	Subspecies                                        	uniflorum                                                                                                                                                                                                                                                      	Hypericum                                                                                                                                                                                                                                                      	aviculariifolium                                                                                                                                                                                                                                               	Jaub. & Spach                                                                                                                                                                                                                                                  	uniflorum                                                                                                                                                                                                                                                      	(Boiss. & Heldr.) Robson                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum aviculariifolium subsp. uniflorum                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
261	Hypericum confertum subsp. confertum                                                                                                                                                                                                                           	                                                                                                                                	Subspecies                                        	confertum                                                                                                                                                                                                                                                      	Hypericum                                                                                                                                                                                                                                                      	confertum                                                                                                                                                                                                                                                      	Choisy                                                                                                                                                                                                                                                         	confertum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum confertum subsp. confertum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
262	Hypericum aviculariifolium var. bourgaei (Boiss.) Robson                                                                                                                                                                                                       	(Boiss.) Robson                                                                                                                 	Variety                                           	bourgaei                                                                                                                                                                                                                                                       	Hypericum                                                                                                                                                                                                                                                      	aviculariifolium                                                                                                                                                                                                                                               	Jaub. & Spach                                                                                                                                                                                                                                                  	depilatum                                                                                                                                                                                                                                                      	(Freyn & Bornm.) Robson                                                                                                                                                                                                                                        	bourgaei                                                                                                                                                                                                                                                       	(Boiss.) Robson                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Hypericum aviculariifolium subsp. depilatum var. bourgaei                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
263	Linum boissieri Boiss.                                                                                                                                                                                                                                         	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	boissieri                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum boissieri                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
264	Linum tenuifolium L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	tenuifolium                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum tenuifolium                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / IA / EMed                                                                                                                                                                                                                                                 	2
265	Linum obtusatum (Boiss.) Stapf                                                                                                                                                                                                                                 	(Boiss.) Stapf                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	obtusatum                                                                                                                                                                                                                                                      	(Boiss.) Stapf                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum obtusatum                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
266	Linum spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum spec.                                                                                                                                                                                                                                                    	cf tenuifolium                                                                                                                                                                                                                                                 	spec                                                                                                                                                                                                                                                           	2
267	Linum hirsutum subsp. pseudoanatolicum P.H. Davis                                                                                                                                                                                                              	P.H. Davis                                                                                                                      	Subspecies                                        	pseudoanatolicum                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	hirsutum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	pseudoanatolicum                                                                                                                                                                                                                                               	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum hirsutum subsp. pseudoanatolicum                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
268	Linum empetrifolium (Boiss.) P.H. Davis                                                                                                                                                                                                                        	(Boiss.) P.H. Davis                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Linum                                                                                                                                                                                                                                                          	empetrifolium                                                                                                                                                                                                                                                  	(Boiss.) P.H. Davis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linum empetrifolium                                                                                                                                                                                                                                            	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	End loc                                                                                                                                                                                                                                                        	2
269	Geranium tuberosum subsp. tuberosum                                                                                                                                                                                                                            	                                                                                                                                	Subspecies                                        	tuberosum                                                                                                                                                                                                                                                      	Geranium                                                                                                                                                                                                                                                       	tuberosum                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	tuberosum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Geranium tuberosum subsp. tuberosum                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	4
270	Pelargonium endlicherianum Fenzl                                                                                                                                                                                                                               	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Pelargonium                                                                                                                                                                                                                                                    	endlicherianum                                                                                                                                                                                                                                                 	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pelargonium endlicherianum                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
271	Erodium cedrorum subsp. salmoneum (P.H. Davis & Roberts) P.H. Davis                                                                                                                                                                                            	(P.H. Davis & Roberts) P.H. Davis                                                                                               	Subspecies                                        	salmoneum                                                                                                                                                                                                                                                      	Erodium                                                                                                                                                                                                                                                        	cedrorum                                                                                                                                                                                                                                                       	Schott & Kotschy                                                                                                                                                                                                                                               	salmoneum                                                                                                                                                                                                                                                      	(P.H. Davis & Roberts) P.H. Davis                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erodium cedrorum subsp. salmoneum                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
272	Heracleum humile Sm.                                                                                                                                                                                                                                           	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Heracleum                                                                                                                                                                                                                                                      	humile                                                                                                                                                                                                                                                         	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Heracleum humile                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
273	Pimpinella tragium subsp. lithophila (I. Schischk.) Tutin                                                                                                                                                                                                      	(I. Schischk.) Tutin                                                                                                            	Subspecies                                        	lithophila                                                                                                                                                                                                                                                     	Pimpinella                                                                                                                                                                                                                                                     	tragium                                                                                                                                                                                                                                                        	Vill.                                                                                                                                                                                                                                                          	lithophila                                                                                                                                                                                                                                                     	(I. Schischk.) Tutin                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pimpinella tragium subsp. lithophila                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
274	Scandix pecten-veneris L.                                                                                                                                                                                                                                      	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Scandix                                                                                                                                                                                                                                                        	pecten-veneris                                                                                                                                                                                                                                                 	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scandix pecten-veneris                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	5
275	Bupleurum falcatum subsp. cernuum (Ten.) Arc.                                                                                                                                                                                                                  	(Ten.) Arc.                                                                                                                     	Subspecies                                        	cernuum                                                                                                                                                                                                                                                        	Bupleurum                                                                                                                                                                                                                                                      	falcatum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	cernuum                                                                                                                                                                                                                                                        	(Ten.) Arc.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bupleurum falcatum subsp. cernuum                                                                                                                                                                                                                              	nach Herbar ssp persicum !                                                                                                                                                                                                                                     	Med / IA                                                                                                                                                                                                                                                       	3
276	Bupleurum falcatum subsp. persicum (Boiss.) Koso-Pol.                                                                                                                                                                                                          	(Boiss.) Koso-Pol.                                                                                                              	Subspecies                                        	persicum                                                                                                                                                                                                                                                       	Bupleurum                                                                                                                                                                                                                                                      	falcatum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	persicum                                                                                                                                                                                                                                                       	(Boiss.) Koso-Pol.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bupleurum falcatum subsp. persicum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux / IA                                                                                                                                                                                                                                                       	3
277	Eryngium bourgatii subsp. heldreichii (Boiss.) P.H.Davis                                                                                                                                                                                                       	(Boiss.) P.H.Davis                                                                                                              	Subspecies                                        	heldreichii                                                                                                                                                                                                                                                    	Eryngium                                                                                                                                                                                                                                                       	bourgatii                                                                                                                                                                                                                                                      	Gouan                                                                                                                                                                                                                                                          	heldreichii                                                                                                                                                                                                                                                    	(Boiss.) P.H.Davis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eryngium bourgatii subsp. heldreichii                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
278	Eryngium spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Eryngium                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eryngium spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
279	Bunium microcarpum subsp. microcarpum                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	microcarpum                                                                                                                                                                                                                                                    	Bunium                                                                                                                                                                                                                                                         	microcarpum                                                                                                                                                                                                                                                    	(Boiss.) Freyn                                                                                                                                                                                                                                                 	microcarpum                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bunium microcarpum subsp. microcarpum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	4
281	Laserpitium petrophilum Boiss. & Heldr.                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Laserpitium                                                                                                                                                                                                                                                    	petrophilum                                                                                                                                                                                                                                                    	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Laserpitium petrophilum                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
282	Plantago holosteum Scop.                                                                                                                                                                                                                                       	Scop.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	holosteum                                                                                                                                                                                                                                                      	Scop.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P. carinata                                                                                                                                                                                                                                                    	Plantago holosteum                                                                                                                                                                                                                                             	+ beleg zwischen 107+109 (evtl=102?)                                                                                                                                                                                                                           	Med                                                                                                                                                                                                                                                            	3
283	Plantago lanceolata L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	lanceolata                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plantago lanceolata                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
284	Plantago media L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	media                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plantago media                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	3
285	Eryngium kotschyi Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Eryngium                                                                                                                                                                                                                                                       	kotschyi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eryngium kotschyi                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
286	Euphorbia herniariifolia var. glaberrima Hal.                                                                                                                                                                                                                  	Hal.                                                                                                                            	Variety                                           	glaberrima                                                                                                                                                                                                                                                     	Euphorbia                                                                                                                                                                                                                                                      	herniariifolia                                                                                                                                                                                                                                                 	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	glaberrima                                                                                                                                                                                                                                                     	Hal.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Euphorbia herniariifolia var. glaberrima                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
287	Euphorbia kotschyana Fenzl                                                                                                                                                                                                                                     	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Euphorbia                                                                                                                                                                                                                                                      	kotschyana                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia kotschyana                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	4
288	Euphorbia pestalozzae Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Euphorbia                                                                                                                                                                                                                                                      	pestalozzae                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia pestalozzae                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
560	Crocus spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Crocus                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crocus spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
289	Euphorbia herniariifolia var. herniarifolia                                                                                                                                                                                                                    	                                                                                                                                	Variety                                           	herniarifolia                                                                                                                                                                                                                                                  	Euphorbia                                                                                                                                                                                                                                                      	herniariifolia                                                                                                                                                                                                                                                 	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	herniarifolia                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia herniariifolia var. herniarifolia                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
290	Bornmuellerantha aucheri Boiss.                                                                                                                                                                                                                                	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Bornmuellerantha                                                                                                                                                                                                                                               	aucheri                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bornmuellerantha aucheri                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
293	Digitalis ferruginea subsp. ferruginea                                                                                                                                                                                                                         	                                                                                                                                	Subspecies                                        	ferruginea                                                                                                                                                                                                                                                     	Digitalis                                                                                                                                                                                                                                                      	ferruginea                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	ferruginea                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Digitalis ferruginea subsp. ferruginea                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES / EMed                                                                                                                                                                                                                                                      	3
294	Melampyrum arvense var. elatius Boiss.                                                                                                                                                                                                                         	Boiss.                                                                                                                          	Variety                                           	elatius                                                                                                                                                                                                                                                        	Melampyrum                                                                                                                                                                                                                                                     	arvense                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	elatius                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Melampyrum arvense var. elatius                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
295	Euphrasia pectinata Ten.                                                                                                                                                                                                                                       	Ten.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Euphrasia                                                                                                                                                                                                                                                      	pectinata                                                                                                                                                                                                                                                      	Ten.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphrasia pectinata                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	5
296	Linaria corifolia Desf.                                                                                                                                                                                                                                        	Desf.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Linaria                                                                                                                                                                                                                                                        	corifolia                                                                                                                                                                                                                                                      	Desf.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linaria corifolia                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
297	Pedicularis comosa var. sibthorpii (Boiss.) Boiss.                                                                                                                                                                                                             	(Boiss.) Boiss.                                                                                                                 	Variety                                           	sibthorpii                                                                                                                                                                                                                                                     	Pedicularis                                                                                                                                                                                                                                                    	comosa                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	sibthorpii                                                                                                                                                                                                                                                     	(Boiss.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Pedicularis comosa var. sibthorpii                                                                                                                                                                                                                             	schutt-grasflur Übergang\nsensu latu im balkan                                                                                                                                                                                                                  	Eux / EMed                                                                                                                                                                                                                                                     	3
298	Pedicularis cadmea Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Pedicularis                                                                                                                                                                                                                                                    	cadmea                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pedicularis cadmea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
299	Scrophularia rimarum Bornm.                                                                                                                                                                                                                                    	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scrophularia                                                                                                                                                                                                                                                   	rimarum                                                                                                                                                                                                                                                        	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scrophularia rimarum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
300	Scrophularia depauperata Boiss.                                                                                                                                                                                                                                	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scrophularia                                                                                                                                                                                                                                                   	depauperata                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scrophularia depauperata                                                                                                                                                                                                                                       	stehen lassen !!!                                                                                                                                                                                                                                              	End T                                                                                                                                                                                                                                                          	2
301	Scrophularia spec.                                                                                                                                                                                                                                             	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Scrophularia                                                                                                                                                                                                                                                   	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scrophularia spec.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
302	Veronica cuneifolia subsp. isaurica P.H.Davis                                                                                                                                                                                                                  	P.H.Davis                                                                                                                       	Subspecies                                        	isaurica                                                                                                                                                                                                                                                       	Veronica                                                                                                                                                                                                                                                       	cuneifolia                                                                                                                                                                                                                                                     	D.Don                                                                                                                                                                                                                                                          	isaurica                                                                                                                                                                                                                                                       	P.H.Davis                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica cuneifolia subsp. isaurica                                                                                                                                                                                                                            	vorher als Trifolio Polygenetalia Kennart !                                                                                                                                                                                                                    	End BT                                                                                                                                                                                                                                                         	2
303	Veronica biloba Schreb.                                                                                                                                                                                                                                        	Schreb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	biloba                                                                                                                                                                                                                                                         	Schreb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica biloba                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
304	Veronica cuneifolia subsp. cuneifolia                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	cuneifolia                                                                                                                                                                                                                                                     	Veronica                                                                                                                                                                                                                                                       	cuneifolia                                                                                                                                                                                                                                                     	D.Don                                                                                                                                                                                                                                                          	cuneifolia                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica cuneifolia subsp. cuneifolia                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
562	Euphorbia herniariifolia Willd.                                                                                                                                                                                                                                	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Euphorbia                                                                                                                                                                                                                                                      	herniariifolia                                                                                                                                                                                                                                                 	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia herniariifolia                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
563	Scutellaria orientalis s.l. L.                                                                                                                                                                                                                                 	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Scutellaria                                                                                                                                                                                                                                                    	orientalis s.l.                                                                                                                                                                                                                                                	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria orientalis s.l.                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IrTur                                                                                                                                                                                                                                                    	2
564	Orobanche spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
305	Veronica thymoides subsp. pseudocinerea M.A.Fischer                                                                                                                                                                                                            	M.A.Fischer                                                                                                                     	Subspecies                                        	pseudocinerea                                                                                                                                                                                                                                                  	Veronica                                                                                                                                                                                                                                                       	thymoides                                                                                                                                                                                                                                                      	P.H.Davis                                                                                                                                                                                                                                                      	pseudocinerea                                                                                                                                                                                                                                                  	M.A.Fischer                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica thymoides subsp. pseudocinerea                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
306	Veronica tauricola Bornm.                                                                                                                                                                                                                                      	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	tauricola                                                                                                                                                                                                                                                      	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica tauricola                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
307	Veronica thymoides subsp. hasandaghensis M.A.Fischer                                                                                                                                                                                                           	M.A.Fischer                                                                                                                     	Subspecies                                        	hasandaghensis                                                                                                                                                                                                                                                 	Veronica                                                                                                                                                                                                                                                       	thymoides                                                                                                                                                                                                                                                      	P.H.Davis                                                                                                                                                                                                                                                      	hasandaghensis                                                                                                                                                                                                                                                 	M.A.Fischer                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica thymoides subsp. hasandaghensis                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
308	Veronica caespitosa var. caespitosa                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	caespitosa                                                                                                                                                                                                                                                     	Veronica                                                                                                                                                                                                                                                       	caespitosa                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	caespitosa                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica caespitosa var. caespitosa                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
309	Veronica elmaliensis M.A.Fischer                                                                                                                                                                                                                               	M.A.Fischer                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	elmaliensis                                                                                                                                                                                                                                                    	M.A.Fischer                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica elmaliensis                                                                                                                                                                                                                                           	bei Özkan für V.cuneifolia !                                                                                                                                                                                                                                   	End A                                                                                                                                                                                                                                                          	2
310	Veronica bombycina subsp. bolkardaghensis M.A.Fischer                                                                                                                                                                                                          	M.A.Fischer                                                                                                                     	Subspecies                                        	bolkardaghensis                                                                                                                                                                                                                                                	Veronica                                                                                                                                                                                                                                                       	bombycina                                                                                                                                                                                                                                                      	Boiss. & Kotschy                                                                                                                                                                                                                                               	bolkardaghensis                                                                                                                                                                                                                                                	M.A.Fischer                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica bombycina subsp. bolkardaghensis                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	2
311	Veronica orientalis subsp. orientalis                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	orientalis                                                                                                                                                                                                                                                     	Veronica                                                                                                                                                                                                                                                       	orientalis                                                                                                                                                                                                                                                     	Mill.                                                                                                                                                                                                                                                          	orientalis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica orientalis subsp. orientalis                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA / EMed                                                                                                                                                                                                                                                      	2
313	Veronica lycica E.Lehm                                                                                                                                                                                                                                         	E.Lehm                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	lycica                                                                                                                                                                                                                                                         	E.Lehm                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica lycica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	5
314	Juniperus excelsa subsp. excelsa                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	excelsa                                                                                                                                                                                                                                                        	Juniperus                                                                                                                                                                                                                                                      	excelsa                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	excelsa                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Juniperus excelsa subsp. excelsa                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
315	Juniperus oxycedrus subsp. oxycedrus                                                                                                                                                                                                                           	                                                                                                                                	Subspecies                                        	oxycedrus                                                                                                                                                                                                                                                      	Juniperus                                                                                                                                                                                                                                                      	oxycedrus                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	oxycedrus                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Juniperus oxycedrus subsp. oxycedrus                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
316	Juniperus communis var. saxatilis Pall.                                                                                                                                                                                                                        	Pall.                                                                                                                           	Variety                                           	saxatilis                                                                                                                                                                                                                                                      	Juniperus                                                                                                                                                                                                                                                      	communis                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	saxatilis                                                                                                                                                                                                                                                      	Pall.                                                                                                                                                                                                                                                          	Jcommunis L. ssp nana\nJ.com. ssp alpina (Suter) Celak                                                                                                                                                                                                          	Juniperus communis var. saxatilis                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
317	Ephedra major Host                                                                                                                                                                                                                                             	Host                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Ephedra                                                                                                                                                                                                                                                        	major                                                                                                                                                                                                                                                          	Host                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ephedra major                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	2
318	Berberis crataegina DC.                                                                                                                                                                                                                                        	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Berberis                                                                                                                                                                                                                                                       	crataegina                                                                                                                                                                                                                                                     	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Berberis crataegina                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
319	Ranunculus demissus var. major Boiss.                                                                                                                                                                                                                          	Boiss.                                                                                                                          	Variety                                           	major                                                                                                                                                                                                                                                          	Ranunculus                                                                                                                                                                                                                                                     	demissus                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	major                                                                                                                                                                                                                                                          	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Ranunculus demissus var. major                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
320	Ranunculus brevifolius Ten.                                                                                                                                                                                                                                    	Ten.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Ranunculus                                                                                                                                                                                                                                                     	brevifolius                                                                                                                                                                                                                                                    	Ten.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ranunculus brevifolius                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
321	Ostrya carpinifolia Scop.                                                                                                                                                                                                                                      	Scop.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Ostrya                                                                                                                                                                                                                                                         	carpinifolia                                                                                                                                                                                                                                                   	Scop.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ostrya carpinifolia                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	7
322	Epilobium hirsutum L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Epilobium                                                                                                                                                                                                                                                      	hirsutum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Epilobium hirsutum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	3
324	Acantholimon lycaonicum Boiss. & Heldr.                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Acantholimon                                                                                                                                                                                                                                                   	lycaonicum                                                                                                                                                                                                                                                     	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon lycaonicum                                                                                                                                                                                                                                        	vorher Steppen VC                                                                                                                                                                                                                                              	EMed                                                                                                                                                                                                                                                           	2
326	Acantholimon armenum var. armenum                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	armenum                                                                                                                                                                                                                                                        	Acantholimon                                                                                                                                                                                                                                                   	armenum                                                                                                                                                                                                                                                        	Boiss. & Huet.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	armenum                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon armenum var. armenum                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
327	Acantholimon venustum var. laxiflorum (Boiss.ex Bunge) Bokhari                                                                                                                                                                                                 	(Boiss.ex Bunge) Bokhari                                                                                                        	Variety                                           	laxiflorum                                                                                                                                                                                                                                                     	Acantholimon                                                                                                                                                                                                                                                   	venustum                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	laxiflorum                                                                                                                                                                                                                                                     	(Boiss.ex Bunge) Bokhari                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Acantholimon venustum var. laxiflorum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
328	Acantholimon kotschyi subsp. kotschyi                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	kotschyi                                                                                                                                                                                                                                                       	Acantholimon                                                                                                                                                                                                                                                   	kotschyi                                                                                                                                                                                                                                                       	(Jaub. & Spach) Boiss.                                                                                                                                                                                                                                         	kotschyi                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon kotschyi subsp. kotschyi                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
329	Acantholimon puberulum var. puberulum                                                                                                                                                                                                                          	                                                                                                                                	Variety                                           	puberulum                                                                                                                                                                                                                                                      	Acantholimon                                                                                                                                                                                                                                                   	puberulum                                                                                                                                                                                                                                                      	Boiss. & Bal.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	puberulum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon puberulum var. puberulum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
330	Astragalus hirsutus Vahl                                                                                                                                                                                                                                       	Vahl                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	hirsutus                                                                                                                                                                                                                                                       	Vahl                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus hirsutus                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
331	Astragalus andrasovszkyi Bornm.                                                                                                                                                                                                                                	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	andrasovszkyi                                                                                                                                                                                                                                                  	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus andrasovszkyi                                                                                                                                                                                                                                       	falscher Artname, aber Geralds alter vorher benutzter name. best fit. evtl neue art?                                                                                                                                                                           	End A                                                                                                                                                                                                                                                          	2
332	Astragalus lanatus Lab.                                                                                                                                                                                                                                        	Lab.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	lanatus                                                                                                                                                                                                                                                        	Lab.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus lanatus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
333	Astragalus paecilanthus Boiss. & Heldr.                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	paecilanthus                                                                                                                                                                                                                                                   	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus paecilanthus                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
334	Astragalus spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	1                                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus spec. subsp. 1                                                                                                                                                                                                                                      	bifurkat                                                                                                                                                                                                                                                       	spec                                                                                                                                                                                                                                                           	2
335	Astragalus spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	2                                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus spec. subsp. 2                                                                                                                                                                                                                                      	simple hair                                                                                                                                                                                                                                                    	spec                                                                                                                                                                                                                                                           	2
336	Astragalus pinetorum Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	pinetorum                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus pinetorum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
337	Astragalus microrchis Barbey                                                                                                                                                                                                                                   	Barbey                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	microrchis                                                                                                                                                                                                                                                     	Barbey                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus microrchis                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
338	Astragalus amoenus Fenzl                                                                                                                                                                                                                                       	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	amoenus                                                                                                                                                                                                                                                        	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus amoenus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
339	Astragalus sorgerae Hub.- Mor. & D.F.Chamb.                                                                                                                                                                                                                    	Hub.- Mor. & D.F.Chamb.                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	sorgerae                                                                                                                                                                                                                                                       	Hub.- Mor. & D.F.Chamb.                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus sorgerae                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
340	Astragalus chrysochlorus Boiss. & Kotschy                                                                                                                                                                                                                      	Boiss. & Kotschy                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	chrysochlorus                                                                                                                                                                                                                                                  	Boiss. & Kotschy                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus chrysochlorus                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
341	Astragalus oxytropifolius Boiss.                                                                                                                                                                                                                               	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	oxytropifolius                                                                                                                                                                                                                                                 	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus oxytropifolius                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
342	Astragalus haussknechtii Bunge                                                                                                                                                                                                                                 	Bunge                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	haussknechtii                                                                                                                                                                                                                                                  	Bunge                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus haussknechtii                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
343	Astragalus lineatus var. lineatus                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	lineatus                                                                                                                                                                                                                                                       	Astragalus                                                                                                                                                                                                                                                     	lineatus                                                                                                                                                                                                                                                       	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	lineatus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus lineatus var. lineatus                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
345	Astragalus condensatus Ledeb.                                                                                                                                                                                                                                  	Ledeb.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	condensatus                                                                                                                                                                                                                                                    	Ledeb.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus condensatus                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
346	Astragalus angustifolius subsp. angustifolius                                                                                                                                                                                                                  	                                                                                                                                	Subspecies                                        	angustifolius                                                                                                                                                                                                                                                  	Astragalus                                                                                                                                                                                                                                                     	angustifolius                                                                                                                                                                                                                                                  	Lam.                                                                                                                                                                                                                                                           	angustifolius                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus angustifolius subsp. angustifolius                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
347	Astragalus angustifolius var. violascens Boiss.                                                                                                                                                                                                                	Boiss.                                                                                                                          	Variety                                           	violascens                                                                                                                                                                                                                                                     	Astragalus                                                                                                                                                                                                                                                     	angustifolius                                                                                                                                                                                                                                                  	Lam.                                                                                                                                                                                                                                                           	angustifolius                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	violascens                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Astragalus angustifolius subsp. angustifolius var. violascens                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
348	Astragalus microcephalus Willd.                                                                                                                                                                                                                                	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	microcephalus                                                                                                                                                                                                                                                  	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus (plur. sp. cf. supra) (QUEZEL)                                                                                                                                                                                                                      	Astragalus microcephalus                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
349	Astragalus gummifer Lab.                                                                                                                                                                                                                                       	Lab.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	gummifer                                                                                                                                                                                                                                                       	Lab.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus gummifer                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
350	Astragalus plumosus var. akardaghicus (Eig) D.F.Chamb. & Matthews                                                                                                                                                                                              	(Eig) D.F.Chamb. & Matthews                                                                                                     	Variety                                           	akardaghicus                                                                                                                                                                                                                                                   	Astragalus                                                                                                                                                                                                                                                     	plumosus                                                                                                                                                                                                                                                       	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	akardaghicus                                                                                                                                                                                                                                                   	(Eig) D.F.Chamb. & Matthews                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Astragalus plumosus var. akardaghicus                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
351	Astragalus plumosus var. plumosus                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	plumosus                                                                                                                                                                                                                                                       	Astragalus                                                                                                                                                                                                                                                     	plumosus                                                                                                                                                                                                                                                       	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	plumosus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus plumosus var. plumosus                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
352	Astragalus plumosus var. krugianus (Freyn & Bornm.) D.F.Chamb. & Matthews                                                                                                                                                                                      	(Freyn & Bornm.) D.F.Chamb. & Matthews                                                                                          	Variety                                           	krugianus                                                                                                                                                                                                                                                      	Astragalus                                                                                                                                                                                                                                                     	plumosus                                                                                                                                                                                                                                                       	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	krugianus                                                                                                                                                                                                                                                      	(Freyn & Bornm.) D.F.Chamb. & Matthews                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Astragalus plumosus var. krugianus                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
353	Astragalus angustifolius Lam.                                                                                                                                                                                                                                  	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	angustifolius                                                                                                                                                                                                                                                  	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus angustifolius                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
566	Asperula stricta s.l. Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Asperula                                                                                                                                                                                                                                                       	stricta s.l.                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula stricta s.l.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
567	Draba bruniifolia Stev.                                                                                                                                                                                                                                        	Stev.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Draba                                                                                                                                                                                                                                                          	bruniifolia                                                                                                                                                                                                                                                    	Stev.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Draba bruniifolia                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
568	Rochelia disperma (L.f.) C.Koch                                                                                                                                                                                                                                	(L.f.) C.Koch                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Rochelia                                                                                                                                                                                                                                                       	disperma                                                                                                                                                                                                                                                       	(L.f.) C.Koch                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rochelia disperma                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
356	Cruciata taurica (Pall. ex Willd.) Ehrend.                                                                                                                                                                                                                     	(Pall. ex Willd.) Ehrend.                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Cruciata                                                                                                                                                                                                                                                       	taurica                                                                                                                                                                                                                                                        	(Pall. ex Willd.) Ehrend.                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium coronatum var stenophyllum (QUEZEL)                                                                                                                                                                                                                     	Cruciata taurica                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
357	Asperula stricta subsp. grandiflora Schönb.-Tem.                                                                                                                                                                                                               	Schönb.-Tem.                                                                                                                    	Subspecies                                        	grandiflora                                                                                                                                                                                                                                                    	Asperula                                                                                                                                                                                                                                                       	stricta                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	grandiflora                                                                                                                                                                                                                                                    	Schönb.-Tem.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula stricta subsp. grandiflora                                                                                                                                                                                                                            	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	End OT                                                                                                                                                                                                                                                         	2
358	Asperula stricta subsp. monticola Ehrend.                                                                                                                                                                                                                      	Ehrend.                                                                                                                         	Subspecies                                        	monticola                                                                                                                                                                                                                                                      	Asperula                                                                                                                                                                                                                                                       	stricta                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	monticola                                                                                                                                                                                                                                                      	Ehrend.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula stricta subsp. monticola                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
359	Asperula stricta subsp. latibracteata (Boiss.) Ehrend.                                                                                                                                                                                                         	(Boiss.) Ehrend.                                                                                                                	Subspecies                                        	latibracteata                                                                                                                                                                                                                                                  	Asperula                                                                                                                                                                                                                                                       	stricta                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	latibracteata                                                                                                                                                                                                                                                  	(Boiss.) Ehrend.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula stricta subsp. latibracteata                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
360	Asperula stricta subsp. stricta                                                                                                                                                                                                                                	                                                                                                                                	Subspecies                                        	stricta                                                                                                                                                                                                                                                        	Asperula                                                                                                                                                                                                                                                       	stricta                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	stricta                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula stricta subsp. stricta                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
361	Asperula setosa Jaub. & Spach                                                                                                                                                                                                                                  	Jaub. & Spach                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Asperula                                                                                                                                                                                                                                                       	setosa                                                                                                                                                                                                                                                         	Jaub. & Spach                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asperula setosa                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
362	Galium incanum subsp. elatius (Boiss.) Ehrend.                                                                                                                                                                                                                 	(Boiss.) Ehrend.                                                                                                                	Subspecies                                        	elatius                                                                                                                                                                                                                                                        	Galium                                                                                                                                                                                                                                                         	incanum                                                                                                                                                                                                                                                        	Sm.                                                                                                                                                                                                                                                            	elatius                                                                                                                                                                                                                                                        	(Boiss.) Ehrend.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium incanum subsp. elatius                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
363	Galium incanum subsp. centrale Ehrend.                                                                                                                                                                                                                         	Ehrend.                                                                                                                         	Subspecies                                        	centrale                                                                                                                                                                                                                                                       	Galium                                                                                                                                                                                                                                                         	incanum                                                                                                                                                                                                                                                        	Sm.                                                                                                                                                                                                                                                            	centrale                                                                                                                                                                                                                                                       	Ehrend.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium incanum subsp. centrale                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
366	Galium cilicicum Boiss.                                                                                                                                                                                                                                        	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	cilicicum                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium cilicicum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
367	Galium cf. incanum Sm.                                                                                                                                                                                                                                         	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	cf. incanum                                                                                                                                                                                                                                                    	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium cf. incanum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
368	Galium aladaghense Parolly                                                                                                                                                                                                                                     	Parolly                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	aladaghense                                                                                                                                                                                                                                                    	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium aladaghense                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
634	Orobanche purpurea Jacq.                                                                                                                                                                                                                                       	Jacq.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	purpurea                                                                                                                                                                                                                                                       	Jacq.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche purpurea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med / IA / Ind                                                                                                                                                                                                                                            	4
637	Orobanche cernua Loefl.                                                                                                                                                                                                                                        	Loefl.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	cernua                                                                                                                                                                                                                                                         	Loefl.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche cernua                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med / IA / Sa-Ar                                                                                                                                                                                                                                               	4
369	Galium verum subsp. glabrescens Ehrend.                                                                                                                                                                                                                        	Ehrend.                                                                                                                         	Subspecies                                        	glabrescens                                                                                                                                                                                                                                                    	Galium                                                                                                                                                                                                                                                         	verum                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	glabrescens                                                                                                                                                                                                                                                    	Ehrend.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium verum subsp. glabrescens                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
370	Galium verum subsp. verum                                                                                                                                                                                                                                      	                                                                                                                                	Subspecies                                        	verum                                                                                                                                                                                                                                                          	Galium                                                                                                                                                                                                                                                         	verum                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	verum                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium verum subsp. verum                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	2
371	Galium tmoleum Boiss.                                                                                                                                                                                                                                          	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	tmoleum                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium tmoleum                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
372	Cerastium macranthum Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Cerastium                                                                                                                                                                                                                                                      	macranthum                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerastium macranthum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
373	Cerastium gnaphalodes Fenzl                                                                                                                                                                                                                                    	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Cerastium                                                                                                                                                                                                                                                      	gnaphalodes                                                                                                                                                                                                                                                    	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerastium gnaphalodes                                                                                                                                                                                                                                          	schutt-grasflur Übergang                                                                                                                                                                                                                                       	End A                                                                                                                                                                                                                                                          	2
374	Cerastium spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Cerastium                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerastium spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
375	Saponaria pumilio Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Saponaria                                                                                                                                                                                                                                                      	pumilio                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Saponaria pumilio                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
376	Cyathophylla chlorifolia (Poir.) Bocquet & Strid                                                                                                                                                                                                               	(Poir.) Bocquet & Strid                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Cyathophylla                                                                                                                                                                                                                                                   	chlorifolia                                                                                                                                                                                                                                                    	(Poir.) Bocquet & Strid                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Saponaria chlorifolia (Poir.) Kunze                                                                                                                                                                                                                            	Cyathophylla chlorifolia                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
377	Gypsophila libanotica Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Gypsophila                                                                                                                                                                                                                                                     	libanotica                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gypsophila libanotica                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
378	Gypsophila curvifolia Fenzl                                                                                                                                                                                                                                    	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Gypsophila                                                                                                                                                                                                                                                     	curvifolia                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gypsophila curvifolia                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
379	Arenaria deflexa subsp. pubescens McNeill                                                                                                                                                                                                                      	McNeill                                                                                                                         	Subspecies                                        	pubescens                                                                                                                                                                                                                                                      	Arenaria                                                                                                                                                                                                                                                       	deflexa                                                                                                                                                                                                                                                        	Dec.                                                                                                                                                                                                                                                           	pubescens                                                                                                                                                                                                                                                      	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria deflexa subsp. pubescens                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	5
380	Arenaria serpyllifolia L.                                                                                                                                                                                                                                      	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	serpyllifolia                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria serpyllifolia                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	ES / Med / circ                                                                                                                                                                                                                                                	5
381	Arenaria acerosa Boiss.                                                                                                                                                                                                                                        	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	acerosa                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria acerosa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
382	Arenaria ledebouriana var. ledebouriana                                                                                                                                                                                                                        	                                                                                                                                	Variety                                           	ledebouriana                                                                                                                                                                                                                                                   	Arenaria                                                                                                                                                                                                                                                       	ledebouriana                                                                                                                                                                                                                                                   	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ledebouriana                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria ledebouriana var. ledebouriana                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
383	Arenaria balansae Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	balansae                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria balansae                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
385	Arenaria kotschyana subsp. kotschyana                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	kotschyana                                                                                                                                                                                                                                                     	Arenaria                                                                                                                                                                                                                                                       	kotschyana                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	kotschyana                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria kotschyana subsp. kotschyana                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
386	Arenaria ledebouriana var. grandiflora Hartvig & Strid                                                                                                                                                                                                         	Hartvig & Strid                                                                                                                 	Variety                                           	grandiflora                                                                                                                                                                                                                                                    	Arenaria                                                                                                                                                                                                                                                       	ledebouriana                                                                                                                                                                                                                                                   	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	grandiflora                                                                                                                                                                                                                                                    	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Arenaria ledebouriana var. grandiflora                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
387	Arenaria cf. pamphylica subsp. alpestris (McNeill) McNeill                                                                                                                                                                                                     	(McNeill) McNeill                                                                                                               	Subspecies                                        	alpestris                                                                                                                                                                                                                                                      	Arenaria                                                                                                                                                                                                                                                       	cf. pamphylica                                                                                                                                                                                                                                                 	Boiss. & Heldr.                                                                                                                                                                                                                                                	alpestris                                                                                                                                                                                                                                                      	(McNeill) McNeill                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria cf. pamphylica subsp. alpestris                                                                                                                                                                                                                       	evtl Minuartia ?                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
388	Minuartia pestalozzae (Boiss.) Bornm.                                                                                                                                                                                                                          	(Boiss.) Bornm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	pestalozzae                                                                                                                                                                                                                                                    	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia pestalozzae                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
389	Minuartia juniperina (L.) Maire & Petitm.                                                                                                                                                                                                                      	(L.) Maire & Petitm.                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	juniperina                                                                                                                                                                                                                                                     	(L.) Maire & Petitm.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia juniperina                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
390	Minuartia dianthifolia subsp. dianthifolia                                                                                                                                                                                                                     	                                                                                                                                	Subspecies                                        	dianthifolia                                                                                                                                                                                                                                                   	Minuartia                                                                                                                                                                                                                                                      	dianthifolia                                                                                                                                                                                                                                                   	(Boiss.) Hand.-Mazz.                                                                                                                                                                                                                                           	dianthifolia                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia dianthifolia subsp. dianthifolia                                                                                                                                                                                                                     	im Feld evtl mit Minuartia pestalozzae verwechselt !!!                                                                                                                                                                                                         	End BT                                                                                                                                                                                                                                                         	2
391	Minuartia hamata (Hausskn. & Bornm.) Mattf.                                                                                                                                                                                                                    	(Hausskn. & Bornm.) Mattf.                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	hamata                                                                                                                                                                                                                                                         	(Hausskn. & Bornm.) Mattf.                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia hamata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	5
392	Minuartia anatolica var. anatolica                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	anatolica                                                                                                                                                                                                                                                      	Minuartia                                                                                                                                                                                                                                                      	anatolica                                                                                                                                                                                                                                                      	(Boiss.) Woronow                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	anatolica                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia anatolica var. anatolica                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
393	Minuartia leucocephala (Boiss.) Mattf.                                                                                                                                                                                                                         	(Boiss.) Mattf.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	leucocephala                                                                                                                                                                                                                                                   	(Boiss.) Mattf.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia leucocephala                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
394	Minuartia erythrosepala var. erythrosepala                                                                                                                                                                                                                     	                                                                                                                                	Variety                                           	erythrosepala                                                                                                                                                                                                                                                  	Minuartia                                                                                                                                                                                                                                                      	erythrosepala                                                                                                                                                                                                                                                  	(Boiss.) Hand.-Mazz.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	erythrosepala                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia erythrosepala var. erythrosepala                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
395	Minuartia recurva subsp. oreina (Mattf.) McNeill                                                                                                                                                                                                               	(Mattf.) McNeill                                                                                                                	Subspecies                                        	oreina                                                                                                                                                                                                                                                         	Minuartia                                                                                                                                                                                                                                                      	recurva                                                                                                                                                                                                                                                        	(All.) Schinz & Thell.                                                                                                                                                                                                                                         	oreina                                                                                                                                                                                                                                                         	(Mattf.) McNeill                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia recurva subsp. oreina                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
396	Minuartia spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
397	Minuartia umbellulifera var. umbellulifera                                                                                                                                                                                                                     	                                                                                                                                	Variety                                           	umbellulifera                                                                                                                                                                                                                                                  	Minuartia                                                                                                                                                                                                                                                      	umbellulifera                                                                                                                                                                                                                                                  	(Boiss. & Balansa) McNeill                                                                                                                                                                                                                                     	umbellulifera                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	umbellulifera                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia umbellulifera subsp. umbellulifera var. umbellulifera                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
398	Dianthus brevicaulis subsp. brevicaulis                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	brevicaulis                                                                                                                                                                                                                                                    	Dianthus                                                                                                                                                                                                                                                       	brevicaulis                                                                                                                                                                                                                                                    	Fenzl                                                                                                                                                                                                                                                          	brevicaulis                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus brevicaulis subsp. brevicaulis                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
399	Dianthus zonatus var. hypochlorus (Boiss. & Heldr.) Reeve                                                                                                                                                                                                      	(Boiss. & Heldr.) Reeve                                                                                                         	Variety                                           	hypochlorus                                                                                                                                                                                                                                                    	Dianthus                                                                                                                                                                                                                                                       	zonatus                                                                                                                                                                                                                                                        	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	hypochlorus                                                                                                                                                                                                                                                    	(Boiss. & Heldr.) Reeve                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Dianthus zonatus var. hypochlorus                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
400	Dianthus zonatus var. zonatus                                                                                                                                                                                                                                  	                                                                                                                                	Variety                                           	zonatus                                                                                                                                                                                                                                                        	Dianthus                                                                                                                                                                                                                                                       	zonatus                                                                                                                                                                                                                                                        	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	zonatus                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus zonatus var. zonatus                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
401	Dianthus micranthus Boiss. & Heldr.                                                                                                                                                                                                                            	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	micranthus                                                                                                                                                                                                                                                     	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus micranthus                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
402	Dianthus spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus spec.                                                                                                                                                                                                                                                 	nicht löschen ! in deckungen gebraucht.                                                                                                                                                                                                                        	spec                                                                                                                                                                                                                                                           	2
403	Dianthus floribundus Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	floribundus                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus floribundus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
405	Silene olympica Boiss.                                                                                                                                                                                                                                         	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	olympica                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene olympica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
406	Silene argentea Ledeb.                                                                                                                                                                                                                                         	Ledeb.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	argentea                                                                                                                                                                                                                                                       	Ledeb.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	S.cappadocica Boiss.+Heldr.                                                                                                                                                                                                                                    	Silene argentea                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
407	Silene odontopetala Fenzl                                                                                                                                                                                                                                      	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	odontopetala                                                                                                                                                                                                                                                   	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene odontopetala                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
408	Silene armena var. armena                                                                                                                                                                                                                                      	                                                                                                                                	Variety                                           	armena                                                                                                                                                                                                                                                         	Silene                                                                                                                                                                                                                                                         	armena                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	armena                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	bei Quetzel = S.nuncupanda                                                                                                                                                                                                                                     	Silene armena var. armena                                                                                                                                                                                                                                      	M938 ist Hybride                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
409	Silene armena var. serrulata (Boiss.) Coode & Cullen                                                                                                                                                                                                           	(Boiss.) Coode & Cullen                                                                                                         	Variety                                           	serrulata                                                                                                                                                                                                                                                      	Silene                                                                                                                                                                                                                                                         	armena                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	serrulata                                                                                                                                                                                                                                                      	(Boiss.) Coode & Cullen                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Silene armena var. serrulata                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
410	Silene nuncupanda Coode & Cullen                                                                                                                                                                                                                               	Coode & Cullen                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	nuncupanda                                                                                                                                                                                                                                                     	Coode & Cullen                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene armena (Quetzel)                                                                                                                                                                                                                                        	Silene nuncupanda                                                                                                                                                                                                                                              	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	End T                                                                                                                                                                                                                                                          	2
411	Silene caryophylloides subsp. cf. masmenaea (Boiss.) Coode & Cullen                                                                                                                                                                                            	(Boiss.) Coode & Cullen                                                                                                         	Subspecies                                        	cf. masmenaea                                                                                                                                                                                                                                                  	Silene                                                                                                                                                                                                                                                         	caryophylloides                                                                                                                                                                                                                                                	(Poiret) Otth                                                                                                                                                                                                                                                  	cf. masmenaea                                                                                                                                                                                                                                                  	(Boiss.) Coode & Cullen                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene caryophylloides subsp. cf. masmenaea                                                                                                                                                                                                                    	bei Gerald als ssp. echinus !                                                                                                                                                                                                                                  	End A                                                                                                                                                                                                                                                          	2
412	Silene rhynchocarpa Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	rhynchocarpa                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene rhynchocarpa                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
413	Silene caryophylloides subsp. stentoria (Fenzl) Coode & Cullen                                                                                                                                                                                                 	(Fenzl) Coode & Cullen                                                                                                          	Subspecies                                        	stentoria                                                                                                                                                                                                                                                      	Silene                                                                                                                                                                                                                                                         	caryophylloides                                                                                                                                                                                                                                                	(Poiret) Otth.                                                                                                                                                                                                                                                 	stentoria                                                                                                                                                                                                                                                      	(Fenzl) Coode & Cullen                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene caryophylloides subsp. stentoria                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
414	Silene caryophylloides subsp. eglandulosa (Chowdhuri) Coode & Cullen                                                                                                                                                                                           	(Chowdhuri) Coode & Cullen                                                                                                      	Subspecies                                        	eglandulosa                                                                                                                                                                                                                                                    	Silene                                                                                                                                                                                                                                                         	caryophylloides                                                                                                                                                                                                                                                	(Poiret) Otth                                                                                                                                                                                                                                                  	eglandulosa                                                                                                                                                                                                                                                    	(Chowdhuri) Coode & Cullen                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene caryophylloides subsp. eglandulosa                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
415	Silene spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
416	Silene pruinosa Boiss.                                                                                                                                                                                                                                         	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	pruinosa                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	S.supina MB. ssp pruinosa                                                                                                                                                                                                                                      	Silene pruinosa                                                                                                                                                                                                                                                	erst als S.cappadocica bestimmt.                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
418	Leontodon oxylepis var. oxylepis                                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	oxylepis                                                                                                                                                                                                                                                       	Leontodon                                                                                                                                                                                                                                                      	oxylepis                                                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	oxylepis                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Leontodon oxylepis var. oxylepis                                                                                                                                                                                                                               	evtl tlw auch Leontodon crispus ssp asper enthalten.                                                                                                                                                                                                           	EMed                                                                                                                                                                                                                                                           	3
419	Leontodon oxylepis var. divaricatus (Boiss.) Kupicha                                                                                                                                                                                                           	(Boiss.) Kupicha                                                                                                                	Variety                                           	divaricatus                                                                                                                                                                                                                                                    	Leontodon                                                                                                                                                                                                                                                      	oxylepis                                                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	divaricatus                                                                                                                                                                                                                                                    	(Boiss.) Kupicha                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Leontodon oxylepis var. divaricatus                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
420	Helichrysum plicatum subsp. plicatum                                                                                                                                                                                                                           	                                                                                                                                	Subspecies                                        	plicatum                                                                                                                                                                                                                                                       	Helichrysum                                                                                                                                                                                                                                                    	plicatum                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	plicatum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Helichrysum plicatum subsp. plicatum                                                                                                                                                                                                                           	evtl = H.pilasii                                                                                                                                                                                                                                               	IA / Pont                                                                                                                                                                                                                                                      	2
421	Helichrysum plicatum subsp. isauricum Parolly                                                                                                                                                                                                                  	Parolly                                                                                                                         	Subspecies                                        	isauricum                                                                                                                                                                                                                                                      	Helichrysum                                                                                                                                                                                                                                                    	plicatum                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	isauricum                                                                                                                                                                                                                                                      	Parolly                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Helichrysum plicatum subsp. isauricum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
422	Helichrysum arenarium subsp. aucheri (Boiss.) P.H.Davis & Kupicha                                                                                                                                                                                              	(Boiss.) P.H.Davis & Kupicha                                                                                                    	Subspecies                                        	aucheri                                                                                                                                                                                                                                                        	Helichrysum                                                                                                                                                                                                                                                    	arenarium                                                                                                                                                                                                                                                      	(L.) Moench                                                                                                                                                                                                                                                    	aucheri                                                                                                                                                                                                                                                        	(Boiss.) P.H.Davis & Kupicha                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Helichrysum arenarium subsp. aucheri                                                                                                                                                                                                                           	steppen Art                                                                                                                                                                                                                                                    	End A                                                                                                                                                                                                                                                          	2
423	Helichrysum pallasii Ledeb.                                                                                                                                                                                                                                    	Ledeb.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Helichrysum                                                                                                                                                                                                                                                    	pallasii                                                                                                                                                                                                                                                       	Ledeb.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	H.chionophyllum var.pallidum (Quetzel)                                                                                                                                                                                                                         	Helichrysum pallasii                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
424	Tanacetum armenum (DC.) Sch.Bip.                                                                                                                                                                                                                               	(DC.) Sch.Bip.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Tanacetum                                                                                                                                                                                                                                                      	armenum                                                                                                                                                                                                                                                        	(DC.) Sch.Bip.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum armenum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
425	Tanacetum argenteum var. canum                                                                                                                                                                                                                                 	                                                                                                                                	Variety                                           	canum                                                                                                                                                                                                                                                          	Tanacetum                                                                                                                                                                                                                                                      	argenteum                                                                                                                                                                                                                                                      	(Lam.) Willd.                                                                                                                                                                                                                                                  	canum                                                                                                                                                                                                                                                          	(C.Koch) Grierson                                                                                                                                                                                                                                              	canum                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum argenteum subsp. canum var. canum                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
426	Tanacetum argenteum subsp. argenteum                                                                                                                                                                                                                           	                                                                                                                                	Subspecies                                        	argenteum                                                                                                                                                                                                                                                      	Tanacetum                                                                                                                                                                                                                                                      	argenteum                                                                                                                                                                                                                                                      	(Lam.) Willd.                                                                                                                                                                                                                                                  	argenteum                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum argenteum subsp. argenteum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
427	Tanacetum praeteritum subsp. praeteritum                                                                                                                                                                                                                       	                                                                                                                                	Subspecies                                        	praeteritum                                                                                                                                                                                                                                                    	Tanacetum                                                                                                                                                                                                                                                      	praeteritum                                                                                                                                                                                                                                                    	(Horwood) Heywood                                                                                                                                                                                                                                              	praeteritum                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum praeteritum subsp. praeteritum                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
428	Xeranthemum annuum L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Xeranthemum                                                                                                                                                                                                                                                    	annuum                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Xeranthemum annuum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
429	Anthemis cretica subsp. anatolica (Boiss.) Grierson                                                                                                                                                                                                            	(Boiss.) Grierson                                                                                                               	Subspecies                                        	anatolica                                                                                                                                                                                                                                                      	Anthemis                                                                                                                                                                                                                                                       	cretica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	anatolica                                                                                                                                                                                                                                                      	(Boiss.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis cretica subsp. anatolica                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
430	Anthemis cretica subsp. albida (Boiss.) Grierson                                                                                                                                                                                                               	(Boiss.) Grierson                                                                                                               	Subspecies                                        	albida                                                                                                                                                                                                                                                         	Anthemis                                                                                                                                                                                                                                                       	cretica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	albida                                                                                                                                                                                                                                                         	(Boiss.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis cretica subsp. albida                                                                                                                                                                                                                                 	vielleicht doch ssp anatolica !                                                                                                                                                                                                                                	EMed                                                                                                                                                                                                                                                           	2
431	Anthemis rosea subsp. carnea (Boiss.) Grierson                                                                                                                                                                                                                 	(Boiss.) Grierson                                                                                                               	Subspecies                                        	carnea                                                                                                                                                                                                                                                         	Anthemis                                                                                                                                                                                                                                                       	rosea                                                                                                                                                                                                                                                          	Sm.                                                                                                                                                                                                                                                            	carnea                                                                                                                                                                                                                                                         	(Boiss.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis rosea subsp. carnea                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
432	Anthemis cretica subsp. leucanthemoides (Boiss.) Grierson                                                                                                                                                                                                      	(Boiss.) Grierson                                                                                                               	Subspecies                                        	leucanthemoides                                                                                                                                                                                                                                                	Anthemis                                                                                                                                                                                                                                                       	cretica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	leucanthemoides                                                                                                                                                                                                                                                	(Boiss.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis cretica subsp. leucanthemoides                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
433	Anthemis cf. cretica subsp. anatolica (Boiss.) Grierson                                                                                                                                                                                                        	(Boiss.) Grierson                                                                                                               	Subspecies                                        	anatolica                                                                                                                                                                                                                                                      	Anthemis                                                                                                                                                                                                                                                       	cf. cretica                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	anatolica                                                                                                                                                                                                                                                      	(Boiss.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis cf. cretica subsp. anatolica                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
434	Tragopogon olympicus Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Tragopogon                                                                                                                                                                                                                                                     	olympicus                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tragopogon olympicus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
435	Tragopogon cf. olympicus Boiss.                                                                                                                                                                                                                                	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Tragopogon                                                                                                                                                                                                                                                     	cf. olympicus                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tragopogon cf. olympicus                                                                                                                                                                                                                                       	Rosetten                                                                                                                                                                                                                                                       	End A                                                                                                                                                                                                                                                          	3
436	Scorzonera cana var. cana                                                                                                                                                                                                                                      	                                                                                                                                	Variety                                           	cana                                                                                                                                                                                                                                                           	Scorzonera                                                                                                                                                                                                                                                     	cana                                                                                                                                                                                                                                                           	(C.A.Meyer) Hoffm.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	cana                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera cana var. cana                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
437	Scorzonera cana var. radicosa (Boiss.) D.F.Chamb.                                                                                                                                                                                                              	(Boiss.) D.F.Chamb.                                                                                                             	Variety                                           	radicosa                                                                                                                                                                                                                                                       	Scorzonera                                                                                                                                                                                                                                                     	cana                                                                                                                                                                                                                                                           	(C.A.Meyer) Hoffm.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	radicosa                                                                                                                                                                                                                                                       	(Boiss.) D.F.Chamb.                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Scorzonera cana var. radicosa                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
438	Scorzonera rigida Aucher                                                                                                                                                                                                                                       	Aucher                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	rigida                                                                                                                                                                                                                                                         	Aucher                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera rigida                                                                                                                                                                                                                                              	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	IA                                                                                                                                                                                                                                                             	3
439	Scorzonera cinerea Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	cinerea                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera cilicica                                                                                                                                                                                                                                            	Scorzonera cinerea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
440	Scorzonera spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera spec.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
441	Scorzonera violacea D.F.Chamb.                                                                                                                                                                                                                                 	D.F.Chamb.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	violacea                                                                                                                                                                                                                                                       	D.F.Chamb.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera violacea                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
442	Scorzonera sandrasica Hartvig & Strid                                                                                                                                                                                                                          	Hartvig & Strid                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	sandrasica                                                                                                                                                                                                                                                     	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera sandrasica                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
443	Crepis sancta (L.) Babcock                                                                                                                                                                                                                                     	(L.) Babcock                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	sancta                                                                                                                                                                                                                                                         	(L.) Babcock                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis sancta                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
444	Crepis willdenowii Czerep.                                                                                                                                                                                                                                     	Czerep.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	willdenowii                                                                                                                                                                                                                                                    	Czerep.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis willdenowii                                                                                                                                                                                                                                             	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	IA                                                                                                                                                                                                                                                             	3
445	Achillea falcata L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	falcata                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea falcata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
446	Achillea biebersteinii Afan.                                                                                                                                                                                                                                   	Afan.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	biebersteinii                                                                                                                                                                                                                                                  	Afan.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea biebersteinii                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
447	Achillea kotschyi subsp. canescens Bässler                                                                                                                                                                                                                     	Bässler                                                                                                                         	Subspecies                                        	canescens                                                                                                                                                                                                                                                      	Achillea                                                                                                                                                                                                                                                       	kotschyi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	canescens                                                                                                                                                                                                                                                      	Bässler                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea kotschyi subsp. canescens                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
448	Achillea spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea spec.                                                                                                                                                                                                                                                 	A.falcata ähnlich                                                                                                                                                                                                                                              	spec                                                                                                                                                                                                                                                           	3
449	Inula acaulis var. acaulis                                                                                                                                                                                                                                     	                                                                                                                                	Variety                                           	acaulis                                                                                                                                                                                                                                                        	Inula                                                                                                                                                                                                                                                          	acaulis                                                                                                                                                                                                                                                        	Schott & Kotschy ex Boiss.                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	acaulis                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Inula acaulis var. acaulis                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
450	Inula oculus-christi L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Inula                                                                                                                                                                                                                                                          	oculus-christi                                                                                                                                                                                                                                                 	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Inula oculus-christi                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
451	Tripleurospermum kotschyi (Boiss.) E.Hossain                                                                                                                                                                                                                   	(Boiss.) E.Hossain                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Tripleurospermum                                                                                                                                                                                                                                               	kotschyi                                                                                                                                                                                                                                                       	(Boiss.) E.Hossain                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tripleurospermum kotschyi                                                                                                                                                                                                                                      	evtl = T.oreades                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
452	Jurinella moschus subsp. moschus                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	moschus                                                                                                                                                                                                                                                        	Jurinella                                                                                                                                                                                                                                                      	moschus                                                                                                                                                                                                                                                        	(Hablitz) Bobrov                                                                                                                                                                                                                                               	moschus                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Jurinella moschus subsp. moschus                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
453	Echinops pungens var. pungens                                                                                                                                                                                                                                  	                                                                                                                                	Variety                                           	pungens                                                                                                                                                                                                                                                        	Echinops                                                                                                                                                                                                                                                       	pungens                                                                                                                                                                                                                                                        	Trautv.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	pungens                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Echinops pungens var. pungens                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
454	Onopordum sibthorpianum Boiss. & Heldr.                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Onopordum                                                                                                                                                                                                                                                      	sibthorpianum                                                                                                                                                                                                                                                  	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onopordum sibthorpianum                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
455	Hieracium pannosum Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	pannosum                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hieracium pannosum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
456	Hieracium pilosella L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	pilosella                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella officinarum C.H. & F.W.Schultz                                                                                                                                                                                                                       	Hieracium pilosella                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
457	Scariola viminea (L.) F.W.Schmidt                                                                                                                                                                                                                              	(L.) F.W.Schmidt                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Scariola                                                                                                                                                                                                                                                       	viminea                                                                                                                                                                                                                                                        	(L.) F.W.Schmidt                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scariola viminea                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
458	Hieracium filiferum Tausch                                                                                                                                                                                                                                     	Tausch                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	filiferum                                                                                                                                                                                                                                                      	Tausch                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella piloselloides ssp. megalomastix                                                                                                                                                                                                                      	Hieracium filiferum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
459	Prenanthes glareosa (Schott & Kotschy ex Boiss.) C.Jeffrey                                                                                                                                                                                                     	(Schott & Kotschy ex Boiss.) C.Jeffrey                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Prenanthes                                                                                                                                                                                                                                                     	glareosa                                                                                                                                                                                                                                                       	(Schott & Kotschy ex Boiss.) C.Jeffrey                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Prenanthes glareosa                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
460	Senecio vernalis Waldst. & Kit.                                                                                                                                                                                                                                	Waldst. & Kit.                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	vernalis                                                                                                                                                                                                                                                       	Waldst. & Kit.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio vernalis                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / EMed / IA                                                                                                                                                                                                                                                 	5
461	Erigeron cilicicus Boiss. ex Vierh.                                                                                                                                                                                                                            	Boiss. ex Vierh.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Erigeron                                                                                                                                                                                                                                                       	cilicicus                                                                                                                                                                                                                                                      	Boiss. ex Vierh.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erigeron cilicicus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
462	Alopecurus armenus (C.Koch) Grossh.                                                                                                                                                                                                                            	(C.Koch) Grossh.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Alopecurus                                                                                                                                                                                                                                                     	armenus                                                                                                                                                                                                                                                        	(C.Koch) Grossh.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alopecurus armenus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
463	Alopecurus gerardii Vill.                                                                                                                                                                                                                                      	Vill.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Alopecurus                                                                                                                                                                                                                                                     	gerardii                                                                                                                                                                                                                                                       	Vill.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alopecurus gerardii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
464	Bromus variegatus M.Bieb.                                                                                                                                                                                                                                      	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	variegatus                                                                                                                                                                                                                                                     	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus variegatus                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
465	Bromus japonicus subsp. anatolicus (Boiss. & Heldr.) Pénzes                                                                                                                                                                                                    	(Boiss. & Heldr.) Pénzes                                                                                                        	Subspecies                                        	anatolicus                                                                                                                                                                                                                                                     	Bromus                                                                                                                                                                                                                                                         	japonicus                                                                                                                                                                                                                                                      	Thunb.                                                                                                                                                                                                                                                         	anatolicus                                                                                                                                                                                                                                                     	(Boiss. & Heldr.) Pénzes                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus japonicus subsp. anatolicus                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IrTur                                                                                                                                                                                                                                                    	5
466	Eremopoa songarica (Schrenk) Roshev.                                                                                                                                                                                                                           	(Schrenk) Roshev.                                                                                                               	                                                  	                                                                                                                                                                                                                                                               	Eremopoa                                                                                                                                                                                                                                                       	songarica                                                                                                                                                                                                                                                      	(Schrenk) Roshev.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eremopoa songarica                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
467	Elytrigia repens (L.) Nevski                                                                                                                                                                                                                                   	(L.) Nevski                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	repens                                                                                                                                                                                                                                                         	(L.) Nevski                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia repens                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	4
468	Elytrigia intermedia (Host) Nevski                                                                                                                                                                                                                             	(Host) Nevski                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	intermedia                                                                                                                                                                                                                                                     	(Host) Nevski                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia intermedia                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA / ES / Med                                                                                                                                                                                                                                                  	4
469	Festuca cf. woronowii Hack.                                                                                                                                                                                                                                    	Hack.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	cf. woronowii                                                                                                                                                                                                                                                  	Hack.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca cf. woronowii                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Eux / IA                                                                                                                                                                                                                                                       	3
470	Festuca elwendiana Markgr.-Dann.                                                                                                                                                                                                                               	Markgr.-Dann.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	elwendiana                                                                                                                                                                                                                                                     	Markgr.-Dann.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca elwendiana                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
471	Festuca callieri (Hack. ex Sal.Yves) Markgr.                                                                                                                                                                                                                   	(Hack. ex Sal.Yves) Markgr.                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	callieri                                                                                                                                                                                                                                                       	(Hack. ex Sal.Yves) Markgr.                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca callieri                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
472	Phleum phleoides (L.) H.Karst.                                                                                                                                                                                                                                 	(L.) H.Karst.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Phleum                                                                                                                                                                                                                                                         	phleoides                                                                                                                                                                                                                                                      	(L.) H.Karst.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Phleum phleoides                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	5
473	Milium vernale M.Bieb.                                                                                                                                                                                                                                         	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Milium                                                                                                                                                                                                                                                         	vernale                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Milium vernale                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
474	Stipa pulcherrima subsp. crassiculmis (P.A.Smirn.) Tzvelev.                                                                                                                                                                                                    	(P.A.Smirn.) Tzvelev.                                                                                                           	Subspecies                                        	crassiculmis                                                                                                                                                                                                                                                   	Stipa                                                                                                                                                                                                                                                          	pulcherrima                                                                                                                                                                                                                                                    	C. Koch                                                                                                                                                                                                                                                        	crassiculmis                                                                                                                                                                                                                                                   	(P.A.Smirn.) Tzvelev.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa pulcherrima subsp. crassiculmis                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	3
475	Poa nemoralis L.                                                                                                                                                                                                                                               	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	nemoralis                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa nemoralis                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES / IrTur / N Am                                                                                                                                                                                                                                              	3
476	Poa compressa L.                                                                                                                                                                                                                                               	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Poa                                                                                                                                                                                                                                                            	compressa                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poa compressa                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES / IrTur / N Am                                                                                                                                                                                                                                              	3
477	Anthoxanthum spec.                                                                                                                                                                                                                                             	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Anthoxanthum                                                                                                                                                                                                                                                   	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthoxanthum spec.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
478	Dactylis spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Dactylis                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dactylis spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
479	Bromus squarrosus L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	squarrosus                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus squarrosus                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
480	Festuca beckeri (Hack.) Trautv.                                                                                                                                                                                                                                	(Hack.) Trautv.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	beckeri                                                                                                                                                                                                                                                        	(Hack.) Trautv.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca beckeri                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
481	Festuca subgenus Leucopoda spec.                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	subgenus Leucopoda spec.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca subgenus Leucopoda spec.                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
482	Poaceae spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Poaceae                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Poaceae spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
483	Centaurea virgata ?A? Lam.                                                                                                                                                                                                                                     	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	virgata ?A?                                                                                                                                                                                                                                                    	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea virgata ?A?                                                                                                                                                                                                                                          	group A                                                                                                                                                                                                                                                        	IA                                                                                                                                                                                                                                                             	2
484	Centaurea virgata ?B? Lam.                                                                                                                                                                                                                                     	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	virgata ?B?                                                                                                                                                                                                                                                    	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea virgata ?B?                                                                                                                                                                                                                                          	group B                                                                                                                                                                                                                                                        	IA                                                                                                                                                                                                                                                             	2
485	Centaurea triumfettii All.                                                                                                                                                                                                                                     	All.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	triumfettii                                                                                                                                                                                                                                                    	All.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea triumfettii                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
487	Centaurea mucronifera DC.                                                                                                                                                                                                                                      	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	mucronifera                                                                                                                                                                                                                                                    	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea mucronifera                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
488	Centaurea urvillei subsp. urvillei                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	urvillei                                                                                                                                                                                                                                                       	Centaurea                                                                                                                                                                                                                                                      	urvillei                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	urvillei                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea urvillei subsp. urvillei                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
489	Centaurea reuterana var. reuterana                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	reuterana                                                                                                                                                                                                                                                      	Centaurea                                                                                                                                                                                                                                                      	reuterana                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	reuterana                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea reuterana var. reuterana                                                                                                                                                                                                                             	vorher Steppen VC                                                                                                                                                                                                                                              	End BT                                                                                                                                                                                                                                                         	3
490	Centaurea bourgaei Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	bourgaei                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea bourgaei                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
491	Centaurea luschaniana Heimerl                                                                                                                                                                                                                                  	Heimerl                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	luschaniana                                                                                                                                                                                                                                                    	Heimerl                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea luschaniana                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
492	Centaurea pichleri subsp. extrarosularis (Hayek & Siehe) Wagenitz                                                                                                                                                                                              	(Hayek & Siehe) Wagenitz                                                                                                        	Subspecies                                        	extrarosularis                                                                                                                                                                                                                                                 	Centaurea                                                                                                                                                                                                                                                      	pichleri                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	extrarosularis                                                                                                                                                                                                                                                 	(Hayek & Siehe) Wagenitz                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea pichleri subsp. extrarosularis                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
493	Centaurea drabifolia subsp. austro-occidentalis Wagenitz                                                                                                                                                                                                       	Wagenitz                                                                                                                        	Subspecies                                        	austro-occidentalis                                                                                                                                                                                                                                            	Centaurea                                                                                                                                                                                                                                                      	drabifolia                                                                                                                                                                                                                                                     	Sm.                                                                                                                                                                                                                                                            	austro-occidentalis                                                                                                                                                                                                                                            	Wagenitz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea drabifolia subsp. austro-occidentalis                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
494	Centaurea drabifolia subsp. cappadocica (DC.) Wagnitz                                                                                                                                                                                                          	(DC.) Wagnitz                                                                                                                   	Subspecies                                        	cappadocica                                                                                                                                                                                                                                                    	Centaurea                                                                                                                                                                                                                                                      	drabifolia                                                                                                                                                                                                                                                     	Sm.                                                                                                                                                                                                                                                            	cappadocica                                                                                                                                                                                                                                                    	(DC.) Wagnitz                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea drabifolia subsp. cappadocica                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
495	Centaurea pestalozzae Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	pestalozzae                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea pestalozzae                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
496	Centaurea cariensis subsp. maculiceps (O.Schwarz) Wagenitz                                                                                                                                                                                                     	(O.Schwarz) Wagenitz                                                                                                            	Subspecies                                        	maculiceps                                                                                                                                                                                                                                                     	Centaurea                                                                                                                                                                                                                                                      	cariensis                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	maculiceps                                                                                                                                                                                                                                                     	(O.Schwarz) Wagenitz                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea cariensis subsp. maculiceps                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
497	Centaurea carduiformis var. carduiformis                                                                                                                                                                                                                       	                                                                                                                                	Variety                                           	carduiformis                                                                                                                                                                                                                                                   	Centaurea                                                                                                                                                                                                                                                      	carduiformis                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	carduiformis                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	carduiformis                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea carduiformis subsp. carduiformis var. carduiformis                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
498	Lactuca intricata Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Lactuca                                                                                                                                                                                                                                                        	intricata                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lactuca intricata                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
499	Crepis armena DC.                                                                                                                                                                                                                                              	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	armena                                                                                                                                                                                                                                                         	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis armena                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
500	Taraxacum crepidiforme subsp. crepidiforme                                                                                                                                                                                                                     	                                                                                                                                	Subspecies                                        	crepidiforme                                                                                                                                                                                                                                                   	Taraxacum                                                                                                                                                                                                                                                      	crepidiforme                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	crepidiforme                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum crepidiforme subsp. crepidiforme                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
502	Taraxacum hellenicum Dahlst.                                                                                                                                                                                                                                   	Dahlst.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	hellenicum                                                                                                                                                                                                                                                     	Dahlst.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum hellenicum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	3
503	Taraxacum sintenisii Dahlst.                                                                                                                                                                                                                                   	Dahlst.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	sintenisii                                                                                                                                                                                                                                                     	Dahlst.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum sintenisii                                                                                                                                                                                                                                           	evtl = T.hellenicum. nix passt wirklich !!!                                                                                                                                                                                                                    	EMed                                                                                                                                                                                                                                                           	3
504	Taraxacum spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
505	Carex tristis M.Bieb.                                                                                                                                                                                                                                          	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Carex                                                                                                                                                                                                                                                          	tristis                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carex tristis                                                                                                                                                                                                                                                  	nicht in FE                                                                                                                                                                                                                                                    	Eux                                                                                                                                                                                                                                                            	3
506	Kobresia humilis (C.A.Meyer ex Trautv.) Sergievsk.                                                                                                                                                                                                             	(C.A.Meyer ex Trautv.) Sergievsk.                                                                                               	                                                  	                                                                                                                                                                                                                                                               	Kobresia                                                                                                                                                                                                                                                       	humilis                                                                                                                                                                                                                                                        	(C.A.Meyer ex Trautv.) Sergievsk.                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Kobresia simpliciuscula                                                                                                                                                                                                                                        	Kobresia humilis                                                                                                                                                                                                                                               	K.humilis ist von Dicoret im B Herbar nachbestimmt worden. Dabei sind alle K.simpliciuscula zu humilis geworden. deshalb die annahme, dass auch unsere humilis sind.\nsiehe Hegi.                                                                               	ES                                                                                                                                                                                                                                                             	3
507	Carex atrata s.l. L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Carex                                                                                                                                                                                                                                                          	atrata s.l.                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carex atrata s.l.                                                                                                                                                                                                                                              	europa, alpen, krim                                                                                                                                                                                                                                            	ES                                                                                                                                                                                                                                                             	3
508	Swertia longifolia Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Swertia                                                                                                                                                                                                                                                        	longifolia                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Swertia longifolia                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
509	Allium scorodoprasum subsp. rotundum (L.) Stearn                                                                                                                                                                                                               	(L.) Stearn                                                                                                                     	Subspecies                                        	rotundum                                                                                                                                                                                                                                                       	Allium                                                                                                                                                                                                                                                         	scorodoprasum                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	rotundum                                                                                                                                                                                                                                                       	(L.) Stearn                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium scorodoprasum subsp. rotundum                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	4
510	Allium flavum var. tauricum                                                                                                                                                                                                                                    	                                                                                                                                	Variety                                           	tauricum                                                                                                                                                                                                                                                       	Allium                                                                                                                                                                                                                                                         	flavum                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	tauricum                                                                                                                                                                                                                                                       	(Besser ex Rchb.) Stearn                                                                                                                                                                                                                                       	tauricum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium flavum subsp. tauricum var. tauricum                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	4
511	Allium cf. scorodoprasum subsp. rotundum (L.) Stearn                                                                                                                                                                                                           	(L.) Stearn                                                                                                                     	Subspecies                                        	rotundum                                                                                                                                                                                                                                                       	Allium                                                                                                                                                                                                                                                         	cf. scorodoprasum                                                                                                                                                                                                                                              	L.                                                                                                                                                                                                                                                             	rotundum                                                                                                                                                                                                                                                       	(L.) Stearn                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium cf. scorodoprasum subsp. rotundum                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	4
512	Allium tauricola Boiss.                                                                                                                                                                                                                                        	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	tauricola                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium tauricola                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	4
513	Allium callidictyon C.A.Meyer ex Kunth                                                                                                                                                                                                                         	C.A.Meyer ex Kunth                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	callidictyon                                                                                                                                                                                                                                                   	C.A.Meyer ex Kunth                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium callidictyon                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
514	Allium spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
515	Ornithogalum alpigenum Stapf                                                                                                                                                                                                                                   	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	alpigenum                                                                                                                                                                                                                                                      	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum alpigenum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	4
516	Ornithogalum spec.                                                                                                                                                                                                                                             	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum spec.                                                                                                                                                                                                                                             	O. orthophyllum / oligophyllum ???                                                                                                                                                                                                                             	spec                                                                                                                                                                                                                                                           	4
517	Gagea uliginosa Siehe & Pascher                                                                                                                                                                                                                                	Siehe & Pascher                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Gagea                                                                                                                                                                                                                                                          	uliginosa                                                                                                                                                                                                                                                      	Siehe & Pascher                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gagea uliginosa                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
518	Ornithogalum comosum L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	comosum                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum comosum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	4
519	Scilla pleiophylla Speta                                                                                                                                                                                                                                       	Speta                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Scilla                                                                                                                                                                                                                                                         	pleiophylla                                                                                                                                                                                                                                                    	Speta                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scilla bifolia var. polyphylla                                                                                                                                                                                                                                 	Scilla pleiophylla                                                                                                                                                                                                                                             	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	EMed                                                                                                                                                                                                                                                           	4
520	Colchicum cf. variegatum L.                                                                                                                                                                                                                                    	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Colchicum                                                                                                                                                                                                                                                      	cf. variegatum                                                                                                                                                                                                                                                 	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Colchicum cf. variegatum                                                                                                                                                                                                                                       	evtl = C.kotschyi                                                                                                                                                                                                                                              	EMed                                                                                                                                                                                                                                                           	4
522	Fritillaria cf. crassifolia Boiss. & Huet                                                                                                                                                                                                                      	Boiss. & Huet                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Fritillaria                                                                                                                                                                                                                                                    	cf. crassifolia                                                                                                                                                                                                                                                	Boiss. & Huet                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fritillaria cf. crassifolia                                                                                                                                                                                                                                    	oder F.pinardii                                                                                                                                                                                                                                                	IA                                                                                                                                                                                                                                                             	4
523	Muscari cf. armeniacum Leichtlin ex Baker                                                                                                                                                                                                                      	Leichtlin ex Baker                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	cf. armeniacum                                                                                                                                                                                                                                                 	Leichtlin ex Baker                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari cf. armeniacum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	4
524	Muscari cf. neglectum / armeniacum / bourgaei                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	cf. neglectum / armeniacum / bourgaei                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari cf. neglectum / armeniacum / bourgaei                                                                                                                                                                                                                  	anhand Kapsel größe + verbreitung                                                                                                                                                                                                                              	Unknown                                                                                                                                                                                                                                                        	4
525	Ornithogalum cf. oligophyllum E.D.Clarke                                                                                                                                                                                                                       	E.D.Clarke                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	cf. oligophyllum                                                                                                                                                                                                                                               	E.D.Clarke                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum cf. oligophyllum                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
526	Ornithogalum oligophyllum E.D.Clarke                                                                                                                                                                                                                           	E.D.Clarke                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	oligophyllum                                                                                                                                                                                                                                                   	E.D.Clarke                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum oligophyllum                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
527	Asphodeline taurica (Pall.) Kunth                                                                                                                                                                                                                              	(Pall.) Kunth                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Asphodeline                                                                                                                                                                                                                                                    	taurica                                                                                                                                                                                                                                                        	(Pall.) Kunth                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asphodeline taurica                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	4
528	Asphodeline rigidifolia (Boiss.) Baker                                                                                                                                                                                                                         	(Boiss.) Baker                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Asphodeline                                                                                                                                                                                                                                                    	rigidifolia                                                                                                                                                                                                                                                    	(Boiss.) Baker                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asphodeline rigidifolia                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	4
529	Arum maculatum L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Arum                                                                                                                                                                                                                                                           	maculatum                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arum maculatum                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	4
530	Muscari tenuiflorum Tausch                                                                                                                                                                                                                                     	Tausch                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	tenuiflorum                                                                                                                                                                                                                                                    	Tausch                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari tenuiflorum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	4
531	Potentilla pulvinaris subsp. pulvinaris                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	pulvinaris                                                                                                                                                                                                                                                     	Potentilla                                                                                                                                                                                                                                                     	pulvinaris                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	pulvinaris                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla pulvinaris subsp. pulvinaris                                                                                                                                                                                                                        	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	End loc                                                                                                                                                                                                                                                        	2
533	Sorbus spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Sorbus                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sorbus spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
534	Brassica elongata Ehrh.                                                                                                                                                                                                                                        	Ehrh.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Brassica                                                                                                                                                                                                                                                       	elongata                                                                                                                                                                                                                                                       	Ehrh.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Brassica elongata                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
536	Hesperis matronalis subsp. cilicica (Siehe ex Bornm.) Cullen                                                                                                                                                                                                   	(Siehe ex Bornm.) Cullen                                                                                                        	Subspecies                                        	cilicica                                                                                                                                                                                                                                                       	Hesperis                                                                                                                                                                                                                                                       	matronalis                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	cilicica                                                                                                                                                                                                                                                       	(Siehe ex Bornm.) Cullen                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hesperis matronalis subsp. cilicica                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
537	Viola modesta Fenzl                                                                                                                                                                                                                                            	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Viola                                                                                                                                                                                                                                                          	modesta                                                                                                                                                                                                                                                        	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Viola modesta                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	5
538	Helianthemum nummularium subsp. nummularium                                                                                                                                                                                                                    	                                                                                                                                	Subspecies                                        	nummularium                                                                                                                                                                                                                                                    	Helianthemum                                                                                                                                                                                                                                                   	nummularium                                                                                                                                                                                                                                                    	(L.) Miller                                                                                                                                                                                                                                                    	nummularium                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Helianthemum nummularium subsp. nummularium                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	2
539	Oxyria digyna (L.) Hill                                                                                                                                                                                                                                        	(L.) Hill                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Oxyria                                                                                                                                                                                                                                                         	digyna                                                                                                                                                                                                                                                         	(L.) Hill                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Oxyria digyna                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
540	Erodium cedrorum subsp. cedrorum                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	cedrorum                                                                                                                                                                                                                                                       	Erodium                                                                                                                                                                                                                                                        	cedrorum                                                                                                                                                                                                                                                       	Schott & Kotschy                                                                                                                                                                                                                                               	cedrorum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erodium cedrorum subsp. cedrorum                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
541	Silene chlorifolia Sm.                                                                                                                                                                                                                                         	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	chlorifolia                                                                                                                                                                                                                                                    	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene chlorifolia                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
542	Silene fenzlii Boiss. & Bal.                                                                                                                                                                                                                                   	Boiss. & Bal.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	fenzlii                                                                                                                                                                                                                                                        	Boiss. & Bal.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene fenzlii                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
543	Minuartia verna s.l. (L.) Hiern                                                                                                                                                                                                                                	(L.) Hiern                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	verna s.l.                                                                                                                                                                                                                                                     	(L.) Hiern                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia verna s.l.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	2
544	Cerastium dichotomum L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Cerastium                                                                                                                                                                                                                                                      	dichotomum                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cerastium dichotomum                                                                                                                                                                                                                                           	ssp dichotomum in MClist nicht mehr existent !                                                                                                                                                                                                                 	EMed                                                                                                                                                                                                                                                           	5
545	Gypsophila laricina Schreb.                                                                                                                                                                                                                                    	Schreb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Gypsophila                                                                                                                                                                                                                                                     	laricina                                                                                                                                                                                                                                                       	Schreb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	G.sphaerocephala Fenzl ex Txhihat var sphaerocephala                                                                                                                                                                                                           	Gypsophila laricina                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
546	Gypsophila elegans M.Bieb.                                                                                                                                                                                                                                     	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Gypsophila                                                                                                                                                                                                                                                     	elegans                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gypsophila elegans                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
547	Alkanna pseudotinctoria Hub.-Mor.                                                                                                                                                                                                                              	Hub.-Mor.                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Alkanna                                                                                                                                                                                                                                                        	pseudotinctoria                                                                                                                                                                                                                                                	Hub.-Mor.                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna pseudotinctoria                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
548	Salvia caespitosa Benth.                                                                                                                                                                                                                                       	Benth.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	caespitosa                                                                                                                                                                                                                                                     	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia caespitosa                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
549	Nepeta spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
550	Orobanche laevis L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	laevis                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche arenaria Borkh.                                                                                                                                                                                                                                      	Orobanche laevis                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	4
551	Orobanche caryophyllacea Sm.                                                                                                                                                                                                                                   	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	caryophyllacea                                                                                                                                                                                                                                                 	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche caryophyllacea                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	4
552	Orobanche fuliginosa Jord.                                                                                                                                                                                                                                     	Jord.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	fuliginosa                                                                                                                                                                                                                                                     	Jord.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche fuliginosa                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	4
553	Orobanche oxyloba (Reut.) Beck                                                                                                                                                                                                                                 	(Reut.) Beck                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	oxyloba                                                                                                                                                                                                                                                        	(Reut.) Beck                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche oxyloba                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA / EMed                                                                                                                                                                                                                                                      	4
554	Orobanche coelestis (Reut.) Beck                                                                                                                                                                                                                               	(Reut.) Beck                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	coelestis                                                                                                                                                                                                                                                      	(Reut.) Beck                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche coelestis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med / IrTur                                                                                                                                                                                                                                                    	4
555	Orobanche rechingeri Gilli                                                                                                                                                                                                                                     	Gilli                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Orobanche                                                                                                                                                                                                                                                      	rechingeri                                                                                                                                                                                                                                                     	Gilli                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Orobanche caucasica G. Beck                                                                                                                                                                                                                                    	Orobanche rechingeri                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
556	Verbascum spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
557	Erodium cedrorum s.l. Schott & Kotschy                                                                                                                                                                                                                         	Schott & Kotschy                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Erodium                                                                                                                                                                                                                                                        	cedrorum s.l.                                                                                                                                                                                                                                                  	Schott & Kotschy                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erodium cedrorum s.l.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
558	Galium incanum s.l. Sm.                                                                                                                                                                                                                                        	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	incanum s.l.                                                                                                                                                                                                                                                   	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium incanum s.l.                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
569	Sideritis libanotica subsp. violascens (P.H.Davis) P.H.Davis                                                                                                                                                                                                   	(P.H.Davis) P.H.Davis                                                                                                           	Subspecies                                        	violascens                                                                                                                                                                                                                                                     	Sideritis                                                                                                                                                                                                                                                      	libanotica                                                                                                                                                                                                                                                     	Labill.                                                                                                                                                                                                                                                        	violascens                                                                                                                                                                                                                                                     	(P.H.Davis) P.H.Davis                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis libanotica subsp. violascens                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	2
570	Gagea spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Gagea                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gagea spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
571	Erigeron acer subsp. pycnotrichus (Vierh.) Grierson                                                                                                                                                                                                            	(Vierh.) Grierson                                                                                                               	Subspecies                                        	pycnotrichus                                                                                                                                                                                                                                                   	Erigeron                                                                                                                                                                                                                                                       	acer                                                                                                                                                                                                                                                           	L.                                                                                                                                                                                                                                                             	pycnotrichus                                                                                                                                                                                                                                                   	(Vierh.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erigeron acer subsp. pycnotrichus                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
572	Cirsium cilicicum P.H.Davis & Parris                                                                                                                                                                                                                           	P.H.Davis & Parris                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Cirsium                                                                                                                                                                                                                                                        	cilicicum                                                                                                                                                                                                                                                      	P.H.Davis & Parris                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cirsium cilicicum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	3
573	Taraxacum cf. serotinum (Waldst. & Kit.) Poir.                                                                                                                                                                                                                 	(Waldst. & Kit.) Poir.                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	cf. serotinum                                                                                                                                                                                                                                                  	(Waldst. & Kit.) Poir.                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum cf. serotinum                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
575	Taraxacum assemanii Blanche                                                                                                                                                                                                                                    	Blanche                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	assemanii                                                                                                                                                                                                                                                      	Blanche                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum assemanii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
576	Logfia arvensis (L.) Holub                                                                                                                                                                                                                                     	(L.) Holub                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Logfia                                                                                                                                                                                                                                                         	arvensis                                                                                                                                                                                                                                                       	(L.) Holub                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Logfia arvensis                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	5
577	Tragopogon spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Tragopogon                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tragopogon spec.                                                                                                                                                                                                                                               	beleg 1318 ebenfalls ! aber doppelt.                                                                                                                                                                                                                           	spec                                                                                                                                                                                                                                                           	3
578	Salvia spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
579	Senecio spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
580	Asteraceae spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Asteraceae                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asteraceae spec.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
583	Dipsacaceae spec.                                                                                                                                                                                                                                              	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Dipsacaceae                                                                                                                                                                                                                                                    	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dipsacaceae spec.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
584	Rubiaceae spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Rubiaceae                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rubiaceae spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
588	Crepis macropus Boiss & Heldr                                                                                                                                                                                                                                  	Boiss & Heldr                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Crepis                                                                                                                                                                                                                                                         	macropus                                                                                                                                                                                                                                                       	Boiss & Heldr                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crepis macropus                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
591	Anthyllis spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Anthyllis                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthyllis spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
592	Chenopodiaceae spec.                                                                                                                                                                                                                                           	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Chenopodiaceae                                                                                                                                                                                                                                                 	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Chenopodiaceae spec.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
593	Convolvulus arvensis L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Convolvulus                                                                                                                                                                                                                                                    	arvensis                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Convolvulus arvensis                                                                                                                                                                                                                                           	häufig in gestörten orten                                                                                                                                                                                                                                      	Plur                                                                                                                                                                                                                                                           	3
594	Convolvulus compactus Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Convolvulus                                                                                                                                                                                                                                                    	compactus                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Convolvulus compactus                                                                                                                                                                                                                                          	kuppen art. polsterförmig, kompakt.                                                                                                                                                                                                                            	IA / Med                                                                                                                                                                                                                                                       	2
595	Trifolium pannonicum subsp. elongatum (Willd.) Zohary                                                                                                                                                                                                          	(Willd.) Zohary                                                                                                                 	Subspecies                                        	elongatum                                                                                                                                                                                                                                                      	Trifolium                                                                                                                                                                                                                                                      	pannonicum                                                                                                                                                                                                                                                     	Jacq.                                                                                                                                                                                                                                                          	elongatum                                                                                                                                                                                                                                                      	(Willd.) Zohary                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium pannonicum subsp. elongatum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
596	Alyssum propinquum Baumg.                                                                                                                                                                                                                                      	Baumg.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	propinquum                                                                                                                                                                                                                                                     	Baumg.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum propinquum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
598	Thymus spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Thymus                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
599	Satureja graveolens (M.Bieb.) Caruel                                                                                                                                                                                                                           	(M.Bieb.) Caruel                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Satureja                                                                                                                                                                                                                                                       	graveolens                                                                                                                                                                                                                                                     	(M.Bieb.) Caruel                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Satureja graveolens                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
600	Marrubium astracanicum subsp. astracanicum                                                                                                                                                                                                                     	                                                                                                                                	Subspecies                                        	astracanicum                                                                                                                                                                                                                                                   	Marrubium                                                                                                                                                                                                                                                      	astracanicum                                                                                                                                                                                                                                                   	Jacq.                                                                                                                                                                                                                                                          	astracanicum                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium astracanicum subsp. astracanicum                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
601	Marrubium cf. globosum var.                                                                                                                                                                                                                                    	                                                                                                                                	Variety                                           	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	cf. globosum                                                                                                                                                                                                                                                   	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium cf. globosum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
602	Marrubium spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
603	Marrubium cf. trachyticum Boiss.                                                                                                                                                                                                                               	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Marrubium                                                                                                                                                                                                                                                      	cf. trachyticum                                                                                                                                                                                                                                                	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Marrubium cf. trachyticum                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
605	Teucrium alyssifolium Stapf                                                                                                                                                                                                                                    	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Teucrium                                                                                                                                                                                                                                                       	alyssifolium                                                                                                                                                                                                                                                   	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium alyssifolium                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
606	Teucrium polium L.                                                                                                                                                                                                                                             	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Teucrium                                                                                                                                                                                                                                                       	polium                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Teucrium polium                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
607	Lamium lycium Boiss.                                                                                                                                                                                                                                           	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Lamium                                                                                                                                                                                                                                                         	lycium                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lamium lycium                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
608	Lamium garganicum subsp. pulchrum R.B. Mill                                                                                                                                                                                                                    	R.B. Mill                                                                                                                       	Subspecies                                        	pulchrum                                                                                                                                                                                                                                                       	Lamium                                                                                                                                                                                                                                                         	garganicum                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	pulchrum                                                                                                                                                                                                                                                       	R.B. Mill                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lamium garganicum subsp. pulchrum                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
609	Lamium macrodon Boiss. & Huet                                                                                                                                                                                                                                  	Boiss. & Huet                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Lamium                                                                                                                                                                                                                                                         	macrodon                                                                                                                                                                                                                                                       	Boiss. & Huet                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lamium macrodon                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
610	Nepeta concolor Boiss. & Heldr.                                                                                                                                                                                                                                	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	concolor                                                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta concolor                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
611	Nepeta isaurica Boiss. & Heldr.                                                                                                                                                                                                                                	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	isaurica                                                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta isaurica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
612	Nepeta nuda L.                                                                                                                                                                                                                                                 	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Nepeta                                                                                                                                                                                                                                                         	nuda                                                                                                                                                                                                                                                           	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nepeta nuda                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
613	Scutellaria albida subsp. colchica (Rech.f.) J.R.Edm.                                                                                                                                                                                                          	(Rech.f.) J.R.Edm.                                                                                                              	Subspecies                                        	colchica                                                                                                                                                                                                                                                       	Scutellaria                                                                                                                                                                                                                                                    	albida                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	colchica                                                                                                                                                                                                                                                       	(Rech.f.) J.R.Edm.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria albida subsp. colchica                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	2
614	Salvia verticillata subsp. amasiaca (Freyn & Bornm.) Bornm.                                                                                                                                                                                                    	(Freyn & Bornm.) Bornm.                                                                                                         	Subspecies                                        	amasiaca                                                                                                                                                                                                                                                       	Salvia                                                                                                                                                                                                                                                         	verticillata                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	amasiaca                                                                                                                                                                                                                                                       	(Freyn & Bornm.) Bornm.                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia verticillata subsp. amasiaca                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
615	Salvia dichroantha Stapf                                                                                                                                                                                                                                       	Stapf                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	dichroantha                                                                                                                                                                                                                                                    	Stapf                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia dichroantha                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
616	Scutellaria orientalis subsp. pinnatifida J.R.Edm.                                                                                                                                                                                                             	J.R.Edm.                                                                                                                        	Subspecies                                        	pinnatifida                                                                                                                                                                                                                                                    	Scutellaria                                                                                                                                                                                                                                                    	orientalis                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	pinnatifida                                                                                                                                                                                                                                                    	J.R.Edm.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scutellaria orientalis subsp. pinnatifida                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
617	Satureja troodi (Post) Holmboe                                                                                                                                                                                                                                 	(Post) Holmboe                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Satureja                                                                                                                                                                                                                                                       	troodi                                                                                                                                                                                                                                                         	(Post) Holmboe                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acinos troodi (Post) Holmboe                                                                                                                                                                                                                                   	Satureja troodi                                                                                                                                                                                                                                                	= Calamintha troodi ?                                                                                                                                                                                                                                          	End loc                                                                                                                                                                                                                                                        	5
618	Ajuga chamaepitys subsp. glareosa P.H. Davis                                                                                                                                                                                                                   	P.H. Davis                                                                                                                      	Subspecies                                        	glareosa                                                                                                                                                                                                                                                       	Ajuga                                                                                                                                                                                                                                                          	chamaepitys                                                                                                                                                                                                                                                    	(L.) Schreb.                                                                                                                                                                                                                                                   	glareosa                                                                                                                                                                                                                                                       	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ajuga chamaepitys subsp. glareosa                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
619	Stachys lavandulifolia Vahl                                                                                                                                                                                                                                    	Vahl                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Stachys                                                                                                                                                                                                                                                        	lavandulifolia                                                                                                                                                                                                                                                 	Vahl                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys lavandulifolia                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
620	Stachys cretica subsp. anatolica Rech.f.                                                                                                                                                                                                                       	Rech.f.                                                                                                                         	Subspecies                                        	anatolica                                                                                                                                                                                                                                                      	Stachys                                                                                                                                                                                                                                                        	cretica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	anatolica                                                                                                                                                                                                                                                      	Rech.f.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys cretica subsp. anatolica                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
621	Stachys macrantha (C. Koch) Stearn                                                                                                                                                                                                                             	(C. Koch) Stearn                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Stachys                                                                                                                                                                                                                                                        	macrantha                                                                                                                                                                                                                                                      	(C. Koch) Stearn                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys macrantha                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
622	Stachys iberica subsp. iberica                                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	iberica                                                                                                                                                                                                                                                        	Stachys                                                                                                                                                                                                                                                        	iberica                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	iberica                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys iberica subsp. iberica                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
623	Stachys iberica subsp. georgica Rech.f.                                                                                                                                                                                                                        	Rech.f.                                                                                                                         	Subspecies                                        	georgica                                                                                                                                                                                                                                                       	Stachys                                                                                                                                                                                                                                                        	iberica                                                                                                                                                                                                                                                        	M.Bieb.                                                                                                                                                                                                                                                        	georgica                                                                                                                                                                                                                                                       	Rech.f.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys iberica subsp. georgica                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
624	Stachys balansae subsp. balansae                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	balansae                                                                                                                                                                                                                                                       	Stachys                                                                                                                                                                                                                                                        	balansae                                                                                                                                                                                                                                                       	Boiss. & Kotschy                                                                                                                                                                                                                                               	balansae                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stachys balansae subsp. balansae                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pont / IA                                                                                                                                                                                                                                                      	3
625	Sideritis spec. nova                                                                                                                                                                                                                                           	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	spec. nova                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis spec. nova                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
626	Sideritis condensata Benth.                                                                                                                                                                                                                                    	Benth.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Sideritis                                                                                                                                                                                                                                                      	condensata                                                                                                                                                                                                                                                     	Benth.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sideritis condensata                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
627	Plantago coronopus L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	coronopus                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plantago coronopus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
628	Plantago spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Plantago                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Plantago spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
629	Thesium spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Thesium                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thesium spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
630	Globularia dumulosa O.Schwarz                                                                                                                                                                                                                                  	O.Schwarz                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Globularia                                                                                                                                                                                                                                                     	dumulosa                                                                                                                                                                                                                                                       	O.Schwarz                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Globularia dumulosa                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
639	Cardamine raphanifolia subsp. acris (Gris) O.E.Schulz                                                                                                                                                                                                          	(Gris) O.E.Schulz                                                                                                               	Subspecies                                        	acris                                                                                                                                                                                                                                                          	Cardamine                                                                                                                                                                                                                                                      	raphanifolia                                                                                                                                                                                                                                                   	Pourr.                                                                                                                                                                                                                                                         	acris                                                                                                                                                                                                                                                          	(Gris) O.E.Schulz                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cardamine raphanifolia subsp. acris                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	3
640	Alyssoides urticulata (L.) Moench                                                                                                                                                                                                                              	(L.) Moench                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Alyssoides                                                                                                                                                                                                                                                     	urticulata                                                                                                                                                                                                                                                     	(L.) Moench                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssoides urticulata                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Eux / EMed                                                                                                                                                                                                                                                     	2
643	Alyssum huber- morathii Dudley                                                                                                                                                                                                                                 	Dudley                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	huber- morathii                                                                                                                                                                                                                                                	Dudley                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum huber- morathii                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
644	Alyssum desertorum var. desertorum                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	desertorum                                                                                                                                                                                                                                                     	Alyssum                                                                                                                                                                                                                                                        	desertorum                                                                                                                                                                                                                                                     	Stapf.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	desertorum                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum desertorum var. desertorum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	5
645	Alyssum hirsutum M.Bieb.                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	hirsutum                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum hirsutum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / ES / IA                                                                                                                                                                                                                                                 	2
647	Alyssum mouradicum Boiss. & Balansa                                                                                                                                                                                                                            	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Alyssum                                                                                                                                                                                                                                                        	mouradicum                                                                                                                                                                                                                                                     	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum mouradicum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
648	Fibigia clypeata (L.) L.W.Medicus                                                                                                                                                                                                                              	(L.) L.W.Medicus                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Fibigia                                                                                                                                                                                                                                                        	clypeata                                                                                                                                                                                                                                                       	(L.) L.W.Medicus                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fibigia clypeata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
649	Cardaria draba subsp. draba                                                                                                                                                                                                                                    	                                                                                                                                	Subspecies                                        	draba                                                                                                                                                                                                                                                          	Cardaria                                                                                                                                                                                                                                                       	draba                                                                                                                                                                                                                                                          	(L.) Desv.                                                                                                                                                                                                                                                     	draba                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cardaria draba subsp. draba                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
651	Erysimum crassipes J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                       	J.C.Fisch. & C.A.Mey.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	crassipes                                                                                                                                                                                                                                                      	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum crassipes                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
652	Erysimum pulchellum (Willd.) Gay                                                                                                                                                                                                                               	(Willd.) Gay                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	pulchellum                                                                                                                                                                                                                                                     	(Willd.) Gay                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum pulchellum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Pont / IA                                                                                                                                                                                                                                                      	3
653	Erysimum pusillum Bory & Chaub.                                                                                                                                                                                                                                	Bory & Chaub.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	pusillum                                                                                                                                                                                                                                                       	Bory & Chaub.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum pusillum                                                                                                                                                                                                                                              	in MClist nur in Griechenland                                                                                                                                                                                                                                  	EMed                                                                                                                                                                                                                                                           	3
654	Erysimum cuspidatum (M.Bieb.) DC.                                                                                                                                                                                                                              	(M.Bieb.) DC.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Erysimum                                                                                                                                                                                                                                                       	cuspidatum                                                                                                                                                                                                                                                     	(M.Bieb.) DC.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erysimum cuspidatum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	2
655	Aethionema spicatum Post                                                                                                                                                                                                                                       	Post                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Aethionema                                                                                                                                                                                                                                                     	spicatum                                                                                                                                                                                                                                                       	Post                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aethionema spicatum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
658	Sedum telephium subsp. maximum (L.) Schinz & Thell.                                                                                                                                                                                                            	(L.) Schinz & Thell.                                                                                                            	Subspecies                                        	maximum                                                                                                                                                                                                                                                        	Sedum                                                                                                                                                                                                                                                          	telephium                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	maximum                                                                                                                                                                                                                                                        	(L.) Schinz & Thell.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum telephium subsp. maximum                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
659	Sedum pallidum var. bithynicum (Boiss.) D.F.Chamb.                                                                                                                                                                                                             	(Boiss.) D.F.Chamb.                                                                                                             	Variety                                           	bithynicum                                                                                                                                                                                                                                                     	Sedum                                                                                                                                                                                                                                                          	pallidum                                                                                                                                                                                                                                                       	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	bithynicum                                                                                                                                                                                                                                                     	(Boiss.) D.F.Chamb.                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Sedum pallidum var. bithynicum                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
661	Sedum acre L.                                                                                                                                                                                                                                                  	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	acre                                                                                                                                                                                                                                                           	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sedum acre                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	2
662	Sedum urvillei DC.                                                                                                                                                                                                                                             	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Sedum                                                                                                                                                                                                                                                          	urvillei                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	S.sartorianum Boiss.                                                                                                                                                                                                                                           	Sedum urvillei                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
663	Sempervivum transcaucasicum Muirhead                                                                                                                                                                                                                           	Muirhead                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Sempervivum                                                                                                                                                                                                                                                    	transcaucasicum                                                                                                                                                                                                                                                	Muirhead                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Sempervivum transcaucasicum                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	2
664	Rosularia libanotica (Labill.) Muirhead                                                                                                                                                                                                                        	(Labill.) Muirhead                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Rosularia                                                                                                                                                                                                                                                      	libanotica                                                                                                                                                                                                                                                     	(Labill.) Muirhead                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosularia libanotica                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
665	Scabiosa crinita Kotschy & Boiss.                                                                                                                                                                                                                              	Kotschy & Boiss.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Scabiosa                                                                                                                                                                                                                                                       	crinita                                                                                                                                                                                                                                                        	Kotschy & Boiss.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scabiosa crinita                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
667	Lomelosia argentea (L.) Greuter & Burdet                                                                                                                                                                                                                       	(L.) Greuter & Burdet                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Lomelosia                                                                                                                                                                                                                                                      	argentea                                                                                                                                                                                                                                                       	(L.) Greuter & Burdet                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scabiosa argentea                                                                                                                                                                                                                                              	Lomelosia argentea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
669	Lomelosia rotata (M.Bieb.) Greuter & Burdet                                                                                                                                                                                                                    	(M.Bieb.) Greuter & Burdet                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Lomelosia                                                                                                                                                                                                                                                      	rotata                                                                                                                                                                                                                                                         	(M.Bieb.) Greuter & Burdet                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scabiosa rotata                                                                                                                                                                                                                                                	Lomelosia rotata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
670	Lomelosia micrantha (Desf.) Greuter & Burdet                                                                                                                                                                                                                   	(Desf.) Greuter & Burdet                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Lomelosia                                                                                                                                                                                                                                                      	micrantha                                                                                                                                                                                                                                                      	(Desf.) Greuter & Burdet                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lomelosia micrantha                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
671	Pterocephalus plumosus (L.) Coult.                                                                                                                                                                                                                             	(L.) Coult.                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Pterocephalus                                                                                                                                                                                                                                                  	plumosus                                                                                                                                                                                                                                                       	(L.) Coult.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pterocephalus plumosus                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	5
672	Eryngium campestre var. virens Link                                                                                                                                                                                                                            	Link                                                                                                                            	Variety                                           	virens                                                                                                                                                                                                                                                         	Eryngium                                                                                                                                                                                                                                                       	campestre                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	virens                                                                                                                                                                                                                                                         	Link                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Eryngium campestre var. virens                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	3
673	Eryngium thorifolium Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Eryngium                                                                                                                                                                                                                                                       	thorifolium                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Eryngium thorifolium                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
674	Turgenia latifolia (L.) Hoffm.                                                                                                                                                                                                                                 	(L.) Hoffm.                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Turgenia                                                                                                                                                                                                                                                       	latifolia                                                                                                                                                                                                                                                      	(L.) Hoffm.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Turgenia latifolia                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	5
675	Astrantia maxima subsp. maxima                                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	maxima                                                                                                                                                                                                                                                         	Astrantia                                                                                                                                                                                                                                                      	maxima                                                                                                                                                                                                                                                         	Pall.                                                                                                                                                                                                                                                          	maxima                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astrantia maxima subsp. maxima                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
676	Bupleurum sulphureum Boiss. & Balansa                                                                                                                                                                                                                          	Boiss. & Balansa                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Bupleurum                                                                                                                                                                                                                                                      	sulphureum                                                                                                                                                                                                                                                     	Boiss. & Balansa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bupleurum sulphureum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	5
678	Ferulago sandrasica Pesmen & Quezel                                                                                                                                                                                                                            	Pesmen & Quezel                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Ferulago                                                                                                                                                                                                                                                       	sandrasica                                                                                                                                                                                                                                                     	Pesmen & Quezel                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ferulago sandrasica                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
679	Pimpinella spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Pimpinella                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pimpinella spec.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
681	Pimpinella corymbosa Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Pimpinella                                                                                                                                                                                                                                                     	corymbosa                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pimpinella corymbosa                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
682	Falcaria vulgaris Bernh.                                                                                                                                                                                                                                       	Bernh.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Falcaria                                                                                                                                                                                                                                                       	vulgaris                                                                                                                                                                                                                                                       	Bernh.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Falcaria vulgaris                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	3
683	Heracleum crenatifolium Boiss.                                                                                                                                                                                                                                 	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Heracleum                                                                                                                                                                                                                                                      	crenatifolium                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Heracleum crenatifolium                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	3
684	Pyrus elaeagnifolia subsp. elaeagnifolia                                                                                                                                                                                                                       	                                                                                                                                	Subspecies                                        	elaeagnifolia                                                                                                                                                                                                                                                  	Pyrus                                                                                                                                                                                                                                                          	elaeagnifolia                                                                                                                                                                                                                                                  	Pall.                                                                                                                                                                                                                                                          	elaeagnifolia                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pyrus elaeagnifolia subsp. elaeagnifolia                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	6
686	Alchemilla sericea Willd.                                                                                                                                                                                                                                      	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Alchemilla                                                                                                                                                                                                                                                     	sericea                                                                                                                                                                                                                                                        	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alchemilla sericea                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux / IA                                                                                                                                                                                                                                                       	3
687	Alchemilla barbatiflora Juz.                                                                                                                                                                                                                                   	Juz.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Alchemilla                                                                                                                                                                                                                                                     	barbatiflora                                                                                                                                                                                                                                                   	Juz.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alchemilla barbatiflora                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
688	Cotoneaster cf. nummularia J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                               	J.C.Fisch. & C.A.Mey.                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Cotoneaster                                                                                                                                                                                                                                                    	cf. nummularia                                                                                                                                                                                                                                                 	J.C.Fisch. & C.A.Mey.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cotoneaster cf. nummularia                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
689	Potentilla recta L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	recta                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla recta                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IA / ES                                                                                                                                                                                                                                                 	3
690	Potentilla palustris (L.) Scop.                                                                                                                                                                                                                                	(L.) Scop.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	palustris                                                                                                                                                                                                                                                      	(L.) Scop.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla palustris                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
691	Potentilla ruprechtii Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	ruprechtii                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla ruprechtii                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
692	Potentilla speciosa var. speciosa                                                                                                                                                                                                                              	                                                                                                                                	Variety                                           	speciosa                                                                                                                                                                                                                                                       	Potentilla                                                                                                                                                                                                                                                     	speciosa                                                                                                                                                                                                                                                       	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	speciosa                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla speciosa var. speciosa                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
693	Potentilla reptans L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	reptans                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla reptans                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
694	Rosa cf. pulverulenta M.Bieb.                                                                                                                                                                                                                                  	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Rosa                                                                                                                                                                                                                                                           	cf. pulverulenta                                                                                                                                                                                                                                               	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa cf. pulverulenta                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	2
695	Rosa iberica Stev.                                                                                                                                                                                                                                             	Stev.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Rosa                                                                                                                                                                                                                                                           	iberica                                                                                                                                                                                                                                                        	Stev.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa iberica                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	2
696	Rosa heckeliana subsp. orientalis (Dupont) Meikle                                                                                                                                                                                                              	(Dupont) Meikle                                                                                                                 	Subspecies                                        	orientalis                                                                                                                                                                                                                                                     	Rosa                                                                                                                                                                                                                                                           	heckeliana                                                                                                                                                                                                                                                     	Tratt.                                                                                                                                                                                                                                                         	orientalis                                                                                                                                                                                                                                                     	(Dupont) Meikle                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa heckeliana subsp. orientalis                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
697	Rosa montana subsp. woronowii (Lonacz.) O. Nilsson                                                                                                                                                                                                             	(Lonacz.) O. Nilsson                                                                                                            	Subspecies                                        	woronowii                                                                                                                                                                                                                                                      	Rosa                                                                                                                                                                                                                                                           	montana                                                                                                                                                                                                                                                        	Chaix                                                                                                                                                                                                                                                          	woronowii                                                                                                                                                                                                                                                      	(Lonacz.) O. Nilsson                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rosa montana subsp. woronowii                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	2
698	Campanula rapunculoides subsp. cordifolia (C. Koch) Damboldt                                                                                                                                                                                                   	(C. Koch) Damboldt                                                                                                              	Subspecies                                        	cordifolia                                                                                                                                                                                                                                                     	Campanula                                                                                                                                                                                                                                                      	rapunculoides                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	cordifolia                                                                                                                                                                                                                                                     	(C. Koch) Damboldt                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Campanula rapunculoides subsp. cordifolia                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
699	Asyneuma amplexicaule var. angustifolium (Boiss.) Bornm.                                                                                                                                                                                                       	(Boiss.) Bornm.                                                                                                                 	Variety                                           	angustifolium                                                                                                                                                                                                                                                  	Asyneuma                                                                                                                                                                                                                                                       	amplexicaule                                                                                                                                                                                                                                                   	(Willd.) Hand.- Mazz.                                                                                                                                                                                                                                          	amplexicaule                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	angustifolium                                                                                                                                                                                                                                                  	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Asyneuma amplexicaule subsp. amplexicaule var. angustifolium                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
700	Asyneuma virgatum subsp. virgatum                                                                                                                                                                                                                              	                                                                                                                                	Subspecies                                        	virgatum                                                                                                                                                                                                                                                       	Asyneuma                                                                                                                                                                                                                                                       	virgatum                                                                                                                                                                                                                                                       	(Labill.) Bornm.                                                                                                                                                                                                                                               	virgatum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma virgatum subsp. virgatum                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
702	Samolus valerandi L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Samolus                                                                                                                                                                                                                                                        	valerandi                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Samolus valerandi                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	5
705	Polygala transcaucasia Tamamsch.                                                                                                                                                                                                                               	Tamamsch.                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Polygala                                                                                                                                                                                                                                                       	transcaucasia                                                                                                                                                                                                                                                  	Tamamsch.                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygala transcaucasia                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
706	Polygonum setosum Jacq.                                                                                                                                                                                                                                        	Jacq.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	setosum                                                                                                                                                                                                                                                        	Jacq.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum setosum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
707	Polygonum karacae Zielinski & Boratynski                                                                                                                                                                                                                       	Zielinski & Boratynski                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	karacae                                                                                                                                                                                                                                                        	Zielinski & Boratynski                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum karacae                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
708	Polygonum aviculare L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	aviculare                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum aviculare                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	5
709	Polygonum bellardii All.                                                                                                                                                                                                                                       	All.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Polygonum                                                                                                                                                                                                                                                      	bellardii                                                                                                                                                                                                                                                      	All.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum bellardii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / IrTur / Med                                                                                                                                                                                                                                               	5
710	Rumex angustifolius subsp. macranthus (Boiss.) Rech.f.                                                                                                                                                                                                         	(Boiss.) Rech.f.                                                                                                                	Subspecies                                        	macranthus                                                                                                                                                                                                                                                     	Rumex                                                                                                                                                                                                                                                          	angustifolius                                                                                                                                                                                                                                                  	Campd.                                                                                                                                                                                                                                                         	macranthus                                                                                                                                                                                                                                                     	(Boiss.) Rech.f.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rumex angustifolius subsp. macranthus                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	5
711	Hypericum orientale L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	orientale                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum orientale                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
712	Hypericum perfoliatum L.                                                                                                                                                                                                                                       	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Hypericum                                                                                                                                                                                                                                                      	perfoliatum                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hypericum perfoliatum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	2
713	Hypericum aviculariifolium var. leprosum (Boiss.) Robson                                                                                                                                                                                                       	(Boiss.) Robson                                                                                                                 	Variety                                           	leprosum                                                                                                                                                                                                                                                       	Hypericum                                                                                                                                                                                                                                                      	aviculariifolium                                                                                                                                                                                                                                               	Jaub. & Spach                                                                                                                                                                                                                                                  	depilatum                                                                                                                                                                                                                                                      	(Freyn & Bornm.) Robson                                                                                                                                                                                                                                        	leprosum                                                                                                                                                                                                                                                       	(Boiss.) Robson                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Hypericum aviculariifolium subsp. depilatum var. leprosum                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
715	Glaucium oxylobum Boiss. & Buhse                                                                                                                                                                                                                               	Boiss. & Buhse                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Glaucium                                                                                                                                                                                                                                                       	oxylobum                                                                                                                                                                                                                                                       	Boiss. & Buhse                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Glaucium leiocarpum Boiss.                                                                                                                                                                                                                                     	Glaucium oxylobum                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
716	Papaver pilosum subsp. spicatum (Boiss. & Balansa) Wendt ex Kaderait                                                                                                                                                                                           	(Boiss. & Balansa) Wendt ex Kaderait                                                                                            	Subspecies                                        	spicatum                                                                                                                                                                                                                                                       	Papaver                                                                                                                                                                                                                                                        	pilosum                                                                                                                                                                                                                                                        	Sm.                                                                                                                                                                                                                                                            	spicatum                                                                                                                                                                                                                                                       	(Boiss. & Balansa) Wendt ex Kaderait                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	P.spicatum var spicatum Boiss. & Balansa                                                                                                                                                                                                                       	Papaver pilosum subsp. spicatum                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
717	Papaver orientale var. orientale                                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	orientale                                                                                                                                                                                                                                                      	Papaver                                                                                                                                                                                                                                                        	orientale                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	orientale                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Papaver orientale var. orientale                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
718	Silene oreades Boiss. & Heldr.                                                                                                                                                                                                                                 	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	oreades                                                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene oreades                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
719	Silene caryophylloides s.l. (Poiret) Otth                                                                                                                                                                                                                      	(Poiret) Otth                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	caryophylloides s.l.                                                                                                                                                                                                                                           	(Poiret) Otth                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene caryophylloides s.l.                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
720	Dianthus lactiflorus Fenzl                                                                                                                                                                                                                                     	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	lactiflorus                                                                                                                                                                                                                                                    	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus lactiflorus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
721	Dianthus brevicaulis subsp. setaceus Reeve                                                                                                                                                                                                                     	Reeve                                                                                                                           	Subspecies                                        	setaceus                                                                                                                                                                                                                                                       	Dianthus                                                                                                                                                                                                                                                       	brevicaulis                                                                                                                                                                                                                                                    	Fenzl                                                                                                                                                                                                                                                          	setaceus                                                                                                                                                                                                                                                       	Reeve                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus brevicaulis subsp. setaceus                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
722	Dianthus calocephalus Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	calocephalus                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus calocephalus                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	3
723	Dianthus orientalis s.l. Adams                                                                                                                                                                                                                                 	Adams                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	orientalis s.l.                                                                                                                                                                                                                                                	Adams                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus orientalis s.l.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	2
725	Dianthus masmenaeus var. masmenaeus                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	masmenaeus                                                                                                                                                                                                                                                     	Dianthus                                                                                                                                                                                                                                                       	masmenaeus                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	masmenaeus                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus masmenaeus var. masmenaeus                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
726	Dianthus elegans var. elegans                                                                                                                                                                                                                                  	                                                                                                                                	Variety                                           	elegans                                                                                                                                                                                                                                                        	Dianthus                                                                                                                                                                                                                                                       	elegans                                                                                                                                                                                                                                                        	d´Urv.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	elegans                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus elegans var. elegans                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
727	Dianthus zonatus s.l. Fenzl                                                                                                                                                                                                                                    	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	zonatus s.l.                                                                                                                                                                                                                                                   	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus zonatus s.l.                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
728	Dianthus leucophaeus var. leucophaeus                                                                                                                                                                                                                          	                                                                                                                                	Variety                                           	leucophaeus                                                                                                                                                                                                                                                    	Dianthus                                                                                                                                                                                                                                                       	leucophaeus                                                                                                                                                                                                                                                    	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	leucophaeus                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus leucophaeus var. leucophaeus                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
729	Saxifraga sibirica subsp. mollis (Sm.) Matthews                                                                                                                                                                                                                	(Sm.) Matthews                                                                                                                  	Subspecies                                        	mollis                                                                                                                                                                                                                                                         	Saxifraga                                                                                                                                                                                                                                                      	sibirica                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	mollis                                                                                                                                                                                                                                                         	(Sm.) Matthews                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Saxifraga sibirica subsp. mollis                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
730	Minuartia hirsuta subsp. falcata (Griseb.) Mattf.                                                                                                                                                                                                              	(Griseb.) Mattf.                                                                                                                	Subspecies                                        	falcata                                                                                                                                                                                                                                                        	Minuartia                                                                                                                                                                                                                                                      	hirsuta                                                                                                                                                                                                                                                        	(M.Bieb.) Hand.- Mazz.                                                                                                                                                                                                                                         	falcata                                                                                                                                                                                                                                                        	(Griseb.) Mattf.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia hirsuta subsp. falcata                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pont / IA                                                                                                                                                                                                                                                      	2
731	Arenaria cucubaloides Sm.                                                                                                                                                                                                                                      	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	cucubaloides                                                                                                                                                                                                                                                   	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria cucubaloides                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
732	Herniaria hirsuta L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Herniaria                                                                                                                                                                                                                                                      	hirsuta                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Herniaria hirsuta                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	2
733	Minuartia verna subsp. brevipetala Hartvig & Strid                                                                                                                                                                                                             	Hartvig & Strid                                                                                                                 	Subspecies                                        	brevipetala                                                                                                                                                                                                                                                    	Minuartia                                                                                                                                                                                                                                                      	verna                                                                                                                                                                                                                                                          	(L.) Hiern                                                                                                                                                                                                                                                     	brevipetala                                                                                                                                                                                                                                                    	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia verna subsp. brevipetala                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	2
734	Minuartia aizoides (Boiss.) Bornm.                                                                                                                                                                                                                             	(Boiss.) Bornm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	aizoides                                                                                                                                                                                                                                                       	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia aizoides                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux / Hyrc                                                                                                                                                                                                                                                     	3
735	Minuartia recurva subsp. carica McNeill                                                                                                                                                                                                                        	McNeill                                                                                                                         	Subspecies                                        	carica                                                                                                                                                                                                                                                         	Minuartia                                                                                                                                                                                                                                                      	recurva                                                                                                                                                                                                                                                        	(All.) Schinz & Thell.                                                                                                                                                                                                                                         	carica                                                                                                                                                                                                                                                         	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia recurva subsp. carica                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
736	Minuartia multinervis (Boiss.) Bornm.                                                                                                                                                                                                                          	(Boiss.) Bornm.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Minuartia                                                                                                                                                                                                                                                      	multinervis                                                                                                                                                                                                                                                    	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia multinervis                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
737	Petrorhagia alpina subsp. alpina                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	alpina                                                                                                                                                                                                                                                         	Petrorhagia                                                                                                                                                                                                                                                    	alpina                                                                                                                                                                                                                                                         	(Hablitz) Ball & Heywood                                                                                                                                                                                                                                       	alpina                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Petrorhagia alpina subsp. alpina                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
738	Petrorhagia alpina subsp. olympica (Boiss.) Ball & Heywood                                                                                                                                                                                                     	(Boiss.) Ball & Heywood                                                                                                         	Subspecies                                        	olympica                                                                                                                                                                                                                                                       	Petrorhagia                                                                                                                                                                                                                                                    	alpina                                                                                                                                                                                                                                                         	(Hablitz) Ball & Heywood                                                                                                                                                                                                                                       	olympica                                                                                                                                                                                                                                                       	(Boiss.) Ball & Heywood                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Petrorhagia alpina subsp. olympica                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
739	Silene saxatilis Sims                                                                                                                                                                                                                                          	Sims                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	saxatilis                                                                                                                                                                                                                                                      	Sims                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene saxatilis                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
740	Silene spergulifolia (Willd.) M.Bieb.                                                                                                                                                                                                                          	(Willd.) M.Bieb.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	spergulifolia                                                                                                                                                                                                                                                  	(Willd.) M.Bieb.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene spergulifolia                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
741	Silene cf. montbretiana Boiss.                                                                                                                                                                                                                                 	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	cf. montbretiana                                                                                                                                                                                                                                               	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene cf. montbretiana                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
742	Silene cf. italica (L.) Pers.                                                                                                                                                                                                                                  	(L.) Pers.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	cf. italica                                                                                                                                                                                                                                                    	(L.) Pers.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene cf. italica                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	3
743	Silene cf. marschallii s.l. C.A.Meyer                                                                                                                                                                                                                          	C.A.Meyer                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	cf. marschallii s.l.                                                                                                                                                                                                                                           	C.A.Meyer                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene cf. marschallii s.l.                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
744	Paronychia mughlaei Chaudhri                                                                                                                                                                                                                                   	Chaudhri                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Paronychia                                                                                                                                                                                                                                                     	mughlaei                                                                                                                                                                                                                                                       	Chaudhri                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Paronychia mughlaei                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
745	Acer cappadocicum var. stenocarpum Yalt.                                                                                                                                                                                                                       	Yalt.                                                                                                                           	Variety                                           	stenocarpum                                                                                                                                                                                                                                                    	Acer                                                                                                                                                                                                                                                           	cappadocicum                                                                                                                                                                                                                                                   	Gled.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	stenocarpum                                                                                                                                                                                                                                                    	Yalt.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Acer cappadocicum var. stenocarpum                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux / Hyrc                                                                                                                                                                                                                                                     	7
746	Geranium subcaulescens DC.                                                                                                                                                                                                                                     	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Geranium                                                                                                                                                                                                                                                       	subcaulescens                                                                                                                                                                                                                                                  	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Geranium cinereum Cav. subsp. subcaulescens (L´Herit ex DC.) Hayek var. subcaulescens                                                                                                                                                                          	Geranium subcaulescens                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
747	Geranium glaberrimum Boiss. & Heldr.                                                                                                                                                                                                                           	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Geranium                                                                                                                                                                                                                                                       	glaberrimum                                                                                                                                                                                                                                                    	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Geranium glaberrimum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
748	Geranium cinereum var. subacutum (Boiss.) P.H.Davis & Roberts                                                                                                                                                                                                  	(Boiss.) P.H.Davis & Roberts                                                                                                    	Variety                                           	subacutum                                                                                                                                                                                                                                                      	Geranium                                                                                                                                                                                                                                                       	cinereum                                                                                                                                                                                                                                                       	Cav.                                                                                                                                                                                                                                                           	subcaulescens                                                                                                                                                                                                                                                  	(L`Hérit. ex DC.) Hayek                                                                                                                                                                                                                                        	subacutum                                                                                                                                                                                                                                                      	(Boiss.) P.H.Davis & Roberts                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	Geranium cinereum subsp. subcaulescens var. subacutum                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	3
749	Geranium ibericum subsp. jubatum (Hand.- Mazz.) P.H. Davis                                                                                                                                                                                                     	(Hand.- Mazz.) P.H. Davis                                                                                                       	Subspecies                                        	jubatum                                                                                                                                                                                                                                                        	Geranium                                                                                                                                                                                                                                                       	ibericum                                                                                                                                                                                                                                                       	Cav.                                                                                                                                                                                                                                                           	jubatum                                                                                                                                                                                                                                                        	(Hand.- Mazz.) P.H. Davis                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Geranium ibericum subsp. jubatum                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	3
750	Geranium molle subsp. molle                                                                                                                                                                                                                                    	                                                                                                                                	Subspecies                                        	molle                                                                                                                                                                                                                                                          	Geranium                                                                                                                                                                                                                                                       	molle                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	molle                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Geranium molle subsp. molle                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / ES                                                                                                                                                                                                                                                       	5
751	Erodium spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Erodium                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Erodium spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
752	Cuscuta brevistyla A. Rich.                                                                                                                                                                                                                                    	A. Rich.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Cuscuta                                                                                                                                                                                                                                                        	brevistyla                                                                                                                                                                                                                                                     	A. Rich.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cuscuta brevistyla                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Med / IA / Sud                                                                                                                                                                                                                                                 	5
753	Lithospermum incrassatum Guss.                                                                                                                                                                                                                                 	Guss.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Lithospermum                                                                                                                                                                                                                                                   	incrassatum                                                                                                                                                                                                                                                    	Guss.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Buglossoides incrassata (Guss.)Johnston                                                                                                                                                                                                                        	Lithospermum incrassatum                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
754	Anchusa italica Retz.                                                                                                                                                                                                                                          	Retz.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Anchusa                                                                                                                                                                                                                                                        	italica                                                                                                                                                                                                                                                        	Retz.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anchusa azurea Miller var. azurea                                                                                                                                                                                                                              	Anchusa italica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Med / ES / IA                                                                                                                                                                                                                                                  	3
755	Alkanna orientalis var. leucantha (Bornm.) Hub.- Mor.                                                                                                                                                                                                          	(Bornm.) Hub.- Mor.                                                                                                             	Variety                                           	leucantha                                                                                                                                                                                                                                                      	Alkanna                                                                                                                                                                                                                                                        	orientalis                                                                                                                                                                                                                                                     	(L.) Boiss.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	leucantha                                                                                                                                                                                                                                                      	(Bornm.) Hub.- Mor.                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Alkanna orientalis var. leucantha                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
756	Alkanna areolata var. areolata                                                                                                                                                                                                                                 	                                                                                                                                	Variety                                           	areolata                                                                                                                                                                                                                                                       	Alkanna                                                                                                                                                                                                                                                        	areolata                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	areolata                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alkanna areolata var. areolata                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
758	Cynoglossum montanum L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Cynoglossum                                                                                                                                                                                                                                                    	montanum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cynoglossum montanum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
759	Onosma armena DC.                                                                                                                                                                                                                                              	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	armena                                                                                                                                                                                                                                                         	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onosma armena                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
760	Onosma aucheriana DC.                                                                                                                                                                                                                                          	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Onosma                                                                                                                                                                                                                                                         	aucheriana                                                                                                                                                                                                                                                     	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	O. pallida, O.montana Sm. ->MClist                                                                                                                                                                                                                             	Onosma aucheriana                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
761	Linaria genistifolia subsp. linifolia (Boiss.) P.H.Davis                                                                                                                                                                                                       	(Boiss.) P.H.Davis                                                                                                              	Subspecies                                        	linifolia                                                                                                                                                                                                                                                      	Linaria                                                                                                                                                                                                                                                        	genistifolia                                                                                                                                                                                                                                                   	(L.) Mill.                                                                                                                                                                                                                                                     	linifolia                                                                                                                                                                                                                                                      	(Boiss.) P.H.Davis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linaria genistifolia subsp. linifolia                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
841	Trigonella lycica Hub.- Mor.                                                                                                                                                                                                                                   	Hub.- Mor.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Trigonella                                                                                                                                                                                                                                                     	lycica                                                                                                                                                                                                                                                         	Hub.- Mor.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trigonella lycica                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	5
842	Trigonella brachycarpa M.Bieb.                                                                                                                                                                                                                                 	M.Bieb.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Trigonella                                                                                                                                                                                                                                                     	brachycarpa                                                                                                                                                                                                                                                    	M.Bieb.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trigonella brachycarpa                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
762	Linaria kurdica subsp. eriocalyx (Boiss.) P.H.Davis                                                                                                                                                                                                            	(Boiss.) P.H.Davis                                                                                                              	Subspecies                                        	eriocalyx                                                                                                                                                                                                                                                      	Linaria                                                                                                                                                                                                                                                        	kurdica                                                                                                                                                                                                                                                        	Boiss. & Hohen.                                                                                                                                                                                                                                                	eriocalyx                                                                                                                                                                                                                                                      	(Boiss.) P.H.Davis                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Linaria kurdica subsp. eriocalyx                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
763	Pedicularis comosa var. acmodonta (Boiss.) Boiss.                                                                                                                                                                                                              	(Boiss.) Boiss.                                                                                                                 	Variety                                           	acmodonta                                                                                                                                                                                                                                                      	Pedicularis                                                                                                                                                                                                                                                    	comosa                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	acmodonta                                                                                                                                                                                                                                                      	(Boiss.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Pedicularis comosa var. acmodonta                                                                                                                                                                                                                              	Gerlad Bolkar                                                                                                                                                                                                                                                  	IA                                                                                                                                                                                                                                                             	3
764	Digitalis cariensis Boiss. ex Jaub. & Spach                                                                                                                                                                                                                    	Boiss. ex Jaub. & Spach                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Digitalis                                                                                                                                                                                                                                                      	cariensis                                                                                                                                                                                                                                                      	Boiss. ex Jaub. & Spach                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Digitalis cariensis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
765	Euphrasia minima subsp. davisii Yeo                                                                                                                                                                                                                            	Yeo                                                                                                                             	Subspecies                                        	davisii                                                                                                                                                                                                                                                        	Euphrasia                                                                                                                                                                                                                                                      	minima                                                                                                                                                                                                                                                         	Jacq. ex DC.                                                                                                                                                                                                                                                   	davisii                                                                                                                                                                                                                                                        	Yeo                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphrasia minima subsp. davisii                                                                                                                                                                                                                                	schutt-grasflur Übergang                                                                                                                                                                                                                                       	Eux                                                                                                                                                                                                                                                            	5
766	Melampyrum arvense var. arvense                                                                                                                                                                                                                                	                                                                                                                                	Variety                                           	arvense                                                                                                                                                                                                                                                        	Melampyrum                                                                                                                                                                                                                                                     	arvense                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	arvense                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Melampyrum arvense var. arvense                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
767	Odontites glutinosa (M.Bieb.) Benth.                                                                                                                                                                                                                           	(M.Bieb.) Benth.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Odontites                                                                                                                                                                                                                                                      	glutinosa                                                                                                                                                                                                                                                      	(M.Bieb.) Benth.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Odontites glutinosa                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
769	Veronica macrostachya subsp. macrostachya                                                                                                                                                                                                                      	                                                                                                                                	Subspecies                                        	macrostachya                                                                                                                                                                                                                                                   	Veronica                                                                                                                                                                                                                                                       	macrostachya                                                                                                                                                                                                                                                   	Vahl                                                                                                                                                                                                                                                           	macrostachya                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica macrostachya subsp. macrostachya                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
770	Veronica hispidula subsp. hispidula                                                                                                                                                                                                                            	                                                                                                                                	Subspecies                                        	hispidula                                                                                                                                                                                                                                                      	Veronica                                                                                                                                                                                                                                                       	hispidula                                                                                                                                                                                                                                                      	Boiss. & Huet                                                                                                                                                                                                                                                  	hispidula                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica hispidula subsp. hispidula                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
771	Veronica orientalis s.l. Mill.                                                                                                                                                                                                                                 	Mill.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	orientalis s.l.                                                                                                                                                                                                                                                	Mill.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica orientalis s.l.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
772	Veronica multifida L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	multifida                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Veronica multifida                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	2
773	Veronica dichrus Schott & Kotschy                                                                                                                                                                                                                              	Schott & Kotschy                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Veronica                                                                                                                                                                                                                                                       	dichrus                                                                                                                                                                                                                                                        	Schott & Kotschy                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	v. macrostachya ssp. pisidica (quezel)                                                                                                                                                                                                                         	Veronica dichrus                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	2
774	Verbascum cf. transcaucasicum E.Wulff                                                                                                                                                                                                                          	E.Wulff                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. transcaucasicum                                                                                                                                                                                                                                            	E.Wulff                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. transcaucasicum                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	3
775	Verbascum cariense Hub.- Mor.                                                                                                                                                                                                                                  	Hub.- Mor.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cariense                                                                                                                                                                                                                                                       	Hub.- Mor.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cariense                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
776	Verbascum myriocarpum Boiss. & Heldr.                                                                                                                                                                                                                          	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	myriocarpum                                                                                                                                                                                                                                                    	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum myriocarpum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
777	Scrophularia cryptophila Boiss. & Heldr.                                                                                                                                                                                                                       	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Scrophularia                                                                                                                                                                                                                                                   	cryptophila                                                                                                                                                                                                                                                    	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scrophularia cryptophila                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
778	Rhododendron ponticum subsp. ponticum                                                                                                                                                                                                                          	                                                                                                                                	Subspecies                                        	ponticum                                                                                                                                                                                                                                                       	Rhododendron                                                                                                                                                                                                                                                   	ponticum                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	ponticum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rhododendron ponticum subsp. ponticum                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	Pont / Eux / Med                                                                                                                                                                                                                                               	6
1149	Androsace maxima L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Androsace                                                                                                                                                                                                                                                      	maxima                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Androsace maxima                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	2
779	Reseda lutea var. nutans Boiss.                                                                                                                                                                                                                                	Boiss.                                                                                                                          	Variety                                           	nutans                                                                                                                                                                                                                                                         	Reseda                                                                                                                                                                                                                                                         	lutea                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	nutans                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Reseda lutea var. nutans                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	3
780	Viola spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Viola                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Viola spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
781	Nigella arvensis var. glauca Boiss.                                                                                                                                                                                                                            	Boiss.                                                                                                                          	Variety                                           	glauca                                                                                                                                                                                                                                                         	Nigella                                                                                                                                                                                                                                                        	arvensis                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	glauca                                                                                                                                                                                                                                                         	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Nigella arvensis var. glauca                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	5
800	Colchicum cf. sanguicolle                                                                                                                                                                                                                                      	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Colchicum                                                                                                                                                                                                                                                      	cf. sanguicolle                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Colchicum cf. sanguicolle                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
802	Allium schoenoprasum L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	schoenoprasum                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium schoenoprasum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	4
803	Allium oltense Grossh.                                                                                                                                                                                                                                         	Grossh.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Allium                                                                                                                                                                                                                                                         	oltense                                                                                                                                                                                                                                                        	Grossh.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium oltense                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	4
985	Scorzonera tomentosa L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	tomentosa                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera tomentosa                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
782	Consolida hellespontica (Boiss.) Chater                                                                                                                                                                                                                        	(Boiss.) Chater                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Consolida                                                                                                                                                                                                                                                      	hellespontica                                                                                                                                                                                                                                                  	(Boiss.) Chater                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Consolida hellespontica                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IA / Pont                                                                                                                                                                                                                                                      	5
783	Delphinium cilicicum P.H. Davis & Kit Tan                                                                                                                                                                                                                      	P.H. Davis & Kit Tan                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Delphinium                                                                                                                                                                                                                                                     	cilicicum                                                                                                                                                                                                                                                      	P.H. Davis & Kit Tan                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Delphinium cilicicum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	3
784	Thalictrum minus var. majus (Crantz) Crép.                                                                                                                                                                                                                     	(Crantz) Crép.                                                                                                                  	Variety                                           	majus                                                                                                                                                                                                                                                          	Thalictrum                                                                                                                                                                                                                                                     	minus                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	majus                                                                                                                                                                                                                                                          	(Crantz) Crép.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	Thalictrum minus var. majus                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	ES / Med / IrTur                                                                                                                                                                                                                                               	3
786	Juniperus foetidissima Willd.                                                                                                                                                                                                                                  	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Juniperus                                                                                                                                                                                                                                                      	foetidissima                                                                                                                                                                                                                                                   	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Juniperus foetidissima                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
787	Valeriana sisymbriifolia Vahl                                                                                                                                                                                                                                  	Vahl                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Valeriana                                                                                                                                                                                                                                                      	sisymbriifolia                                                                                                                                                                                                                                                 	Vahl                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Valeriana sisymbriifolia                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
788	Epilobium ponticum Hausskn.                                                                                                                                                                                                                                    	Hausskn.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Epilobium                                                                                                                                                                                                                                                      	ponticum                                                                                                                                                                                                                                                       	Hausskn.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Epilobium ponticum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
789	Epilobium angustifolium L.                                                                                                                                                                                                                                     	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Epilobium                                                                                                                                                                                                                                                      	angustifolium                                                                                                                                                                                                                                                  	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Epilobium angustifolium                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	3
790	Acantholimon glumaceum (Jaub. & Spach) Boiss.                                                                                                                                                                                                                  	(Jaub. & Spach) Boiss.                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Acantholimon                                                                                                                                                                                                                                                   	glumaceum                                                                                                                                                                                                                                                      	(Jaub. & Spach) Boiss.                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon glumaceum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
791	Acantholimon ulicinum var. purpurascens (Bokhari) Bokhari & J.R.Edm.                                                                                                                                                                                           	(Bokhari) Bokhari & J.R.Edm.                                                                                                    	Variety                                           	purpurascens                                                                                                                                                                                                                                                   	Acantholimon                                                                                                                                                                                                                                                   	ulicinum                                                                                                                                                                                                                                                       	(Schultes) Boiss.                                                                                                                                                                                                                                              	ulicinum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	purpurascens                                                                                                                                                                                                                                                   	(Bokhari) Bokhari & J.R.Edm.                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	Acantholimon ulicinum subsp. ulicinum var. purpurascens                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	2
792	Acantholimon acerosum var. acerosum                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	acerosum                                                                                                                                                                                                                                                       	Acantholimon                                                                                                                                                                                                                                                   	acerosum                                                                                                                                                                                                                                                       	(Willd.) Boiss.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	acerosum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon acerosum var. acerosum                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
793	Acantholimon ulicinum var. ulicinum                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	ulicinum                                                                                                                                                                                                                                                       	Acantholimon                                                                                                                                                                                                                                                   	ulicinum                                                                                                                                                                                                                                                       	(Willd. ex Schultes) Boiss.                                                                                                                                                                                                                                    	ulicinum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	ulicinum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon ulicinum subsp. ulicinum var. ulicinum                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
794	Acantholimon ulicinum s.l. (Schultes) Boiss.                                                                                                                                                                                                                   	(Schultes) Boiss.                                                                                                               	                                                  	                                                                                                                                                                                                                                                               	Acantholimon                                                                                                                                                                                                                                                   	ulicinum s.l.                                                                                                                                                                                                                                                  	(Schultes) Boiss.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon ulicinum s.l.                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
795	Acantholimon venustum var. venustum                                                                                                                                                                                                                            	                                                                                                                                	Variety                                           	venustum                                                                                                                                                                                                                                                       	Acantholimon                                                                                                                                                                                                                                                   	venustum                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	venustum                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Acantholimon venustum var. venustum                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
796	Dactylorhiza urvilleana (Steud.) H.Baumann & Künkele                                                                                                                                                                                                           	(Steud.) H.Baumann & Künkele                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Dactylorhiza                                                                                                                                                                                                                                                   	urvilleana                                                                                                                                                                                                                                                     	(Steud.) H.Baumann & Künkele                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dactylorhiza urvilleana                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Eux / Hyrc                                                                                                                                                                                                                                                     	4
797	Gladiolus kotschyanus Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Gladiolus                                                                                                                                                                                                                                                      	kotschyanus                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Gladiolus kotschyanus                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
798	Crocus scharojanii Rupr.                                                                                                                                                                                                                                       	Rupr.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Crocus                                                                                                                                                                                                                                                         	scharojanii                                                                                                                                                                                                                                                    	Rupr.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crocus scharojanii                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	4
804	Anthyllis vulneraria subsp. pulchella (Vis.) Bornm.                                                                                                                                                                                                            	(Vis.) Bornm.                                                                                                                   	Subspecies                                        	pulchella                                                                                                                                                                                                                                                      	Anthyllis                                                                                                                                                                                                                                                      	vulneraria                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	pulchella                                                                                                                                                                                                                                                      	(Vis.) Bornm.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthyllis vulneraria subsp. pulchella                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
805	Ebenus laguroides var. cilicica (Boiss.) Bornm.                                                                                                                                                                                                                	(Boiss.) Bornm.                                                                                                                 	Variety                                           	cilicica                                                                                                                                                                                                                                                       	Ebenus                                                                                                                                                                                                                                                         	laguroides                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	cilicica                                                                                                                                                                                                                                                       	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Ebenus laguroides var. cilicica                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
806	Ebenus bourgaei Boiss.                                                                                                                                                                                                                                         	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Ebenus                                                                                                                                                                                                                                                         	bourgaei                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ebenus bourgaei                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
807	Ebenus pisidica Hub.- Mor. & Reese                                                                                                                                                                                                                             	Hub.- Mor. & Reese                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Ebenus                                                                                                                                                                                                                                                         	pisidica                                                                                                                                                                                                                                                       	Hub.- Mor. & Reese                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ebenus pisidica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
808	Hedysarum pestalozzae Boiss.                                                                                                                                                                                                                                   	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hedysarum                                                                                                                                                                                                                                                      	pestalozzae                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hedysarum pestalozzae                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	5
809	Coronilla coronata L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Coronilla                                                                                                                                                                                                                                                      	coronata                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Coronilla coronata                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
810	Securigea varia (L.) Lassen                                                                                                                                                                                                                                    	(L.) Lassen                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Securigea                                                                                                                                                                                                                                                      	varia                                                                                                                                                                                                                                                          	(L.) Lassen                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Coronilla varia L. subsp. varia                                                                                                                                                                                                                                	Securigea varia                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	2
811	Medicago lupulina L.                                                                                                                                                                                                                                           	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Medicago                                                                                                                                                                                                                                                       	lupulina                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Medicago lupulina                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES / IrTur / Med                                                                                                                                                                                                                                               	2
812	Medicago sativa L.                                                                                                                                                                                                                                             	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Medicago                                                                                                                                                                                                                                                       	sativa                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Medicago sativa                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IrTur / Med / ES                                                                                                                                                                                                                                               	5
813	Medicago rigidula var. rigidula                                                                                                                                                                                                                                	                                                                                                                                	Variety                                           	rigidula                                                                                                                                                                                                                                                       	Medicago                                                                                                                                                                                                                                                       	rigidula                                                                                                                                                                                                                                                       	(L.) All.                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	rigidula                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Medicago rigidula var. rigidula                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
814	Medicago spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Medicago                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Medicago spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
815	Cicer anatolicum Alef.                                                                                                                                                                                                                                         	Alef.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Cicer                                                                                                                                                                                                                                                          	anatolicum                                                                                                                                                                                                                                                     	Alef.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cicer anatolicum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
816	Onobrychis cf. transcaucasica Grossh.                                                                                                                                                                                                                          	Grossh.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Onobrychis                                                                                                                                                                                                                                                     	cf. transcaucasica                                                                                                                                                                                                                                             	Grossh.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onobrychis cf. transcaucasica                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
817	Onobrychis lasistanica Sirj.                                                                                                                                                                                                                                   	Sirj.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Onobrychis                                                                                                                                                                                                                                                     	lasistanica                                                                                                                                                                                                                                                    	Sirj.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Onobrychis lasistanica                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
818	Vicia canescens subsp. gregaria (Boiss. & Heldr.) P.H.Davis                                                                                                                                                                                                    	(Boiss. & Heldr.) P.H.Davis                                                                                                     	Subspecies                                        	gregaria                                                                                                                                                                                                                                                       	Vicia                                                                                                                                                                                                                                                          	canescens                                                                                                                                                                                                                                                      	Lab.                                                                                                                                                                                                                                                           	gregaria                                                                                                                                                                                                                                                       	(Boiss. & Heldr.) P.H.Davis                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vicia canescens subsp. gregaria                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
819	Convolvulus cf. compactus Boiss.                                                                                                                                                                                                                               	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Convolvulus                                                                                                                                                                                                                                                    	cf. compactus                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Convolvulus cf. compactus                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	IA / Med                                                                                                                                                                                                                                                       	2
820	Vicia anatolica Turrill                                                                                                                                                                                                                                        	Turrill                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Vicia                                                                                                                                                                                                                                                          	anatolica                                                                                                                                                                                                                                                      	Turrill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Vicia anatolica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	5
821	Lens orientalis (Boiss.) Smal´g                                                                                                                                                                                                                                	(Boiss.) Smal´g                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Lens                                                                                                                                                                                                                                                           	orientalis                                                                                                                                                                                                                                                     	(Boiss.) Smal´g                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	L. orientalis (Boiss.) Hand.- Mazz.                                                                                                                                                                                                                            	Lens orientalis                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Med / IrTur                                                                                                                                                                                                                                                    	5
822	Trifolium ochroleucum Huds.                                                                                                                                                                                                                                    	Huds.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Trifolium                                                                                                                                                                                                                                                      	ochroleucum                                                                                                                                                                                                                                                    	Huds.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium ochroleucum                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
823	Trifolium spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Trifolium                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trifolium spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
824	Ononis spinosa subsp. leiosperma (Boiss.) Sirj.                                                                                                                                                                                                                	(Boiss.) Sirj.                                                                                                                  	Subspecies                                        	leiosperma                                                                                                                                                                                                                                                     	Ononis                                                                                                                                                                                                                                                         	spinosa                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	leiosperma                                                                                                                                                                                                                                                     	(Boiss.) Sirj.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ononis spinosa subsp. leiosperma                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	2
826	Genista anatolica Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Genista                                                                                                                                                                                                                                                        	anatolica                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Genista anatolica                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	6
827	Astragalus cataonicus Bunge                                                                                                                                                                                                                                    	Bunge                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	cataonicus                                                                                                                                                                                                                                                     	Bunge                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus cataonicus                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
828	Astragalus depressus L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	depressus                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus depressus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / IA / Med                                                                                                                                                                                                                                                  	3
829	Astragalus angustifolius var. angustifolius                                                                                                                                                                                                                    	                                                                                                                                	Variety                                           	angustifolius                                                                                                                                                                                                                                                  	Astragalus                                                                                                                                                                                                                                                     	angustifolius                                                                                                                                                                                                                                                  	Lam.                                                                                                                                                                                                                                                           	angustifolius                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	angustifolius                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus angustifolius subsp. angustifolius var. angustifolius                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
832	Astragalus prusianus Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	prusianus                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus prusianus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
833	Astragalus creticus Lam.                                                                                                                                                                                                                                       	Lam.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	creticus                                                                                                                                                                                                                                                       	Lam.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus creticus                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
834	Astragalus parnassi subsp. cylleneus (Boiss. & Heldr.) Hayek                                                                                                                                                                                                   	(Boiss. & Heldr.) Hayek                                                                                                         	Subspecies                                        	cylleneus                                                                                                                                                                                                                                                      	Astragalus                                                                                                                                                                                                                                                     	parnassi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	cylleneus                                                                                                                                                                                                                                                      	(Boiss. & Heldr.) Hayek                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus parnassi subsp. cylleneus                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
835	Astragalus breviflorus DC.                                                                                                                                                                                                                                     	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	breviflorus                                                                                                                                                                                                                                                    	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	A. eriocephalus Willd. subsp. eriocephalus                                                                                                                                                                                                                     	Astragalus breviflorus                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
836	Astragalus cf. caucasicus Pall.                                                                                                                                                                                                                                	Pall.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	cf. caucasicus                                                                                                                                                                                                                                                 	Pall.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus cf. caucasicus                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	Eux / Hyrc / Pont                                                                                                                                                                                                                                              	2
837	Astragalus aureus Willd.                                                                                                                                                                                                                                       	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	aureus                                                                                                                                                                                                                                                         	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus aureus                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
838	Astragalus cf. microcephalus Willd.                                                                                                                                                                                                                            	Willd.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	cf. microcephalus                                                                                                                                                                                                                                              	Willd.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus cf. microcephalus                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
839	Astragalus cf. kurdicus Boiss.                                                                                                                                                                                                                                 	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Astragalus                                                                                                                                                                                                                                                     	cf. kurdicus                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Astragalus cf. kurdicus                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
843	Centaurea pseudoscabiosa subsp. pseudoscabiosa                                                                                                                                                                                                                 	                                                                                                                                	Subspecies                                        	pseudoscabiosa                                                                                                                                                                                                                                                 	Centaurea                                                                                                                                                                                                                                                      	pseudoscabiosa                                                                                                                                                                                                                                                 	Boiss. & Buhse                                                                                                                                                                                                                                                 	pseudoscabiosa                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea pseudoscabiosa subsp. pseudoscabiosa                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
846	Crupina crupinastrum (Moris) Vis.                                                                                                                                                                                                                              	(Moris) Vis.                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Crupina                                                                                                                                                                                                                                                        	crupinastrum                                                                                                                                                                                                                                                   	(Moris) Vis.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Crupina crupinastrum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
847	Centaurea ensiformis P.H. Davis                                                                                                                                                                                                                                	P.H. Davis                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Centaurea                                                                                                                                                                                                                                                      	ensiformis                                                                                                                                                                                                                                                     	P.H. Davis                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea ensiformis                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
848	Echinops ritro L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Echinops                                                                                                                                                                                                                                                       	ritro                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Echinops ritro                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
849	Echinops cf. ritro L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Echinops                                                                                                                                                                                                                                                       	cf. ritro                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Echinops cf. ritro                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
850	Echinops viscosus subsp. viscosus                                                                                                                                                                                                                              	                                                                                                                                	Subspecies                                        	viscosus                                                                                                                                                                                                                                                       	Echinops                                                                                                                                                                                                                                                       	viscosus                                                                                                                                                                                                                                                       	DC.                                                                                                                                                                                                                                                            	viscosus                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	E.spinosissimus Turra (Conspectus)                                                                                                                                                                                                                             	Echinops viscosus subsp. viscosus                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
852	Centaurea cf. urvillei subsp. armata Wagenitz                                                                                                                                                                                                                  	Wagenitz                                                                                                                        	Subspecies                                        	armata                                                                                                                                                                                                                                                         	Centaurea                                                                                                                                                                                                                                                      	cf. urvillei                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	armata                                                                                                                                                                                                                                                         	Wagenitz                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea cf. urvillei subsp. armata                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
853	Carlina oligocephala subsp. oligocephala                                                                                                                                                                                                                       	                                                                                                                                	Subspecies                                        	oligocephala                                                                                                                                                                                                                                                   	Carlina                                                                                                                                                                                                                                                        	oligocephala                                                                                                                                                                                                                                                   	Boiss. & Kotschy                                                                                                                                                                                                                                               	oligocephala                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carlina oligocephala subsp. oligocephala                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	3
854	Cirsium caucasicum (Adams) Petr.                                                                                                                                                                                                                               	(Adams) Petr.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Cirsium                                                                                                                                                                                                                                                        	caucasicum                                                                                                                                                                                                                                                     	(Adams) Petr.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cirsium caucasicum                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
855	Tanacetum argenteum s.l. (Lam.) Willd.                                                                                                                                                                                                                         	(Lam.) Willd.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Tanacetum                                                                                                                                                                                                                                                      	argenteum s.l.                                                                                                                                                                                                                                                 	(Lam.) Willd.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum argenteum s.l.                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA / EMed                                                                                                                                                                                                                                                      	2
856	Tanacetum praeteritum subsp. massicyticum Heywood                                                                                                                                                                                                              	Heywood                                                                                                                         	Subspecies                                        	massicyticum                                                                                                                                                                                                                                                   	Tanacetum                                                                                                                                                                                                                                                      	praeteritum                                                                                                                                                                                                                                                    	(Horw.) Heywood                                                                                                                                                                                                                                                	massicyticum                                                                                                                                                                                                                                                   	Heywood                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tanacetum praeteritum subsp. massicyticum                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
857	Anthemis spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Anthemis                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
858	Anthemis cretica subsp. pontica (Willd.) Grierson                                                                                                                                                                                                              	(Willd.) Grierson                                                                                                               	Subspecies                                        	pontica                                                                                                                                                                                                                                                        	Anthemis                                                                                                                                                                                                                                                       	cretica                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	pontica                                                                                                                                                                                                                                                        	(Willd.) Grierson                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis cretica subsp. pontica                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Pont                                                                                                                                                                                                                                                           	2
859	Cousinia cf. cataonica Boiss. & Hausskn.                                                                                                                                                                                                                       	Boiss. & Hausskn.                                                                                                               	                                                  	                                                                                                                                                                                                                                                               	Cousinia                                                                                                                                                                                                                                                       	cf. cataonica                                                                                                                                                                                                                                                  	Boiss. & Hausskn.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cousinia cf. cataonica                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
860	Carduus spec.                                                                                                                                                                                                                                                  	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Carduus                                                                                                                                                                                                                                                        	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carduus spec.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
861	Cirsium lappaceum subsp. anatolicum Petr.                                                                                                                                                                                                                      	Petr.                                                                                                                           	Subspecies                                        	anatolicum                                                                                                                                                                                                                                                     	Cirsium                                                                                                                                                                                                                                                        	lappaceum                                                                                                                                                                                                                                                      	(M.Bieb.) Fischer                                                                                                                                                                                                                                              	anatolicum                                                                                                                                                                                                                                                     	Petr.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cirsium lappaceum subsp. anatolicum                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
862	Achillea millefolium subsp. millefolium                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	millefolium                                                                                                                                                                                                                                                    	Achillea                                                                                                                                                                                                                                                       	millefolium                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	millefolium                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea millefolium subsp. millefolium                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
863	Achillea kotschyi subsp. kotschyi                                                                                                                                                                                                                              	                                                                                                                                	Subspecies                                        	kotschyi                                                                                                                                                                                                                                                       	Achillea                                                                                                                                                                                                                                                       	kotschyi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	kotschyi                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea kotschyi subsp. kotschyi                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
864	Achillea cf. biebersteinii Afan.                                                                                                                                                                                                                               	Afan.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	cf. biebersteinii                                                                                                                                                                                                                                              	Afan.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea cf. biebersteinii                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
865	Achillea wilhelmsii C. Koch                                                                                                                                                                                                                                    	C. Koch                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Achillea                                                                                                                                                                                                                                                       	wilhelmsii                                                                                                                                                                                                                                                     	C. Koch                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Achillea wilhelmsii                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
866	Carduus cf. nutans L.                                                                                                                                                                                                                                          	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Carduus                                                                                                                                                                                                                                                        	cf. nutans                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carduus cf. nutans                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
868	Inula heterolepis Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Inula                                                                                                                                                                                                                                                          	heterolepis                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Inula heterolepis                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
869	Senecio castagneanus DC.                                                                                                                                                                                                                                       	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	castagneanus                                                                                                                                                                                                                                                   	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio castagneanus                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
870	Senecio racemosus (M.Bieb.) DC.                                                                                                                                                                                                                                	(M.Bieb.) DC.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	racemosus                                                                                                                                                                                                                                                      	(M.Bieb.) DC.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio racemosus                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
871	Senecio ovatifolius Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	ovatifolius                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio ovatifolius                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End K                                                                                                                                                                                                                                                          	3
872	Hieracium hoppeanum Schult.                                                                                                                                                                                                                                    	Schult.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	hoppeanum                                                                                                                                                                                                                                                      	Schult.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella hoppeana (Schultes) C.H. & F.W. Schultz subsp. troica (Zahn) Sell & West                                                                                                                                                                             	Hieracium hoppeanum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
873	Hieracium cf. hoppeanum Schult.                                                                                                                                                                                                                                	Schult.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	cf. hoppeanum                                                                                                                                                                                                                                                  	Schult.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella c.f. hoppeana (Schultes) C.H. & F.W. Schultz                                                                                                                                                                                                         	Hieracium cf. hoppeanum                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
874	Hieracium spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Hieracium spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
875	Solidago virgaurea subsp. alpestris (Waldst. & Kit.) Gaudin                                                                                                                                                                                                    	(Waldst. & Kit.) Gaudin                                                                                                         	Subspecies                                        	alpestris                                                                                                                                                                                                                                                      	Solidago                                                                                                                                                                                                                                                       	virgaurea                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	alpestris                                                                                                                                                                                                                                                      	(Waldst. & Kit.) Gaudin                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Solidago virgaurea subsp. alpestris                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
876	Telekia speciosa (Schreb.) Baumg.                                                                                                                                                                                                                              	(Schreb.) Baumg.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Telekia                                                                                                                                                                                                                                                        	speciosa                                                                                                                                                                                                                                                       	(Schreb.) Baumg.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Telekia speciosa                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
877	Doronicum cacaliifolium Boiss. & Heldr.                                                                                                                                                                                                                        	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Doronicum                                                                                                                                                                                                                                                      	cacaliifolium                                                                                                                                                                                                                                                  	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Doronicum cacaliifolium                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
878	Tragopogon albinervis Freyn & Sint.                                                                                                                                                                                                                            	Freyn & Sint.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Tragopogon                                                                                                                                                                                                                                                     	albinervis                                                                                                                                                                                                                                                     	Freyn & Sint.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tragopogon albinervis                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
879	Tragopogon latifolius var. angustifolius Boiss.                                                                                                                                                                                                                	Boiss.                                                                                                                          	Variety                                           	angustifolius                                                                                                                                                                                                                                                  	Tragopogon                                                                                                                                                                                                                                                     	latifolius                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	angustifolius                                                                                                                                                                                                                                                  	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Tragopogon latifolius var. angustifolius                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
880	Scariola orientalis (Boiss.) Soják                                                                                                                                                                                                                             	(Boiss.) Soják                                                                                                                  	                                                  	                                                                                                                                                                                                                                                               	Scariola                                                                                                                                                                                                                                                       	orientalis                                                                                                                                                                                                                                                     	(Boiss.) Soják                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scariola orientalis                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
881	Lactuca saligna L.                                                                                                                                                                                                                                             	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Lactuca                                                                                                                                                                                                                                                        	saligna                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lactuca saligna                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Med / IA / Sa-Ar                                                                                                                                                                                                                                               	3
882	Lactuca serriola L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Lactuca                                                                                                                                                                                                                                                        	serriola                                                                                                                                                                                                                                                       	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Lactuca serriola                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Med / ES / IA / Sud                                                                                                                                                                                                                                            	3
884	Leontodon crispus var. asper                                                                                                                                                                                                                                   	                                                                                                                                	Variety                                           	asper                                                                                                                                                                                                                                                          	Leontodon                                                                                                                                                                                                                                                      	crispus                                                                                                                                                                                                                                                        	Vill.                                                                                                                                                                                                                                                          	asper                                                                                                                                                                                                                                                          	(Waldst. & Kit.) Rohl.                                                                                                                                                                                                                                         	asper                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Leontodon crispus subsp. asper var. asper                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
885	Tripleurospermum oreades var. tchihatchewii (Boiss.) E. Hossain                                                                                                                                                                                                	(Boiss.) E. Hossain                                                                                                             	Variety                                           	tchihatchewii                                                                                                                                                                                                                                                  	Tripleurospermum                                                                                                                                                                                                                                               	oreades                                                                                                                                                                                                                                                        	(Boiss.) Rech.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	tchihatchewii                                                                                                                                                                                                                                                  	(Boiss.) E. Hossain                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Tripleurospermum oreades var. tchihatchewii                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	IA / EMed                                                                                                                                                                                                                                                      	2
886	Tripleurospermum cf. callosum (Boiss. & Heldr.) E. Hossain                                                                                                                                                                                                     	(Boiss. & Heldr.) E. Hossain                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Tripleurospermum                                                                                                                                                                                                                                               	cf. callosum                                                                                                                                                                                                                                                   	(Boiss. & Heldr.) E. Hossain                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Tripleurospermum cf. callosum                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
887	Scorzonera mollis subsp. szowitzii (DC.) D.F.Chamb.                                                                                                                                                                                                            	(DC.) D.F.Chamb.                                                                                                                	Subspecies                                        	szowitzii                                                                                                                                                                                                                                                      	Scorzonera                                                                                                                                                                                                                                                     	mollis                                                                                                                                                                                                                                                         	M.Bieb.                                                                                                                                                                                                                                                        	szowitzii                                                                                                                                                                                                                                                      	(DC.) D.F.Chamb.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera mollis subsp. szowitzii                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
888	Scorzonera cana s.l. (C.A.Meyer) Hoffm.                                                                                                                                                                                                                        	(C.A.Meyer) Hoffm.                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	cana s.l.                                                                                                                                                                                                                                                      	(C.A.Meyer) Hoffm.                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera cana s.l.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	3
889	Scorzonera cf. sosnowskyi Lipsch.                                                                                                                                                                                                                              	Lipsch.                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	cf. sosnowskyi                                                                                                                                                                                                                                                 	Lipsch.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera cf. sosnowskyi                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
890	Scorzonera cana var. jacquiniana (W. Koch) D.F.Chamb.                                                                                                                                                                                                          	(W. Koch) D.F.Chamb.                                                                                                            	Variety                                           	jacquiniana                                                                                                                                                                                                                                                    	Scorzonera                                                                                                                                                                                                                                                     	cana                                                                                                                                                                                                                                                           	(C.A. Meyer) Hoffm.                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	jacquiniana                                                                                                                                                                                                                                                    	(W. Koch) D.F.Chamb.                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Scorzonera cana var. jacquiniana                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
891	Scorzonera laciniata subsp. calcitrapifolia (Vahl) Maire                                                                                                                                                                                                       	(Vahl) Maire                                                                                                                    	Subspecies                                        	calcitrapifolia                                                                                                                                                                                                                                                	Scorzonera                                                                                                                                                                                                                                                     	laciniata                                                                                                                                                                                                                                                      	L.                                                                                                                                                                                                                                                             	calcitrapifolia                                                                                                                                                                                                                                                	(Vahl) Maire                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera laciniata subsp. calcitrapifolia                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
892	Scorzonera cf. cinerea Boiss.                                                                                                                                                                                                                                  	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Scorzonera                                                                                                                                                                                                                                                     	cf. cinerea                                                                                                                                                                                                                                                    	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scorzonera cf. cinerea                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
893	Taraxacum cf. pseudonigricans Hand.- Mazz.                                                                                                                                                                                                                     	Hand.- Mazz.                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	cf. pseudonigricans                                                                                                                                                                                                                                            	Hand.- Mazz.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum cf. pseudonigricans                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
894	Taraxacum bithynicum DC.                                                                                                                                                                                                                                       	DC.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	bithynicum                                                                                                                                                                                                                                                     	DC.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum bithynicum                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	3
895	Taraxacum cf. bellidiforme van Soest                                                                                                                                                                                                                           	van Soest                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	cf. bellidiforme                                                                                                                                                                                                                                               	van Soest                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum cf. bellidiforme                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
896	Taraxacum buttleri Soest                                                                                                                                                                                                                                       	Soest                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Taraxacum                                                                                                                                                                                                                                                      	buttleri                                                                                                                                                                                                                                                       	Soest                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Taraxacum buttleri                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	IA / EMed                                                                                                                                                                                                                                                      	3
897	Hieracium ruprechtii Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Hieracium                                                                                                                                                                                                                                                      	ruprechtii                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Pilosella hoppeana X ruprechtii (Boiss.) Sell & West                                                                                                                                                                                                           	Hieracium ruprechtii                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	3
898	Chondrilla juncea var. juncea                                                                                                                                                                                                                                  	                                                                                                                                	Variety                                           	juncea                                                                                                                                                                                                                                                         	Chondrilla                                                                                                                                                                                                                                                     	juncea                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	juncea                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Chondrilla juncea var. juncea                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	3
899	Artemisia spec.                                                                                                                                                                                                                                                	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Artemisia                                                                                                                                                                                                                                                      	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Artemisia spec.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
900	Bombycilaena erecta (L.) Smoljan                                                                                                                                                                                                                               	(L.) Smoljan                                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Bombycilaena                                                                                                                                                                                                                                                   	erecta                                                                                                                                                                                                                                                         	(L.) Smoljan                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bombycilaena erecta                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	Med                                                                                                                                                                                                                                                            	5
901	Galium spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Galium                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	5
903	Galium canum subsp. ovatum Ehrend.                                                                                                                                                                                                                             	Ehrend.                                                                                                                         	Subspecies                                        	ovatum                                                                                                                                                                                                                                                         	Galium                                                                                                                                                                                                                                                         	canum                                                                                                                                                                                                                                                          	Req. ex DC.                                                                                                                                                                                                                                                    	ovatum                                                                                                                                                                                                                                                         	Ehrend.                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Galium canum subsp. ovatum                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	5
904	Melica ciliata subsp. ciliata                                                                                                                                                                                                                                  	                                                                                                                                	Subspecies                                        	ciliata                                                                                                                                                                                                                                                        	Melica                                                                                                                                                                                                                                                         	ciliata                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	ciliata                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Melica ciliata subsp. ciliata                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
905	Aegilops triuncialis subsp. triuncialis                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	triuncialis                                                                                                                                                                                                                                                    	Aegilops                                                                                                                                                                                                                                                       	triuncialis                                                                                                                                                                                                                                                    	L.                                                                                                                                                                                                                                                             	triuncialis                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aegilops triuncialis subsp. triuncialis                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	5
906	Aegilops caudata L.                                                                                                                                                                                                                                            	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Aegilops                                                                                                                                                                                                                                                       	caudata                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aegilops caudata                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	5
907	Aegilops umbellulata subsp. umbellulata                                                                                                                                                                                                                        	                                                                                                                                	Subspecies                                        	umbellulata                                                                                                                                                                                                                                                    	Aegilops                                                                                                                                                                                                                                                       	umbellulata                                                                                                                                                                                                                                                    	Zhuk.                                                                                                                                                                                                                                                          	umbellulata                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aegilops umbellulata subsp. umbellulata                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	5
908	Bromus erectus Huds.                                                                                                                                                                                                                                           	Huds.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	erectus                                                                                                                                                                                                                                                        	Huds.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus erectus                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / IA                                                                                                                                                                                                                                                        	3
909	Bromus riparius Rehm                                                                                                                                                                                                                                           	Rehm                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	riparius                                                                                                                                                                                                                                                       	Rehm                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus riparius                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
910	Bromus spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Bromus                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bromus spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
911	Nardus stricta L.                                                                                                                                                                                                                                              	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Nardus                                                                                                                                                                                                                                                         	stricta                                                                                                                                                                                                                                                        	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Nardus stricta                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	3
913	Alopecurus lanatus Sm.                                                                                                                                                                                                                                         	Sm.                                                                                                                             	                                                  	                                                                                                                                                                                                                                                               	Alopecurus                                                                                                                                                                                                                                                     	lanatus                                                                                                                                                                                                                                                        	Sm.                                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alopecurus lanatus                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
914	Elytrigia koshaninii (Nábelek.)                                                                                                                                                                                                                                	(Nábelek.)                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Elytrigia                                                                                                                                                                                                                                                      	koshaninii                                                                                                                                                                                                                                                     	(Nábelek.)                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia koshaninii                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
917	Elytrigia intermedia subsp. trichophora (Link) Tzvelev.                                                                                                                                                                                                        	(Link) Tzvelev.                                                                                                                 	Subspecies                                        	trichophora                                                                                                                                                                                                                                                    	Elytrigia                                                                                                                                                                                                                                                      	intermedia                                                                                                                                                                                                                                                     	(Host) Nevski                                                                                                                                                                                                                                                  	trichophora                                                                                                                                                                                                                                                    	(Link) Tzvelev.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Elytrigia intermedia subsp. trichophora                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	ES / Med / IA                                                                                                                                                                                                                                                  	4
918	Stipa cf. holosericea Trin.                                                                                                                                                                                                                                    	Trin.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Stipa                                                                                                                                                                                                                                                          	cf. holosericea                                                                                                                                                                                                                                                	Trin.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa cf. holosericea                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
919	Stipa cf. hohenackeriana Trin. & Rupr.                                                                                                                                                                                                                         	Trin. & Rupr.                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Stipa                                                                                                                                                                                                                                                          	cf. hohenackeriana                                                                                                                                                                                                                                             	Trin. & Rupr.                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Stipa cf. hohenackeriana                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	IrTur                                                                                                                                                                                                                                                          	3
920	Festuca cf. valesiaca Schleicher ex Gaudin                                                                                                                                                                                                                     	Schleicher ex Gaudin                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Festuca                                                                                                                                                                                                                                                        	cf. valesiaca                                                                                                                                                                                                                                                  	Schleicher ex Gaudin                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Festuca cf. valesiaca                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	ES / IrTur                                                                                                                                                                                                                                                     	3
921	Koeleria brevis Steven                                                                                                                                                                                                                                         	Steven                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Koeleria                                                                                                                                                                                                                                                       	brevis                                                                                                                                                                                                                                                         	Steven                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Koeleria brevis                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
922	Koeleria spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Koeleria                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Koeleria spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
923	Trisetum rigidum (M.Bieb.) R.Roem. ex Schult.                                                                                                                                                                                                                  	(M.Bieb.) R.Roem. ex Schult.                                                                                                    	                                                  	                                                                                                                                                                                                                                                               	Trisetum                                                                                                                                                                                                                                                       	rigidum                                                                                                                                                                                                                                                        	(M.Bieb.) R.Roem. ex Schult.                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Trisetum rigidum                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	4
924	Agrostis lazica Balansa                                                                                                                                                                                                                                        	Balansa                                                                                                                         	                                                  	                                                                                                                                                                                                                                                               	Agrostis                                                                                                                                                                                                                                                       	lazica                                                                                                                                                                                                                                                         	Balansa                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Agrostis lazica                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Eux                                                                                                                                                                                                                                                            	3
925	Agrostis gigantea Roth                                                                                                                                                                                                                                         	Roth                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Agrostis                                                                                                                                                                                                                                                       	gigantea                                                                                                                                                                                                                                                       	Roth                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Agrostis gigantea                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	3
926	Bothriochloa ischaemum (L.) Keng                                                                                                                                                                                                                               	(L.) Keng                                                                                                                       	                                                  	                                                                                                                                                                                                                                                               	Bothriochloa                                                                                                                                                                                                                                                   	ischaemum                                                                                                                                                                                                                                                      	(L.) Keng                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Bothriochloa ischaemum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Med / IrTur / EAs                                                                                                                                                                                                                                              	3
927	Briza minor L.                                                                                                                                                                                                                                                 	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Briza                                                                                                                                                                                                                                                          	minor                                                                                                                                                                                                                                                          	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Briza minor                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	5
928	Luzula spicata (L.) DC.                                                                                                                                                                                                                                        	(L.) DC.                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Luzula                                                                                                                                                                                                                                                         	spicata                                                                                                                                                                                                                                                        	(L.) DC.                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Luzula spicata                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	Plur                                                                                                                                                                                                                                                           	3
929	Carex cf. caucasica Steven                                                                                                                                                                                                                                     	Steven                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Carex                                                                                                                                                                                                                                                          	cf. caucasica                                                                                                                                                                                                                                                  	Steven                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Carex cf. caucasica                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	3
930	Rhamnus punctata var. angustifolius Poot                                                                                                                                                                                                                       	Poot                                                                                                                            	Variety                                           	angustifolius                                                                                                                                                                                                                                                  	Rhamnus                                                                                                                                                                                                                                                        	punctata                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	angustifolius                                                                                                                                                                                                                                                  	Poot                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Rhamnus punctata var. angustifolius                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
931	Asphodeline damascena subsp. damascena                                                                                                                                                                                                                         	                                                                                                                                	Subspecies                                        	damascena                                                                                                                                                                                                                                                      	Asphodeline                                                                                                                                                                                                                                                    	damascena                                                                                                                                                                                                                                                      	(Boiss.) Baker                                                                                                                                                                                                                                                 	damascena                                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asphodeline damascena subsp. damascena                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	EMed / IA                                                                                                                                                                                                                                                      	4
932	Ornithogalum orthophyllum Ten.                                                                                                                                                                                                                                 	Ten.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	orthophyllum                                                                                                                                                                                                                                                   	Ten.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum orthophyllum                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	Med / ES                                                                                                                                                                                                                                                       	4
933	Muscari sandrasicum Karlén                                                                                                                                                                                                                                     	Karlén                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	sandrasicum                                                                                                                                                                                                                                                    	Karlén                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari sandrasicum                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	4
934	Muscari comosum (L.) Mill.                                                                                                                                                                                                                                     	(L.) Mill.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	comosum                                                                                                                                                                                                                                                        	(L.) Mill.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari comosum                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	Med / IA / ES                                                                                                                                                                                                                                                  	4
935	Verbascum chrysorhacos Boiss.                                                                                                                                                                                                                                  	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	chrysorhacos                                                                                                                                                                                                                                                   	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum chrysorhacos                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
936	Verbascum cf. barbeyi Post                                                                                                                                                                                                                                     	Post                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. barbeyi                                                                                                                                                                                                                                                    	Post                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. barbeyi                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End T                                                                                                                                                                                                                                                          	3
937	Verbascum cheiranthifolium var. cheiranthifolium                                                                                                                                                                                                               	                                                                                                                                	Variety                                           	cheiranthifolium                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cheiranthifolium                                                                                                                                                                                                                                               	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	cheiranthifolium                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cheiranthifolium var. cheiranthifolium                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	EMed / IrTur                                                                                                                                                                                                                                                   	3
938	Verbascum cf. glomerulosum Hub.- Mor.                                                                                                                                                                                                                          	Hub.- Mor.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. glomerulosum                                                                                                                                                                                                                                               	Hub.- Mor.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. glomerulosum                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
939	Verbascum cf. myriocarpum Boiss. & Heldr.                                                                                                                                                                                                                      	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. myriocarpum                                                                                                                                                                                                                                                	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. myriocarpum                                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
940	Verbascum cf. chionophyllum Hub.- Mor.                                                                                                                                                                                                                         	Hub.- Mor.                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. chionophyllum                                                                                                                                                                                                                                              	Hub.- Mor.                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. chionophyllum                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	End OT                                                                                                                                                                                                                                                         	3
941	Verbascum cf. cappadocicum Bornm.                                                                                                                                                                                                                              	Bornm.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Verbascum                                                                                                                                                                                                                                                      	cf. cappadocicum                                                                                                                                                                                                                                               	Bornm.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Verbascum cf. cappadocicum                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
964	Saxifraga kotschyi Boiss.                                                                                                                                                                                                                                      	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Saxifraga                                                                                                                                                                                                                                                      	kotschyi                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Saxifraga kotschyi                                                                                                                                                                                                                                             	Nur im Bolkar und den Aladaglari.                                                                                                                                                                                                                              	Eux                                                                                                                                                                                                                                                            	2
965	Salvia frigida Boiss.                                                                                                                                                                                                                                          	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	frigida                                                                                                                                                                                                                                                        	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia frigida                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
968	Allium cupani subsp. hirtovaginatum (Kunth) Stearn                                                                                                                                                                                                             	(Kunth) Stearn                                                                                                                  	Subspecies                                        	hirtovaginatum                                                                                                                                                                                                                                                 	Allium                                                                                                                                                                                                                                                         	cupani                                                                                                                                                                                                                                                         	Rafin.                                                                                                                                                                                                                                                         	hirtovaginatum                                                                                                                                                                                                                                                 	(Kunth) Stearn                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Allium cupani subsp. hirtovaginatum                                                                                                                                                                                                                            	Özkan                                                                                                                                                                                                                                                          	Med                                                                                                                                                                                                                                                            	4
969	Dianthus anatolicus Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	anatolicus                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus anatolicus                                                                                                                                                                                                                                            	Özkan                                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
970	Seseli ramosissimum Hartvig & Strid                                                                                                                                                                                                                            	Hartvig & Strid                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Seseli                                                                                                                                                                                                                                                         	ramosissimum                                                                                                                                                                                                                                                   	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Seseli ramosissimum                                                                                                                                                                                                                                            	Özkan                                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
971	Minuartia rimarum subsp. rimarum                                                                                                                                                                                                                               	                                                                                                                                	Subspecies                                        	rimarum                                                                                                                                                                                                                                                        	Minuartia                                                                                                                                                                                                                                                      	rimarum                                                                                                                                                                                                                                                        	(Boiss. & Balansa) Mattf.                                                                                                                                                                                                                                      	rimarum                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia rimarum subsp. rimarum                                                                                                                                                                                                                               	Nur im Bolkar und den Aladaglari. Özkan                                                                                                                                                                                                                        	End A                                                                                                                                                                                                                                                          	2
972	Minuartia anatolica subsp. polymorpha McNeill                                                                                                                                                                                                                  	McNeill                                                                                                                         	Subspecies                                        	polymorpha                                                                                                                                                                                                                                                     	Minuartia                                                                                                                                                                                                                                                      	anatolica                                                                                                                                                                                                                                                      	(Boiss.) Woronow                                                                                                                                                                                                                                               	polymorpha                                                                                                                                                                                                                                                     	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia anatolica subsp. polymorpha                                                                                                                                                                                                                          	Özkan                                                                                                                                                                                                                                                          	EMed                                                                                                                                                                                                                                                           	3
973	Anthemis kotschyana Boiss.                                                                                                                                                                                                                                     	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Anthemis                                                                                                                                                                                                                                                       	kotschyana                                                                                                                                                                                                                                                     	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Anthemis kotschyana                                                                                                                                                                                                                                            	Özkan                                                                                                                                                                                                                                                          	EMed / IA                                                                                                                                                                                                                                                      	2
974	Centaurea pichleri subsp. pichleri                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	pichleri                                                                                                                                                                                                                                                       	Centaurea                                                                                                                                                                                                                                                      	pichleri                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	pichleri                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea pichleri subsp. pichleri                                                                                                                                                                                                                             	Özkan                                                                                                                                                                                                                                                          	Med                                                                                                                                                                                                                                                            	3
975	Fritillaria pinardii Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Fritillaria                                                                                                                                                                                                                                                    	pinardii                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fritillaria pinardii                                                                                                                                                                                                                                           	Özkan                                                                                                                                                                                                                                                          	IA                                                                                                                                                                                                                                                             	4
976	Paronychia spec.                                                                                                                                                                                                                                               	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Paronychia                                                                                                                                                                                                                                                     	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Paronychia spec.                                                                                                                                                                                                                                               	Özkan                                                                                                                                                                                                                                                          	spec                                                                                                                                                                                                                                                           	2
977	Muscari neglectum Guss.                                                                                                                                                                                                                                        	Guss.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Muscari                                                                                                                                                                                                                                                        	neglectum                                                                                                                                                                                                                                                      	Guss.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Muscari neglectum                                                                                                                                                                                                                                              	Özkan                                                                                                                                                                                                                                                          	EMed / IA                                                                                                                                                                                                                                                      	4
978	Ranunculus argyraeus Boiss.                                                                                                                                                                                                                                    	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Ranunculus                                                                                                                                                                                                                                                     	argyraeus                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ranunculus argyraeus                                                                                                                                                                                                                                           	Özkan                                                                                                                                                                                                                                                          	IA                                                                                                                                                                                                                                                             	3
979	Senecio cariensis Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Senecio                                                                                                                                                                                                                                                        	cariensis                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Senecio cariensis                                                                                                                                                                                                                                              	Özkan                                                                                                                                                                                                                                                          	End BT                                                                                                                                                                                                                                                         	3
980	Thymus longicaulis var. antalyanus                                                                                                                                                                                                                             	                                                                                                                                	Variety                                           	antalyanus                                                                                                                                                                                                                                                     	Thymus                                                                                                                                                                                                                                                         	longicaulis                                                                                                                                                                                                                                                    	C.Presl                                                                                                                                                                                                                                                        	chaubardii                                                                                                                                                                                                                                                     	(Rchb.f.) Jalas                                                                                                                                                                                                                                                	antalyanus                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Thymus longicaulis subsp. chaubardii var. antalyanus                                                                                                                                                                                                           	Özkan                                                                                                                                                                                                                                                          	End A                                                                                                                                                                                                                                                          	2
982	Paronychia cf. lycica Chaudhri                                                                                                                                                                                                                                 	Chaudhri                                                                                                                        	                                                  	                                                                                                                                                                                                                                                               	Paronychia                                                                                                                                                                                                                                                     	cf. lycica                                                                                                                                                                                                                                                     	Chaudhri                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Paronychia cf. lycica                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
983	Asphodeline spec.                                                                                                                                                                                                                                              	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Asphodeline                                                                                                                                                                                                                                                    	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asphodeline spec.                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	4
986	Scabiosa ochroleuca L.                                                                                                                                                                                                                                         	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Scabiosa                                                                                                                                                                                                                                                       	ochroleuca                                                                                                                                                                                                                                                     	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scabiosa columbaria ssp ochroleuca                                                                                                                                                                                                                             	Scabiosa ochroleuca                                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	ES / Med                                                                                                                                                                                                                                                       	3
987	Swertia cf. perennis L.                                                                                                                                                                                                                                        	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Swertia                                                                                                                                                                                                                                                        	cf. perennis                                                                                                                                                                                                                                                   	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Swertia cf. perennis                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	3
988	Fumana aciphylla Boiss.                                                                                                                                                                                                                                        	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Fumana                                                                                                                                                                                                                                                         	aciphylla                                                                                                                                                                                                                                                      	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Fumana aciphylla                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	IA                                                                                                                                                                                                                                                             	2
990	Cephalaria lycica K.M.Matthew                                                                                                                                                                                                                                  	K.M.Matthew                                                                                                                     	                                                  	                                                                                                                                                                                                                                                               	Cephalaria                                                                                                                                                                                                                                                     	lycica                                                                                                                                                                                                                                                         	K.M.Matthew                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cephalaria lycica                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	2
991	Centaurea kotschyi subsp. kotschyi                                                                                                                                                                                                                             	                                                                                                                                	Subspecies                                        	kotschyi                                                                                                                                                                                                                                                       	Centaurea                                                                                                                                                                                                                                                      	kotschyi                                                                                                                                                                                                                                                       	(Boiss. & Heldr.) Hayek                                                                                                                                                                                                                                        	kotschyi                                                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Centaurea kotschyi subsp. kotschyi                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
992	Valerianella carinata R.J.Loisel                                                                                                                                                                                                                               	R.J.Loisel                                                                                                                      	                                                  	                                                                                                                                                                                                                                                               	Valerianella                                                                                                                                                                                                                                                   	carinata                                                                                                                                                                                                                                                       	R.J.Loisel                                                                                                                                                                                                                                                     	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Valerianella carinata                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed / IrTur / ES                                                                                                                                                                                                                                              	5
1100	Ornithogalum brevipedicellatum Boiss. ex Baker                                                                                                                                                                                                                 	Boiss. ex Baker                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Ornithogalum                                                                                                                                                                                                                                                   	brevipedicellatum                                                                                                                                                                                                                                              	Boiss. ex Baker                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ornithogalum brevipedicellatum                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	4
1101	Alyssum condensatum subsp. flexibile (Nyár.) Dudley                                                                                                                                                                                                            	(Nyár.) Dudley                                                                                                                  	Subspecies                                        	flexibile                                                                                                                                                                                                                                                      	Alyssum                                                                                                                                                                                                                                                        	condensatum                                                                                                                                                                                                                                                    	Boiss. & Hausskn.                                                                                                                                                                                                                                              	flexibile                                                                                                                                                                                                                                                      	(Nyár.) Dudley                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Alyssum condensatum subsp. flexibile                                                                                                                                                                                                                           	gerald, bakirli                                                                                                                                                                                                                                                	IA                                                                                                                                                                                                                                                             	2
1102	Satureja cuneifolia Ten.                                                                                                                                                                                                                                       	Ten.                                                                                                                            	                                                  	                                                                                                                                                                                                                                                               	Satureja                                                                                                                                                                                                                                                       	cuneifolia                                                                                                                                                                                                                                                     	Ten.                                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Satureja cuneifolia                                                                                                                                                                                                                                            	gerlad, tahteli                                                                                                                                                                                                                                                	Med                                                                                                                                                                                                                                                            	2
1103	Arabis alpina subsp. brevifolia (DC.) Greuter & Burdet                                                                                                                                                                                                         	(DC.) Greuter & Burdet                                                                                                          	Subspecies                                        	brevifolia                                                                                                                                                                                                                                                     	Arabis                                                                                                                                                                                                                                                         	alpina                                                                                                                                                                                                                                                         	L.                                                                                                                                                                                                                                                             	brevifolia                                                                                                                                                                                                                                                     	(DC.) Greuter & Burdet                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	A.caucasica Willd. ssp brevifolia                                                                                                                                                                                                                              	Arabis alpina subsp. brevifolia                                                                                                                                                                                                                                	gerald, bakirli                                                                                                                                                                                                                                                	EMed                                                                                                                                                                                                                                                           	3
1104	Echinops emiliae O.Schwarz ex P.H.Davis                                                                                                                                                                                                                        	O.Schwarz ex P.H.Davis                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Echinops                                                                                                                                                                                                                                                       	emiliae                                                                                                                                                                                                                                                        	O.Schwarz ex P.H.Davis                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Echinops emiliae                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End BT                                                                                                                                                                                                                                                         	3
1105	Pinus nigra var. caramanica (Loudon) Rehder                                                                                                                                                                                                                    	(Loudon) Rehder                                                                                                                 	Variety                                           	caramanica                                                                                                                                                                                                                                                     	Pinus                                                                                                                                                                                                                                                          	nigra                                                                                                                                                                                                                                                          	J.F.Arnold                                                                                                                                                                                                                                                     	nigra                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	caramanica                                                                                                                                                                                                                                                     	(Loudon) Rehder                                                                                                                                                                                                                                                	P.nigra Arn. pallasiana (Lamb.) Holmboe                                                                                                                                                                                                                        	Pinus nigra subsp. nigra var. caramanica                                                                                                                                                                                                                       	                                                                                                                                                                                                                                                               	EMed / IA / Pont                                                                                                                                                                                                                                               	6
1106	Persicaria alpina (All.) H. Gross.                                                                                                                                                                                                                             	(All.) H. Gross.                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Persicaria                                                                                                                                                                                                                                                     	alpina                                                                                                                                                                                                                                                         	(All.) H. Gross.                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Polygonum alpinum All.                                                                                                                                                                                                                                         	Persicaria alpina                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	ES                                                                                                                                                                                                                                                             	5
1107	Bolanthus frankenioides var. fasciculatus (Boiss. & Heldr.) Barkoudah                                                                                                                                                                                          	(Boiss. & Heldr.) Barkoudah                                                                                                     	Variety                                           	fasciculatus                                                                                                                                                                                                                                                   	Bolanthus                                                                                                                                                                                                                                                      	frankenioides                                                                                                                                                                                                                                                  	(Boiss.) Barkoudah                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	fasciculatus                                                                                                                                                                                                                                                   	(Boiss. & Heldr.) Barkoudah                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	Bolanthus frankenioides var. fasciculatus                                                                                                                                                                                                                      	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
1108	Dianthus goerkii Hartvig & Strid                                                                                                                                                                                                                               	Hartvig & Strid                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Dianthus                                                                                                                                                                                                                                                       	goerkii                                                                                                                                                                                                                                                        	Hartvig & Strid                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Dianthus goerkii                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	End loc                                                                                                                                                                                                                                                        	2
1109	Scleranthus uncinatus Schur                                                                                                                                                                                                                                    	Schur                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Scleranthus                                                                                                                                                                                                                                                    	uncinatus                                                                                                                                                                                                                                                      	Schur                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Scleranthus uncinatus                                                                                                                                                                                                                                          	Therophyt ?                                                                                                                                                                                                                                                    	ES / IA                                                                                                                                                                                                                                                        	3
1110	Ajuga chamaepitys subsp. mesogitana (Boiss.) Bornm.                                                                                                                                                                                                            	(Boiss.) Bornm.                                                                                                                 	Subspecies                                        	mesogitana                                                                                                                                                                                                                                                     	Ajuga                                                                                                                                                                                                                                                          	chamaepitys                                                                                                                                                                                                                                                    	(L.) Schreb.                                                                                                                                                                                                                                                   	mesogitana                                                                                                                                                                                                                                                     	(Boiss.) Bornm.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Ajuga chamaepitys subsp. mesogitana                                                                                                                                                                                                                            	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
1111	Salvia virgata Jacq.                                                                                                                                                                                                                                           	Jacq.                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Salvia                                                                                                                                                                                                                                                         	virgata                                                                                                                                                                                                                                                        	Jacq.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Salvia virgata                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	Med / IA                                                                                                                                                                                                                                                       	2
1112	Euphorbia erythrodon Boiss. & Heldr.                                                                                                                                                                                                                           	Boiss. & Heldr.                                                                                                                 	                                                  	                                                                                                                                                                                                                                                               	Euphorbia                                                                                                                                                                                                                                                      	erythrodon                                                                                                                                                                                                                                                     	Boiss. & Heldr.                                                                                                                                                                                                                                                	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Euphorbia erythrodon                                                                                                                                                                                                                                           	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
1113	Minuartia dianthifolia subsp. cataonica McNeill                                                                                                                                                                                                                	McNeill                                                                                                                         	Subspecies                                        	cataonica                                                                                                                                                                                                                                                      	Minuartia                                                                                                                                                                                                                                                      	dianthifolia                                                                                                                                                                                                                                                   	(Boiss.) Hand.-Mazz.                                                                                                                                                                                                                                           	cataonica                                                                                                                                                                                                                                                      	McNeill                                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Minuartia dianthifolia subsp. cataonica                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	2
1114	Aubrieta pinardii Boiss.                                                                                                                                                                                                                                       	Boiss.                                                                                                                          	                                                  	                                                                                                                                                                                                                                                               	Aubrieta                                                                                                                                                                                                                                                       	pinardii                                                                                                                                                                                                                                                       	Boiss.                                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Aubrieta pinardii                                                                                                                                                                                                                                              	                                                                                                                                                                                                                                                               	End A                                                                                                                                                                                                                                                          	3
1115	Potentilla kotschyana Fenzl                                                                                                                                                                                                                                    	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Potentilla                                                                                                                                                                                                                                                     	kotschyana                                                                                                                                                                                                                                                     	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Potentilla kotschyana                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
1117	Silene pharnaceifolia Fenzl                                                                                                                                                                                                                                    	Fenzl                                                                                                                           	                                                  	                                                                                                                                                                                                                                                               	Silene                                                                                                                                                                                                                                                         	pharnaceifolia                                                                                                                                                                                                                                                 	Fenzl                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Silene pharnaceifolia                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
1118	Rumex spec.                                                                                                                                                                                                                                                    	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Rumex                                                                                                                                                                                                                                                          	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Rumex spec.                                                                                                                                                                                                                                                    	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
1119	Arenaria spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Arenaria                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arenaria spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
1120	Asyneuma spec.                                                                                                                                                                                                                                                 	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Asyneuma                                                                                                                                                                                                                                                       	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Asyneuma spec.                                                                                                                                                                                                                                                 	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	3
1121	Arabis spec.                                                                                                                                                                                                                                                   	                                                                                                                                	                                                  	                                                                                                                                                                                                                                                               	Arabis                                                                                                                                                                                                                                                         	spec.                                                                                                                                                                                                                                                          	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Arabis spec.                                                                                                                                                                                                                                                   	                                                                                                                                                                                                                                                               	spec                                                                                                                                                                                                                                                           	2
1122	Colchicum cf. trigynum (Adam) Stearn                                                                                                                                                                                                                           	(Adam) Stearn                                                                                                                   	                                                  	                                                                                                                                                                                                                                                               	Colchicum                                                                                                                                                                                                                                                      	cf. trigynum                                                                                                                                                                                                                                                   	(Adam) Stearn                                                                                                                                                                                                                                                  	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Colchicum cf. trigynum                                                                                                                                                                                                                                         	                                                                                                                                                                                                                                                               	Unknown                                                                                                                                                                                                                                                        	4
1123	Cleome ornithopodioides L.                                                                                                                                                                                                                                     	L.                                                                                                                              	                                                  	                                                                                                                                                                                                                                                               	Cleome                                                                                                                                                                                                                                                         	ornithopodioides                                                                                                                                                                                                                                               	L.                                                                                                                                                                                                                                                             	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	                                                                                                                                                                                                                                                               	Cleome ornithopodioides                                                                                                                                                                                                                                        	                                                                                                                                                                                                                                                               	EMed                                                                                                                                                                                                                                                           	2
\.


--
-- TOC entry 1759 (class 0 OID 32149)
-- Dependencies: 1343
-- Data for Name: villayet; Type: TABLE DATA; Schema: public; Owner: postgres
--

COPY villayet (villayet_id, villayet, country_fk) FROM stdin;
1	Unknown                                                                                                                                                                                                                                                        	\N
2	Mugla                                                                                                                                                                                                                                                          	1
3	Antalya                                                                                                                                                                                                                                                        	1
4	Nigde                                                                                                                                                                                                                                                          	1
5	Karaman                                                                                                                                                                                                                                                        	1
6	Ïsparta/Konya                                                                                                                                                                                                                                                  	1
7	Konya                                                                                                                                                                                                                                                          	1
8	Karaman                                                                                                                                                                                                                                                        	1
9	Adana                                                                                                                                                                                                                                                          	1
10	Erzurum                                                                                                                                                                                                                                                        	1
11	Artvin (Çoruh)                                                                                                                                                                                                                                                 	1
12	Rize                                                                                                                                                                                                                                                           	1
13	Trabzon                                                                                                                                                                                                                                                        	1
14	Ankara                                                                                                                                                                                                                                                         	1
15	Afyon                                                                                                                                                                                                                                                          	1
16	Ïzmir                                                                                                                                                                                                                                                          	1
17	Apulia                                                                                                                                                                                                                                                         	2
\.


--
-- TOC entry 1718 (class 2606 OID 31971)
-- Dependencies: 1331 1331
-- Name: chorotype_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY chorotype
    ADD CONSTRAINT chorotype_pkey PRIMARY KEY (chorotype_id);


--
-- TOC entry 1720 (class 2606 OID 31979)
-- Dependencies: 1332 1332
-- Name: country_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY country
    ADD CONSTRAINT country_pkey PRIMARY KEY (country_id);


--
-- TOC entry 1722 (class 2606 OID 31986)
-- Dependencies: 1333 1333
-- Name: genus_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY genus
    ADD CONSTRAINT genus_pkey PRIMARY KEY (genus);


--
-- TOC entry 1724 (class 2606 OID 31999)
-- Dependencies: 1334 1334
-- Name: lifeform_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY lifeform
    ADD CONSTRAINT lifeform_pkey PRIMARY KEY (id);


--
-- TOC entry 1727 (class 2606 OID 32022)
-- Dependencies: 1335 1335
-- Name: locality_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY locality
    ADD CONSTRAINT locality_pkey PRIMARY KEY (locality_id);


--
-- TOC entry 1729 (class 2606 OID 32075)
-- Dependencies: 1336 1336
-- Name: metadata_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY metadata
    ADD CONSTRAINT metadata_pkey PRIMARY KEY (metadata_id);


--
-- TOC entry 1733 (class 2606 OID 32088)
-- Dependencies: 1337 1337
-- Name: mountain_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY mountain
    ADD CONSTRAINT mountain_pkey PRIMARY KEY (mountain_id);


--
-- TOC entry 1736 (class 2606 OID 32098)
-- Dependencies: 1338 1338
-- Name: observation_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY observation
    ADD CONSTRAINT observation_pkey PRIMARY KEY (observation_id);


--
-- TOC entry 1738 (class 2606 OID 32106)
-- Dependencies: 1339 1339
-- Name: soil_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY soil
    ADD CONSTRAINT soil_pkey PRIMARY KEY (soil_id);


--
-- TOC entry 1741 (class 2606 OID 32120)
-- Dependencies: 1340 1340
-- Name: specimen_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY specimen
    ADD CONSTRAINT specimen_pkey PRIMARY KEY (specimen_id);


--
-- TOC entry 1744 (class 2606 OID 32147)
-- Dependencies: 1342 1342
-- Name: taxon_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY taxon
    ADD CONSTRAINT taxon_pkey PRIMARY KEY (taxon_id);


--
-- TOC entry 1747 (class 2606 OID 32156)
-- Dependencies: 1343 1343
-- Name: villayet_pkey; Type: CONSTRAINT; Schema: public; Owner: postgres; Tablespace: 
--

ALTER TABLE ONLY villayet
    ADD CONSTRAINT villayet_pkey PRIMARY KEY (villayet_id);


--
-- TOC entry 1725 (class 1259 OID 32023)
-- Dependencies: 1335
-- Name: locality_index_5_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX locality_index_5_idx ON locality USING btree (locality);


--
-- TOC entry 1730 (class 1259 OID 32076)
-- Dependencies: 1336
-- Name: metadata_sourceid_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX metadata_sourceid_idx ON metadata USING btree (source_id);


--
-- TOC entry 1731 (class 1259 OID 32089)
-- Dependencies: 1337
-- Name: mountain_index_2_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX mountain_index_2_idx ON mountain USING btree (villayet_fk);


--
-- TOC entry 1734 (class 1259 OID 32099)
-- Dependencies: 1338
-- Name: observation_index_4_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX observation_index_4_idx ON observation USING btree (specimen_fk);


--
-- TOC entry 1739 (class 1259 OID 32121)
-- Dependencies: 1340
-- Name: specimen_index_6_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX specimen_index_6_idx ON specimen USING btree (metadata_fk);


--
-- TOC entry 1742 (class 1259 OID 32148)
-- Dependencies: 1342
-- Name: taxon_fullname_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX taxon_fullname_idx ON taxon USING btree (full_name);


--
-- TOC entry 1745 (class 1259 OID 32157)
-- Dependencies: 1343
-- Name: villayet_index_2_idx; Type: INDEX; Schema: public; Owner: postgres; Tablespace: 
--

CREATE INDEX villayet_index_2_idx ON villayet USING btree (country_fk);


--
-- TOC entry 1764 (class 0 OID 0)
-- Dependencies: 3
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


-- Completed on 2008-04-30 20:34:05 CEST

--
-- PostgreSQL database dump complete
--

